﻿
; Background demo - Create a textured background with overlay image and linear garadient colors
; Sprites and images with transparence as overlay supported

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define output_width=1200
Define output_height=700

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "Background demo",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)

Define canvas_ID=(CanvasGadget(#PB_Any, 0, 0, output_width, output_height))

Define path_texture$="./Image_Set/stone_1.png"
Define texture_ID=LoadImage(#PB_Any, path_texture$)

Define path_overlay_image$="./Image_Set/people_1.jpg" ; Overlay image path
Define overlay_ID=LoadImage(#PB_Any, path_overlay_image$)

; === Create a enhanced background ===
Define overlay_x=0
Define overlay_y=0
Define overlay_width=output_width
Define overlay_height=output_height
Define overlay_alpha=120
Define texture_alpha=120
Define activate_overlay_sprite_mode=1
Define color_distance_overlay=15
Define set_linear_gradient_color=$808080
Define set_background_color=$FFFFFF
Define texture_x=0           ; Startposition texture output x - Preset 0
Define texture_y=0           ; Startposition texture output y - Preset 0
Define texture_width=0       ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
Define texture_height=0      ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
Define texture_clip_x=0      ; Startposition inside the texture x - Preset 0
Define texture_clip_y=0      ; Startposition inside the texture y - Preset 0
Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture height
Define texture_resize_x=100  ; Pre resize texture x
Define texture_resize_y=0    ; Pre resize texture y

; Texture settings and many other you must not set, but you can
Define output_ID=CreateBackgroundImage_BF(overlay_ID,                   ; Overlay image_ID
                                          texture_ID,                   ; Background texture ID
                                          output_width,                 ; Resulted image width
                                          output_height,                ; Resulted image height
                                          overlay_x,                    ; Overlay x pos
                                          overlay_y,                    ; Overlay y pos
                                          overlay_width,                ; Overlay width  - 0 = Resulted image width
                                          overlay_height,               ; Overlay height - 0 = Resulted image height
                                          overlay_alpha,                ; Overlay image alpha
                                          texture_alpha,                ; Texture alpha - BF specivic - 0 = full visible
                                          activate_overlay_sprite_mode, ; Use a masked image as overlay - Set to 2 for a image with alpha channel
                                          color_distance_overlay,       ; Color distance oberlay image - This remove border artifacts
                                          set_linear_gradient_color,    ; Set linear gradient color - From background color to this color - Best a grey about $808080
                                          set_background_color,         ; Background color for use with linear gradient output
                                          texture_x,                    ; Startposition texture output x - Preset 0
                                          texture_y,                    ; Startposition texture output y - Preset 0
                                          texture_width,                ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                                          texture_height,               ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                                          texture_clip_x,               ; Startposition inside the texture x - Preset 0
                                          texture_clip_y,               ; Startposition inside the texture y - Preset 0
                                          texture_clip_width,           ; Endposition inside the texture - Preset 0 = full texture width
                                          texture_clip_height,          ; Endposition inside the texture - Preset 0 = full texture height
                                          texture_resize_x,             ; Pre resize texture x
                                          texture_resize_y)             ; Pre resize texture y

StartDrawing(CanvasOutput(canvas_ID))
DrawImage(ImageID(output_ID), 0, 0)
StopDrawing()
; ==========================================

HideWindow(window_ID, 0) ; Show the window 

Repeat
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 45
; FirstLine = 42
; EnableXP
; DisableDebugger