﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; BucketFill demo - This demo demonstrate BucketFill_BF and the BF core function use 
; BucketFill_BF is a special function for BucketFill output
; The core function simple named BF is the Wizzard base function for many things and can also output sprites BF

EnableExplicit

Define window_ID, win_event, image_ID, texture_ID, background_ID, result
Define image_x, image_y, image_width, image_height, point
Define path$

#GeeBee="./Image_Set/Geebee2.bmp"
#Clouds="./Image_Set/Clouds.jpg"
#SoilWall="./Image_Set/soil_wall.jpg"
#RustySteel="./Image_Set/RustySteel.jpg"
#Caisse="./Image_Set/Caisse.png"
#Dirt="./Image_Set/Dirt.jpg"
#Background="./Image_Set/Background.bmp"
#Cat_1="./Image_Set/Cat_01.jpg"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #SoilWall)

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

StartDrawing(ImageOutput(background_ID))
Box (40, 10, 128 , 400, $CCCC00)
RoundBox (185, 80, 133 , 250 , 20, 20, $AAAAA2)
Box (300, 280, 150 , 150, $AAA3)
Circle(460, 260, 125, $AAAAA4)
StopDrawing()

; Hint - So you can replace global a color on a source with a texture - This line replace the color red with a texture
; SetColor_BF(#Red) : ErrorCheck_BF(BF(-2, source_ID, texture_ID, -1, -1))

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
result=BucketFill_BF(-2, background_ID, texture_ID) ; Full size output, not more settings needed
ErrorCheck_BF(result)

; - Call function #2 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
Define output_get_color_x=40 ; Grab transparence color from sprite pos x - For preset set ..x=-1  
Define output_get_color_y=10 ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
Define texture_x=0           ; Startposition texture output x - Preset 0
Define texture_y=0           ; Startposition texture output y - Preset 0
Define texture_width=0       ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
Define texture_height=0      ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
Define texture_clip_x=0      ; Startposition inside the texture x - Preset 0
Define texture_clip_y=0      ; Startposition inside the texture y - Preset 0
Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture height
Define texture_resize_x=44   ; Pre resize texture x
Define texture_resize_y=20   ; Pre resize texture y

result=BucketFill_BF(-50, background_ID, texture_ID,
                     output_get_color_x,  ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                     output_get_color_y,  ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                     texture_x,           ; Startposition texture output x - Preset 0
                     texture_y,           ; Startposition texture output y - Preset 0
                     texture_width,       ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                     texture_height,      ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                     texture_clip_x,      ; Startposition inside the texture x - Preset 0
                     texture_clip_y,      ; Startposition inside the texture y - Preset 0
                     texture_clip_width,  ; Endposition inside the texture - Preset 0 = full texture width
                     texture_clip_height, ; Endposition inside the texture - Preset 0 = full texture height
                     texture_resize_x,    ; Pre resize texture x
                     texture_resize_y)    ; Pre resize texture y
                                          ; mode = 0         - Set only a positioning marker
                                          ;       -1         - Ignore a texture and use a color - Set as texture_ID a color, as sample $FFFF00
                                          ;       -2         - Standard preset texture mode
                                          ;       -3 to -256 - Texture mode with alpha blending
                                          ; For compatibility with BucketFill this function use negative mode values, but it works at the same also with positive values
                                          ; This function can output on images, PB sprites and canvas

ErrorCheck_BF(result)

; - Call function #3 -
path$=#GeeBee
texture_ID=LoadImage(#PB_Any, path$)
result=BucketFill_BF(-2, background_ID, texture_ID,
                     185,
                     100,
                     60, ; Startposition texture output x
                     80) ; y
ErrorCheck_BF(result)

; - Call function #4 -
path$=#Clouds
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, background_ID, texture_ID,
          185, ; Get a color point for replacing with bucket fill x
          100) ; y
ErrorCheck_BF(result)

; - Call function #5 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, background_ID, texture_ID,
          300, 
          280,
          0, ; All zeros to default
          0,
          0,
          0,
          0,
          0,
          30, ; Reduce texture width
          30) ; Reduce texture height
ErrorCheck_BF(result)

; - Call function #6 -
path$=#Cat_1
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, 300, 260)
result=BF(-2, background_ID, texture_ID,
          450,
          250,
          0,
          135) ; Adjust photo
ErrorCheck_BF(result)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing() 

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 47
; FirstLine = 33
; EnableXP
; DisableDebugger