﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - ButtonImageGadget_BF - FadeIn > FadeOut & DrawText_BF

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define button_width=120*DPI_ResizeFactor_BF()
Define button_height=120*DPI_ResizeFactor_BF()
Define background_color=#Blue
Define padding_x=16*DPI_ResizeFactor_BF()
Define padding_y=5*DPI_ResizeFactor_BF()
Define button_flag=0
Define overlay_color=#Blue
Define animation_delay=2
Define animation_alpha_step=10
Define button_x_pos=10
Define button_y_pos=10
Define window_x_pos=500
Define window_y_pos=100
#tiles_h=6
#tiles_v=5

Activate_DPI_aware_BF(1)

Define text_1$="FadeIn/Out"+#LF$+#LF$+
               " - CLICK ME - "+#LF$+#LF$+
               "GFX_Wizzard_BF"

Define i, ii, i1, x, y, on_top_before, on_top_after, image_a_ID, image_b_ID, gadget_ID

#tiles_amount=#tiles_h*#tiles_v
Dim tile_ID(#tiles_amount, 1) ; For simple handling we begins with tile 1 as the first tile
Define cover_image_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")

Define hidden_image_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png") ; Temporary pre defined hidden image 
ResizeImage(cover_image_ID, button_width, button_height)
Define background_image_1_ID=CreateImage(#PB_Any, button_width, button_height, 24, background_color)

; Add text
Define font_1=LoadFont(#PB_Any, "Arial", 8, #PB_Font_Bold)
Define text_width=DrawTextCreateImage_BF(text_1$, 0, 0, 0, 3, font_1)  ; Get text width
Define text_height=DrawTextCreateImage_BF(text_1$, 0, 0, 0, 4, font_1) ; Get text height

StartDrawing(ImageOutput(cover_image_ID))
DrawingFont(FontID(font_1))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(button_width/2-text_width/2, button_height/2-text_height/2, text_1$ , #White, 0, 1)
StopDrawing()

button_width=(button_width-GetFitOffset_X_BF()*2)/DPI_ResizeFactor_BF()
button_height=(button_height-GetFitOffset_Y_BF()*2)/DPI_ResizeFactor_BF()

StartDrawing(ImageOutput(background_image_1_ID))
DrawingFont(FontID(font_1))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(button_width/2-text_width/2, button_height/2-text_height/2, text_1$ , #White, 0, 1)
StopDrawing()

For i=1 To #tiles_amount ; Create sample hidden images
  tile_ID(i, 1)=CopyImage(hidden_image_ID, #PB_Any) ; Temporary presets
Next
; Use not too large images, this make the output slower - Pre shrink very large images
tile_ID(1, 1)=LoadImage(#PB_Any, "./Image_Set/Cat_01.jpg")
tile_ID(2, 1)=LoadImage(#PB_Any, "./Image_Set/Cubes.png")
tile_ID(3, 1)=LoadImage(#PB_Any, "./Image_Set/bird.gif")
tile_ID(4, 1)=LoadImage(#PB_Any, "./Image_Set/Dog_1.gif")
tile_ID(5, 1)=LoadImage(#PB_Any, "./Image_Set/morph.gif")
tile_ID(6, 1)=LoadImage(#PB_Any, "./Image_Set/Penguin.png")
tile_ID(7, 1)=LoadImage(#PB_Any, "./Image_Set/Rose.png")
tile_ID(8, 1)=LoadImage(#PB_Any, "./Image_Set/Meteor_1.png")
tile_ID(9, 1)=LoadImage(#PB_Any, "./Image_Set/Space.png")
tile_ID(10, 1)=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")
tile_ID(11, 1)=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")

FitImageActivateUpscaling_BF(1) ; Activate upscaling - For handling too little images

Define window_ID=OpenWindow(#PB_Any, window_x_pos, window_y_pos, #tiles_h*button_width+20, #tiles_v*button_width+20, "FadeIn and FadeOut Demo with ButtonImageGadget_BF", #PB_Window_SystemMenu|#PB_Window_Invisible)

Procedure CreateImage_DPI(id, width, height, depth=24, color=0)
  ProcedureReturn CreateImage(id, width, height, depth, color)
EndProcedure
Macro CreateImage(id, width, height, depth=24, color=0)
  CreateImage_DPI(id, width, height, depth, color)
EndMacro

For i=1 To #tiles_amount ; Create the tiles
  tile_ID(i, 0)=ButtonImageGadget_BF(cover_image_ID,
                                     background_color,
                                     button_x_pos,
                                     button_y_pos,
                                     button_width,
                                     button_height,
                                     padding_x,
                                     padding_y,
                                     button_flag)
  button_x_pos+button_width : x+1 : If x=#tiles_h : button_y_pos+button_height : button_x_pos=GadgetX(tile_ID(1, 0)) : x=0 : EndIf
Next i

HideWindow(window_ID, 0)

; =================== Main Loop ===================

Repeat
  
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget
    For ii=1 To #tiles_amount
      gadget_ID=tile_ID(ii, 0)
      If EventGadget()=gadget_ID 
        
        image_a_ID=cover_image_ID
        image_b_ID=tile_ID(ii, 1)
        
        ; Fade in and fade out images with ImageGadget_BF - Full automatic mode- This function get and set ImageData (0 > 1)
        ; SetButtonImageGadget_BF_AutoFade_BF(gadget_ID,
        ;                                     image_a_ID,
        ;                                     image_b_ID,
        ;                                     background_color,
        ;                                     overlay_color,
        ;                                     animation_delay,
        ;                                     animation_alpha_step)
        
        ; Fade in And fade out images With ImageGadget_BF - Recommendation : Set ImageData (0 > 1) As state - This function works also With the automatic version above
        If GetGadgetData(gadget_ID) ; Toggle from b to a
          SetButtonImageGadget_BF_Fade_BF(gadget_ID,
                                          image_b_ID,
                                          image_a_ID,
                                          background_color,
                                          overlay_color,
                                          animation_delay,
                                          animation_alpha_step)  
          SetGadgetData(gadget_ID, 0)
        Else ; Toggle from a to b
          SetButtonImageGadget_BF_Fade_BF(gadget_ID,
                                          image_a_ID,
                                          image_b_ID,
                                          background_color,
                                          overlay_color,
                                          animation_delay,
                                          animation_alpha_step)  
          SetGadgetData(gadget_ID, 1)
        EndIf
        
      EndIf
    Next
  EndIf
  
Until win_event=#PB_Event_CloseWindow

FitImageActivateUpscaling_BF(0)
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 12
; FirstLine = 9
; Folding = -
; EnableXP