﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - ColorButtonGadget_BF() & ColorButton creating with CreateFittedTextImage_BF()
; Automatic multi line support
; Automatic text size
; Automatic text adjustment
; Outputs all fonts with edge smoothing
; Can handle GradientColor_BF
; font_ID you must not set
; Use ever a large font size - Then the function adjust the needed font size automatically (about 60 for the mostly large buttons)
; flag : Text center=1 - Text right=2 - Text vertical=3
; mode : Revers text mode=1 - RTL text mode=2
; stretch = Headline text stretcheng function

; ColorButtonGadget_BF(text$,
;                          x,
;                          y,
;                          button_width,
;                          button_height,
;                          text_color=0,
;                          background_color=$E1E1E1,
;                          font_ID=-1,
;                          stretch_x=0,
;                          stretch_y=0,
;                          flag=1,
;                          mode=0,
;                          button_flag=0)

EnableExplicit

; The subsystem Linux gtk3 can expand BF MessageRequester_Pro and ColorButtonGadget_BF color buttons slightly in size
; So you can preset a negative offset to adjust the buttons
; Don't select these offsets too big, the button text will get smaller and smaller
; Different gtk3 versions can affect button sizes differently
; Especially all smaller buttons are automatically enlarged, which can make precise adjustment much more difficult
; This is not a failure of GFX_Wizzard_BF, but a "feature" of gtk3 :-(
; The wizard currently automatically activates gtk3 offsets, which you can also change so :
CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  CompilerIf Not Subsystem("gtk2") And Not Subsystem("qt")
    gtk3_button_x_offset_BF(0) ; Presetted x=13
    gtk3_button_y_offset_BF(6) ; Presetted y=6
  CompilerEndIf
CompilerEndIf

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 800, 490, "GFX_Wizzard_BF",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; Use ever a large font for the buttons
; Then the function adjust the needed font size automatically (about 60 For the mostly large buttons)
Define font_ID=LoadFont(#PB_Any, "Arial", 60, #PB_Font_Bold) ; Smaller is faster - Look for the max needed size to your outputs
                                                              ; You can also activate upscaling fonts, similar Windows OS do this
                                                              ; This is very fast, but on large font output not so clear

; Add to the FitImage functions a automatically upscaling for little images - 1=activated - 0=deactivated
; -You must deactivate again
; -As sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF, ButtonImageGadget_BF
FitImageActivateUpscaling_BF(1) ; This will automatically enlarge fonts that are too small, it's very fast 

; ==================== Button 1 =====================
Define button_width=400
Define button_height=120
Define text_color=#White
Define background_color=#Blue
Define text$="ColorButtonGadget_BF & TextButton_BF"+#LF$+"CreateFittedTextImage_BF"+#LF$+"Create very nice Color Buttons and Text"+#LF$+"DrawText_BF based incredible Functions"

; The function can handle GradientColor_BF
Define text_width=DrawTextCreateImage_BF(text$, 0, 0, 1, 3, font_ID, 0, 0, -1) ; Get the real text size from the used font
Define text_height=DrawTextCreateImage_BF(text$, 0, 0, 1, 4, font_ID, 0, 0, -1)
BackColor_BF(1, $00FF7F)
GradientColor_Array_BF(1, 1, 0.3, $FFFF)
GradientColor_Array_BF(1, 2, 0.8, $00FF7F)
LinearGradient_BF(1, 0, 0, text_width*1.6, text_height*1)

Define gadget_1_ID=ColorButtonGadget_BF(text$,
                                        WindowWidth(window_ID)/2-button_width/2,
                                        10,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID)

DeactivateGradientColors_BF()

; ==================== Button 2 ====================
Define button_width=420
Define button_height=200
Define text_color=#White
Define background_color=#Red
Define text_1$="Works with all OS and subsystems"+#LF$+
               "No more font sizes for different text sizes needed"+#LF$+
               "Texts are automatically adapted to any size"+#LF$+
               "The text is centered and displayed in several lines"+#LF$+
               "Any text is automatically fitted into any output"+#LF$+
               "GradientColor support"+#LF$+
               "Works with any available fonts"+#LF$+
               "Linux gtk2 centered multiline button text supported"+#LF$+
               "Many cool enhanced text functions for all things"
Define stretch_x=5 ; Text stretching
Define stretch_y=5
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

Define gadget_2_ID=ColorButtonGadget_BF(text_1$,
                                        WindowWidth(window_ID)/2-button_width/2,
                                        140,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID,
                                        stretch_x,
                                        stretch_y,
                                        flag,
                                        mode) 

; ================ Button 3 ========================
Define button_width=250
Define button_height=60
Define text_color=#Blue
Define background_color=#Yellow
Define text$="This are all fully automatic created"+#LF$+"Color Buttons"
Define gadget_3_ID=ColorButtonGadget_BF(text$,
                                        WindowWidth(window_ID)/2-button_width/2,
                                        350,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID) 
; FreeGadget_BF(gadget_3_ID) ; This function free a Gadget_BF

; ==================== Button 4 - RAW ==============
Define button_width=230
Define button_height=60
Define text_color=#Yellow
Define background_color=$345600
Define text$="It's magic"+#LF$+"All OS"
Define stretch_x=60 ; Text stretching
Define stretch_y=5
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

Define image_1_ID=CreateFittedTextImage_BF(text$,
                                           button_width,
                                           button_height,
                                           text_color,
                                           background_color,
                                           font_ID,
                                           stretch_x,
                                           stretch_y,
                                           flag,
                                           mode)

ButtonImageGadget(#PB_Any, WindowWidth(window_ID)/2-button_width/2, 420, button_width, button_height, ImageID(image_1_ID)) 

; ==================== Button 5 ====================
Define button_width=80
Define button_height=40
Define text_color=#White
Define background_color=$2F6B55
Define text$="Bye"
Define gadget_4_ID=ColorButtonGadget_BF(text$,
                                        WindowWidth(window_ID)-button_width-20,
                                        WindowHeight(window_ID)-button_height-10,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID)

; ============= Button 6 - vertical ===============
Define button_width=60
Define button_height=400
Define text_color=#White
Define background_color=$645345
Define text$="Vertical Text Buttons"
Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=3 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_5_ID=ColorButtonGadget_BF(text$,
                                        WindowWidth(window_ID)-button_width-20,
                                        10,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID,
                                        stretch_x,
                                        stretch_y,
                                        flag,
                                        mode)

; ================== Button 7 =====================
Define button_width=40
Define button_height=330
Define text_color=#Red
Define background_color=#Green
Define text$="Vertical Text Buttons"
Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=3 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=2 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_6_ID=ColorButtonGadget_BF(text$,
                                        WindowWidth(window_ID)-150,
                                        10,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID,
                                        stretch_x,
                                        stretch_y,
                                        flag,
                                        mode)

; ================== Button 8 =====================
Define button_width=230
Define button_height=100
Define text_color=#White
Define background_color=$365456
Define text$="Simplest use Color Buttons with all OS"+#LF$+
             "Centered, right and vertical Text"+#LF$+
             "Revers and RTL Text"+#LF$+
             "Fully automatically Text adjustment"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_7_ID=ColorButtonGadget_BF(text$,
                                        10,
                                        WindowHeight(window_ID)-button_height-10,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID,
                                        stretch_x,
                                        stretch_y,
                                        flag,
                                        mode)

; ================== Button 9 =====================
Define button_width=170
Define button_height=100
Define text_color=#White
Define background_color=$464375
Define text$="Headline"+#LF$+
             "Centered, right, vertical"+#LF$+
             "Revers and RTL Text"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=0 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=1 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_8_ID=ColorButtonGadget_BF(text$,
                                        10,
                                        10,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID,
                                        stretch_x,
                                        stretch_y,
                                        flag,
                                        mode)

; ================== Button 10 ====================
Define button_width=160
Define button_height=80
Define text_color=#White
Define background_color=$267834
Define text$="Headline"+#LF$+
             "Centered, right, vertical"+#LF$+
             "Revers and RTL Text"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=0 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_9_ID=ColorButtonGadget_BF(text$,
                                        10,
                                        150,
                                        button_width,
                                        button_height,
                                        text_color,
                                        background_color,
                                        font_ID,
                                        stretch_x,
                                        stretch_y,
                                        flag,
                                        mode)

; ================== Button 11 ====================
Define button_width=130
Define button_height=75
Define text_color=#Black
Define background_color=$FF00
Define text$="Click me"+#LF$+"OFF"
Define stretch_x=5 ; Text stretching
Define stretch_y=0
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_10_ID=ColorButtonGadget_BF(text$,
                                         550,
                                         380,
                                         button_width,
                                         button_height,
                                         text_color,
                                         background_color,
                                         font_ID,
                                         stretch_x,
                                         stretch_y,
                                         flag,
                                         mode)

; ================== Button 12 ====================
Define button_width=120
Define button_height=80
Define text_color=#White
Define background_color=0
Define text$="Envy"+#LF$+"is the higgest"+#LF$+"form of recognition"+#LF$+":-)"

Define stretch_x=5 ; Text stretching
Define stretch_y=0
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_11_ID=ColorButtonGadget_BF(text$,
                                         30,
                                         270,
                                         button_width,
                                         button_height,
                                         text_color,
                                         background_color,
                                         font_ID,
                                         stretch_x,
                                         stretch_y,
                                         flag,
                                         mode)

; =============== Get the result ===================

HideWindow(window_ID, 0)

Define font_1_ID=LoadFont(#PB_Any, "Arial", 60, #PB_Font_Bold | #PB_Font_Italic)

Repeat
  
  Define win_event=WaitWindowEvent()
  
  If win_event=#PB_Event_CloseWindow
    Break
  ElseIf win_event=#PB_Event_Gadget And EventGadget()=gadget_4_ID
    Break
  ElseIf win_event=#PB_Event_Gadget And
         (EventGadget()=gadget_1_ID Or
          EventGadget()=gadget_3_ID Or
          EventGadget()=gadget_5_ID Or
          EventGadget()=gadget_7_ID Or
          EventGadget()=gadget_8_ID Or
          EventGadget()=gadget_10_ID)
    Define flip=1-flip
    
    ; ============= Click me Button ===============
    ; Simple you can change the ColorButtonGgadget_BF - You must only set used parameters
    ; SetColorButtonGadget_BF(gadget_ID, text$, text_color, background_color, x, y, button_width, button_height, stretch_x, stretch_y, font_ID)
    ; Ignored parameters you can set to -1
    If flip
      Define text$="Click me"+#LF$+"ON"
      text_color=#Black
      background_color=#Red
      SetColorButtonGadget_BF(gadget_1_ID, text$, text_color, background_color, -1, -1, -1, -1, -1, -1, font_ID)
    Else
      Define text$="Click me"+#LF$+"OFF"
      text_color=#Black
      background_color=#Green
      SetColorButtonGadget_BF(gadget_1_ID, text$, text_color, background_color, -1, -1, -1, -1, 30, 30, font_1_ID)
    EndIf
    SetColorButtonGadget_BF(gadget_3_ID, text$, text_color, background_color)
    SetColorButtonGadget_BF(gadget_5_ID, text$, text_color, background_color)
    SetColorButtonGadget_BF(gadget_7_ID, text$, text_color, background_color)
    SetColorButtonGadget_BF(gadget_8_ID, text$, text_color, background_color)
    SetColorButtonGadget_BF(gadget_10_ID, text$, text_color, background_color)
  EndIf
  
ForEver

; FreeGadget_BF(gadget_ID) ; This function free a Gadget_BF - For ImageGadget_BF not needed
FreeAllGadgets_BF(0) ; Take with care - This free all Gadget_BF - For ImageGadget_BF not needed
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 1
; FirstLine = 1
; Folding = -
; EnableXP