﻿DeclareModule BaseU_BF
  EnableExplicit
  ; Sakis BaseU © - Unicode based string to binary - binary to string Generator
  ; This code is free for use, changing and enhancing
  ; character_offset - Base character offset - As sample 30, 160, 230 - Try what ever you want
  ; Seed - set as a integer - This works as password for the integrated data crypter
  Declare BaseU_Decoder_BF(Data_BF$, seed=0)
  Declare.s BaseU_Encoder_BF(*buffer, len_buffer, length_data_line=100, character_offset=230, seed=0)
  Declare.s StringEncoderBU_BF(string$, length_line, character_offset=230, seed=0)
  Declare.s StringDecoderBU_BF(string$, seed=0)
EndDeclareModule

Module BaseU_BF
  Procedure.s BaseU_Encoder_BF(*buffer, len_buffer, length_data_line=100, character_offset=230, seed=0)
    Protected i, ii, iii, breaks, len_source.q, padding=3, string$, new_string$, temp_string$, last$, length$
    Macro Create_length_string
      length$=LSet(Chr(character_offset<<8), 6, Chr(character_offset<<8))
      ii=0 : For i=0 To 5 : PokeA(@length$+ii, PeekA(@len_source+i)) : ii+2 : Next i
    EndMacro
    len_source.q=len_buffer : len_buffer+padding : RandomSeed(seed)
    breaks=len_buffer/length_data_line : breaks+Bool(len_buffer%length_data_line) : string$=Space(len_buffer+breaks-1)
    For i=0 To len_buffer-1 : ii+1 : iii+1
      PokeA(@string$+i+ii, character_offset) : PokeA(@string$+i+ii-1, PeekA(*buffer+i)+Random(254, 1))
      If Not iii%length_data_line : ii+1 : PokeW(@string$+i+ii, 10) : ii+1 : EndIf
    Next 
    If breaks<2 : Create_length_string : ProcedureReturn string$+length$ : EndIf
    iii=(length_data_line+1) : new_string$=Space(breaks*iii) : ii=0 : iii*2
    For i=1 To breaks : temp_string$=StringField(string$, i, #LF$)+#LF$
      CopyMemory(@temp_string$, @new_string$+ii, iii) : ii+iii 
    Next
    Create_length_string : new_string$+length$ : ProcedureReturn new_string$
  EndProcedure
  
  Procedure BaseU_Decoder_BF(Data_BF$, seed=0)
    Data_BF$=RemoveString(Data_BF$, #LF$)
    Protected *data_start_pointer=@Data_BF$, len_data.q, data_size=Len(Data_BF$)*2
    Protected i, ii, offset, *buffer, *catch_buffer, len_buffer, *catch_buffer_new : len_buffer=data_size/2
    RandomSeed(seed) : *buffer=AllocateMemory(data_size) : CopyMemory(*data_start_pointer, *buffer, data_size)
    Repeat : If Not PeekW(*buffer+i) : PokeW(*buffer+i, 2560) : offset+1 : EndIf : i+2 : Until i>data_size
    *catch_buffer=AllocateMemory(data_size/2-offset)
    For i=0 To len_buffer-offset-1 : PokeA(*catch_buffer+i, PeekA(*buffer+ii)-Random(254, 1)) : ii+2 : Next
    ii=12 : For i=0 To 5 : PokeA(@len_data+i, PeekA(*data_start_pointer+StringByteLength(Data_BF$)-ii)) : ii-2 : Next
    *catch_buffer_new=AllocateMemory(len_data)
    CopyMemory(*catch_buffer, *catch_buffer_new, MemorySize(*catch_buffer_new))
    FreeMemory(*catch_buffer) : FreeMemory(*buffer)
    ProcedureReturn *catch_buffer_new
  EndProcedure
  
  Procedure.s StringEncoderBU_BF(string$, length_line, character_offset=230, seed=0)
    ProcedureReturn BaseU_Encoder_BF(@string$, StringByteLength(string$), length_line, character_offset, seed)
  EndProcedure
  
  Procedure.s StringDecoderBU_BF(string$, seed=0)
    Protected *buffer=BaseU_Decoder_BF(string$, seed), result$=PeekS(*buffer)
    FreeMemory(*buffer) : ProcedureReturn result$
  EndProcedure
  
EndModule
UseModule BaseU_BF

; #################### Encode and decode a string #######################
CompilerIf #PB_Compiler_IsMainFile
  EnableExplicit
  
  Define string$="Hello World, this is Saki's BaseU_BF"+#LF$+
                 "The simplest method to transfer binary data in unicode strings"+#LF$+
                 "In Unicode environments about 35% smaller than Base64"
  
  ; Define i : For i=1 To 10 : string$+string$ : Next i ; Multi loop test
  
  Define length_line=60
  Define character_offset=230
  Define seed=0
  string$=StringEncoderBU_BF(string$, length_line, character_offset, seed)
  Debug string$
  Debug StringDecoderBU_BF(string$, seed)
CompilerEndIf

; ; #################### Encode and decode a image ########################
; CompilerIf #PB_Compiler_IsMainFile
;   EnableExplicit
;   
;   Define path$=OpenFileRequester("Select a image", "", "", 0) : If path$="" : End : EndIf
;   
;   If FileSize(path$)<1 : End : EndIf
;   Define file=ReadFile(#PB_Any, path$) : Define *buffer=AllocateMemory(Lof(file))
;   If Not ReadData(file, *buffer, Lof(file)) : CloseFile(file) : End : EndIf
;   
;   ; You can remove what you not want
;   UsePNGImageDecoder() : UseJPEGImageDecoder() : UseGIFImageDecoder() : UseTIFFImageDecoder()

;   Define BaseU$=BaseU_Encoder_BF(*buffer, MemorySize(*buffer), 80)
;   Define *buffer_1=BaseU_Decoder_BF(BaseU$)
;   
;   Debug BaseU$
;   
;   Define image_ID=CatchImage(#PB_Any, *buffer_1)
;   
;   Define window_ID=OpenWindow(#PB_Any, 0, 0, 600, 400, "", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
;   If IsImage(image_ID)
;     Define image_gadget_ID=ImageGadget(#PB_Any,
;                                        WindowWidth(window_ID)/2-ImageWidth(image_ID)/2,
;                                        WindowHeight(window_ID)/2-ImageHeight(image_ID)/2,
;                                        0,
;                                        0,
;                                        ImageID(image_ID))
;   Else
;     CloseWindow(window_ID)
;     MessageRequester("Hint", "Embedded image not usable")
;     End
;   EndIf
;   
;   Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
; CompilerEndIf

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 19
; FirstLine = 5
; Folding = --
; EnableXP
; Optimizer