﻿XIncludeFile("./Game_Counter_Odometer_Digital_clock_with_PB_logo.pbi")

; ########################## Desktop digital clock #############################
EnableExplicit

UseModule Odometer_OD

InitOdometer_OD()

Define DR.d=DesktopResolutionX()
Define menu_activ 
Global home$=GetHomeDirectory()+"Sakis_digi_clock"

If FileSize(home$)>0
  Global file=ReadFile(#PB_Any, home$)
  Global window_x=ReadLong(file)
  Global window_y=ReadLong(file)
  Global switch_colors=ReadByte(file)
  Global gradient_color=ReadByte(file)
  Global ampm_mode=ReadByte(file)
  Global change_size_percent=ReadAsciiCharacter(file)
  CloseFile(file)
  ; Fuse
  If change_size_percent<60 Or change_size_percent>140 : change_size_percent=100 : EndIf
  If ExamineDesktops()
    If window_x>DesktopWidth(0)/DR : window_x=DesktopWidth(0)/DR-GetFrameWidth_OD()/DR : EndIf
    If window_y>DesktopHeight(0)/DR : window_y=DesktopHeight(0)/DR-GetFrameHeight_OD()/DR*3 : EndIf
  EndIf
  If window_x<0 : window_x=0 : EndIf
  If window_y<0 : window_y=0 : EndIf
EndIf 

If Not file : Define flag=#PB_Window_ScreenCentered : EndIf

If switch_colors : SetFrameColor_OD(#Green) : Define used_frame_color=#Green : SetCharColor_OD(#Yellow)
Else
  used_frame_color=#Red
EndIf

If gradient_color : UseGradientColor_OD(1) : Else : UseGradientColor_OD(0) : EndIf

If ampm_mode : UseAMPM_OD(1) : Else : UseAMPM_OD(0) : EndIf

Select change_size_percent
  Case 60  : ChangeSizePercent_OD(60)
  Case 70  : ChangeSizePercent_OD(70)
  Case 80  : ChangeSizePercent_OD(80)
  Case 90  : ChangeSizePercent_OD(90)
  Case 100 : ChangeSizePercent_OD(100)
  Case 110 : ChangeSizePercent_OD(110)
  Case 120 : ChangeSizePercent_OD(120)
  Case 130 : ChangeSizePercent_OD(130)
  Case 140 : ChangeSizePercent_OD(140)
EndSelect

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : menu_activ=12 : CompilerElse : menu_activ=1 : CompilerEndIf

Global window_ID=OpenWindow(#PB_Any, window_x, window_y,
                            Int(GetFrameWidth_OD()/DR), Int(GetFrameHeight_OD()/DR+MenuHeight()-1+menu_activ), " Adjust now",
                            flag|#PB_Window_SystemMenu|#PB_Window_Tool)
AddWindowTimer(window_ID, 1, 500)
If file : HideWindow(window_ID, 1) : EndIf
Global canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

Define button_1_state, button_2_state, button_3_state, change_window=1, menu_, mode$

Macro menu
  menu_=CreateMenu(#PB_Any , WindowID (window_ID) )
  MenuTitle("Menu")
  MenuItem(1, "Switch Mode 12h/24h")
  MenuItem(2, "Switch Colors")
  MenuItem(3, "GradientColor on/off")
  MenuItem(4, "Info")
  MenuBar()
  MenuBar()
  MenuItem(20, "Finish the clock")
  CompilerIf #PB_Compiler_OS=#PB_OS_Windows
    MenuBar()
    MenuBar()
    MenuItem(5, "PureBasic Website")
    MenuItem(6, "PureArea.net")
    MenuItem(7, "PureBasic Forum EN")
    MenuItem(8, "PureBasic Forum DE")
    MenuItem(9, "PureBasic Forum FR")
  CompilerEndIf
  MenuTitle("Size")
  MenuItem(21, "Size 1")
  MenuItem(22, "Size 2")
  MenuItem(23, "Size 3")
  MenuItem(24, "Size 4")
  MenuItem(25, "Size 5")
  MenuItem(26, "Size 6")
  MenuItem(27, "Size 7")
  MenuItem(28, "Size 8")
  MenuItem(29, "Size 9")
EndMacro
menu

Macro Write_settings
  window_x=WindowX(window_ID) : window_y=WindowY(window_ID)
  file=CreateFile(#PB_Any, home$)
  If file
    WriteLong(file, window_x)
    WriteLong(file, window_y)
    WriteByte(file, switch_colors)
    WriteByte(file, gradient_color)
    WriteByte(file, ampm_mode)
    WriteAsciiCharacter(file, change_size_percent)
  CloseFile(file) : EndIf
EndMacro

Global MouseDown, OffsetX, OffsetY
Procedure RightMouseDown()
  MouseDown=#True
  offsetX=WindowMouseX(window_ID)/DesktopResolutionX()
  OffsetY=WindowMouseY(window_ID)/DesktopResolutionY()
EndProcedure

Procedure RightMouseUp()
  MouseDown=#False
  Write_settings
EndProcedure

Procedure MouseMove()
  If MouseDown And GetGadgetAttribute(canvas_ID,#PB_Canvas_Buttons)&#PB_Canvas_RightButton
    ResizeWindow(window_ID, DesktopMouseX()/DesktopResolutionX()-OffsetX,
                 DesktopMouseY()/DesktopResolutionY()-OffsetY, #PB_Ignore, #PB_Ignore)
  EndIf
EndProcedure

Macro Bind_event
  BindEvent(#PB_Event_Gadget, @RightMouseDown(), window_ID, canvas_ID, #PB_EventType_RightButtonDown)
  BindEvent(#PB_Event_Gadget, @RightMouseUp()  , window_ID, canvas_ID, #PB_EventType_RightButtonUp)
  BindEvent(#PB_Event_Gadget, @MouseMove()     , window_ID, canvas_ID, #PB_EventType_MouseMove)
EndMacro

Macro Common_1
  If IsWindow(window_ID)
    window_x=WindowX(window_ID) : window_y=WindowY(window_ID)
    If IsMenu(menu_) : FreeMenu(menu_) : EndIf
    FreeGadget(canvas_ID) ; Mac need this or it crash with VM
    RemoveWindowTimer(window_ID, 1)
    CloseWindow(window_ID)
  EndIf
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : menu_activ=12 : CompilerElse : menu_activ=1 :CompilerEndIf
  window_ID=OpenWindow(#PB_Any, window_x, window_y,
                       Int(GetFrameWidth_OD()/DR), Int(GetFrameHeight_OD()/DR+MenuHeight()-1+menu_activ),
                       " Adjust now",
                       #PB_Window_SystemMenu|#PB_Window_Tool)
  AddWindowTimer(window_ID, 1, 500)
  menu
  canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
  ResetDelay_OD()
EndMacro        

Macro Common_2
  If IsWindow(window_ID)
    If IsMenu(menu_) : FreeMenu(menu_) : EndIf
    window_x=WindowX(window_ID) : window_y=WindowY(window_ID)
    FreeGadget(canvas_ID) ; Mac need this or it crash with VM
    RemoveWindowTimer(window_ID, 1)
    CloseWindow(window_ID)
  EndIf
  menu_activ=0
  window_ID=OpenWindow(#PB_Any, window_x, window_y,
                       Int(GetFrameWidth_OD()/DR), Int(GetFrameHeight_OD()/DR), "Saki's Digi clock",
                       #PB_Window_BorderLess)
  AddWindowTimer(window_ID, 1, 500)
  canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
  Bind_event
  change_window=0
  Write_settings
EndMacro

If file : Common_2 : EndIf

Repeat ; ### Main loop ### 
  
  ; Auto adjust clock rolling speed (delay)
  ; This reduces the cores workload considerably - If a clock is running stand alone, a delay can be increased up to ~10
  Define delay=ClockAutoDelay_OD()
  
  Repeat   ; Get ever all events 
    Define win_event=WindowEvent() ; Add here your events - Just like they always do
    If win_event=#PB_Event_CloseWindow : Common_2 : EndIf
    
    If win_event=#PB_Event_Timer
      If change_window
        If GetClockCycleLength_OD()=-1
          SetWindowTitle(window_ID, " Reduce size")
        Else
          SetWindowTitle(window_ID, " Delay "+Str(delay))
        EndIf
      EndIf
    EndIf
    
    If win_event=#PB_Event_Menu
      Select EventMenu()
        Case 1
          If ampm_mode
            UseAMPM_OD(0) : Common_1 : ampm_mode=1
          Else
            UseAMPM_OD(1) : Common_1 : ampm_mode=0
          EndIf
          ampm_mode=1-ampm_mode
        Case 2
          If switch_colors
            SetFrameColor_OD(#Red) : SetCharColor_OD(#Yellow)
            used_frame_color=#Red
          Else
            SetFrameColor_OD(#Green) : SetCharColor_OD(#Yellow)
            used_frame_color=#Green
          EndIf
          switch_colors=1-switch_colors
        Case 3
          If gradient_color
            UseGradientColor_OD(0)
          Else
            UseGradientColor_OD(1)
          EndIf
          gradient_color=1-gradient_color
        Case 4
          CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
            MessageRequester(" Saki's Digi clock", "Free for use and free distribution"+#LF$+"This is a part of GFX_Wizzard_BF"+#LF$+
                                                   "You can also adjust the clock with the right mouse key"+#LF$+
                                                   "The settings file is in your home folder"+#LF$+#LF$+
                                                   "GradientColor on MacOS is emulated and generates"+#LF$+
                                                   "quite high load, you can disable it"+#LF$+#LF$+                                       
                                                   "Created with PureBasic")
          CompilerElse
            MessageRequester(" Saki's Digi clock", "Free for use and free distribution"+#LF$+"This is a part of GFX_Wizzard_BF"+#LF$+
                                                   "You can also adjust the clock with the right mouse key"+#LF$+
                                                   "The settings file is in your home folder"+#LF$+#LF$+                                    
                                                   "Created with PureBasic"+#LF$+#LF$+ 
                                                   "Main Site : www.purebasic.com"+#LF$+ 
                                                   "Support : www.purearea.net"+#LF$+ 
                                                   "Forum EN : www.purebasic.fr/english"+#LF$+ 
                                                   "Forum DE : www.purebasic.fr/german"+#LF$+ 
                                                   "Forum FR : www.purebasic.fr/french")
            
          CompilerEndIf
        Case 5
          RunProgram("http://www.purebasic.com")
        Case 6
          RunProgram("http://www.purearea.net")
        Case 7
          RunProgram("http://www.purebasic.fr/english/") 
        Case 8
          RunProgram("http://www.purebasic.fr/german/")
        Case 9
          RunProgram("http://www.purebasic.fr/french/")                      
        Case 20 : common_2 : End
        Case 21 : ChangeSizePercent_OD(60)  : Common_1 : change_size_percent=60
        Case 22 : ChangeSizePercent_OD(70)  : Common_1 : change_size_percent=70
        Case 23 : ChangeSizePercent_OD(80)  : Common_1 : change_size_percent=80
        Case 24 : ChangeSizePercent_OD(90)  : Common_1 : change_size_percent=90
        Case 25 : ChangeSizePercent_OD(100) : Common_1 : change_size_percent=100
        Case 26 : ChangeSizePercent_OD(110) : Common_1 : change_size_percent=110
        Case 27 : ChangeSizePercent_OD(120) : Common_1 : change_size_percent=120
        Case 28 : ChangeSizePercent_OD(130) : Common_1 : change_size_percent=130
        Case 29 : ChangeSizePercent_OD(140) : Common_1 : change_size_percent=140
      EndSelect 
    EndIf
    If win_event=#PB_Event_Gadget
      Select EventGadget()
        Case canvas_ID
          If Not menu_activ
            If GetGadgetAttribute(canvas_ID ,#PB_Canvas_Buttons)&#PB_Canvas_LeftButton
              window_x=WindowX(window_ID) : window_y=WindowY(window_ID)
              If IsMenu(menu_) : FreeMenu(menu_) : EndIf
              FreeGadget(canvas_ID) ; Mac need this or it crash with VM
              RemoveWindowTimer(window_ID, 1)
              CloseWindow(window_ID)
              If change_window And EventType()=#PB_EventType_LeftButtonDown
                window_ID=OpenWindow(#PB_Any, window_x, window_y,
                                     Int(GetFrameWidth_OD()/DR), Int(GetFrameHeight_OD()/DR), "Saki's Digi clock",
                                     #PB_Window_BorderLess)
                change_window=0
              Else
                CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : menu_activ=12 : CompilerElse : menu_activ=1 :CompilerEndIf
                window_ID=OpenWindow(#PB_Any, window_x, window_y,
                                     Int(GetFrameWidth_OD()/DR), Int(GetFrameHeight_OD()/DR+MenuHeight()-1+menu_activ), " Adjust now",
                                     #PB_Window_SystemMenu|#PB_Window_Tool)
                menu
              EndIf
              canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
              Bind_event
              AddWindowTimer(window_ID, 1, 500)
              change_window=1
            EndIf
          EndIf
      EndSelect 
    EndIf 
  Until Not win_event
  
  Define image_ID=DrawOdometer_OD() ; Create the frames for output as image - Alpha Channel supported
                                    ; You need ever to check if an image is available for output
  StartDrawing(CanvasOutput(canvas_ID))
  If IsImage(image_ID)                 ; You need ever to check if an image is available for output
    DrawImage(ImageID(image_ID), 0, 0) ; Output the image (frame) - With visible background color you can use DrawImage()
                                       ; DrawText(5, 5, Str(delay))       ; Show the used auto delay
    FreeImage(image_ID)                ; After any output the image (frame) delete it or you get a memory leak
  EndIf
  StopDrawing()
ForEver
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 195
; FirstLine = 177
; Folding = --
; EnableXP
; DPIAware
; Executable = ..\Digi_Clock_with_PB_Logo.exe