﻿; Demo : Dynamic GUI Developing Module - Automatic resizing PB gadgets, BF gadgets and fonts

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

CompilerIf #PB_Compiler_Version<560 : MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code") : End
CompilerElse
  
  DeclareModule CreateGUI_1 ; TODO === You can create modules for any GUIs - Give each new module a different name ===
    EnableExplicit          ; Use the replace function to globally change the name (as sample) "CreateGUI_1" found all over
    UseModule GFX_Wizzard_BF
    Declare CreateGUI_1(titel$="", x=0, y=0, width=0, height=0)
    Global GUI_x_pos, GUI_y_pos, GUI_width, GUI_height
  EndDeclareModule
  
  Module CreateGUI_1
    ; TODO === Set here your presets for the GUI ===
    Global on_demand_resizing=#True
    #UsedWindowFlags=#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_Invisible|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget
    #Developing_Size_Width=1000
    #Developing_Size_Height=785
    #Max_GUI_Size_X=2000
    #Max_GUI_Size_Y=1570
    #Window_Background_Color=$22BB22
    #Max_needed_Font_Size=60 ; This is the maximum font size to be output - between 40 and 60 should usually be enough
    #Padding_x=25            ; Text padding X
    #PreShrink_large_images_x=#Max_GUI_Size_X/2.5
    #PreShrink_large_images_y=#Max_GUI_Size_y/2.5
    CompilerIf #PB_Compiler_OS=#PB_OS_Linux
      #Min_GUI_Size_X=380 
      #Min_GUI_Size_Y=260
      #Padding_y=25 ; Text padding y
    CompilerElse
      #Min_GUI_Size_X=230 
      #Min_GUI_Size_Y=200
      #Padding_y=5 ; Text padding y
    CompilerEndIf
    
    Enumeration Buttons_PB ; TODO - Add here your gadgets - Important, use ever continuously enumeration, do not produce doublets
      #ButtonGadget_1
      #ButtonGadget_2
      #ButtonGadget_3
    EndEnumeration
    
    Enumeration Other_gadgets_PB #PB_Compiler_EnumerationValue+1 ; TODO - A furter enumeration
      #EditorGadget_1
    EndEnumeration
    
    Enumeration Gadgets_BF #PB_Compiler_EnumerationValue+1 ; TODO - A furter enumeration
      #ImageGadget_BF_1
      #ImageGadget_BF_2
      #TextGadget_BF_1
      #TextGadget_BF_2
      #TextGadget_BF_3
      #ColorButtonGadget_BF_1
      #ColorButtonGadget_BF_2
      #ButtonImageGadget_BF_1
      #ButtonImageGadget_BF_2
      #GIF_1_BF
      #GIF_2_BF
    EndEnumeration
    
    Enumeration images_BF #PB_Compiler_EnumerationValue+1 ; TODO - A furter enumeration
      #Additional_Image_BF_Rose
      #Additional_Image_BF_Foxy
      #Temporary_Image_1
    EndEnumeration
    
    CompilerIf #PB_Compiler_OS=#PB_OS_Windows ; Deactivate on demand resizing Windows OS < Win10
      Procedure GetVersion()                  ; Version code based by TS-Soft
        Protected version.OSVERSIONINFO
        version\dwOSVersionInfoSize=SizeOf(OSVERSIONINFO)
        If GetVersionEx_(@version)
          ProcedureReturn Val(Str(version\dwPlatformId)+Str(version\dwMajorVersion)+Str(version\dwMinorVersion))
        EndIf
      EndProcedure
      If GetVersion()<262
        on_demand_resizing=#False 
      EndIf
    CompilerEndIf
    
    ; Workaround Linux PB570 window background color
    CompilerIf #PB_Compiler_OS=#PB_OS_Linux And Not Subsystem("gtk2") And Not Subsystem("qt")
      Macro SetWindowColor(window_ID, color)
        Window_SetCssBackColor(window_ID, color)
      EndMacro
      ImportC "" ; By Oma
        gtk_css_provider_load_from_data(*css_provider, data_.p-utf8, length, *error.GError)
        gtk_css_provider_new()
        gtk_style_context_add_provider(*context, *provider, priority)
        gtk_widget_get_style_context(*widget.GtkWidget)
      EndImport
      Procedure Window_SetCssBackColor(Window_ID, color)
        #GTK_STYLE_PROVIDER_PRIORITY_USER=800
        Protected color$, *gProvider=gtk_css_provider_new()
        ; Protected color$="#"+RSet(Hex(color), 6, "000000")
        color$="#"+RSet(Hex(Red(color)), 2, "00")+RSet(Hex(Green(color)), 2, "00")+RSet(Hex(Blue(color)), 2, "00")   
        Protected.s WinBkGndCSS="window.background{background-color: "+color$+";" + #LF$ + "}"
        gtk_css_provider_load_from_data(*gProvider, WinBkGndCSS, -1, #Null)
        gtk_style_context_add_provider(gtk_widget_get_style_context(WindowID(window_ID)), *gProvider, #GTK_STYLE_PROVIDER_PRIORITY_USER)
      EndProcedure
    CompilerEndIf
    
    Global amount_parameters=#PB_Compiler_EnumerationValue-1 ; Change this line not
    
    ; You can simple add needed other definitions - As sample for new user created custom Gadgets_BF
    Global Dim gadget_ID(amount_parameters)
    Global Dim image_ID_1_gadget(amount_parameters)
    Global Dim image_ID_2_gadget(amount_parameters)
    Global Dim temporary_image_ID_1_gadget(amount_parameters)
    Global Dim image_frame_ID(amount_parameters)
    Global Dim font_ID_gadget(amount_parameters) 
    Global Dim x_pos_gadget(amount_parameters)
    Global Dim y_pos_gadget(amount_parameters)
    Global Dim width_gadget(amount_parameters)
    Global Dim height_gadget(amount_parameters)
    Global Dim text_1_gadget$(amount_parameters)
    Global Dim text_2_gadget$(amount_parameters)
    Global Dim text_color_gadget(amount_parameters)
    Global Dim background_color_gadget(amount_parameters)
    Global Dim grid_color_gadget(amount_parameters)
    Global Dim grid_size_gadget(amount_parameters)
    Global Dim grid_tiling_gadget(amount_parameters)
    Global Dim frame_color_gadget(amount_parameters)
    Global Dim frame_size_gadget(amount_parameters)
    Global Dim frame_flag_gadget(amount_parameters)
    Global Dim stretch_x_gadget(amount_parameters)
    Global Dim stretch_y_gadget(amount_parameters)
    Global Dim flag_gadget(amount_parameters)
    Global Dim flag_canvas_gadget(amount_parameters)
    Global Dim mode_gadget(amount_parameters)
    Global Dim padding_gadget(amount_parameters)
    Global Dim padding_x_gadget(amount_parameters)
    Global Dim padding_y_gadget(amount_parameters)
    
    Global Dim Font_Arial(#Max_needed_Font_Size)
    Global window_ID, origin_window_width.f, origin_window_height.f, needed_font_size, progressbar_count, flip, gadget_grid_size_1
    Global frame, frames, output_width, output_height
    Global texture_clip_x, texture_clip_y, texture_clip_width, texture_clip_height
    
    Procedure set_x(position_x.f) : ProcedureReturn position_x/(origin_window_width/WindowWidth(window_ID)) : EndProcedure
    Procedure set_y(position_y.f) : ProcedureReturn position_y/(origin_window_height/WindowHeight(window_ID)) : EndProcedure
    
    Procedure get_font_resize_factor(set_font, divisor.f)
      Protected result
      result=set_font/divisor
      If result<1 : result=1 : EndIf
      If result>needed_font_size-1 : result=needed_font_size-1 : EndIf
      ProcedureReturn result
    EndProcedure
    
    Procedure calculate_Font_Arial(text$,
                                   button_width,
                                   button_height,
                                   resize_factor.f=1)
      
      ProcedureReturn Calculate_fitted_Font_BF(text$,
                                               set_x(button_width),
                                               set_y(button_height),
                                               Font_Arial(),
                                               0, ; Vertical
                                               #Padding_x,
                                               #Padding_y,
                                               0, ; Stretch x
                                               0, ; Stretch y
                                               resize_factor.f)
    EndProcedure
    
    Procedure calculated_font_ID(set_font, resize_factor.f)
      ProcedureReturn FontID(Font_Arial(get_font_resize_factor(set_font, resize_factor)))
    EndProcedure
    
    Procedure WindowResizing_BindEvent_CreateGUI_1()
      
      ; TODO === Grab the font you need from a gadget to inherit
      ; You can use inheritance, this is very fast, or you can use this function for any gadgets individually
      Global set_font=calculate_Font_Arial(text_1_gadget$(#ButtonGadget_1),
                                           width_gadget(#ButtonGadget_1)*DPI_ResizeFactor_BF(),
                                           height_gadget(#ButtonGadget_1)*DPI_ResizeFactor_BF(),
                                           1.1) ; Resize factor as float, you can, but you must not set
      
      ; TODO === Add here the resize calls for your gadgets =======================================================
      ; It is mostly sufficient to calculate the required font size from only one PB gadget
      ; This can then be inherited by many similar other gadgets, and also the size can be changed arbitrarily - this is very fast
      ; Gadgets_BF automatically inherit all parameters and only changed parameters have to be set
      ; Use you a Gadget_BF, you must give free again each used before you leave the tool
      
      ; Calculate a resize factor for the ImageGadget_BF grid and frame
      Global gadget_frame_size=get_font_resize_factor(set_font, 6.0)
      Global gadget_grid_size=get_font_resize_factor(set_font, 3.0)
      
      Macro ColorButtonGadget_BF_2
        ; ColorButtonGadget_BF 2
        ; Add a overlay color
        FitImage_Add_Overlay_Color_BF(1,
                                      $FF00, ; Overlay color
                                      160,   ; Overlay alpha
                                      0,
                                      0,
                                      set_x(progressbar_count)*DPI_ResizeFactor_BF(),
                                      set_y(height_gadget(#ColorButtonGadget_BF_2))*DPI_ResizeFactor_BF())
        
        ; Add a overlay frame
        FitImage_Add_Overlay_Frame_BF(1,
                                      $FF, ; Overlay color
                                      160, ; Overlay alpha
                                      -get_font_resize_factor(set_font, 4.0),
                                      -get_font_resize_factor(set_font, 4.0),
                                      set_x((progressbar_count)+get_font_resize_factor(set_font, 4.0))*DPI_ResizeFactor_BF(),
                                      set_y((height_gadget(#ColorButtonGadget_BF_2))+get_font_resize_factor(set_font, 2.0))*DPI_ResizeFactor_BF(),
                                      get_font_resize_factor(set_font, 4.0)) ; Frame thickness
        
        ; Add a background image
        DrawTextCreateImage_Add_Image_BF(1,
                                         temporary_image_ID_1_gadget(#Additional_Image_BF_Rose),
                                         40,                        ; x pos
                                         20,                        ; y pos
                                         140*DPI_ResizeFactor_BF(), ; width
                                         100*DPI_ResizeFactor_BF(), ; Height
                                         100)                       ; Alpha / -1 = ignore
        
        ; ManualPadding_DrawTextCreateImage_X_BF(100) ; Additional text padding for DrawTextCreateImage_BF - Works with all DrawTextCreateImage_BF Functions
        SetColorButtonGadget_BF(gadget_ID(#ColorButtonGadget_BF_2), ; ButtonGadget_BF calculate the needed font size self
                                "",
                                -1,
                                -1,
                                set_x(x_pos_gadget(#ColorButtonGadget_BF_2)),
                                set_y(y_pos_gadget(#ColorButtonGadget_BF_2)),
                                set_x(width_gadget(#ColorButtonGadget_BF_2)),
                                set_y(height_gadget(#ColorButtonGadget_BF_2)),
                                10, ; Padding x
                                3)  ; Padding y
                                    ; ManualPadding_DrawTextCreateImage_X_BF(0) ; Additional text padding for DrawTextCreateImage_BF - Works with all DrawTextCreateImage_BF Functions
        
        DrawTextCreateImage_Add_Image_BF(0) ; Deactivate background image
        
        FitImage_Add_Overlay_Frame_BF(0) ; Deactivate overlay frame
        
        FitImage_Add_Overlay_Color_BF(0) ; Deactivate overlay color
        
      EndMacro
      
      ; ButtonGadget PB 1
      SetGadgetFont(gadget_ID(#ButtonGadget_1), FontID(Font_Arial(set_font)))
      ResizeGadget(gadget_ID(#ButtonGadget_1),
                   set_x(x_pos_gadget(#ButtonGadget_1)),
                   set_y(y_pos_gadget(#ButtonGadget_1)),
                   set_x(width_gadget(#ButtonGadget_1)),
                   set_y(height_gadget(#ButtonGadget_1)))
      
      ; ButtonGadget PB 2
      SetGadgetFont(gadget_ID(#ButtonGadget_2), calculated_font_ID(set_font, 1.6)) ; Adjust the needed font size for this gadget a little
      ResizeGadget(gadget_ID(#ButtonGadget_2),
                   set_x(x_pos_gadget(#ButtonGadget_2)),
                   set_y(y_pos_gadget(#ButtonGadget_2)),
                   set_x(width_gadget(#ButtonGadget_2)),
                   set_y(height_gadget(#ButtonGadget_2)))
      
      ; ButtonGadget PB 3
      SetGadgetFont(gadget_ID(#ButtonGadget_3), calculated_font_ID(set_font, 1.6)) ; Adjust the needed font size for this gadget a little
      ResizeGadget(gadget_ID(#ButtonGadget_3),
                   set_x(x_pos_gadget(#ButtonGadget_3)),
                   set_y(y_pos_gadget(#ButtonGadget_3)),
                   set_x(width_gadget(#ButtonGadget_3)),
                   set_y(height_gadget(#ButtonGadget_3)))
      
      ; EditorGadget PB 1
      SetGadgetFont(gadget_ID(#EditorGadget_1), calculated_font_ID(set_font, 2.0))
      ResizeGadget(gadget_ID(#EditorGadget_1),
                   set_x(x_pos_gadget(#EditorGadget_1)),
                   set_y(y_pos_gadget(#EditorGadget_1)),
                   set_x(width_gadget(#EditorGadget_1))-2,
                   set_y(height_gadget(#EditorGadget_1)))
      
      ; ColorButtonGadget_BF 1
      ; ManualPadding_DrawTextCreateImage_X_BF(100) ; Additional text padding for DrawTextCreateImage_BF - Works with all DrawTextCreateImage_BF Functions
      SetColorButtonGadget_DualPadding_BF(gadget_ID(#ColorButtonGadget_BF_1), ; ButtonGadget_BF calculate the needed font size self
                                          "",
                                          -1,
                                          -1,
                                          10, ; Padding x
                                          3,  ; Padding y
                                          set_x(x_pos_gadget(#ColorButtonGadget_BF_1)),
                                          set_y(y_pos_gadget(#ColorButtonGadget_BF_1)),
                                          set_x(width_gadget(#ColorButtonGadget_BF_1)),
                                          set_y(height_gadget(#ColorButtonGadget_BF_1)))
      ; ManualPadding_DrawTextCreateImage_X_BF(0)
      
      ; ImageGadget_BF 2
      ColorButtonGadget_BF_2 ; Macro
      
      ; ImageGadget_BF 1
      SetImageGadget_BF(gadget_ID(#ImageGadget_BF_1),
                        image_ID_1_gadget(#ImageGadget_BF_1),
                        set_x(x_pos_gadget(#ImageGadget_BF_1)),
                        set_y(y_pos_gadget(#ImageGadget_BF_1)),
                        set_x(width_gadget(#ImageGadget_BF_1)),
                        set_y(height_gadget(#ImageGadget_BF_1)))
      
      ; ImageGadget_BF 2
      ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
      SetImageGadget_BF(gadget_ID(#ImageGadget_BF_2),
                        image_ID_1_gadget(#ImageGadget_BF_2),
                        set_x(x_pos_gadget(#ImageGadget_BF_2)),
                        set_y(y_pos_gadget(#ImageGadget_BF_2)),
                        set_x(width_gadget(#ImageGadget_BF_2)),
                        set_y(height_gadget(#ImageGadget_BF_2)),
                        background_color_gadget(#ImageGadget_BF_2),
                        -1,
                        -1,
                        gadget_grid_size, ; We get the inherited grid size
                        0,
                        -1,
                        gadget_frame_size) ; We get the inherited frame size
      
      ; ButtonImageGadget_BF 1
      ; ManualPadding_DrawTextCreateImage_X_BF(40) ; Additional text padding for DrawTextCreateImage_BF - Works with all DrawTextCreateImage_BF Functions
      SetButtonImageGadget_BF(gadget_ID(#ButtonImageGadget_BF_1),
                              image_ID_1_gadget(#GIF_2_BF),
                              background_color_gadget(#ButtonImageGadget_BF_1),
                              set_x(x_pos_gadget(#ButtonImageGadget_BF_1)),
                              set_y(y_pos_gadget(#ButtonImageGadget_BF_1)),
                              set_x(width_gadget(#ButtonImageGadget_BF_1)),
                              set_y(height_gadget(#ButtonImageGadget_BF_1)),
                              5,
                              3)
      ; ManualPadding_DrawTextCreateImage_X_BF(0)
      
      ; ButtonImageGadget_BF 2
      If GetGadgetData(gadget_ID(#ButtonImageGadget_BF_2))
        Protected fading_image_1=image_ID_2_gadget(#ButtonImageGadget_BF_2)
      Else
        fading_image_1=image_ID_1_gadget(#ButtonImageGadget_BF_2)
      EndIf
      SetButtonImageGadget_BF(gadget_ID(#ButtonImageGadget_BF_2),
                              fading_image_1,
                              background_color_gadget(#ButtonImageGadget_BF_2),
                              set_x(x_pos_gadget(#ButtonImageGadget_BF_2)),
                              set_y(y_pos_gadget(#ButtonImageGadget_BF_2)),
                              set_x(width_gadget(#ButtonImageGadget_BF_2)),
                              set_y(height_gadget(#ButtonImageGadget_BF_2)))
      
      ; TextGadget_BF 1
      ; Add a background image
      DrawTextCreateImage_Add_Image_BF(1,
                                       temporary_image_ID_1_gadget(#Additional_Image_BF_Rose),
                                       10,  ; x pos
                                       0,   ; y pos
                                       190, ; width
                                       140, ; Height
                                       50)  ; Alpha / -1 = ignore
      
      SetTextGadget_BF(gadget_ID(#TextGadget_BF_1),
                       text_1_gadget$(#TextGadget_BF_1),
                       text_color_gadget(#TextGadget_BF_1),
                       background_color_gadget(#TextGadget_BF_1),
                       set_x(x_pos_gadget(#TextGadget_BF_1)),
                       set_y(y_pos_gadget(#TextGadget_BF_1)),
                       set_x(width_gadget(#TextGadget_BF_1)),
                       set_y(height_gadget(#TextGadget_BF_1)))
      
      DrawTextCreateImage_Add_Image_BF(0) ; Deactivate background image 
      
      ; TextGadget_BF 2
      ; Add a background image
      DrawTextCreateImage_Add_Image_BF(1,
                                       temporary_image_ID_1_gadget(#Additional_Image_BF_Foxy),
                                       0,                         ; x pos
                                       0,                         ; y pos
                                       100*DPI_ResizeFactor_BF(), ; width
                                       160*DPI_ResizeFactor_BF(), ; Height
                                       50)                        ; Alpha / -1 = ignore
      
      If GetGadgetData(gadget_ID(#TextGadget_BF_2))
        Protected fading_text_1$=text_2_gadget$(#TextGadget_BF_2) ; text_a,
      Else
        fading_text_1$=text_1_gadget$(#TextGadget_BF_2) ; text_b,
      EndIf        
      SetTextGadget_BF(gadget_ID(#TextGadget_BF_2),
                       fading_text_1$,
                       -1,
                       -1,
                       set_x(x_pos_gadget(#TextGadget_BF_2)),
                       set_y(y_pos_gadget(#TextGadget_BF_2)),
                       set_x(width_gadget(#TextGadget_BF_2)),
                       set_y(height_gadget(#TextGadget_BF_2)))
      
      DrawTextCreateImage_Add_Image_BF(0) ; Deactivate background image
      
      ; TextGadget_BF 3
      SetTextGadget_BF(gadget_ID(#TextGadget_BF_3),
                       "",
                       -1,
                       -1,
                       set_x(x_pos_gadget(#TextGadget_BF_3)),
                       set_y(y_pos_gadget(#TextGadget_BF_3)),
                       set_x(width_gadget(#TextGadget_BF_3)),
                       set_y(height_gadget(#TextGadget_BF_3)))
      
      ; ImageGadget_BF GIF 1
      ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
      
      If flip : Protected gadget_grid_size_1=0 : Else : gadget_grid_size_1=gadget_grid_size : EndIf
      SetImageGadget_BF(gadget_ID(#GIF_1_BF),
                        image_frame_ID(#Temporary_Image_1),
                        set_x(x_pos_gadget(#GIF_1_BF)),
                        set_y(y_pos_gadget(#GIF_1_BF)),
                        set_x(width_gadget(#GIF_1_BF)),
                        set_y(height_gadget(#GIF_1_BF)),
                        -1,
                        -1,
                        -1,
                        gadget_grid_size_1,
                        -1,
                        -1,
                        gadget_frame_size) ; We get the inherited frame size
      
      ; ImageGadget_BF GIF 2
      ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
      SetImageGadget_BF(gadget_ID(#GIF_2_BF),
                        image_frame_ID(#Temporary_Image_1),
                        set_x(320),
                        set_y(390),
                        set_x(360),
                        set_y(230))
      
      ; End add resize calls ======================================================================================
    EndProcedure
    
    Procedure CreateGUI_1(titel$="", x=0, y=0, width=0, height=0)
      ; The subsystem Linux gtk3 can expand BF MessageRequester_Pro and ButtonGadgets_BF slightly in size
      ; So you can preset a negative offset to adjust the buttons
      ; Don't select these offsets too big, the button text will get smaller and smaller
      ; Different gtk3 versions can affect button sizes differently
      ; Especially all smaller buttons are automatically enlarged, which can make precise adjustment much more difficult
      ; This is not a failure of GFX_Wizzard_BF, but a "feature" of gtk3 :-(
      ; The wizard currently automatically activates gtk3 offsets, which you can also change so :
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        CompilerIf Not Subsystem("gtk2") And Not Subsystem("qt")
          gtk3_button_x_offset_BF(13) ; Presetted x=13
          gtk3_button_y_offset_BF(6)  ; Presetted y=6
        CompilerEndIf
      CompilerEndIf
      
      window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore , #Developing_Size_Width, #Developing_Size_Height, titel$, #UsedWindowFlags)
      
      If Not IsWindow(window_ID) : ProcedureReturn -24 : EndIf
      
      Protected win_center_x_pos=WindowX(window_ID), win_center_y_pos=WindowY(window_ID)
      
      For needed_font_size=1 To #Max_needed_Font_Size ; Get the fonts
        Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
      Next needed_font_size
      
      origin_window_width=WindowWidth(window_ID) : origin_window_height=WindowHeight(window_ID)
      
      ; TODO === Add here your gadgets ===========================================================================
      
      ; ============= Available_parameters =============
      ; gadget_ID(#SampleGadget)
      ; image_ID_1_gadget(#SampleGadget)
      ; image_ID_2_gadget(#SampleGadget)
      ; temporary_image_ID_1_gadget(#SampleGadget)
      ; image_frame_ID(#SampleGadget)
      ; font_ID_gadget(#SampleGadget) 
      ; x_pos_gadget(#SampleGadget)
      ; y_pos_gadget(#SampleGadget)
      ; width_gadget(#SampleGadget)
      ; height_gadget(#SampleGadget)
      ; text_1_gadget$(#SampleGadget)
      ; text_2_gadget$(#SampleGadget)
      ; text_color_gadget(#SampleGadget)
      ; background_color_gadget(#SampleGadget)
      ; grid_color_gadget(#SampleGadget)
      ; grid_size_gadget(#SampleGadget)
      ; grid_tiling_gadget(#SampleGadget)
      ; frame_color_gadget(#SampleGadget)
      ; frame_size_gadget(#SampleGadget)
      ; frame_flag_gadget(#SampleGadget)
      ; stretch_x_gadget(#SampleGadget)
      ; stretch_y_gadget(#SampleGadget)
      ; flag_gadget(#SampleGadget)
      ; flag_canvas_gadget(#SampleGadget)
      ; mode_gadget(#SampleGadget)
      ; padding_gadget(#SampleGadget)
      ; padding_x_gadget(#SampleGadget)
      ; padding_y_gadget(#SampleGadget)
      
      temporary_image_ID_1_gadget(#Additional_Image_BF_Rose)=LoadImage(#PB_Any, "./Image_Set/Rose.png") ; Additional image 1     
      temporary_image_ID_1_gadget(#Additional_Image_BF_Foxy)=LoadImage(#PB_Any, "./Image_Set/Foxy.png") ; Additional image 2
      
      ; ================= ButtonGadget PB 1 ==================
      text_1_gadget$(#ButtonGadget_1)="You can"+#LF$+"resize the Window"
      width_gadget(#ButtonGadget_1)=300
      height_gadget(#ButtonGadget_1)=100
      x_pos_gadget(#ButtonGadget_1)=350
      y_pos_gadget(#ButtonGadget_1)=170
      
      gadget_ID(#ButtonGadget_1)=ButtonGadget(#PB_Any, 0, 0, 0, 0, ; Position and size data you must not set for initializing PB gadgets
                                              text_1_gadget$(#ButtonGadget_1),#PB_Button_MultiLine)
      
      ; ================= ButtonGadget PB 2 ==================
      text_1_gadget$(#ButtonGadget_2)="Bye"
      width_gadget(#ButtonGadget_2)=100
      height_gadget(#ButtonGadget_2)=50
      x_pos_gadget(#ButtonGadget_2)=867
      y_pos_gadget(#ButtonGadget_2)=670
      
      gadget_ID(#ButtonGadget_2)=ButtonGadget(#PB_Any, 0, 0, 0, 0, ; Position and size data you must not set for initializing PB gadgets
                                              text_1_gadget$(#ButtonGadget_2),
                                              #PB_Button_MultiLine)
      
      ; ================= ButtonGadget PB 3 ==================
      text_1_gadget$(#ButtonGadget_3)="Default size"
      width_gadget(#ButtonGadget_3)=120
      height_gadget(#ButtonGadget_3)=50
      x_pos_gadget(#ButtonGadget_3)=712
      y_pos_gadget(#ButtonGadget_3)=670
      
      gadget_ID(#ButtonGadget_3)=ButtonGadget(#PB_Any, 0, 0, 0, 0, ; Position and size data you must not set for initializing PB gadgets
                                              text_1_gadget$(#ButtonGadget_3))
      
      ; ================ Editor Gadget PB 1 =================
      ; Sample for simple add any gadgets
      text_1_gadget$(#EditorGadget_1)="Feature demos"+#LF$+#LF$+
                                      "You can get function calls"+#LF$+"from this demo"+#LF$+
                                      "and see how they work"+#LF$+
                                      "For practical use you will"+#LF$+
                                      "find easier to handle codes"+#LF$+#LF$+
                                      "So it is primarily a test code"+#LF$+
                                      "Very well suited to locate"+#LF$+
                                      "different PB bugs"
      width_gadget(#EditorGadget_1)=260
      height_gadget(#EditorGadget_1)=200
      x_pos_gadget(#EditorGadget_1)=710
      y_pos_gadget(#EditorGadget_1)=200
      
      gadget_ID(#EditorGadget_1)=EditorGadget(#PB_Any, 0, 0, 0, 0) ; Position and size data you must not set for initializing PB gadgets
      
      SetGadgetText(gadget_ID(#EditorGadget_1), text_1_gadget$(#EditorGadget_1))
      
      ; =========== ColorButtonGadget_BF 1 =============
      text_1_gadget$(#ColorButtonGadget_BF_1)="This is a ColorButtonGadget_BF"+#LF$+
                                              "Perfect fitted stepless resizable text"+#LF$+
                                              "Works at the same on all OS"
      
      width_gadget(#ColorButtonGadget_BF_1)=260
      height_gadget(#ColorButtonGadget_BF_1)=90
      x_pos_gadget(#ColorButtonGadget_BF_1)=30
      y_pos_gadget(#ColorButtonGadget_BF_1)=30
      text_color_gadget(#ColorButtonGadget_BF_1)=#Yellow
      background_color_gadget(#ColorButtonGadget_BF_1)=#Red
      
      gadget_ID(#ColorButtonGadget_BF_1)=ColorButtonGadget_BF(text_1_gadget$(#ColorButtonGadget_BF_1),
                                                              x_pos_gadget(#ColorButtonGadget_BF_1),
                                                              y_pos_gadget(#ColorButtonGadget_BF_1),
                                                              -1, ; You must not set here, look, you have define above
                                                              -1,
                                                              text_color_gadget(#ColorButtonGadget_BF_1),
                                                              background_color_gadget(#ColorButtonGadget_BF_1),
                                                              Font_Arial(25)) ; Max font size 25 is enough here - Use not larger as needed, too large make the output slow, larger as #Max_needed_Font_Size crash the array
                                                                              ; BF Supports also automatically text upscaling with the function FitImageActivateUpscaling_BF
      
      ; =========== ColorButtonGadget_BF 2 =============
      text_1_gadget$(#ColorButtonGadget_BF_2)="GFX_Wizzard_BF"+#LF$+
                                              "Create a dynamic GUI without XML"+#LF$+
                                              "- Click me -"
      width_gadget(#ColorButtonGadget_BF_2)=350
      height_gadget(#ColorButtonGadget_BF_2)=110
      x_pos_gadget(#ColorButtonGadget_BF_2)=325
      y_pos_gadget(#ColorButtonGadget_BF_2)=20
      text_color_gadget(#ColorButtonGadget_BF_2)=#Blue
      background_color_gadget(#ColorButtonGadget_BF_2)=$FFFF
      
      gadget_ID(#ColorButtonGadget_BF_2)=ColorButtonGadget_BF(text_1_gadget$(#ColorButtonGadget_BF_2),
                                                              x_pos_gadget(#ColorButtonGadget_BF_2),
                                                              y_pos_gadget(#ColorButtonGadget_BF_2),
                                                              -1, ; You must not set here, look, you have define above
                                                              -1,
                                                              text_color_gadget(#ColorButtonGadget_BF_2),
                                                              background_color_gadget(#ColorButtonGadget_BF_2),
                                                              Font_Arial(40)) ; Max font size 40 is enough here - Use not larger as needed, too large make the output slow, larger as #Max_needed_Font_Size crash the array
                                                                              ; BF Supports also automatically text upscaling with the function FitImageActivateUpscaling_BF
      
      ; =============== ImageGadget_BF 1 ==================
      image_ID_1_gadget(#ImageGadget_BF_1)=LoadImage(#PB_Any, "./Image_Set/Lion.png")
      width_gadget(#ImageGadget_BF_1)=230
      height_gadget(#ImageGadget_BF_1)=170
      x_pos_gadget(#ImageGadget_BF_1)=725
      y_pos_gadget(#ImageGadget_BF_1)=10
      grid_color_gadget(#ImageGadget_BF_1)=0
      grid_size_gadget(#ImageGadget_BF_1)=8
      grid_tiling_gadget(#ImageGadget_BF_1)=10
      frame_size_gadget(#ImageGadget_BF_1)=4
      
      gadget_ID(#ImageGadget_BF_1)=ImageGadget_BF(image_ID_1_gadget(#ImageGadget_BF_1), ; You must only set needed parameters
                                                  -1,                                   ; Mostly data you must not set here, look, you have define above
                                                  -1,
                                                  -1,
                                                  -1,
                                                  -2) ; Background color - For a invisible background set background_color=-2
      
      ; =============== ImageGadget_BF 2 ==================
      image_ID_1_gadget(#ImageGadget_BF_2)=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
      width_gadget(#ImageGadget_BF_2)=260
      height_gadget(#ImageGadget_BF_2)=200
      x_pos_gadget(#ImageGadget_BF_2)=710
      y_pos_gadget(#ImageGadget_BF_2)=450
      background_color_gadget(#ImageGadget_BF_2)=$808080
      
      gadget_ID(#ImageGadget_BF_2)=ImageGadget_BF(image_ID_1_gadget(#ImageGadget_BF_2),
                                                  -1, ; Mostly data you must not set here, look, you have define above
                                                  -1,
                                                  -1,
                                                  -1,
                                                  background_color_gadget(#ImageGadget_BF_2), ; Background color - For a invisible background set background_color=-2
                                                  10)                                         ; Padding
      
      ; ============= ButtonImageGadget_BF 1 ==============
      image_ID_1_gadget(#ButtonImageGadget_BF_1)=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
      width_gadget(#ButtonImageGadget_BF_1)=260
      height_gadget(#ButtonImageGadget_BF_1)=90
      x_pos_gadget(#ButtonImageGadget_BF_1)=30
      y_pos_gadget(#ButtonImageGadget_BF_1)=520
      background_color_gadget(#ButtonImageGadget_BF_1)=$20A5DA
      padding_x_gadget(#ButtonImageGadget_BF_1)=7
      padding_y_gadget(#ButtonImageGadget_BF_1)=7
      
      gadget_ID(#ButtonImageGadget_BF_1)=ButtonImageGadget_BF(image_ID_1_gadget(#ButtonImageGadget_BF_1),
                                                              background_color_gadget(#ButtonImageGadget_BF_1),
                                                              x_pos_gadget(#ButtonImageGadget_BF_1),
                                                              y_pos_gadget(#ButtonImageGadget_BF_1),
                                                              width_gadget(#ButtonImageGadget_BF_1),
                                                              height_gadget(#ButtonImageGadget_BF_1),
                                                              padding_x_gadget(#ButtonImageGadget_BF_1),
                                                              padding_y_gadget(#ButtonImageGadget_BF_1))
      
      ; ============= ButtonImageGadget_BF 2 ==============
      Protected temp_ID=LoadImage(#PB_Any, "./Image_Set/Penguin.jpg")
      width_gadget(#ButtonImageGadget_BF_2)=260
      height_gadget(#ButtonImageGadget_BF_2)=90
      x_pos_gadget(#ButtonImageGadget_BF_2)=30
      y_pos_gadget(#ButtonImageGadget_BF_2)=395
      background_color_gadget(#ButtonImageGadget_BF_2)=#Yellow
      padding_x_gadget(#ButtonImageGadget_BF_2)=15
      padding_y_gadget(#ButtonImageGadget_BF_2)=15
      
      image_ID_1_gadget(#ButtonImageGadget_BF_2)=CreateImage(#PB_Any,
                                                             800,
                                                             280,
                                                             24,
                                                             #Yellow)
      
      image_ID_2_gadget(#ButtonImageGadget_BF_2)=image_ID_1_gadget(#ButtonImageGadget_BF_1) ; Add a second image ID for creating a fade Button
      
      SetColorDistanceSpriteMask_BF(10) ; Percent color distance
      SpriteSimple_Fast_BF(1, image_ID_1_gadget(#ButtonImageGadget_BF_2), temp_ID, ; Output a BF Sprite
                           0,
                           0,
                           280,
                           20,
                           0,
                           0)
      SetColorDistanceSpriteMask_BF(0) ; Deactivate color distance
      
      BackColor_BF(1, $578B2E) ; Add gradient colors
      GradientColor_Array_BF(1, 1, 0.3, $FF)
      GradientColor_Array_BF(1, 2, 0.9, $FF0000)
      LinearGradient_BF(1, 0, 0,
                        ImageWidth(image_ID_1_gadget(#ButtonImageGadget_BF_2))*1.4,
                        ImageHeight(image_ID_1_gadget(#ButtonImageGadget_BF_2))*1.0)
      
      Protected font_size_1=40/DPI_ResizeFactor_BF()
      Protected font_size_2=35/DPI_ResizeFactor_BF()
      StartDrawing(ImageOutput(image_ID_1_gadget(#ButtonImageGadget_BF_2))) ; Add text
                                                                            ; DrawText_BF(set_x(10), set_y(5), "BF is Cool", f_col=#White, b_col=#Black, flag=0, mode=0, stretch_x=0, stretch_y=0)
                                                                            ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                                                            ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
      
      DrawingFont(FontID(Font_Arial(font_size_1)))
      DrawText_BF(0, 20, "BF is Cool", #Blue, #Yellow, 0, 0, 0, 0)
      DrawingFont(FontID(Font_Arial(font_size_2)))
      DrawText_BF(570, 10, "Also"+#LF$+"says"+#LF$+"the"+#LF$+"Penguin", #Blue, #Yellow, 1, 0, 0, 0)
      StopDrawing()
      DeactivateGradientColors_BF()
      
      gadget_ID(#ButtonImageGadget_BF_2)=ButtonImageGadget_BF(image_ID_1_gadget(#ButtonImageGadget_BF_2),
                                                              background_color_gadget(#ButtonImageGadget_BF_2),
                                                              x_pos_gadget(#ButtonImageGadget_BF_2),
                                                              y_pos_gadget(#ButtonImageGadget_BF_2),
                                                              width_gadget(#ButtonImageGadget_BF_2),
                                                              height_gadget(#ButtonImageGadget_BF_2),
                                                              padding_x_gadget(#ButtonImageGadget_BF_2),
                                                              padding_y_gadget(#ButtonImageGadget_BF_2))
      
      ; ================ TextGadget_BF 1 =================
      text_1_gadget$(#TextGadget_BF_1)="  GFX_Wizzard_BF"+#LF$+
                                       "This is a TextGadget_BF"+#LF$+
                                       "Center, Right, Left, Revers, RTL"
      width_gadget(#TextGadget_BF_1)=280
      height_gadget(#TextGadget_BF_1)=100
      x_pos_gadget(#TextGadget_BF_1)=350
      y_pos_gadget(#TextGadget_BF_1)=655
      text_color_gadget(#TextGadget_BF_1)=#Blue
      background_color_gadget(#TextGadget_BF_1)=#Window_Background_Color
      stretch_x_gadget(#TextGadget_BF_1)=0
      stretch_y_gadget(#TextGadget_BF_1)=0
      font_ID_gadget(#TextGadget_BF_1)=Font_Arial(20) ; Max font size - Use not larger as needed, too large make the output slow, larger as #Max_needed_Font_Size crash the array
      flag_gadget(#TextGadget_BF_1)=1                 ; BF Supports also automatically text upscaling with the function FitImageActivateUpscaling_BF
      mode_gadget(#TextGadget_BF_1)=0
      flag_canvas_gadget(#TextGadget_BF_1)=0
      
      ; Hint : The mostly parameters you must not set for initializing Gadgets_BF, they are preset with defaults
      gadget_ID(#TextGadget_BF_1)=TextGadget_BF("", ; Mostly you must not set here, look, you have define above
                                                -1,
                                                -1,
                                                -1,
                                                -1,
                                                -1,
                                                -1,
                                                font_ID_gadget(#TextGadget_BF_1),
                                                -1,
                                                -1,
                                                flag_gadget(#TextGadget_BF_1),
                                                mode_gadget(#TextGadget_BF_1),
                                                flag_canvas_gadget(#TextGadget_BF_1))
      
      ; ================ TextGadget_BF 2 =================
      text_1_gadget$(#TextGadget_BF_2)="GFX_Wizzard_BF"+#LF$+
                                       "Powerfull Gadgets"+#LF$+
                                       "This is a TextGadget_BF"+#LF$+
                                       " Center, Right, Left, Revers, RTL"
      text_2_gadget$(#TextGadget_BF_2)="WOW"+#LF$+
                                       "Nice Effects for Text output"+#LF$+
                                       "Incredible Features for Gadgets"+#LF$+
                                       "Simple a little more"
      width_gadget(#TextGadget_BF_2)=260
      height_gadget(#TextGadget_BF_2)=100
      x_pos_gadget(#TextGadget_BF_2)=30
      y_pos_gadget(#TextGadget_BF_2)=650
      text_color_gadget(#TextGadget_BF_2)=#White
      background_color_gadget(#TextGadget_BF_2)=#Red
      stretch_x_gadget(#TextGadget_BF_2)=5
      stretch_y_gadget(#TextGadget_BF_2)=5
      font_ID_gadget(#TextGadget_BF_2)=Font_Arial(20) ; Max font size - Use not larger as needed, too large make the output slow, larger as #Max_needed_Font_Size crash the array
      flag_gadget(#TextGadget_BF_2)=2                 ; BF Supports also automatically text upscaling with the function FitImageActivateUpscaling_BF
      mode_gadget(#TextGadget_BF_2)=0
      flag_canvas_gadget(#TextGadget_BF_2)=#PB_Canvas_Border
      
      gadget_ID(#TextGadget_BF_2)=TextGadget_BF("", ; Mostly you must not set here, look, you have define above
                                                -1,
                                                -1,
                                                -1,
                                                -1,
                                                -1,
                                                background_color_gadget(#TextGadget_BF_2),
                                                font_ID_gadget(#TextGadget_BF_2),
                                                -1,
                                                -1,
                                                flag_gadget(#TextGadget_BF_2),
                                                mode_gadget(#TextGadget_BF_2),
                                                flag_canvas_gadget(#TextGadget_BF_2))
      
      ; ================ TextGadget_BF 3 =================
      text_1_gadget$(#TextGadget_BF_3)="Load GIF / Image / Photo / BF Sheet"
      width_gadget(#TextGadget_BF_3)=300
      height_gadget(#TextGadget_BF_3)=55
      x_pos_gadget(#TextGadget_BF_3)=350
      y_pos_gadget(#TextGadget_BF_3)=300
      text_color_gadget(#TextGadget_BF_3)=#Red
      background_color_gadget(#TextGadget_BF_3)=#Blue
      stretch_x_gadget(#TextGadget_BF_3)=0
      stretch_y_gadget(#TextGadget_BF_3)=0
      font_ID_gadget(#TextGadget_BF_3)=Font_Arial(20) ; Max font size - Use not larger as needed, too large make the output slow, larger as #Max_needed_Font_Size crash the array
      flag_gadget(#TextGadget_BF_3)=1                 ; BF Supports also automatically text upscaling with the function FitImageActivateUpscaling_BF
      mode_gadget(#TextGadget_BF_3)=0
      flag_canvas_gadget(#TextGadget_BF_3)=#PB_Canvas_Border
      
      ; Hint : The mostly parameters you must not set for initializing Gadgets_BF, they are preset with defaults
      gadget_ID(#TextGadget_BF_3)=TextGadget_BF(text_1_gadget$(#TextGadget_BF_3),
                                                -1, ; Mostly you must not set here, look, you have define above
                                                -1,
                                                -1,
                                                -1,
                                                text_color_gadget(#TextGadget_BF_3),
                                                background_color_gadget(#TextGadget_BF_3),
                                                font_ID_gadget(#TextGadget_BF_3),
                                                -1,
                                                -1,
                                                flag_gadget(#TextGadget_BF_3),
                                                mode_gadget(#TextGadget_BF_3),
                                                flag_canvas_gadget(#TextGadget_BF_3))
      
      ; End add gadgets ===========================================================================================
      
      ; ========== Init - Change this part not ===========
      Protected init_tool=1
      SetWindowColor(window_ID, #Window_Background_Color)
      If x<0 : x=win_center_x_pos+WindowWidth(window_ID)/2-width/2 : EndIf
      If y<0 : y=win_center_y_pos+WindowHeight(window_ID)/2-height/2 : EndIf
      If width<#Min_GUI_Size_X Or height<#Min_GUI_Size_Y : Else : ResizeWindow(window_ID, x, y, width, height) : EndIf   
      WindowBounds(window_ID, #Min_GUI_Size_X, #Min_GUI_Size_Y, #Max_GUI_Size_X, #Max_GUI_Size_y)
      
      FitImageActivateUpscaling_BF(1) ; Add to the FitImage functions a automatically upscaling for little images
                                      ; With this function too small fonts and images are automatically enlarged for the Gadgets_BF
                                      ; The use of very large maximum font sizes slows down the calculation of the gadgets
                                      ; So it can make sense to use smaller pictures and fonts to enlarge them a little if necessary
                                      ; End Init =========================================
      
      ; ================ Add a GIF =======================
      ; We create firstly a SpriteSheet from the GIF
      Protected output_ID, loaded_image_ID, gif_ID, win_event, delay, init=1
      
      gif_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1.gif") ; Load a GIF with invisible color - All sizes supported
      If IsImage(gif_ID)
        ActivateAlphaChannel_BF(1) ; Create a sprite sheet from a GIF with invisible background - Deactivate AlphaChannel for using GIF without invisible color
        gif_ID=CreateCSSSheet_simple_BF(gif_ID, 2) ; This BF method is the easiest way ever for using GIF
        ActivateAlphaChannel_BF(0)
        loaded_image_ID=gif_ID
      EndIf
      
      ; For multiple GIF outputs you can simple get all GIF frame data also in a string
      ; Define sheet$=SetFrameDataInString_BF() ; Grabbing the GIF frame data and put it in a string - Take with care
      ; Then you can simple automatically move the sheet frame data in the BF Sheet and GIF variables for simplest using and output
      ; frames=GetGIFandCSS_Frames_BF() ; Count frames in the sheet
      ; GetFrameDataFromString_BF(sheet$) ; Grabb a frame data string and put it in the frame datas
      
      x_pos_gadget(#GIF_1_BF)=30
      y_pos_gadget(#GIF_1_BF)=160
      width_gadget(#GIF_1_BF)=260
      height_gadget(#GIF_1_BF)=200
      background_color_gadget(#GIF_1_BF)=$DCDCDC ; Background color - For a invisible background set background_color=-2
      padding_gadget(#GIF_1_BF)=24
      grid_color_gadget(#GIF_1_BF)=$505050
      grid_size_gadget(#GIF_1_BF)=0
      grid_tiling_gadget(#GIF_1_BF)=10
      frame_color_gadget(#GIF_1_BF)=$808080
      frame_size_gadget(#GIF_1_BF)=4
      
      gadget_ID(#GIF_1_BF)=ImageGadget_BF(0,
                                          x_pos_gadget(#GIF_1_BF),
                                          y_pos_gadget(#GIF_1_BF),
                                          width_gadget(#GIF_1_BF),
                                          height_gadget(#GIF_1_BF),
                                          background_color_gadget(#GIF_1_BF),
                                          padding_gadget(#GIF_1_BF),
                                          grid_color_gadget(#GIF_1_BF),
                                          grid_size_gadget(#GIF_1_BF),
                                          grid_tiling_gadget(#GIF_1_BF),
                                          frame_color_gadget(#GIF_1_BF),
                                          frame_size_gadget(#GIF_1_BF),
                                          flag_gadget(#GIF_1_BF))
      
      ; === Add a second GIF output ===
      gadget_ID(#GIF_2_BF)=ImageGadget_BF(0,
                                          -1,
                                          -1,
                                          -1,
                                          -1,
                                          #Window_Background_Color, ; For a invisible background set background_color=-2
                                          0,
                                          0,
                                          0,
                                          0,
                                          0,
                                          0)
      
      ; End add a GIF ====================================
      
      ; =============== Get the Output =================== 
      Delay_BF(1,-1) ; time=-1 Initialize the timer - This set the first delay to zero for beginning a animation directly without a delay
      
      Protected get_gif_loop=1
      
      Repeat ; Main loop
        
        If IsImage(gif_ID)
          Protected image_exist=1
          If GetGIFandCSS_Frames_BF()<2
            Protected is_gif=0
          Else
            is_gif=1
          EndIf
        Else
          image_exist=0
        EndIf
        
        ; === Play the GIFs or any images ===
        ; Frame delay - Using timer 1
        If image_exist And (get_gif_loop Or is_gif)
          If Delay_BF(1, GetGIFandCSS_delay_array_BF(frame)) : If init : init=0 : frame=0 : Else : frame+1 : init=0 : EndIf : If frame=>GetGIFandCSS_Frames_BF() : frame=0 : EndIf 
          EndIf
          
          image_ID_1_gadget(#GIF_1_BF)=Sprite_CSS_sheet_grab_frame_BF(gif_ID, ; It is needed, this function supports also a complete clipping
                                                                      GetGIFandCSS_Frames_BF(),
                                                                      frame,
                                                                      GetGIFandCSS_Frame_width_BF(),
                                                                      GetGIFandCSS_Frame_height_BF())
          
          If IsImage(image_ID_1_gadget(#GIF_1_BF))
            
            If flip : Protected gadget_grid_size_1=0 : Else : gadget_grid_size_1=gadget_grid_size : EndIf
            SetImageGadget_BF(gadget_ID(#GIF_1_BF),
                              image_ID_1_gadget(#GIF_1_BF),
                              set_x(x_pos_gadget(#GIF_1_BF)),
                              set_y(y_pos_gadget(#GIF_1_BF)),
                              set_x(width_gadget(#GIF_1_BF)),
                              set_y(height_gadget(#GIF_1_BF)),
                              -1,
                              -1,
                              -1,
                              gadget_grid_size_1,
                              -1,
                              -1,
                              gadget_frame_size) ; We get the inherited frame size
            
            ; === Add a second GIF output ===
            SetImageGadget_BF(gadget_ID(#GIF_2_BF),
                              image_ID_1_gadget(#GIF_1_BF),
                              set_x(320),
                              set_y(390),
                              set_x(360),
                              set_y(230))
            
            ; ButtonImageGadget_BF 1 
            SetButtonImageGadget_BF(gadget_ID(#ButtonImageGadget_BF_1),
                                    image_ID_1_gadget(#GIF_1_BF),
                                    background_color_gadget(#ButtonImageGadget_BF_1),
                                    set_x(x_pos_gadget(#ButtonImageGadget_BF_1)),
                                    set_y(y_pos_gadget(#ButtonImageGadget_BF_1)),
                                    set_x(width_gadget(#ButtonImageGadget_BF_1)),
                                    set_y(height_gadget(#ButtonImageGadget_BF_1)))
            
            ; Note : Temporary image for window resizing
            FreeImage_BF(image_frame_ID(#Temporary_Image_1))
            If CopyImage(image_ID_1_gadget(#GIF_1_BF), image_frame_ID(#Temporary_Image_1))
              FreeImage(image_ID_1_gadget(#GIF_1_BF))
              If get_gif_loop
                While WindowEvent() : Wend
                get_gif_loop=0
              EndIf
            EndIf
          EndIf
        EndIf
        ; End Play the GIFs or any images ===
        
        Repeat ; === Event loop - Get all events ===
          win_event=WaitWindowEvent(1) ; Use this here so
          
          If Delay_BF(2, 100) ; Delay for overlay progressbar simulation and canvas detection
            progressbar_count+1
            If progressbar_count>width_gadget(#ColorButtonGadget_BF_2)-get_font_resize_factor(set_font, 8.0)
              progressbar_count=0
            EndIf
            ; ImageGadget_BF 2
            ColorButtonGadget_BF_2 ; Macro - Add overlay progressbar and progeress
          EndIf
          
          If win_event=#PB_Event_SizeWindow And Not on_demand_resizing : WindowResizing_BindEvent_CreateGUI_1() : EndIf
          
          If win_event=#PB_Event_Gadget And EventGadget()=gadget_ID(#ButtonGadget_2)
            
            ; = Demonstrate MessageRequester_Pro_BF using ========
            ; = Demo with animated big GIF =======================
            Protected image_1_ID=LoadImage(#PB_Any, "./Image_Set/bird.gif")
            If Not image_1_ID : image_1_ID=-1 : EndIf ; Zero is not good, this can exist, -1 can not exist   
            Protected title_line$="MessageRequester_BF"
            Protected text$="Because the OS message requesters looks not good"+#LF$+#LF$+
                            "I made another one,"+#LF$+
                            "that can do much more"+#LF$+#LF$+
                            "GFX_Wizzard_BF"+#LF$+
                            "Simple a little more"
            Protected flags.a=#PB_MessageRequester_YesNo
            Protected text_button_yes$="Leave the Demo"
            Protected text_button_no$="Back to the Demo"
            Protected text_button_cancel$="Cancel"
            Protected text_color=$FF
            Protected text_background_color=$FFFF
            Protected buttons_width=280
            Protected buttons_height=40
            Protected button_text_color=$FF0000
            Protected button_background_color=$C0C0C0
            Protected resize_factor_button_text.f=1.0
            Protected background_color=$FF00
            Protected image_x_pos=0
            Protected image_y_pos=-50 
            Protected image_output_width=500  ; 0 = without resizing
            Protected image_output_height=500 ; 0 = without resizing
            Protected alpha=0                 ; Alpha blending - 0 deactivate the invisible color   
            
            ; SetMessageRequester_BF :
            ; mode 0 = Deactivate the function
            ; mode 1 = Save and restore the GadgetList
            ; mode 2 - Save and restore the GadgetList and create a centered output on the parent window
            ; mode 3 - Save and restore the GadgetList and create a x_pos, y_ pos adjusted output
            ; SetMessageRequester_BF(window_ID, mode, x_pos, y_pos)
            ; A window ID is not needed , you can set to -1 for ignore
            ; Set you on mode 2 or mode 3 x_pos or y_pos too -1, this position is automatically centered
            SetMessageRequester_BF(window_ID, 2)
            
            Protected result=MessageRequester_BF(Font_Arial(),
                                                 500, ; Requester width
                                                 300, ; Requester_height
                                                 title_line$,
                                                 text$,
                                                 flags.a,
                                                 text_button_yes$,
                                                 text_button_no$,
                                                 text_button_cancel$,
                                                 text_color,
                                                 text_background_color,
                                                 background_color,
                                                 button_text_color,
                                                 button_background_color,
                                                 resize_factor_button_text.f,
                                                 image_1_ID,
                                                 image_x_pos,
                                                 image_y_pos,
                                                 image_output_width,
                                                 image_output_height,
                                                 alpha)
            
            Freeimage_BF(image_1_ID)
            
            If result=#PB_MessageRequester_Yes
              Break 2
            EndIf
            
          EndIf
          
          If win_event=#PB_Event_CloseWindow
            Break 2
          EndIf
          
          If win_event=#PB_Event_Gadget
            
            If EventGadget()=gadget_ID(#TextGadget_BF_2) And EventType()=#PB_EventType_LeftButtonDown ; Canvas event
              
              ; Add a background image
              DrawTextCreateImage_Add_Image_BF(1,
                                               temporary_image_ID_1_gadget(#Additional_Image_BF_Foxy),
                                               0,   ; x pos
                                               0,   ; y pos
                                               100, ; width
                                               160, ; Height
                                               50)  ; Alpha / -1 = ignore
              
              ; SetTextGadget_BF_AutoFade_BF(gadget_ID(#TextGadget_BF_2), ; This function get and set GadgetData (0 > 1)
              ;                              text_1_gadget$(#TextGadget_BF_2), ; text_a,
              ;                              text_2_gadget$(#TextGadget_BF_2), ; text_b,
              ;                              text_color_gadget(#TextGadget_BF_2),
              ;                              background_color_gadget(#TextGadget_BF_2),
              ;                              2, ;animation_delay,
              ;                              12);animation_alpha_step
              
              SetTextGadget_BF_Fading_BF(gadget_ID(#TextGadget_BF_2), ; This function get and set GadgetData (0 > 1)
                                         text_1_gadget$(#TextGadget_BF_2), ; text_a,
                                         text_2_gadget$(#TextGadget_BF_2), ; text_b,
                                         text_color_gadget(#TextGadget_BF_2),
                                         $FFFF,
                                         2,  ;animation_delay,
                                         12) ;animation_alpha_step 
              
              DrawTextCreateImage_Add_Image_BF(0) ; Deactivate background image
            EndIf
            
            Select EventGadget()
                
              Case gadget_ID(#TextGadget_BF_3)
                If EventType()=#PB_EventType_MouseEnter
                  SetTextGadget_BF(gadget_ID(#TextGadget_BF_3), "", #Blue, #Red)
                EndIf
                If EventType()=#PB_EventType_MouseLeave
                  SetTextGadget_BF(gadget_ID(#TextGadget_BF_3), "", #Red, #Blue)
                EndIf
                
                If EventType()=#PB_EventType_LeftButtonDown ; Loader for GIF - Image - Photo - BF Sprite sheet
                  Protected path$=OpenFileRequester("Select a GIF / Image / Photo / BF Sheet / BF Sheet-Infofile", "", "", 0)
                  If path$<>""
                    
                    Macro free_used_resources_1
                      ; Free used textures
                      FreeImage_BF(loaded_image_ID)
                      FreeImage_BF(@image_frame_ID(#Temporary_Image_1))
                      
                      ; Init for a new GIF or image output
                      frame=0 : init=1 : get_gif_loop=1
                      While WindowEvent() : Wend
                    EndMacro
                    
                    If IsSheetInfoFile_BF(path$) 
                      ReadSheetInfoFile_BF(path$)
                      path$=RemoveString(GetPathPart(path$)+RemoveString(GetFilePart(path$), "_sheet_info_BF", #PB_String_NoCase), GetExtensionPart(path$), #PB_String_NoCase)
                      If FileSize(path$+"jpg")>0 : path$+"jpg"
                      ElseIf FileSize(path$+"JPG")>0 : path$+"JPG"
                      ElseIf FileSize(path$+"png")>0 : path$+"png"
                      ElseIf FileSize(path$+"PNG")>0 : path$+"PNG"
                      ElseIf FileSize(path$+"bmp")>0 : path$+"bmp"
                      ElseIf FileSize(path$+"JPG")>0 : path$+"JPG"
                      EndIf 
                      gif_ID=LoadImage(#PB_Any, path$)
                      If gif_ID
                        free_used_resources_1 ; Free firstly used resources and init for a new outout
                      EndIf
                      
                    Else ; Sheet
                      gif_ID=LoadPhoto_BF(path$) ; Can handle also rotated images with EXIF data
                      
                      If IsImage(gif_ID)
                        free_used_resources_1 ; Free firstly used resources and init for a new outout
                        If IsSheet_BF(path$)=1
                          GetFrameData_fromSheet_BF(path$) 
                        Else ; Image
                          If ImageFrameCount_BF(gif_ID)<2
                            If ImageWidth(gif_ID)>#PreShrink_large_images_x Or ImageHeight(gif_ID)>#PreShrink_large_images_y ; Pre shrink large images
                              GetFitSize_BF(ImageWidth(gif_ID), ImageHeight(gif_ID), #PreShrink_large_images_x, #PreShrink_large_images_y)
                              ResizeImage(gif_ID, GetFitSize_Width_BF(), GetFitSize_Height_BF())
                            EndIf
                            CreateCSSSheet_simple_BF(gif_ID, 1) ; Only init the CSS data sheet for a simple image output
                            
                          Else ; Multi frame image
                            ActivateAlphaChannel_BF(1) ; Create a sprite sheet from a GIF with invisible background - Deactivate AlphaChannel for using GIF without invisible color
                            gif_ID=CreateCSSSheet_simple_BF(gif_ID, 2) ; This BF method is the easiest way ever for using GIF
                            ActivateAlphaChannel_BF(0)
                          EndIf
                          
                        EndIf
                        
                      EndIf
                      
                    EndIf
                  EndIf 
                  loaded_image_ID=gif_ID
                EndIf
                
              Case gadget_ID(#ButtonImageGadget_BF_1)
                SetGadgetData(gadget_ID(#ButtonImageGadget_BF_1), 1-GetGadgetData(gadget_ID(#ButtonImageGadget_BF_1)))
                If GetGadgetData(gadget_ID(#ButtonImageGadget_BF_1))
                  background_color_gadget(#ButtonImageGadget_BF_1)=#Green
                Else
                  background_color_gadget(#ButtonImageGadget_BF_1)=$20A5DA
                EndIf
                
                get_gif_loop=1    
                
              Case gadget_ID(#ButtonImageGadget_BF_2)
                SetButtonImageGadget_BF_AutoFade_BF(gadget_ID(#ButtonImageGadget_BF_2),
                                                    image_ID_1_gadget(#ButtonImageGadget_BF_2), ; image_a_ID,
                                                    image_ID_2_gadget(#ButtonImageGadget_BF_2), ; image_b_ID,
                                                    $FFFF,                                      ; background_color,
                                                    $C0C0C0,                                    ; overlay_color,
                                                    5,                                          ; animation_delay,
                                                    5)                                          ; animation_alpha_step)
                
              Case gadget_ID(#ButtonGadget_3)
                HideWindow(window_ID, 1)
                ResizeWindow(window_ID, #PB_Ignore, #PB_Ignore, #Developing_Size_Width, #Developing_Size_Height)
                Delay(200)
                HideWindow(window_ID, 0)
                While WindowEvent() : Wend
                
              Case gadget_ID(#ColorButtonGadget_BF_1), gadget_ID(#ColorButtonGadget_BF_2)
                
                flip=~flip ; State - This change flip from 0 to -1 - Also you can use flip=1-flip, this change flip from 0 to 1
                
                If flip : background_color_gadget(#ImageGadget_BF_2)=-2: Else
                background_color_gadget(#ImageGadget_BF_2)=$808080 : EndIf
                ; ManualPadding_DrawTextCreateImage_X_BF(100) ; Additional text padding for DrawTextCreateImage_BF - Works with all DrawTextCreateImage_BF Functions
                
                ; Method 1
                ; SetColorButtonGadget_BF_AutoFade_BF(gadget_ID(#ColorButtonGadget_BF_1),
                ;                                     text_1_gadget$(#ColorButtonGadget_BF_1), ; Text a
                ;                                     "Simple a little more",                  ; Text b
                ;                                     5,                                       ; Animation delay
                ;                                     8)                                       ; Animation alpha step
                
                ; Method 2
                SetColorButtonGadget_BF_Fading_BF(gadget_ID(#ColorButtonGadget_BF_1),
                                                  text_1_gadget$(#ColorButtonGadget_BF_1), ; Text a
                                                  "Simple a little more",                  ; Text b
                                                  $FFFF,                                   ; Text color a,
                                                  $FF0000,                                 ; Text color b,
                                                  5,                                       ; Animation delay,
                                                  8)                                       ; Animation alpha step)
                
                ; ManualPadding_DrawTextCreateImage_X_BF(0)
                
                Mirror_and_Copy_BF(1, image_ID_1_gadget(#ImageGadget_BF_1)) ; Mirror image
                SetImageGadget_BF(gadget_ID(#ImageGadget_BF_1),
                                  image_ID_1_gadget(#ImageGadget_BF_1))
                
                SetImageGadget_BF(gadget_ID(#ImageGadget_BF_2),
                                  image_ID_1_gadget(#ImageGadget_BF_2),
                                  -1,
                                  -1,
                                  -1,
                                  -1,
                                  background_color_gadget(#ImageGadget_BF_2))
                
                While WindowEvent() : Wend
            EndSelect
          EndIf
          
        Until Not win_event ; ================
        
        ; ==== Remove or change this part not =====
        If init_tool
          init_tool=0
          CompilerIf #PB_Compiler_OS=#PB_OS_Windows ; Workaround PB562 Windows for using CanvasContainer and ColorButtonGadget_BF
            Protected old_window_x=WindowX(window_ID), old_window_y=WindowY(window_ID)
            ResizeWindow(window_ID, -#Max_GUI_Size_X, -#Max_GUI_Size_Y, #PB_Ignore, #PB_Ignore)
            HideWindow(window_ID, 0)
            WindowResizing_BindEvent_CreateGUI_1() ; Init
            If on_demand_resizing : BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1(), window_ID) : EndIf
            ResizeWindow(window_ID, old_window_x, old_window_y,  #PB_Ignore, #PB_Ignore)
          CompilerElse
            WindowResizing_BindEvent_CreateGUI_1() ; Init
            If on_demand_resizing : BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1(), window_ID) : EndIf
          CompilerEndIf
          HideWindow(window_ID, 0)
          While WindowEvent() : Wend
        EndIf
        ; === End Remove or change this part not ===
        
      ForEver
      
      ; === Finishing - last  steps ===
      
      ; Free the used Gadgets_BF
      ; Debug FreeAllGadgets_bf(1) ; Before releasing the gadgets_BF you can check how many gadgets_BF are requisitioned
      
      FreeGadget_BF(gadget_ID(#ColorButtonGadget_BF_1)) ; Don't forget one !
      FreeGadget_BF(gadget_ID(#ColorButtonGadget_BF_2))
      FreeGadget_BF(gadget_ID(#ButtonImageGadget_BF_1))
      FreeGadget_BF(gadget_ID(#ButtonImageGadget_BF_2))
      FreeGadget_BF(gadget_ID(#TextGadget_BF_1))
      FreeGadget_BF(gadget_ID(#TextGadget_BF_2))
      FreeGadget_BF(gadget_ID(#TextGadget_BF_3))
      FreeGadget_BF(gadget_ID(#ImageGadget_BF_1))
      FreeGadget_BF(gadget_ID(#ImageGadget_BF_2))
      FreeGadget_BF(gadget_ID(#GIF_1_BF)) ; Free the GIF's with all used resources - The GIF output is on a ImageGadget_BF
      FreeGadget_BF(gadget_ID(#GIF_2_BF))
      
      FreeImage_BF(temporary_image_ID_1_gadget(#Additional_Image_BF_Rose))
      FreeImage_BF(temporary_image_ID_1_gadget(#Additional_Image_BF_Foxy))
      FreeImage_BF(loaded_image_ID)
      FreeImage_BF(image_frame_ID(#Temporary_Image_1)) ; Free the temporary image for GIF frame creating - FreeImage_BF can not crash, so i use it
      
      If FreeAllGadgets_bf(1) ; After releasing you can check if all have been released
        MessageRequester("Warning", "You haven't released all the gadgets BF"+#LF$+#LF$+
                                    "Not released : "+Str(FreeAllGadgets_bf(1)))
      EndIf
      
      ; FreeAllGadgets_BF() ; You can alterable use, but take with care, this function delete the cache for Gadgets_BF complete all over
      ; End Free the used Gadgets_BF
      
      ; Remove or change this part not
      UnbindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1(), window_ID)
      GUI_x_pos=WindowX(window_ID)
      GUI_y_pos=WindowY(window_ID)
      GUI_width=WindowWidth(window_ID)
      GUI_height=WindowHeight(window_ID)
      frame=0 ; Init for a new GIF or image output
      CloseWindow(window_ID)
      ProcedureReturn 1
      ; Remove or change this part not
    EndProcedure
    
  EndModule
  
  ; ============= Call the created GUI ===============
  EnableExplicit
  
  Activate_DPI_aware_BF(1) ; For using Gadgets_BF - Use with the compiler option 
  
  ; For Developing you can call the function without parameters
  CreateGUI_1::CreateGUI_1("Developing")
  
  ; After developing you can preset the needed name, output size and position you want
  ; Close the GUI give back :
  ; Debug CreateGUI_1::GUI_x_pos
  ; Debug CreateGUI_1::GUI_y_pos
  ; Debug CreateGUI_1::GUI_width
  ; Debug CreateGUI_1::GUI_height
  
  ; After developing you can set as sample :
  Define x=-1       ; -1 = Centred x
  Define y=-1       ; -1 = Centred y
  Define width=800  ; Call the function with presetted width
  Define height=600 ; Call the function with presetted height
  
  ; You can activate the next line for starting a resized GUI
  ; CreateGUI_1::CreateGUI_1("Resized", -1, -1, width, height) ; Centered and resized output
  
  ; Hints
  ; With WinOS < Win10 you can not get flicker free on demand resizing, it's automatically deactivated here for WinOS < Win10, this is not a GFX_Wizzard_BF issue
  ; Animated 32Bit Image output, using ImageGadget, with invisible ImageGadget Background, can flicker on WinOS, this is not a GFX_Wizzard_BF issue
  ; Temporarily restarting a GUI module can trigger different resource conflicts for changed images and variables, take with care
  ; SetGadgets_BF functions works with #PB_Ignore, you must only set needed parameters
  ; ImageGadget_BF create and cache needed temporary images for WinOS outputs automatically
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 2 (Linux - x64)
; CursorPosition = 514
; FirstLine = 510
; Folding = ----
; EnableXP
; DPIAware
; Executable = ../__test.exe
; DisableDebugger