﻿
; ************** Dynamic Window / GUI creating module ***************

XIncludeFile("./GFX_Wizzard_BF.pbi")

DeclareModule CreateGUI_1
  EnableExplicit
  UseModule GFX_Wizzard_BF
  Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
EndDeclareModule

Module CreateGUI_1
  
  Global window_width_developing=920 ; Developing size
  Global window_height_developing=400
  
  Global window_min_width=240 ; Minimum window size
  Global window_min_height=180
  
  Global window_x, window_y, window_width_output, window_height_output
  Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
  Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                              "Dynamic Window and GUI creating", Window_flags)
  WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
  Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
  
  ; Create needed Fonts =====================================================
  ; Create a font array
  ; Mostly 30pt > 40pt is enough - smaller is faster
  Global max_needed_font_size=72
  Global needed_font_size
  Global Dim Font_Georgia(max_needed_font_size)
  For needed_font_size=1 To max_needed_font_size ; Get the fonts
    Font_Georgia(needed_font_size)=LoadFont(#PB_Any, "Georgia", needed_font_size, #PB_Font_Bold)
  Next needed_font_size
  
  ; Create a font array
  ; Mostly 30pt > 40pt is enough - smaller is faster
  Global max_needed_font_size=72
  Global needed_font_size
  Global Dim Font_Arial(max_needed_font_size) ; For using in a callback procedure define as global 
  For needed_font_size=1 To max_needed_font_size ; Get the fonts
    Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
  Next needed_font_size
  
  FitImageActivateUpscaling_BF(1) ; Add to the FitImage functions a automatically upscaling for little images
                                  ; With this function too small fonts and images are automatically enlarged for the Gadgets_BF
                                  ; The use of very large maximum font sizes slows down the calculation of the gadgets
                                  ; So it can make sense to use smaller pictures and fonts to enlarge them a little if necessary
  
  ; ====================== Add here all Gadgets ==============================
  ; Create ColorButtonGadget_BF for using ====================================
  Global ColorButtonGadget_1_x=290
  Global ColorButtonGadget_1_y=20
  Global ColorButtonGadget_1_width=320
  Global ColorButtonGadget_1_height=90
  Global ColorButtonGadget_1_text$="Resizable Window Demo"+#LF$+
                                   "This is a ColorButtonGadget_BF"+#LF$+
                                   "Gadgets_BF resize fonts stepless"+#LF$+
                                   " - Resize the Window -"
  Global ColorButtonGadget_1_ID=ColorButtonGadget_BF(ColorButtonGadget_1_text$,
                                                     0,
                                                     0,
                                                     -1, ; You must not set here, look, you have define above
                                                     -1,
                                                     $FFFF,
                                                     $FF0000,
                                                     Font_Arial(40)) ; Max font size 40 is enough here
                                                                     ;  Use not larger as needed, too large make the output slow
                                                                     ;  Larger as max_needed_font_size crash the Array
  
  ; This is a mighty function, many more parameters are available
  ; For explanations on ColorButtonGadget_BF see the other demo codes or GFX_Wizzard_BF module
  
  ; Create ButtonGadget 1 for using ==========================================
  Global ButtonGadget_1_x=20
  Global ButtonGadget_1_y=135
  Global ButtonGadget_1_width=450
  Global ButtonGadget_1_height=240
  Global ButtonGadget_1_text$="Create Gadgets with automatically fitted Text"+#LF$+#LF$+
                              "For simple solving many Gadget Problems"+#LF$+#LF$+
                              "Try any Text"+#LF$+
                              "Fontsizes up to 72pt are supported here"+#LF$+#LF$+
                              "Works with any Rectangles"+#LF$+
                              "and Gadgets with Font changing Feature"
  
  Global ButtonGadget_1_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, "", #PB_Button_MultiLine)
  
  ; Create CanvasGadget 1 for using ================================================
  Global CanvasGadget_1_x=500
  Global CanvasGadget_1_y=135
  Global CanvasGadget_1_width=400
  Global CanvasGadget_1_height=240
  Global text_color=#Blue
  Global background_color=#Yellow
  Global headletter_mode_text_stretching_x=0
  Global headletter_mode_text_stretching_y=0
  Global flag=1 ; Text center=1 - Text right=2 - Text vertical=3
  Global mode=0 ; Revers text mode=1 - RTL text mode=2
  
  Global CanvasGadget_1_text$=" The colored Gadget is a CanvasGadget"+#LF$+#LF$+
                              "Try any text"+#LF$+
                              "Without Subsystem Problems"+#LF$+#LF$+
                              "All OS"+#LF$+
                              " - Click me -"+#LF$+#LF$+
                              "Supports"+#LF$+
                              "Headline, Multiline"+#LF$+
                              "Vertical, Center, Right, Left, RTL"
  
  Global CanvasGadget_ID=CanvasGadget(#PB_Any, 0, 0, 0, 0, #PB_Canvas_Border)
  
  ; Create HyperlinkGadget 1 for using =======================================
  Global HyperlinkGadget_1_x=30
  Global HyperlinkGadget_1_y=90
  Global HyperlinkGadget_1_width=260
  Global HyperlinkGadget_1_height=25
  Global HyperlinkGadget_1_text$="This is a HyperlinkGadget"
  
  Global HyperlinkGadget_1_ID=HyperLinkGadget(#PB_Any, 0, 0, 0, 0, "", $FF0000, #PB_HyperLink_Underline)
  
  ; Create StringGadget 1 for using ==========================================
  Global StringGadget_1_x=30
  Global StringGadget_1_y=20
  Global StringGadget_1_width=225
  Global StringGadget_1_height=25
  Global StringGadget_1_Text$="This is a StringGadget"
  Global StringGadget_2_Text$="With enhanced text fitting"
  
  Global StringGadget_1_ID=StringGadget(#PB_Any, 0, 0, 0, 0, StringGadget_1_Text$)
  
  ; Create ImageGadget_BF 1 ==================================================
  Global ImageGadget_BF_1_Image_ID=LoadImage(#PB_Any, "./Image_Set/Penguin.png")
  Global ImageGadget_BF_1_x=700
  Global ImageGadget_BF_1_y=20
  Global ImageGadget_BF_1_width=120
  Global ImageGadget_BF_1_height=95
  
  Global ImageGadget_BF_1_ID=ImageGadget_BF(ImageGadget_BF_1_Image_ID,
                                            0, ; Mostly data you must not set, they are already preset to default
                                            0,
                                            0,
                                            0,
                                            -2) ; Background color - For a invisible background set background_color=-2
  
  ; This is a mighty function, many more parameters are available
  ; For explanations on ImageGadget_BF see the other demo codes or GFX_Wizzard_BF module
  
  ; ==========================================================================
  
  ; ############# Add here the resizing calls for all Gadgets ################
  ; #################### Resize procedure for callback #######################
  Procedure WindowResizing_BindEvent_CreateGUI_1()
    
    ; ============= Init the scaling variables ==============
    Protected set_x.f=100/window_width_developing*WindowWidth(window_ID)/100
    Protected set_y.f=100/window_height_developing*WindowHeight(window_ID)/100
    
    ; Resize ColorButtonGadget_BF 1 ==========================================
    ; This function is GradientColor_BF sensitive
    GradientColor_Array_BF(1, 1, 0.15, $FFFF)
    GradientColor_Array_BF(1, 2, 0.4, $FFFF00)
    GradientColor_Array_BF(1, 3, 0.8, $FF00)
    ; BF create internal text outputs for TextGadget_BF and ColorButtonGadget_BF with automatic downsizing / upsizing and interpolation
    ; So you set for manipulating the text output the for this gadget presetted fontsize  
    Protected text_width=GetTextWidth_BF(ColorButtonGadget_1_text$,
                                         Font_Arial(40),   ; The presetted max font size for this gadget
                                         0,                ; vertical
                                         0,                ; stretch_x=0,
                                         0)                ; padding_x=0
    Protected text_height=GetTextHeight_BF(ColorButtonGadget_1_text$,
                                           Font_Arial(40), ; The presetted max font size for this gadget
                                           0,              ; vertical
                                           0,              ; stretch_x=0,
                                           0)              ; padding_x=0               
    LinearGradient_BF(1, -300*DPI_ResizeFactor_BF(), 0, text_width, text_height*2)
    
    SetColorButtonGadget_DualPadding_BF(ColorButtonGadget_1_ID,
                                        "",
                                        -1,
                                        -1,
                                        30, ; Padding x
                                        10, ; Padding y
                                        ColorButtonGadget_1_x*set_x,
                                        ColorButtonGadget_1_y*set_y,
                                        ColorButtonGadget_1_width*set_x,
                                        ColorButtonGadget_1_height*set_y)
    
    LinearGradient_BF(0) ; Deactivate LinearGradient_BF
    
    ; This is a mighty function, many more parameters are available
    ; For explanations on SetColorButtonGadget_BF see the other demo codes or GFX_Wizzard_BF module
    
    ; Resize ButtonGadget 1 ==================================================
    SetGadgetText_BF(ButtonGadget_1_ID,
                     Font_Arial(),
                     ButtonGadget_1_x*set_x,
                     ButtonGadget_1_y*set_y,
                     ButtonGadget_1_width*set_x,
                     ButtonGadget_1_height*set_y,
                     ButtonGadget_1_text$,
                     30, ; Padding x
                     30, ; Padding y
                     1)  ; resize_factor.f
    
    ; Resize CanvasGadget 1 ==================================================
    
    ; This function is GradientColor_BF sensitive
    GradientColor_Array_BF(1, 1, 0.0, $FF)
    GradientColor_Array_BF(1, 2, 0.6, $FF00FF)
    GradientColor_Array_BF(1, 3, 1.0, $FF00)
    LinearGradient_BF(1, 0, 0, CanvasGadget_1_width*set_x*DPI_ResizeFactor_BF(), CanvasGadget_1_height*set_y*DPI_ResizeFactor_BF())
    
    SetCanvasCustomText_BF(CanvasGadget_ID,
                           Font_Georgia(),
                           CanvasGadget_1_x*set_x,
                           CanvasGadget_1_y*set_y,
                           CanvasGadget_1_width*set_x,
                           CanvasGadget_1_height*set_y,
                           CanvasGadget_1_text$,
                           text_color,
                           background_color,
                           flag,
                           mode,
                           30, ; Padding x
                           30, ; Padding y
                           0,  ; Headletter mode - text stretching x
                           0,  ; Headletter_mode - text stretching y
                           1)  ; resize_factor.f
    
    LinearGradient_BF(0) ; Deactivate LinearGradient_BF
    
    ; Resize HyperlinkGadget 1 ===============================================
    SetGadgetText_BF(HyperlinkGadget_1_ID,
                     Font_Arial(),
                     HyperlinkGadget_1_x*set_x,
                     HyperlinkGadget_1_y*set_y,
                     HyperlinkGadget_1_width*set_x,
                     HyperlinkGadget_1_height*set_y,
                     HyperlinkGadget_1_text$,
                     0,   ; Padding x
                     5,   ; Padding y
                     1.2) ; resize_factor.f
    
    ; Resize StringGadget 1 ==================================================
    SetGadgetText_BF(StringGadget_1_ID,
                     Font_Arial(),
                     StringGadget_1_x*set_x,
                     StringGadget_1_y*set_y,
                     StringGadget_1_width*set_x,
                     StringGadget_1_height*set_y,
                     StringGadget_1_Text$,
                     5,   ; Padding x
                     5,   ; Padding y
                     1.2) ; resize_factor.f
    
    ; Resize ImageGadget_BF 1 ================================================
    SetImageGadget_BF(ImageGadget_BF_1_ID,
                      ImageGadget_BF_1_Image_ID,
                      ImageGadget_BF_1_x*set_x,
                      ImageGadget_BF_1_y*set_y,
                      ImageGadget_BF_1_width*set_x,
                      ImageGadget_BF_1_height*set_y)
    
    ; This is a mighty function, many more parameters are available
    ; For explanations on SetImageGadget_BF see the other demo codes or GFX_Wizzard_BF module
    
    ; ========================================================================
    
    ; The Set...BF functions returns the determined font size so that it can easily be inherit on to other gadgets
    ; This is also possible on gadgets of other sizes - Sample : alterable_size=calculated_font_size/my_resize_factor
    
    ; As you can see above, the Set...BF functions can not only set the text, but also reposition and resize the gadgets
    
    ; You can also check the actual padding on demand - Call this functions after a monitored Set...BF function  
    ; Debug "canvas Custom Gadget - Padding X : "+Str(Get_Fitted_Font_Padding_X_BF())
    ; Debug "canvas Custom Gadget - Padding Y: "+Str(Get_Fitted_Font_Padding_Y_BF())
    
  EndProcedure
  
  ; ==========================================================================
  
  Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
    
    ; =============== Calculate the output position and size =================
    Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
    window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
    If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
      Else : window_x*DPI_ResizeFactor_BF() : EndIf
    If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
      Else : window_y*DPI_ResizeFactor_BF() : EndIf
    ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
    
    ; ================= Init the resize procedure callback ===================
    BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
    
    ; ==== Init all gadgets - Call simple the resize callback procedure =====
    Macro Refresh_all_Gadgets ; Refresh the gadgets
      get_all_window_events=1 : WindowResizing_BindEvent_CreateGUI_1() : get_all_window_events=0
      ; No WindowEvent may be called during a callback
      ; However, if the callback procedure is only called to refresh or the first initializing the gadgets,
      ; is a WindowEvent after updating each gadget recommended as flicker protection
      ; and must be triggered manually with get_all_window_events=1
    EndMacro
    
    ; ============================= Show the result =============================
    Deactivate_DPI_ResizeFactor_BF(0)
    Activate_DPI_aware_BF(1) ; For using Gadgets_BF - Use with the compiler option 
    
    Refresh_all_Gadgets
    
    HideWindow(window_ID, 0)
    
    Repeat
      Define win_event=WaitWindowEvent()
      
      Select EventGadget()
          
        Case ColorButtonGadget_1_ID, ButtonGadget_1_ID, HyperlinkGadget_1_ID ; Gadget events
          If Not EventType()
            Swap text_color, background_color
            Define temp_text$=CanvasGadget_1_text$ : CanvasGadget_1_text$=ButtonGadget_1_Text$ : ButtonGadget_1_text$=temp_text$ 
            Define temp_text$=StringGadget_1_text$ : StringGadget_1_text$=StringGadget_2_Text$ : StringGadget_2_text$=temp_text$
            Refresh_all_Gadgets ; Refresh all gadgets
          EndIf
        Case CanvasGadget_ID ; CanvasGadget 1 event
          If EventType()=#PB_EventType_LeftButtonDown
            Swap text_color, background_color
            Refresh_all_Gadgets ; Refresh all gadgets
          EndIf
      EndSelect
      
    Until win_event=#PB_Event_CloseWindow
    
    ; =============================== Bye ====================================
    FreeGadget_BF(ImageGadget_BF_1_ID)    ; This function free a Gadget_BF with all resources
    FreeGadget_BF(ColorButtonGadget_1_ID) ; You can free Gadgets_B, but you must not
    If FreeAllGadgets_bf(1)               ; After releasing you can check if all have been released
      MessageRequester("Warning", "You haven't released all the gadgets BF"+#LF$+#LF$+
                                  "Not released : "+Str(FreeAllGadgets_bf(1)))
    EndIf
    
  EndProcedure
  
EndModule
UseModule CreateGUI_1
UseModule GFX_Wizzard_BF

; ========================== Run the module ===================================
; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
CreateGUI_1(-1, -1, DesktopWidth_UserScaled_BF()*0.70, DesktopHeight_UserScaled_BF()*0.70) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 174
; FirstLine = 150
; Folding = -
; EnableXP
; DPIAware