﻿
; ************** Dynamic Window / GUI creating module ***************

  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  DeclareModule CreateGUI_1
    EnableExplicit
    UseModule GFX_Wizzard_BF
    Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
  EndDeclareModule
  
  Module CreateGUI_1
    
    Global window_width_developing=920 ; Developing size
    Global window_height_developing=400
    
    Global window_min_width=450 ; Minimum window size
    Global window_min_height=200
    
    Global window_x, window_y, window_width_output, window_height_output
    Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
    Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                                "Dynamic Window and GUI creating", Window_flags)
    WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
    Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
    
    ; Create a font array
    ; Mostly 30pt > 40pt is enough - smaller is faster
    Global max_needed_font_size=40
    Global needed_font_size
    Global Dim Font_Georgia(max_needed_font_size)
    For needed_font_size=1 To max_needed_font_size ; Get the fonts
      Font_Georgia(needed_font_size)=LoadFont(#PB_Any, "Georgia", needed_font_size, #PB_Font_Bold)
    Next needed_font_size
    
    ; Create a font array
    ; Mostly 30pt > 40pt is enough - smaller is faster
    Global max_needed_font_size=40
    Global needed_font_size
    Global Dim Font_Arial(max_needed_font_size) ; For using in a callback procedure define as global 
    For needed_font_size=1 To max_needed_font_size ; Get the fonts
      Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
    Next needed_font_size
    
    ; Create ButtonGadget 1 for using ==========================================
    Global ButtonGadget_1_x=310
    Global ButtonGadget_1_y=20
    Global ButtonGadget_1_width=300
    Global ButtonGadget_1_height=90
    Global ButtonGadget_1_text$="Resizable Window Demo"+#LF$+"This is a ButtonGadget"+#LF$+" - Resize the Window -"
    Global ButtonGadget_1_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, ButtonGadget_1_text$, #PB_Button_MultiLine)
    
    ; Create ButtonGadget 2 for using ==========================================
    Global ButtonGadget_2_x=20
    Global ButtonGadget_2_y=135
    Global ButtonGadget_2_width=450
    Global ButtonGadget_2_height=240
    Global ButtonGadget_2_text$="Create Gadgets with automatically fitted Text"+#LF$+#LF$+
                                "GFX_Wizzard_BF enhanced"+#LF$+#LF$+
                                "For simple solving many Gadget Problems"+#LF$+#LF$+
                                "Try any Text"+#LF$+
                                "Fontsizes up to 40pt are supported here"+#LF$+#LF$+
                                "Works with any Rectangles"+#LF$+
                                "and Gadgets with Font changing Feature"
    
    Global ButtonGadget_2_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, "", #PB_Button_MultiLine)
    
    ; Create CanvasGadget 1 for using ==========================================
    Global CanvasGadget_1_x=500
    Global CanvasGadget_1_y=135
    Global CanvasGadget_1_width=400
    Global CanvasGadget_1_height=240
    Global text_color=#Blue
    Global background_color=#Yellow
    Global headletter_mode_text_stretching_x=0
    Global headletter_mode_text_stretching_y=0
    Global flag=1 ; Text center=1 - Text right=2 - Text vertical=3
    Global mode=0 ; Revers text mode=1 - RTL text mode=2
    
    Global DPI_Resizefactor.d=DPI_Resizefactor_BF()
    
    Global CanvasGadget_0_text$="FittedText_BF"
    
    Global CanvasGadget_1_text$=#LF$+#LF$+
                                "Advanced rectangle fitted text output"+#LF$+
                                "Directly on canvas"+#LF$+
                                "A mighty universal text output function"+#LF$+#LF$+
                                "Try any text"+#LF$+
                                "Without Subsystem Problems"+#LF$+#LF$+
                                "All OS"+#LF$+
                                "Available for canvas, images, sprites, window, screen"+#LF$+#LF$+
                                "Supports"+#LF$+
                                "Headline, Multiline"+#LF$+
                                "Vertical, Center, Right, Left, RTL"
    
    Global CanvasGadget_ID=CanvasGadget(#PB_Any, CanvasGadget_1_x, CanvasGadget_1_y, CanvasGadget_1_width, CanvasGadget_1_height, #PB_Canvas_Border)
    
    ; Create HyperlinkGadget 1 for using =======================================
    Global HyperlinkGadget_1_x=30
    Global HyperlinkGadget_1_y=90
    Global HyperlinkGadget_1_width=260
    Global HyperlinkGadget_1_height=25
    Global HyperlinkGadget_1_text$="This is a HyperlinkGadget"
    
    Global HyperlinkGadget_1_ID=HyperLinkGadget(#PB_Any, 0, 0, 0, 0, "", $FF0000, #PB_HyperLink_Underline)
    
    ; Create TextGadget 1 for using ============================================
    Global TextGadget_1_x=650
    Global TextGadget_1_y=95
    Global TextGadget_1_width=225
    Global TextGadget_1_height=30
    Global TextGadget_1_text$="This is a TextGadget"
    
    Global TextGadget_1_ID=TextGadget(#PB_Any, 0, 0, 0, 0, "")
    
    ; Create SpinGadget 1 for using ============================================
    Global SpinGadget_1_x=650
    Global SpinGadget_1_y=20
    Global SpinGadget_1_width=225
    Global SpinGadget_1_height=25
    Global SpinGadget_1_Text$="This is a SpinGadget"
    
    Global SpinGadget_1_ID=SpinGadget(#PB_Any, 0, 0, 0, 0, 0, 100)
    
    ; Create StringGadget 1 for using ==========================================
    Global StringGadget_1_x=30
    Global StringGadget_1_y=20
    Global StringGadget_1_width=225
    Global StringGadget_1_height=25
    Global StringGadget_1_Text$="This is a StringGadget"
    Global StringGadget_2_Text$="With enhanced text fitting"
    
    Global StringGadget_1_ID=StringGadget(#PB_Any, 0, 0, 0, 0, StringGadget_1_Text$)
    
    ; ==========================================================================
    
    ; ############## Resize procedure for callback ##############################
    Procedure WindowResizing_BindEvent_CreateGUI_1()
      
      ; ============= Init the scaling variables ==============
      Protected set_x.f=100/window_width_developing*WindowWidth(window_ID)/100
      Protected set_y.f=100/window_height_developing*WindowHeight(window_ID)/100
      
      ; Resize ButtonGadget 1 ===================================================
      FitGadgetText_BF(ButtonGadget_1_ID,
                       Font_Arial(),
                       ButtonGadget_1_x*set_x,
                       ButtonGadget_1_y*set_y,
                       ButtonGadget_1_width*set_x,
                       ButtonGadget_1_height*set_y,
                       30, ; Padding x
                       10, ; Padding y
                       1)  ; resize_factor.f
      
      ; Resize ButtonGadget 2 ===================================================
      SetGadgetText_BF(ButtonGadget_2_ID,
                       Font_Arial(),
                       ButtonGadget_2_x*set_x,
                       ButtonGadget_2_y*set_y,
                       ButtonGadget_2_width*set_x,
                       ButtonGadget_2_height*set_y,
                       ButtonGadget_2_text$,
                       30, ; Padding x
                       30, ; Padding y
                       1)  ; resize_factor.f
      
      ; Resize CanvasGadget 1 and output fitted text  =========================== 
      ResizeGadget(CanvasGadget_ID,
                   CanvasGadget_1_x*set_x,
                   CanvasGadget_1_y*set_y,
                   CanvasGadget_1_width*set_x,
                   CanvasGadget_1_height*set_y)
      
      If StartDrawing(CanvasOutput(CanvasGadget_ID))
        Box(0, 0, CanvasGadget_1_width*set_x*DPI_Resizefactor, CanvasGadget_1_height*set_y*DPI_Resizefactor, #Blue)
        StopDrawing()
      EndIf   
      
      FittedText_BF(CanvasGadget_ID,
                    Font_Arial(),
                    25*set_x,
                    20*set_y,
                    350*set_x,
                    200*set_y,
                    CanvasGadget_1_text$,
                    #Blue,   ; Text color
                    #Yellow, ; Background color - Without text background = -1
                    3,       ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                    #Red,    ; Frame Color
                    flag,    ; Text center=1 - Text right=2 - Text vertical=3
                    mode,    ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4  
                    15,      ; Padding x, 
                    15,      ; Padding y,
                    0,       ; Headletter mode - text stretching x
                    0,       ; Headletter_mode - text stretching y
                    1)       ; resize_factor.f
      
      FittedText_BF(CanvasGadget_ID,
                    Font_Georgia(),
                    25*set_x,
                    27*set_y,
                    350*set_x,
                    23*set_y,
                    CanvasGadget_0_text$,
                    #Red, ; Text color
                    -1,   ; Background color - Without text background = -1
                    0,    ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                    $FF,  ; Frame Color
                    flag, ; Text center=1 - Text right=2 - Text vertical=3
                    mode, ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                    20,   ; Padding x, 
                    0,    ; Padding y,
                    0,    ; Headletter mode - text stretching x
                    0,    ; Headletter_mode - text stretching y
                    1)    ; resize_factor.f
      
      ; Resize HyperlinkGadget 1 ================================================
      SetGadgetText_BF(HyperlinkGadget_1_ID,
                       Font_Arial(),
                       HyperlinkGadget_1_x*set_x,
                       HyperlinkGadget_1_y*set_y,
                       HyperlinkGadget_1_width*set_x,
                       HyperlinkGadget_1_height*set_y,
                       HyperlinkGadget_1_text$,
                       0,   ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize TextGadget 1 =====================================================
      SetGadgetText_BF(TextGadget_1_ID,
                       Font_Arial(),
                       TextGadget_1_x*set_x,
                       TextGadget_1_y*set_y,
                       TextGadget_1_width*set_x,
                       TextGadget_1_height*set_y,
                       TextGadget_1_text$,
                       0,   ; Padding x
                       10,  ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize SpinGadget 1 =====================================================
      SetGadgetText_BF(SpinGadget_1_ID,
                       Font_Arial(),
                       SpinGadget_1_x*set_x,
                       SpinGadget_1_y*set_y,
                       SpinGadget_1_width*set_x,
                       SpinGadget_1_height*set_y,
                       SpinGadget_1_Text$,
                       20,  ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize StringGadget 1 ===================================================
      SetGadgetText_BF(StringGadget_1_ID,
                       Font_Arial(),
                       StringGadget_1_x*set_x,
                       StringGadget_1_y*set_y,
                       StringGadget_1_width*set_x,
                       StringGadget_1_height*set_y,
                       StringGadget_1_Text$,
                       5,   ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; =========================================================================
      
      ; The Set...BF functions returns the determined font size so that it can easily be inherit on to other gadgets
      ; This is also possible on gadgets of other sizes - Sample : alterable_size=calculated_font_size/my_resize_factor
      
      ; As you can see above, the Set...BF functions can not only set the text, but also reposition and resize the gadgets
      
      ; You can also check the actual padding on demand - Call this functions after a monitored Set...BF function  
      ; Debug "canvas Custom Gadget - Padding X : "+Str(Get_Fitted_Font_Padding_X_BF())
      ; Debug "canvas Custom Gadget - Padding Y: "+Str(Get_Fitted_Font_Padding_Y_BF())
      
    EndProcedure
    
    ; ===========================================================================
    
    Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
      
      ; =============== Calculate the output position and size =================
      Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
      window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
      If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
        Else : window_x*DPI_ResizeFactor_BF() : EndIf
      If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
        Else : window_y*DPI_ResizeFactor_BF() : EndIf
      ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
      
      ; ================= Init the resize procedure callback ======================
      BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
      
      ; ====== Init all gadgets - Call simple the resize callback procedure =======
      Macro Refresh_all_Gadgets ; Refresh the gadgets
        Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                    ; For using inside a callback procedure deactivate 
        WindowResizing_BindEvent_CreateGUI_1()
        Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                    ; For using inside a callback procedure deactivate 
      EndMacro
      
      ; ============================= Show the result =============================
      Deactivate_DPI_ResizeFactor_BF(0)
      Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
      
      Refresh_all_Gadgets
      
      HideWindow(window_ID, 0)
      
      Repeat
        Define win_event=WaitWindowEvent()
      Until win_event=#PB_Event_CloseWindow
      
    EndProcedure
    
  EndModule
  UseModule CreateGUI_1

CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 900, 500) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 23
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger