﻿
; ************** Dynamic Window / GUI creating module ***************

  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  DeclareModule CreateGUI_1
    EnableExplicit
    UseModule GFX_Wizzard_BF
    Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
  EndDeclareModule 
  
  Module CreateGUI_1
    
    Global window_width_developing=920 ; Developing size
    Global window_height_developing=400
    
    Global window_min_width=450 ; Minimum window size
    Global window_min_height=200
    
    Global window_x, window_y, window_width_output, window_height_output
    Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
    Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                                "Dynamic Window and GUI creating", Window_flags)
    WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
    Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
    
    ; Create a font array
    ; Mostly 30pt > 40pt is enough - smaller is faster
    Global max_needed_font_size=72
    Global needed_font_size
    Global Dim Font_Georgia(max_needed_font_size)
    For needed_font_size=1 To max_needed_font_size ; Get the fonts
      Font_Georgia(needed_font_size)=LoadFont(#PB_Any, "Georgia", needed_font_size, #PB_Font_Bold)
    Next needed_font_size
    
    ; Create a font array
    ; Mostly 30pt > 40pt is enough - smaller is faster
    Global max_needed_font_size=60
    Global needed_font_size
    Global Dim Font_Arial(max_needed_font_size) ; For using in a callback procedure define as global 
    For needed_font_size=1 To max_needed_font_size ; Get the fonts
      Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
    Next needed_font_size
    
    ; Create ButtonGadget 1 for using ==========================================
    Global ButtonGadget_1_x=310
    Global ButtonGadget_1_y=20
    Global ButtonGadget_1_width=300
    Global ButtonGadget_1_height=90
    Global ButtonGadget_1_text$="Resizable Window Demo"+#LF$+"This is a ButtonGadget"+#LF$+" - Resize the Window -"
    Global ButtonGadget_1_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, ButtonGadget_1_text$, #PB_Button_MultiLine)
    
    ; Create ImageGadget 1 and content for using ===============================
    Global ImageGadget_1_x=20
    Global ImageGadget_1_y=130
    Global ImageGadget_1_width=880
    Global ImageGadget_1_height=250
    
    Global Image_1_ID=LoadImage(#PB_Any, "./Image_Set/Sunrise_1.jpg")
    
    Define text_1$="It's cool man"+#LF$+
                   "Create your own"+#LF$+
                   "Buttons and Text Boxes"
    
    Define text_2$="FittedText_RoundBox_Vector_BF"
    
    Define text_3$=#LF$+#LF$+#LF$+
                   "Advanced rectangle fitted text output"+#LF$+
                   "A mighty universal text output function"+#LF$+
                   "Try any text"+#LF$+
                   "Without Subsystem Problems"+#LF$+
                   "Supports"+#LF$+
                   "Headline, Multiline"+#LF$+
                   "Vertical, Center, Right, Left, RTL"+#LF$+
                   "Text alpha blending available"+#LF$+
                   "With and without background colors"+#LF$+
                   "With and without a frame"+#LF$+
                   "Background and frame alpha blending"+#LF$+
                   "With or without edge rounding"+#LF$+
                   "Available for canvas, images, window"
    
    Define text_4$="The simplest solution ever"+#LF$+
                   "for automatically creating fitted text"
    
    ; This function give back a fitted image
    Define image_temp_1_ID=FitImage_BF(1,       ; Mode
                                       image_1_ID,
                                       500,     ; Fit image to this width
                                       250,     ; Fit image to this height
                                       $DCDCDC, ; Background color
                                       0,       ; Padding
                                       $FFFFFF, ; Grid color
                                       5,       ; Grid size
                                       10,      ; Grid tiling
                                       $FFFFFF, ; Frame color
                                       3,       ; frame_size
                                       0)       ; Sprite mode for PB sprite output
                                                ; mode 0 = image output
                                                ; mode 1 = Without background
                                                ; mode 2 = PB sprite output
                                                ; mode 3 = Without output - You can use GetFitSize_Width_BF and GetFitSize_Height_BF for get the calculated width and height
                                                ; This function can output images and PB sprites
                                                ; Look the FitImage demo code
                                                ; You can set ActivateAlphaChannel_BF(1) before you call this function
    
    FittedText_RoundBox_Vector_BF(image_temp_1_ID,
                                  Font_Georgia(),
                                  260,     ; x
                                  0,       ; y
                                  230,     ; Width
                                  40,      ; Height
                                  0,       ; Edge rounding
                                  "Incredible abilities",
                                  $FFFFFF, ; Text color without alpha blending
                                  -1,      ; Background color - Without text background = -1
                                  0,       ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF,     ; Frame Color
                                  1,       ; Text center=1 - Text right=2 - Text vertical=3
                                  0,       ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  0,       ; Padding x, 
                                  0,       ; Padding y,
                                  0,       ; Headletter mode - text stretching x
                                  0,       ; Headletter_mode - text stretching y
                                  1)       ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  35,      ; x
                                  35,      ; y
                                  350,     ; Width
                                  200,     ; Height
                                  20,      ; Edge rounding
                                  "BF"+#LF$+"Text Wizards"+#LF$+"DPI aware",
                                  0,       ; Text color without alpha blending
                                  $FFFE,   ; Background color - Without text background = -1
                                  12,      ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF,     ; Frame Color
                                  1,       ; Text center=1 - Text right=2 - Text vertical=3
                                  0,       ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,      ; Padding x, 
                                  20,      ; Padding y,
                                  0,       ; Headletter mode - text stretching x
                                  0,       ; Headletter_mode - text stretching y
                                  1)       ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  410,                    ; x   
                                  35,                     ; y
                                  350,                    ; Width
                                  200,                    ; Height
                                  40,                     ; Edge rounding
                                  text_1$,
                                  $FFFFFF,                ; Text color without alpha blending
                                  RGBA($FF, $FF, 0, 100), ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  12,                     ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FFFE,                  ; Frame Color
                                  1,                      ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,                     ; Padding x, 
                                  5,                      ; Padding y,
                                  0,                      ; Headletter mode - text stretching x
                                  0,                      ; Headletter_mode - text stretching y
                                  1)                      ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  785,                  ; x
                                  35,                   ; y
                                  350,                  ; Width
                                  200,                  ; Height
                                  0,                    ; Edge rounding
                                  #LF$+#LF$+"Many Functions for"+#LF$+"enhanced text outputs",
                                  $FFFFFF,              ; Text color without alpha blending
                                  RGBA(0, $FF, 0, 100), ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  5,                    ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,                ; Frame Color
                                  1,                    ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                    ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,                   ; Padding x, 
                                  5,                    ; Padding y,
                                  0,                    ; Headletter mode - text stretching x
                                  0,                    ; Headletter_mode - text stretching y
                                  1)                    ; resize_factor.f 
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  785,              ; x
                                  -20,              ; y
                                  350,              ; Width
                                  200,              ; Height
                                  8,                ; Edge rounding
                                  "GFX_Wizzard_BF",
                                  $FFFF00,          ; Text color without alpha blending
                                  -1,               ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  0,                ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,            ; Frame Color
                                  1,                ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  40,               ; Padding x, 
                                  5,                ; Padding y,
                                  0,                ; Headletter mode - text stretching x
                                  0,                ; Headletter_mode - text stretching y
                                  1)                ; resize_factor.f 
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  1160,                  ; x
                                  35,                    ; y
                                  350,                   ; Width
                                  200,                   ; Height
                                  8,                     ; Edge rounding
                                  "Also for Gadgets PB"+#LF$+"and Gadgets BF"+#LF$+#LF$,
                                  $FFFFFF,               ; Text color without alpha blending
                                  RGBA($FF, $FF, 0, 50), ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  10,                    ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,                 ; Frame Color
                                  1,                     ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                     ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,                    ; Padding x, 
                                  5,                     ; Padding y,
                                  0,                     ; Headletter mode - text stretching x
                                  0,                     ; Headletter_mode - text stretching y
                                  1)                     ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  1160,             ; x
                                  80,               ; y
                                  350,              ; Width
                                  200,              ; Height
                                  8,                ; Edge rounding
                                  "GFX_Wizzard_BF",
                                  $FFFF,            ; Text color without alpha blending
                                  -1,               ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  0,                ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,            ; Frame Color
                                  1,                ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  40,               ; Padding x, 
                                  5,                ; Padding y,
                                  0,                ; Headletter mode - text stretching x
                                  0,                ; Headletter_mode - text stretching y
                                  1)                ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  1535,                 ; x
                                  35,                   ; y
                                  350,                  ; Width
                                  200,                  ; Height
                                  30,                   ; Edge rounding
                                  "No more"+#LF$+"DPI problems",
                                  $FFFF,                ; Text color without alpha blending
                                  RGBA($FF, 0, 0, 100), ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  0,                    ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,                ; Frame Color
                                  1,                    ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                    ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,                   ; Padding x, 
                                  5,                    ; Padding y,
                                  0,                    ; Headletter mode - text stretching x
                                  0,                    ; Headletter_mode - text stretching y
                                  1)                    ; resize_factor.f 
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  1535,    ; x
                                  270,     ; y
                                  350,     ; Width
                                  200,     ; Height
                                  30,      ; Edge rounding
                                  text_1$,
                                  $FFFF,   ; Text color without alpha blending
                                  -1,      ; Background color - Without text background = -1
                                  15,      ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  RGBA($FF, 0, 0, 150), ; Frame color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255,   ; Frame Color
                                  1,                    ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                    ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,                   ; Padding x, 
                                  5,                    ; Padding y,
                                  0,                    ; Headletter mode - text stretching x
                                  0,                    ; Headletter_mode - text stretching y
                                  1)                    ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  1480,    ; x
                                  430,     ; y
                                  450,     ; Width
                                  300,     ; Height
                                  30,      ; Edge rounding
                                  text_1$,
                                  $FFFF,   ; Text color without alpha blending
                                  -1,      ; Background color - Without text background = -1
                                  0,       ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,   ; Frame Color
                                  1,       ; Text center=1 - Text right=2 - Text vertical=3
                                  0,       ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,      ; Padding x, 
                                  5,       ; Padding y,
                                  0,       ; Headletter mode - text stretching x
                                  0,       ; Headletter_mode - text stretching y
                                  1)       ; resize_factor.f
    
    ; === Activate GradientColor ===
    ; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
    GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
    GradientColor_Array_BF(1, 2, 0.4, RGBA($00, $FF, $FF, $FF))
    GradientColor_Array_BF(1, 3, 0.9, RGBA($FF, $FF, $00, $FF))
    
    ; Activate linear gradient
    LinearGradient_BF(1, -500, 0, 2000 , 2000)
    ; Aactivate circular gradient
    ; CircularGradient_BF(1, 450*DPI_ResizeFactor_BF(), 450*DPI_ResizeFactor_BF(), 600*DPI_ResizeFactor_BF())
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  35,                   ; x
                                  370,                  ; y
                                  650,                  ; Width
                                  500,                  ; Height
                                  30,                   ; Edge rounding
                                  text_3$,
                                  $FFFF,                ; Text color without alpha blending
                                  RGBA(0, 0, $FF, 120), ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  2,                    ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,                ; Frame Color
                                  1,                    ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                    ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,                   ; Padding x, 
                                  5,                    ; Padding y,
                                  0,                    ; Headletter mode - text stretching x
                                  0,                    ; Headletter_mode - text stretching y
                                  1)                    ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  35,      ; x
                                  395,     ; y
                                  650,     ; Width
                                  50,      ; Height
                                  30,      ; Edge rounding
                                  text_2$,
                                  $FFFFFF, ; Text color without alpha blending
                                  -1,      ; Background color - Without text background = -1
                                  0,       ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,   ; Frame Color
                                  1,       ; Text center=1 - Text right=2 - Text vertical=3
                                  0,       ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,      ; Padding x, 
                                  0,       ; Padding y,
                                  0,       ; Headletter mode - text stretching x
                                  0,       ; Headletter_mode - text stretching y
                                  1)       ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  750,     ; x
                                  580,     ; y
                                  1150,    ; Width
                                  400,     ; Height
                                  30,      ; Edge rounding
                                  text_4$,
                                  $FFFE,   ; Text color without alpha blending
                                  -1,      ; Background color - Without text background = -1
                                  0,       ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  $FF00,   ; Frame Color
                                  1,       ; Text center=1 - Text right=2 - Text vertical=3
                                  0,       ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  50,      ; Padding x, 
                                  0,       ; Padding y,
                                  0,       ; Headletter mode - text stretching x
                                  0,       ; Headletter_mode - text stretching y
                                  1)       ; resize_factor.f
    
    FittedText_RoundBox_Vector_BF(image_1_ID,
                                  Font_Georgia(),
                                  780, ; x
                                  270, ; y
                                  650, ; Width
                                  400, ; Height
                                  30,  ; Edge rounding    ; Workaround PB570 Linux - Using text_4$+#LF$ bellow overwritte resources - very bad
                                  "The simplest solution ever"+#LF$+ "for automatically creating fitted text"+#LF$+#LF$+#LF$+#LF$+#LF$+#LF$+#LF$+#LF$,
                                  $FFFFFF,                ; Text color without alpha blending
                                  RGBA($FF, 0, 0, 100),   ; Background color - Without text background = -1 - Alpha 0 is ignored and equal Alpha 255
                                  8,                      ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                  RGBA($FF, $FF, 0, 100), ; Frame Color - Alpha 0 is ignored and equal Alpha 255
                                  1,                      ; Text center=1 - Text right=2 - Text vertical=3
                                  0,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
                                  80,                     ; Padding x, 
                                  5,                      ; Padding y,
                                  0,                      ; Headletter mode - text stretching x
                                  0,                      ; Headletter_mode - text stretching y
                                  1)                      ; resize_factor.f
    
    ; Deactivate linear gradient
    LinearGradient_BF(1, 0, 0, 500*DPI_ResizeFactor_BF() , 500*DPI_ResizeFactor_BF())
    
    ; Draw the temporary image 1
    StartDrawing(ImageOutput(image_1_ID))
    DrawImage(ImageID(image_temp_1_ID), 855, 385)
    StopDrawing()
    
    Define image_temp_2_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha8.png")
    AlphaChannelSprite_Pro_BF(image_1_ID, image_temp_2_ID,
                              550,  ; Image x
                              520,  ; Image y 
                              300,  ; Endposition texture output - Preset 0 = Clipping is automatic to input width
                              300,  ; Endposition texture output - Preset 0 = Clipping is automatic to input height
                              300,  ; Output width  - You can here resize the output width
                              300,  ; Output height - You can here resize the output height
                              0,    ; Image clip x
                              0,    ; Image clip y
                              0,    ; Image clip width
                              0)    ; Image clip height
    
    Define image_temp_3_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
    
    ; BucketFill - Replace a color with a texture
    SetColor_BF($FFFE) 
    NoCaching_BF(0) ; Disable the BF texture caching - not needed here
    BF(-2, image_1_ID, image_temp_3_ID, -1, -1)
    SetColor_BF(-1)
    NoCaching_BF(1) ; Set back to preset
    
    ; Create ImageGadget 1 =====
    Global ImageGadget_1_ID=ImageGadget_BF(image_1_ID,           ; For initializing a image_ID is not needed
                                           ImageGadget_1_x,      ; Output pos x
                                           ImageGadget_1_y,      ; Output pos y
                                           ImageGadget_1_width,  ; Gadget width
                                           ImageGadget_1_height, ; Gadget height
                                           $808080,              ; Background color - For a invisible background set background_color=-2 (-1 is reserved for ignore)
                                           20,                   ; Padding
                                           $FFFFFF,              ; Grid color
                                           5,                    ; Grid size
                                           10,                   ; Grid tiling
                                           $808080,              ; Frame color
                                           4,                    ; Frame size
                                           0)                    ; Flags same the PB function
                                                                 ; The function give back the gadget ID
                                                                 ; For a empty image output set image_ID=-1
                                                                 ; The Gadget is compatible to the PB ImageGadget 
                                                                 ; BF Supports also automatically image upscaling with the function FitImageActivateUpscaling_BF
                                                                 ; Use a invisible background only for images with invisible color or you see nothing
                                                                 ; ImageGadget_BF create and cache needed temporary images for WinOS outputs automatically
    
    ; Create HyperlinkGadget 1 for using =======================================
    Global HyperlinkGadget_1_x=30
    Global HyperlinkGadget_1_y=90
    Global HyperlinkGadget_1_width=260
    Global HyperlinkGadget_1_height=25
    Global HyperlinkGadget_1_text$="This is a HyperlinkGadget"
    
    Global HyperlinkGadget_1_ID=HyperLinkGadget(#PB_Any, 0, 0, 0, 0, "", $FF0000, #PB_HyperLink_Underline)
    
    ; Create TextGadget 1 for using ============================================
    Global TextGadget_1_x=650
    Global TextGadget_1_y=95
    Global TextGadget_1_width=225
    Global TextGadget_1_height=30
    Global TextGadget_1_text$="This is a TextGadget"
    
    Global TextGadget_1_ID=TextGadget(#PB_Any, 0, 0, 0, 0, "")
    
    ; Create SpinGadget 1 for using ============================================
    Global SpinGadget_1_x=650
    Global SpinGadget_1_y=20
    Global SpinGadget_1_width=225
    Global SpinGadget_1_height=25
    Global SpinGadget_1_Text$="This is a SpinGadget"
    
    Global SpinGadget_1_ID=SpinGadget(#PB_Any, 0, 0, 0, 0, 0, 100)
    
    ; Create StringGadget 1 for using ==========================================
    Global StringGadget_1_x=30
    Global StringGadget_1_y=20
    Global StringGadget_1_width=225
    Global StringGadget_1_height=25
    Global StringGadget_1_Text$="This is a StringGadget"
    Global StringGadget_2_Text$="With enhanced text fitting"
    
    Global StringGadget_1_ID=StringGadget(#PB_Any, 0, 0, 0, 0, StringGadget_1_Text$)
    
    ; ==========================================================================
    
    ; ############## Resize procedure for callback ##############################
    Procedure WindowResizing_BindEvent_CreateGUI_1()
      
      ; ============= Init the scaling variables ==============
      Protected set_x.f=100/window_width_developing*WindowWidth(window_ID)/100
      Protected set_y.f=100/window_height_developing*WindowHeight(window_ID)/100
      
      ; Resize ButtonGadget 1 ===================================================
      FitGadgetText_BF(ButtonGadget_1_ID,
                       Font_Arial(),
                       ButtonGadget_1_x*set_x,
                       ButtonGadget_1_y*set_y,
                       ButtonGadget_1_width*set_x,
                       ButtonGadget_1_height*set_y,
                       30, ; Padding x
                       10, ; Padding y
                       1)  ; resize_factor.f
      
      ; Resize ImageGadget 1 ====================================================      
      SetImageGadget_BF(ImageGadget_1_ID,           ; Gadget ID
                        image_1_ID,                 ; Image ID
                        ImageGadget_1_x*set_x,      ; Output pos x
                        ImageGadget_1_y*set_y,      ; Output pos y
                        ImageGadget_1_width*set_x,  ; Gadget width
                        ImageGadget_1_height*set_y) ; Gadget height
                                                    ; BF Supports also automatically image upscaling with the function FitImageActivateUpscaling_BF
                                                    ; Use a invisible background only for images with invisible color or you see nothing
                                                    ; ImageGadget_BF create and cache needed temporary images for WinOS outputs automatically
      
      ; Resize HyperlinkGadget 1 ================================================
      SetGadgetText_BF(HyperlinkGadget_1_ID,
                       Font_Arial(),
                       HyperlinkGadget_1_x*set_x,
                       HyperlinkGadget_1_y*set_y,
                       HyperlinkGadget_1_width*set_x,
                       HyperlinkGadget_1_height*set_y,
                       HyperlinkGadget_1_text$,
                       0,   ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize TextGadget 1 =====================================================
      SetGadgetText_BF(TextGadget_1_ID,
                       Font_Arial(),
                       TextGadget_1_x*set_x,
                       TextGadget_1_y*set_y,
                       TextGadget_1_width*set_x,
                       TextGadget_1_height*set_y,
                       TextGadget_1_text$,
                       0,   ; Padding x
                       10,  ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize SpinGadget 1 =====================================================
      SetGadgetText_BF(SpinGadget_1_ID,
                       Font_Arial(),
                       SpinGadget_1_x*set_x,
                       SpinGadget_1_y*set_y,
                       SpinGadget_1_width*set_x,
                       SpinGadget_1_height*set_y,
                       SpinGadget_1_Text$,
                       20,  ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize StringGadget 1 ===================================================
      SetGadgetText_BF(StringGadget_1_ID,
                       Font_Arial(),
                       StringGadget_1_x*set_x,
                       StringGadget_1_y*set_y,
                       StringGadget_1_width*set_x,
                       StringGadget_1_height*set_y,
                       StringGadget_1_Text$,
                       5,   ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; =========================================================================
      
      ; The Set...BF functions returns the determined font size so that it can easily be inherit on to other gadgets
      ; This is also possible on gadgets of other sizes - Sample : alterable_size=calculated_font_size/my_resize_factor
      
      ; As you can see above, the Set...BF functions can not only set the text, but also reposition and resize the gadgets
      
      ; You can also check the actual padding on demand - Call this functions after a monitored Set...BF function  
      ; Debug "canvas Custom Gadget - Padding X : "+Str(Get_Fitted_Font_Padding_X_BF())
      ; Debug "canvas Custom Gadget - Padding Y: "+Str(Get_Fitted_Font_Padding_Y_BF())
      
    EndProcedure
    
    ; ===========================================================================
    
    Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
      
      ; =============== Calculate the output position and size =================
      Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
      window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
      If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
        Else : window_x*DPI_ResizeFactor_BF() : EndIf
      If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
        Else : window_y*DPI_ResizeFactor_BF() : EndIf
      ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
      
      ; ================= Init the resize procedure callback ======================
      BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
      
      ; ====== Init all gadgets - Call simple the resize callback procedure =======
      Macro Refresh_all_Gadgets ; Refresh the gadgets
        get_all_window_events=1 : WindowResizing_BindEvent_CreateGUI_1() : get_all_window_events=0 
        ; No WindowEvent may be called during a callback
        ; However, if the callback procedure is only called to refresh or the first initializing the gadgets,
        ; is a WindowEvent after updating each gadget recommended as flicker protection
        ; and must be triggered manually with get_all_window_events=1
      EndMacro
      
      ; ============================= Show the result =============================
      Deactivate_DPI_ResizeFactor_BF(0)
      Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
      
      Refresh_all_Gadgets
      
      HideWindow(window_ID, 0)
      
      Repeat
        Define win_event=WaitWindowEvent()
      Until win_event=#PB_Event_CloseWindow
      
      FreeGadget_BF(ImageGadget_1_ID)
      ; FreeTextures_BF() ; After cached BF calls - This clear the BF texture cache
      
    EndProcedure
    
  EndModule
  UseModule CreateGUI_1
  
  CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, DesktopWidth_UserScaled_BF()*0.70, DesktopHeight_UserScaled_BF()*0.70) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 312
; FirstLine = 285
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger