﻿
; ************** Dynamic Window / GUI creating module ***************

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

DeclareModule CreateGUI_1
  EnableExplicit
  UseModule GFX_Wizzard_BF
  Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
EndDeclareModule

Module CreateGUI_1
  
  Global window_width_developing=920 ; Developing size
  Global window_height_developing=400
  
  Global window_min_width=200 ; Minimum window size
  Global window_min_height=150
  
  Global window_x, window_y, window_width_output, window_height_output
  Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
  Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                              "Dynamic Window and GUI creating", Window_flags)
  WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
  Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
  
  Global Image_1_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
  Global Image_2_ID=LoadImage(#PB_Any, "./Image_Set/Cat_01.jpg")
  
  ; Create ButtonImageGadget _1 for using ==========================================
  Global ButtonImageGadget_1_width=600
  Global ButtonImageGadget_1_height=150
  Global ButtonImageGadget_1_x=WindowWidth(window_ID)/2-ButtonImageGadget_1_width/2
  Global ButtonImageGadget_1_y=WindowHeight(window_ID)/2-ButtonImageGadget_1_height/2
  
  Global text_1$="GFX_Wizzard_BF"+#LF$+#LF$+
                 "MagicTextGadget_BF"+#LF$+#LF$+
                 "Resize the window"+#LF$+         
                 "A new level of text output"+#LF$+
                 "Pixel exactly text adjustment"+#LF$+
                 "Incredible headline mode"+#LF$+
                 "Adjustable dual padding"
  
  Global Gadget_1_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_1$,                    ; Text
                                        ButtonImageGadget_1_x,      ; Gadget output x pos
                                        ButtonImageGadget_1_y,      ; Gadget output y pos
                                        ButtonImageGadget_1_width,  ; Gadget width
                                        ButtonImageGadget_1_height, ; Gadget height
                                        ButtonImageGadget_1_width,  ; Text width
                                        ButtonImageGadget_1_height, ; Text height
                                        2,                          ; Text stretching x - Headline mode
                                        4,                          ; Text stretching y - Headline mode
                                        5,                          ; padding_x
                                        5,                          ; Padding y
                                        #Blue,                      ; Text color - Alpha channel supported
                                        -1,                         ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "Georgia",                  ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Canvas_Border ; Border flag)
  
  ; Create ButtonImageGadget _2 for using ==========================================
  Global ButtonImageGadget_2_width=350
  Global ButtonImageGadget_2_height=100
  Global ButtonImageGadget_2_x=10
  Global ButtonImageGadget_2_y=10
  
  Global text_2$="Saki's text tools"+#LF$+
                 "Fully automated solutions"+#LF$+
                 "A new way for creating formatted text"+#LF$+
                 "Never see again font and"+#LF$+         
                 "text scaling problems"+#LF$+
                 "No fonts need to be loaded"+#LF$+
                 "Never more text adjustment problems"
  
  Global Gadget_2_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget
                                        text_2$,                    ; Text
                                        ButtonImageGadget_2_x,      ; Gadget output x pos
                                        ButtonImageGadget_2_y,      ; Gadget output y pos
                                        ButtonImageGadget_2_width,  ; Gadget width
                                        ButtonImageGadget_2_height, ; Gadget height
                                        ButtonImageGadget_2_width,  ; Text width
                                        ButtonImageGadget_2_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        2,                          ; Text stretching y - Headline mode
                                        5,                          ; padding_x
                                        5,                          ; Padding y
                                        #Blue,                      ; Text color - Alpha channel supported
                                        #Yellow,                    ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "Georgia",                  ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Canvas_Border ; Border flag)
  
  ; Create ButtonImageGadget _3 for using ==========================================
  Global ButtonImageGadget_3_width=340
  Global ButtonImageGadget_3_height=100
  Global ButtonImageGadget_3_x=WindowWidth(window_ID)-350-Get_gtk3_button_x_offset_BF()*1.5
  Global ButtonImageGadget_3_y=10
  
  Global text_3$="Any text size"+#LF$+"automatically fitted "+#LF$+"and freely scalable" 
  
  Global Gadget_3_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget
                                        text_3$,                    ; Text
                                        ButtonImageGadget_3_x,      ; Gadget output x pos
                                        ButtonImageGadget_3_y,      ; Gadget output y pos
                                        ButtonImageGadget_3_width,  ; Gadget width
                                        ButtonImageGadget_3_height, ; Gadget height
                                        ButtonImageGadget_3_width,  ; Text width
                                        ButtonImageGadget_3_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        0,                          ; Text stretching y - Headline mode
                                        0,                          ; padding_x
                                        0,                          ; Padding y
                                        #Blue,                      ; Text color - Alpha channel supported
                                        #Yellow,                    ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "Georgia",                  ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Canvas_Border ; Border flag)
  
  ; Create ButtonImageGadget _4 for using ==========================================
  Global ButtonImageGadget_4_width=320
  Global ButtonImageGadget_4_height=90
  Global ButtonImageGadget_4_x=WindowWidth(window_ID)/2-ButtonImageGadget_4_width/2
  Global ButtonImageGadget_4_y=290
  
  Global text_4$="Create perfect gadgets"+#LF$+#LF$+
                 "All OS and subsystems"+#LF$+ 
                 "Freely resizable, stretchable,"+#LF$+         
                 "zoomable, movable, colourable, headline,"+#LF$+
                 "left, right, centered, RTL, vertical"
  
  Global Gadget_4_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget
                                        text_4$,                    ; Text
                                        ButtonImageGadget_4_x,      ; Gadget output x pos
                                        ButtonImageGadget_4_y,      ; Gadget output y pos
                                        ButtonImageGadget_4_width,  ; Gadget width
                                        ButtonImageGadget_4_height, ; Gadget height
                                        ButtonImageGadget_4_width,  ; Text width
                                        ButtonImageGadget_4_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        5,                          ; Text stretching y - Headline mode
                                        0,                          ; padding_x
                                        0,                          ; Padding y
                                        #Blue,                      ; Text color - Alpha channel supported
                                        #White,                     ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "",                         ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Canvas_Border ; Border flag)
  
  ; Create ButtonImageGadget _5 for using ==========================================
  Global ButtonImageGadget_5_width=30
  Global ButtonImageGadget_5_height=210
  Global ButtonImageGadget_5_x=60
  Global ButtonImageGadget_5_y=150
  
  Global text_5$="Real vertical buttons"
  
  Global Gadget_5_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget
                                        text_5$,                    ; Text
                                        ButtonImageGadget_5_x,      ; Gadget output x pos
                                        ButtonImageGadget_5_y,      ; Gadget output y pos
                                        ButtonImageGadget_5_width,  ; Gadget width
                                        ButtonImageGadget_5_height, ; Gadget height
                                        ButtonImageGadget_5_width,  ; Text width
                                        ButtonImageGadget_5_height, ; Text height
                                        4,                          ; Text stretching x - Headline mode
                                        0,                          ; Text stretching y - Headline mode
                                        0,                          ; padding_x
                                        0,                          ; Padding y
                                        #Black,                     ; Text color - Alpha channel supported
                                        #White,                     ; Background color - Alpha channel supported - For invisible background set to -1
                                        3,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "",                         ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Canvas_Border ; Border flag)
  
  ; === Activate GradientColor ===
  ; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
  GradientColor_Array_BF(1, 1, 0.2, RGBA($FF, $00, $00, $FF))
  GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
  GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))
  
  ; ===========================================================================
  
  ; ############## Resize procedure for callback ##############################
  Procedure WindowResizing_BindEvent_CreateGUI_1()
    
    ; ============= Init the scaling variables ==============
    Global set_x.d=100/window_width_developing*WindowWidth(window_ID)/100
    Global set_y.d=100/window_height_developing*WindowHeight(window_ID)/100
    
    ; The text is output without disturbing borders and can even be output separately proportional or unproportional in the x and y axis
    ; Padding can be used and the text can be moved anywhere in the output rectangle
    
    Define button_width.d=600 ; Text width
    Define button_height.d=200; Text height
    
    Define fitted_text_width.d=ButtonImageGadget_1_width*set_x   ; Fitted text width  - Negative values available
    Define fitted_text_height.d=ButtonImageGadget_1_height*set_y ; Fitted text height - Negative values available
    
    ; Activate linear gradient
    LinearGradient_BF(1, GadgetX(gadget_1_ID), GadgetY(gadget_1_ID), GadgetWidth(gadget_1_ID), GadgetHeight(gadget_1_ID))
    ; Activate circular gradient
    ; CircularGradient_BF(1, 500, 100, 800) - Hint Circular gradient is not fast !
    
    ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
    
    ; Works with Magic_StretchText_Pro_TextOffset_BF()
    ; Magic_StretchText_Pro_TextOffset_BF(stretchtext_pro_offset_x_, stretchtext_pro_offset_y_)
    ; You can set a text output offset to add an image as sample or text adjustment or text animations
    ; This function deactivate frames
    ; Magic_StretchText_Pro_TextOffset_BF(15*DPI_ResizeFactor_BF()*set_x, 1*DPI_ResizeFactor_BF()*set_y)
    
    Define frame_size_stretchtext=1
    Define frame_padding_stretchtext=3
    Define frame_rounding_stretchtext=4
    Define frame_color_stretchtext=$AAAAAA
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    ; Add a percent based fitted proportional image to MagicTextGadget_BF - You must deactivate again
    MagicStretchText_Add_Image_BF(image_1_ID,
                                  5*DPI_ResizeFactor_BF(), ; MagicTextGadget_add_image_x
                                  5*DPI_ResizeFactor_BF(), ; MagicTextGadget_add_image_y
                                  100,                     ; MagicTextGadget_add_image_width_percent
                                  56,                      ; MagicTextGadget_add_image_height_percent
                                  255,                     ; Image Alpha 
                                  0)                       ; Sticky image 
    
    SetMagicTextGadget_BF(gadget_1_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_1_width*set_x,  ; Button width
                          ButtonImageGadget_1_height*set_y, ; Button height
                          ButtonImageGadget_1_width*1.3,    ; Text width
                          ButtonImageGadget_1_height*1.8,   ; Text height
                          ButtonImageGadget_1_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_1_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    LinearGradient_BF(0) ; Deactivate linear gradient   
    
    SetMagicTextGadget_BF(gadget_2_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_2_width*set_x,  ; Button width
                          ButtonImageGadget_2_height*set_y, ; Button height
                          ButtonImageGadget_2_width*1.3,    ; Text width
                          ButtonImageGadget_2_height*1.8,   ; Text height
                          ButtonImageGadget_2_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_2_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color 
    
    Magic_StretchText_Pro_Border_BF() ; Deactivate again
    
    Define frame_size_stretchtext=6*(set_x+set_y)/2
    Define frame_padding_stretchtext=6
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=$80AAAAAA
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    ; Add a percent based fitted proportional image to MagicTextGadget_BF - You must deactivate again
    MagicStretchText_Add_Image_BF(image_1_ID,
                                  10*DPI_ResizeFactor_BF(), ; MagicTextGadget_add_image_x
                                  10*DPI_ResizeFactor_BF(), ; MagicTextGadget_add_image_y
                                  70,                       ; MagicTextGadget_add_image_width_percent
                                  40,                       ; MagicTextGadget_add_image_height_percent
                                  255,                      ; Image Alpha 
                                  1)                        ; Sticky image 
    
    SetMagicTextGadget_BF(gadget_3_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_3_width*set_x,  ; Button width
                          ButtonImageGadget_3_height*set_y, ; Button height
                          ButtonImageGadget_3_width*1.3,    ; Text width
                          ButtonImageGadget_3_height*1.8,   ; Text height
                          ButtonImageGadget_3_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_3_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color 
    
    MagicStretchText_Add_Image_BF() ; Deactivate again a added image
    
    Define frame_size_stretchtext=3
    Define frame_padding_stretchtext=6
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=$8000FFFF
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    SetMagicTextGadget_BF(gadget_4_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_4_width*set_x,  ; Button width
                          ButtonImageGadget_4_height*set_y, ; Button height
                          ButtonImageGadget_4_width*1.2,    ; Text width
                          ButtonImageGadget_4_height*1.4,   ; Text height
                          ButtonImageGadget_4_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_4_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    Define frame_size_stretchtext=3
    Define frame_padding_stretchtext=3
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=#Yellow
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    SetMagicTextGadget_BF(gadget_5_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_5_width*set_x,  ; Button width
                          ButtonImageGadget_5_height*set_y, ; Button height
                          ButtonImageGadget_5_width,        ; Text width
                          ButtonImageGadget_5_height*3.5,   ; Text height
                          ButtonImageGadget_5_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_5_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    Define frame_size_stretchtext=0
    Define frame_padding_stretchtext=10
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=#Yellow
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    ; Magic_StretchText_Pro_TextOffset_BF() ; Deactivate again
    
  EndProcedure
  
  ; ===========================================================================
  
  Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
    
    ; =============== Calculate the output position and size =================
    Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
    window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
    If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
      Else : window_x*DPI_ResizeFactor_BF() : EndIf
    If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
      Else : window_y*DPI_ResizeFactor_BF() : EndIf
    ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
    
    ; ================= Init the resize procedure callback ======================
    BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
    
    ; ====== Init all gadgets - Call simple the resize callback procedure =======
    Macro Refresh_all_Gadgets ; Refresh the gadgets
      Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
      WindowResizing_BindEvent_CreateGUI_1()
      Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
    EndMacro
    
    ; ============================= Show the result =============================
    
    Deactivate_DPI_ResizeFactor_BF(0)
    
    ; Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
    
    Refresh_all_Gadgets
    
    HideWindow(window_ID, 0)
    
    Repeat
      Define win_event=WaitWindowEvent()
    Until win_event=#PB_Event_CloseWindow
    
  EndProcedure
  
EndModule
UseModule CreateGUI_1

CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 900, 550) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 235
; FirstLine = 213
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger