﻿
; ************** Dynamic Window / GUI creating module ***************

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

DeclareModule CreateGUI_1
  EnableExplicit
  UseModule GFX_Wizzard_BF
  Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
EndDeclareModule

Module CreateGUI_1
  
  Global window_width_developing=920 ; Developing size
  Global window_height_developing=400
  
  Global window_min_width=200 ; Minimum window size
  Global window_min_height=150
  
  Global window_x, window_y, window_width_output, window_height_output
  Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
  Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                              "Dynamic Window and GUI creating", Window_flags)
  
  WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
  Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
  
  Global Image_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")
  Global Image_1_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
  Global Image_2_ID=LoadImage(#PB_Any, "./Image_Set/Dog_1.gif")
  
  ; Create ButtonImageGadget _1 for using ==========================================
  Global ButtonImageGadget_1_width=600
  Global ButtonImageGadget_1_height=150
  Global ButtonImageGadget_1_x=WindowWidth(window_ID)/2-ButtonImageGadget_1_width/2
  Global ButtonImageGadget_1_y=WindowHeight(window_ID)/2-ButtonImageGadget_1_height/2
  
  Global text_1$="GFX_Wizzard_BF"+#LF$+#LF$+
                 "MagicTextGadget_BF"+#LF$+#LF$+
                 "Resize the window"+#LF$+         
                 "A new level of text output"+#LF$+
                 "Pixel exactly text adjustment"+#LF$+
                 "Incredible headline mode"+#LF$+
                 "Adjustable dual padding"
  
  Global Gadget_1_ID=MagicTextGadget_BF(2,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_1$,                    ; Text
                                        ButtonImageGadget_1_x,      ; Gadget output x pos
                                        ButtonImageGadget_1_y,      ; Gadget output y pos
                                        ButtonImageGadget_1_width,  ; Gadget width
                                        ButtonImageGadget_1_height, ; Gadget height
                                        ButtonImageGadget_1_width,  ; Text width
                                        ButtonImageGadget_1_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        1,                          ; Text stretching y - Headline mode
                                        1,                          ; padding_x
                                        1,                          ; Padding y
                                        #Black,                     ; Text color - Alpha channel supported
                                        -1,                         ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "Georgia",                  ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        #PB_Image_Raised)           ; #PB_Image_Border, #PB_Image_Raised ; Border flag)
  
  ; Create ImageGadget _2 for using ==========================================
  Global ButtonImageGadget_2_width=350
  Global ButtonImageGadget_2_height=100
  Global ButtonImageGadget_2_x=10
  Global ButtonImageGadget_2_y=10
  
  Global text_2$="Saki's text tools"+#LF$+
                 "Fully automated solutions"+#LF$+
                 "Incredible abilities"+#LF$+
                 "Never see again font and"+#LF$+         
                 "text scaling problems"+#LF$+
                 "No fonts need to be loaded"+#LF$+
                 "Never more text adjustment problems"
  
  Global Gadget_2_ID=MagicTextGadget_BF(2,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_2$,                    ; Text
                                        ButtonImageGadget_2_x,      ; Gadget output x pos
                                        ButtonImageGadget_2_y,      ; Gadget output y pos
                                        ButtonImageGadget_2_width,  ; Gadget width
                                        ButtonImageGadget_2_height, ; Gadget height
                                        ButtonImageGadget_2_width,  ; Text width
                                        ButtonImageGadget_2_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        2,                          ; Text stretching y - Headline mode
                                        1,                          ; padding_x
                                        1,                          ; Padding y
                                        #Blue,                      ; Text color - Alpha channel supported
                                        -1,                         ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "Georgia",                  ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Image_Border, #PB_Image_Raised ; Border flag)
  
  ; Create ImageGadget _3 for using ==========================================
  Global ButtonImageGadget_3_width=340-Get_gtk3_button_x_offset_BF()*1.5
  Global ButtonImageGadget_3_height=100
  Global ButtonImageGadget_3_x=WindowWidth(window_ID)-350
  Global ButtonImageGadget_3_y=10
  
  Global text_3$="ImageGadget"+#LF$+"automatically fitted"+#LF$+"freely scalable" 
  
  Global Gadget_3_ID=MagicTextGadget_BF(2,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_3$,                    ; Text
                                        ButtonImageGadget_3_x,      ; Gadget output x pos
                                        ButtonImageGadget_3_y,      ; Gadget output y pos
                                        ButtonImageGadget_3_width,  ; Gadget width
                                        ButtonImageGadget_3_height, ; Gadget height
                                        ButtonImageGadget_3_width,  ; Text width
                                        ButtonImageGadget_3_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        0,                          ; Text stretching y - Headline mode
                                        0,                          ; padding_x
                                        0,                          ; Padding y
                                        #Blue,                      ; Text color - Alpha channel supported
                                        #Yellow,                    ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "Georgia",                  ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Image_Border, #PB_Image_Raised ; Border flag)
  
  ; Create ImageGadget _4 for using ==========================================
  Global ButtonImageGadget_4_width=320
  Global ButtonImageGadget_4_height=90
  Global ButtonImageGadget_4_x=WindowWidth(window_ID)/2-ButtonImageGadget_4_width/2
  Global ButtonImageGadget_4_y=290
  
  Global text_4$="A ButtonImageGadget"+#LF$+#LF$+
                 "Multiple outputs"+#LF$+         
                 "with included ProgressBar"+#LF$+ 
                 "Images & GIF"
  
  Global Gadget_4_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_4$,                    ; Text
                                        ButtonImageGadget_4_x,      ; Gadget output x pos
                                        ButtonImageGadget_4_y,      ; Gadget output y pos
                                        ButtonImageGadget_4_width,  ; Gadget width
                                        ButtonImageGadget_4_height, ; Gadget height
                                        ButtonImageGadget_4_width,  ; Text width
                                        ButtonImageGadget_4_height, ; Text height
                                        1,                          ; Text stretching x - Headline mode
                                        2,                          ; Text stretching y - Headline mode
                                        60,                         ; padding_x
                                        15,                         ; Padding y 
                                        #Blue,                      ; Text color - Alpha channel supported
                                        $FFFF,                      ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "",                         ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; Border flag)
  
  ; Create ImageGadget _5 for using ==========================================
  Global ButtonImageGadget_5_width=120
  Global ButtonImageGadget_5_height=30
  Global ButtonImageGadget_5_x=410-Get_gtk3_button_x_offset_BF()/3
  Global ButtonImageGadget_5_y=30-Get_gtk3_button_x_offset_BF()/2
  
  Global text_5$="All OS"
  
  Global Gadget_5_ID=MagicTextGadget_BF(2,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_5$,                    ; Text
                                        ButtonImageGadget_5_x,      ; Gadget output x pos
                                        ButtonImageGadget_5_y,      ; Gadget output y pos
                                        ButtonImageGadget_5_width,  ; Gadget width
                                        ButtonImageGadget_5_height, ; Gadget height
                                        ButtonImageGadget_5_width,  ; Text width
                                        ButtonImageGadget_5_height, ; Text height
                                        0,                          ; Text stretching x - Headline mode
                                        0,                          ; Text stretching y - Headline mode
                                        0,                          ; padding_x
                                        0,                          ; Padding y
                                        #Red,                       ; Text color - Alpha channel supported
                                        #White,                     ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "",                         ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Image_Border, #PB_Image_Raised ; Border flag)
  
  ; Create ImageGadget _6 for using ==========================================
  Global ButtonImageGadget_6_width=140
  Global ButtonImageGadget_6_height=35
  Global ButtonImageGadget_6_x=400-Get_gtk3_button_x_offset_BF()/3
  Global ButtonImageGadget_6_y=70
  
  Global text_6$="Demos"+#LF$+"Image Gadgets"
  
  Global Gadget_6_ID=MagicTextGadget_BF(2,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                        text_6$,                    ; Text
                                        ButtonImageGadget_6_x,      ; Gadget output x pos
                                        ButtonImageGadget_6_y,      ; Gadget output y pos
                                        ButtonImageGadget_6_width,  ; Gadget width
                                        ButtonImageGadget_6_height, ; Gadget height
                                        ButtonImageGadget_6_width,  ; Text width
                                        ButtonImageGadget_6_height, ; Text height
                                        0,                          ; Text stretching x - Headline mode
                                        0,                          ; Text stretching y - Headline mode
                                        0,                          ; padding_x
                                        0,                          ; Padding y
                                        #Black,                     ; Text color - Alpha channel supported
                                        -1,                         ; Background color - Alpha channel supported - For invisible background set to -1
                                        1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                        "",                         ; Font type - more is not needed - accept also ""
                                        #PB_Font_Bold,              ; Font style
                                        0)                          ; #PB_Image_Border, #PB_Image_Raised ; Border flag)
  
  ; ===========================================================================
  
  ; ############## Resize procedure for callback ##############################
  Procedure WindowResizing_BindEvent_CreateGUI_1()
    
    ; ============= Init the scaling variables ==============
    Global set_x.d=100/window_width_developing*WindowWidth(window_ID)/100
    Global set_y.d=100/window_height_developing*WindowHeight(window_ID)/100
    
    ; The text is output without disturbing borders and can even be output separately proportional or unproportional in the x and y axis
    ; Padding can be used and the text can be moved anywhere in the output rectangle
    
    Define button_width.d=600 ; Text width
    Define button_height.d=200; Text height
    
    Define fitted_text_width.d=ButtonImageGadget_1_width*set_x   ; Fitted text width  - Negative values available
    Define fitted_text_height.d=ButtonImageGadget_1_height*set_y ; Fitted text height - Negative values available
    
    MagicStretchText_Add_ProgressBar_BF() ; Deactivate Progressbar
    
    ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
    
    ; Works with Magic_StretchText_Pro_TextOffset_BF()
    ; Magic_StretchText_Pro_TextOffset_BF(stretchtext_pro_offset_x_, stretchtext_pro_offset_y_)
    ; You can set a text output offset to add an image as sample or text adjustment or text animations
    ; This function deactivate frames
    ; Magic_StretchText_Pro_TextOffset_BF(15*DPI_ResizeFactor_BF()*set_x, 1*DPI_ResizeFactor_BF()*set_y)
    
    Define frame_size_stretchtext=0
    Define frame_padding_stretchtext=3
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=$AAAAAA
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    ; Add a percent based fitted proportional image to MagicTextGadget_BF - You must deactivate again
    MagicStretchText_Add_Image_1_BF(image_1_ID,
                                    5*DPI_ResizeFactor_BF(), ; MagicTextGadget_add_image_x
                                    5*DPI_ResizeFactor_BF(), ; MagicTextGadget_add_image_y
                                    100,                     ; MagicTextGadget_add_image_width_percent
                                    56,                      ; MagicTextGadget_add_image_height_percent
                                    255,                     ; Image Alpha 
                                    0)                       ; Sticky image 
    
    SetMagicTextGadget_BF(gadget_1_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_1_width*set_x,  ; Button width
                          ButtonImageGadget_1_height*set_y, ; Button height
                          ButtonImageGadget_1_width*1.3,    ; Text width
                          ButtonImageGadget_1_height*1.8,   ; Text height
                          ButtonImageGadget_1_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_1_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    LinearGradient_BF(0) ; Deactivate linear gradient   
    
    SetMagicTextGadget_BF(gadget_2_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_2_width*set_x,  ; Button width
                          ButtonImageGadget_2_height*set_y, ; Button height
                          ButtonImageGadget_2_width*1.3,    ; Text width
                          ButtonImageGadget_2_height*1.8,   ; Text height
                          ButtonImageGadget_2_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_2_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color 
    
    Define frame_size_stretchtext=5*(set_x+set_y)/2
    Define frame_padding_stretchtext=6
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=$80AAAAAA
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    SetMagicTextGadget_BF(gadget_3_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_3_width*set_x,  ; Button width
                          ButtonImageGadget_3_height*set_y, ; Button height
                          ButtonImageGadget_3_width*1.3,    ; Text width
                          ButtonImageGadget_3_height*1.8,   ; Text height
                          ButtonImageGadget_3_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_3_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color 
    
    Define frame_size_stretchtext=0
    Define frame_padding_stretchtext_x=25
    Define frame_padding_stretchtext_y=0
    Define frame_rounding_stretchtext=5
    Define frame_color_stretchtext=$AAAAAA
    Magic_StretchText_Pro_Border_DualPadding_BF(frame_size_stretchtext,
                                                frame_padding_stretchtext_x,
                                                frame_padding_stretchtext_y,
                                                frame_rounding_stretchtext,
                                                frame_color_stretchtext)
    
    MagicStretchText_Add_Image_BF(-1)  ; Deactivate again
    SetMagicTextGadget_BF(gadget_4_ID, ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_4_width*set_x,  ; Button width
                          ButtonImageGadget_4_height*set_y, ; Button height
                          ButtonImageGadget_4_width*1.2,    ; Text width
                          ButtonImageGadget_4_height*1.4,   ; Text height
                          ButtonImageGadget_4_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_4_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    SetMagicTextGadget_BF(gadget_5_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_5_width*set_x,  ; Button width
                          ButtonImageGadget_5_height*set_y, ; Button height
                          ButtonImageGadget_5_width,        ; Text width
                          ButtonImageGadget_5_height,       ; Text height
                          ButtonImageGadget_5_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_5_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          0,                                ; Padding x
                          0,                                ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    SetMagicTextGadget_BF(gadget_6_ID,                      ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_6_width*set_x,  ; Button width
                          ButtonImageGadget_6_height*set_y, ; Button height
                          ButtonImageGadget_6_width/1.5,    ; Text width
                          ButtonImageGadget_6_height,       ; Text height
                          ButtonImageGadget_6_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_6_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          0,                                ; Padding x
                          0,                                ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
    CompilerIf #PB_Compiler_OS=#PB_OS_Windows 
      RedrawWindow_(WindowID(window_ID), 0, 0, 7)
    CompilerEndIf
    
    ; Magic_StretchText_Pro_TextOffset_BF() ; Deactivate again
    
  EndProcedure
  
  ; ===========================================================================
  
  Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
    
    ; =============== Calculate the output position and size =================
    Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
    window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
    If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
      Else : window_x*DPI_ResizeFactor_BF() : EndIf
    If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
      Else : window_y*DPI_ResizeFactor_BF() : EndIf
    ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
    
    ; ================= Init the resize procedure callback ======================
    BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
    
    ; ====== Init all gadgets - Call simple the resize callback procedure =======
    Macro Refresh_all_Gadgets ; Refresh the gadgets
      Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
      WindowResizing_BindEvent_CreateGUI_1()
      Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
    EndMacro
    
    ; ============================= Show the result =============================
    
    Deactivate_DPI_ResizeFactor_BF(0)
    
    ; Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
    
    Refresh_all_Gadgets ; Linux need this
    
    HideWindow(window_ID, 0)
    
    Protected is_gif, frame, frames, delay, refresh, win_event, count
    Protected old_window_width=WindowWidth(window_ID), old_window_height=WindowHeight(window_ID) 
    Protected progress, swap_
    
    If IsImage(image_2_ID)
      frames=ImageFrameCount_BF(image_2_ID) : If frames>1 : is_gif=1 : EndIf
    EndIf
    Repeat
      If is_gif
        SetImageFrame(image_2_ID, frame) ; Set the GIF frame for processing
        If refresh
          MagicStretchText_Add_Image_2_BF(image_2_ID,                      ; Image ID - deactivate = -1
                                          240*DPI_ResizeFactor_BF()*set_x, ; x
                                          0*DPI_ResizeFactor_BF()*set_y,   ; y
                                          50,                              ; Image width  - percent
                                          50,                              ; Image height - percent
                                          255,                             ; Image alpha
                                          1)                               ; Sticky image)
          
          If SetMagicTextGadget_BF(gadget_4_ID)<1 : Break : EndIf
          MagicStretchText_Add_Image_2_BF(-1) ; Deactivate again - This works also with the DualPadding variant at the same
        EndIf
        If Delay_BF(1, Get_Gif_FrameDelay_BF(image_2_ID, frame)) : frame+1 : refresh=1 : If frame=frames : frame=0 : EndIf : Else : refresh=0 : EndIf
      EndIf
      
      Macro events
        If win_event=#PB_Event_CloseWindow : Break 2 : EndIf
      EndMacro
      
      If Delay_BF(2, 20)
        ; Add a ProgressBar inside the gadget
        ; Width and height -frame thickness - You must deactivate again - Alpha channel supported
        ; You can set the output to layer 0 or 1
        MagicStretchText_Add_ProgressBar_BF(progress, $600000FF, swap_)
        
        ; Refresh the GIF
        MagicStretchText_Add_Image_2_BF(image_2_ID,                      ; Image ID - deactivate = -1
                                        240*DPI_ResizeFactor_BF()*set_x, ; x
                                        0*DPI_ResizeFactor_BF()*set_y,   ; y
                                        50,                              ; Image width  - percent
                                        50,                              ; Image height - percent
                                        255,                             ; Image alpha
                                        1)                               ; Sticky image)
        
        ; Draw the Gadget content
        If SetMagicTextGadget_BF(gadget_4_ID)<1 : Break : EndIf
        MagicStretchText_Add_Image_2_BF(-1) ; Deactivate again - This works also with the DualPadding variant at the same
        progress+1
        If progress>100 : progress=0 : swap_=1-swap_ : EndIf
      EndIf
      
      Repeat ; Get all window events
        win_event=WindowEvent()
        events
      Until Not win_event
      Delay(1)
      
    ForEver
    
  EndProcedure
  
EndModule
UseModule CreateGUI_1

CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 900, 550) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 4 (Windows - x64)
; CursorPosition = 107
; FirstLine = 107
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe