﻿
; ************** Dynamic Window / GUI creating module ***************

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

DeclareModule CreateGUI_1
  EnableExplicit
  UseModule GFX_Wizzard_BF
  Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
EndDeclareModule

Module CreateGUI_1
  
  Global Image_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
  
  Global Image_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
  ; Global Image_1_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
  ; Global Image_1_ID=LoadImage(#PB_Any, "./Image_Set/Cat_01.jpg")
  
  ; You must deactivate again - So : Embossing_Color()
  Embossing_Color(1, #Black)
  
  ; With this function you can texture any MagicText and MagicGadgets text
  ; With changing x and y pos you can adjust or scroll the textures
  ; You must deactivate again - So : MagicText_BucketFill_BF()
  ; Accept also color in place of the image ID, as sample #Red
  MagicText_BucketFill_BF(image_ID,                  ; Image ID -1 deactivate the function - Also you can set simple
                          260*DPI_ResizeFactor_BF(), ; Output x pos
                          0*DPI_ResizeFactor_BF(),   ; Output y pos
                          310*DPI_ResizeFactor_BF(), ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                          70*DPI_ResizeFactor_BF(),  ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                          50*DPI_ResizeFactor_BF(),  ; Resize texture width  - 0 = without resizing
                          50*DPI_ResizeFactor_BF(),  ; Resize texture height - 0 = without resizing
                          0)                         ; Texture alpha - BF specific 0 = full visible
  
  MagicText_BucketFill_1_BF(#Green,                    ; Image ID -1 deactivate the function - Also you can set simple a color
                            220*DPI_ResizeFactor_BF(), ; Output x pos
                            95*DPI_ResizeFactor_BF(),  ; Output y pos
                            420*DPI_ResizeFactor_BF(), ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                            80*DPI_ResizeFactor_BF(),  ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                            50*DPI_ResizeFactor_BF(),  ; Resize texture width  - 0 = without resizing
                            50*DPI_ResizeFactor_BF(),  ; Resize texture height - 0 = without resizing
                            0)                         ; Texture alpha - BF specific 0 = full visible
  
  MagicText_BucketFill_2_BF($FF00FF,                   ; Image ID -1 deactivate the function - Also you can set simple a color
                            130*DPI_ResizeFactor_BF(), ; Output x pos
                            180*DPI_ResizeFactor_BF(), ; Output y pos
                            520*DPI_ResizeFactor_BF(), ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                            90*DPI_ResizeFactor_BF(),  ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                            50*DPI_ResizeFactor_BF(),  ; Resize texture width  - 0 = without resizing
                            50*DPI_ResizeFactor_BF(),  ; Resize texture height - 0 = without resizing  
                            0)                         ; Texture alpha - BF specific 0 = full visible
  
  Global window_width_developing=920 ; Developing size
  Global window_height_developing=400
  
  Global window_min_width=200 ; Minimum window size
  Global window_min_height=150
  
  Global window_x, window_y, window_width_output, window_height_output
  Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
  Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                              "Dynamic Window and GUI creating", Window_flags)
  WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
  Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
  
  ; Create ButtonImageGadget 1 for using ==========================================
  Global ButtonImageGadget_1_width=600
  Global ButtonImageGadget_1_height=150
  Global ButtonImageGadget_1_x=WindowWidth(window_ID)/2-ButtonImageGadget_1_width/2
  Global ButtonImageGadget_1_y=WindowHeight(window_ID)/2-ButtonImageGadget_1_height/2
  
  Global text$="GFX_Wizzard_BF"+#LF$+
               "MagicTextGadget_BF"+#LF$+
               "Multi colored" 
  
  Global Gadget_ID=MagicTextGadget_BF(0,                          ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                      text$,                      ; Text
                                      ButtonImageGadget_1_x,      ; Gadget output x pos
                                      ButtonImageGadget_1_y,      ; Gadget output y pos
                                      ButtonImageGadget_1_width,  ; Gadget width
                                      ButtonImageGadget_1_height, ; Gadget height
                                      ButtonImageGadget_1_width,  ; Text width
                                      ButtonImageGadget_1_height, ; Text height
                                      2,                          ; Text stretching x - Headline mode
                                      2,                          ; Text stretching y - Headline mode
                                      30,                         ; padding_x
                                      5,                          ; Padding y
                                      #White,                     ; Text color - Alpha channel supported
                                      $606060,                    ; Background color - Alpha channel supported - For invisible background set to -1
                                      1,                          ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                      "Georgia",                  ; Font type - more is not needed - accept also ""
                                      #PB_Font_Bold,              ; Font style
                                      0)                          ; #PB_Canvas_Border ; Border flag)
  
  ; ==========================================================================
  
  ; ############## Resize procedure for callback ##############################
  Procedure WindowResizing_BindEvent_CreateGUI_1()
    
    ; ============= Init the scaling variables ==============
    Global set_x.d=100/window_width_developing*WindowWidth(window_ID)/100
    Global set_y.d=100/window_height_developing*WindowHeight(window_ID)/100
    
    ; The text is output without disturbing borders and can even be output separately proportional or unproportional in the x and y axis
    ; Padding can be used and the text can be moved anywhere in the output rectangle
    
    Define button_width.d=600 ; Text width
    Define button_height.d=200; Text height
    
    Define fitted_text_width.d=ButtonImageGadget_1_width*set_x   ; Fitted text width  - Negative values available
    Define fitted_text_height.d=ButtonImageGadget_1_height*set_y ; Fitted text height - Negative values available
    
    ; Works with Magic_StretchText_Pro_TextOffset_BF()
    ; Magic_StretchText_Pro_TextOffset_BF(stretchtext_pro_offset_x_, stretchtext_pro_offset_y_)
    ; You can set a text output offset to add an image as sample or text adjustment or text animations
    ; Magic_StretchText_Pro_TextOffset_BF(100*set_x, 0*set_y)
    
    ; Add a percent based fitted proportional image to MagicTextGadget_BF - You must deactivate again
    MagicStretchText_Add_Background_BF(image_1_ID,
                                       0,         ; Output x pos
                                       0,         ; Output y pos
                                       200*set_x, ; MagicTextGadget Background width - 0 = original width
                                       200*set_y, ; MagicTextGadget Background height - 0 = original height
                                       0)         ; Image Alpha - BF Specific - 0 = full visible
    
    SetMagicTextGadget_BF(gadget_ID,                        ; Gadget_ID - look the demo code for using
                          ButtonImageGadget_1_width*set_x,  ; Button width
                          ButtonImageGadget_1_height*set_y, ; Button height
                          ButtonImageGadget_1_width*1.3,    ; Text width
                          ButtonImageGadget_1_height*1.8,   ; Text height
                          ButtonImageGadget_1_x*set_x,      ; Gadget output x pos
                          ButtonImageGadget_1_y*set_y,      ; Gadget output y pos
                          "",                               ; Text
                          -1,                               ; Text stretching x - Headline mode
                          -1,                               ; Text stretching y - Headline mode
                          -1,                               ; Padding x
                          -1,                               ; Padding_y
                          -1,                               ; Text color
                          -1)                               ; Background color
    
  EndProcedure
  
  ; ===========================================================================
  
  Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
    
    ; =============== Calculate the output position and size =================
    Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
    window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
    If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
      Else : window_x*DPI_ResizeFactor_BF() : EndIf
    If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
      Else : window_y*DPI_ResizeFactor_BF() : EndIf
    ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
    
    ; ================= Init the resize procedure callback ======================
    BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
    
    ; ====== Init all gadgets - Call simple the resize callback procedure =======
    Macro Refresh_all_Gadgets ; Refresh the gadgets
      Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
      WindowResizing_BindEvent_CreateGUI_1()
      Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
    EndMacro
    
    ; ============================= Show the result =============================
    
    Deactivate_DPI_ResizeFactor_BF(0)
    
    ; Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
    
    Refresh_all_Gadgets
    
    HideWindow(window_ID, 0)
    
    Repeat
      Define win_event=WaitWindowEvent()
    Until win_event=#PB_Event_CloseWindow
    
  EndProcedure
  
EndModule
UseModule CreateGUI_1

CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 900, 550) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 3 (Linux - x64)
; CursorPosition = 43
; FirstLine = 35
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger