﻿
; ************** Dynamic Window / GUI creating module ***************

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

DeclareModule CreateGUI_1
  EnableExplicit
  UseModule GFX_Wizzard_BF
  Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
EndDeclareModule

Module CreateGUI_1
  
  Global window_width_developing=920 ; Developing size
  Global window_height_developing=400
  
  Global window_min_width=450 ; Minimum window size
  Global window_min_height=200
  
  Global window_x, window_y, window_width_output, window_height_output
  Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
  Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                              "Dynamic Window and GUI creating", Window_flags)
  WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
  Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
  
  ; Create a font array
  ; Mostly 30pt > 40pt is enough - smaller is faster
  Global max_needed_font_size=40
  
  ; Create a font array
  ; Mostly 30pt > 40pt is enough - smaller is faster
  Global max_needed_font_size=40
  Global needed_font_size
  Global Dim Font_Arial(max_needed_font_size) ; For using in a callback procedure define as global 
  For needed_font_size=1 To max_needed_font_size ; Get the fonts
    Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
  Next needed_font_size
  
  ; Create ButtonGadget 1 for using ==========================================
  Global ButtonGadget_1_x=310
  Global ButtonGadget_1_y=20
  Global ButtonGadget_1_width=300
  Global ButtonGadget_1_height=90
  Global ButtonGadget_1_text$="Resizable Window Demo"+#LF$+"This is a ButtonGadget"+#LF$+" - Resize the Window -"
  Global ButtonGadget_1_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, ButtonGadget_1_text$, #PB_Button_MultiLine)
  
  ; Create CanvasGadget 1 for using ==========================================
  Global CanvasGadget_1_x=60
  Global CanvasGadget_1_y=135
  Global CanvasGadget_1_width=800
  Global CanvasGadget_1_height=240
  
  Global CanvasGadget_1_ID=CanvasGadget(#PB_Any, 0, 0, window_width_developing, window_height_developing) ; Workaround Linux qt 5.72 crash with smaller values
  
  ; Create HyperlinkGadget 1 for using =======================================
  Global HyperlinkGadget_1_x=30
  Global HyperlinkGadget_1_y=90
  Global HyperlinkGadget_1_width=260
  Global HyperlinkGadget_1_height=25
  Global HyperlinkGadget_1_text$="This is a HyperlinkGadget"
  
  Global HyperlinkGadget_1_ID=HyperLinkGadget(#PB_Any, 0, 0, 0, 0, "", $FF0000, #PB_HyperLink_Underline)
  
  ; Create TextGadget 1 for using ============================================
  Global TextGadget_1_x=650
  Global TextGadget_1_y=95
  Global TextGadget_1_width=225
  Global TextGadget_1_height=30
  Global TextGadget_1_text$="This is a TextGadget"
  
  Global TextGadget_1_ID=TextGadget(#PB_Any, 0, 0, 0, 0, "")
  
  ; Create SpinGadget 1 for using ============================================
  Global SpinGadget_1_x=650
  Global SpinGadget_1_y=20
  Global SpinGadget_1_width=225
  Global SpinGadget_1_height=25
  Global SpinGadget_1_Text$="This is a SpinGadget"
  
  Global SpinGadget_1_ID=SpinGadget(#PB_Any, 0, 0, 0, 0, 0, 100)
  
  ; Create StringGadget 1 for using ==========================================
  Global StringGadget_1_x=30
  Global StringGadget_1_y=20
  Global StringGadget_1_width=225
  Global StringGadget_1_height=25
  Global StringGadget_1_Text$="This is a StringGadget"
  Global StringGadget_2_Text$="With enhanced text fitting"
  
  Global StringGadget_1_ID=StringGadget(#PB_Any, 0, 0, 0, 0, StringGadget_1_Text$)
  
  ; Create a background ======================================================
  Define path$="./Image_Set/stone_1.jpg"
  Global texture_ID=LoadImage(#PB_Any, path$)
  
  ; ==========================================================================
  
  ; ############## Resize procedure for callback ##############################
  Procedure WindowResizing_BindEvent_CreateGUI_1()
    
    ; ============= Init the scaling variables ==============
    Global set_x.d=100/window_width_developing*WindowWidth(window_ID)/100
    Global set_y.d=100/window_height_developing*WindowHeight(window_ID)/100
    
    ; Resize ButtonGadget 1 ===================================================
    FitGadgetText_BF(ButtonGadget_1_ID,
                     Font_Arial(),
                     ButtonGadget_1_x*set_x,
                     ButtonGadget_1_y*set_y,
                     ButtonGadget_1_width*set_x,
                     ButtonGadget_1_height*set_y,
                     30, ; Padding x
                     10, ; Padding y
                     1)  ; resize_factor.f
    
    ; Resize CanvasGadget 1 and output fitted text  ===========================
    
    ResizeGadget(CanvasGadget_1_ID,
                 CanvasGadget_1_x*set_x,
                 CanvasGadget_1_y*set_y,
                 CanvasGadget_1_width*set_x,
                 CanvasGadget_1_height*set_y)
    
    If StartDrawing(CanvasOutput(CanvasGadget_1_ID))
      Box(0, 0, CanvasGadget_1_width*set_x*DPI_ResizeFactor_BF(), CanvasGadget_1_height*set_y*DPI_ResizeFactor_BF(), #Yellow)
      StopDrawing()
    EndIf
    
    Define text$="A new GFX_Wizzard_BF function"+#LF$+
                 "Magic_StretchText_Pro_BF"+#LF$+
                 "Headline mode"+#LF$+
                 "Stepless free scalable"+#LF$+
                 "Exactly fitted free text"+#LF$+
                 "A new level of text output"+#LF$+
                 "Created by Saki"+#LF$+
                 "Unproportional output demo"
    
    ; The text is output without disturbing borders and can even be output separately proportional or unproportional in the x and y axis
    ; Padding can be used and the text can be moved anywhere in the output rectangle
    
    Define x_pos=0
    Define y_pos=0
    ; Define text_width.d=CanvasGadget_1_width/2  ; Text width  - So you get proportional x fitted text
    ; Define text_height.d=CanvasGadget_1_height  ; Text height - So you get proportional y fitted text
    
    Define text_width.d=CanvasGadget_1_width*set_x   ; Text width  - So you get non propotrtional x fitted text
    Define text_height.d=CanvasGadget_1_height*set_y ; Text height - So you get non propotrtional y fitted text
    
    Define fitted_text_width.d=CanvasGadget_1_width*set_x   ; Fitted text width  - Negative values available
    Define fitted_text_height.d=CanvasGadget_1_height*set_y ; Fitted text height - Negative values available
    
    ; Define text_width.d=GadgetWidth(CanvasGadget_1_ID)   ; Or so as sample - Non proportional output
    ; Define text_height.d=GadgetHeight(CanvasGadget_1_ID)
    ; Define fitted_text_width.d=text_width.d, fitted_text_height.d=text_height.d 
    
    Define text_color=#Blue     ; Accept alpha channel
    Define background_color=-1  ; Accept alpha channel - For invisible background set to -1
    Define text_stretching_x=3  ; Headline mode x stretching
    Define text_stretching_y=6  ; Headline mode y stretching
    Define padding_x.d=40       ; Padding x - Negative values available
    Define padding_y.d=40       ; Padding y - Negative values available
    
    Define flag=1 ; Text center=1 - Text right=2 - Text vertical=3
    Define mode=0 ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
    
    ; Rotate MagicStretchText - This force also a left adjusted output
    ; This function works sprite based
    ; -The sprite mask is black, don't use black less than $04 as border colors
    Define activate_rotating_stretchtext=0
    Define degree_stretchtext=15
    RotateMagic_Stretchtext(activate_rotating_stretchtext, degree_stretchtext) ; Activate rotating stretchtext
    
    ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
    Define frame_size_stretchtext=5
    Define frame_padding_stretchtext=2
    Define frame_rounding_stretchtext=8
    Define frame_color_stretchtext=$AAAAAAAA
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)
    
    ; For output as image use a output function with alpha channel support or you see nothing
    ; With the function "ActivateScreenOutput_BF" you can activate the screen output
    ; Fitted_text_width and fitted_text_height different text_width and text_height is needed
    ; -for dynamic GUI, but also for moving or adjust the text inside the output rectangle
    Magic_StretchText_Pro_BF(CanvasGadget_1_ID,           ; All channels supported
                             text$,                       ; Text
                             x_pos*DPI_ResizeFactor_BF(), ; Output x pos
                             y_pos*DPI_ResizeFactor_BF(), ; Output y pos
                             text_width,                  ; Text width
                             text_height,                 ; Text height
                             fitted_text_width,           ; Fitted text width
                             fitted_text_height,          ; fitted text height
                             text_color,                  ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                             background_color,            ; Alpha channel available - For invisible background set to -1
                             text_stretching_x,           ; Text stretching x - Headline mode
                             text_stretching_y,           ; Text stretching y - Headline mode
                             padding_x.d,                 ; Padding x - This is a virtual padding for resizing and boxed output
                             padding_y.d,                 ; Padding y - This is a virtual padding for resizing and boxed output
                             flag,                        ; Text center=1 - Text right=2 - Text vertical=3
                             mode,                        ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Georgia",                   ; Font type - more is not needed - accept also ""
                             #PB_Font_Bold)               ; Font style 
    
    ; Add a background on demand
    ; ErrorCheck_BF(BucketFill_BF(-200, CanvasGadget_1_ID, texture_ID)) ; Full size output, not more settings needed
    
    ; Resize HyperlinkGadget 1 ================================================
    SetGadgetText_BF(HyperlinkGadget_1_ID,
                     Font_Arial(),
                     HyperlinkGadget_1_x*set_x,
                     HyperlinkGadget_1_y*set_y,
                     HyperlinkGadget_1_width*set_x,
                     HyperlinkGadget_1_height*set_y,
                     HyperlinkGadget_1_text$,
                     0,   ; Padding x
                     5,   ; Padding y
                     1.2) ; resize_factor.f
    
    ; Resize TextGadget 1 =====================================================
    SetGadgetText_BF(TextGadget_1_ID,
                     Font_Arial(),
                     TextGadget_1_x*set_x,
                     TextGadget_1_y*set_y,
                     TextGadget_1_width*set_x,
                     TextGadget_1_height*set_y,
                     TextGadget_1_text$,
                     0,   ; Padding x
                     10,  ; Padding y
                     1.2) ; resize_factor.f
    
    ; Resize SpinGadget 1 =====================================================
    SetGadgetText_BF(SpinGadget_1_ID,
                     Font_Arial(),
                     SpinGadget_1_x*set_x,
                     SpinGadget_1_y*set_y,
                     SpinGadget_1_width*set_x,
                     SpinGadget_1_height*set_y,
                     SpinGadget_1_Text$,
                     20,  ; Padding x
                     5,   ; Padding y
                     1.2) ; resize_factor.f
    
    ; Resize StringGadget 1 ===================================================
    SetGadgetText_BF(StringGadget_1_ID,
                     Font_Arial(),
                     StringGadget_1_x*set_x,
                     StringGadget_1_y*set_y,
                     StringGadget_1_width*set_x,
                     StringGadget_1_height*set_y,
                     StringGadget_1_Text$,
                     5,   ; Padding x
                     5,   ; Padding y
                     1.2) ; resize_factor.f
    
    ; =========================================================================
    
    ; The Set...BF functions returns the determined font size so that it can easily be inherit on to other gadgets
    ; This is also possible on gadgets of other sizes - Sample : alterable_size=calculated_font_size/my_resize_factor
    
    ; As you can see above, the Set...BF functions can not only set the text, but also reposition and resize the gadgets
    
    ; You can also check the actual padding on demand - Call this functions after a monitored Set...BF function  
    ; Debug "canvas Custom Gadget - Padding X : "+Str(Get_Fitted_Font_Padding_X_BF())
    ; Debug "canvas Custom Gadget - Padding Y: "+Str(Get_Fitted_Font_Padding_Y_BF())
    
  EndProcedure
  
  ; ===========================================================================
  
  Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
    
    ; =============== Calculate the output position and size =================
    Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
    window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
    If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
      Else : window_x*DPI_ResizeFactor_BF() : EndIf
    If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
      Else : window_y*DPI_ResizeFactor_BF() : EndIf
    ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
    
    ; ================= Init the resize procedure callback ======================
    BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
    
    ; ====== Init all gadgets - Call simple the resize callback procedure =======
    Macro Refresh_all_Gadgets ; Refresh the gadgets
      Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
      WindowResizing_BindEvent_CreateGUI_1()
      Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
    EndMacro
    
    ; ============================= Show the result =============================
    
    Deactivate_DPI_ResizeFactor_BF(0)
    Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
    
    Refresh_all_Gadgets
    
    HideWindow(window_ID, 0)
    
    Repeat
      Define win_event=WaitWindowEvent()
    Until win_event=#PB_Event_CloseWindow
    
  EndProcedure
  
EndModule
UseModule CreateGUI_1

CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 900, 550) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 179
; FirstLine = 173
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger