﻿
; ************** Dynamic Window / GUI creating module ***************

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

DeclareModule CreateGUI_1
  EnableExplicit
  UseModule GFX_Wizzard_BF
  Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
EndDeclareModule

Module CreateGUI_1
  
  Global window_width_developing=920 ; Developing size
  Global window_height_developing=400
  
  Global window_min_width=200 ; Minimum window size
  Global window_min_height=150
  
  Global window_x, window_y, window_width_output, window_height_output
  Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
  Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                              "Dynamic Window and GUI creating", Window_flags)
  WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
  Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
  
  ; Create ButtonImageGadget 1 for using ==========================================
  Global ButtonImageGadget_1_width=600
  Global ButtonImageGadget_1_height=170
  Global ButtonImageGadget_1_x=WindowWidth(window_ID)/2-ButtonImageGadget_1_width/2
  Global ButtonImageGadget_1_y=WindowHeight(window_ID)/2-ButtonImageGadget_1_height/2
  Global ButtonImageGadget_1_ID=ButtonImageGadget(#PB_Any, 0, 0, 10, 10, 0)
  
  ; Create ButtonImageGadget 2 for using ==========================================
  Global ButtonImageGadget_2_x=10
  Global ButtonImageGadget_2_y=10
  Global ButtonImageGadget_2_width=200
  Global ButtonImageGadget_2_height=60
  Global ButtonImageGadget_2_ID=ButtonImageGadget(#PB_Any, 0, 0, 10, 10, 0)
  
  ; Create ButtonImageGadget 3 for using ==========================================
  Global ButtonImageGadget_3_x=708
  Global ButtonImageGadget_3_y=10
  Global ButtonImageGadget_3_width=200
  Global ButtonImageGadget_3_height=60
  Global ButtonImageGadget_3_ID=ButtonImageGadget(#PB_Any, 0, 0, 10, 10, 0)
  
  ; ==========================================================================
  
  ; ############## Resize procedure for callback ##############################
  Procedure WindowResizing_BindEvent_CreateGUI_1()
    
    ; ============= Init the scaling variables ==============
    Global set_x.d=100/window_width_developing*WindowWidth(window_ID)/100
    Global set_y.d=100/window_height_developing*WindowHeight(window_ID)/100
    
    ResizeGadget(ButtonImageGadget_1_ID,
                 ButtonImageGadget_1_x*set_x,
                 ButtonImageGadget_1_y*set_y,
                 ButtonImageGadget_1_width*set_x,
                 ButtonImageGadget_1_height*set_y)
    
    ResizeGadget(ButtonImageGadget_2_ID,
                 ButtonImageGadget_2_x*set_x,
                 ButtonImageGadget_2_y*set_y,
                 ButtonImageGadget_2_width*set_x,
                 ButtonImageGadget_2_height*set_y)
    
    ResizeGadget(ButtonImageGadget_3_ID,
                 ButtonImageGadget_3_x*set_x-Get_gtk3_button_x_offset_BF()*1.5,
                 ButtonImageGadget_3_y*set_y,
                 ButtonImageGadget_3_width*set_x,
                 ButtonImageGadget_3_height*set_y)
    
    ; The text is output without disturbing borders and can even be output separately proportional or unproportional in the x and y axis
    ; Padding can be used and the text can be moved anywhere in the output rectangle
    
    Define text_width.d=ButtonImageGadget_1_width/1.35 ; Text width
    Define text_height.d=ButtonImageGadget_1_height    ; Text height
    
    Define fitted_text_width.d=ButtonImageGadget_1_width*set_x   ; Fitted text width  - Negative values available
    Define fitted_text_height.d=ButtonImageGadget_1_height*set_y ; Fitted text height - Negative values available
    
    Global temp_image_1_ID : FreeImage_BF(temp_image_1_ID)
    temp_image_1_ID=CreateImage(#PB_Any,
                                ButtonImageGadget_1_width*DPI_ResizeFactor_BF()*set_x,
                                ButtonImageGadget_1_height*DPI_ResizeFactor_BF()*set_y,
                                32,
                                #PB_Image_Transparent)
    
    Define text_1$="GFX_Wizzard_BF"+#LF$+
                   "Create simple your own mighty functions"
    
    Magic_StretchText_Pro_BF(temp_image_1_ID,               ; All channels supported
                             text_1$,                       ; Text
                             0*DPI_ResizeFactor_BF()*set_x, ; Output x pos
                             0*DPI_ResizeFactor_BF()*set_y, ; Output y pos
                             text_width*1.2,                ; Text width
                             text_height/2,                 ; Text height
                             fitted_text_width,             ; Fitted text width
                             fitted_text_height/2,          ; fitted text height
                             #Red,                          ; text_color - Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel 
                             -1,                            ; background_color - Alpha channel available - For invisible background set to -1
                             3,                             ; Text stretching x - Headline mode
                             0,                             ; Text stretching y - Headline mode
                             20,                            ; Padding x - This is a virtual padding for resizing and boxed output
                             0,                             ; Padding y - This is a virtual padding for resizing and boxed output
                             1,                             ; Text center=1 - Text right=2 - Text vertical=3
                             0,                             ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Georgia",                     ; Font type - more is not needed - accept also ""
                             #PB_Font_Bold)                 ; Font style
    
    Define text_2$="Resize the window"+#LF$+
                   "This is a ButtonImageGadget"+#LF$+
                   "Enhanced with Magic_StretchText_Pro_BF"+#LF$+
                   "A new level of text output"+#LF$+
                   "With incredible headline function"+#LF$+
                   "It's magic"
    
    Magic_StretchText_Pro_BF(temp_image_1_ID,                ; All channels supported
                             text_2$,                        ; Text
                             1*DPI_ResizeFactor_BF()*set_x,  ; Output x pos
                             82*DPI_ResizeFactor_BF()*set_y, ; Output y pos
                             text_width,                     ; Text width
                             text_height/2,                  ; Text height
                             fitted_text_width,              ; Fitted text width
                             fitted_text_height/2,           ; fitted text height
                             #Blue,                          ; text_color - Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                             -1,                             ; background_color - Alpha channel available - For invisible background set to -1
                             1,                              ; Text stretching x - Headline mode
                             2,                              ; Text stretching y - Headline mode
                             100*set_x,                      ; Padding x - This is a virtual padding for resizing and boxed output
                             1*set_x,                        ; Padding y - This is a virtual padding for resizing and boxed output
                             1,                              ; Text center=1 - Text right=2 - Text vertical=3
                             0,                              ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Arial",                        ; Font type - more is not needed - accept also ""
                             #PB_Font_Bold)                  ; Font style
    
    
    Define text_3$="New"+#LF$+
                   "mighty text tools"
    
    Magic_StretchText_Pro_BF(temp_image_1_ID,               ; All channels supported
                             text_3$,                       ; Text
                             5*DPI_ResizeFactor_BF()*set_x, ; Output x pos
                             5*DPI_ResizeFactor_BF()*set_y, ; Output y pos
                             text_width/5,                  ; Text width
                             text_height/5,                 ; Text height
                             fitted_text_width/5,           ; Fitted text width
                             fitted_text_height/5,          ; fitted text height
                             #Green,                        ; text_color - Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                             -1,                            ; background_color - Alpha channel available - For invisible background set to -1
                             0,                             ; Text stretching x - Headline mode
                             0,                             ; Text stretching y - Headline mode
                             0,                             ; Padding x - This is a virtual padding for resizing and boxed output
                             0,                             ; Padding y - This is a virtual padding for resizing and boxed output
                             0,                             ; Text center=1 - Text right=2 - Text vertical=3
                             0,                             ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Times New Roman",             ; Font type - more is not needed - accept also ""
                             0)                             ; Font style 
    
    Define text_4$="Created"+#LF$+
                   "by Tanaka Saki"
    
    Magic_StretchText_Pro_BF(temp_image_1_ID,                 ; All channels supported
                             text_4$,                         ; Text
                             475*DPI_ResizeFactor_BF()*set_x, ; Output x pos
                             5*DPI_ResizeFactor_BF()*set_y,   ; Output y pos
                             text_width/5,                    ; Text width
                             text_height/5,                   ; Text height
                             fitted_text_width/5,             ; Fitted text width
                             fitted_text_height/5,            ; fitted text height
                             #Green,                          ; text_color - Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                             -1,                              ; background_color - Alpha channel available - For invisible background set to -1
                             0,                               ; Text stretching x - Headline mode
                             0,                               ; Text stretching y - Headline mode
                             0,                               ; Padding x - This is a virtual padding for resizing and boxed output
                             0,                               ; Padding y - This is a virtual padding for resizing and boxed output
                             2,                               ; Text center=1 - Text right=2 - Text vertical=3
                             0,                               ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Times New Roman",               ; Font type - more is not needed - accept also ""
                             0)                               ; Font style 
    
    SetGadgetAttribute(ButtonImageGadget_1_ID, #PB_Button_Image, ImageID(temp_image_1_ID)) 
    
    ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
    Define frame_size_stretchtext=0
    Define frame_padding_stretchtext=5
    Define frame_rounding_stretchtext=0
    Define frame_color_stretchtext=$AAAAAAAA
    Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                    frame_padding_stretchtext,
                                    frame_rounding_stretchtext,
                                    frame_color_stretchtext)

    Global temp_image_2_ID : FreeImage_BF(temp_image_2_ID)
    temp_image_2_ID=CreateImage(#PB_Any,
                                ButtonImageGadget_2_width*DPI_ResizeFactor_BF()*set_x,
                                ButtonImageGadget_2_height*DPI_ResizeFactor_BF()*set_y,
                                32,
                                #PB_Image_Transparent)
    
    Define text_5$="GFX_Wizzard_BF"+#LF$+"Simple a little more"
    
    Magic_StretchText_Pro_BF(temp_image_2_ID,                  ; All channels supported
                             text_5$,                          ; Text
                             0,                                ; Output x pos
                             0,                                ; Output y pos
                             ButtonImageGadget_2_width,        ; Text width
                             ButtonImageGadget_2_height*1.2,   ; Text height
                             ButtonImageGadget_2_width*set_x,  ; Fitted text width
                             ButtonImageGadget_2_height*set_y, ; fitted text height
                             #Black,                           ; text_color - Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                             -1,                               ; background_color - Alpha channel available - For invisible background set to -1
                             2,                                ; Text stretching x - Headline mode
                             5,                                ; Text stretching y - Headline mode
                             4,                                ; Padding x - This is a virtual padding for resizing and boxed output
                             4,                                ; Padding y - This is a virtual padding for resizing and boxed output
                             1,                                ; Text center=1 - Text right=2 - Text vertical=3
                             0,                                ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Times New Roman",                ; Font type - more is not needed - accept also ""
                             #PB_Font_Bold)                    ; Font style 
    
    SetGadgetAttribute(ButtonImageGadget_2_ID, #PB_Button_Image, ImageID(temp_image_2_ID))
    
    
    Global temp_image_3_ID : FreeImage_BF(temp_image_3_ID)
    temp_image_3_ID=CreateImage(#PB_Any,
                                ButtonImageGadget_3_width*DPI_ResizeFactor_BF()*set_x,
                                ButtonImageGadget_3_height*DPI_ResizeFactor_BF()*set_y,
                                32,
                                #PB_Image_Transparent)
    
    Define text_6$="How are you"+#LF$+"It's cool man"
    
    Magic_StretchText_Pro_BF(temp_image_3_ID,                  ; All channels supported
                             text_6$,                          ; Text
                             0,                                ; Output x pos
                             0,                                ; Output y pos
                             ButtonImageGadget_3_width,        ; Text width
                             ButtonImageGadget_3_height*1.2,   ; Text height
                             ButtonImageGadget_3_width*set_x,  ; Fitted text width
                             ButtonImageGadget_3_height*set_y, ; fitted text height
                             #Red,                             ; text_color - Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                             -1,                               ; background_color - Alpha channel available - For invisible background set to -1
                             2,                                ; Text stretching x - Headline mode
                             5,                                ; Text stretching y - Headline mode
                             4,                                ; Padding x - This is a virtual padding for resizing and boxed output
                             4,                                ; Padding y - This is a virtual padding for resizing and boxed output
                             1,                                ; Text center=1 - Text right=2 - Text vertical=3
                             0,                                ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                             "Georgia",                        ; Font type - more is not needed - accept also ""
                             #PB_Font_Bold)                    ; Font style 
    
    SetGadgetAttribute(ButtonImageGadget_3_ID, #PB_Button_Image, ImageID(temp_image_3_ID))
    
  EndProcedure
  
  ; ===========================================================================
  
  Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
    
    ; =============== Calculate the output position and size =================
    Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
    window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
    If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
      Else : window_x*DPI_ResizeFactor_BF() : EndIf
    If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
      Else : window_y*DPI_ResizeFactor_BF() : EndIf
    ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
    
    ; ================= Init the resize procedure callback ======================
    BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
    
    ; ====== Init all gadgets - Call simple the resize callback procedure =======
    Macro Refresh_all_Gadgets ; Refresh the gadgets
      Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
      WindowResizing_BindEvent_CreateGUI_1()
      Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                  ; For using inside a callback procedure deactivate 
    EndMacro
    
    ; ============================= Show the result =============================
    
    Deactivate_DPI_ResizeFactor_BF(0)
    Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
    
    Refresh_all_Gadgets
    
    HideWindow(window_ID, 0)
    
    Repeat
      Define win_event=WaitWindowEvent()
    Until win_event=#PB_Event_CloseWindow
    
  EndProcedure
  
EndModule
UseModule CreateGUI_1

CompilerIf #PB_Compiler_IsMainFile 
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 900, 550) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 2 (Linux - x64)
; CursorPosition = 73
; FirstLine = 69
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger