﻿
; ************** Dynamic Window / GUI creating module ***************

CompilerIf #PB_Compiler_IsMainFile 
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  DeclareModule CreateGUI_1
    EnableExplicit
    UseModule GFX_Wizzard_BF
    Declare CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
  EndDeclareModule
  
  Module CreateGUI_1
    
    Global window_width_developing=920 ; Developing size
    Global window_height_developing=400
    
    Global window_min_width=450 ; Minimum window size
    Global window_min_height=200
    
    Global window_x, window_y, window_width_output, window_height_output
    Global window_flags=#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible 
    Global window_ID=OpenWindow(#PB_Any, 0, 0, window_width_developing, window_height_developing,
                                "Dynamic Window and GUI creating", Window_flags)
    WindowBounds(window_ID, window_min_width, window_min_height, #PB_Ignore, #PB_Ignore)
    Global get_all_window_events ; Auxiliary variable for callback procedure WindowEvent handling
    
    ; Create a font array
    ; Mostly 30pt > 40pt is enough - smaller is faster
    Global max_needed_font_size=40
    Global needed_font_size
    Global Dim Font_Georgia(max_needed_font_size)
    For needed_font_size=1 To max_needed_font_size ; Get the fonts
      Font_Georgia(needed_font_size)=LoadFont(#PB_Any, "Georgia", needed_font_size, #PB_Font_Bold)
    Next needed_font_size
    
    ; Create a font array
    ; Mostly 30pt > 40pt is enough - smaller is faster
    Global max_needed_font_size=40
    Global needed_font_size
    Global Dim Font_Arial(max_needed_font_size) ; For using in a callback procedure define as global 
    For needed_font_size=1 To max_needed_font_size ; Get the fonts
      Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
    Next needed_font_size
    
    ; Create ButtonGadget 1 for using ==========================================
    Global ButtonGadget_1_x=310
    Global ButtonGadget_1_y=20
    Global ButtonGadget_1_width=300
    Global ButtonGadget_1_height=90
    Global ButtonGadget_1_text$="Resizable Window Demo"+#LF$+"This is a ButtonGadget"+#LF$+" - Resize the Window -"
    Global ButtonGadget_1_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, ButtonGadget_1_text$, #PB_Button_MultiLine)
    
    ; Create ButtonGadget 2 for using ==========================================
    Global ButtonGadget_2_x=20
    Global ButtonGadget_2_y=135
    Global ButtonGadget_2_width=450
    Global ButtonGadget_2_height=240
    Global ButtonGadget_2_text$="Create Gadgets with automatically fitted Text"+#LF$+#LF$+
                                "GFX_Wizzard_BF enhanced"+#LF$+#LF$+
                                "For simple solving many Gadget Problems"+#LF$+#LF$+
                                "Try any Text"+#LF$+#LF$+
                                "Works with any Rectangles"+#LF$+
                                "and Gadgets with Font changing Feature"
    
    Global ButtonGadget_2_ID=ButtonGadget(#PB_Any, 0, 0, 0, 0, "", #PB_Button_MultiLine)
    
    ; Create CanvasGadget 1 for using ==========================================
    Global CanvasGadget_1_x=500
    Global CanvasGadget_1_y=135
    Global CanvasGadget_1_width=400
    Global CanvasGadget_1_height=240
    Global text_color=#Blue
    Global background_color=#Yellow
    Global Headline_mode_text_stretching_x=0
    Global Headline_mode_text_stretching_y=0
    Global flag=1 ; Text center=1 - Text right=2 - Text vertical=3
    Global mode=0 ; Revers text mode=1 - RTL text mode=2
    
    ; Create HyperlinkGadget 1 for using =======================================
    Global HyperlinkGadget_1_x=30
    Global HyperlinkGadget_1_y=90
    Global HyperlinkGadget_1_width=260
    Global HyperlinkGadget_1_height=25
    Global HyperlinkGadget_1_text$="This is a HyperlinkGadget"
    
    Global HyperlinkGadget_1_ID=HyperLinkGadget(#PB_Any, 0, 0, 0, 0, "", $FF0000, #PB_HyperLink_Underline)
    
    ; Create TextGadget 1 for using ============================================
    Global TextGadget_1_x=650
    Global TextGadget_1_y=95
    Global TextGadget_1_width=225
    Global TextGadget_1_height=30
    Global TextGadget_1_text$="This is a TextGadget"
    
    Global TextGadget_1_ID=TextGadget(#PB_Any, 0, 0, 0, 0, "")
    
    ; Create SpinGadget 1 for using ============================================
    Global SpinGadget_1_x=650
    Global SpinGadget_1_y=20
    Global SpinGadget_1_width=225
    Global SpinGadget_1_height=25
    Global SpinGadget_1_Text$="This is a SpinGadget"
    
    Global SpinGadget_1_ID=SpinGadget(#PB_Any, 0, 0, 0, 0, 0, 100)
    
    ; Create StringGadget 1 for using ==========================================
    Global StringGadget_1_x=30
    Global StringGadget_1_y=20
    Global StringGadget_1_width=225
    Global StringGadget_1_height=25
    Global StringGadget_1_Text$="This is a StringGadget"
    Global StringGadget_2_Text$="With enhanced text fitting"
    Global set_x.f=100/window_width_developing*WindowWidth(window_ID)/100
    Global set_y.f=100/window_height_developing*WindowHeight(window_ID)/100
    
    Global StringGadget_1_ID=StringGadget(#PB_Any, 0, 0, 0, 0, StringGadget_1_Text$)
    
    Global texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha5.png")
    
    ; This function deactivate the automatically text stretching for vector text based Gadgets_BF, as sample ToggleGadget_BF and StretchTextGadget_BF
    ; This is a mighty feature - you must activate again text stretching
    Deactivate_TextStretching_BF(1)
    
    Define text_gadget_1$="SEE THE DIFFERENCE"+#LF$+#LF$+#LF$+
                          "This is a advanced StretchTextGadget_BF"+#LF$+#LF$+
                          "Resize the Window"+#LF$+#LF$+
                          "This gadget smoothly changes any text size"+#LF$+#LF$+
                          "You must not load more or large fonts"+#LF$+#LF$+
                          "It's very fast"+#LF$+#LF$+
                          "Absolutely exact text adjustment"
    ; Set a x, y offset for FitImage..BF - You must deactivate again
    ; FitImage_Offset_BF(0, 00/set_y.f)
    SetTextFlagsStretchTextGadget_BF(#PB_VectorParagraph_Left)
    Global gadget_1_ID=StretchTextGadget_BF(text_gadget_1$, ; Pre define the Gadget
                                            0,              ; x pos
                                            0,              ; y pos
                                            0,              ; Width
                                            0,              ; Height
                                            0,              ; padding_x
                                            0 ,             ; padding_y
                                            #Blue,          ; text_color
                                            #Yellow,        ; back_color
                                            "Times New Roman",
                                            #PB_Font_Bold)
    
    ; Deactivate_TextStretching_BF(0) ; Activate text stretching again
    
    ; ==========================================================================
    
    ; ############## Resize procedure for callback ##############################
    Procedure WindowResizing_BindEvent_CreateGUI_1()
      
      ; ============= Init the scaling variables ==============
      set_x.f=100/window_width_developing*WindowWidth(window_ID)/100
      set_y.f=100/window_height_developing*WindowHeight(window_ID)/100
      
      ; Resize ButtonGadget 1 ===================================================
      FitGadgetText_BF(ButtonGadget_1_ID,
                       Font_Arial(),
                       ButtonGadget_1_x*set_x,
                       ButtonGadget_1_y*set_y,
                       ButtonGadget_1_width*set_x,
                       ButtonGadget_1_height*set_y,
                       30, ; Padding x
                       10, ; Padding y
                       1)  ; resize_factor.f
      
      ; Resize ButtonGadget 2 ===================================================
      SetGadgetText_BF(ButtonGadget_2_ID,
                       Font_Arial(),
                       ButtonGadget_2_x*set_x,
                       ButtonGadget_2_y*set_y,
                       ButtonGadget_2_width*set_x,
                       ButtonGadget_2_height*set_y,
                       ButtonGadget_2_text$,
                       WindowWidth(window_ID)*DPI_ResizeFactor_BF()/20,  ; Padding x
                       WindowHeight(window_ID)*DPI_ResizeFactor_BF()/30, ; Padding y
                       1)                                                ; resize_factor.f
      
      ; Resize StretchTextGadget 1 and output fitted text  ===========================
      SetStretchTextGadget_BF(gadget_1_ID,
                              "", 
                              CanvasGadget_1_x*set_x-Get_gtk3_button_x_offset_BF(),
                              CanvasGadget_1_y*set_y,
                              CanvasGadget_1_width*set_x,
                              CanvasGadget_1_height*set_y,
                              GadgetWidth(gadget_1_ID)/10*DPI_ResizeFactor_BF(),
                              GadgetWidth(gadget_1_ID)/10*DPI_ResizeFactor_BF())
      
      ; Fit a source rectangle proportional in to a destination rectangle
      ; You can use for proportional resizing with many BF functions
      ; This raw base function is not needed and created for smaller images as the fitted output, you must handle this and skip the function for smaller images
      GetFitSize_BF(ImageWidth(texture_1_ID), ImageHeight(texture_1_ID), 80*set_x.f*DPI_ResizeFactor_BF(), 85*set_y.f*DPI_ResizeFactor_BF())
      ; GetFitOffset_X_BF() ; Give back the x offset for the fitted output
      ; GetFitOffset_Y_BF() ; Give back the y offset for the fitted output
      ; GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
      ; GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output  
      
      ErrorCheck_BF(AlphaChannelSprite_Pro_BF(GetGadgetImage_BF(gadget_1_ID), texture_1_ID, ; Sprite BF output
                                              -3*set_x.f*DPI_ResizeFactor_BF(),
                                              -3*set_y.f*DPI_ResizeFactor_BF(),
                                              0, ; Endposition texture output  x - Preset 0 = Clipping is automatic to input width
                                              0, ; Endposition texture output  y - Preset 0 = Clipping is automatic to input height
                                              GetFitSize_Width_BF(),  ; You can here resize the output x
                                              GetFitSize_Height_BF())); You can here resize the output y
      SetGadgetAttribute(gadget_1_ID, #PB_Button_Image, ImageID(GetGadgetImage_BF(gadget_1_ID)))
      
      ; Resize HyperlinkGadget 1 ================================================
      SetGadgetText_BF(HyperlinkGadget_1_ID,
                       Font_Arial(),
                       HyperlinkGadget_1_x*set_x,
                       HyperlinkGadget_1_y*set_y,
                       HyperlinkGadget_1_width*set_x,
                       HyperlinkGadget_1_height*set_y,
                       HyperlinkGadget_1_text$,
                       0,   ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize TextGadget 1 =====================================================
      SetGadgetText_BF(TextGadget_1_ID,
                       Font_Arial(),
                       TextGadget_1_x*set_x,
                       TextGadget_1_y*set_y,
                       TextGadget_1_width*set_x,
                       TextGadget_1_height*set_y,
                       TextGadget_1_text$,
                       0,   ; Padding x
                       10,  ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize SpinGadget 1 =====================================================
      SetGadgetText_BF(SpinGadget_1_ID,
                       Font_Arial(),
                       SpinGadget_1_x*set_x,
                       SpinGadget_1_y*set_y,
                       SpinGadget_1_width*set_x,
                       SpinGadget_1_height*set_y,
                       SpinGadget_1_Text$,
                       20,  ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; Resize StringGadget 1 ===================================================
      SetGadgetText_BF(StringGadget_1_ID,
                       Font_Arial(),
                       StringGadget_1_x*set_x,
                       StringGadget_1_y*set_y,
                       StringGadget_1_width*set_x,
                       StringGadget_1_height*set_y,
                       StringGadget_1_Text$,
                       5,   ; Padding x
                       5,   ; Padding y
                       1.2) ; resize_factor.f
      
      ; =========================================================================
      
      ; The Set...BF functions returns the determined font size so that it can easily be inherit on to other gadgets
      ; This is also possible on gadgets of other sizes - Sample : alterable_size=calculated_font_size/my_resize_factor
      
      ; As you can see above, the Set...BF functions can not only set the text, but also reposition and resize the gadgets
      
      ; You can also check the actual padding on demand - Call this functions after a monitored Set...BF function  
      ; Debug "canvas Custom Gadget - Padding X : "+Str(Get_Fitted_Font_Padding_X_BF())
      ; Debug "canvas Custom Gadget - Padding Y: "+Str(Get_Fitted_Font_Padding_Y_BF())
      
    EndProcedure
    
    ; ===========================================================================
    
    Procedure CreateGUI_1(window_x, window_y, window_width_output, window_height_output)
      
      ; =============== Calculate the output position and size =================
      Deactivate_DPI_ResizeFactor_BF(1) ; We use here the DPI aware compiler option
      window_width_output*DPI_ResizeFactor_BF() : window_height_output*DPI_ResizeFactor_BF()
      If window_x=-1 : window_x=WindowX(window_ID)-(window_width_output-WindowWidth(window_ID))/2
        Else : window_x*DPI_ResizeFactor_BF() : EndIf
      If window_y=-1 : window_y=WindowY(window_ID)-(window_height_output-WindowHeight(window_ID))/2
        Else : window_y*DPI_ResizeFactor_BF() : EndIf
      ResizeWindow(window_ID, window_x, window_y, window_width_output, window_height_output)
      
      ; ================= Init the resize procedure callback ======================
      BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_CreateGUI_1())
      
      ; ====== Init all gadgets - Call simple the resize callback procedure =======
      Macro Refresh_all_Gadgets ; Refresh the gadgets
        Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                    ; For using inside a callback procedure deactivate 
        WindowResizing_BindEvent_CreateGUI_1()
        Get_all_Window_Events_BF(0) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                                    ; For using inside a callback procedure deactivate 
      EndMacro
      
      ; ============================= Show the result =============================
      
      Deactivate_DPI_ResizeFactor_BF(0)
      Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option 
      
      Refresh_all_Gadgets
      
      HideWindow(window_ID, 0)
      
      Repeat
        Define win_event=WaitWindowEvent()
      Until win_event=#PB_Event_CloseWindow
      
    EndProcedure
    
  EndModule
  UseModule CreateGUI_1
  
  ; ========================== Run the module, ====================================
  ; Debug DPI_ResizeFactor_BF() ; Get the actual DPI resize factor  
  ; Deactivate_DPI_ResizeFactor_BF(1) ; This function deactivate the DPI aware feature 
  CreateGUI_1(-1, -1, 950, 550) ; x, y, width, height - x=-1 center the output x - y=-1 center the output y
  
CompilerEndIf
; IDE Options = PureBasic 5.73 beta 2 (Linux - x64)
; CursorPosition = 177
; FirstLine = 155
; Folding = --
; EnableXP
; DPIAware
; Executable = __test.exe
; DisableDebugger