﻿
; FontWizzard_BF
DeclareModule FontWizzard_BF
  EnableExplicit
  
  ; This function converts TextImages_FW to images with transparent background - You must deactivate again
  ; Use this for creating TextImages_FW with transparent background and GradientColors
  ; The function make a defined color invisible
  Declare CreateMaskedAlphaImage_FW(CreateMaskedAlphaImage_FW_=0, MaskColor_FW_=0)
  
  Declare GetTextWidth_FW(text$, font_ID=-1)  ; Get text width - Multiline supported
  
  Declare GetTextHeight_FW(text$, font_ID=-1) ; Get text height - Multiline supported
  
  Declare GetTextLineHeight_BF(font_ID=-1) ; Get text line height
  
  Declare GetTextLinesAmount_BF(text$) ; Get amount text lines
  
  Declare GetMaxLineChars_FW(text$) ; Number of characters of the longest line
  
  Declare Calculate_fitted_Font_FW(text$,
                                   width_rectangle,
                                   height_rectangle,
                                   font$,
                                   font_flag,
                                   padding_x=0,
                                   padding_y=0,
                                   resize_factor.f=1)
  
  Declare SetGadgetText_FW(gadget_ID, 
                           Font$, ; The necessary fonts are managed automatically
                           font_flag,
                           text$=" ",
                           padding_x=0,
                           padding_y=0,
                           resize_factor.f=1)
  
  Declare SetGadget_FW(gadget_ID, 
                       Font$, ; The necessary fonts are managed automatically
                       font_flag,
                       output_x,
                       output_y,
                       gadget_width,
                       gadget_height,
                       text$=" ",
                       padding_x=0,
                       padding_y=0,
                       resize_factor.f=1)
  
  Declare SetImageBasedGadgetText_FW(gadget_ID,           ; Works at the same with CanvasGadget, ImageGadget, ButtonImageGadget
                                     Font$,               ; The necessary fonts are managed automatically
                                     font_flag,
                                     text_color=#Black,   ; Alpha channel sensitive - Sample $8000FFFF
                                     text_adjustment=0,   ; Text adjustment - 0=center - 1=left - 2=right
                                     background_color=-1, ; Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                     text$=" ",
                                     padding_x=0,
                                     padding_y=0,
                                     resize_factor.f=1)
  
  Declare SetImageBasedGadget_FW(gadget_ID,           ; Works at the same with CanvasGadget, ImageGadget, ButtonImageGadget
                                 Font$,               ; The necessary fonts are managed automatically
                                 font_flag,
                                 output_x,
                                 output_y,
                                 gadget_width,
                                 gadget_height,
                                 text_color=#Black,   ; Alpha channel sensitive - Sample $8000FFFF
                                 text_adjustment=0,   ; Text adjustment - 0=center - 1=left - 2=right
                                 background_color=-1, ; Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                 text$=" ",
                                 padding_x=0,
                                 padding_y=0,
                                 resize_factor.f=1)
  
  Declare ImageBasedGadget_FW(gadget_Typ, ; 0 = ButtonImageGadget - 1 = ImageGadget - 2 = CanvasGadget 
                              Font$,      ; The necessary fonts are managed automatically
                              font_flag,
                              output_x,
                              output_y,
                              gadget_width,
                              gadget_height,
                              text_color=#Black,
                              text_adjustment=0,
                              background_color=-1,
                              text$=" ",
                              padding_x=0,
                              padding_y=0,
                              resize_factor.f=1,
                              gadget_frame_flag=0)
  
  ; Get the actual output position X
  Declare GetCursor_X_FW()
  
  ; Get the actual output position Y
  Declare GetCursor_Y_FW()
  
  ; Set the actual output position X
  Declare SetCursor_X_FW(GetCursor_X_FW_)
  
  ; Set the actual output position Y
  Declare SetCursor_Y_FW(GetCursor_Y_FW_)
  
  ; Adjust the text cursor position X inside the output rectangle - You must deactivate again
  Declare SetOffsetCursor_X_FW(OffsetCursor_X_FW_)
  
  ; Adjust the text cursor position Y inside the output rectangle - You must deactivate again
  Declare SetOffsetCursor_Y_FW(OffsetCursor_Y_FW_)
  
  ; Insert an image into the ImageBasedGadget - You must deactivate again
  ; To deactivate simply set the image ID to -1 - Or use it so AddImage...()
  Declare AddImage_1_FW(Image_1_ID_FW_=-1,
                        Image_1_x_FW_=0,
                        Image_1_y_FW_=0,
                        Image_1_width_FW_=0,
                        Image_1_height_FW_=0,
                        Image_1_alpha_FW_=255)
  
  ; Insert an image into the ImageBasedGadget - You must deactivate again
  ; To deactivate simply set the image ID to -1 - Or use it so AddImage...()
  Declare AddImage_2_FW(Image_2_ID_FW_=-1,
                        Image_2_x_FW_=0,
                        Image_2_y_FW_=0,
                        Image_2_width_FW_=0,
                        Image_2_height_FW_=0,
                        Image_2_alpha_FW_=255)
  
  ; Insert an image into the ImageBasedGadget - You must deactivate again
  ; To deactivate simply set the image ID to -1 - Or use it so AddImage...()
  Declare AddImage_3_FW(Image_3_ID_FW_=-1,
                        Image_3_x_FW_=0,
                        Image_3_y_FW_=0,
                        Image_3_width_FW_=0,
                        Image_3_height_FW_=0,
                        Image_3_alpha_FW_=255)
  
  ; Add a frame to all outputs - Padding is automatically adjusted - Alpha channel sensitive - Sample $8000FFFF
  ; To deactivate simply set it so AddFrame...()
  Declare AddFrame_FW(AddFrame_Size_FW_=0, AddFrame_Color_FW_=0, AddFrame_Rounding_FW_=0)
  
  ; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
  ; To deactivate simply set it so AddFrame...()
  Declare AddSubFrame_1_FW(AddSubFrame_1_X_FW_=0,
                           AddSubFrame_1_Y_FW_=0,
                           AddSubFrame_1_Width_FW_=0,
                           AddSubFrame_1_Height_FW_=0,
                           AddSubFrame_1_Size_FW_=0, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                           AddSubFrame_1_Color_FW_=0,
                           AddSubFrame_1_Rounding_FW_=0)
  
  ; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
  ; To deactivate simply set it so AddFrame...()
  Declare AddSubFrame_2_FW(AddSubFrame_2_X_FW_=0,
                           AddSubFrame_2_Y_FW_=0,
                           AddSubFrame_2_Width_FW_=0,
                           AddSubFrame_2_Height_FW_=0,
                           AddSubFrame_2_Size_FW_=0, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                           AddSubFrame_2_Color_FW_=0,
                           AddSubFrame_2_Rounding_FW_=0)
  
  ; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
  ; To deactivate simply set it so AddFrame...()
  Declare AddSubFrame_3_FW(AddSubFrame_3_X_FW_=0,
                           AddSubFrame_3_Y_FW_=0,
                           AddSubFrame_3_Width_FW_=0,
                           AddSubFrame_3_Height_FW_=0,
                           AddSubFrame_3_Size_FW_=0, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                           AddSubFrame_3_Color_FW_=0,
                           AddSubFrame_3_Rounding_FW_=0)
  
  ; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
  ; To deactivate simply set it so AddFrame...()
  Declare AddSubFrame_4_FW(AddSubFrame_4_X_FW_=0,
                           AddSubFrame_4_Y_FW_=0,
                           AddSubFrame_4_Width_FW_=0,
                           AddSubFrame_4_Height_FW_=0,
                           AddSubFrame_4_Size_FW_=0, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                           AddSubFrame_4_Color_FW_=0,
                           AddSubFrame_4_Rounding_FW_=0)
  
  ; Activate screen output for DrawText_FW - You must deactivate again
  Declare ActivateScreenOutput_FW(Screen_Output_FW_=0)
  
  Declare OpenGLGadgetFlipBuffers_FW(gadget_ID) ; Flip Buffers OpenGLGadget
  
  Declare SetColorOpenGLGadget_FW(background_color) ; OpenGLGadget color
  
  ; You can also add images to the text output
  ; - The image size is not limited and can be larger than the text and the background
  Declare DrawText_FW(output_ID,
                      Font$,
                      font_flag,
                      output_x,
                      output_y,
                      output_width,
                      output_height,
                      text_color=#Black,
                      text_adjustment=0,
                      background_color=-1,
                      text$=" ",
                      padding_x=0,
                      padding_y=0,
                      resize_factor.f=1)
  
  ; Get the actual used font size of an output
  Declare GetUsedFontsize_FW()
  
  ; Adjust the DrawText_FW output rectangle and its content
  ; 0 Sets the output centered
  ; 1 Sets the output left
  ; 2 Sets the cursor position before the output and makes the output to the right
  ; 3 Sets the cursor position behind the output and makes the output to the left
  Declare AdjustText_FW(AdjustText_FW_=0)
  
  ; Get the AdjustText_FW state
  Declare GetAdjustTextState_FW()
  
  ; Output directly on a OpenGLGadget
  Declare DrawGLTextImage_FW(gadget_ID,           ; Gadget ID
                             font$,               ; Font
                             font_flag,           ; Font flag
                             output_x,            ; Output x
                             output_y,            ; Output y
                             output_width,        ; Output width
                             output_height,       ; Output height
                             text_color=#White,   ; Text color - Alpha channel sensitive
                             text_adjustment=1,   ; Text adjustment - 0=center - 1=left - 2=right
                             background_color=-1, ; Background color - Alpha channel sensitive
                             text$="",            ; Text
                             padding_x=0,         ; Padding x
                             padding_y=0,         ; Padding y
                             resize_factor.f=1.0) ; Resize factor - float
  
  ; This function create a text image for post processing and output on all channels 
  Declare CreateTextImage_FW(font$,               ; Font
                             font_flag,           ; Font flag
                             output_width,        ; Output width
                             output_height,       ; Output height
                             text_color=#White,   ; Text color - Alpha channel sensitive
                             text_adjustment=1,   ; Text adjustment - 0=center - 1=left - 2=right
                             background_color=-1, ; Background color - Alpha channel sensitive
                             text$="",            ; Text
                             padding_x=0,         ; Padding x
                             padding_y=0,         ; Padding y
                             resize_factor.f=1.0) ; Resize factor - float
  
  ; This function create a PB text sprite for output on screen
  Declare CreateTextSprite_FW(modus,               ; #PB_Sprite_PixelCollision - #PB_Sprite_AlphaBlending
                              font$,               ; Font
                              font_flag,           ; Font flag
                              output_width,        ; Output width
                              output_height,       ; Output height
                              text_color=#White,   ; Text color - Alpha channel sensitive
                              text_adjustment=1,   ; Text adjustment - 0=center - 1=left - 2=right
                              background_color=-1, ; Background color
                              text$="",            ; Text
                              padding_x=0,         ; Padding x
                              padding_y=0,         ; Padding y
                              resize_factor.f=1.0) ; Resize factor - float
  
  ; Headletter mode for any text output - You must daactivate again
  Declare TextStretching_FW(Stretch_X_FW_=0, Stretch_Y_FW_=0)
  
  ; Back Color for GradientColor
  Declare BackColor_FW(BackColor_FW_)
  
  ; Output pos (0.0 to 1.0) for GradientColor and defined color
  Declare GradientColor_Pos_FW(GradientColor_Pos_FW_.f, Gradient_Pos_Color_FW_)
  
  ; Front Color for GradientColor
  Declare FrontColor_FW(FrontColor_FW_)
  
  ; Linear Gradient
  Declare LinearGradient_FW(ActivateLinearGradient_FW_=0,
                            LinearGradient_X_FW_=0,
                            LinearGradient_Y_FW_=0,
                            LinearGradient_XX_FW_=0,
                            LinearGradient_YY_FW_=0)
  
  ; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
  Declare TextColor_Line_FW(Line_FW_=0, LineColor_FW_=-1)
  
  ; Remove all defined Text line colors
  Declare ResetTextColor_Lines_FW()
  
  ; Add a ProgressBar -  You must deactivate again - Simple so ProgressBar_FW()
  Declare ProgressBar_FW(x=0,
                         y=0,
                         width.f=0,
                         height.f=0,
                         min=0,
                         max=0,
                         state=0,
                         foreground_color=#Green,
                         background_color=$BBBBBB,
                         alpha=0,
                         flag=0) ; 1 = vertical
  
  Declare PresetFontsize_FW(PresetFontsize_FW_=0) ; Preset a fontsize - You must deactivate again
  
  Declare PresetMinFontsize_FW(PresetMinFontsize_FW_=0) ; Set the smallest font size - You must deactivate again
  
  Declare PresetMaxFontsize_FW(PresetMaxFontsize_FW_=0) ; Sets the largest font size - You must deactivate again
  
  Declare FreeGadget_FW(gadget_ID) ; Free the actual used gadget_FW, font and cached image for this gadget
                                   ; Only recommended when the font is no longer needed
  
  ; Auto free accessories after output
  Declare ActivateAutoFree_FW(AutoFree_FW_=0)
  
  Declare FreeAllGadgets_FW(mode=0) ; Free all Gadgets_FW, fonts and cached images used - Presetted
                                    ; Only recommended when the fonts is no longer needed
                                    ; mode=1 returns the number of fonts created by the tool
                                    ; Otherwise the function returns the number of deleted fonts
  
  Declare GetGadgetImage_FW(gadget_ID) ; For Gadgets_FW only - Fail results -1
  
  Declare.s GetGadgetText_FW(gadget_ID) ; For Gadgets - Fail results ""
  
  Declare GetGadgetTextColor_FW(gadget_ID) ; For Gadgets_FW only - Fail results -1
  
  Declare GetGadgetBackgroundColor_FW(gadget_ID) ; For Gadgets_FW only - Fail results -1
  
  Declare GetGadgetPadding_X_FW(gadget_ID) ; For Gadgets - Fail results 0
  
  Declare GetGadgetPadding_Y_FW(gadget_ID) ; For Gadgets - Fail results 0
  
  Declare GetGadgetFontsize_FW(gadget_ID) ; For Gadgets - Fail results 0
  
  Declare GetGadgetStretch_X_FW(gadget_ID) ; For Gadgets - Fail results 0
  
  Declare GetGadgetStretch_Y_FW(gadget_ID) ; For Gadgets - Fail results 0
  
  Declare GetGadgetType_FW(gadget_ID) ; 0=ButtonImageGadget_FW - 1=ImageGadget_FW - 2=CanvasGadget_FW - 3=Gadget_FW - -1=Gadget_PB
  
EndDeclareModule

Module FontWizzard_BF
  ; Font_Wizzard_BF - A part from GFX_Wizzard_BF - For PureBasic
  ; Author : W. Albus - © 2018 - 2021
  ; Copyright text and references may not be removed
  ; The use of the GFX-Wizzard_BF is free, but the distribution is reserved for me
  ; Exceptions require my written permission
  
  ; Padding can also be used to create text zoom effects
  ; The padding can also be specified negatively for very small buttons
  
  ; Set a little Padding, this pervent the OS word wrap on multi line ButtonGadgets
  #min_padding_x=25
  CompilerIf #PB_Compiler_OS=#PB_OS_Linux And Subsystem("gtk2")
    #min_padding_y=9
  CompilerElse
    #min_padding_y=5
  CompilerEndIf
  
  Structure gadget_bf
    gadget_ID.i
    font_ID.i
    image_ID.i
    text_color.i
    background_color.i
    padding_x.i
    padding_y.i
    used_fontsize.i
    stretch_x.i
    stretch_y.i
    gadget_type.i
    text$
  EndStructure
  
  Global Dim LineColorArray.q(1000+2) ; You can change 1000
  Global NewList gadget_bf.gadget_bf()
  Global Screen_Output_FW, PresetFontsize_FW, PresetMinFontsize_FW, PresetMaxFontsize_FW
  Global GetCursor_X_FW, GetCursor_Y_FW
  Global Image_1_ID_FW, Image_1_x_FW, Image_1_y_FW, Image_1_width_FW, Image_1_height_FW, Image_1_alpha_FW
  Global Image_2_ID_FW, Image_2_x_FW, Image_2_y_FW, Image_2_width_FW, Image_2_height_FW, Image_2_alpha_FW
  Global Image_3_ID_FW, Image_3_x_FW, Image_3_y_FW, Image_3_width_FW, Image_3_height_FW, Image_3_alpha_FW
  Global AddFrame_Size_FW, AddFrame_Color_FW, AddFrame_Rounding_FW
  Global AddSubFrame_1_X_FW, AddSubFrame_1_Y_FW, AddSubFrame_1_Size_FW, AddSubFrame_1_Rounding_FW
  Global AddSubFrame_1_Color_FW, AddSubFrame_1_Width_FW, AddSubFrame_1_Height_FW
  Global AddSubFrame_2_X_FW, AddSubFrame_2_Y_FW, AddSubFrame_2_Size_FW, AddSubFrame_2_Rounding_FW
  Global AddSubFrame_2_Color_FW, AddSubFrame_2_Width_FW, AddSubFrame_2_Height_FW
  Global AddSubFrame_3_X_FW, AddSubFrame_3_Y_FW, AddSubFrame_3_Size_FW, AddSubFrame_3_Rounding_FW
  Global AddSubFrame_3_Color_FW, AddSubFrame_3_Width_FW, AddSubFrame_3_Height_FW
  Global AddSubFrame_4_X_FW, AddSubFrame_4_Y_FW, AddSubFrame_4_Size_FW, AddSubFrame_4_Rounding_FW
  Global AddSubFrame_4_Color_FW, AddSubFrame_4_Width_FW, AddSubFrame_4_Height_FW
  Global ProgressBar_X_FW, ProgressBar_Y_FW
  Global ProgressBar_Width_FW.f, ProgressBar_Height_FW.f, ProgressBar_Min_FW, ProgressBar_Max_FW, ProgressBar_State_FW
  Global ProgressBar_Foreground_Color_FW, ProgressBar_Background_Color_FW, ProgressBar_Alpha_FW, ProgressBar_Flag_FW
  Global ActivateAutoFree_FW=1, CreateImage_FW, Sprite_mode_FW
  Global GradientColor_Pos_FW.f, Gradient_Pos_Color_FW, BackColor_FW, FrontColor_FW, CreateMaskedAlphaImage_FW, MaskColor_FW
  Global ActivateLinearGradient_FW, LinearGradient_X_FW, LinearGradient_Y_FW, LinearGradient_XX_FW, LinearGradient_YY_FW
  Global Stretch_X_FW, Stretch_Y_FW, UsedFontsize_FW, GadgetType_FW, AdjustText_FW 
  Global OffsetCursor_X_FW, OffsetCursor_Y_FW
  
  Global Rx.d=DesktopResolutionX()
  Global Ry.d=DesktopResolutionY()
  
  FillMemory(@LineColorArray(1), ArraySize(LineColorArray()), $FF)
  
  If Not InitSprite() :  MessageRequester("  ERROR", "InitSprite fails"+#LF$+#LF$+"The tool is terminated") : End : EndIf
  
  Procedure CallBack_CreateMaskedAlphaImage(x, y, source_color, destination_color)
    If source_color&$FFFFFF<>MaskColor_FW
      ProcedureReturn source_color
    EndIf
  EndProcedure
  
  Procedure CreateMaskedAlphaImage(image_ID)
    If Not IsImage(image_ID)
      ProcedureReturn -2
    EndIf
    Protected resulted_image_ID=CreateImage(#PB_Any, ImageWidth(image_ID), ImageHeight(image_ID), 32, #PB_Image_Transparent)
    If Not resulted_image_ID
      ProcedureReturn -6
    EndIf
    If StartDrawing(ImageOutput(resulted_image_ID))
      DrawingMode(#PB_2DDrawing_CustomFilter)
      CustomFilterCallback(@CallBack_CreateMaskedAlphaImage())
      DrawImage(ImageID(image_ID), 0, 0)
      StopDrawing()
      ProcedureReturn resulted_image_ID
    EndIf
    ProcedureReturn -3
  EndProcedure
  
  Procedure CreateMaskedAlphaImage_FW(CreateMaskedAlphaImage_FW_=0, MaskColor_FW_=0)
    CreateMaskedAlphaImage_FW=CreateMaskedAlphaImage_FW_
    MaskColor_FW=MaskColor_FW_
    ProcedureReturn MaskColor_FW
  EndProcedure
  
  Procedure ProgressBar(width.f,
                        height.f,
                        min,
                        max,
                        state,
                        foreground_color,
                        background_color,
                        flag=0) ; 1 = vertical
    width.f
    height.f
    If min<1 : min=1 : EndIf : If max<1 : max=1 : EndIf
    Protected image_ID=CreateImage(#PB_Any, width, height, 24, background_color)
    If Not image_ID
      ProcedureReturn -6
    EndIf
    If Not StartDrawing(ImageOutput(image_ID))
      ProcedureReturn -4
    EndIf
    Box(0, 0, width, height, background_color)
    If flag=1
      Box(1, height-(state-min)*(height/(max-min)), width-1, height, foreground_color)
    Else
      Box(0, 1, (state-min)*(width/(max-min)), height-1, foreground_color)
    EndIf
    DrawingMode(#PB_2DDrawing_Outlined)
    Box(0, 0, width, height, $BBBBBB)
    StopDrawing()
    ProcedureReturn image_ID
  EndProcedure
  
  Procedure.s Replace_LineBreaks_to_LF(text$)
    If FindString(text$, #CR$)
      text$=ReplaceString(text$, #CRLF$, #LF$)
      text$=ReplaceString(text$, #LFCR$, #LF$)
      ReplaceString(text$, #CR$, #LF$, #PB_String_InPlace)
    EndIf
    ProcedureReturn text$
  EndProcedure
  
  Procedure GetTextWidth_FW(text$, font_ID=-1)
    Protected lf, i, ii, iii
    Static image_ID
    
    If Not IsImage(image_ID)
      image_ID=CreateImage(#PB_Any, 16, 16)
      If Not image_ID : ProcedureReturn -6
      EndIf
    EndIf
    
    text$=Replace_LineBreaks_to_LF(text$)
    
    lf=CountString(text$, #LF$)
    
    If Not StartDrawing(ImageOutput(image_ID))
      ProcedureReturn -4
      FreeImage(image_ID)
    EndIf
    
    If IsFont(font_ID)
      DrawingFont(FontID(font_ID))
    EndIf
    
    If lf
      lf+1
      For i=1 To lf
        ii=TextWidth(StringField(text$, i, #LF$))
        If ii>iii : iii=ii : EndIf
      Next i
    Else
      iii=TextWidth(text$)
    EndIf
    
    StopDrawing()
    ProcedureReturn iii
  EndProcedure
  
  Procedure GetTextHeight_FW(text$, font_ID=-1)
    Protected lf, i
    Static image_ID
    
    If Not IsImage(image_ID)
      image_ID=CreateImage(#PB_Any, 16, 16)
      If Not image_ID : ProcedureReturn -6
      EndIf
    EndIf
    
    text$=Replace_LineBreaks_to_LF(text$)
    
    lf=CountString(text$, #LF$)+1
    
    If Not StartDrawing(ImageOutput(image_ID))
      ProcedureReturn -4
      FreeImage(image_ID)
    EndIf
    
    If IsFont(font_ID)
      DrawingFont(FontID(font_ID))
    EndIf
    
    i=TextHeight(" ")*lf
    
    StopDrawing()
    ProcedureReturn i
  EndProcedure
  
  Procedure GetTextLineHeight_BF(font_ID=-1)
    Protected result
    Static image_ID
    
    If Not IsImage(image_ID)
      image_ID=CreateImage(#PB_Any, 16, 16)
      If Not image_ID : ProcedureReturn -6
      EndIf
    EndIf
    
    If Not StartDrawing(ImageOutput(image_ID))
      ProcedureReturn -4
      FreeImage(image_ID)
    EndIf
    
    If IsFont(font_ID)
      DrawingFont(FontID(font_ID))
    EndIf
    
    result=TextHeight(" ")
    StopDrawing()
    
    ProcedureReturn result
  EndProcedure
  
  Procedure GetTextLinesAmount_BF(text$)
    text$=Replace_LineBreaks_to_LF(text$)
    ProcedureReturn CountString(text$, #LF$)+1
  EndProcedure
  
  Procedure GetMaxLineChars_FW(text$)
    Protected lf, i, ii, iii, max_Line_chars, stringfield$
    
    text$=Replace_LineBreaks_to_LF(text$)
    
    lf=CountString(text$, #LF$)
    
    If lf
      lf+1
      For i=1 To lf
        stringfield$=StringField(text$, i, #LF$)
        ii=Len(stringfield$)
        If ii>iii
          max_line_chars=Len(stringfield$) 
          iii=ii
        EndIf
      Next i
    Else
      max_line_chars=Len(text$)
    EndIf
    
    ProcedureReturn max_line_chars
  EndProcedure
  
  Procedure Calculate_fitted_Font_FW(text$,
                                     width_rectangle,
                                     height_rectangle,
                                     font$,
                                     font_flag,
                                     padding_x=0,
                                     padding_y=0,
                                     resize_factor.f=1)
    
    If resize_factor<=0 : resize_factor=1 : EndIf
    
    If text$="" : ProcedureReturn 0 : EndIf
    
    Protected font_ID, max_needed_font_size, text_width, text_height
    
    If PresetMinFontsize_FW>1
      max_needed_font_size=PresetMinFontsize_FW
    EndIf
    
    If PresetFontsize_FW>0
      font_ID=LoadFont(#PB_Any, font$, PresetFontsize_FW, font_flag)
    Else
      Macro calculate_font_FW
        font_ID=LoadFont(#PB_Any, font$, max_needed_font_size, font_flag)
        text_width=GetTextWidth_FW(text$, font_ID)*resize_factor
        text_height=GetTextHeight_FW(text$, font_ID)*resize_factor
        If IsFont(font_ID)
          FreeFont(font_ID)
        EndIf
        If PresetMaxFontsize_FW>0
          If max_needed_font_size>PresetMaxFontsize_FW
            Break
          EndIf
        EndIf
        If text_width>width_rectangle-padding_x Or text_height>height_rectangle-padding_y
          Break
        EndIf
      EndMacro
      
      Repeat
        max_needed_font_size+20
        calculate_font_FW
      ForEver
      max_needed_font_size-20
      
      Repeat
        max_needed_font_size+10
        calculate_font_FW
      ForEver
      max_needed_font_size-10
      
      Repeat
        max_needed_font_size+5
        calculate_font_FW
      ForEver
      max_needed_font_size-5
      
      Repeat
        max_needed_font_size+1
        calculate_font_FW
      ForEver
      
      If max_needed_font_size>1
        max_needed_font_size-1
      EndIf
      font_ID=LoadFont(#PB_Any, font$, max_needed_font_size, font_flag)
    EndIf
    
    UsedFontsize_FW=max_needed_font_size
    
    ProcedureReturn font_ID
  EndProcedure
  
  Procedure SetGadget_FW(gadget_ID,
                         Font$,
                         font_flag,
                         output_x,
                         output_y,
                         gadget_width,
                         gadget_height,
                         text$=" ",
                         padding_x=0,
                         padding_y=0,
                         resize_factor.f=1)
    
    If Not IsGadget(gadget_ID) : ProcedureReturn -25 : EndIf
    
    If resize_factor<=0 : resize_factor=1 : EndIf
    
    If output_x=-1 : output_x=GadgetX(gadget_ID) : EndIf
    If output_y=-1 : output_y=GadgetY(gadget_ID) : EndIf
    If gadget_width<0 : gadget_width=GadgetWidth(gadget_ID) : EndIf
    If gadget_height<0 : gadget_height=GadgetHeight(gadget_ID) : EndIf
    
    If text$="" : text$=" " : EndIf
    
    If gadget_width>0 And gadget_height>0
      Protected gadget_width_=gadget_width*Rx
      Protected gadget_height_=gadget_height*Ry
      padding_x=(padding_x+#min_padding_x)*Rx
      padding_y=(padding_y+#min_padding_y)*Ry
    Else
      gadget_width_=gadget_width
      gadget_height_=gadget_height
    EndIf
    
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        If IsFont(gadget_bf()\font_ID)
          FreeFont(gadget_bf()\font_ID)
        EndIf
        DeleteElement(gadget_bf())
        Break
      EndIf
    Next
    
    Protected font_ID=Calculate_fitted_Font_FW(text$,
                                               gadget_width_,
                                               gadget_height_,
                                               font$,
                                               font_flag,
                                               padding_x, 
                                               padding_y,
                                               resize_factor)
    
    If Not IsFont(font_ID) : ProcedureReturn -9 : EndIf
    
    AddElement(gadget_bf())
    gadget_bf()\gadget_ID=gadget_ID
    gadget_bf()\font_ID=font_ID
    gadget_bf()\padding_x=padding_x
    gadget_bf()\padding_y=padding_y
    gadget_bf()\used_fontsize=UsedFontsize_FW
    gadget_bf()\gadget_type=3
    gadget_bf()\text$=text$
    
    ResizeGadget(gadget_ID, output_x, output_y, gadget_width, gadget_height)
    SetGadgetFont(gadget_ID, FontID(font_ID))
    SetGadgetText(gadget_ID, text$)
    
    ProcedureReturn font_ID
  EndProcedure
  
  Procedure SetGadgetText_FW(gadget_ID,
                             Font$,
                             font_flag,
                             text$=" ",
                             padding_x=0,
                             padding_y=0,
                             resize_factor.f=1)
    
    ProcedureReturn SetGadget_FW(gadget_ID,
                                 Font$,
                                 font_flag,
                                 -1,
                                 -1,
                                 -1,
                                 -1,
                                 text$,
                                 padding_x,
                                 padding_y,
                                 resize_factor.f)
  EndProcedure
  
  Procedure SetImageBasedGadget_FW(gadget_ID,
                                   Font$,
                                   font_flag,
                                   output_x,
                                   output_y,
                                   gadget_width,
                                   gadget_height,
                                   text_color=#Black,
                                   text_adjustment=0,
                                   background_color=-1,
                                   text$=" ",
                                   padding_x=0,
                                   padding_y=0,
                                   resize_factor.f=1)   
    
    If Not IsGadget(gadget_ID)
      ProcedureReturn -25
    EndIf
    
    If resize_factor<=0 : resize_factor=1 : EndIf
    
    If output_x=-1 : output_x=GadgetX(gadget_ID) : EndIf
    If output_y=-1 : output_y=GadgetY(gadget_ID) : EndIf
    If gadget_width<0 : gadget_width=GadgetWidth(gadget_ID) : EndIf
    If gadget_height<0 : gadget_height=GadgetHeight(gadget_ID) : EndIf
    
    Protected image_ID=CreateTextImage_FW(font$,            ; Font
                                          font_flag,        ; Font flag
                                          gadget_width*Rx,  ; Output width
                                          gadget_height*Ry, ; Output height
                                          text_color,       ; Text color - Alpha channel sensitive
                                          text_adjustment,  ; Text adjustment - 0=center - 1=left - 2=right
                                          background_color, ; Background color - Alpha channel sensitive
                                          text$,            ; Text
                                          padding_x,        ; Padding x
                                          padding_y,        ; Padding y
                                          resize_factor.f)  ; Resize factor - float
    
    If Not IsImage(image_ID)
      ProcedureReturn -6
    EndIf
    
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        If IsImage(gadget_bf()\image_ID)
          FreeImage(gadget_bf()\image_ID)
        EndIf
        DeleteElement(gadget_bf())
        Break
      EndIf
    Next
    
    AddElement(gadget_bf())
    gadget_bf()\gadget_ID=gadget_ID
    gadget_bf()\image_ID=image_ID
    gadget_bf()\text_color=text_color
    gadget_bf()\background_color=background_color
    gadget_bf()\padding_x=padding_x
    gadget_bf()\padding_y=padding_y
    gadget_bf()\used_fontsize=UsedFontsize_FW
    gadget_bf()\stretch_x=Stretch_X_FW
    gadget_bf()\stretch_y=Stretch_Y_FW
    gadget_bf()\gadget_type=GadgetType_FW
    gadget_bf()\text$=text$
    
    ResizeGadget(gadget_ID, output_x, output_y, gadget_width, gadget_height)
    
    If GadgetType(gadget_ID)=#PB_GadgetType_Image
      SetGadgetState(gadget_ID, ImageID(image_ID)) ; ImageGadget
    Else
      If GadgetType(gadget_ID)=#PB_GadgetType_Canvas ; Linux crash with 32 bit images
        StartDrawing(CanvasOutput(gadget_ID))
        DrawAlphaImage(ImageID(image_ID), 0, 0)
        StopDrawing()
      Else
        SetGadgetAttribute(gadget_ID, #PB_Button_Image, ImageID(image_ID)) ; ButtonImageGadget, CanvasGadget
      EndIf
    EndIf
    
    If ActivateAutoFree_FW=1
      AddFrame_FW()
      AddSubFrame_1_FW()
      AddSubFrame_2_FW()
      AddSubFrame_3_FW()
      AddSubFrame_4_FW()
      AddImage_1_FW()
      AddImage_2_FW()
      AddImage_3_FW()
      ProgressBar_FW()
    EndIf 
    
    ProcedureReturn image_ID
  EndProcedure
  
  Procedure SetImageBasedGadgetText_FW(gadget_ID,
                                       Font$,
                                       font_flag,
                                       text_color=#Black,
                                       text_adjustment=0,
                                       background_color=-1,
                                       text$=" ",
                                       padding_x=0,
                                       padding_y=0,
                                       resize_factor.f=1)
    
    ProcedureReturn SetImageBasedGadget_FW(gadget_ID,
                                           Font$,
                                           font_flag,
                                           -1,
                                           -1,
                                           -1,
                                           -1,
                                           text_color,
                                           text_adjustment,
                                           background_color,
                                           text$,
                                           padding_x,
                                           padding_y,
                                           resize_factor.f)
  EndProcedure
  
  Procedure ImageBasedGadget_FW(gadget_Typ,
                                Font$,
                                font_flag,
                                output_x,
                                output_y,
                                gadget_width,
                                gadget_height,
                                text_color=#Black,
                                text_adjustment=0,
                                background_color=-1,
                                text$=" ",
                                padding_x=0,
                                padding_y=0,
                                resize_factor.f=1,
                                gadget_frame_flag=0)
    
    Select gadget_Typ
      Case 0
        Protected gadget_ID=ButtonImageGadget(#PB_Any, output_x, output_y, gadget_width, gadget_height, 0, gadget_frame_flag)
      Case 1
        gadget_ID=ImageGadget(#PB_Any, output_x, output_y, gadget_width, gadget_height, 0, gadget_frame_flag)
      Case 2
        gadget_ID=CanvasGadget(#PB_Any, output_x, output_y, gadget_width, gadget_height, gadget_frame_flag)
      Default
        ProcedureReturn 0
    EndSelect
    
    Protected result=SetImageBasedGadget_FW(gadget_ID, 
                                            Font$,
                                            font_flag,
                                            output_x,
                                            output_y,
                                            gadget_width,
                                            gadget_height,
                                            text_color,
                                            text_adjustment,
                                            background_color,
                                            text$,
                                            padding_x,
                                            padding_y,
                                            resize_factor.f)
    
    If result<1 : ProcedureReturn result : EndIf
    
    ProcedureReturn gadget_ID
    
  EndProcedure
  
  Procedure AddFrame_FW(AddFrame_Size_FW_=0, AddFrame_Color_FW_=0, AddFrame_Rounding_FW_=0)
    AddFrame_Size_FW=AddFrame_Size_FW_
    AddFrame_Color_FW=AddFrame_Color_FW_
    AddFrame_Rounding_FW=AddFrame_Rounding_FW_
    ProcedureReturn 1
  EndProcedure 
  
  Procedure AddSubFrame_1_FW(AddSubFrame_1_X_FW_=0,
                             AddSubFrame_1_Y_FW_=0,
                             AddSubFrame_1_Width_FW_=0,
                             AddSubFrame_1_Height_FW_=0,
                             AddSubFrame_1_Size_FW_=0,
                             AddSubFrame_1_Color_FW_=0,
                             AddSubFrame_1_Rounding_FW_=0)
    AddSubFrame_1_X_FW=AddSubFrame_1_X_FW_
    AddSubFrame_1_Y_FW=AddSubFrame_1_Y_FW_
    AddSubFrame_1_Width_FW=AddSubFrame_1_Width_FW_
    AddSubFrame_1_Height_FW=AddSubFrame_1_Height_FW_
    AddSubFrame_1_Size_FW=AddSubFrame_1_Size_FW_
    AddSubFrame_1_Color_FW=AddSubFrame_1_Color_FW_
    AddSubFrame_1_Rounding_FW=AddSubFrame_1_Rounding_FW_
    ProcedureReturn 1
  EndProcedure 
  
  Procedure AddSubFrame_2_FW(AddSubFrame_2_X_FW_=0,
                             AddSubFrame_2_Y_FW_=0,
                             AddSubFrame_2_Width_FW_=0,
                             AddSubFrame_2_Height_FW_=0,
                             AddSubFrame_2_Size_FW_=0,
                             AddSubFrame_2_Color_FW_=0,
                             AddSubFrame_2_Rounding_FW_=0)
    AddSubFrame_2_X_FW=AddSubFrame_2_X_FW_
    AddSubFrame_2_Y_FW=AddSubFrame_2_Y_FW_
    AddSubFrame_2_Width_FW=AddSubFrame_2_Width_FW_
    AddSubFrame_2_Height_FW=AddSubFrame_2_Height_FW_
    AddSubFrame_2_Size_FW=AddSubFrame_2_Size_FW_
    AddSubFrame_2_Color_FW=AddSubFrame_2_Color_FW_
    AddSubFrame_2_Rounding_FW=AddSubFrame_2_Rounding_FW_
    ProcedureReturn 1
  EndProcedure 
  
  Procedure AddSubFrame_3_FW(AddSubFrame_3_X_FW_=0,
                             AddSubFrame_3_Y_FW_=0,
                             AddSubFrame_3_Width_FW_=0,
                             AddSubFrame_3_Height_FW_=0,
                             AddSubFrame_3_Size_FW_=0,
                             AddSubFrame_3_Color_FW_=0,
                             AddSubFrame_3_Rounding_FW_=0)
    AddSubFrame_3_X_FW=AddSubFrame_3_X_FW_
    AddSubFrame_3_Y_FW=AddSubFrame_3_Y_FW_
    AddSubFrame_3_Width_FW=AddSubFrame_3_Width_FW_
    AddSubFrame_3_Height_FW=AddSubFrame_3_Height_FW_
    AddSubFrame_3_Size_FW=AddSubFrame_3_Size_FW_
    AddSubFrame_3_Color_FW=AddSubFrame_3_Color_FW_
    AddSubFrame_3_Rounding_FW=AddSubFrame_3_Rounding_FW_
    ProcedureReturn 1
  EndProcedure 
  
  Procedure AddSubFrame_4_FW(AddSubFrame_4_X_FW_=0,
                             AddSubFrame_4_Y_FW_=0,
                             AddSubFrame_4_Width_FW_=0,
                             AddSubFrame_4_Height_FW_=0,
                             AddSubFrame_4_Size_FW_=0,
                             AddSubFrame_4_Color_FW_=0,
                             AddSubFrame_4_Rounding_FW_=0)
    AddSubFrame_4_X_FW=AddSubFrame_4_X_FW_
    AddSubFrame_4_Y_FW=AddSubFrame_4_Y_FW_
    AddSubFrame_4_Width_FW=AddSubFrame_4_Width_FW_
    AddSubFrame_4_Height_FW=AddSubFrame_4_Height_FW_
    AddSubFrame_4_Size_FW=AddSubFrame_4_Size_FW_
    AddSubFrame_4_Color_FW=AddSubFrame_4_Color_FW_
    AddSubFrame_4_Rounding_FW=AddSubFrame_4_Rounding_FW_
    ProcedureReturn 1
  EndProcedure 
  
  Procedure ActivateScreenOutput_FW(Screen_Output_FW_=0)
    Screen_Output_FW=Screen_Output_FW_
  EndProcedure
  
  Procedure OpenGLGadgetFlipBuffers_FW(gadget_ID) ; Flip Buffers OpenGLGadget
    If IsGadget(gadget_ID)
      SetGadgetAttribute(gadget_ID, #PB_OpenGL_FlipBuffers, #True)
      ProcedureReturn 1
    EndIf
    ProcedureReturn -25
  EndProcedure
  
  Procedure SetColorOpenGLGadget_FW(background_color) ; OpenGLGadget color
    glEnable_(#GL_BLEND)
    glBlendFunc_(#GL_SRC_ALPHA, #GL_ONE_MINUS_SRC_ALPHA)
    glClearColor_(Red(background_color)/255, Green(background_color)/255, Blue(background_color)/255, 1)
    glClear_(#GL_COLOR_BUFFER_BIT)
    ProcedureReturn 1
  EndProcedure
  
  Macro macro_common_RoundBox_Vector_BF
    If Not Alpha(frame_color)
      VectorSourceColor(RGBA(Red(frame_color), Green(frame_color), Blue(frame_color), 255))
    ElseIf Alpha(frame_color)=1
      VectorSourceColor(RGBA(Red(frame_color), Green(frame_color), Blue(frame_color), 0))
    Else
      VectorSourceColor(RGBA(Red(frame_color), Green(frame_color), Blue(frame_color), Alpha(frame_color)))
    EndIf
    
    StrokePath(frame_thickness)
    
    MovePathCursor(x, y)
    
    If radius>0
      AddPathArc(width-radius, 0, width-radius, radius, radius, #PB_Path_Relative)
      AddPathArc(0, height-radius, -radius, height-radius, radius, #PB_Path_Relative)
      AddPathArc(-width+radius, 0, -width+radius, -radius, radius, #PB_Path_Relative)
      AddPathArc(0, -height+radius, radius, -height+radius, radius, #PB_Path_Relative)
    Else
      AddPathLine(width, 0, #PB_Path_Relative)
      AddPathLine(0, height, #PB_Path_Relative)
      AddPathLine(-width, 0, #PB_Path_Relative)
      AddPathLine(0, -height, #PB_Path_Relative)
    EndIf
    
    ClosePath()
    
    If Not Alpha(background_color)
      VectorSourceColor(RGBA(Red(background_color), Green(background_color), Blue(background_color), 255))
    ElseIf Alpha(frame_color)=1
      VectorSourceColor(RGBA(Red(background_color), Green(background_color), Blue(background_color), 0))
    Else
      VectorSourceColor(RGBA(Red(background_color), Green(background_color), Blue(background_color), Alpha(background_color)))
    EndIf
    
    If background_color>>8<>-1
      FillPath(#PB_Path_Preserve)
    EndIf
    
    If Not Alpha(frame_color)
      VectorSourceColor(RGBA(Red(frame_color), Green(frame_color), Blue(frame_color), 255))
    ElseIf Alpha(frame_color)=1
      VectorSourceColor(RGBA(Red(frame_color), Green(frame_color), Blue(frame_color), 0))
    Else
      VectorSourceColor(RGBA(Red(frame_color), Green(frame_color), Blue(frame_color), Alpha(frame_color)))
    EndIf
    
    If Not negative_frame_thickness And frame_thickness>1
      If radius>1
        StrokePath(frame_thickness, #PB_Path_RoundCorner)
      Else
        StrokePath(frame_thickness, #PB_Path_Default)
      EndIf
    EndIf
  EndMacro
  
  Procedure RoundBox_Vector(output_ID, 
                            x.d,
                            y.d,
                            width.d,
                            height.d,
                            radius.d,
                            frame_thickness.d,
                            frame_color,
                            background_color)
    
    If radius<0 : radius=0 : EndIf
    If radius>0 : radius+1 : EndIf
    
    If frame_thickness<0 : Protected negative_frame_thickness=1 : frame_thickness*-1*2 : EndIf 
    x+frame_thickness/2+radius : y+frame_thickness/2 : width-frame_thickness : height-frame_thickness : frame_thickness+1
    If width-radius*2<0 : width=radius*2 : EndIf : If height-radius*2<0 : height=radius*2 : EndIf 
    If IsImage(output_ID) ; check for image
      Protected image=1
    ElseIf IsGadget(output_ID) ; Check for canvas
      Protected canvas=1
    ElseIf IsWindow(output_ID) ; Check for window
      Protected window=1  
    Else
      ProcedureReturn -11
    EndIf
    
    If image
      Protected result=StartVectorDrawing(ImageVectorOutput(output_ID))
    ElseIf canvas
      result=StartVectorDrawing(CanvasVectorOutput(output_ID))
    Else
      result=StartVectorDrawing(WindowVectorOutput(output_ID)) 
    EndIf
    
    If Not result : ProcedureReturn -11 : EndIf
    
    macro_common_RoundBox_Vector_BF
    
    StopVectorDrawing()
    ProcedureReturn 1
  EndProcedure
  
  Procedure DrawText_FW(output_ID,
                        Font$,
                        font_flag,
                        output_x,
                        output_y,
                        output_width,
                        output_height,
                        text_color=#Black,
                        text_adjustment=0,
                        background_color=-1,
                        text$=" ",
                        padding_x=0,
                        padding_y=0,
                        resize_factor.f=1)
    
    If CreateImage_FW ; Image output
      If CreateImage_FW=3
        Protected image=3
      Else
        image=2
      EndIf
    Else
      If Not Screen_Output_FW
        If IsImage(output_ID) ; Image
          image=1
        ElseIf IsSprite(output_ID) ; PB sprite
          Protected sprite=1
        ElseIf IsGadget(output_ID) ; Canvas
          Protected canvas=1
        ElseIf IsWindow(output_ID) ; Window
          Protected window=1
        Else
          ProcedureReturn -11
        EndIf
      EndIf
    EndIf
    
    If resize_factor<=0 : resize_factor=1 : EndIf
    
    If text$="" : text$=" " : EndIf
    
    If output_width<1  : output_width=1  : EndIf
    If output_height<1 : output_height=1 : EndIf
    
    padding_x+#min_padding_x
    padding_y+#min_padding_y
    
    If canvas
      padding_x*Rx
      padding_y*Ry
    EndIf
    
    If AddFrame_Size_FW>0
      padding_x+AddFrame_Size_FW*2
      padding_y+AddFrame_Size_FW*2
    EndIf
    
    Protected GetMaxLineChars=GetMaxLineChars_FW(text$)
    Protected GetTextLinesAmount=GetTextLinesAmount_BF(text$)
    
    Protected font_ID=Calculate_fitted_Font_FW(text$,
                                               output_width-(GetMaxLineChars*Stretch_X_FW),
                                               output_height-(GetTextLinesAmount*Stretch_Y_FW),
                                               font$,
                                               font_flag,
                                               padding_x, 
                                               padding_y,
                                               resize_factor)
    
    If Not IsFont(font_ID)
      ProcedureReturn -9
    EndIf
    
    Protected i, ii, iii, line_width, string_field$
    Protected lf=CountString(Replace_LineBreaks_to_LF(text$), #LF$)
    Protected text_height=GetTextHeight_FW(text$, font_ID)
    
    Protected init
    
    Protected GetCursor_X_1_FW
    Protected GetCursor_Y_1_FW
    
    Protected i1, i2, i3, i4, chr$
    
    Protected text_width=GetTextWidth_FW(text$, font_ID)
    
    If AdjustText_FW=3
      output_x-output_width
    EndIf
    
    Macro text_adjustment_c(text_line)
      Select text_adjustment
        Case 0 ; centered
          GetCursor_X_1_FW=(output_width/2-line_width/2)+output_x+Stretch_X_FW/2
        Case 1 ; Left
          GetCursor_X_1_FW=(output_width/2-text_width/2)+output_x+Stretch_X_FW/2
        Case 2 ; Right
          GetCursor_X_1_FW=(output_width/2+text_width/2-line_width)+output_x+Stretch_X_FW/2
      EndSelect
      
      GetCursor_Y_1_FW=((output_height-text_height)/2+ii)+output_y
      
      GetCursor_X_1_FW+OffsetCursor_X_FW
      GetCursor_Y_1_FW+OffsetCursor_Y_FW
      
      If Not init
        init=1
        GetCursor_X_FW=output_x+output_width
        GetCursor_Y_FW=output_y+output_height
      EndIf
      
      If Stretch_X_FW Or Stretch_Y_FW
        i2=(-Stretch_X_FW*Len(text_line)/2) : i3=0
        For i1= 0 To Len(text_line)-1 
          chr$=PeekS(@text_line+i3, 1)
          Select text_adjustment
            Case 0
              DrawText(GetCursor_X_1_FW+i2,
                       GetCursor_Y_1_FW,
                       chr$,
                       text_color)
            Case 1
              DrawText(GetCursor_X_1_FW+i2-((GetMaxLineChars-Len(text_line))*Stretch_X_FW)/2,
                       GetCursor_Y_1_FW,
                       chr$,
                       text_color) 
            Case 2
              DrawText(GetCursor_X_1_FW+i2+((GetMaxLineChars-Len(text_line))*Stretch_X_FW)/2,
                       GetCursor_Y_1_FW,
                       chr$,
                       text_color) 
          EndSelect
          i2+TextWidth(chr$)+Stretch_X_FW
          i3+2
        Next 
        
        ii+Stretch_y_FW
        
      Else
        DrawText(GetCursor_X_1_FW,
                 GetCursor_Y_1_FW,
                 text_line,
                 text_color)
      EndIf   
    EndMacro
    
    Macro text_adjustment_lr(text_line)
      Select text_adjustment
        Case 0 ; Centered
          i2=-Stretch_X_FW*Len(text_line)/2+GetMaxLineChars*Stretch_X_FW/2 
        Case 1 ; left
          i2=0 
        Case 2 ; right
          i2=-Stretch_X_FW*Len(text_line)+GetMaxLineChars*Stretch_X_FW
      EndSelect
      
      If AdjustText_FW=1
        GetCursor_X_1_FW=output_x+padding_x/2
      Else
        GetCursor_X_1_FW=output_x+output_width-text_width-(GetMaxLineChars*Stretch_X_FW)-padding_x/2
      EndIf
      
      GetCursor_Y_1_FW=((output_height-text_height)/2+ii)+output_y+i4 
      
      GetCursor_X_1_FW+OffsetCursor_X_FW
      GetCursor_Y_1_FW+OffsetCursor_Y_FW
      
      If Not init
        init=1
        GetCursor_X_FW=output_x+output_width
        GetCursor_Y_FW=output_y+output_height
      EndIf  
      
      If Stretch_X_FW Or Stretch_Y_FW
        For i1= 0 To Len(text_line)-1 
          chr$=PeekS(@text_line+i3, 1)
          GetCursor_X_1_FW+i2 
          Select text_adjustment
            Case 0 ; Centered
              DrawText(GetCursor_X_1_FW+text_width/2-line_width/2,
                       GetCursor_Y_1_FW,
                       chr$,
                       text_color) 
            Case 1 ; Left
              DrawText(GetCursor_X_1_FW,
                       GetCursor_Y_1_FW,
                       chr$,
                       text_color)
            Case 2 ; Right
              DrawText(GetCursor_X_1_FW+text_width-line_width,
                       GetCursor_Y_1_FW,
                       chr$,
                       text_color) 
          EndSelect
          i2=TextWidth(chr$)+Stretch_X_FW
          i3+2
        Next
        i3=0
        i4+Stretch_Y_FW
      Else
        GetCursor_X_1_FW+i2 
        Select text_adjustment
          Case 0 ; Centered
            DrawText(GetCursor_X_1_FW+text_width/2-line_width/2,
                     GetCursor_Y_1_FW,
                     text_line,
                     text_color) 
          Case 1 ; Left
            DrawText(GetCursor_X_1_FW,
                     GetCursor_Y_1_FW,
                     text_line,
                     text_color)
          Case 2 ; Right
            DrawText(GetCursor_X_1_FW+text_width-line_width,
                     GetCursor_Y_1_FW,
                     text_line,
                     text_color) 
        EndSelect
      EndIf
    EndMacro
    
    Protected temp_image_1_ID
    Macro add_image_1_fw_1
      If Image_1_Width_FW>0 And Image_1_Height_FW>0
        If IsImage(Image_1_ID_FW)
          temp_image_1_ID=CopyImage(Image_1_ID_FW, #PB_Any)
          If Not temp_image_1_ID
            ProcedureReturn -6
          EndIf
          ResizeImage(temp_image_1_ID,
                      Image_1_Width_FW,
                      Image_1_Height_FW)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
          DrawAlphaImage(ImageID(temp_image_1_ID),
                         Image_1_x_FW+output_x,
                         Image_1_y_FW+output_y,
                         Image_1_alpha_FW)
          FreeImage(temp_image_1_ID)
        EndIf
      EndIf
    EndMacro
    
    Protected temp_image_2_ID
    Macro add_image_2_fw_1
      If Image_2_Width_FW>0 And Image_2_Height_FW>0
        If IsImage(Image_2_ID_FW)
          temp_image_2_ID=CopyImage(Image_2_ID_FW, #PB_Any)
          If Not temp_image_2_ID
            ProcedureReturn -6
          EndIf
          ResizeImage(temp_image_2_ID,
                      Image_2_Width_FW,
                      Image_2_Height_FW)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
          DrawAlphaImage(ImageID(temp_image_2_ID),
                         Image_2_x_FW+output_x,
                         Image_2_y_FW+output_y,
                         Image_2_alpha_FW)
          FreeImage(temp_image_2_ID)
        EndIf
      EndIf
    EndMacro
    
    Protected temp_image_3_ID
    Macro add_image_3_fw_1
      If Image_3_Width_FW>0 And Image_3_Height_FW>0
        If IsImage(Image_3_ID_FW)
          temp_image_3_ID=CopyImage(Image_3_ID_FW, #PB_Any)
          If Not temp_image_3_ID
            ProcedureReturn -6
          EndIf
          ResizeImage(temp_image_3_ID,
                      Image_3_Width_FW,
                      Image_3_Height_FW)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
          DrawAlphaImage(ImageID(temp_image_3_ID),
                         Image_3_x_FW+output_x,
                         Image_3_y_FW+output_y,
                         Image_3_alpha_FW)
          FreeImage(temp_image_3_ID)
        EndIf
      EndIf
    EndMacro
    
    If ProgressBar_Width_FW>0 And ProgressBar_Height_FW>0
      Protected progressbar_ID=ProgressBar(ProgressBar_Width_FW,
                                           ProgressBar_Height_FW,
                                           ProgressBar_Min_FW,
                                           ProgressBar_Max_FW,
                                           ProgressBar_State_FW,
                                           ProgressBar_Foreground_Color_FW,
                                           ProgressBar_Background_Color_FW,
                                           ProgressBar_Flag_FW) ; 1 = vertical
      If Not IsImage(progressbar_ID)
        FreeFont(font_ID)
        ProcedureReturn -5
      EndIf
    EndIf
    
    Protected AddFrame_Color_FW_=AddFrame_Color_FW
    Protected AddSubFrame_1_Color_FW_=AddSubFrame_1_Color_FW
    Protected AddSubFrame_2_Color_FW_=AddSubFrame_2_Color_FW
    Protected AddSubFrame_3_Color_FW_=AddSubFrame_3_Color_FW
    Protected AddSubFrame_4_Color_FW_=AddSubFrame_4_Color_FW
    If Not Alpha(AddFrame_Color_FW_) And Not Screen_Output_FW      : AddFrame_Color_FW_      | $FF000000 : EndIf
    If Not Alpha(AddSubFrame_1_Color_FW_) And Not Screen_Output_FW : AddSubFrame_1_Color_FW_ | $FF000000 : EndIf
    If Not Alpha(AddSubFrame_2_Color_FW_) And Not Screen_Output_FW : AddSubFrame_2_Color_FW_ | $FF000000 : EndIf
    If Not Alpha(AddSubFrame_3_Color_FW_) And Not Screen_Output_FW : AddSubFrame_3_Color_FW_ | $FF000000 : EndIf
    If Not Alpha(AddSubFrame_4_Color_FW_) And Not Screen_Output_FW : AddSubFrame_4_Color_FW_ | $FF000000 : EndIf
    
    If Not Alpha(background_color) And Not Screen_Output_FW And image<>3 : background_color=background_color | $FF000000 : EndIf
    
    If AddFrame_Rounding_FW>0
      Protected temp_image_fr1_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
      Protected temp_image_fr2_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
      If temp_image_fr1_ID And temp_image_fr2_ID
        RoundBox_Vector(temp_image_fr1_ID, 
                        0,
                        0,
                        output_width,
                        output_height,
                        AddFrame_Rounding_FW,
                        0,
                        0,
                        background_color)
        RoundBox_Vector(temp_image_fr2_ID, 
                        0,
                        0,
                        output_width,
                        output_height,
                        AddFrame_Rounding_FW,
                        AddFrame_Size_FW,
                        AddFrame_Color_FW_,
                        -1)
      Else
        If temp_image_fr1_ID : FreeImage(temp_image_fr1_ID) : EndIf
        If temp_image_fr2_ID : FreeImage(temp_image_fr2_ID) : EndIf
        ProcedureReturn -5
      EndIf
    EndIf
    
    If AddSubFrame_1_Rounding_FW>0
      Protected temp_image_Sfr_1_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
      If temp_image_sfr_1_ID
        If AddSubFrame_1_Size_FW=-1
          RoundBox_Vector(temp_image_sfr_1_ID, 
                          0,                         ; x
                          0,                         ; y
                          AddSubFrame_1_Width_FW,    ; Box width
                          AddSubFrame_1_Height_FW,   ; Box height
                          AddSubFrame_1_Rounding_FW, ; Frame rounding
                          0,                         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                          0,                         ; Frame color
                          AddSubFrame_1_Color_FW_)   ; Background color - For invisible background set to -1
        Else
          RoundBox_Vector(temp_image_sfr_1_ID, 
                          0,
                          0,
                          AddSubFrame_1_Width_FW,
                          AddSubFrame_1_Height_FW,
                          AddSubFrame_1_Rounding_FW,
                          AddSubFrame_1_Size_FW,
                          AddSubFrame_1_Color_FW_,
                          -1)
        EndIf
      Else
        ProcedureReturn -5
      EndIf
    EndIf
    
    If AddSubFrame_2_Rounding_FW>0
      Protected temp_image_Sfr_2_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
      If temp_image_sfr_2_ID
        If AddSubFrame_2_Size_FW=-1
          RoundBox_Vector(temp_image_sfr_2_ID, 
                          0,                         ; x
                          0,                         ; y
                          AddSubFrame_2_Width_FW,    ; Box width
                          AddSubFrame_2_Height_FW,   ; Box height
                          AddSubFrame_2_Rounding_FW, ; Frame rounding
                          0,                         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                          0,                         ; Frame color
                          AddSubFrame_2_Color_FW_)   ; Background color - For invisible background set to -1
        Else
          RoundBox_Vector(temp_image_sfr_2_ID, 
                          0,
                          0,
                          AddSubFrame_2_Width_FW,
                          AddSubFrame_2_Height_FW,
                          AddSubFrame_2_Rounding_FW,
                          AddSubFrame_2_Size_FW,
                          AddSubFrame_2_Color_FW_,
                          -1)
        EndIf
      Else
        ProcedureReturn -5
      EndIf
    EndIf
    
    If AddSubFrame_3_Rounding_FW>0
      Protected temp_image_Sfr_3_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
      If temp_image_sfr_3_ID
        If AddSubFrame_3_Size_FW=-1
          RoundBox_Vector(temp_image_sfr_3_ID, 
                          0,                         ; x
                          0,                         ; y
                          AddSubFrame_3_Width_FW,    ; Box width
                          AddSubFrame_3_Height_FW,   ; Box height
                          AddSubFrame_3_Rounding_FW, ; Frame rounding
                          0,                         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                          0,                         ; Frame color
                          AddSubFrame_3_Color_FW_)   ; Background color - For invisible background set to -1
        Else
          RoundBox_Vector(temp_image_sfr_3_ID, 
                          0,
                          0,
                          AddSubFrame_3_Width_FW,
                          AddSubFrame_3_Height_FW,
                          AddSubFrame_3_Rounding_FW,
                          AddSubFrame_3_Size_FW,
                          AddSubFrame_3_Color_FW_,
                          -1)
        EndIf
      Else
        ProcedureReturn -5
      EndIf
    EndIf
    
    If AddSubFrame_4_Rounding_FW>0
      Protected temp_image_Sfr_4_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
      If temp_image_sfr_4_ID
        If AddSubFrame_4_Size_FW=-1
          RoundBox_Vector(temp_image_sfr_4_ID, 
                          0,                         ; x
                          0,                         ; y
                          AddSubFrame_4_Width_FW,    ; Box width
                          AddSubFrame_4_Height_FW,   ; Box height
                          AddSubFrame_4_Rounding_FW, ; Frame rounding
                          0,                         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                          0,                         ; Frame color
                          AddSubFrame_4_Color_FW_)   ; Background color - For invisible background set to -1
        Else
          RoundBox_Vector(temp_image_sfr_4_ID, 
                          0,
                          0,
                          AddSubFrame_4_Width_FW,
                          AddSubFrame_4_Height_FW,
                          AddSubFrame_4_Rounding_FW,
                          AddSubFrame_4_Size_FW,
                          AddSubFrame_4_Color_FW_,
                          -1)
        EndIf
      Else
        ProcedureReturn -5
      EndIf
    EndIf
    
    If Screen_Output_FW
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        text_color|$FF000000
      CompilerEndIf
      Protected result=StartDrawing(ScreenOutput())
    Else
      If Not Alpha(text_color)
        text_color|$FF000000
      EndIf
      
      If image=2 Or image=3 
        If image=3
          Protected image_ID=CreateSprite(#PB_Any, output_width, output_height, Sprite_Mode_FW)
          If Not image_ID
            FreeFont(font_ID)
            If IsImage(progressbar_ID) : FreeImage(progressbar_ID) : EndIf 
            ProcedureReturn -16
          EndIf
        Else
          image_ID=CreateImage(#PB_Any, output_width, output_height, 32, #PB_Image_Transparent)
          If Not image_ID
            FreeFont(font_ID)
            If IsImage(progressbar_ID) : FreeImage(progressbar_ID) : EndIf
            ProcedureReturn -5
          EndIf
        EndIf
        output_ID=image_ID
      EndIf
      
      If image
        If image=3
          result=StartDrawing(SpriteOutput(output_ID))
        Else
          result=StartDrawing(ImageOutput(output_ID))
        EndIf
      ElseIf sprite
        result=StartDrawing(SpriteOutput(output_ID))
      ElseIf canvas
        result=StartDrawing(CanvasOutput(output_ID))
      Else
        result=StartDrawing(WindowOutput(output_ID))
      EndIf
    EndIf
    
    If Not result
      FreeFont(font_ID)
      If IsImage(progressbar_ID) : FreeImage(progressbar_ID) : EndIf
      ProcedureReturn -11
    EndIf
    
    If AddFrame_Rounding_FW<1
      If Not Screen_Output_FW
        If Alpha(background_color) And background_color<>-1
          DrawingMode(#PB_2DDrawing_AlphaBlend)
        EndIf
      EndIf
      If background_color<>-1
        Box(output_x, output_y, output_width, output_height, background_color)     
      EndIf
    EndIf
    
    If AddFrame_Rounding_FW>0 And temp_image_fr1_ID And temp_image_fr2_ID
      DrawAlphaImage(ImageID(temp_image_fr1_ID), output_x, output_y)
      add_image_1_fw_1
      add_image_2_fw_1
      add_image_3_fw_1
      DrawAlphaImage(ImageID(temp_image_fr2_ID), output_x, output_y)
      FreeImage(temp_image_fr1_ID)
      FreeImage(temp_image_fr2_ID)
    Else
      add_image_1_fw_1
      add_image_2_fw_1
      add_image_3_fw_1
      If AddFrame_Size_FW
        If Alpha(AddFrame_Color_FW_)
          DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Outlined)
        EndIf
        For iii=0 To (AddFrame_Size_FW-1)
          Box(output_x+iii,output_y+iii, output_width-iii*2, output_height-iii*2, AddFrame_Color_FW_)
        Next iii
      EndIf
    EndIf
    
    If AddSubFrame_1_Rounding_FW>0 And temp_image_sfr_1_ID
      DrawAlphaImage(ImageID(temp_image_sfr_1_ID), AddSubFrame_1_X_FW+output_x, AddSubFrame_1_Y_FW+output_y)
      FreeImage(temp_image_sfr_1_ID)
    Else
      If AddSubFrame_1_Size_FW=-1
        If Alpha(AddSubFrame_1_Color_FW_)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Default)
        EndIf
        Box(AddSubFrame_1_X_FW+output_x,
            AddSubFrame_1_Y_FW+output_y,
            AddSubFrame_1_Width_FW,
            AddSubFrame_1_Height_FW,
            AddSubFrame_1_Color_FW_)
      Else
        If Alpha(AddSubFrame_1_Color_FW_)
          DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Outlined)
        EndIf
        If AddSubFrame_1_Size_FW
          For iii=0 To (AddSubFrame_1_Size_FW-1)
            Box(AddSubFrame_1_X_FW+output_x+iii,
                AddSubFrame_1_Y_FW+output_y+iii,
                AddSubFrame_1_Width_FW-iii*2,
                AddSubFrame_1_Height_FW-iii*2,
                AddSubFrame_1_Color_FW_)
          Next iii
        EndIf
      EndIf
    EndIf
    
    If AddSubFrame_2_Rounding_FW>0 And temp_image_sfr_2_ID
      DrawAlphaImage(ImageID(temp_image_sfr_2_ID), AddSubFrame_2_X_FW+output_x, AddSubFrame_2_Y_FW+output_y)
      FreeImage(temp_image_sfr_2_ID)
    Else
      If AddSubFrame_2_Size_FW=-1
        If Alpha(AddSubFrame_2_Color_FW_)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Default)
        EndIf
        Box(AddSubFrame_2_X_FW+output_x,
            AddSubFrame_2_Y_FW+output_y,
            AddSubFrame_2_Width_FW,
            AddSubFrame_2_Height_FW,
            AddSubFrame_2_Color_FW_)
      Else
        If Alpha(AddSubFrame_2_Color_FW_)
          DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Outlined)
        EndIf
        If AddSubFrame_2_Size_FW
          For iii=0 To (AddSubFrame_2_Size_FW-1)
            Box(AddSubFrame_2_X_FW+output_x+iii,
                AddSubFrame_2_Y_FW+output_y+iii,
                AddSubFrame_2_Width_FW-iii*2,
                AddSubFrame_2_Height_FW-iii*2,
                AddSubFrame_2_Color_FW_)
          Next iii
        EndIf
      EndIf
    EndIf
    
    If AddSubFrame_3_Rounding_FW>0 And temp_image_sfr_3_ID
      DrawAlphaImage(ImageID(temp_image_sfr_3_ID), AddSubFrame_3_X_FW+output_x, AddSubFrame_3_Y_FW+output_y)
      FreeImage(temp_image_sfr_3_ID)
    Else
      If AddSubFrame_3_Size_FW=-1
        If Alpha(AddSubFrame_3_Color_FW_)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Default)
        EndIf
        Box(AddSubFrame_3_X_FW+output_x,
            AddSubFrame_3_Y_FW+output_y,
            AddSubFrame_3_Width_FW,
            AddSubFrame_3_Height_FW,
            AddSubFrame_3_Color_FW_)
      Else
        If Alpha(AddSubFrame_3_Color_FW_)
          DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Outlined)
        EndIf
        If AddSubFrame_3_Size_FW
          For iii=0 To (AddSubFrame_3_Size_FW-1)
            Box(AddSubFrame_3_X_FW+output_x+iii,
                AddSubFrame_3_Y_FW+output_y+iii,
                AddSubFrame_3_Width_FW-iii*2,
                AddSubFrame_3_Height_FW-iii*2,
                AddSubFrame_3_Color_FW_)
          Next iii
        EndIf
      EndIf
    EndIf
    
    If AddSubFrame_4_Rounding_FW>0 And temp_image_sfr_4_ID
      DrawAlphaImage(ImageID(temp_image_sfr_4_ID), AddSubFrame_4_X_FW+output_x, AddSubFrame_4_Y_FW+output_y)
      FreeImage(temp_image_sfr_4_ID)
    Else
      If AddSubFrame_4_Size_FW=-1
        If Alpha(AddSubFrame_4_Color_FW_)
          DrawingMode(#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Default)
        EndIf
        Box(AddSubFrame_4_X_FW+output_x,
            AddSubFrame_4_Y_FW+output_y,
            AddSubFrame_4_Width_FW,
            AddSubFrame_4_Height_FW,
            AddSubFrame_4_Color_FW_)
      Else
        If Alpha(AddSubFrame_4_Color_FW_)
          DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_AlphaBlend)
        Else
          DrawingMode(#PB_2DDrawing_Outlined)
        EndIf
        If AddSubFrame_4_Size_FW
          For iii=0 To (AddSubFrame_4_Size_FW-1)
            Box(AddSubFrame_4_X_FW+output_x+iii,
                AddSubFrame_4_Y_FW+output_y+iii,
                AddSubFrame_4_Width_FW-iii*2,
                AddSubFrame_4_Height_FW-iii*2,
                AddSubFrame_4_Color_FW_)
          Next iii
        EndIf
      EndIf
    EndIf
    
    If IsImage(progressbar_ID)
      DrawAlphaImage(ImageID(progressbar_ID),
                     ProgressBar_X_FW+output_x,
                     ProgressBar_Y_FW+output_y,
                     ProgressBar_Alpha_FW)
      FreeImage(progressbar_ID)
    EndIf
    
    If ActivateLinearGradient_FW
      DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_Gradient)
      FrontColor(FrontColor_FW)
      BackColor(BackColor_FW)
      GradientColor(GradientColor_Pos_FW.f, Gradient_Pos_Color_FW)
      LinearGradient(LinearGradient_X_FW, LinearGradient_Y_FW, LinearGradient_XX_FW, LinearGradient_YY_FW)
    Else
      DrawingMode(#PB_2DDrawing_AlphaBlend|#PB_2DDrawing_Transparent)
    EndIf
    
    DrawingFont(FontID(font_ID))
    Protected line_height=TextHeight(" ")
    
    DrawingFont(FontID(font_ID))
    
    Protected old_text_color
    If lf
      ii-(GetTextLinesAmount-1)*(Stretch_Y_FW)/2
      lf+1
      For i=1 To lf
        string_field$=StringField(text$, i, #LF$)
        line_width=TextWidth(string_field$)
        old_text_color=text_color
        If ArraySize(LineColorArray())>i
          If LineColorArray(i)<>-1
            If Screen_Output_FW And #PB_Compiler_OS<>#PB_OS_Linux
              text_color=LineColorArray(i) & $FFFFFF
            Else
              text_color=LineColorArray(i)
            EndIf 
          EndIf
        EndIf
        If AdjustText_FW
          text_adjustment_lr(string_field$)
        Else
          text_adjustment_c(string_field$)
        EndIf
        text_color=old_text_color
        ii+line_height
      Next i
    Else
      text_adjustment=0
      line_width=TextWidth(text$)
      old_text_color=text_color
      If LineColorArray(1)<>-1
        If Screen_Output_FW And #PB_Compiler_OS<>#PB_OS_Linux
          text_color=LineColorArray(1) & $FFFFFF
        Else
          text_color=LineColorArray(1)
        EndIf 
      EndIf
      If AdjustText_FW
        text_adjustment_lr(text$)
      Else
        text_adjustment_c(text$)
      EndIf
      text_color=old_text_color
    EndIf
    
    StopDrawing()
    
    FreeFont(font_ID)
    
    If ActivateAutoFree_FW=1
      AddFrame_FW()
      AddSubFrame_1_FW()
      AddSubFrame_2_FW()
      AddSubFrame_3_FW()
      AddSubFrame_4_FW()
      AddImage_1_FW()
      AddImage_2_FW()
      AddImage_3_FW()
      ProgressBar_FW()
    EndIf
    
    If image=2 Or image=3
      ProcedureReturn image_ID
    EndIf
    
    ProcedureReturn 1
  EndProcedure
  
  Procedure GetUsedFontsize_FW()
    ProcedureReturn UsedFontsize_FW
  EndProcedure
  
  Procedure AdjustText_FW(AdjustText_FW_=0)
    If AdjustText_FW_<0 Or AdjustText_FW_>3
      AdjustText_FW_=0
    EndIf
    AdjustText_FW=AdjustText_FW_
    ProcedureReturn AdjustText_FW
  EndProcedure
  
  Procedure GetAdjustTextState_FW()
    ProcedureReturn AdjustText_FW
  EndProcedure
  
  Procedure DrawGLTextImage_FW(gadget_ID,           ; Gadget ID
                               font$,               ; Font
                               font_flag,           ; Font flag
                               output_x,            ; Output x
                               output_y,            ; Output y
                               output_width,        ; Output width
                               output_height,       ; Output height
                               text_color=#White,   ; Text color - Alpha channel sensitive
                               text_adjustment=1,   ; Text adjustment - 0=center - 1=left - 2=right
                               background_color=-1, ; Background color - Alpha channel sensitive
                               text$="",            ; Text
                               padding_x=0,         ; Padding x
                               padding_y=0,         ; Padding y
                               resize_factor.f=1.0) ; Resize factor - float
    
    If output_x<0 : Protected output_x_=output_x : output_x=0 : EndIf : If output_y<0 : Protected output_y_=output_y : output_y=0 : EndIf
    output_width*DesktopResolutionX() : output_height*DesktopResolutionX()
    
    CompilerIf #PB_Compiler_OS=#PB_OS_Windows
      CreateImage_FW=1
    CompilerElse
      CreateImage_FW=2
    CompilerEndIf
    
    If Not Alpha(background_color) : background_color=$FF000000|background_color : EndIf
    
    Protected image_ID=DrawText_FW(-1,               ; output_ID 
                                   font$,            ; Font
                                   font_flag,        ; Font flag
                                   output_x_,        ; Output x pos
                                   output_y_,        ; Output y pos
                                   output_width,     ; Output width
                                   output_height,    ; Output height
                                   text_color,       ; Text color
                                   text_adjustment,  ; Text adjustment - 0=center - 1=left - 2=right
                                   background_color, ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                   Text$,            ; Text
                                   padding_x,        ; Padding x
                                   padding_y,        ; Padding y
                                   resize_factor)    ; resize_factor.f
    
    CreateImage_FW=0
    
    If Not IsImage(image_ID) : ProcedureReturn image_ID : EndIf
    
    If CreateMaskedAlphaImage_FW
      Protected image_1_ID=CreateMaskedAlphaImage(image_ID)
      FreeImage(image_ID)
      image_ID=image_1_ID
      If Not IsImage(image_ID) : ProcedureReturn -6 : EndIf
    EndIf
    
    ; Mirroring 
    CompilerIf #PB_Compiler_OS<>#PB_OS_Windows
      Protected i, ii, iii
      If StartDrawing(ImageOutput(image_ID))
        Protected *buffer=DrawingBuffer()
        Protected pitch=DrawingBufferPitch()
        Protected *line_buffer_1=AllocateMemory(pitch)
        Protected *line_buffer_2=AllocateMemory(pitch)
        Protected lines=ImageHeight(image_ID)
        StopDrawing()
        ii=pitch*lines
        lines>>1-1
        For i=0 To lines
          ii-pitch
          CopyMemory(*buffer+iii, *line_buffer_1, pitch)
          CopyMemory(*buffer+ii, *line_buffer_2, pitch)
          CopyMemory(*line_buffer_1, *buffer+ii, pitch)
          CopyMemory(*line_buffer_2, *buffer+iii, pitch)      
          iii+pitch
        Next i
        FreeMemory(*line_buffer_1)
        FreeMemory(*line_buffer_2)
      Else
        FreeImage(image_ID)
        ProcedureReturn -4
      EndIf
    CompilerEndIf
    
    If IsGadget(gadget_ID)
      If StartDrawing(ImageOutput(image_ID))
        glPushMatrix_()
        glOrtho_(0, GadgetWidth(gadget_ID), GadgetHeight(gadget_ID), 0, 0, 1)
        glRasterPos2i_(output_x, output_y+output_height/DesktopResolutionX())
        CompilerIf #PB_Compiler_OS<>#PB_OS_Windows
          glDrawPixels_(output_width, output_height, #GL_RGBA, #GL_UNSIGNED_BYTE, DrawingBuffer())
        CompilerElse
          glDrawPixels_(output_width, output_height, #GL_BGRA_EXT, #GL_UNSIGNED_BYTE, DrawingBuffer())
        CompilerEndIf
        glPopMatrix_()
        StopDrawing()
      Else
        ProcedureReturn -6
      EndIf
    Else
      FreeImage(image_ID)
      ProcedureReturn -25
    EndIf
    FreeImage(image_ID)
    ProcedureReturn 1
  EndProcedure
  
  Procedure CreateTextImage_FW(font$,               ; Font
                               font_flag,           ; Font flag
                               output_width,        ; Output width
                               output_height,       ; Output height
                               text_color=#White,   ; Text color - Alpha channel sensitive
                               text_adjustment=1,   ; Text adjustment - 0=center - 1=left - 2=right
                               background_color=-1, ; Background color - Alpha channel sensitive
                               text$="",            ; Text
                               padding_x=0,         ; Padding x
                               padding_y=0,         ; Padding y
                               resize_factor.f=1.0) ; Resize factor - float
    
    CreateImage_FW=1
    
    If Not Alpha(background_color) : background_color=$FF000000|background_color : EndIf
    
    Protected image_ID=DrawText_FW(-1,               ; output_ID 
                                   font$,            ; Font
                                   font_flag,        ; Font flag
                                   0,                ; Output x pos
                                   0,                ; Output y pos
                                   output_width,     ; Output width
                                   output_height,    ; Output height
                                   text_color,       ; Text color
                                   text_adjustment,  ; Text adjustment - 0=center - 1=left - 2=right
                                   background_color, ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                   Text$,            ; Text
                                   padding_x,        ; Padding x
                                   padding_y,        ; Padding y
                                   resize_factor)    ; resize_factor.f
    
    CreateImage_FW=0
    
    If CreateMaskedAlphaImage_FW
      Protected image_1_ID=CreateMaskedAlphaImage(image_ID)
      FreeImage(image_ID)
      ProcedureReturn image_1_ID
    EndIf
    
    If Not IsImage(image_ID) : ProcedureReturn -6 : EndIf
    
    ProcedureReturn image_ID
  EndProcedure
  
  Procedure CreateTextSprite_FW(modus,               ; #PB_Sprite_PixelCollision - #PB_Sprite_AlphaBlending
                                font$,               ; Font
                                font_flag,           ; Font flag
                                output_width,        ; Output width
                                output_height,       ; Output height
                                text_color=#White,   ; Text color - Alpha channel sensitive
                                text_adjustment=1,   ; Text adjustment - 0=center - 1=left - 2=right
                                background_color=-1, ; Background color
                                text$="",            ; Text
                                padding_x=0,         ; Padding x
                                padding_y=0,         ; Padding y
                                resize_factor.f=1.0) ; Resize factor - float
    
    Sprite_Mode_FW=modus
    CreateImage_FW=3
    
    Protected image_ID=DrawText_FW(-1,               ; output_ID 
                                   font$,            ; Font
                                   font_flag,        ; Font flag
                                   0,                ; Output x pos
                                   0,                ; Output y pos
                                   output_width,     ; Output width
                                   output_height,    ; Output height
                                   text_color,       ; Text color
                                   text_adjustment,  ; Text adjustment - 0=center - 1=left - 2=right
                                   background_color, ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                   Text$,            ; Text
                                   padding_x,        ; Padding x
                                   padding_y,        ; Padding y
                                   resize_factor)    ; resize_factor.f
    
    CreateImage_FW=0
    
    If Not IsSprite(image_ID) : ProcedureReturn image_ID : EndIf
    
    ProcedureReturn image_ID
  EndProcedure
  
  ; Headletter mode for any text output - You must daactivate again
  Procedure TextStretching_FW(Stretch_X_FW_=0, Stretch_Y_FW_=0)
    Stretch_X_FW=stretch_X_FW_
    Stretch_Y_FW=stretch_Y_FW_
    ProcedureReturn 1
  EndProcedure
  
  Procedure BackColor_FW(BackColor_FW_)
    BackColor_FW=BackColor_FW_
    ProcedureReturn 1
  EndProcedure
  
  Procedure GradientColor_Pos_FW(GradientColor_Pos_FW_.f, Gradient_Pos_Color_FW_)
    GradientColor_Pos_FW.f=GradientColor_Pos_FW_.f
    Gradient_Pos_Color_FW=Gradient_Pos_Color_FW_
    ProcedureReturn 1
  EndProcedure
  
  Procedure FrontColor_FW(FrontColor_FW_)
    FrontColor_FW=FrontColor_FW_
    ProcedureReturn 1
  EndProcedure
  
  Procedure LinearGradient_FW(ActivateLinearGradient_FW_=0,
                              LinearGradient_X_FW_=0,
                              LinearGradient_Y_FW_=0,
                              LinearGradient_XX_FW_=0,
                              LinearGradient_YY_FW_=0)
    ActivateLinearGradient_FW=ActivateLinearGradient_FW_
    LinearGradient_X_FW=LinearGradient_X_FW_
    LinearGradient_Y_FW=LinearGradient_Y_FW_
    LinearGradient_XX_FW=LinearGradient_XX_FW_
    LinearGradient_YY_FW=LinearGradient_YY_FW_
    ProcedureReturn 1
  EndProcedure
  
  Procedure TextColor_Line_FW(Line_FW_=0, LineColor_FW_=-1)
    If Not Alpha(LineColor_FW_)
      LineColor_FW_|$FF000000
    EndIf
    If Line_FW_>0 And Line_FW_<=ArraySize(LineColorArray())
      LineColorArray(Line_FW_)=LineColor_FW_
      ProcedureReturn 1
    EndIf
    ProcedureReturn 0
  EndProcedure
  
  Procedure ResetTextColor_Lines_FW()    
    FillMemory(@LineColorArray(1), ArraySize(LineColorArray()), $FF)
    ProcedureReturn 1
  EndProcedure
  
  Procedure ProgressBar_FW(x=0,
                           y=0,
                           width.f=0,
                           height.f=0,
                           min=0,
                           max=0,
                           state=0,
                           foreground_color=#Green,
                           background_color=$BBBBBB,
                           alpha=0,
                           flag=0) ; 1 = vertical
    ProgressBar_X_FW=x
    ProgressBar_Y_FW=y
    ProgressBar_Width_FW=width
    ProgressBar_Height_FW=height
    ProgressBar_Min_FW=min
    ProgressBar_Max_FW=max
    ProgressBar_State_FW=state
    ProgressBar_Foreground_Color_FW=foreground_color
    ProgressBar_Background_Color_FW=background_color
    ProgressBar_Alpha_FW=alpha
    ProgressBar_Flag_FW=flag
    ProcedureReturn 1
  EndProcedure
  
  Procedure GetCursor_X_FW()
    ProcedureReturn GetCursor_X_FW
  EndProcedure
  
  Procedure GetCursor_Y_FW()
    ProcedureReturn GetCursor_Y_FW
  EndProcedure
  
  Procedure SetCursor_X_FW(GetCursor_X_FW_)
    GetCursor_X_FW=GetCursor_X_FW_
    ProcedureReturn GetCursor_X_FW
  EndProcedure
  
  Procedure SetCursor_Y_FW(GetCursor_Y_FW_)
    GetCursor_Y_FW=GetCursor_Y_FW_
    ProcedureReturn GetCursor_Y_FW
  EndProcedure
  
  Procedure SetOffsetCursor_X_FW(OffsetCursor_X_FW_)
    OffsetCursor_X_FW=OffsetCursor_X_FW_
    ProcedureReturn OffsetCursor_X_FW
  EndProcedure
  
  Procedure SetOffsetCursor_Y_FW(OffsetCursor_Y_FW_)
    OffsetCursor_Y_FW=OffsetCursor_Y_FW_
    ProcedureReturn OffsetCursor_Y_FW
  EndProcedure 
  
  Procedure AddImage_1_FW(Image_1_ID_FW_=-1,
                          Image_1_x_FW_=0,
                          Image_1_y_FW_=0,
                          Image_1_width_FW_=0,
                          Image_1_height_FW_=0,
                          Image_1_alpha_FW_=255)
    Image_1_ID_FW=Image_1_ID_FW_
    Image_1_x_FW=Image_1_x_FW_
    Image_1_y_FW=Image_1_y_FW_
    Image_1_width_FW=Image_1_width_FW_
    Image_1_height_FW=Image_1_height_FW_
    Image_1_alpha_FW=Image_1_alpha_FW_
    ProcedureReturn Image_1_ID_FW
  EndProcedure
  
  Procedure AddImage_2_FW(Image_2_ID_FW_=-1,
                          Image_2_x_FW_=0,
                          Image_2_y_FW_=0,
                          Image_2_width_FW_=0,
                          Image_2_height_FW_=0,
                          Image_2_alpha_FW_=255)
    Image_2_ID_FW=Image_2_ID_FW_
    Image_2_x_FW=Image_2_x_FW_
    Image_2_y_FW=Image_2_y_FW_
    Image_2_width_FW=Image_2_width_FW_
    Image_2_height_FW=Image_2_height_FW_
    Image_2_alpha_FW=Image_2_alpha_FW_
    ProcedureReturn Image_1_ID_FW
  EndProcedure
  
  Procedure AddImage_3_FW(Image_3_ID_FW_=-1,
                          Image_3_x_FW_=0,
                          Image_3_y_FW_=0,
                          Image_3_width_FW_=0,
                          Image_3_height_FW_=0,
                          Image_3_alpha_FW_=255)
    Image_3_ID_FW=Image_3_ID_FW_
    Image_3_x_FW=Image_3_x_FW_
    Image_3_y_FW=Image_3_y_FW_
    Image_3_width_FW=Image_3_width_FW_
    Image_3_height_FW=Image_3_height_FW_
    Image_3_alpha_FW=Image_3_alpha_FW_
    ProcedureReturn Image_3_ID_FW
  EndProcedure
  
  Procedure PresetFontsize_FW(PresetFontsize_FW_=0)
    PresetFontsize_FW=PresetFontsize_FW_
    ProcedureReturn PresetFontsize_FW
  EndProcedure
  
  Procedure PresetMinFontsize_FW(PresetMinFontsize_FW_=0)
    PresetMinFontsize_FW=PresetMinFontsize_FW_
    ProcedureReturn PresetMinFontsize_FW
  EndProcedure
  
  Procedure PresetMaxFontsize_FW(PresetMaxFontsize_FW_=0)
    PresetMaxFontsize_FW=PresetMaxFontsize_FW_
    ProcedureReturn PresetMaxFontsize_FW
  EndProcedure
  
  ; Auto free accessories after output
  Procedure ActivateAutoFree_FW(ActivateAutoFree_FW_=0)
    ActivateAutoFree_FW=ActivateAutoFree_FW_
    ProcedureReturn ActivateAutoFree_FW
  EndProcedure
  
  Procedure FreeGadget_FW(gadget_ID)
    ForEach(gadget_bf())
      If (gadget_bf()\gadget_ID)=gadget_ID
        If IsFont(gadget_bf()\font_ID)
          FreeFont(gadget_bf()\font_ID)
        EndIf
        If IsImage(gadget_bf()\image_ID)
          FreeImage(gadget_bf()\image_ID)
        EndIf
        If IsGadget(gadget_bf()\gadget_ID)
          FreeGadget(gadget_bf()\gadget_ID)
        EndIf
        gadget_bf()\text$=#Null$
        DeleteElement(gadget_bf())
        ProcedureReturn 1
      EndIf
    Next
    ProcedureReturn 0
  EndProcedure
  
  Procedure FreeAllGadgets_FW(mode=0)
    Protected result
    If Not mode
      ForEach(gadget_BF())
        If IsFont(gadget_bf()\font_ID)
          FreeFont(gadget_bf()\font_ID)
        EndIf
        If IsImage(gadget_bf()\image_ID)
          FreeImage(gadget_bf()\image_ID)
        EndIf
        If IsGadget(gadget_bf()\gadget_ID)
          FreeGadget(gadget_bf()\gadget_ID)
          gadget_bf()\text$=#Null$
          result+1
        EndIf 
      Next
      ClearList(gadget_bf())
      ProcedureReturn result
    ElseIf mode=1
      ProcedureReturn ListSize(gadget_bf())
    EndIf
  EndProcedure
  
  Procedure GetGadgetImage_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\image_ID
      EndIf
    Next
    ProcedureReturn -1
  EndProcedure
  
  Procedure.s GetGadgetText_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\text$
      EndIf
    Next
    ProcedureReturn ""
  EndProcedure
  
  Procedure GetGadgetTextColor_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\text_color
      EndIf
    Next
    ProcedureReturn -1
  EndProcedure
  
  Procedure GetGadgetBackgroundColor_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\background_color
      EndIf
    Next
    ProcedureReturn -1
  EndProcedure
  
  Procedure GetGadgetPadding_X_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\padding_x/2
      EndIf
    Next
    ProcedureReturn 0
  EndProcedure
  
  Procedure GetGadgetPadding_Y_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\padding_y/2
      EndIf
    Next
    ProcedureReturn 0
  EndProcedure
  
  Procedure GetGadgetFontsize_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\used_fontsize
      EndIf
    Next
    ProcedureReturn 0
  EndProcedure
  
  Procedure GetGadgetStretch_X_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\stretch_x
      EndIf
    Next
    ProcedureReturn 0
  EndProcedure
  
  Procedure GetGadgetStretch_Y_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\stretch_y
      EndIf
    Next
    ProcedureReturn 0
  EndProcedure
  
  Procedure GetGadgetType_FW(gadget_ID)
    ForEach(gadget_bf())
      If gadget_bf()\gadget_ID=gadget_ID
        ProcedureReturn gadget_bf()\gadget_type
      EndIf
    Next
    ProcedureReturn -1
  EndProcedure
  
EndModule
UseModule FontWizzard_BF

CompilerIf #PB_Compiler_IsMainFile
  MessageRequester("FontWizzard_BF", "This is only the Module"+#LF$+#LF$+
                                     "So you see nothing !")
CompilerEndIf
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 1973
; FirstLine = 1949
; Folding = --------------
; DPIAware