﻿; FontWizzard_BF - Demo code
XIncludeFile("./FontWizzard_BF.pbi")
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define scaling.f=1.5 ; List output size

Define DR.f=DesktopResolutionX(), i

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1000, 600, "Font_Wizzard_BF", #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
SetGadgetColor(canvas_ID, #PB_Gadget_BackColor, $CDCDCD)
scaling*DR

Define x=80*scaling ; List output x pos
Define y=80*scaling ; List output y pos

Procedure DrawText_FW_1(canvas_ID,    ; output_ID
                        font$,        ; Font$
                        x,            ; output_x
                        y,            ; output_y
                        content_left, ; background_color or numbering
                        text$,        ; text$
                        text1$,       ; Text1$
                        scaling.f)    ; resize_factor.f
  
  If content_left<255
    Protected text_left$=Str(content_left)
    Protected background_color=#White
  Else
  background_color=content_left : EndIf
  Protected padding_x=-20/scaling
  Protected padding_y=-3/scaling
  
  Protected old_AdjustText_FW=GetAdjustTextState_FW()
  
  ; Adjust the DrawText_FW output rectangle and its content
  ; 0 Sets the output centered
  ; 1 Sets the output left
  ; 2 Sets the cursor position before the output and makes the output to the right
  ; 3 Sets the cursor position behind the output and makes the output to the left
  AdjustText_FW(0)
  
  AddFrame_FW(2*scaling, $90000000, 5*scaling)
  
  Protected result=DrawText_FW(canvas_ID,        ; output_ID
                               font$,            ; Font$
                               0,                ; font_flag
                               x,                ; output_x
                               y,                ; output_y
                               40*scaling,       ; output_width
                               30*scaling,       ; output_height
                               #Black,           ; text_color
                               0,                ; text_adjustment
                               background_color, ; background_color -1 = invisible
                               text_left$,       ; text$
                               padding_x,        ; padding_x
                               padding_y)        ; padding_y
  
  If result<1
    AdjustText_FW(old_AdjustText_FW)
    ProcedureReturn result
  EndIf
  
  AdjustText_FW(1)
  
  result=DrawText_FW(canvas_ID,                   ; output_ID
                     "",                          ; Font$
                     0,                           ; font_flag
                     GetCursor_X_FW()+4*scaling,  ; output_x
                     GetCursor_Y_FW()-30*scaling, ; output_y
                     200*scaling,                 ; output_width
                     30*scaling,                  ; output_height
                     #Black,                      ; text_color
                     0,                           ; text_adjustment
                     -1,                          ; background_color -1 = invisible
                     text$,                       ; text$
                     padding_x,                   ; padding_x
                     padding_y)                   ; padding_y
  
  If result<1
    AdjustText_FW(old_AdjustText_FW)
    ProcedureReturn result
  EndIf
  
  AdjustText_FW(2)
  
  AddFrame_FW(2*scaling, $90000000, 5*scaling)
  
  result=DrawText_FW(canvas_ID,                   ; output_ID
                     font$,                       ; Font$
                     0,                           ; font_flag
                     GetCursor_X_FW()+4*scaling,  ; output_x
                     GetCursor_Y_FW()-30*scaling, ; output_y
                     100*scaling,                 ; output_width
                     30*scaling,                  ; output_height
                     #Black,                      ; text_color
                     0,                           ; text_adjustment
                     -1,                          ; background_color -1 = invisible
                     text1$,                      ; text$
                     padding_x,                   ; padding_x
                     padding_y)                   ; padding_y
  
  
  AdjustText_FW(old_AdjustText_FW)
  ProcedureReturn result
  
EndProcedure

; ####### Get it #######

Define text$="Adjusted text"
Define text1$="100"
DrawText_FW_1(canvas_ID, ; output_ID
              "",        ; Font$
              x,         ; output_x
              y,         ; output_y
              1,         ; background_color or numbering
              text$,     ; text$
              text1$,    ; text$
              scaling)   ; resize_factor.f

Define text$="Adjusted values"
Define text1$="1.011"
DrawText_FW_1(canvas_ID,                  ; output_ID
              "",                         ; Font$
              x,                          ; output_x
              GetCursor_Y_FW()+5*scaling, ; output_y
              #Red,                       ; background_color or numbering
              text$,                      ; text$
              text1$,                     ; text1$
              scaling)                    ; resize_factor.f
                                          ;
Define text$="Autamatically sizes"
Define text1$="11.222"
DrawText_FW_1(canvas_ID,                  ; output_ID
              "",                         ; Font$
              x,                          ; output_x
              GetCursor_Y_FW()+5*scaling, ; output_y
              2,                          ; background_color or numbering
              text$,                      ; text$
              text1$,                     ; text1$
              scaling)                    ; resize_factor.f

Define text$="Auto fitted text"
Define text1$="123.10333"
DrawText_FW_1(canvas_ID,                  ; output_ID
              "",                         ; Font$
              x,                          ; output_x
              GetCursor_Y_FW()+5*scaling, ; output_y
              #Green,                     ; background_color or numbering
              text$,                      ; text$
              text1$,                     ; text1$
              scaling)                    ; resize_factor.f

HideWindow(window_ID, 0)
Repeat
Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 105
; FirstLine = 5
; Folding = -
; EnableXP
; DPIAware