﻿; FontWizzard_BF - Demo code - Formatted lists
XIncludeFile("./FontWizzard_BF.pbi")
EnableExplicit

Define DR.f=DesktopResolutionX(), i

Define scaling.f=1.0    ; List output size
Define x=130*scaling*DR ; List output x pos
Define y=80*scaling*DR  ; List output y pos

Define window_ID=OpenWindow(#PB_Any, 0, 0, 950*scaling, 600*scaling, "Font_Wizzard_BF", #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
SetGadgetColor(canvas_ID, #PB_Gadget_BackColor, $CDCDCD)

Define text$="DrawText_FW"+#LF$+"Solves the ugly problem with right-aligned text output"
DrawText_FW(canvas_ID,    ; output_ID
          "",             ; Font$
          #PB_Font_Bold,  ; font_flag
          130*scaling*DR, ; output_x
          10*scaling*DR,  ; output_y
          680*scaling*DR, ; output_width
          60*scaling*DR,  ; output_height
          #Black,         ; text_color
          0,              ; text_adjustment
          -1,             ; background_color -1 = invisible
          text$,          ; text$
          0,              ; padding_x
          0,              ; padding_y
          1)              ; resize_factor.f

; Activate LinearGradient
FrontColor_FW(#Red)
GradientColor_Pos_FW(0.5, #Blue)
LinearGradient_FW(1, 0, 0, x*2, 0)

Define background_color=#Yellow
TextColor_Line_FW(1, #Blue) ; Set Line 1 blue
SetCursor_Y_FW(y)
For i=1 To 10
  If i>3
    TextColor_Line_FW(1, -1) ; Deactivate again
    PresetMaxFontsize_FW(12*scaling)
  EndIf 
  If i>7
    Define background_color=-1
  EndIf
  DrawText_FW(canvas_ID,      ; output_ID
            "",               ; Font$
            0,                ; font_flag
            x,                ; output_x
            GetCursor_Y_FW(), ; output_y
            145*scaling*DR,   ; output_width
            45*scaling*DR,    ; output_height
            #Black,           ; text_color
            1,                ; text_adjustment
            background_color, ; background_color -1 = invisible
            "Hello World",    ; text$
            -16,              ; padding_x
            -5,               ; padding_y
            1)                ; resize_factor.f
Next i

LinearGradient_FW() ; Deactivate again
Define x=GetCursor_X_FW()
SetCursor_Y_FW(y)
For i=1 To 10
  DrawText_FW(canvas_ID,      ; output_ID
            "",               ; Font$
            0,                ; font_flag
            x,                ; output_x
            GetCursor_Y_FW(), ; output_y
            100*scaling*DR,   ; output_width
            25*scaling*DR,    ; output_height
            #Black,           ; text_color
            1,                ; text_adjustment - 0=center - 1=left - 2=right
            -1,               ; background_color - -1 = invisible
            "How are you",    ; text$
            -16,              ; padding_x
            -5,               ; padding_y
            1)                ; resize_factor.f
Next i

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(1, 1)

TextColor_Line_FW(2, #Red)
Define x=GetCursor_X_FW()
SetCursor_Y_FW(y)
Define text$="Hello World"+#LF$+"We hope you are well"
For i=1 To 10
  DrawText_FW(canvas_ID,      ; output_ID
            "",               ; Font$
            0,                ; font_flag
            x,                ; output_x
            GetCursor_Y_FW(), ; output_y
            180*scaling*DR,   ; output_width
            45*scaling*DR,    ; output_height
            #Black,           ; text_color
            1,                ; text_adjustment - 0=center - 1=left - 2=right
            -1,               ; background_color - -1 = invisible
            text$,            ; text$
            -16,              ; padding_x
            -5,               ; padding_y
            1)                ; resize_factor.f
Next i

Define text_color=#White
Define background_color=#Blue
Define x=GetCursor_X_FW()
Define output_height=45
SetCursor_Y_FW(y)
For i=1 To 9
  
  ; Adjust the DrawText_FW output rectangle and its content
  ; 0 Sets the output centered
  ; 1 Sets the output left
  ; 2 Sets the cursor position before the output and makes the output to the right
  ; 3 Sets the cursor position behind the output and makes the output to the left
  AdjustText_FW(2)
  
  Select i
    Case 1
      Define text$="Created with FontWizzard_BF" 
    Case 2
      Define text$="A new way for text output on PB"
    Case 3
      Define text$="All you can eat"+#LF$+"Many advanced features"
    Case 4
      Define adjust=1
    Case 5
      Define adjust=2
    Case 6
      PresetMaxFontsize_FW()
    Case 8
      Define output_height=60
      Define text_color=#Black
      Define background_color=-1
      TextColor_Line_FW(2, -1)
    Case 9
      AddFrame_FW(2*scaling*DR, #Black)
      Define text_color=#Blue
      Define output_height=80
      text$="Any text will be supported"+#LF$+
            "No matter how many lines"+#LF$+
            "How big, left, centered"+#LF$+
            "Right aligned or headline"
      adjust=2
  EndSelect
  DrawText_FW(canvas_ID,              ; output_ID
            "",                       ; Font$
            0,                        ; font_flag
            x,                        ; output_x
            GetCursor_Y_FW(),         ; output_y
            250*scaling*DR,           ; output_width
            output_height*scaling*DR, ; output_height
            text_color,               ; text_color
            adjust,                   ; text_adjustment - 0=center - 1=left - 2=right
            background_color,         ; background_color - -1 = invisible
            text$,                    ; text$
            -16,                      ; padding_x
            -5,                       ; padding_y
            1)                        ; resize_factor.f
Next i

HideWindow(window_ID, 0)
Repeat
Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 24
; EnableXP
; DPIAware
; DisableDebugger