﻿; FontWizzard_BF Text as a Image with transparence Background on a WindowedScreen - Demo code

XIncludeFile("./FontWizzard_BF.pbi")

; ##############  Simple WindowedScreen FontWizzard_BF Demo - DPI aware - All OS ############
EnableExplicit

UseJPEGImageDecoder()
UsePNGImageDecoder()

Define DR.f=DesktopResolutionX()

Define image_1_ID=LoadImage(#PB_Any, "./Image_Set/PureBasicLogo.bmp")
Define image_2_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
Define image_3_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha5.png")
Define window_ID=OpenWindow(#PB_Any, 0, 0, 500, 370, "FW Text as Image with transparence on a WindowedScreen", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
Define gadget_ID=OpenWindowedScreen(WindowID(window_ID), 0, 0, WindowWidth(window_ID)*DR, WindowHeight(window_ID)*DR)

If IsImage(image_2_ID)
  ResizeImage(image_2_ID, WindowWidth(window_ID)*DR, WindowHeight(window_ID)*DR)
EndIf

; ----------------------------------------------------------

Define text$="Hello World"+#LF$+"This is a advanced text output"

; Activate LinearGradient ; Works here Windows only
FrontColor_FW($FFFF)
BackColor_FW($FFFF)
GradientColor_Pos_FW(0.5, #Red)
LinearGradient_FW(1, 0, 0, 480*DR, 90*DR)
CreateMaskedAlphaImage_FW(1, $000001) ; Use this so for creating a image with invisible background and GradientColor
                                      ; - The function make a defined color invisible

TextStretching_FW(1*DR, 2*DR) ; Headletter mode for any text output - You must daactivate again - X, Y

CompilerIf #PB_Compiler_OS<>#PB_OS_MacOS
 Define background_color=$000001 ; Look above, black is reserved - CreateMaskedAlphaImage_FW(1, $000001)
CompilerElse
 Define background_color=-1
CompilerEndIf

AddFrame_FW(2*DR, #Red, 6*DR) ; AddFrame_Size_FW, AddFrame_Color_FW
Define text_sprite_1_ID=CreateTextImage_FW("",               ; Font
                                           #PB_Font_Bold,    ; Font flag
                                           300*DR,           ; Output width
                                           60*DR,            ; Output height
                                           #Red,             ; Text color
                                           1,                ; Text adjustment - 0=center - 1=left - 2=right
                                           background_color, ; Background_color
                                           text$,            ; Text
                                           12*DR,            ; Padding x
                                           2*DR,             ; Padding y
                                           1.0)              ; Resize factor

TextStretching_FW(1*DR, 10*DR) ; Headletter mode for any text output - You must daactivate again - X, Y

text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"With incredible HEADLETTER mode"
AddFrame_FW() ; Remove the frame

Define text_sprite_2_ID=CreateTextImage_FW("Georgia",        ; Font
                                           #PB_Font_Bold,    ; Font flag
                                           480*DR,           ; Output width
                                           110*DR,           ; Output height
                                           #Red,             ; Text color
                                           0,                ; Text adjustment - 0=center - 1=left - 2=right
                                           background_color, ; Background_color
                                           text$,            ; Text
                                           -12/DR,           ; Padding x
                                           2*DR,             ; Padding y
                                           1.0)              ; Resize factor

LinearGradient_FW() ; Deactivate again
CreateMaskedAlphaImage_FW() ; Deactivate again

TextStretching_FW(1*DR, 2*DR) ; Headletter mode for any text output - You must daactivate again - X, Y

text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"Try any Text"
text$+#LF$+#LF$+"Have fun"
AddFrame_FW(3*DR, #Red, 8*DR) ; AddFrame_Size_FW, AddFrame_Color_FW
AddImage_1_FW(image_1_ID,
              252*DR, ; x pos
              88*DR,  ; y pos
              140*DR, ; Width
              25*DR,  ; Height
              255)    ; Alpha

AddImage_2_FW(image_2_ID,
              3*DR,   ; x pos
              3*DR,   ; y pos
              394*DR, ; Width
              114*DR, ; Height
              80)     ; Alpha

AddImage_3_FW(image_3_ID,
              -10*DR, ; x pos
              30*DR,  ; y pos
              110*DR, ; Width
              100*DR, ; Height
              255)    ; Alpha

AddSubFrame_1_FW(140*DR,
                 75*DR,
                 120*DR,
                 3*DR,
                 -1, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                 $000055FF)

TextColor_Line_FW(1, #Blue)
TextColor_Line_FW(2, #Black)
TextColor_Line_FW(3, #Yellow)

Define text_sprite_3_ID=CreateTextImage_FW("Georgia",     ; Font
                                           #PB_Font_Bold, ; Font flag
                                           400*DR,        ; Output width
                                           120*DR,        ; Output height
                                           #Red,          ; Text color
                                           0,             ; Text adjustment - 0=center - 1=left - 2=right
                                           #Green,        ; Background_color
                                           text$,         ; Text
                                           12*DR,         ; Padding x
                                           2*DR,          ; Padding y
                                           1.0)           ; Resize factor
AddImage_1_FW()                                           ; Remove additional image 1

; ============== Output the result ================

Repeat
  Delay(10) 
  
  Repeat
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow 
      End
    EndIf
  Until Not win_event
  
  FlipBuffers()
  ClearScreen (#Blue)
  
  StartDrawing(ScreenOutput())
  If image_2_ID
    DrawAlphaImage(ImageID(image_2_ID), 0, 0, 80)
  EndIf
  DrawAlphaImage(ImageID(text_sprite_1_ID),
                 100*DR, ; Output x pos
                 20*DR)  ; Output y pos
  
  DrawAlphaImage(ImageID(text_sprite_2_ID),
                 10*DR,  ; Output x pos
                 100*DR) ; Output y pos
  
  DrawAlphaImage(ImageID(text_sprite_3_ID),
                 50*DR,  ; Output x pos
                 230*DR) ; Output y pos
  StopDrawing()
  
ForEver
; IDE Options = PureBasic 5.73 LTS (Linux - x64)
; CursorPosition = 39
; FirstLine = 26
; Folding = -
; EnableXP
; EnableUser
; DPIAware