﻿; FontWizzard_BF Text as PB Sprite on a WindowedScreen - Demo code

XIncludeFile("./FontWizzard_BF.pbi")

UsePNGImageDecoder()
UseJPEGImageDecoder()

; ##############  Simple WindowedScreen FontWizzard_BF Demo - DPI aware - All OS ############
EnableExplicit

Define DR.f=DesktopResolutionX()

Define image_1_ID=LoadImage(#PB_Any, "./Image_Set/PureBasicLogo.bmp")
Define image_2_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha4.png")
Define window_ID=OpenWindow(#PB_Any, 0, 0, 650, 370, "FW Text as PB Sprite on a WindowedScreen", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
Define gadget_ID=OpenWindowedScreen(WindowID(window_ID), 0, 0, WindowWidth(window_ID)*DR, WindowHeight(window_ID)*DR)

; ----------------------------------------------------------

TextStretching_FW(1*DR, 1*DR) ; Headletter mode for any text output - You must daactivate again - X, Y

Define text$="This is a advanced text output"+#LF$+"As sprite on screen"
; Add a frame to all outputs - Padding is automatically adjusted - Alpha channel sensitive - Sample $8000FFFF

AddFrame_FW(2*DR, #Red) ; AddFrame_Size_FW, AddFrame_Color_FW

AddImage_1_FW(image_2_ID,
              345*DR, ; x pos
              7*DR,   ; y pos
              110*DR, ; Width
              80*DR,  ; Height
              255)    ; Alpha

Define text_sprite_1_ID=CreateTextSprite_FW(#PB_Sprite_AlphaBlending, ; #PB_Sprite_PixelCollision - #PB_Sprite_AlphaBlending
                                            "",                       ; Font
                                            #PB_Font_Bold,            ; Font flag
                                            410*DR,                   ; Output width
                                            60*DR,                    ; Output height
                                            #White,                   ; Text color
                                            1,                        ; Text adjustment - 0=center - 1=left - 2=right
                                            0,                        ; Background_color
                                            text$,                    ; Text
                                            12*DR,                    ; Padding x
                                            2*DR,                     ; Padding y
                                            1.0)                      ; Resize factor

text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"With included ProgressBar feature"
AddFrame_FW() ; Remove the frame
ProgressBar_FW(350*DR,  ; Offset X
               8*DR,    ; Offset Y
               100*DR,  ; Width
               20*DR,   ; Height
               0,       ; Min
               100,     ; Max
               60,      ; State
               #Green,  ; Foreground color
               #Yellow, ; Background color
               255,     ; Alpha
               0)       ; 1 = vertical

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  ; Activate LinearGradient
  FrontColor_FW($FFFF)
  BackColor_FW($FFFF)
  GradientColor_Pos_FW(0.5, #Green)
  LinearGradient_FW(1, 0, 0, 480*DR, 90*DR)
CompilerEndIf

Define text_sprite_2_ID=CreateTextSprite_FW(#PB_Sprite_AlphaBlending, ; #PB_Sprite_PixelCollision - #PB_Sprite_AlphaBlending
                                            "Georgia",                ; Font
                                            #PB_Font_Bold,            ; Font flag
                                            480*DR,                   ; Output width
                                            90*DR,                    ; Output height
                                            #Red,                     ; Text color
                                            0,                        ; Text adjustment - 0=center - 1=left - 2=right
                                            0,                        ; Background_color
                                            text$,                    ; Text
                                            -25/DR,                   ; Padding x
                                            5*DR,                     ; Padding y
                                            1.0)                      ; Resize factor
LinearGradient_FW()                                                   ; Deactivate again

text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"With incredible HEADLETTER Feature"
text$+#LF$+#LF$+"Have fun"
AddFrame_FW(3*DesktopResolutionX(), #Red) ; AddFrame_Size_FW, AddFrame_Color_FW
AddImage_1_FW(image_1_ID,
              252*DR, ; x pos
              88*DR,  ; y pos
              140*DR, ; Width
              25*DR,  ; Height
              255)    ; Alpha

Define text_sprite_3_ID=CreateTextSprite_FW(0, ; #PB_Sprite_PixelCollision - #PB_Sprite_AlphaBlending
                                            "Georgia",     ; Font
                                            #PB_Font_Bold, ; Font flag
                                            400*DR,        ; Output width
                                            120*DR,        ; Output height
                                            $FFFF0000,     ; Text color
                                            0,             ; Text adjustment - 0=center - 1=left - 2=right
                                            $FF00FF00,     ; Background_color
                                            text$,         ; Text
                                            12*DR,         ; Padding x
                                            2*DR,          ; Padding y
                                            1.0)           ; Resize factor
AddImage_1_FW()                                            ; Remove additional image 1

; ============== Output the result ================

SpriteQuality(#PB_Sprite_BilinearFiltering)
Repeat
  Delay(10) 
  
  Repeat
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow 
      End
    EndIf
  Until Not win_event
  
  FlipBuffers()
  ClearScreen (#Blue)
  
  TransparentSpriteColor(text_sprite_1_ID, #Black)
  DisplayTransparentSprite(text_sprite_1_ID,
                           100*DR, ; Output x pos
                           20*DR)  ; Output y pos
  
  TransparentSpriteColor(text_sprite_2_ID, #Black)
  RotateSprite(text_sprite_2_ID, 15, #PB_Absolute)
  DisplayTransparentSprite(text_sprite_2_ID,
                           170*DR, ; Output x pos
                           120*DR) ; Output y pos
  
  RotateSprite(text_sprite_3_ID, 25, #PB_Absolute)
  DisplaySprite(text_sprite_3_ID,
                20*DR,  ; Output x pos
                165*DR) ; Output y pos
  
ForEver
; IDE Options = PureBasic 5.73 LTS (Linux - x64)
; CursorPosition = 138
; FirstLine = 113
; Folding = -
; EnableXP
; EnableUser
; DPIAware