﻿; FontWizzard_BF Text as Image on a CanvasGadget - Demo code

XIncludeFile("./FontWizzard_BF.pbi")

; ##############  Simple OpenGLGadget FontWizzard_BF Demo - DPI aware - All OS ############
EnableExplicit

Define DR.f=DesktopResolutionX()

Define image_1_ID=LoadImage(#PB_Any, #PB_Compiler_Home+"/Examples/Sources/Data/PureBasicLogo.bmp")
Define window_ID=OpenWindow(#PB_Any, 0, 0, 500, 370, "FW Text as Image on a CanvasGadget", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
Define gadget_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

; ----------------------------------------------------------

SetGadgetColor(gadget_ID, #PB_Gadget_BackColor , #Blue) ; CanvasGadget color

Define text$="Hello World"+#LF$+"This is a advanced text output"
; Add a frame to all outputs - Padding is automatically adjusted - Alpha channel sensitive - Sample 

AddFrame_FW(2*DR, $FF0000FF, 4*DR) ; AddFrame_Size_FW, AddFrame_Color_FW

Define text_image_1_ID=CreateTextImage_FW("",            ; Font
                                          #PB_Font_Bold, ; Font flag
                                          300*DR,        ; Output width
                                          60*DR,         ; Output height
                                          #White,        ; Text color
                                          1,             ; Text adjustment - 0=center - 1=left - 2=right
                                          -1,            ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                          text$,         ; Text
                                          12*DR,         ; Padding x
                                          2*DR,          ; Padding y
                                          1.0)           ; Resize factor

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(4, 4)

text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"With incredible HEADLETTER Feature"
AddFrame_FW() ; Remove the frame

; Activate LinearGradient
FrontColor_FW($FFFF)
BackColor_FW($FFFF)
GradientColor_Pos_FW(0.5, #Green)
LinearGradient_FW(1, 0, 0, 480*DR, 90*DR)

Define text_image_2_ID=CreateTextImage_FW("Georgia",     ; Font
                                          #PB_Font_Bold, ; Font flag
                                          480*DR,        ; Output width
                                          90*DR,         ; Output height
                                          #Red,          ; Text color
                                          0,             ; Text adjustment - 0=center - 1=left - 2=right
                                          #Blue,         ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                          text$,         ; Text
                                          -12/DR,        ; Padding x
                                          2/DR,          ; Padding y
                                          1.0)           ; Resize factor

TextStretching_FW() ; Deactivate again 

LinearGradient_FW() ; Deactivate again

text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"Try any Text"
text$+#LF$+#LF$+"Have fun"
AddFrame_FW(3*DR, #Red) ; AddFrame_Size_FW, AddFrame_Color_FW
AddImage_1_FW(image_1_ID,
              252*DR, ; x pos
              88*DR,  ; y pos
              140*DR, ; Width
              25*DR,  ; Height
              255)    ; Alpha

Define text_image_3_ID=CreateTextImage_FW("Georgia",     ; Font
                                          #PB_Font_Bold, ; Font flag
                                          400*DR,        ; Output width
                                          120*DR,        ; Output height
                                          #Blue,         ; Text color
                                          0,             ; Text adjustment - 0=center - 1=left - 2=right
                                          #Green,        ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                                          text$,         ; Text
                                          12*DR,         ; Padding x
                                          2*DR,          ; Padding y
                                          1.0)           ; Resize factor
AddImage_1_FW()                                          ; Remove additional image 1

; ============== Output the result ================

StartDrawing(CanvasOutput(gadget_ID))

DrawAlphaImage(ImageID(text_image_1_ID),
               100*DR, ; Output x pos
               20*DR)  ; Output y pos

DrawAlphaImage(ImageID(text_image_2_ID),
               10*DR,  ; Output x pos
               110*DR) ; Output y pos

DrawAlphaImage(ImageID(text_image_3_ID),
               50*DR,  ; Output x pos
               230*DR) ; Output y pos

StopDrawing()
Repeat
  Define win_event=WaitWindowEvent()
Until win_event=#PB_Event_CloseWindow 

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 52
; FirstLine = 34
; EnableXP
; EnableUser
; DPIAware