﻿; FontWizzard_BF on OpenGLGadget - Demo code

XIncludeFile("./FontWizzard_BF.pbi")

; ##############  Simple OpenGLGadget FontWizzard_BF Demo - DPI aware - All OS ############
EnableExplicit

Define DR.f=DesktopResolutionX()

UseJPEGImageDecoder()

; Define image_1_ID=LoadImage(#PB_Any, #PB_Compiler_Home+"/Examples/Sources/Data/PureBasicLogo.bmp")
Define image_1_ID=LoadImage(#PB_Any, "./Image_Set/PureBasicLogo.bmp")
Define image_2_ID=LoadImage(#PB_Any, "./Image_Set/Polynesia.jpg")
Define window_ID=OpenWindow(#PB_Any, 0, 0, 700, 370, "FW Text on a OpenGLGadget", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
Define gadget_ID=OpenGLGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

; ----------------------------------------------------------

Repeat
  Delay(10) 
  
  Repeat
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow 
      End
    EndIf
  Until Not win_event
  
  SetColorOpenGLGadget_FW(#Blue) ; OpenGLGadget color
  
  Define text$="Hello World"+#LF$+"This is a advanced text output"
  ; Add a frame to all outputs - Padding is automatically adjusted - Alpha channel sensitive - Sample $8000FFFF
  AddFrame_FW(2*DesktopResolutionX(), $FF0000FF) ; AddFrame_Size_FW, AddFrame_Color_FW
  
  ; Activate LinearGradient
  FrontColor_FW($FFFF)
  BackColor_FW($FFFF)
  GradientColor_Pos_FW(0.5, #Green)
  LinearGradient_FW(1, 0, 0, 480*DR, 90*DR)
  CreateMaskedAlphaImage_FW(1, $000001) ; Use this so for creating a image with invisible background and GradientColor
                                        ; - The function make a defined color invisible
  
  DrawGLTextImage_FW(gadget_ID,     ; Gadget ID
                     "",            ; Font
                     #PB_Font_Bold, ; Font flag
                     155,           ; Output x pos
                     20,            ; Output y pos
                     400,           ; Output width
                     60,            ; Output height
                     #White,        ; Text color
                     1,             ; Text adjustment - 0=center - 1=left - 2=right
                     $000001,       ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                     text$,         ; Text
                     12*DR,         ; Padding x
                     2*DR,          ; Padding y
                     1.0)           ; Resize factor
  
  text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"Try any Text"
  AddFrame_FW() ; Remove the frame
  
  DrawGLTextImage_FW(gadget_ID,     ; Gadget ID
                     "Georgia",     ; Font
                     #PB_Font_Bold, ; Font flag
                     115,           ; Output x pos
                     110,           ; Output y pos
                     480,           ; Output width
                     90,            ; Output height
                     #Red,          ; Text color
                     0,             ; Text adjustment - 0=center - 1=left - 2=right
                     $000001,       ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                     text$,         ; Text
                     -12/DR,        ; Padding x
                     2/DR,          ; Padding y
                     1.0)           ; Resize factor
  
  LinearGradient_FW() ; Deactivate again
  
  ; Moves the AdjustText_FW output from the left edge of the output rectangle to the right edge - You must deactivate again
  ; 1 sets the cursor in front of the output and makes the output to the right
  ; 2 puts the cursor behind the output and makes the output to the left
  AdjustText_FW(2)
  
  text$+#LF$+#LF$+"Have fun"
  AddFrame_FW(3*DesktopResolutionX(), #Red, 8*DR) ; AddFrame_Size_FW, AddFrame_Color_FW, AddFrame_Rounding_FW
  AddImage_1_FW(image_1_ID,
                450*DR, ; x pos
                86*DR,  ; y pos
                140*DR, ; Width
                25*DR,  ; Height
                255)    ; Alpha
  
  AddImage_2_FW(image_2_ID,
                10*DR,  ; x pos
                10*DR,  ; y pos
                160*DR, ; Width
                100*DR, ; Height
                255)    ; Alpha
  
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
    SetOffsetCursor_X_FW(-40) 
  CompilerEndIf
  
  DrawGLTextImage_FW(gadget_ID,     ; Gadget ID
                     "Georgia",     ; Font
                     #PB_Font_Bold, ; Font flag
                     50,            ; Output x pos
                     230,           ; Output y pos
                     600,           ; Output width
                     120,           ; Output height
                     #Blue,         ; Text color
                     0,             ; Text adjustment - 0=center - 1=left - 2=right
                     #Green,        ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                     text$,         ; Text
                     40*DR,         ; Padding x
                     2*DR,          ; Padding y
                     1.0)           ; Resize factor
  
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
    SetOffsetCursor_X_FW(0) 
  CompilerEndIf
  
  AddImage_1_FW() ; Remove additional image 1
  AddImage_2_FW() ; Remove additional image 2
  AdjustText_FW() ; Deactivate again
  
  OpenGLGadgetFlipBuffers_FW(gadget_ID) ; Flip Buffers OpenGLGadget - Get the output  
  
ForEver
; IDE Options = PureBasic 5.73 LTS (MacOS X - x64)
; CursorPosition = 120
; FirstLine = 95
; Folding = -
; EnableXP
; EnableUser
; DPIAware