﻿; FontWizzard_BF - Demo code
XIncludeFile("./FontWizzard_BF.pbi")
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit
UseJPEGImageDecoder()

Define scaling.f=1.5 ; List output size

Define DR.f=DesktopResolutionX(), i

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1000, 400, "Font_Wizzard_BF - GFX_Wizzard_BF enhanced", #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
SetGadgetColor(canvas_ID, #PB_Gadget_BackColor, $CDCDCD)
scaling*DR

Define x=50*scaling ; List output x pos
Define y=80*scaling ; List output y pos

Define image_1_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")
Define image_2_ID=LoadImage(#PB_Any, "./Image_Set/Polynesia.jpg")

TextColor_Line_FW(1, #Blue) ; Set Line 1 blue
PresetMaxFontsize_FW(12*scaling)

SetCursor_X_FW(x)
SetCursor_Y_FW(y)

; Add to the FitImage functions a automatically upscaling for little images - 1=activated - 0=deactivated
; -You must deactivate again
; -As sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF, ButtonImageGadget_BF
FitImageActivateUpscaling_BF(1)

; This function give back a fitted image
Define fitted_Image_ID=FitImage_BF(0,          ; mode,
                                   image_1_ID, ; Source image ID
                                   80*scaling, ; Fit image to this width
                                   60*scaling, ; Fit image to this height
                                   $DCDCDC,    ; Background color
                                   8*scaling,  ; Padding
                                   $FFFFFF,    ; Grid color
                                   0,          ; Grid size - Set on special mode 4 Edge Rounding
                                   10,         ; Grid tiling
                                   $FFFFFF,    ; Frame color
                                   0,          ; frame_size
                                   0)          ; Sprite mode for PB sprite output
                                               ; mode 0 = image output
                                               ; mode 1 = Without background
                                               ; mode 2 = PB sprite output
                                               ; mode 3 = Without output - You can use GetFitSize_Width_BF() and GetFitSize_Height_BF() for get the calculated width and height
                                               ; mode 4 = Special mode with offsets for Magic_StretchText_Pro_BF()
                                               ; This function can output images and PB sprites
                                               ; Look the FitImage demo code
                                               ; You can set ActivateAlphaChannel_BF(1) before you call this function

AddFrame_FW(2*scaling, $606060)

AddImage_1_FW(fitted_image_ID,
              198*scaling, ; x pos
              0,           ; y pos
              80*scaling,  ; Width
              60*scaling,  ; Height
              255)         ; Alpha

; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
; To deactivate simply set it so AddFrame...()
AddSubFrame_1_FW(201*scaling,
                 3*scaling,
                 74*scaling,
                 54*scaling,
                 5*scaling, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                 #White,
                 8*scaling)

; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
; To deactivate simply set it so AddFrame...()
AddSubFrame_2_FW(198*scaling,
                 0,
                 80*scaling,
                 60*scaling,
                 8*scaling, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                 #White,
                 0)

; Add a additional limitless sub frame - Alpha channel sensitive - Sample $8000FFFF
; To deactivate simply set it so AddFrame...()
AddSubFrame_3_FW(198*scaling,
                 0,
                 80*scaling,
                 60*scaling,
                 2*scaling, ; Set to -1 for a filled frame - As sample for a Progressbar or other
                 $606060)

; Auto free accessories after output
ActivateAutoFree_FW(0)

Define text$="Be creative"+#LF$+"Create your own artwork"
DrawText_FW(canvas_ID,        ; output_ID
            "",               ; Font$
            0,                ; font_flag
            GetCursor_X_FW(), ; output_x
            GetCursor_Y_FW(), ; output_y
            200*scaling,      ; output_width
            60*scaling,       ; output_height
            #Black,           ; text_color
            0,                ; text_adjustment
            #White,           ; background_color -1 = invisible
            text$,            ; text$
            -16/DR,           ; padding_x
            0*DR,             ; padding_y
            1)                ; resize_factor.f

TextColor_Line_FW(1, -1) ; Deactivate again

FreeImage_BF(fitted_image_ID) ; Bulletproof

Define fitted_Image_ID=FitImage_BF(0,          ; mode,
                                   image_2_ID, ; Source image ID
                                   80*scaling, ; Fit image to this width
                                   60*scaling, ; Fit image to this height
                                   $DCDCDC,    ; Background color
                                   8*scaling,  ; Padding
                                   $FFFFFF,    ; Grid color
                                   0,          ; Grid size - Set on special mode 4 Edge Rounding
                                   10,         ; Grid tiling
                                   $FFFFFF,    ; Frame color
                                   0,          ; frame_size
                                   0)          ; Sprite mode for PB sprite output
                                               ; mode 0 = image output
                                               ; mode 1 = Without background
                                               ; mode 2 = PB sprite output
                                               ; mode 3 = Without output - You can use GetFitSize_Width_BF() and GetFitSize_Height_BF() for get the calculated width and height
                                               ; mode 4 = Special mode with offsets for Magic_StretchText_Pro_BF()
                                               ; This function can output images and PB sprites
                                               ; Look the FitImage demo code
                                               ; You can set ActivateAlphaChannel_BF(1) before you call this function

AddImage_1_FW(fitted_image_ID,
              198*scaling, ; x pos
              0,           ; y pos
              80*scaling,  ; Width
              60*scaling,  ; Height
              255)         ; Alpha

Define text$="FontWizzard_BF"+#LF$+"I hope you have a nice day"+#LF$+"All things on it place"
DrawText_FW(canvas_ID,                   ; output_ID
            "",                          ; Font$
            0,                           ; font_flag
            GetCursor_X_FW()+84*scaling, ; output_x
            GetCursor_Y_FW()-60*scaling, ; output_y
            200*scaling,                 ; output_width
            60*scaling,                  ; output_height
            #Black,                      ; text_color
            0,                           ; text_adjustment
            #White,                      ; background_color -1 = invisible
            text$,                       ; text$
            -16/DR,                      ; padding_x
            0*DR,                        ; padding_y
            1)                           ; resize_factor.f

FreeImage_BF(fitted_image_ID) ; Bulletproof

HideWindow(window_ID, 0)
Repeat
Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 164
; FirstLine = 124
; EnableXP