﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  ; - Demo - 
  ; Base code for advanced users - With proportional fitted output
  ; Use a GIF with mask or without mask as PB sprite - BF Sprite CSS sheet fast function used - PB sprite output on windowed screen - Extreme fast
  ; Also this code can handle CSS sprite sheets, clipping, resizing
  
  ; You can set self the used invisible color
  
  ; Look in the code for the needed settings
  
  EnableExplicit
  
  Define window_ID, canvas_ID, win_event, texture_ID, gif_ID, background_ID, background_1_ID, result
  Define window_width, window_height, frame, delay, i, invisible_color
  Define path$
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  path$=OpenFileRequester("Select a GIF or a image", "", "", 0)
  
  If path$="" : End : EndIf
  
  gif_ID=LoadImage(#PB_Any, path$)
  
  texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
  StartDrawing(ImageOutput(texture_ID))
  For i=1 To ImageWidth(texture_ID)-1 Step 7
    LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
  Next i
  For i=1 To ImageHeight(texture_ID)-1 Step 7
    LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
  Next i
  StopDrawing()
  
  ; Presets
  Define frames=ImageFrameCount(gif_ID)   ; Count frames - start by zero for PB compatibility
  
  CompilerIf #PB_Compiler_OS<>#PB_OS_Windows ; Workaround PB570 - PB incompatibility, a image give back 0, on Windows 1
    If Not frames : frames=1 : EndIf
  CompilerEndIf
  
  Define frame_width=ImageWidth(gif_ID)   ; Frame width
  Define frame_height=ImageHeight(gif_ID) ; Frame height
  
  Define output_width=0  ; Output width  - For original sprite width set width = 0
  Define output_height=0 ; Output height - For original sprite height set height = 0
  
  Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
  Define texture_clip_y=0 ; Startposition inside the texture - Preset 0
  
  Define texture_clip_width=0  ; Offset endposition inside the texture - Preset 0 = full texture width
  Define texture_clip_height=0 ; Offset endposition inside the texture - Preset 0 = full texture height
  
  Define alpha=255  ; Here you can set alpha blending - Set 255 for full visible, 0 for full transparence
  
  Define window_width=frame_width
  Define window_height=frame_height
  
  Macro coloring_image(source_ID)
    Define partition_x=100 ; You can select a defined part for coloring
    Define partition_y=100
    Define partition_width=200
    Define partition_height=200
    Define swap_partition=1 ; You can swap the part for coloring
    Define change_red.f=0   ; Add more red for demonstrating
    Define change_green.f=70
    Define change_blue.f=0
    Define change_contrast.f=0
    Define change_brightness.f=0
    Define change_intensity.f=0
    Define mode_grey=0
    Define mode=0
    Define sprite_mode=0
    
    ; This function change the brightness, color, contrast - The function works with images and canvas
    ; The parameters are percent based - positive and negative values
    ; Source and destination must have the same size
    ; Similar Image_coloring_BF, but you can colorize parts of the image
    ; Not for input and direct output PB sprites
    ; mode 0 = without creating a new output - mode 1 create a image - mode 2 create a PB sprite
    ; sprite_mode - Same PB function call for PB sprite creating
    ; Tree grey modes available mode=1, mode=2, mode=3 - mode=1 is more neutral
    Image_coloring_partition_BF(source_ID, source_ID,
                                partition_x,
                                partition_y,
                                partition_width,
                                partition_height,
                                swap_partition,
                                change_red,
                                change_green,
                                change_blue,
                                change_contrast,
                                change_brightness,
                                change_intensity,
                                mode_grey,
                                mode,
                                sprite_mode)
  EndMacro
  
  ExamineDesktops()
  
  If window_width>DesktopWidth(0)-120: window_width=DesktopWidth(0)-120 : EndIf
  If window_height>DesktopHeight(0)-120: window_height=DesktopHeight(0)-120 : EndIf
  
  ; --- Calculate the needed output window and temporary image ---
  If frame_width>window_width Or frame_height>window_height ; Calculate a proportional resized output - Tipp : Look for ORBO GIF
    GetFitSize_BF(frame_width, frame_height, window_width, window_height)
    output_width=GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
    output_height=GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
  Else
    output_width=frame_width
    output_height=frame_height
  EndIf
  
  If frame_width<400 : window_width=400 : EndIf
  If frame_height<250 : window_height=250 : EndIf
  
  ; ------------------------------------------------------------------------------
  
  window_ID=OpenWindow(#PB_Any, 0, 0,
                       window_width, window_height, "GFX_Wizzard_BF - GIF and images",
                       #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
  
  ; If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, window_width, window_height) : End : EndIf ; Create a windowed screen for output
  canvas_ID=CanvasGadget(#PB_Any, 0, 0, window_width, window_height)
  
  background_ID=CreateImage(#PB_Any, window_width, window_height)
  
  ; - Call function #1 -
  ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background
  
  Define temporary_frame_ID=CreateImage(#PB_Any, frame_width, frame_height) ; Create a temporary frame
  
  ; invisible_color=$A7A8A9 ; You can preset here a invisible color - Define not the same as the GIF content color or you get "Holes"
  
  invisible_color=Create_invisible_GIF_color_BF(gif_ID) ; This create automatic a new and common invisible color for the GIF output as sprite
  If invisible_color<1 : invisible_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic invisible color generating
  
  NoCaching_BF(1) ; Deactivate BF texture caching
  HideWindow(window_ID, 0)
  Dim frame_sprite_ID(frames, 1)
  
  For i=0 To frames-1
    frame_sprite_ID(i, 1)=Get_Gif_FrameDelay_BF(gif_ID, i) ; Get the GIF frame delay
    frame_sprite_ID(i, 0)=CreateImage(#PB_Any, output_width, output_height)
    StartDrawing(ImageOutput(temporary_frame_ID)) ; Draw in the temporary frame buffer
    Box(0, 0, frame_width, frame_height, invisible_color) ; Draw the invisible color
    DrawAlphaImage(ImageID(gif_ID),0 , 0)                 ; Draw the GIF frame in the temporary frame buffer
    StopDrawing()
    
    coloring_image(temporary_frame_ID) ; Coloring change the invisible GIF color - Preset a suitable invisible color for GIF or you can get holes in your output  
    
    result=Sprite_CSS_sheet_simple_BF(0, frame_sprite_ID(i, 0), temporary_frame_ID, 
                                      0,                   ; Grab transparence color from sprite pos x - For preset set ..x=-1                      
                                      0,                   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                      0,                   ; Output position x
                                      0,                   ; Output position y
                                      1,                   ; Numbers of frames
                                      0,                   ; Selected frame - For PB GIF compatibility the first frame is 0
                                      frame_width,         ; Frame width
                                      frame_height,        ; Frame height
                                      1,                   ; Frames in a row - Preset 0, then BF calculate self
                                      output_width,        ; Resizing - Define the output width - Preset zero = without resizing 
                                      output_height,       ; Resizing - Define the output height
                                      texture_clip_x,      ; Startposition inside the texture - Preset 0
                                      texture_clip_y,      ; Startposition inside the texture - Preset 0
                                      texture_clip_width,  ; Endposition inside the texture  - Preset 0 = full texture width
                                      texture_clip_height) ; Endposition inside the texture  - Preset 0 = full texture height
  Next i
  
  FreeImage(temporary_frame_ID) ; Free temporary image
  
  Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation
  
  Repeat
    Delay(1)
    
    Repeat ; Get all window events before FlipBuffers
      Define win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        For i=0 To frames-1 : FreeImage(frame_sprite_ID(i, 0)) : Next i : FreeArray(frame_sprite_ID())
        End
      EndIf
    Until Not win_event
    
    FlipBuffers_BF(0)
    
    ErrorCheck_BF(SpriteSimple_fast_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), frame_sprite_ID(frame, 0),                                     
                                       -1,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                      
                                       invisible_color,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                       window_width>>1-output_width>>1,                    ; Output position x
                                       window_height>>1-output_height>>1,                  ; Output position y
                                       output_width,                                       ; Resizing - Define the output width - Preset zero = without resizing 
                                       output_height,                                      ; Resizing - Define the output height
                                       texture_clip_x,                                     ; Startposition inside the texture - Preset 0
                                       texture_clip_y,                                     ; Startposition inside the texture - Preset 0
                                       texture_clip_width,                                 ; Endposition inside the texture - Preset 0 = full texture width
                                       texture_clip_height))                               ; Endposition inside the texture - Preset 0 = full texture height
    
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID)
    
    ; Frame delay - Using timer 1
    If delay : delay=0 : frame+1 : If frame=frames : frame=0 : EndIf : Else : delay+Delay_BF(1, frame_sprite_ID(frame, 1)) : EndIf
    
  ForEver
  
CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 14
; FirstLine = 9
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger