﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  ; - Demo - 
  ; Base code for advanced users - With proportional fitted output and coloring
  ; Use a GIF with mask or without mask as sprite - BF Sprite CSS sheet fast function used - Also for images
  ; Also this code can handle CSS sprite sheets, clipping, resizing
  
  ; You can set self the used invisible color
  
  ; Look in the code for the needed settings
  
  EnableExplicit
  
  Define window_ID, canvas_ID, temporary_frame_ID, sheet_ID, texture_ID, image_ID, background_ID, background_1_ID, win_event, result, gif
  Define window_width, window_height, frame, delay, frame_delay, i, invisible_color
  Define path$
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  path$=OpenFileRequester("Select a GIF or a image", "", "", 0)
  
  If path$="" : End : EndIf
  
  If UCase(GetExtensionPart(path$))="GIF": gif=1 : EndIf
  
  image_ID=LoadImage(#PB_Any, path$)
  
  texture_ID=CreateImage(#PB_Any, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF()) ; Create a texture for the background
  StartDrawing(ImageOutput(texture_ID))
  For i=1 To ImageWidth(texture_ID)-1 Step 7
    LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
  Next i
  For i=1 To ImageHeight(texture_ID)-1 Step 7
    LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
  Next i
  StopDrawing()
  
  ; Presets
  Define frames=ImageFrameCount(image_ID)   ; Count frames - start by zero for PB compatibility
  Define frame_width=ImageWidth(image_ID)   ; Frame width
  Define frame_height=ImageHeight(image_ID) ; Frame height
  
  Define output_width=0  ; Output width  - For original sprite width set width = 0
  Define output_height=0 ; Output height - For original sprite height set height = 0
  
  Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
  Define texture_clip_y=0 ; Startposition inside the texture - Preset 0
  
  Define texture_clip_width=0  ; Offset endposition inside the texture - Preset 0 = full texture width
  Define texture_clip_height=0 ; Offset endposition inside the texture - Preset 0 = full texture height
  
  Define alpha=255  ; Here you can set alpha blending - Set 255 for full visible, 0 for full transparence
  
  Define window_width=frame_width
  Define window_height=frame_height
  
  Macro coloring_image(source_ID)
    Define partition_x=100 ; You can select a defined part for coloring
    Define partition_y=100
    Define partition_width=200
    Define partition_height=200
    Define swap_partition=1 ; You can swap the part for coloring
    Define change_red.f=0   ; Add more red for demonstrating
    Define change_green.f=70
    Define change_blue.f=0
    Define change_contrast.f=0
    Define change_brightness.f=0
    Define change_intensity.f=0
    Define mode_grey=0
    Define mode=0
    Define sprite_mode=0
    
    ; This function change the brightness, color, contrast - The function works with images and canvas
    ; The parameters are percent based - positive and negative values
    ; Source and destination must have the same size
    ; Similar Image_coloring_BF, but you can colorize parts of the image
    ; Not for input and direct output PB sprites
    ; mode 0 = without creating a new output - mode 1 create a image - mode 2 create a PB sprite
    ; sprite_mode - Same PB function call for PB sprite creating
    ; Tree grey modes available mode=1, mode=2, mode=3 - mode=1 is more neutral
    Image_coloring_partition_BF(source_ID, source_ID,
                                partition_x*DPI_ResizeFactor_BF(),
                                partition_y*DPI_ResizeFactor_BF(),
                                partition_width*DPI_ResizeFactor_BF(),
                                partition_height*DPI_ResizeFactor_BF(),
                                swap_partition,
                                change_red,
                                change_green,
                                change_blue,
                                change_contrast,
                                change_brightness,
                                change_intensity,
                                mode_grey,
                                mode,
                                sprite_mode)
  EndMacro
  
  ExamineDesktops()
  
  If window_width>DesktopWidth(0)-120: window_width=DesktopWidth(0)-120 : EndIf
  If window_height>DesktopHeight(0)-120: window_height=DesktopHeight(0)-120 : EndIf
  
  ; --- Calculate the needed output window and temporary image ---
  If frame_width>window_width Or frame_height>window_height ; Calculate a proportional resized output - Tipp : Look for ORBO GIF
    GetFitSize_BF(frame_width, frame_height, window_width, window_height)
    output_width=GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
    output_height=GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
  Else
    output_width=frame_width
    output_height=frame_height
  EndIf
  
  If frame_width<400 : window_width=400 : EndIf
  If frame_height<250 : window_height=250 : EndIf
  
  ; ------------------------------------------------------------------------------
  
  window_ID=OpenWindow(#PB_Any, 0, 0,
                       window_width, window_height, "GFX_Wizzard_BF - GIF and images",
                       #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
  
  canvas_ID=CanvasGadget(#PB_Any, 0, 0, window_width, window_height)
  
  background_ID=CreateImage(#PB_Any, window_width*DPI_ResizeFactor_BF(), window_height*DPI_ResizeFactor_BF())
  
  ; - Call function #1 -
  ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background
  
  If gif ; Create a temporary frame
    temporary_frame_ID=CreateImage(#PB_Any, window_width, window_height)
    ; sheet_ID=CreateGifSpriteSheet_BF(image_ID, $FFFF) ; This function create a CSS sprite sheet from a GIF - You must set a invisible color (Background color)
    sheet_ID=CreateCSSSheet_simple_BF(image_ID) ; This function create a CSS sprite sheet from a GIF with automatic created invisible color (Background color)
                                                ; coloring_image(sheet_ID) ; GIF coloring - Hint : With a presetted suitable invisible color simple coloring GIF is easy available
    StartDrawing(ImageOutput(sheet_ID))
    invisible_color=Point(ImageWidth(sheet_ID)-1, ImageHeight(sheet_ID)-1)
    StopDrawing()
    ; Hint : With a presetted suitable invisible color simple coloring GIF is easy available
    
    Dim frame_sprite_ID(frames)
    
    For i=0 To frames-1
      frame_delay=Get_Gif_FrameDelay_BF(image_ID, i) ; Get the GIF frame delay
      frame_sprite_ID(i)=frame_delay
      StopDrawing()
    Next i
  Else
    temporary_frame_ID=CreateImage(#PB_Any, window_width, window_height) ; Create a temporary frame
    ResizeImage(image_ID, output_width, output_height)
    coloring_image(image_ID) ; Image coloring - Not for images with alpha channel
  EndIf
  
  NoCaching_BF(1) ; Deactivate BF texture caching
  
  Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - triple buffering - Flicker free animation
  
  HideWindow(window_ID, 0)
  
  Repeat
    Delay(1)
    
    Repeat ; Get all window events before FlipBuffers
      Define win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        If IsImage(sheet_ID) : FreeImage(sheet_ID) : EndIf : FreeImage(temporary_frame_ID) : FreeArray(frame_sprite_ID())
        End
      EndIf
    Until Not win_event
    
    If Not gif
      CopyContent_Image_Image_BF(background_ID, temporary_frame_ID)
      StartDrawing(ImageOutput(temporary_frame_ID))
      DrawAlphaImage(ImageID(image_ID), window_width>>1-output_width>>1, window_height>>1-output_height>>1)
      StopDrawing()
      CopyContent_Image_Canvas_BF(temporary_frame_ID, canvas_ID)
      Delay_BF(1, 10)
      
    Else
      
      FlipBuffers_BF(0)
      
      result=Sprite_CSS_sheet_simple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), sheet_ID, 
                                        -1,                                  ; Grab transparence color from sprite pos x - For preset set ..x=-1                      
                                        invisible_color,                     ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                        window_width>>1-output_width>>1,     ; Output pos x
                                        window_height>>1-output_height>>1,   ; Output pos y
                                        1,                                   ; Numbers of frames
                                        frame,                               ; Selected frame - For PB GIF compatibility the first frame is 0
                                        frame_width,                         ; Frame width
                                        frame_height,                        ; Frame height
                                        0,                                   ; Frames in a row - Preset 0, then BF calculate self
                                        output_width*DPI_ResizeFactor_BF(),  ; Resizing - Define the output width - Preset zero = without resizing 
                                        output_height*DPI_ResizeFactor_BF(), ; Resizing - Define the output height
                                        texture_clip_x,                      ; Startposition inside the texture - Preset 0
                                        texture_clip_y,                      ; Startposition inside the texture - Preset 0
                                        texture_clip_width,                  ; Endposition inside the texture  - Preset 0 = full texture width
                                        texture_clip_height)                 ; Endposition inside the texture  - Preset 0 = full texture height
      
      coloring_image(Get_animation_buffer_hidden_image_ID_BF(0)) ; Image coloring - Not for images with alpha channel
      
      CopyContent_image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID)
      
      ; Frame delay - Using timer 1
      If delay : delay=0 : frame+1 : If frame=frames : frame=0 : EndIf : Else : delay+Delay_BF(1, frame_sprite_ID(frame)) : EndIf
      
    EndIf
    
  ForEver
  
CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 7
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger