﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  ; - Demo - 
  ; Base code for advanced users - With proportional fitted output and coloring
  ; Use a GIF with mask or without mask as sprite - BF Sprite CSS sheet fast function used - Also for images
  ; Also this code can handle CSS sprite sheets, clipping, resizing
  
  ; You can set self the used invisible color
  
  ; Looking in the code for the needed settings
  
  EnableExplicit
  
  Define window_ID, canvas_ID, temporary_frame_ID, sheet_ID, texture_ID, image_ID, background_ID, background_1_ID, win_event, result, gif
  Define window_width, window_height, frame, delay, frame_delay, i, invisible_color
  Define path$
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  path$=OpenFileRequester("Select a GIF or a image", "", "", 0)
  
  If path$="" : End : EndIf
  
  If UCase(GetExtensionPart(path$))="GIF": gif=1 : EndIf
  
  image_ID=LoadImage(#PB_Any, path$)
  
  texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
  StartDrawing(ImageOutput(texture_ID))
  For i=1 To ImageWidth(texture_ID)-1 Step 7
    LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
  Next i
  For i=1 To ImageHeight(texture_ID)-1 Step 7
    LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
  Next i
  StopDrawing()
  
  ; Presets
  Define frames=ImageFrameCount(image_ID)   ; Count frames - start by zero for PB compatibility
  Define frame_width=ImageWidth(image_ID)   ; Frame width
  Define frame_height=ImageHeight(image_ID) ; Frame height
  
  Define output_width=0  ; Output width  - For original sprite width set width = 0
  Define output_height=0 ; Output height - For original sprite height set height = 0
  
  Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
  Define texture_clip_y=0 ; Startposition inside the texture - Preset 0
  
  Define texture_clip_width=0  ; Offset endposition inside the texture - Preset 0 = full texture width
  Define texture_clip_height=0 ; Offset endposition inside the texture - Preset 0 = full texture height
  
  Define alpha=255  ; Here you can set alpha blending - Set 255 for full visible, 0 for full transparence
  
  Define window_width=frame_width
  Define window_height=frame_height
  
  Dim frame_sprite_ID(frames)
  
  ExamineDesktops()
  
  If window_width>DesktopWidth_UserScaled_BF()-120: window_width=DesktopWidth_UserScaled_BF()-120 : EndIf
  If window_height>DesktopHeight_UserScaled_BF()-120: window_height=DesktopHeight_UserScaled_BF()-120 : EndIf
  
  ; --- Calculate the needed output window and temporary image ---
  If frame_width>window_width Or frame_height>window_height ; Calculate a proportional resized output - Tipp : Look for ORBO GIF
    GetFitSize_BF(frame_width, frame_height, window_width, window_height)
    output_width=GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
    output_height=GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
  Else
    output_width=frame_width
    output_height=frame_height
  EndIf
  
  If frame_width<400 : window_width=400 : EndIf
  If frame_height<250 : window_height=250 : EndIf
  
  ; ------------------------------------------------------------------------------
  
  window_ID=OpenWindow(#PB_Any, 0, 0,
                       window_width, window_height, "GFX_Wizzard_BF - GIF and Images",
                       #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
  
  canvas_ID=CanvasGadget(#PB_Any, 0, 0, window_width, window_height)
  
  background_ID=CreateImage(#PB_Any, window_width, window_height)
  
  ; - Call function #1 -
  ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background
  
  If gif
    temporary_frame_ID=CreateImage(#PB_Any, frame_width, frame_height) ; Create a temporary frame
                                                                       ; sheet_ID=CreateGifSpriteSheet_BF(image_ID, $FFFF) ; This function create a CSS sprite sheet from a GIF - You must set a invisible color (Background color)
    sheet_ID=CreateCSSSheet_simple_BF(image_ID)                        ; This function create a CSS sprite sheet from a GIF with automatic created invisible color (Background color)
    
    StartDrawing(ImageOutput(sheet_ID))
    invisible_color=Point(ImageWidth(sheet_ID)-1, ImageHeight(sheet_ID)-1)
    StopDrawing()
    
    For i=0 To frames-1
      frame_delay=Get_Gif_FrameDelay_BF(image_ID, i) ; Get the GIF frame delay
      frame_sprite_ID(i)=frame_delay
      StopDrawing()
    Next i
    
    Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - triple buffering - Flicker free animation
  Else
    temporary_frame_ID=CreateImage(#PB_Any, window_width, window_height) ; Create a temporary frame
    ResizeImage(image_ID, output_width, output_height)
  EndIf
  
  NoCaching_BF(1) ; Deactivate BF texture caching
  
  HideWindow(window_ID, 0)
  
  Repeat
    Delay(1)
    
    Repeat ; Get all window events before FlipBuffers
      Define win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        If IsImage(sheet_ID) : FreeImage(sheet_ID) : EndIf : FreeImage(temporary_frame_ID) : FreeArray(frame_sprite_ID())
        End
      EndIf
    Until Not win_event
    
    If Not gif
      CopyContent_Image_Image_BF(background_ID, temporary_frame_ID)
      StartDrawing(ImageOutput(temporary_frame_ID))
      DrawAlphaImage(ImageID(image_ID), window_width>>1-output_width>>1, window_height>>1-output_height>>1)
      StopDrawing()
      CopyContent_Image_Canvas_BF(temporary_frame_ID, canvas_ID)
      
    Else
      
      FlipBuffers_BF(0)
      
      result=Sprite_CSS_sheet_simple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), sheet_ID, 
                                        -1,                                ; Grab transparence color from sprite pos x - For preset set ..x=-1                      
                                        invisible_color,                   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                        window_width>>1-output_width>>1,   ; Output pos x
                                        window_height>>1-output_height>>1, ; Output pos y
                                        1,                                 ; Numbers of frames
                                        frame,                             ; Selected frame - For PB GIF compatibility the first frame is 0
                                        frame_width,                       ; Frame width
                                        frame_height,                      ; Frame height
                                        0,                                 ; Frames in a row - Preset 0, then BF calculate self
                                        output_width,                      ; Resizing - Define the output width - Preset zero = without resizing 
                                        output_height,                     ; Resizing - Define the output height
                                        texture_clip_x,                    ; Startposition inside the texture - Preset 0
                                        texture_clip_y,                    ; Startposition inside the texture - Preset 0
                                        texture_clip_width,                ; Endposition inside the texture  - Preset 0 = full texture width
                                        texture_clip_height)               ; Endposition inside the texture  - Preset 0 = full texture height
      
      CopyContent_image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID)
      
      ; Frame delay - Using timer 1
      If delay : delay=0 : frame+1 : If frame=frames : frame=0 : EndIf : Else : delay+Delay_BF(1, frame_sprite_ID(frame)) : EndIf
      
    EndIf
    
  ForEver
  
CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 65
; FirstLine = 49
; Folding = -
; EnableXP
; DisableDebugger