﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - GIF output - Use a GIF with mask or without mask as sprite - AlphaChannelSprite_BF function used

; Output available directly on canvas, images and PB sprites, with tilling, scrolling and clipping functions

; You can also set self the used invisible color - Look in the code for the needed settings

; Enhanced and very fast GIF players with GIF resizing and alpha blending are in the download packet disposable !

EnableExplicit

Define background_ID, image_width, image_height, frame, delay, i, invisible_color, win_event, gif_ID, path$

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

path$=OpenFileRequester("Select a GIF", "", "", 0)

If path$="" : End : EndIf

If UCase(GetExtensionPart(path$))<>"GIF"
  MessageRequester("Hint", "This is not a GIF !")
  End
EndIf

gif_ID=LoadImage(#PB_Any, path$)

Define texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7 : LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC) : Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7 : LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC) : Next i
StopDrawing()

; Presets
Define frames=ImageFrameCount(gif_ID)   ; Count frames
Define frame_width=ImageWidth(gif_ID)   ; Frame width
Define frame_height=ImageHeight(gif_ID) ; Frame height

Define x=40 ; Output start point x
Define y=40 ; Output start point y

Define output_width=0  ; Output width  - For original sprite width set width = 0
Define output_height=0 ; Output height - For original sprite height set height = 0

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0

Define texture_clip_width=0  ; Offset endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Offset endposition inside the texture - Preset 0 = full texture height

If output_width ; --- Calculate the needed output window and temporary image ---
  image_width=output_width+x*2
Else
  If texture_clip_width
    image_width=frame_width-texture_clip_x-(frame_width-texture_clip_width)+x*2
  Else
    image_width=frame_width-texture_clip_x-texture_clip_width+x*2
  EndIf
EndIf
If output_height
  image_height=output_height+y*2
Else
  If texture_clip_height
    image_height=frame_height-texture_clip_y-(frame_height-texture_clip_height)+y*2
  Else
    image_height=frame_height-texture_clip_y-texture_clip_height+y*2
  EndIf
EndIf
; ------------------------------------------------------------------------------
background_ID=CreateImage(#PB_Any, image_width, image_height)

Define window_ID=OpenWindow(#PB_Any, 0, 0, image_width, image_height, "GFX_Wizzard_BF",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID)) ; Create a canvas for output the result

Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

; ; invisible_color=$A7A8A9 ; You can preset here a invisible color - Define not the same as the GIF content color or you get "Holes"
; invisible_color=Create_invisible_GIF_color_BF(gif_ID) ; This create automatic a new and common invisible color for the GIF output as sprite
; If invisible_color<1 : invisible_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic invisible color generating
; SetInvisibleColor_BF(invisible_color)

If Not IsImageInvisibleColor_BF(gif_ID) ; Has the first Gif frame a invisible color ?
  SetInvisibleColor_BF(-2)          ; This deactivate a invisible color handling for this BF Sprite function
                                    ; Because, this function can output Gif without a invisible color also as Gif with invisible color
                                    ; -for this define simple a Gif color as invisible
EndIf

NoCaching_BF(1) ; For immediately changed textures deactivate the BF texture caching

Repeat
  Delay(1)
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change - Animation Refresh
    
    ; Frame delay - Using timer 1
    If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : frame+1 : If frame=frames : frame=0 : EndIf : EndIf
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    ErrorCheck_BF(AlphaChannelSprite_BF(Get_animation_buffer_hidden_image_ID_BF(0), gif_ID,
                                        x,
                                        y,
                                        output_width,
                                        output_height,
                                        texture_clip_x,
                                        texture_clip_y,
                                        texture_clip_width,
                                        texture_clip_height))

    ; Get the result
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
  EndIf
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : Free_animation_buffers_BF(0) : End : EndIf
  Until Not win_event 
ForEver

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 19
; FirstLine = 19
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger