﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - 
; Base code for advanced users
; Use a GIF with mask or without mask as PB sprite - BF Sprite CSS sheet function used - PB sprite output on windowed screen - Extreme fast
; Also this code can handle CSS sprite sheets, automatic tilling, clipping, resizing

; You can set self the used invisible color

; Look in the code for the needed settings

EnableExplicit

Define window_ID, win_event, texture_ID, gif_ID, background_ID, background_1_ID, result
Define image_width, image_height, frame, delay, i, invisible_color
Define path$

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

path$=OpenFileRequester("Select a GIF", "", "", 0)

If path$="" : End : EndIf

If UCase(GetExtensionPart(path$))<>"GIF"
  MessageRequester("Hint", "This is not a GIF !")
  End
EndIf

gif_ID=LoadImage(#PB_Any, path$)

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7
  LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7
  LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
Next i
StopDrawing()

; Presets
Define frames=ImageFrameCount(gif_ID)   ; Count frames - start by zero for PB compatibility
Define frame_width=ImageWidth(gif_ID)   ; Frame width
Define frame_height=ImageHeight(gif_ID) ; Frame height

Define x=40 ; Output start point x
Define y=40 ; Output start point y

Define output_width=0  ; Output width  - For original sprite width set width = 0
Define output_height=0 ; Output height - For original sprite height set height = 0

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0

Define texture_clip_width=0  ; Offset endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Offset endposition inside the texture - Preset 0 = full texture height

Define texture_width=0  ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
Define texture_height=0 ; Endposition texture output - Preset 0 = Clipping is automatic to output height
                        ; You can set this larger as the frame, then you get tilles, set it smaller clip the output !

Define alpha=255 ; Here you can set alpha blending - Set 255 for full visible, 0 for full transparence

If output_width ; --- Calculate the needed output window and temporary image ---
  image_width=output_width+x*2
Else
  output_width=frame_width
  If texture_clip_width
    image_width=frame_width-texture_clip_x-(frame_width-texture_clip_width)+x*2
  Else
    image_width=frame_width-texture_clip_x-texture_clip_width+x*2
  EndIf
EndIf
If output_height
  image_height=output_height+y*2
Else
  output_height=frame_height
  If texture_clip_height
    image_height=frame_height-texture_clip_y-(frame_height-texture_clip_height)+y*2
  Else
    image_height=frame_height-texture_clip_y-texture_clip_height+y*2
  EndIf
EndIf
; ------------------------------------------------------------------------------

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF - Windowed Screen - GIF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height) : End : EndIf ; Create a windowed screen for output
If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height, 0, 0, 0, #PB_Screen_NoSynchronization) : End : EndIf ; No sync

background_ID=CreateSprite(#PB_Any, image_width, image_height)

; - Call function #1 -
ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background

Define temporary_frame_ID=CreateImage(#PB_Any, frame_width, frame_height) ; Create a temporary frame

; invisible_color=$A7A8A9 ; You can preset here a invisible color - Define not the same as the GIF content color or you get "Holes"

invisible_color=Create_invisible_GIF_color_BF(gif_ID) ; This create automatic a new and common invisible color for the GIF output as sprite
If invisible_color<1 : invisible_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic invisible color generating

NoCaching_BF(1) ; Deactivate BF texture caching
HideWindow(window_ID, 0)
Dim frame_sprite_ID(frames, 1)

For i=0 To frames-1
  frame_sprite_ID(i, 1)=Get_Gif_FrameDelay_BF(gif_ID, i) ; Get the GIF frame delay
  frame_sprite_ID(i, 0)=CreateSprite(#PB_Any, output_width, output_height)
  StartDrawing(ImageOutput(temporary_frame_ID)) ; Draw in the temporary frame buffer
  Box(0, 0, frame_width, frame_height, invisible_color) ; Draw the invisible color
  DrawAlphaImage(ImageID(gif_ID),0 , 0)                 ; Draw the GIF frame in the temporary frame buffer
  StopDrawing()
  
  result=Sprite_CSS_sheet_BF(0, frame_sprite_ID(i, 0), temporary_frame_ID,                                     
                             -1,                  ; Grab transparence color from the frame pos x - Set to -1 for output without invisible color 
                             0,                   ; Grab transparence color from the frame pos y - You can set x or y, or both parameters to -1 
                             0,                   ; Output position x
                             0,                   ; Output position y
                             1,                   ; Numbers of frames
                             0,                   ; Selected frame - For PB GIF compatibility the first frame is 0
                             frame_width,         ; Frame width
                             frame_height,        ; Frame height
                             1,                   ; Frames in a row - Preset 0, then BF calculate self
                             output_width,        ; Output width  - Resizing   - Preset 0 = Is the full texture width
                             output_height,       ; Output height - Resizing   - Preset 0 = Is the full texture width
                             texture_width,       ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
                             texture_height,      ; Endposition texture output - Preset 0 = Clipping is automatic to output height 
                             texture_clip_x,      ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                             texture_clip_y,      ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                             texture_clip_width,  ; Endposition inside the texture   - Preset 0 = Full texture width
                             texture_clip_height) ; Endposition inside the texture   - Preset 0 = Full texture height 
Next i

FreeImage(temporary_frame_ID) ; Free temporary image

Repeat
  Delay(1)
  
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      For i= 0 To frames-1 : FreeSprite(frame_sprite_ID(i, 0)) : Next i : FreeArray(frame_sprite_ID())
      End
    EndIf
  Until Not win_event
  
  FlipBuffers()
  ClearScreen(RGB(0, 0, 0))
  DisplaySprite(background_ID, 0, 0)
  TransparentSpriteColor(frame_sprite_ID(frame, 0), invisible_color)
  DisplayTransparentSprite(frame_sprite_ID(frame, 0), image_width>>1-output_width>>1, image_height>>1-output_height>>1, alpha)
  
  ; Frame delay - Using timer 1
  If delay : delay=0 : frame+1 : If frame=frames : frame=0 : EndIf : Else : delay+Delay_BF(1, frame_sprite_ID(frame, 1)) : EndIf
  
ForEver

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 91
; FirstLine = 54
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger