﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

; - Demo - Use a GIF with mask or without mask as BF sprite on canvas
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define window_ID, canvas_ID, win_event, texture_ID, gif_ID, background_ID, image_width, image_height, frame, i, invisible_color, path$

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

path$=OpenFileRequester("Select a GIF", "", "", 0)

If path$="" : End : EndIf

If UCase(GetExtensionPart(path$))<>"GIF"
  MessageRequester("Hint", "This is not a GIF !")
  End
EndIf

gif_ID=LoadImage(#PB_Any, path$)

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7 : LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC) : Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7 : LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC) : Next i
StopDrawing()

Define x=10 ; Output x pos
Define y=10 ; Output y pos

; Texture clipping
Define texture_clip_x=0 ; Startposition inside the texture x - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture y - Preset 0
Define texture_clip_width=0 ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0; Endposition inside the texture - Preset 0 = full texture width

Define output_width=0  ; Output width  - For original sprite width set width = 0
Define output_height=0 ; Output height - For original sprite height set height = 0

Define degree ; Degree for rotating

Define rotating_mode=3
; rotating_mode 0 = Without rotating
; rotating_mode 1 = Create a exactely resized sprite with minimized mask - Centered with offsets
; rotating_mode 2 = Create a exactely resized sprite with minimized mask - Centered
; rotating_mode 3 = Create a exactely resized sprite with minimized mask - Left-aligned

Define rotating_offset_x=0 ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
Define rotating_offset_y=0 ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple

If Not rotating_mode ; A presetted invisible color is only needed for rotated frames
  invisible_color=Create_invisible_GIF_color_BF(gif_ID) ; This create automatic a new and common invisible color for the GIF output as sprite
  If invisible_color<1 : invisible_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic invisible color generating
Else
  invisible_color=$E1E941 ; You must preset a suitable invisible color for the used image - This color must are different from the frame color
EndIf

; Hint :
; You can use also color distance with different invisible colors for creating different nice effects, best on movie like Gif
; The color distance function works with activated rotating mode different, but the effect is similar, also for creating different nice effects
Define color_distance=10 ; Color distance sprite mask - Percent - Needed for rotated sprites - Also available with non rotated frames, but then use a presetted invisible color
                         ; The used invisible color and the GIF frame color influence the color distance
                         ; Get you "holes" in the sprite, reduce or disable the color distance (Set to zero)
                         ; You can use also for creating nice effects

Define mode=0
; mode 0 = With invisible color
; mode 1 > 256 = With invisible color and with alpha blending
; mode -1 > -256 = Without invisible color and with alpha blending

Define frame_width=ImageWidth(gif_ID), frame_height=ImageHeight(gif_ID), win_output_width=frame_width+150, win_output_height=frame_height+150

If output_width>0 : win_output_width=output_width+150 : EndIf
If output_height>0 : win_output_height=output_height+150 : EndIf

Define win_output_width, win_output_height
; ------------------------------------------------------------------------------

window_ID=OpenWindow(#PB_Any, 0, 0, win_output_width, win_output_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

canvas_ID=CanvasGadget(#PB_Any, 0, 0, win_output_width, win_output_height) ; Create a canvas for output

background_ID=CreateImage(#PB_Any, win_output_width, win_output_height)

ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a tilled background with the BF core function

Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - Flicker free animation

HideWindow(window_ID, 0)

Repeat
  Delay(1)
  
  Repeat ; Get all window events
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : Free_animation_buffers_BF(0) : FreeTextures_BF(0) : End : EndIf
  Until Not win_event
  
  FlipBuffers_BF(0)
  
  ; Processing and copy the result in the front buffer
  ErrorCheck_BF(Output_Gif_Frame_on_Canvas_rotated_BF(mode, Get_animation_buffer_hidden_image_ID_BF(0), gif_ID,
                                                      x,                  ; Output coordinate x
                                                      y,                  ; Output coordinate y
                                                      frame,              ; Sceect the GIF frame - The first frame is 0 (Because compatibility with PB)
                                                      invisible_color,    ; Select a invisible color - The function create new frame with this color
                                                      color_distance,     ; Color distance sprite mask
                                                      output_width,       ; You can here resize the output x - On demand
                                                      output_height,      ; You can here resize the output y - On demand
                                                      degree,             ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                                      rotating_mode,      ; Look down
                                                      rotating_offset_x,  ; Rotating offset x - For rotating_mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
                                                      rotating_offset_y)) ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                                                          ; mode 0 = With invisible color
                                                                          ; mode 1 > 256 = With invisible color and with alpha blending
                                                                          ; mode -1 > -256 = Without invisible color and with alpha blending
                                                                          ; rotating_mode 0 = Without rotating
                                                                          ; rotating_mode 1 = Create a exactely resized sprite with minimized mask - Centered with offsets
                                                                          ; rotating_mode 2 = Create a exactely resized sprite with minimized mask - Centered
                                                                          ; rotating_mode 3 = Create a exactely resized sprite with minimized mask - Left-aligned
  
  CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Copy front buffer to canvas
  
  If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : frame+1 : If frame=ImageFrameCount(gif_ID) : frame=0 : EndIf : EndIf  ; Frame delay - Using timer 1
  If Delay_BF(2, 50) : degree=(degree+1)%359+1 : EndIf                                                                  ; Automatic rotating - You can remove
  
ForEver

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 21
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger