﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Use a GIF with mask or without mask as sprite - BF_SpriteSimple_BF function used - Output on windowed screen

; You can set self the used invisible color

; This function is not based on the BF core function, it's based on PB CustomFilterCallback and works so a litle other

; Look in the code for the needed settings

EnableExplicit

Define window_ID, win_event, texture_ID, gif_ID, background_ID, background_1_ID, result
Define image_width, image_height, frame, i, invisible_color
Define path$

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

path$=OpenFileRequester("Select a GIF", "", "", 0)

If path$="" : End : EndIf

If UCase(GetExtensionPart(path$))<>"GIF"
  MessageRequester("Hint", "This is not a GIF !")
  End
EndIf

gif_ID=LoadImage(#PB_Any, path$)

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7
  LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7
  LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
Next i
StopDrawing()

; Presets
Define frames=ImageFrameCount(gif_ID)   ; Count frames
Define frame_width=ImageWidth(gif_ID)   ; Frame width
Define frame_height=ImageHeight(gif_ID) ; Frame height

Define x=40 ; Output start point x
Define y=40 ; Output start point y

Define output_width=0  ; Output width  - For original sprite width set width = 0
Define output_height=0 ; Output height - For original sprite height set height = 0

Define texture_width=0  ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
Define texture_height=0 ; Endposition texture output - Preset 0 = Clipping is automatic to output height
                        ; You can set this larger as the frame, then you get tilles, set it smaller clip the output !

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0

Define texture_clip_width=0  ; Offset endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Offset endposition inside the texture - Preset 0 = full texture height

If output_width ; --- Calculate the needed output window and temporary image ---
  image_width=output_width+x*2
Else
  If texture_clip_width
    image_width=frame_width-texture_clip_x-(frame_width-texture_clip_width)+x*2
  Else
    image_width=frame_width-texture_clip_x-texture_clip_width+x*2
  EndIf
EndIf
If output_height
  image_height=output_height+y*2
Else
  If texture_clip_height
    image_height=frame_height-texture_clip_y-(frame_height-texture_clip_height)+y*2
  Else
    image_height=frame_height-texture_clip_y-texture_clip_height+y*2
  EndIf
EndIf
; ------------------------------------------------------------------------------

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF - Windowed Screen output demo for GIF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height) : End : EndIf ; Create a windowed screen for output
If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height, 0, 0, 0, #PB_Screen_NoSynchronization) : End : EndIf ; No sync

background_ID=CreateSprite(#PB_Any, image_width, image_height)

; - Call function #1 -
ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background

background_1_ID=CopySprite(background_ID, #PB_Any)

Define temporary_frame_ID

Define sprite_ID=CreateSprite(#PB_Any, frame_width, frame_height) ; Create a temporary frame

; invisible_color=$A7A8A9 ; You can preset here a invisible color - Define not the same as the GIF content color or you get "Holes"

invisible_color=Create_invisible_GIF_color_BF(gif_ID) ; This create automatic a new and common invisible color for the GIF output as sprite
If invisible_color<1 : invisible_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic invisible color generating

Define mode=1
; mode 0 = Without invisible color
; mode 1 > 256 = With invisible color

Define alpha=1  ; Here you can set alpha blending - Set 1 for full visible, 256 for full transparence

SetColorDistanceSpriteMask_BF(0) ; 0=deactivated - Hint: For nice effects with a pre defined invisible color - Test this also with pictures without a mask
                                 ; Use this not with a automatic defined invisible color

NoCaching_BF(1) ; For immediately changed textures you can deactivate the BF texture caching

HideWindow(window_ID, 0)

Repeat
  Delay(1)
  
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change - Animation Refresh
    
    temporary_frame_ID=CreateSprite_from_Gif_Frame_BF(gif_ID, frame, invisible_color)
    
    SetInvisibleColor_BF(invisible_color)
    ErrorCheck_BF(SpriteSimple_BF(mode, background_ID, temporary_frame_ID,
                                  0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                                  0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                  x,                    ; Output pos x
                                  y,                    ; Output pos y
                                  output_width,         ; You can here resize the output x
                                  output_height,        ; You can here resize the output y
                                  alpha,                ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  texture_width,        ; Endposition texture output       - Preset 0 = Clipping is automatic to input width
                                  texture_height,       ; Endposition texture output       - Preset 0 = Clipping is automatic to input height
                                  texture_clip_x,       ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                                  texture_clip_y,       ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                                  texture_clip_width,   ; Endposition inside the texture   - Preset 0 = full texture width
                                  texture_clip_height)) ; Endposition inside the texture   - Preset 0 = full texture height
                                                        ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                        ; For using pictures with alpha channel use mode=2
                                                        ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                        ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                        ; Resizing can change the colors a little,
                                                        ; so it is available a presetted invisible color works after resizing not longer correct
    
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(background_ID, 0, 0)
    
    If mode ; With invisible color or alpha blending
      CopyContent_PB_Sprite_PB_Sprite_BF(background_1_ID, background_ID)
    EndIf
    
    FreeImage(temporary_frame_ID)
    
    ; Frame delay - Using timer 1
    If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : frame+1 : If frame=frames : frame=0 : EndIf : EndIf
  EndIf
  
ForEver

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 13
; FirstLine = 50
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger