﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

; - Demo - Use a GIF with mask or without mask as PB sprite on screen
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define window_ID, win_event, texture_ID, gif_ID, background_ID, image_width, image_height, frame, i, frame_sprite_ID, invisible_color, path$

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

path$=OpenFileRequester("Select a GIF", "", "", 0)

If path$="" : End : EndIf

If UCase(GetExtensionPart(path$))<>"GIF"
  MessageRequester("Hint", "This is not a GIF !")
  End
EndIf

gif_ID=LoadImage(#PB_Any, path$)

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7 : LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC) : Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7 : LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC) : Next i
StopDrawing()

Define alpha=255 ; Here you can set alpha blending - Set 255 for full visible, 0 for full transparence

Define output_width=0  ; Output width  - For original sprite width set width = 0
Define output_height=0 ; Output height - For original sprite height set height = 0

Define degree=0 ; Degree for rotating

Define rotating_mode=1
; rotating_mode 0 = Without rotating
; rotating_mode 1 = Centered with offsets
; rotating_mode 2 = Centered
; rotating_mode 3 = Left-aligned

Define rotating_offset_x=0 ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
Define rotating_offset_y=0 ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple

If Not rotating_mode ; A presetted invisible color is only needed for rotated frames
  invisible_color=Create_invisible_GIF_color_BF(gif_ID) ; This create automatic a new and common invisible color for the GIF output as sprite
  If invisible_color<1 : invisible_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic invisible color generating
Else
  invisible_color=$E16941 ; You must preset a suitable invisible color for the used image - This color must are different from the frame color
EndIf

; Hint :
; You can use also color distance with different invisible colors for creating different nice effects, best on movie like Gif
; The color distance function works with activated rotating mode different, but the effect is similar, also for creating different nice effects
Define color_distance=30 ; Color distance sprite mask - Percent - Needed for rotated sprites - Also available with non rotated frames, but then use a presetted invisible color
                         ; The used invisible color and the GIF frame color influence the color distance
                         ; Get you "holes" in the sprite, reduce or disable the color distance (Set to zero)
                         ; You can use also for creating nice effects

Define frame_width=ImageWidth(gif_ID), frame_height=ImageHeight(gif_ID), win_output_width=frame_width+150, win_output_height=frame_height+150

Define win_output_width, win_output_height
; ------------------------------------------------------------------------------

window_ID=OpenWindow(#PB_Any, 0, 0, win_output_width, win_output_height, "GFX_Wizzard_BF - Gif on Windowed Screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, win_output_width, win_output_height) : End : EndIf ; Create a windowed screen for output

background_ID=CreateSprite(#PB_Any, win_output_width, win_output_height)

ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a tilled background with the BF core function

Repeat
  Delay(1)
  
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : End : EndIf
  Until Not win_event
  
  frame_sprite_ID=Create_PB_Sprite_from_Gif_Frame_rotated_BF(gif_ID,            ; Create a PB sprite - Resizing, rotating and quality engancement available
                                                             frame,             ; Sceect the GIF frame - The first frame is 0 (Because compatibility with PB)
                                                             invisible_color,   ; Select a invisible color - The function create new frame with this color
                                                             color_distance,    ; Color distance sprite mask
                                                             0,                 ; Sprite mode - Same PB function
                                                             output_width,      ; You can here resize the output x - On demand
                                                             output_height,     ; You can here resize the output y - On demand
                                                             degree,            ; Rotating degree
                                                             rotating_mode,     ; mode=0 without rotating - mode=1 create a exactely resized sprite with minimized mask - mode=2 create a quadratic sprite for on demand rotation 
                                                             rotating_offset_x, ; Rotating offset x - Do not make offsets too large - Larger = slower, but I will give you not a limit
                                                             rotating_offset_y) ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                                                                ; rotating_mode 0 = Without rotating
                                                                                ; rotating_mode 1 = Centered with offsets
                                                                                ; rotating_mode 2 = Centered
                                                                                ; rotating_mode 3 = Left-aligned
  ErrorCheck_BF(frame_sprite_ID)
  
  TransparentSpriteColor(frame_sprite_ID, invisible_color) ; Set the sprite invisible color
  FlipBuffers() : ClearScreen(0)
  DisplaySprite(background_ID, 0, 0) ; Draw a textured background
  
  ; ; Sample for additional available functions
  ; SpriteQuality(#PB_Sprite_BilinearFiltering)
  ; ZoomSprite(frame_sprite_ID, 300, 300)
  ; Rotate_PB_Sprite_with_Offset_BF(frame_sprite_ID, 0, 0, 30, 0, alpha) ; PB sprite rotate bugfix (Workaround PB561) from J. Baker
  ;                                                               ; I am not sure we get a bugfix in the future, so i add this function 
  
  DisplayTransparentSprite(frame_sprite_ID, 10, 10, alpha) ; Draw the Gif frame
  FreeSprite(frame_sprite_ID)
  If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : frame+1 : If frame=ImageFrameCount(gif_ID) : frame=0 : EndIf : EndIf  ; Frame delay - Using timer 1
  
  If Delay_BF(2, 50) : degree=(degree+1)%359+1 : EndIf ; Automatic rotating - You can remove
  
ForEver

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 23
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger