﻿; Clickable ImageGadgets with TextBoxes_BF and Rectangle caching BF - Demo

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; DPI aware output
; You must also activate the DPI aware compiler option
Activate_DPI_aware_BF(1)

If Not GetState_Activate_DPI_aware_BF() ; On BF you can activate or deactivate self DPI_ResizeFactor_BF()
  Deactivate_DPI_ResizeFactor_BF(1)     ; So you have more control about it and can simple test with or without this feature
EndIf

Define win_event
Define needed_font_size, max_needed_font_size=72 ; 25 > 40 is mostly onough - Larger is slower
Define Dim Font_Arial(max_needed_font_size)
For needed_font_size=1 To max_needed_font_size ; Get the fonts
  Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
Next needed_font_size

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1000, 600, "Clickable ImageGadgets with TextBoxes_BF and Rectangle caching BF ",
                            #PB_Window_SystemMenu | #PB_Window_Invisible | #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 1000, 600, #PB_Canvas_Container)

; === Removing this part, remove the background image ===
; Define path$="./Image_Set/stone_1.jpg"
; Define path$="./Image_Set/testtexture_large.png"
Define path$="./Image_Set/Sunset.jpg"
Define texture_ID=LoadImage(#PB_Any, path$)

ResizeImage(texture_ID, 1000*DPI_ResizeFActor_BF(), 600*DPI_ResizeFActor_BF()) ; Only for Demo image Sunset.jpg

ErrorCheck_BF(BF(-2, canvas_ID, texture_ID)) ; Make a Background texture

; Using Gadget Frame (#PB_Image_Border - #PB_Image_Raised)
; can shift the output of the background image in the ImageGadget a bit
; You can easily compensate this by setting small offsets in Grab_Rectangle_BF parameters

; Box 1
Define box_x_1=50
Define box_y_1=50
Define box_width_1=250
Define box_height_1=80

; Grab the boxes pos data and their image
Define box_1_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_1,      ; Output pos x
                                  box_y_1,      ; Output pos y
                                  box_width_1,  ; Rectangle width
                                  box_height_1, ; Rectangle height
                                  1)            ; Grab the rectangle as image - 0=ignore a background image

Define box_1_text$="GFX_Wizzard_BF"

Define box_1_empty_image_ID=CopyImage(Get_Rectangle_BF(box_1_ID), #PB_Any) ; Create a image without text for refresh the ImageGadget content

Macro draw_box_1(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(Get_Rectangle_BF(box_1_ID),
                                Font_Arial(),         ; Font array
                                0,                    ; Output pos x
                                0,                    ; Output pos y
                                box_width_1,          ; Rectangle width
                                box_height_1,         ; Rectangle height
                                5,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                background_color,     ; Background color - Without text background = -1
                                5,                    ; Frame thickness
                                RGBA(0, 0, $FF, 200), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                25,                   ; Padding x, 
                                15,                   ; Padding y,
                                0,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_1(RGBA($B8, 86, $0B, 120), #White, box_1_text$)

Define image_gadget_1_ID=ImageGadget(#PB_Any, box_x_1, box_y_1, 0, 0, ImageID(Get_Rectangle_BF(box_1_ID)))

; Box 2
Define box_x_2=390
Define box_y_2=50
Define box_width_2=580
Define box_height_2=180

; Grab the boxes pos data and their image
Define box_2_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_2,      ; Output pos x
                                  box_y_2,      ; Output pos y
                                  box_width_2,  ; Rectangle width
                                  box_height_2, ; Rectangle height
                                  1)            ; Grab the rectangle as image - 0=ignore a background image

Define box_2_text$="These are Text Boxes BF"+#LF$+
                   "Clickable Output on ImageGadgets"+#LF$+
                   "With full automatically fitted Text"

Define box_2_empty_image_ID=CopyImage(Get_Rectangle_BF(box_2_ID), #PB_Any) ; Create a image without text for refresh the ImageGadget content

Macro draw_box_2(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(Get_Rectangle_BF(box_2_ID),
                                Font_Arial(),         ; Font array
                                0,                    ; Output pos x
                                0,                    ; Output pos y
                                box_width_2,          ; Rectangle width
                                box_height_2,         ; Rectangle height
                                5,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                background_color,     ; Background color - Without text background = -1
                                6,                    ; Frame thickness
                                RGBA($FF, 0, 0, 200), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                30,                   ; Padding x, 
                                15,                   ; Padding y,
                                1,                    ; Headletter mode - text stretching x
                                10,                   ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_2(RGBA(0, $FF, $FF, 120), #Black, box_2_text$)

Define image_gadget_2_ID=ImageGadget(#PB_Any, box_x_2, box_y_2, 0, 0, ImageID(Get_Rectangle_BF(box_2_ID)))

; Box 3
Define box_x_3=50
Define box_y_3=350
Define box_width_3=550
Define box_height_3=230

; Grab the boxes pos data and their image
Define box_3_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_3,      ; Output pos x
                                  box_y_3,      ; Output pos y
                                  box_width_3,  ; Rectangle width
                                  box_height_3, ; Rectangle height
                                  1)            ; Grab the rectangle as image - 0=ignore a background image

Define box_3_text$="Click the Boxes"+#LF$+#LF$+
                   "This BF Functions can grab and cache"+#LF$+
                   "Rectangle Coordinates also with Images"+#LF$+
                   "You get a ID for each cached Rectangle"+#LF$+#LF$+
                   "Works with Images, canvas and PB Sprites"+#LF$+
                   "Simple create your own Buttons and Boxes"

Define box_3_empty_image_ID=CopyImage(Get_Rectangle_BF(box_3_ID), #PB_Any) ; Create a image without text for refresh the ImageGadget content

Macro draw_box_3(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(Get_Rectangle_BF(box_3_ID),
                                Font_Arial(), ; Font array
                                0,            ; Output pos x
                                0,            ; Output pos y
                                box_width_3,  ; Rectangle width
                                box_height_3, ; Rectangle height
                                8,            ; Edge rounding
                                text,         ; Text
                                text_color,   ; Text color
                                background_color,      ; Background color - Without text background = -1
                                6,                     ; Frame thickness
                                RGBA($FF, 0, 0, 200),  ; Frame Color
                                1,                     ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                     ; Modes : Revers text mode=1 - RTL text mode=2
                                30,                    ; Padding x, 
                                25,                    ; Padding y,
                                1,                     ; Headletter mode - text stretching x
                                1,                     ; Headletter_mode - text stretching y
                                1)                     ; resize_factor.f
EndMacro

draw_box_3(RGBA(0, $FF, 0, 150), #Blue, box_3_text$)

Define image_gadget_3_ID=ImageGadget(#PB_Any, box_x_3, box_y_3, 0, 0, ImageID(Get_Rectangle_BF(box_3_ID)))

; Box 4
Define box_x_4=40
Define box_y_4=170
Define box_width_4=320
Define box_height_4=150

; Grab the boxes pos data and their image
Define box_4_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_4,      ; Output pos x
                                  box_y_4,      ; Output pos y
                                  box_width_4,  ; Rectangle width
                                  box_height_4, ; Rectangle height
                                  1)            ; Grab the rectangle as image - 0=ignore a background image

Define box_4_text$="Rectangle Tools BF"+#LF$+
                   "Caching"+#LF$+
                   "Localizing"+#LF$+
                   "With or without Images"

Define box_4_empty_image_ID=CopyImage(Get_Rectangle_BF(box_4_ID), #PB_Any) ; Create a image without text for refresh the ImageGadget content


Macro draw_box_4(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(Get_Rectangle_BF(box_4_ID),
                                Font_Arial(), ; Font array
                                0,            ; Output pos x
                                0,            ; Output pos y
                                box_width_4,  ; Rectangle width
                                box_height_4, ; Rectangle height
                                3,            ; Edge rounding
                                text,         ; Text
                                text_color,   ; Text color
                                background_color,   ; Background color - Without text background = -1
                                6,                  ; Frame thickness
                                RGBA(0, $FF, 0, 0), ; Frame Color
                                1,                  ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                  ; Modes : Revers text mode=1 - RTL text mode=2
                                25,                 ; Padding x, 
                                15,                 ; Padding y,
                                2,                  ; Headletter mode - text stretching x
                                2,                  ; Headletter_mode - text stretching y
                                1)                  ; resize_factor.f
EndMacro

draw_box_4(RGBA($FF, $FF, 0, 150), #Black, box_4_text$)

Define image_gadget_4_ID=ImageGadget(#PB_Any, box_x_4, box_y_4, 0, 0, ImageID(Get_Rectangle_BF(box_4_ID)))

; Box 5
Define box_x_5=640
Define box_y_5=310
Define box_width_5=340
Define box_height_5=150

; Grab the boxes pos data and their image
Define box_5_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_5,      ; Output pos x
                                  box_y_5,      ; Output pos y
                                  box_width_5,  ; Rectangle width
                                  box_height_5, ; Rectangle height
                                  1)            ; Grab the rectangle as image - 0=ignore a background image

Define box_5_text$="Amount Rectangles  "+FreeRectangles_BF(1)+#LF$+#LF$+ ; Count Rectangles
                   box_5_text$+"All over cached Images  "+FreeRectangles_BF(3)+#LF$+#LF$+ ; Amount created images
                   box_5_text$+"All over used Memory  "+FreeRectangles_BF(2)              ; Used Memory

Define box_5_empty_image_ID=CopyImage(Get_Rectangle_BF(box_5_ID), #PB_Any) ; Create a image without text for refresh the ImageGadget content

Macro draw_box_5(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(Get_Rectangle_BF(box_5_ID),
                                Font_Arial(), ; Font array
                                0,            ; Output pos x
                                0,            ; Output pos y
                                box_width_5,  ; Rectangle width
                                box_height_5, ; Rectangle height
                                9,            ; Edge rounding
                                text,         ; Text
                                text_color,   ; Text color
                                background_color,     ; Background color - Without text background = -1
                                6,                    ; Frame thickness
                                RGBA(0, 0, $FF, 150), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                25,                   ; Padding x, 
                                25,                   ; Padding y,
                                0,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_5(RGBA($AA, $AA, $80, 150), #White, box_5_text$)

Define image_gadget_5_ID=ImageGadget(#PB_Any, box_x_5, box_y_5, 0, 0, ImageID(Get_Rectangle_BF(box_5_ID)))

CloseGadgetList()

HideWindow(window_ID, 0)

; Handle the Boxes_BF
Define i, temp_text$
Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget 
    Macro text_output_1(text)
      CopyContent_Image_Image_BF(box_5_empty_image_ID, Get_Rectangle_BF(box_5_ID))
      draw_box_5(RGBA($AA, $AA, $80, 150), #White, "Gadget "+text+" was clicked")        
      SetGadgetState(image_gadget_5_ID, ImageID(Get_Rectangle_BF(box_5_ID)))
    EndMacro
    
    Macro gadget_1(text)
      CopyContent_Image_Image_BF(box_1_empty_image_ID, Get_Rectangle_BF(box_1_ID))
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux      
        SetGadgetState(image_gadget_1_ID, ImageID(Get_Rectangle_BF(box_1_ID)))
        draw_box_1(RGBA($B8, 86, $0B, 120), #Red, text) 
      CompilerElse
        draw_box_1(RGBA($B8, 86, $0B, 120), #Red, text)       
        SetGadgetState(image_gadget_1_ID, ImageID(Get_Rectangle_BF(box_1_ID)))
      CompilerEndIf
      While WindowEvent() : Wend
      Delay(180)
      CopyContent_Image_Image_BF(box_1_empty_image_ID, Get_Rectangle_BF(box_1_ID))
      draw_box_1(RGBA($B8, 86, $0B, 120), #White, text)       
      SetGadgetState(image_gadget_1_ID, ImageID(Get_Rectangle_BF(box_1_ID)))
      While WindowEvent() : Wend
    EndMacro
    
    Macro gadget_2(text)
      CopyContent_Image_Image_BF(box_2_empty_image_ID, Get_Rectangle_BF(box_2_ID))
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        SetGadgetState(image_gadget_2_ID, ImageID(Get_Rectangle_BF(box_2_ID)))
        draw_box_2(RGBA(0, $FF, $FF, 120), #Red, text) 
      CompilerElse
        draw_box_2(RGBA(0, $FF, $FF, 120), #Red, text) 
        SetGadgetState(image_gadget_2_ID, ImageID(Get_Rectangle_BF(box_2_ID)))
      CompilerEndIf
      While WindowEvent() : Wend
      Delay(180)
      CopyContent_Image_Image_BF(box_2_empty_image_ID, Get_Rectangle_BF(box_2_ID))
      draw_box_2(RGBA(0, $FF, $FF, 120), #Black, text)        
      SetGadgetState(image_gadget_2_ID, ImageID(Get_Rectangle_BF(box_2_ID))) 
      While WindowEvent() : Wend 
    EndMacro
    
    Macro gadget_3(text)
      CopyContent_Image_Image_BF(box_3_empty_image_ID, Get_Rectangle_BF(box_3_ID))
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        SetGadgetState(image_gadget_3_ID, ImageID(Get_Rectangle_BF(box_3_ID)))
        draw_box_3(RGBA(0, $FF, 0, 150), #Red, text)       
      CompilerElse
        draw_box_3(RGBA(0, $FF, 0, 150), #Red, text)       
        SetGadgetState(image_gadget_3_ID, ImageID(Get_Rectangle_BF(box_3_ID)))
      CompilerEndIf
      While WindowEvent() : Wend
      Delay(180)
      CopyContent_Image_Image_BF(box_3_empty_image_ID, Get_Rectangle_BF(box_3_ID))
      draw_box_3(RGBA(0, $FF, 0, 150), #Blue, text)        
      SetGadgetState(image_gadget_3_ID, ImageID(Get_Rectangle_BF(box_3_ID)))
      While WindowEvent() : Wend
    EndMacro
    
    Macro gadget_4(text)
      CopyContent_Image_Image_BF(box_4_empty_image_ID, Get_Rectangle_BF(box_4_ID))
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        SetGadgetState(image_gadget_4_ID, ImageID(Get_Rectangle_BF(box_4_ID)))
        draw_box_4(RGBA($FF, $FF, 0, 150), #Red, text)        
      CompilerElse
        draw_box_4(RGBA($FF, $FF, 0, 150), #Red, text)        
        SetGadgetState(image_gadget_4_ID, ImageID(Get_Rectangle_BF(box_4_ID)))
      CompilerEndIf
      While WindowEvent() : Wend
      Delay(180)
      CopyContent_Image_Image_BF(box_4_empty_image_ID, Get_Rectangle_BF(box_4_ID))
      draw_box_4(RGBA($FF, $FF, 0, 150), #Black, text)       
      SetGadgetState(image_gadget_4_ID, ImageID(Get_Rectangle_BF(box_4_ID))) 
      While WindowEvent() : Wend
    EndMacro
    
    Select EventGadget()
      Case image_gadget_1_ID
        text_output_1("1")
        temp_text$=box_1_text$ : box_1_Text$=box_2_text$ : box_2_text$=temp_text$ ; Flip text
        gadget_1(box_1_text$)
        gadget_2(box_2_text$)
        i=1-i : HideGadget(image_gadget_4_ID, i) ; Hidde Gadget 4 
      Case image_gadget_2_ID
        text_output_1("2")
        gadget_2(box_2_text$)
      Case image_gadget_3_ID
        text_output_1("3")
        gadget_3(box_3_text$)
      Case image_gadget_4_ID
        text_output_1("4")
        gadget_4(box_4_text$)
      Case image_gadget_5_ID
        text_output_1("5")
    EndSelect
  EndIf
  
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    FreeRectangles_BF() ; Free all Rectangles_BF
    FreeImage(box_1_empty_image_ID)
    FreeImage(box_2_empty_image_ID)
    FreeImage(box_3_empty_image_ID)
    FreeImage(box_4_empty_image_ID)
    FreeImage(box_5_empty_image_ID)
    Break
  EndIf
  
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 31
; FirstLine = 6
; Folding = --
; EnableXP
; DPIAware
; DisableDebugger