﻿; Clickable TextBoxes BF with Rectangle caching BF - Demo

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; DPI aware output
; You must also activate the DPI aware compiler option
Activate_DPI_aware_BF(1)

If Not GetState_Activate_DPI_aware_BF() ; On BF you can activate or deactivate self DPI_ResizeFactor_BF()
  Deactivate_DPI_ResizeFactor_BF(1)     ; So you have more control about it and can simple test with or without this feature
EndIf

Define win_event
Define needed_font_size, max_needed_font_size=72 ; 25 > 40 is mostly onough - Larger is slower
Define Dim Font_Arial(max_needed_font_size)
For needed_font_size=1 To max_needed_font_size ; Get the fonts
  Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
Next needed_font_size

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1000, 600, "Clickable TextBoxes BF with Rectangle caching BF",
                            #PB_Window_SystemMenu | #PB_Window_Invisible | #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 1000, 600)

; === Removing this part, remove the background image ===
; Define path$="./Image_Set/stone_1.jpg"
; Define path$="./Image_Set/testtexture_large.png"
Define path$="./Image_Set/Sunset.jpg"
Define texture_ID=LoadImage(#PB_Any, path$)

ResizeImage(texture_ID, 1000*DPI_ResizeFactor_BF(), 600*DPI_ResizeFactor_BF()) ; Only for Demo image Sunset.jpg

ErrorCheck_BF(BF(-2, canvas_ID, texture_ID)) ; Make a Background texture

; Hint :
; Vector outputs works not on screen, as sample FittedText_RoundBox_Vector_BF
; So BF provide also similar functions without vector lib using, as sample FittedText_BF or FittedText_RoundBox_BF
; Or you can output alterable to a PB Sprite

Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                            ; For using inside a callback procedure deactivate

; Box 1
Define box_x_1=50
Define box_y_1=50
Define box_width_1=260
Define box_height_1=80
Define box_1_text$="GFX_Wizzard_BF"

; Grab the boxes pos data and their image
Define box_1_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_1,      ; Output pos x
                                  box_y_1,      ; Output pos y
                                  box_width_1,  ; Rectangle width
                                  box_height_1, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  0,            ; Output offset x
                                  0,            ; Output_offset y
                                  0,            ; Output offset width
                                  0)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2

Macro draw_box_1(background_color, frame_color, text_color, text)
  FittedText_RoundBox_Vector_BF(canvas_ID,
                                Font_Arial(),     ; Font array
                                box_x_1,          ; Output pos x
                                box_y_1,          ; Output pos y
                                box_width_1,      ; Rectangle width
                                box_height_1,     ; Rectangle height
                                5,                ; Edge rounding
                                text,             ; Text
                                text_color,       ; Text color
                                background_color, ; Background color - Without text background = -1
                                5,                ; Frame thickness
                                frame_color,      ; Frame Color
                                1,                ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                ; Modes : Revers text mode=1 - RTL text mode=2
                                25,               ; Padding x, 
                                15,               ; Padding y,
                                0,                ; Headletter mode - text stretching x
                                0,                ; Headletter_mode - text stretching y
                                1)                ; resize_factor.f
EndMacro

draw_box_1(RGBA($B8, 86, $0B, 150), RGBA(0, 0, $FF, 255), #White, box_1_text$)

; Box 2
Define box_x_2=390
Define box_y_2=50
Define box_width_2=580
Define box_height_2=180
Define box_2_text$="These are clickable Text Boxes BF"+#LF$+
                   "With full automatically fitted Text"+#LF$+
                   "And nice Graphic Effects"

; Grab the boxes pos data and their image
Define box_2_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_2,      ; Output pos x
                                  box_y_2,      ; Output pos y
                                  box_width_2,  ; Rectangle width
                                  box_height_2, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  0,            ; Output offset x
                                  0,            ; Output_offset y
                                  0,            ; Output offset width
                                  0)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2


Macro draw_box_2(background_color, frame_color, text_color, text)
  FittedText_RoundBox_Vector_BF(canvas_ID,
                                Font_Arial(),     ; Font array
                                box_x_2,          ; Output pos x
                                box_y_2,          ; Output pos y
                                box_width_2,      ; Rectangle width
                                box_height_2,     ; Rectangle height
                                5,                ; Edge rounding
                                text,             ; Text
                                text_color,       ; Text color
                                background_color, ; Background color - Without text background = -1
                                8,                ; Frame thickness
                                frame_color,      ; Frame Color
                                1,                ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                ; Modes : Revers text mode=1 - RTL text mode=2
                                30,               ; Padding x, 
                                15,               ; Padding y,
                                1,                ; Headletter mode - text stretching x
                                10,               ; Headletter_mode - text stretching y
                                1)                ; resize_factor.f
EndMacro

draw_box_2(RGBA(0, $FF, $FF, 120), RGBA($FF, 0, 0, 255), #Black, box_2_text$)

; Box 3
Define box_x_3=50
Define box_y_3=350
Define box_width_3=550
Define box_height_3=230
Define box_3_text$="Click the Boxes"+#LF$+#LF$+
                   "This BF Functions can grab and cache"+#LF$+
                   "Rectangle Coordinates also with Images"+#LF$+
                   "You get a ID for each cached Rectangle"+#LF$+#LF$+
                   "Works with Images, Canvas and PB Sprites"+#LF$+
                   "Simple create your own Buttons and Boxes"

; Grab the boxes pos data and their image
Define box_3_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_3,      ; Output pos x
                                  box_y_3,      ; Output pos y
                                  box_width_3,  ; Rectangle width
                                  box_height_3, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  0,            ; Output offset x
                                  0,            ; Output_offset y
                                  0,            ; Output offset width
                                  0)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2


Macro draw_box_3(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(canvas_ID,
                                Font_Arial(),         ; Font array
                                box_x_3,              ; Output pos x
                                box_y_3,              ; Output pos y
                                box_width_3,          ; Rectangle width
                                box_height_3,         ; Rectangle height
                                5,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                background_color,     ; Background color - Without text background = -1
                                6,                    ; Frame thickness
                                RGBA($FF, 0, 0, 200), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                30,                   ; Padding x, 
                                25,                   ; Padding y,
                                1,                    ; Headletter mode - text stretching x
                                1,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_3(RGBA(0, $FF, 0, 150), #Blue, box_3_text$)

; Box 4
Define box_x_4=40
Define box_y_4=170
Define box_width_4=320
Define box_height_4=150
Define box_4_text$=#LF$+#LF$+
                   "Caching"+#LF$+
                   "Localizing"+#LF$+
                   "With or without Images"

; Grab the boxes pos data and their image
Define box_4_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_4,      ; Output pos x
                                  box_y_4,      ; Output pos y
                                  box_width_4,  ; Rectangle width
                                  box_height_4, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  0,            ; Output offset x
                                  0,            ; Output_offset y
                                  0,            ; Output offset width
                                  0)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2


Macro draw_box_4(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(canvas_ID,
                                Font_Arial(),       ; Font array
                                box_x_4,            ; Output pos x
                                box_y_4,            ; Output pos y
                                box_width_4,        ; Rectangle width
                                box_height_4,       ; Rectangle height
                                3,                  ; Edge rounding
                                text,               ; Text
                                text_color,         ; Text color
                                background_color,   ; Background color - Without text background = -1
                                6,                  ; Frame thickness
                                RGBA(0, $FF, 0, 0), ; Frame Color
                                1,                  ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                  ; Modes : Revers text mode=1 - RTL text mode=2
                                15,                 ; Padding x, 
                                25,                 ; Padding y,
                                2,                  ; Headletter mode - text stretching x
                                2,                  ; Headletter_mode - text stretching y
                                1)                  ; resize_factor.f
EndMacro

draw_box_4(RGBA($FF, $FF, 0, 150), #Black, box_4_text$)

; Box 4a - Add Headletter
Define box_x_4a=40
Define box_y_4a=170
Define box_width_4a=320
Define box_height_4a=70
Define box_4a_text$="Rectangle Tools"

Macro draw_box_4a(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(canvas_ID,
                                Font_Arial(),         ; Font Array
                                box_x_4a,             ; Output pos x
                                box_y_4a,             ; Output pos y
                                box_width_4a,         ; Rectangle width
                                box_height_4a,        ; Rectangle height
                                5,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                -1,                   ; Background color - Without text background = -1
                                0,                    ; Frame thickness
                                RGBA(0, 0, $FF, 200), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                35,                   ; Padding x, 
                                15,                   ; Padding y,
                                0,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_4a(RGBA($B8, 86, $0B, 120), #Blue, box_4a_text$)

; Box 5
Define box_x_5=645
Define box_y_5=290
Define box_width_5=300
Define box_height_5=250
Define box_5_text$

Macro draw_box_5(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(canvas_ID,
                                Font_Arial(),         ; Font array
                                box_x_5,              ; Output pos x
                                box_y_5,              ; Output pos y
                                box_width_5,          ; Rectangle width
                                box_height_5,         ; Rectangle height
                                7,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                background_color,     ; Background color - Without text background = -1
                                6,                    ; Frame thickness
                                RGBA(0, 0, $FF, 150), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                25,                   ; Padding x, 
                                20,                   ; Padding y,
                                0,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_5(RGBA($AA, $AA, $80, 150), #White, box_5_text$)

; Grab the boxes pos data and their image
Define box_5_ID=Grab_Rectangle_BF(canvas_ID,
                                  box_x_5,      ; Output pos x
                                  box_y_5,      ; Output pos y
                                  box_width_5,  ; Rectangle width
                                  box_height_5, ; Rectangle height
                                  1,            ; Grab the rectangle as image - 0=ignore a background image
                                  0,            ; Output offset x
                                  0,            ; Output_offset y
                                  0,            ; Output offset width
                                  0)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2


box_5_text$+"Amount Rectangles  "+FreeRectangles_BF(1)+#LF$+#LF$+ ; Count Rectangles
            box_5_text$+"All over cached Images  "+FreeRectangles_BF(3)+#LF$+#LF$+ ; Amount created images
            box_5_text$+"All over used Memory  "+FreeRectangles_BF(2)              ; Used Memory

draw_box_5(-1, #White, box_5_text$)

HideWindow(window_ID, 0)

; Handle the Boxes_BF
Repeat
  win_event=WaitWindowEvent()
  
  If win_event=#PB_Event_Gadget And EventGadget()=canvas_ID
    If EventType()=#PB_EventType_LeftButtonDown Or
       (EventType()=#PB_EventType_MouseMove And
        GetGadgetAttribute(canvas_ID, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
      
      Define canvas_x_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseX)
      Define canvas_y_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseY)
      Define found=1 : box_5_text$=""
      Select Get_Rectangle_ID_BF(canvas_x_pos, canvas_y_pos) ; The function read the rectangle stack reverse, for better handling child rectangles
        Case box_1_ID
          box_5_text$+#LF$+"Box 1 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_1_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_1_ID) ; This call fill the location variables
          draw_box_1(-1, RGBA($FF, 0, 0, 255), #White, box_1_text$)
          Delay(180)
          draw_box_1(-1, RGBA(0, 0, $FF, 255), #White, box_1_text$)
        Case box_2_ID
          box_5_text$+#LF$+"Box 2 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_2_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_2_ID) ; This call fill the location variables
          draw_box_2(-1, RGBA(0, $FF, 0, 255), #Black, box_2_text$)
          Delay(180)
          draw_box_2(-1, RGBA($FF, 0, 0, 255), #Black, box_2_text$)
        Case box_3_ID
          box_5_text$+#LF$+"Box 3 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_3_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_3_ID) ; This call fill the location variables
          draw_box_3(-1, #Red, box_3_text$)
          Delay(180)
          draw_box_3(-1, #Black, box_3_text$)
        Case box_4_ID
          box_5_text$+#LF$+"Box 4 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_4_ID  
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_4_ID) ; This call fill the location variables
          draw_box_4(-1, #Red, box_4_text$)
          draw_box_4a(-1, #Red, box_4a_text$)
          Delay(180)
          draw_box_4(-1, #Black, box_4_text$)
          draw_box_4a(-1, #Blue, box_4a_text$)
        Case box_5_ID
          box_5_text$+#LF$+"Box 5 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_5_ID 
          box_5_text$+#LF$+"Image ID  "+Get_Rectangle_BF(box_5_ID) ; This call fill the location variables
        Default
          found=0
      EndSelect
      
      If found
        box_5_text$+#LF$+#LF$+"Rectangle x pos "+Get_Rectangle_x_BF()
        box_5_text$+#LF$+"Rectangle y pos "+Get_Rectangle_y_BF()
        box_5_text$+#LF$+"Rectangle width "+Get_Rectangle_width_BF()
        box_5_text$+#LF$+"Rectangle height "+Get_Rectangle_height_BF()+#LF$
      Else
        box_5_text$="     Outside a Box     "       
      EndIf
      
      Draw_Rectangle_Image_BF(box_5_ID,  ; Rectangle ID
                              canvas_ID, ; Output ID
                              0,         ; Output offset x
                              0,         ; Output_offset y
                              0,         ; Output offset width
                              0)         ; Output offset height
                                         ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                         ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2
                                         ; This function can output on images, PB sprites, canvas
                                         ; For screen output set firstly ActivateScreenOutput_BF(1)
      
      Delay(180)  
      draw_box_5(-1, #White, box_5_text$) 
    EndIf
  EndIf
  
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    FreeRectangles_BF() ; Free all Rectangles_BF
    Break
  EndIf
  
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 31
; FirstLine = 12
; Folding = --
; EnableXP
; DPIAware
; DisableDebugger