﻿; Clickable TextBoxes BF with Rectangle caching BF - Demo

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit
Define win_event

; DPI aware output
; You must also activate the DPI aware compiler option
Activate_DPI_aware_BF(1)

If Not GetState_Activate_DPI_aware_BF() ; On BF you can activate or deactivate self the DPI_ResizeFactor_BF() function
  Deactivate_DPI_ResizeFactor_BF(1)     ; So you have more control about it and can simple test with or without this feature
EndIf

Define needed_font_size, max_needed_font_size=72 ; 25 > 40 is mostly onough - Larger is slower
Define Dim Font_Arial(max_needed_font_size)
For needed_font_size=1 To max_needed_font_size ; Get the fonts
  Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
Next needed_font_size

Define output_width=1000
Define output_height=600

Get_all_Window_Events_BF(1) ; Activate for fixing output problems with complex text and textboxes on MacOS 
                            ; For using inside a callback procedure deactivate

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "Clickable TextBoxes BF with Rectangle caching BF",
                            #PB_Window_SystemMenu | #PB_Window_Invisible | #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, output_width, output_height, #PB_Canvas_Container)

; Sample using a BF enhanced ButtonGadget PB
Define button_1_ID=ButtonGadget(#PB_Any, 70, output_height-130, 250, 50, "Hide the multi Rectangle Gadget")

FitGadgetText_BF(button_1_ID, ; Enhance a ButtonGadget
                 Font_Arial(),; Font array
                 -1,          ; x
                 -1,          ; y
                 -1,          ; Width
                 -1,          ; Height
                 25,          ; Padding x
                 25,          ; Padding y
                 1)           ; resize_factor.f

; Sample using ButtonGadgetSimple_BF
Define button_2_ID=ButtonGadgetSimple_BF("Show the multi Rectangle Gadget"+#LF$+"Multiple click removes the transparency",
                                         Font_Arial(),      ; Font array                                    
                                         330,               ; x
                                         output_height-130, ; y
                                         250,               ; Width
                                         50,                ; Height
                                         35,                ; Text padding x - -1 = Preset 25 
                                         0,                 ; Text padding y - -1 = Preset 15 
                                         1)                 ; Text resize_factor

CloseGadgetList()

output_width*DPI_ResizeFactor_BF() ; DPI aware output
output_height*DPI_ResizeFactor_BF()

; === Removing this part, remove the background image ===
; Define path$="./Image_Set/stone_1.png"
; Define path$="./Image_Set/testtexture_large.png"
Define path$="./Image_Set/Sunset.jpg"
Define texture_ID=LoadImage(#PB_Any, path$)

ResizeImage(texture_ID, output_width, output_height) ; Only for Demo image Sunset.jpg

Define temporary_image_1_ID=CreateImage(#PB_Any, output_width, output_height)
Define temporary_image_2_ID=CreateImage(#PB_Any, output_width, output_height)

ErrorCheck_BF(BF(-2, temporary_image_1_ID, texture_ID)) ; Make a Background texture
FreeImage(texture_ID)

Define texture_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
ResizeImage(texture_ID, 20, 20)

#Sheet="./Image_Set/Kid_1.png"
Define sheet_ID=LoadImage(#PB_Any, #Sheet)
GetFrameData_fromSheet_BF(#Sheet) ; Get all frame date from the sheet and use the BF frame variables
                                  ; A sheet info file is not needed
                                  ; You can convert GIF with the SpriteTool_BF to Sheets_BF
                                  ; Sheets_BF are high flexible and very simple for editing and changing contents

; Hint :
; Vector outputs works not on screen, as sample FittedText_RoundBox_Vector_BF
; So BF provide also similar functions without vector lib using, as sample FittedText_BF or FittedText_RoundBox_BF
; Or you can output alterable to a PB Sprite

; Grab_Rectangle_BF has included DPI_aware_BF enhancement

; Box 1
Define box_x_1=50
Define box_y_1=50
Define box_width_1=550
Define box_height_1=400
Define box_1_text$="Rectangle Tools BF"

; Grab the boxes pos data and their image
Define box_1_ID=Grab_Rectangle_BF(temporary_image_1_ID,
                                  box_x_1,      ; Output pos x
                                  box_y_1,      ; Output pos y
                                  box_width_1,  ; Rectangle width
                                  box_height_1, ; Rectangle height
                                  1,            ; Grab the rectangle as image - 0=ignore a background image
                                  -1,           ; Output offset x
                                  -1,           ; Output_offset y
                                  2,            ; Output offset width
                                  2)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2

Macro draw_box_1(background_color, frame_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),     ; Font array
                                box_x_1,          ; Output pos x
                                box_y_1,          ; Output pos y
                                box_width_1,      ; Rectangle width
                                box_height_1,     ; Rectangle height
                                5,                ; Edge rounding
                                text,             ; Text
                                text_color,       ; Text color
                                background_color, ; Background color - Without text background = -1
                                10,               ; Frame thickness
                                frame_color,      ; Frame Color
                                1,                ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                ; Modes : Revers text mode=1 - RTL text mode=2
                                50,               ; Padding x, 
                                15,               ; Padding y,
                                0,                ; Headletter mode - text stretching x
                                0,                ; Headletter_mode - text stretching y
                                1)                ; resize_factor.f
EndMacro

draw_box_1(RGBA($B8, 86, $0B, 150), RGBA(0, 0, $FF, 255), $AAFFAA, box_1_text$)

; Box 2
Define box_x_2=80
Define box_y_2=70
Define box_width_2=200
Define box_height_2=80
Define box_2_text$="Click me"+#LF$+
                   "Child 1"

; Grab the boxes pos data and their image
Define box_2_ID=Grab_Rectangle_BF(temporary_image_1_ID,
                                  box_x_2,      ; Output pos x
                                  box_y_2,      ; Output pos y
                                  box_width_2,  ; Rectangle width
                                  box_height_2, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  -1,           ; Output offset x
                                  -1,           ; Output_offset y
                                  2,            ; Output offset width
                                  2)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2


Macro draw_box_2(background_color, frame_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),     ; Font array
                                box_x_2,          ; Output pos x
                                box_y_2,          ; Output pos y
                                box_width_2,      ; Rectangle width
                                box_height_2,     ; Rectangle height
                                5,                ; Edge rounding
                                text,             ; Text
                                text_color,       ; Text color
                                background_color, ; Background color - Without text background = -1
                                8,                ; Frame thickness
                                frame_color,      ; Frame Color
                                1,                ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                ; Modes : Revers text mode=1 - RTL text mode=2
                                25,               ; Padding x, 
                                15,               ; Padding y,
                                1,                ; Headletter mode - text stretching x
                                0,                ; Headletter_mode - text stretching y
                                1)                ; resize_factor.f
EndMacro

draw_box_2(RGBA(0, $FF, 0, 100), RGBA($FF, 0, 0, 255), #White, box_2_text$)

; Box 3
Define box_x_3=370
Define box_y_3=70
Define box_width_3=200
Define box_height_3=80
Define box_3_text$="Child 2"

; Grab the boxes pos data and their image
Define box_3_ID=Grab_Rectangle_BF(temporary_image_1_ID,
                                  box_x_3,      ; Output pos x
                                  box_y_3,      ; Output pos y
                                  box_width_3,  ; Rectangle width
                                  box_height_3, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  -1,           ; Output offset x
                                  -1,           ; Output_offset y
                                  2,            ; Output offset width
                                  2)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2


Macro draw_box_3(background_color, frame_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),     ; Font array
                                box_x_3,          ; Output pos x
                                box_y_3,          ; Output pos y
                                box_width_3,      ; Rectangle width
                                box_height_3,     ; Rectangle height
                                5,                ; Edge rounding
                                text,             ; Text
                                text_color,       ; Text color
                                background_color, ; Background color - Without text background = -1
                                8,                ; Frame thickness
                                frame_color,      ; Frame Color
                                1,                ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                ; Modes : Revers text mode=1 - RTL text mode=2
                                25,               ; Padding x, 
                                35,               ; Padding y,
                                0,                ; Headletter mode - text stretching x
                                0,                ; Headletter_mode - text stretching y
                                1)                ; resize_factor.f
EndMacro

draw_box_3(RGBA(0, $FF, 0, 100), RGBA($FF, 0, 0, 255), #White, box_3_text$)

; Box 4
Define box_x_4=160
Define box_y_4=300
Define box_width_4=320
Define box_height_4=120
Define box_4_text$="GFX_Wizzard_BF"+#LF$+"Rectangle Tools"+#LF$+
                   "This is a Multi Rectangle"+#LF$+
                   "Custom Gadget BF"

; Grab the boxes pos data and their image
Define box_4_ID=Grab_Rectangle_BF(temporary_image_1_ID,
                                  box_x_4,      ; Output pos x
                                  box_y_4,      ; Output pos y
                                  box_width_4,  ; Rectangle width
                                  box_height_4, ; Rectangle height
                                  0,            ; Grab the rectangle as image - 0=ignore a background image
                                  -1,           ; Output offset x
                                  -1,           ; Output_offset y
                                  2,            ; Output offset width
                                  2)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2

Macro draw_box_4(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),       ; Font array
                                box_x_4,            ; Output pos x
                                box_y_4,            ; Output pos y
                                box_width_4,        ; Rectangle width
                                box_height_4,       ; Rectangle height
                                3,                  ; Edge rounding
                                text,               ; Text
                                text_color,         ; Text color
                                background_color,   ; Background color - Without text background = -1
                                6,                  ; Frame thickness
                                RGBA(0, $FF, 0, 0), ; Frame Color
                                1,                  ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                  ; Modes : Revers text mode=1 - RTL text mode=2
                                15,                 ; Padding x, 
                                25,                 ; Padding y,
                                0,                  ; Headletter mode - text stretching x
                                0,                  ; Headletter_mode - text stretching y
                                1)                  ; resize_factor.f
EndMacro

draw_box_4(RGBA($FF, $FF, 0, 80), #Black, box_4_text$)

; Box 4a - Add Headletter
Define box_x_4a=170
Define box_y_4a=150
Define box_width_4a=320
Define box_height_4a=70
Define box_4a_text$="Custom Gadgets"

Macro draw_box_4a(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),         ; Font Array
                                box_x_4a,             ; Output pos x
                                box_y_4a,             ; Output pos y
                                box_width_4a,         ; Rectangle width
                                box_height_4a,        ; Rectangle height
                                5,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                -1,                   ; Background color - Without text background = -1
                                0,                    ; Frame thickness
                                RGBA(0, 0, $FF, 200), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                25,                   ; Padding x, 
                                15,                   ; Padding y,
                                3,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_4a(RGBA($B8, 86, $0B, 120), #Blue, box_4a_text$)

; Box 5
Define box_x_5=645
Define box_y_5=290
Define box_width_5=300
Define box_height_5=250
Define box_5_text$

Macro draw_box_5(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),         ; Font array
                                box_x_5,              ; Output pos x
                                box_y_5,              ; Output pos y
                                box_width_5,          ; Rectangle width
                                box_height_5,         ; Rectangle height
                                7,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                background_color,     ; Background color - Without text background = -1
                                6,                    ; Frame thickness
                                RGBA(0, 0, $FF, 150), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                25,                   ; Padding x, 
                                20,                   ; Padding y,
                                0,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_5(RGBA($AA, $AA, $80, 150), #White, box_5_text$)

; Grab the boxes pos data and their image
Define box_5_ID=Grab_Rectangle_BF(temporary_image_1_ID,
                                  box_x_5,      ; Output pos x
                                  box_y_5,      ; Output pos y
                                  box_width_5,  ; Rectangle width
                                  box_height_5, ; Rectangle height
                                  1,            ; Grab the rectangle as image - 0=ignore a background image
                                  -1,           ; Output offset x
                                  -1,           ; Output_offset y
                                  2,            ; output offset width
                                  2)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2

box_5_text$+"Amount Rectangles  "+FreeRectangles_BF(1)+#LF$+#LF$+ ; Count Rectangles
            box_5_text$+"All over cached Images  "+FreeRectangles_BF(3)+#LF$+#LF$+ ; Amount created images
            box_5_text$+"All over used Memory  "+FreeRectangles_BF(2)              ; Used Memory

draw_box_5(-1, #White, box_5_text$)

; Box 6
Define box_x_6=420
Define box_y_6=310
Define box_width_6=50
Define box_height_6=30
Define box_6_text$

Macro draw_box_6(background_color, text_color, text)
  FittedText_RoundBox_Vector_BF(temporary_image_1_ID,
                                Font_Arial(),         ; Font array
                                box_x_6,              ; Output pos x
                                box_y_6,              ; Output pos y
                                box_width_6,          ; Rectangle width
                                box_height_6,         ; Rectangle height
                                2,                    ; Edge rounding
                                text,                 ; Text
                                text_color,           ; Text color
                                background_color,     ; Background color - Without text background = -1
                                3,                    ; Frame thickness
                                RGBA(0, 0, $FF, 150), ; Frame Color
                                1,                    ; Flags : Text center=1 - Text right=2 - Text vertical=3
                                0,                    ; Modes : Revers text mode=1 - RTL text mode=2
                                15,                   ; Padding x, 
                                12,                   ; Padding y,
                                0,                    ; Headletter mode - text stretching x
                                0,                    ; Headletter_mode - text stretching y
                                1)                    ; resize_factor.f
EndMacro

draw_box_6(RGBA($AA, $AA, $80, 150), #White, box_6_text$)

; Grab the boxes pos data and their image
Define box_6_ID=Grab_Rectangle_BF(temporary_image_1_ID,
                                  box_x_6,      ; Output pos x
                                  box_y_6,      ; Output pos y
                                  box_width_6,  ; Rectangle width
                                  box_height_6, ; Rectangle height
                                  1,            ; Grab the rectangle as image - 0=ignore a background image
                                  -1,           ; Output offset x
                                  -1,           ; Output_offset y
                                  2,            ; output offset width
                                  2)            ; Output offset height
                                                ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2

box_6_text$+"SUB"

draw_box_6(-1, #White, box_6_text$)

; Draw sprite sheet
; Sprite and image based BF functions have not a included DPI_aware_BF encancement, as this would be counterproductive
Macro draw_sheet
  Define alpha=1 ; BF specific 1=Full visible
  SetColorDistanceSpriteMask_BF(10)
  ResizeInterpolation_BF(0)
  ErrorCheck_BF(Sprite_CSS_sheet_simple_BF(alpha, temporary_image_1_ID, sheet_ID,
                                           0,                              ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                           0,                              ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                           75*DPI_ResizeFactor_BF(),       ; Output position x
                                           300*DPI_ResizeFactor_BF(),      ; Output position y
                                           frames,                         ; Numbers of frames
                                           frame,                          ; Selected frame - For GIF compatibility the first frame is 0
                                           GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                           GetGIFandCSS_Frame_height_BF(), ; Frame height
                                           0,                              ; Frames in a row - Preset 0, then BF calculate self
                                           GetGIFandCSS_Frame_width_BF()*DPI_ResizeFactor_BF(),  ; Resizing - Define the output width - Preset zero = without resizing 
                                           GetGIFandCSS_Frame_height_BF()*DPI_ResizeFactor_BF(), ; Resizing - Define the output height
                                           0,                                                    ; Startposition inside the texture - Preset 0
                                           0,                                                    ; Startposition inside the texture - Preset 0
                                           0,                                                    ; Endposition inside the texture - Preset 0 = full texture width
                                           0))                                                   ; Endposition inside the texture - Preset 0 = full texture height
                                                                                                 ; mode 0 = Without invisible color
                                                                                                 ; mode 1 > 256 = With invisible color and with alpha blending
                                                                                                 ; mode -1 > -256 = Without invisible color and with alpha blending
                                                                                                 ; This is a special function for very fast CSS sheet output- mode 0 is the fastest mode - Image output is a little faster as canvas output
                                                                                                 ; The function is not based on the GFX_Wizzard_BF core function, can so not output multiple pattern and works not with the BF sprite arrayial function for very fast CSS sheet output- mode 0 is the fastest mode - Image output is a little faster as canvas output
                                                                                                 ; The function is not based on the GFX_Wizzard_BF core function, can so not output multiple pattern and works not with the BF sprite array
  
  ResizeInterpolation_BF(1)
  SetColorDistanceSpriteMask_BF(0)
EndMacro

; Text info
Define text_info$="With the GFX_Wizzard_BF you can create text outputs,"+#LF$+
                  "text boxes and custom gadgets of any kind"+#LF$+
                  "You can create small works of art"+#LF$+
                  "It is important that you are familiar with how it works"+#LF$+
                  "Familiarize with the Wizzard"+#LF$+
                  "Many functions can be combined with each other"+#LF$+
                  "And thus create new functions again"+#LF$+
                  "The possibilities are almost endless"

FittedText_BF(temporary_image_1_ID,
              Font_Arial(), ; Font array
              600,          ; Output pos x
              70,           ; Output pos y
              400,          ; Rectangle width
              200,          ; Rectangle height
              text_info$,   ; Text
              $FFFFFF,      ; Text color
              -1,           ; Background color - Without text background = -1
              0,            ; Frame thickness
              0,            ; Frame Color
              1,            ; Flags : Text center=1 - Text right=2 - Text vertical=3
              0,            ; Modes : Revers text mode=1 - RTL text mode=2
              25,           ; Padding x, 
              20,           ; Padding y,
              0,            ; Headletter mode - text stretching x
              5,            ; Headletter_mode - text stretching y
              1)            ; resize_factor.f

HideWindow(window_ID, 0)

; Handle the Boxes_BF
Define output_x=0, output_y=0
SetColor_BF($AAFFAA) ; Set the color for replacing with a texture

; Set color distance for the texture scrolling - This remove edge glowing - Depending on colour, use this carefully
; Edge glow is not always undesirable - Textured texts can be given very beautiful edges by selecting specific colours
SetColorDistanceFill_BF(12) 

Define init=1, frame, frames=GetGIFandCSS_Frames_BF() ; Init the Sprite sheet variables and get the frames amount

Repeat
  win_event=WaitWindowEvent(10)
  If win_event=#PB_Event_Gadget And EventGadget()=button_1_ID
    Define rectangle_image_ID=Get_Rectangle_ImageID_BF(box_1_ID) ; Fill firstly the location variables
    CopyContent_Image_Image_BF(rectangle_image_ID,
                               temporary_image_1_ID,
                               Get_Rectangle_x_BF(),
                               Get_Rectangle_y_BF())
  EndIf
  
  If win_event=#PB_Event_Gadget And EventGadget()=button_2_ID
    draw_box_1(RGBA($B8, 86, $0B, 150), RGBA(0, 0, $FF, 255), $AAFFAA, box_1_text$)
    draw_box_2(RGBA(0, $FF, 0, 100), RGBA($FF, 0, 0, 255), #White, box_2_text$)
    draw_box_3(RGBA(0, $FF, 0, 100), RGBA($FF, 0, 0, 255), #White, box_3_text$)
    draw_box_4(RGBA($FF, $FF, 0, 80), #Black, box_4_text$)
    draw_box_4a(RGBA($B8, 86, $0B, 120), #Blue, box_4a_text$)
    draw_box_6(RGBA($AA, $AA, $80, 150), #White, box_6_text$)
  EndIf
  
  If win_event=#PB_Event_Gadget And EventGadget()=canvas_ID
    If EventType()=#PB_EventType_LeftButtonDown Or
       (EventType()=#PB_EventType_MouseMove And
        GetGadgetAttribute(canvas_ID, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
      
      Define canvas_x_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseX)
      Define canvas_y_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseY)
      Define found=1 : box_5_text$=""
      Select Get_Rectangle_ID_BF(canvas_x_pos, canvas_y_pos) ; The function read the rectangle stack reverse, for better handling child rectangles
        Case box_1_ID
          box_5_text$+#LF$+"Box 1 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_1_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_1_ID) ; This call fill the location variables
          draw_box_1(-1, RGBA($FE, 0, 0, 255), $AAFFAA, box_1_text$)
          BF(-2, temporary_image_1_ID, texture_ID, -1, -1, output_x, output_y) ; Scroll a texture with the BF core function                                                 ; Set the color for replacing with a texture
          draw_sheet
          CopyContent_Image_Canvas_BF(temporary_image_1_ID, canvas_ID)
          Delay(100)
          CopyContent_Image_Image_BF(temporary_image_2_ID, temporary_image_1_ID)
          draw_box_1(-1, RGBA(0, 0, $FF, 255), $AAFFAA, box_1_text$)
        Case box_2_ID
          box_5_text$+#LF$+"Box 2 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_2_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_2_ID) ; This call fill the location variables
          draw_box_2(-1, RGBA(0, $FF, 0, 255), 0, box_2_text$)
          BF(-2, temporary_image_1_ID, texture_ID, -1, -1, output_x, output_y) ; Scroll a texture with the BF core function
          draw_sheet
          CopyContent_Image_Canvas_BF(temporary_image_1_ID, canvas_ID)
          Delay(100)
          CopyContent_Image_Image_BF(temporary_image_2_ID, temporary_image_1_ID)
          draw_box_2(-1, RGBA($FF, 0, 0, 255), #White, box_2_text$)
        Case box_3_ID
          box_5_text$+#LF$+"Box 3 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_3_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_3_ID) ; This call fill the location variables
          draw_box_3(-1, RGBA(0, $FF, 0, 255), #White, box_3_text$)
          draw_sheet
          CopyContent_Image_Canvas_BF(temporary_image_1_ID, canvas_ID)
          Delay(100)
          CopyContent_Image_Image_BF(temporary_image_2_ID, temporary_image_1_ID)
          draw_box_3(-1, RGBA($FF, 0, 0, 255), #White, box_3_text$)
        Case box_4_ID
          box_5_text$+#LF$+"Box 4 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_4_ID  
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_4_ID) ; This call fill the location variables
          draw_box_4(-1, #Red, box_4_text$)
          draw_box_4a(-1, #Red, box_4a_text$)
          BF(-2, temporary_image_1_ID, texture_ID, -1, -1, output_x, output_y) ; Scroll a texture with the BF core function
          draw_sheet
          CopyContent_Image_Canvas_BF(temporary_image_1_ID, canvas_ID)
          Delay(100)
          CopyContent_Image_Image_BF(temporary_image_2_ID, temporary_image_1_ID)
          draw_box_4(-1, #Black, box_4_text$)
          draw_box_4a(-1, #Blue, box_4a_text$)
        Case box_5_ID
          box_5_text$+#LF$+"Box 5 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_5_ID 
          box_5_text$+#LF$+"Image ID  "+Get_Rectangle_BF(box_5_ID) ; This call fill the location variables
        Case box_6_ID
          box_5_text$+#LF$+"Box 6 selected"+#LF$
          box_5_text$+#LF$+"Box ID  "+box_6_ID
          box_5_text$+#LF$+"Image not cached"
          Get_Rectangle_BF(box_6_ID) ; This call fill the location variables
          draw_box_6(-1, #Red, box_6_text$)
          draw_sheet
          CopyContent_Image_Canvas_BF(temporary_image_1_ID, canvas_ID)
          Delay(100)
          CopyContent_Image_Image_BF(temporary_image_2_ID, temporary_image_1_ID)
          draw_box_6(-1, #White, box_6_text$)
        Default
          found=0
      EndSelect
      
      If found
        box_5_text$+#LF$+#LF$+"Rectangle x pos "+Get_Rectangle_x_BF()
        box_5_text$+#LF$+"Rectangle y pos "+Get_Rectangle_y_BF()
        box_5_text$+#LF$+"Rectangle width "+Get_Rectangle_width_BF()
        box_5_text$+#LF$+"Rectangle height "+Get_Rectangle_height_BF()+#LF$
      Else
        box_5_text$="     Outside a Box     "       
      EndIf
      
      Draw_Rectangle_Image_BF(box_5_ID, ; Rectangle ID
                              temporary_image_1_ID, ; Output ID
                              -1,                   ; Output offset x
                              -1,                   ; Output_offset y
                              2,                    ; output offset width
                              2)                    ; Output offset height
                                                    ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                                    ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2
                                                    ; This function can output on images, PB sprites, canvas
                                                    ; For screen output set firstly ActivateScreenOutput_BF(1)
      
      Delay(100)  
      draw_box_5(-1, #White, box_5_text$) 
    EndIf
  EndIf
  
  ; Look the magic of BF 
  If Delay_BF(0, 30) ; Timer 0 - 100 timer available 0 - 99 - you can change
    CopyContent_Image_Image_BF(temporary_image_1_ID, temporary_image_2_ID)
    BF(-2, temporary_image_1_ID, texture_ID, -1, -1, output_x, output_y) ; Scroll a texture with the BF core function
    output_x-1 : If output_x<-ImageWidth(texture_ID) : output_x=0 : EndIf
    output_y-1 : If output_y<-ImageHeight(texture_ID) : output_y=0 : EndIf 
    
    If Delay_BF(1, GetGIFandCSS_delay_array_BF(frame)) : If Not init : init=1 : Else : frame+1 : init=1 : EndIf : If frame=>frames : frame=0 : EndIf : EndIf
    
    draw_sheet
    
    CopyContent_Image_Canvas_BF(temporary_image_1_ID, canvas_ID)
    CopyContent_Image_Image_BF(temporary_image_2_ID, temporary_image_1_ID)
  EndIf
  
  If win_event=#PB_Event_CloseWindow
    FreeImage(texture_ID)
    FreeImage(sheet_ID)
    FreeImage(temporary_image_1_ID)
    FreeImage(temporary_image_2_ID)
    FreeTextures_BF() ; Free grabed textures
    FreeRectangles_BF() ; Free all Rectangles_BF
    Break
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 14
; FirstLine = 7
; Folding = --
; EnableXP
; DPIAware
; DisableDebugger