﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - ImageGadget_BF - FadeIn > FadeOut

EnableExplicit

; Workaround Linux PB570 window background color
CompilerIf #PB_Compiler_OS=#PB_OS_Linux And Not Subsystem("gtk2") And Not Subsystem("qt")
  Macro SetWindowColor(window_ID, color)
    Window_SetCssBackColor(window_ID, color)
  EndMacro
  ImportC "" ; By Oma
    gtk_css_provider_load_from_data(*css_provider, data_.p-utf8, length, *error.GError)
    gtk_css_provider_new()
    gtk_style_context_add_provider(*context, *provider, priority)
    gtk_widget_get_style_context(*widget.GtkWidget)
  EndImport
  Procedure Window_SetCssBackColor(Window_ID, color)
    #GTK_STYLE_PROVIDER_PRIORITY_USER=800
    Protected color$, *gProvider=gtk_css_provider_new()
    ; Protected color$="#"+RSet(Hex(color), 6, "000000")
    color$="#"+RSet(Hex(Red(color)), 2, "00")+RSet(Hex(Green(color)), 2, "00")+RSet(Hex(Blue(color)), 2, "00")   
    Protected.s WinBkGndCSS="window.background{background-color: "+color$+";" + #LF$ + "}"
    gtk_css_provider_load_from_data(*gProvider, WinBkGndCSS, -1, #Null)
    gtk_style_context_add_provider(gtk_widget_get_style_context(WindowID(window_ID)), *gProvider, #GTK_STYLE_PROVIDER_PRIORITY_USER)
  EndProcedure
CompilerEndIf

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define button_width=450
Define button_height=350
Define background_color=#White
Define padding=30
Define grid_color=$808080
Define grid_size=0 
Define grid_tiling=1
Define frame_color=#Blue
Define frame_size=5
Define button_flag=#PB_Image_Border ; Flags same the PB function
Define overlay_color=#Blue
Define animation_delay=6
Define animation_alpha_step=9

Define image_a_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
Define image_b_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")

Define window_color=$A0A0A0
Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 600, "Klick me - FadeIn and FadeOut Demo with ImageGadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
SetWindowColor(window_ID, window_color)

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/2-button_height/2

FitImageActivateUpscaling_BF(1) ; Activate upscaling - For little images

Activate_DPI_aware_BF(1) ; This activate DPI_aware

Define image_gadget_1_ID=ImageGadget_BF(image_a_ID,
                                        x_pos+100,
                                        y_pos+90,
                                        button_width,
                                        button_height,
                                        background_color,
                                        padding,
                                        grid_color,
                                        grid_size,
                                        grid_tiling,
                                        frame_color,
                                        frame_size,
                                        button_flag)

Define image_gadget_2_ID=ImageGadget_BF(image_a_ID,
                                        10,
                                        10,
                                        250,
                                        200,
                                        window_color,
                                        padding,
                                        grid_color,
                                        grid_size,
                                        grid_tiling,
                                        frame_color,
                                        0)


Define font_ID=LoadFont(#PB_Any, "Arial", 20) ; Set simple the max needed font size - TextGadget_BF scale the text automatically
Define text_gadget_1_ID=Textgadget_BF("Click the images", 380, 50, 250, 80, #Blue, window_color, font_ID)

; =================== Main Loop ===================

Repeat
  
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget
    If EventGadget()=image_gadget_1_ID Or EventGadget()=image_gadget_2_ID
      
      ; Fade in and fade out images with ImageGadget_BF - Full automatic mode- This function get and set ImageData (0 > 1)
      SetImageGadget_BF_AutoFade_BF(image_gadget_1_ID,
                                    image_a_ID,
                                    image_b_ID,
                                    background_color,
                                    overlay_color,
                                    animation_delay,
                                    animation_alpha_step)
      
      SetImageGadget_BF_AutoFade_BF(image_gadget_2_ID,
                                    image_a_ID,
                                    image_b_ID,
                                    window_color,
                                    window_color,
                                    animation_delay,
                                    animation_alpha_step)  
      
      ; Fade in and fade out images with ImageGadget_BF - Recommendation : Set ImageData (0 > 1) as state - This function works also with the automatic version above
      If GetGadgetData(image_gadget_1_ID) ; Toggle from b to a
        
        SetImageGadget_BF_Fade_BF(image_gadget_1_ID, ; Gadget 1
                                  image_b_ID,
                                  image_a_ID,
                                  background_color,
                                  overlay_color,
                                  animation_delay,
                                  animation_alpha_step)
        
        SetImageGadget_BF_Fade_BF(image_gadget_2_ID, ; Gadget 2
                                  image_b_ID,
                                  image_a_ID,
                                  window_color,
                                  window_color,
                                  animation_delay,
                                  animation_alpha_step)
        
        SetGadgetData(image_gadget_1_ID, 0)
        
      Else ; Toggle from a to b
        
        SetImageGadget_BF_Fade_BF(image_gadget_1_ID, ; Gadget 1
                                  image_a_ID,
                                  image_b_ID,
                                  background_color,
                                  overlay_color,
                                  animation_delay,
                                  animation_alpha_step)
        
        SetImageGadget_BF_Fade_BF(image_gadget_2_ID, ; Gadget 2
                                  image_a_ID,
                                  image_b_ID,
                                  window_color,
                                  window_color,
                                  animation_delay,
                                  animation_alpha_step)
        
        SetGadgetData(image_gadget_1_ID, 1)
        
      EndIf
      
    EndIf
  EndIf
  
Until win_event=#PB_Event_CloseWindow

FitImageActivateUpscaling_BF(0)
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 106
; FirstLine = 132
; Folding = -
; EnableXP
; DPIAware