﻿; - Demo - Use a CSS Alpha Channel sprite sheet with a ImageGadget_BF
CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  ; This function is created for simple using sheets with a symmetric frame arrangement
  ; As sample, for sheets created with the BF sheet creating tool for GIF pictures 
  ; For all other sheets use the method demonstrated in the demo code for RAW handling sprite sheets
  
  EnableExplicit
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  Define window_ID, texture_ID, output_ID
  Define win_event, image_width, image_height, frame, delay
  
  #Gif="./Image_Set/Chicken_1.gif"
  
  ; Presets
  image_width=600 : image_height=475
  
  window_ID=OpenWindow(#PB_Any, 0, 0, image_width, image_height, "GFX_Wizzard_BF - Using GIF as sprite sheet with ImageGadget_BF",
                       #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  SetWindowColor(window_ID, $D0D0D0)
  WindowBounds(window_ID, 150, 150-MenuHeight(), #PB_Ignore, #PB_Ignore)
  
  Define gif_ID=LoadImage(#PB_Any, #Gif)
  
  ActivateAlphaChannel_BF(1) ; Create a sprite sheet from a GIF with invisible background
  texture_ID=CreateCSSSheet_simple_BF(gif_ID)
  ActivateAlphaChannel_BF(0) 
  
  ; For multiple GIF outputs you can simple get all GIF frame data also in a string
  Define sheet$=SetFrameDataInString_BF() ; Grabbing the GIF frame data and put it in a string - Take with care
                                          ; Then you can simple automatically move the sheet frame data in the BF Sheet and GIF variables for simplest using and output
  Debug GetFrameDataFromString_BF(sheet$) ; Grabbing a frame data string and put it in the frame datas
  
  Define frame_width=GetGIFandCSS_Frame_width_BF() ; Frame width
  Define frame_height=GetGIFandCSS_Frame_height_BF() ; Frame height
  
  Define frames=GetGIFandCSS_Frames_BF() ; Count frames in the sheet
  
  Define output_width=0  ; Output width  - For original frame width set width = 0
  Define output_height=0 ; Output height - For original frame height set height = 0
  
  Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
  Define texture_clip_y=0 ; Startposition inside the texture - Preset 0
  
  Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
  Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture width
  
  ; Get the result
  
  Define x=60                     ; Output pos x
  Define y=35                     ; Output pos y
  Define padding=16               ; Padding - Deactivate with -1
  Define width=480                ; Fit image to this width
  Define height=395               ; Fit image to this height
  Define background_color=$808080 ; Background color - For a invisible background set background_color=-2 (-1 is reserved for ignore)
  Define grid_color=$DCDCDC       ; Grid color
  Define grid_size=6              ; Grid size
  Define grid_tiling=0            ; Grid tiling
  Define frame_color=$606060      ; Frame color
  Define frame_size=8             ; Frame size
  Define flags=0                  ; #PB_Image_Raised - #PB_Image_Border - Frame flags
  
  width=WindowWidth(window_ID)+WindowWidth(window_ID)%2-120 : height=WindowHeight(window_ID)+WindowHeight(window_ID)%2-80 
  
  Define gadget_1_ID=ImageGadget_BF(output_ID,
                                    x,
                                    y,
                                    width,
                                    height,
                                    background_color,
                                    padding,
                                    grid_color,
                                    grid_size,
                                    grid_tiling,
                                    frame_color,
                                    frame_size,
                                    flags)
  
  Delay_BF(1, -1) ; time=-1 Initialize the timer - This set the first delay to zero for beginning a animation directly without a delay)
  
  Define init=1
  Repeat
    Delay(1)
    
    If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : If init : init=0 : Else : frame+1 : init=0 : EndIf : If frame=ImageFrameCount(gif_ID) : frame=0 : EndIf 
      
      output_ID=Sprite_CSS_sheet_grab_frame_BF(texture_ID,
                                               frames,
                                               frame,
                                               frame_width,
                                               frame_height,
                                               0,
                                               output_width,
                                               output_height,
                                               texture_clip_x,
                                               texture_clip_y,
                                               texture_clip_width,
                                               texture_clip_height)
      
      SetImageGadget_BF(gadget_1_ID,output_ID)
      
      FreeImage(output_ID)
    EndIf
    
    Repeat ; Get all window events
      win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        End
      EndIf
    Until Not win_event
    
  ForEver
  
CompilerEndIf
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 14
; FirstLine = 14
; Folding = -
; EnableXP
; DisableDebugger