﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Image output as BF sprites

EnableExplicit

Define window_ID, texture_ID, texture_1_ID, texture_2_ID, texture_3_ID, texture_4_ID, texture_5_ID, image_ID, background_ID, destination_ID
Define win_event, image_x, image_y, image_width, image_height, i, ii, iii
#SoilWall="./Image_Set/soil_wall.jpg"
#Lion="./Image_Set/Lion.jpg"
#Cat_01="./Image_Set/Cat_01.jpg"
#Logo="./Image_Set/PureBasicLogo.bmp" 

; Presets
image_width=1060 : image_height=860

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0, image_width, image_height, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

; - Call function #1 -
texture_ID=LoadImage(#PB_Any, #SoilWall)
texture_1_ID=LoadImage(#PB_Any, #Lion)
texture_2_ID=LoadImage(#PB_Any, #Cat_01)
texture_4_ID=LoadImage(#PB_Any, #Logo)

Define change_red.f=0
Define change_green.f=0
Define change_blue.f=0
Define change_contrast.f=10
Define change_brightness.f=0
Define change_intensity.f=10
Define mode_grey=1
Define mode=1
Define sprite_mode=0

; This function change the brightness, color, contrast - The function works with images, PB sprites, canvas
; The parameters are percent based - positive and negative values
; Source and destination must have the same size
; mode 0 = without creating a new output - mode 1 create a image - mode 2 create a PB sprite
; sprite_mode - Same PB function call for PB sprite creating
; Tree grey modes available mode=1, mode=2, mode=3 - mode=1 is more neutral
texture_3_ID=Image_coloring_BF(texture_2_ID, destination_ID,
                               change_red,
                               change_green,
                               change_blue,
                               change_contrast,
                               change_brightness,
                               change_intensity,
                               mode_grey,
                               mode,
                               sprite_mode)

texture_5_ID=Image_coloring_BF(texture_1_ID, destination_ID,
                               change_red,
                               change_green,
                               change_blue,
                               change_contrast,
                               change_brightness,
                               change_intensity,
                               mode_grey,
                               mode,
                               sprite_mode) ; destination_ID and sprite_mode not used here

ErrorCheck_BF(BF(-2, background_ID, texture_ID))

Define alpha=0               ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
Define texture_width=0       ; Endposition texture output       - Preset 0 = Clipping is automatic To image width 
Define texture_height=0      ; Endposition texture output       - Preset 0 = Clipping is automatic To image height 
Define texture_clip_x=0      ; Startposition inside the texture - Preset 0
Define texture_clip_y=0      ; Startposition inside the texture - Preset 0
Define texture_clip_width=0  ; Endposition inside the texture   - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture   - Preset 0 = full texture height

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing()  

Delay_BF(1, -1) ; Init Delay BF

image_ID=CreateImage(#PB_Any, ImageWidth(texture_1_ID)*2, ImageHeight(texture_1_ID)*2) ; create a large image

iii=-ImageWidth(texture_4_ID)

Repeat
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(1, 30)
    
    If Not ii
      i+1 : If i>50 : ii=1 : EndIf
    Else
      i-1 : If i<0 : ii=0 : ii=0 : EndIf
    EndIf
    
    iii+1 : If iii>image_width+ImageWidth(texture_4_ID) : iii=-ImageWidth(texture_4_ID) : EndIf
    
    CopyContent_Image_Image_BF(background_ID, image_ID)
    
    ; Function for simple using any images as sprites
    ErrorCheck_BF(SpriteSimple_BF(0, image_ID, texture_3_ID,  
                                  0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                  0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                  30,                   ; Output pos x
                                  30,                   ; Output pos y
                                  450+i,                ; You can here resize the output x
                                  350+i,                ; You can here resize the output y
                                  alpha))               ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
    
    ErrorCheck_BF(SpriteSimple_BF(0, image_ID, texture_2_ID,  
                                  0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                  0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                  530,                  ; Output pos x
                                  30,                   ; Output pos y
                                  600,                  ; You can here resize the output x
                                  450,                  ; You can here resize the output y
                                  i+30,                 ; Set alpha blending from 1 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  500,                  ; Endposition texture output       - Preset 0 = Clipping is automatic to output width 
                                  400,                  ; Endposition texture output       - Preset 0 = Clipping is automatic to output height 
                                  i,                    ; Startposition inside the texture - Preset 0
                                  i,                    ; Startposition inside the texture - Preset 0
                                  texture_clip_width,   ; Endposition inside the texture   - Preset 0 = full texture width
                                  texture_clip_height)) ; Endposition inside the texture   - Preset 0 = full texture height
                                                        ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                        ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                        ; For using pictures with alpha channel use mode=2
                                                        ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                        ; Resizing can change the colors a little,
                                                        ; so it is available a presetted invisible color works after resizing not longer correct
    
    ; Function for simple and fast using any images as sprites
    ErrorCheck_BF(SpriteSimple_fast_BF(ii, image_ID, texture_1_ID, 
                                       0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                       0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                       30,                   ; Output pos x
                                       430,                  ; Output pos y
                                       450+i,                ; You can here resize the output x
                                       350+i,                ; You can here resize the output y
                                       texture_clip_x,       ; Startposition inside the texture - Preset 0
                                       texture_clip_y,       ; Startposition inside the texture - Preset 0
                                       texture_clip_width,   ; Endposition inside the texture - Preset 0 = full texture width
                                       texture_clip_height)) ; Endposition inside the texture - Preset 0 = full texture height
                                                             ; mode 0 = Without invisible color
                                                             ; mode 1 > 256 = With invisible color and with alpha blending
                                                             ; mode -1 > -256 = Without invisible color and with alpha blending
                                                             ; This is a special function for very fast sprite or GIF output- mode 0 is the fastest mode - Image output is a little faster as canvas output
                                                             ; The function is not based on the GFX_Wizzard_BF core function, can so not output multiple pattern and works not with the BF sprite array
                                                             ; On PB sprites invisible color and alpha blending is ignored
    
    ErrorCheck_BF(SpriteSimple_fast_BF(-alpha, image_ID, texture_5_ID,
                                       0,     ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                       0,     ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                       480+i, ; Output position x
                                       380+i, ; Output position y
                                       500,   ; Resizing - Define the output width - Preset zero = without resizing 
                                       400))  ; Resizing - Define the output height
    
    
    ErrorCheck_BF(SpriteSimple_fast_BF(-alpha, image_ID, texture_4_ID,
                                       0,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                       0,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                       iii,  ; Output position x
                                       380)) ; Output position y
    
    
    SetColorDistanceSpriteMask_BF(25)
    ErrorCheck_BF(SpriteSimple_fast_BF(1, image_ID, texture_4_ID,
                                       0,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                       0,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                       iii,  ; Output position x
                                       710)) ; Output position y
    SetColorDistanceSpriteMask_BF(10)
    
    SetColorDistanceSpriteMask_BF(25)
    ErrorCheck_BF(SpriteSimple_fast_BF(1, image_ID, texture_4_ID,
                                       -1,      ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                       $FFFFFF, ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                       iii+80,  ; Output position x
                                       830,     ; Resizing - Define the output width - Preset zero = without resizing 
                                       200,     ; Resizing - Define the output height
                                       28))     ; Output position y
    
    StartDrawing(ImageOutput(image_ID))
    DrawingMode(#PB_2DDrawing_Transparent)
    DrawText_BF(50, 40, "Brightened picture"+#LF$+#LF$+"With increased contrast"+#LF$+#LF$+"Converted to grey")
    DrawText_BF(550, 40, "GFX WIZZARD BF "+#LF$+"Simple a little more"+#LF$+#LF$+"Multiple animated output"+#LF$+#LF$+"Directly on canvas")
    StopDrawing()
    
    CopyContent_Image_Canvas_BF(image_ID, canvas_ID)
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 2
; EnableXP
; DisableDebugger