﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Image output as BF sprites - simple

EnableExplicit

Define win_event, window_ID, texture_0_ID, texture_1_ID, texture_2_ID, texture_3_ID, texture_4_ID, texture_5_ID, image_ID, background_ID, destination_ID
Define image_width, image_height, change_red.f, change_green.f, change_blue.f, change_contrast.f, change_brightness.f, change_intensity.f, grey_mode

; Presets
image_width=1060 : image_height=860

window_ID=OpenWindow(#PB_Any, 0, 0, image_width, image_height, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, image_width, image_height) ; Create a canvas for output the result all over

; - Call function #1 -
texture_0_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")
texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Lion.jpg")
texture_2_ID=LoadPhoto_BF("./Image_Set/Cat_01.jpg") ; LoadPhoto_BF can handle EXIF data and automatically image rotation
texture_3_ID=LoadPhoto_BF("./Image_Set/Hubble.jpg")
texture_4_ID=LoadImage(#PB_Any, "./Image_Set/Rose.jpg")
texture_5_ID=LoadImage(#PB_Any, "./Image_Set/PureBasicLogo.bmp")

NoCaching_BF(1) ; BF Texture caching not needed, i deactivate it

background_ID=CreateImage(#PB_Any, image_width, image_height) ; Create a large image for the background
ErrorCheck_BF(BF(-2, background_ID, texture_0_ID))            ; Create a tiled background

image_ID=CreateImage(#PB_Any, ImageWidth(texture_1_ID)*2, ImageHeight(texture_1_ID)*2) ; create a large image for the final output

; Change the colors, contrast and brightness from the textures before output to the large image - How ever you want
change_red.f=0
change_green.f=0
change_blue.f=0
change_contrast.f=0
change_brightness.f=0
change_intensity.f=0
grey_mode=0
ErrorCheck_BF(Image_coloring_BF(texture_1_ID, texture_1_ID, ; Recoloring texture 1
                                change_red,
                                change_green,
                                change_blue,
                                change_contrast,
                                change_brightness,
                                change_intensity,
                                grey_mode))

change_red.f=0
change_green.f=0
change_blue.f=0
change_contrast.f=0
change_brightness.f=0
change_intensity.f=0
grey_mode=0
ErrorCheck_BF(Image_coloring_BF(texture_2_ID, texture_2_ID, ; Recoloring texture 2
                                change_red,
                                change_green,
                                change_blue,
                                change_contrast,
                                change_brightness,
                                change_intensity,
                                grey_mode))

change_red.f=0
change_green.f=0
change_blue.f=0
change_contrast.f=0
change_brightness.f=0
change_intensity.f=0
grey_mode=0
ErrorCheck_BF(Image_coloring_BF(texture_3_ID, texture_3_ID, ; Recoloring texture 3
                                change_red,
                                change_green,
                                change_blue,
                                change_contrast,
                                change_brightness,
                                change_intensity,
                                grey_mode))

change_red.f=0
change_green.f=0
change_blue.f=0
change_contrast.f=0
change_brightness.f=0
change_intensity.f=0
grey_mode=0
ErrorCheck_BF(Image_coloring_BF(texture_4_ID, texture_4_ID, ; Recoloring texture 4
                                change_red,
                                change_green,
                                change_blue,
                                change_contrast,
                                change_brightness,
                                change_intensity,
                                grey_mode))

CopyContent_Image_Image_BF(background_ID, image_ID) ; Copy the created tiled background to the large output image

; Draw now the textures in the large image
ErrorCheck_BF(SpriteSimple_fast_BF(-1, image_ID, texture_1_ID,  
                                   0,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   30,   ; Output pos x
                                   30,   ; Output pos y
                                   500,  ; You can here resize the output x
                                   400)) ; You can here resize the output y

ErrorCheck_BF(SpriteSimple_fast_BF(-1, image_ID, texture_2_ID,  
                                   0,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   530,  ; Output pos x
                                   30,   ; Output pos y
                                   500,  ; You can here resize the output x
                                   400)) ; You can here resize the output y


ErrorCheck_BF(SpriteSimple_fast_BF(-1, image_ID, texture_3_ID, 
                                   0,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   30,   ; Output pos x
                                   430,  ; Output pos y
                                   500,  ; You can here resize the output x
                                   400)) ; You can here resize the output y

ErrorCheck_BF(SpriteSimple_fast_BF(-1, image_ID, texture_4_ID,
                                   0,    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                   530,  ; Output position x
                                   430,  ; Output position y
                                   500,  ; Resizing - Define the output width - Preset zero = without resizing 
                                   400)) ; Resizing - Define the output height

; Add a Logo
ErrorCheck_BF(SpriteSimple_fast_BF(-1, image_ID, texture_5_ID,
                                   0,  ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,  ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                   10, ; Output position x
                                   10, ; Output position y
                                   0,  ; Resizing - Define the output width - Preset zero = without resizing 
                                   0)) ; Resizing - Define the output height

; Add at least a text to the large image
StartDrawing(ImageOutput(image_ID))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(550, 40, "GFX WIZZARD BF"+#LF$+"Simple a little more"+#LF$+#LF$+"Multiple animated output"+#LF$+#LF$+"Directly on canvas")
StopDrawing()

CopyContent_Image_Canvas_BF(image_ID, canvas_ID) ; Copy the finaly created large image to the canvas for output

Repeat ; Waiting for Godot :-)
  win_event=WindowEvent()
  If win_event=#PB_Event_CloseWindow
    End
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 2
; EnableXP
; DisableDebugger