﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  ; === MessageRequester_AutoSize_BF === 
  ; Same the PB function, but very enhanced with auto resizing text and buttons - Without OS Icon output
  ; But you can include any images or you can use also without
  ; Can handle all images, also GIF, resize and placing, with animated output and alpha blending
  ; Can handle LinearGradient for text
  ; Set simple a max requester width and height, the requester automatically adapts to any text
  
  EnableExplicit
  
  ; The Requester works with or without activated PB Compileroption DPI aware automatically
  ; - you must do nothing here
  Activate_DPI_aware_BF(1)
  
  ; The subsystem Linux gtk3 can expand MessageRequester_BF slightly in size
  ; So you can preset a negative offset to adjust the buttons
  ; Don't select these offsets too big, the button text will get smaller and smaller
  ; Different gtk3 versions can affect button sizes differently
  ; Especially all smaller buttons are automatically enlarged, which can make precise adjustment much more difficult
  ; This is not a failure of GFX_Wizzard_BF, but a "feature" of gtk3 :-(
  ; The wizard currently automatically activates gtk3 offsets, which you can also change so :
  CompilerIf #PB_Compiler_OS=#PB_OS_Linux
    CompilerIf Not Subsystem("gtk2") And Not Subsystem("qt")
      gtk3_button_x_offset_BF(13) ; Presetted x=13
      gtk3_button_y_offset_BF(6)  ; Presetted y=6
    CompilerEndIf
  CompilerEndIf
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  Define title_line$="Message Requester"
  Define text$="Cool full automatic Message requester GFX_Wizzard_BF"+#LF$+#LF$+
               "Simple a little more"+#LF$+
               "With auto text and buttons"+#LF$+#LF$+
               "Animated GIF supported"+#LF$+
               "Multicolor"

  ; Create a font array
  ; Mostly 30pt > 40pt is enough - smaller is faster
  Define max_needed_font_size=72
  Define needed_font_size
  Global Dim Font_Arial(max_needed_font_size)
  For needed_font_size=1 To max_needed_font_size ; Get the fonts
    Font_Arial(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
  Next needed_font_size
  
  ; Set simple a max requester width and height
  ; But, the requester adjusts its size itself according to a given text and requester_width, requester_height
  ; You can also influence the button text size with resize_factor_button_text - This change the button size automatically
  Define requester_width=600
  Define requester_height=250
  
  Define flags.a=#PB_MessageRequester_YesNoCancel
  Define text_button_yes$="Monoline"
  Define text_button_no$="Or"+#LF$+"  Multiline  "
  Define text_button_cancel$="Fitted Text"
  Define text_color=#Red
  Define text_background_color=$FFFF
  Define background_color=$FF
  Define button_text_color=#Yellow
  Define button_background_color=$808080
  Define resize_factor_button_text.f=1.0
  
  ; = Demo with Alpha Channel Image =======================
  
  Define image_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")
  
  ; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
  GradientColor_Array_BF(1, 1, 0.2, $FFFF)
  GradientColor_Array_BF(1, 2, 0.5, $FF)
  GradientColor_Array_BF(1, 3, 0.8, $FFFF00)
  CircularGradient_BF(1, 320*DPI_ResizeFactor_BF(), 550*DPI_ResizeFactor_BF(), 800*DPI_ResizeFactor_BF())
  
  ; Hint : The function DrawTextCreateImage_BF can give back the used text width and length for optimized image and LinearGradient positioning
  
  Define image_x_pos=235
  Define image_y_pos=5
  Define image_output_width=400  ; 0 = without resizing
  Define image_output_height=600 ; 0 = without resizing
  
  Define alpha=70 ; Alpha blending - 0 deactivate the invisible color
  
  ResizeInterpolation_BF(1) ; Interpolation is presetted enabled to increase quality - but not good for shrinking GIF with invisible color
  
  ; SetMessageRequester_BF : ( You can adjust with or without a parent window )
  ; mode 0 = Deactivate the function
  ; mode 1 = Save and restore the GadgetList
  ; mode 2 - Save and restore the GadgetList and create a centered output on the parent window
  ; mode 3 - Save and restore the GadgetList and create a x_pos, y_ pos adjusted output
  ; SetMessageRequester_BF(window_ID, mode, x_pos, y_pos)
  ; A window ID is not needed , you can set to -1 for ignore
  ; Set you x_pos or y_pos too -1, this position is automatically centered
  ; Set you on mode 2 or mode 3 x_pos or y_pos too -1, this position is automatically centered
  SetMessageRequester_BF(-1, 0, -1, -1)
  
  MessageRequester_BF(Font_Arial(),
                      requester_width,
                      requester_height,
                      title_line$,
                      text$,
                      flags.a,
                      text_button_yes$,
                      text_button_no$,
                      text_button_cancel$,
                      text_color,
                      text_background_color,
                      background_color,
                      button_text_color,
                      button_background_color,
                      resize_factor_button_text.f,
                      image_ID,
                      image_x_pos,
                      image_y_pos,
                      image_output_width,
                      image_output_height,
                      alpha)
  
  ; = Demo with image =======================
  Define image_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")
  
  Define background_color=$8CB4D2
  
  Define image_x_pos=-365
  Define image_y_pos=-80
  Define image_output_width=0  ; 0 = without resizing
  Define image_output_height=0 ; 0 = without resizing
  
  Define alpha=0 ; Alpha blending - 0 deactivate the invisible color
  
  Define button_text_color=$FFFFFF
  Define button_background_color=$20A5DA
  
  MessageRequester_BF(Font_Arial(),
                      requester_width,
                      requester_height,
                      title_line$,
                      text$,
                      flags.a,
                      text_button_yes$,
                      text_button_no$,
                      text_button_cancel$,
                      text_color,
                      text_background_color,
                      background_color,
                      button_text_color,
                      button_background_color,
                      resize_factor_button_text.f,
                      image_ID,
                      image_x_pos,
                      image_y_pos,
                      image_output_width,
                      image_output_height,
                      alpha)
  
  GradientColor_Array_BF(1, 1, 0.2, $FFFF)
  GradientColor_Array_BF(1, 2, 0.5, $FF)
  GradientColor_Array_BF(1, 3, 0.8, $FF00FF)
  CircularGradient_BF(1, 320*DPI_ResizeFactor_BF(), 450*DPI_ResizeFactor_BF(), 700*DPI_ResizeFactor_BF())
  
  ; = Demo with animated big GIF =======================
  Define image_ID=LoadImage(#PB_Any, "./Image_Set/bird.gif")
  
  Define background_color=$32CD9A
  Define flags.a=#PB_MessageRequester_YesNo
  
  Define image_x_pos=0
  Define image_y_pos=-80
  Define image_output_width=680  ; 0 = without resizing
  Define image_output_height=500 ; 0 = without resizing
  
  Define alpha=0 ; Alpha blending - 0 deactivate the invisible color             
  
  Define button_text_color=$FFFF
  Define button_background_color=$FF
  
  MessageRequester_BF(Font_Arial(),
                      requester_width,
                      requester_height,
                      title_line$,
                      text$,
                      flags.a,
                      text_button_yes$,
                      text_button_no$,
                      text_button_cancel$,
                      text_color,
                      text_background_color,
                      background_color,
                      button_text_color,
                      button_background_color,
                      resize_factor_button_text.f,
                      image_ID,
                      image_x_pos,
                      image_y_pos,
                      image_output_width,
                      image_output_height,
                      alpha)
  
  ; = Demo with animated GIF and invisible color =======================
  Define image_ID=LoadImage(#PB_Any, "./Image_Set/Dog_1.gif")
  
  ResizeInterpolation_BF(0) ; Interpolation is presetted enabled to increase quality - but not good for shrinking GIF with invisible color
  
  ; Hint : The function DrawTextCreateImage_BF can give back the used text width and length for optimized image and LinearGradient positioning
  
  GradientColor_Array_BF(1, 1, 0.2, $FFFF)
  GradientColor_Array_BF(1, 2, 0.5, $FF)
  GradientColor_Array_BF(1, 3, 0.8, $FFFF00)
  CircularGradient_BF(1, 320*DPI_ResizeFactor_BF(), 550*DPI_ResizeFactor_BF(), 800*DPI_ResizeFactor_BF())
  
  Define background_color=$FFFF
  
  Define image_x_pos=10
  Define image_y_pos=30
  Define image_output_width=0  ; 0 = without resizing
  Define image_output_height=0 ; 0 = without resizing
  
  Define alpha=1 ; Alpha blending - 0 deactivate the invisible color
  
  Define button_text_color=$FFFF
  Define button_background_color=$FF0000
  
  MessageRequester_BF(Font_Arial(),
                      requester_width,
                      requester_height,
                      title_line$,
                      text$,
                      flags.a,
                      text_button_yes$,
                      text_button_no$,
                      text_button_cancel$,
                      text_color,
                      text_background_color,
                      background_color,
                      button_text_color,
                      button_background_color,
                      resize_factor_button_text.f,
                      image_ID,
                      image_x_pos,
                      image_y_pos,
                      image_output_width,
                      image_output_height,
                      alpha)
  
  ; = Demo without Image ================================================
  
  Define button_text_color=0
  Define button_background_color=$FFFFFF
  Define flags.a=#PB_MessageRequester_Yes
  
  CircularGradient_BF(1, 320*DPI_ResizeFactor_BF(), 500*DPI_ResizeFactor_BF(), 800*DPI_ResizeFactor_BF())
  MessageRequester_BF(Font_Arial(),
                      requester_width,
                      requester_height,
                      title_line$,
                      text$,
                      flags.a,
                      text_button_yes$,
                      text_button_no$,
                      text_button_cancel$,
                      text_color,
                      text_background_color,
                      background_color,
                      button_text_color,
                      button_background_color,
                      resize_factor_button_text.f)
  
  DeactivateGradientColors_BF()
  If IsImage(image_ID) : FreeImage(image_ID) : EndIf
  
  ; = Simple OS requester replacing ===================================
  SetMessageRequester_BF(-1, 3, -1, 200)
  MessageRequester_BF(Font_Arial(), 560, 200, title_line$, text$, #PB_MessageRequester_Yes)
  
CompilerEndIf
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; Folding = -
; EnableXP
; DPIAware
; Executable = test.exe
; DisableDebugger