﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Deflickering and animation demo for output multiple moved sprites - simple - Directly screen output

; Hint : This is faster as the RAW version

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

EnableExplicit

Define window_0, image_ID, window_ID, texture_ID, texture_1_ID, texture_2_ID, temporary_image_0_ID, temporary_image_1_ID
Define image_x, image_y, image_width, image_height, point, arc, result
Define path$

#GeeBee="./Image_Set/Geebee2.bmp"
#SoilWall="./Image_Set/soil_wall.jpg"
#Testtexture="./Image_Set/testtexture_large.png"
#Penguin="./Image_Set/Penguin.png"

; Presets
image_x=50
image_y=50
image_width=600
image_height=400

window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, image_width+100, image_height+100, "GFX_Wizzard_BF - For screen",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

image_ID=CreateImage(#PB_Any, image_width, image_height)

OpenWindowedScreen(WindowID(window_ID), image_x, image_y, image_width, image_height)

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, image_ID, texture_ID) ; Make a background texture
ErrorCheck_BF(result)

; - Sprite animation #1 -
Define i, x, y, x1, y1, x2, y2, xx, image_width

path$=#Geebee ; Get a sprite
texture_ID=LoadImage(#PB_Any, path$)

path$=#Testtexture ; Get a sprite
texture_1_ID=LoadImage(#PB_Any, path$)

path$=#Penguin; Get a sprite
texture_2_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_2_ID, 100, 100)

ResizeImage(texture_ID, 90, 80) ; Resize the sprite

Create_animation_buffers_BF(image_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation                                                                                                                                                                            

SetColorDistanceSpriteMask_BF(25) ; Remove artifacts from the sprite mask

Repeat
  
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  
  If Delay_BF(0, 10) ; Timer 0, Time 10 ms - 100 timer available 0 - 99 - you can change
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    x+1 : y-1
    If x>ImageWidth(image_ID)+100
      x=-(ImageWidth(texture_ID)+100)
    EndIf
    If y<-(ImageHeight(texture_ID)+20)
      y=ImageHeight(image_ID)+20
    EndIf
    
    x1+2 : y1-1
    If x1>ImageWidth(image_ID)+100
      x1=-(ImageWidth(texture_ID)+100)
    EndIf
    If y1<-(ImageHeight(texture_ID)+20)
      y1=ImageHeight(image_ID)+20
    EndIf
    
    x2+1 : y2-2
    If x2>ImageWidth(image_ID)+100
      x2=-(ImageWidth(texture_ID)+100)
    EndIf
    If y2<-(ImageHeight(texture_ID)+20)
      y2=ImageHeight(image_ID)+20
    EndIf
    
    xx-2 : If xx<-100 : xx=-2 : EndIf
    
    arc+1
    If arc>360 : arc=-arc : EndIf
    
    SetColorDistanceSpriteMask_BF(30) ; Remove artifacts from the sprite mask
    
    ; - Call function - output sprite #1 -
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, ; Sprite mode
              0,                                   
              0,                                 
              x,                           
              y,                             
              ImageWidth(texture_ID),                           
              ImageHeight(texture_ID))
    ErrorCheck_BF(result)
    
    ; Graphic output #1
    If StartVectorDrawing(ImageVectorOutput(Get_animation_buffer_hidden_image_ID_BF(0)))
      VectorSourceColor($FFFF0001)
      MovePathCursor (250 , 150)
      AddPathCircle (250 , 150 , 80, 0, arc , #PB_Path_Connected)
      FillPath()
      StopVectorDrawing()
    EndIf
    StopDrawing()
    
    ; - Call function - output sprite #2 -
    result=BF(80, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, ; Sprite mode
              0,                                   
              0,                                 
              x1-100,                           
              y1-20,                             
              ImageWidth(texture_ID),                           
              ImageHeight(texture_ID))
    ErrorCheck_BF(result)
    
    ; Call function - output sprite #3 -
    result=BF(40, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, ; Sprite mode
              0,                                   
              0,                                 
              x2+100,                           
              y2+20,                             
              ImageWidth(texture_ID),                           
              ImageHeight(texture_ID))
    ErrorCheck_BF(result)
    
    ; Call function - output sprite #4 -
    result=BF(40, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, ; Sprite mode
              0,                                   
              0,                                 
              x2+100,                           
              y2+20,                             
              ImageWidth(texture_ID),                           
              ImageHeight(texture_ID))
    ErrorCheck_BF(result)
    
    ; Call function - alphachannel sprite output #1 -
    result=AlphaChannelSprite_BF(Get_animation_buffer_hidden_image_ID_BF(0), texture_2_ID, ; Sprite mode
                                 xx,                                   
                                 200,
                                 ImageWidth(texture_2_ID)*7,
                                 ImageHeight(texture_2_ID))                                 
    ErrorCheck_BF(result)
    
    ; Call function - output sprite #5 -
    result=SpriteSimple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, ; Sprite simple
                           0,
                           0,
                           x,                           
                           100,                             
                           ImageWidth(texture_ID)/2,                           
                           ImageHeight(texture_ID)/2)
    ErrorCheck_BF(result)
    
    ; Call function - output sprite #6 -
    result=SpriteSimple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, ; Sprite simple
                           0,
                           0,
                           250,                           
                           y,                             
                           ImageWidth(texture_ID)*1.3,                           
                           ImageHeight(texture_ID)*1.3)
    ErrorCheck_BF(result)
    
    ; Graphic output #2
    If StartVectorDrawing(ImageVectorOutput(Get_animation_buffer_hidden_image_ID_BF(0)))
      VectorSourceColor($AAFFFF01)
      MovePathCursor (400 , 200)
      AddPathCircle (400 , 200 , 100, 0, arc , #PB_Path_Connected)
      FillPath()
      StopVectorDrawing()
    EndIf
    StopDrawing()
    
    SetColorDistanceSpriteMask_BF(5) ; Remove artifacts from the sprite mask
    
    ; - Call function - output sprite #7 -
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_1_ID, ; Sprite mode
              5,                                   
              5,                                 
              235,                           
              60,                             
              ImageWidth(texture_1_ID),                           
              ImageHeight(texture_1_ID))
    ErrorCheck_BF(result)
    
    ; Get the result - Its very simple output complexe BF results to a screen
    CopyContent_Image_Screen_BF(Get_animation_buffer_hidden_image_ID_BF(0), i)
    CopyContent_Image_Screen_BF(Get_animation_buffer_hidden_image_ID_BF(0), i-image_width)
    
    ; ActivateScreenOutput_BF(1) ; Also you can use this universal automatic output function - ActivateScreenOutput_BF is needed
    ; CopyContent_BF(Get_animation_buffer_hidden_image_ID_BF(0), 0, i-image_width)
    ; ActivateScreenOutput_BF(0)
    
    i=(i+1)%image_width
    
    FlipBuffers() ; Draw PB sprite
    ClearScreen(RGB(0, 0, 0))
    
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; DisableDebugger