﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Progressbar_BF - DPI aware

; Look in the Wizzard declare part or on Progressbar_BF demo code 1 or 2 for parameter descriptions

EnableExplicit

Define clouds_ID=LoadImage(#PB_Any, "./Image_Set/Clouds.jpg")
Define rusty_steel_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define background_ID=LoadImage(#PB_Any, "./Image_Set/Background.bmp")
Define Dirt_ID=LoadImage(#PB_Any, "./Image_Set/Dirt.jpg")

ResizeImage(clouds_ID, ImageWidth(clouds_ID)*DPI_ResizeFactor_BF(), ImageHeight(clouds_ID)*DPI_ResizeFactor_BF())
ResizeImage(rusty_steel_ID, ImageWidth(rusty_steel_ID)*DPI_ResizeFactor_BF(), ImageHeight(rusty_steel_ID)*DPI_ResizeFactor_BF())
ResizeImage(background_ID, ImageWidth(background_ID)*DPI_ResizeFactor_BF(), ImageHeight(background_ID)*DPI_ResizeFactor_BF())
ResizeImage(Dirt_ID, ImageWidth(Dirt_ID)*DPI_ResizeFactor_BF()/2, ImageHeight(Dirt_ID)*DPI_ResizeFactor_BF()/2)

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

; -----------------------------------

OpenWindow(0, #PB_Ignore, #PB_Ignore, 485, 465,
           "Progressbar_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define background_canvas_ID=CanvasGadget(#PB_Any, 10, 10, 465, 445, #PB_Canvas_Container)
SetWindowColor(0, $20A5DA)

Define i, ii.f, iii.f, output_y_1.f, iiii, degree, output_ID, result, output_x_0, output_y_0, font_1_ID, win_event
Define border_0=8

CompilerIf #PB_Compiler_OS=#PB_OS_Windows : font_1_ID=LoadFont(#PB_Any, "Arial", 11) : CompilerEndIf ; Select a suitable font for each OS
CompilerIf #PB_Compiler_OS=#PB_OS_Linux   : font_1_ID=LoadFont(#PB_Any, "Arial", 11) : CompilerEndIf
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS   : font_1_ID=LoadFont(#PB_Any, "Arial", 14) : CompilerEndIf

Define Bar_1=ProgressBarGadget(#PB_Any, 200, 80, 50, 280, 0, 300, #PB_ProgressBar_Vertical)  ; OS Progressbars with custom output 
Define Bar_2=ProgressBarGadget(#PB_Any, 100, 100, 50, 250, 0, 300, #PB_ProgressBar_Vertical) ; The vertical flag, you can, but you must not set
Define Bar_3=ProgressBarGadget(#PB_Any, 320, 100, 50, 250, 0, 300, #PB_ProgressBar_Vertical) ; The SetGadgetState_EX call set the vertical flag, more is not needed
Define Bar_4=ProgressBarGadget(#PB_Any, 48, 400, 370, 20, 0, 300)

Define progressbar_1_ID=CanvasGadget(#PB_Any,
                                     GadgetX(Bar_1),
                                     GadgetY(Bar_1),
                                     GadgetWidth(Bar_1)+border_0*2-1,
                                     GadgetHeight(Bar_1)+border_0*2-1)

Create_animation_buffers_BF(progressbar_1_ID, 0) ; Init animation buffers - triple buffering - Flicker free animation
Create_animation_buffers_BF(background_canvas_ID, 1) ; Init animation buffers - triple buffering - Flicker free animation

iiii=-300
Repeat 
  
  If Delay_BF(0, 30) ; Timer 0 - 100 timer available 0 - 99 - you can change
    i+1 : ii.f+0.5 : iii.f+0.83 : iiii+1 : If i=300 : i=0 : ii=0 : iii=0 : EndIf : If iiii=0 : iiii=-300 : EndIf
    
    FlipBuffers_BF(1)
    ; Look, the animation buffers 0 i use here only for simplest composing a sprite content, this is very easy
    ; After sprite composing i copy the composed sprite content in the hidden buffer 1
    
    ; This demo demonstrate sprite output directly on canvas and sprite output on a additional canvas 
    ; - Call function #1 -
    SetReplacingColor_BF($FFFFFF)
    result=BF(-50, Get_animation_buffer_hidden_image_ID_BF(1), Dirt_ID, 0, 0, -i*DPI_ResizeFactor_BF(), iiii*DPI_ResizeFactor_BF()) ; Full size output, not more settings needed
    ErrorCheck_BF(result)
    HideWindow(0, 0)
    SetFrontText_0_Progressbar_BF(RSet(Str(i/3+1), 3, "  ")+"%", 7, 255, 0, $FFFF, 50, font_1_ID) ; Add text
    output_ID=SetGadgetState_Progressbar_BF(Bar_1, i, #PB_ProgressBar_Vertical, -1, $FF, $FFBF00, -2, border_0) ; Replace the OS progressbar #1
    
    StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(0))) ; Draw in the foreground (hidden) animation buffer
    DrawImage(ImageID(output_ID), 0, 0)
    StopDrawing()
    
    output_x_0-1 : If output_x_0<-ImageWidth(background_ID)*DPI_ResizeFactor_BF() : output_x_0=0 : EndIf
    output_y_0-3 : If output_y_0<-ImageHeight(background_ID)*DPI_ResizeFactor_BF() : output_y_0=0 : EndIf
    output_y_1-1*DPI_ResizeFactor_BF()-i/(200*DPI_ResizeFactor_BF()) : If output_y_1*DPI_ResizeFactor_BF()<-ImageHeight(rusty_steel_ID) : output_y_1=0 : EndIf
    
    degree+1 : If degree>359 : degree=0 : EndIf
    
    SetGadgetState_Progressbar_BF(Bar_2, i, #PB_ProgressBar_Vertical, 3, $FF00, $E6E6E6, $FF) ; Replace the OS progressbar #2
    
    SetGadgetState_Progressbar_BF(Bar_3, i, #PB_ProgressBar_Vertical, 2, $FFFF00, $00D7FF, $FF0000, 3) ; Replace the OS progressbar #3
    
    SetGadgetState_Progressbar_BF(Bar_4, i, #PB_ProgressBar_Horizontal, 1, $FF00, $E6E6E6, $578B2E, 4, $AAAAAA) ; Replace the OS progressbar #4
    
    ; - Call function #2 -
    SetReplacingColor_BF($FFBF00) ; This function call replace a defined color inside the sprite with a new content
    result=BF(-250+iii, Get_animation_buffer_hidden_image_ID_BF(0), clouds_ID, 0, 0, 0, output_y_0*DPI_ResizeFactor_BF()) ; Full size output, not more settings needed
    ErrorCheck_BF(result)
    
    SetColorDistanceSpriteMask_BF(30-i/10) ; You can change
    
    ; - Call function #3 -
    SetReplacingColor_BF($FF) ; This function call replace a defined color inside the sprite with a new content
    result=BF(-2-ii, Get_animation_buffer_hidden_image_ID_BF(0), rusty_steel_ID, 0, 0, 0, output_y_1*DPI_ResizeFactor_BF()) ; Full size output, not more settings needed
    ErrorCheck_BF(result)
    
    SetColorDistanceSpriteMask_BF(0) ; You can change
    
    ; - Call function #4 -
    SetReplacingColor_BF($AAAAAA) ; This function call replace a defined color inside the sprite with a new content
    result=BF(-2, Get_animation_buffer_hidden_image_ID_BF(0), background_ID, 0, 0, output_x_0*DPI_ResizeFactor_BF(), output_x_0*DPI_ResizeFactor_BF()) ; Full size output, not more settings needed
    ErrorCheck_BF(result)
    
    ; - Call function #5 - Sprite Output
    ; This function move the resized and alpha blended sprite in the hidden buffer 0 - Now the sprite is ready for output
    ; Function for simple using any images as sprites 
    SpriteSimple_BF(0, Get_animation_buffer_hidden_image_ID_BF(1), Get_animation_buffer_hidden_image_ID_BF(0), 
                    0,                         ; Grab transparence color from sprite pos x                           
                    0,                         ; Grab transparence color from sprite pos y      
                    410*DPI_ResizeFactor_BF(), ; Output pos x
                    95*DPI_ResizeFactor_BF(),  ; Output pos y
                    25*DPI_ResizeFactor_BF(),  ; You can here resize the output x
                    100*DPI_ResizeFactor_BF(), ; You can here resize the output y
                    250-iii,                   ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                    0,                         ; Endposition texture output       - Preset 0 = Clipping is automatic to output width
                    0,                         ; Endposition texture output       - Preset 0 = Clipping is automatic to output height
                    0,                         ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                    0,                         ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                    0,                         ; Endposition inside the texture   - Preset 0 = full texture width
                    0)                         ; Endposition inside the texture   - Preset 0 = full texture height
                                               ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                               ; For using pictures with alpha channel use mode=2
                                               ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                               ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                               ; Resizing can change the colors a little,
                                               ; so it is available a presetted invisible color works after resizing not longer correct
    
    ; - Call function #6 - Sprite Output
    ; This function move the resized and alpha blended sprite in the hidden buffer 0 - Now the sprite is ready for output
    SpriteSimple_BF(0, Get_animation_buffer_hidden_image_ID_BF(1), Get_animation_buffer_hidden_image_ID_BF(0), 
                    0,                          
                    0,    
                    413*DPI_ResizeFactor_BF(),
                    230*DPI_ResizeFactor_BF(),
                    20*DPI_ResizeFactor_BF(),
                    70*DPI_ResizeFactor_BF())
    
    ; - Call function #7 - Sprite rotate
    ; This function move the rotated, resized and alpha blended sprite in the hidden buffer 0 - Now the sprite is ready for output
    result=RotateSprite_Simple_BF(3, Get_animation_buffer_hidden_image_ID_BF(1), Get_animation_buffer_hidden_image_ID_BF(0),                      
                                  -1,                        ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                      
                                  $AAAAAA,                   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                  23,                        ; Adjust rotation
                                  15,                        ; Adjust rotation
                                  degree,                    ; Rotating degree
                                  1,                         ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  45*DPI_ResizeFactor_BF(),  ; You can here resize the output x
                                  250*DPI_ResizeFactor_BF(), ; You can here resize the output y
                                  0,                         ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
                                  0)                         ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50   
                                                             ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets - Do not make offsets too big - Bigger = slower
                                                             ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                                             ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                                             ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                                             ; So you can also simple create masked rotated sprites from all images without mask
                                                             ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                                             ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                                             ; Reduce for Images SetColorDistanceSpriteMask_BF or you can become "holes", but also nice effects
    
    ; Output on a canvas
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(1), background_canvas_ID) ; Put the hidden animation buffer in the canvas
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), progressbar_1_ID)     ; Put the hidden animation buffer in the canvas
  EndIf 
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      Free_animation_buffers_BF(1) ; Free animation buffers
      FreeTextures_BF()            ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 65
; FirstLine = 61
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger