﻿; ==== Progressbar_Simple_BF ====
DeclareModule Progressbar_Simple_BF
  Declare Progressbar_Simple_BF(progressbar_ID, flags, foreground_color=$32CD32, background_color=$DDDDDD)
EndDeclareModule

Module Progressbar_Simple_BF
  ; This is a module for replacing a OS progressbar with a multi color progressbar
  ; Author : Werner Albus
  
  ; Add simple the Progressbar_Simple_BF call after any progressbar SetGadgetState calls
  ; SetGadgetState(progressbar_ID, 100*writen/file_size) ; OS progress bar
  ; Progressbar_Simple_BF(progressbar_ID, flags, $32CD32, $FFFF) ; Progressbar_Simple_BF
  
  ; This module can handle one progressbar in a event loop
  ; For handling different progressbars at the same loop, create other modules
  ; As sample, Progressbar_Simple_BF_1, Progressbar_Simple_BF_2, for each different progressbar one
  
  Procedure Progressbar_Simple_BF(progressbar_ID, flags, foreground_color=$32CD32, background_color=$DDDDDD)
    ; Available flags : #PB_ProgressBar_Vertical
    ; -1 remove the Progressbar_Simple_BF
    Static image_ID, image_gadget_ID
    If flags=-1
      If IsImage(image_ID) : FreeImage(image_ID) : image_ID=0 : EndIf
      If IsGadget(image_gadget_ID) : FreeGadget(image_gadget_ID) : image_gadget_ID=0 : EndIf
      DisableGadget(progressbar_ID, 0)
      HideGadget(progressbar_ID, 0)
      ProcedureReturn 0
    EndIf 
    Protected state=GetGadgetState(progressbar_ID)
    Protected width.f=GadgetWidth(progressbar_ID)*DesktopResolutionX()
    Protected height.f=GadgetHeight(progressbar_ID)*DesktopResolutionY()
    Protected min=GetGadgetAttribute(progressbar_ID, #PB_ProgressBar_Minimum)
    Protected max=GetGadgetAttribute(progressbar_ID, #PB_ProgressBar_Maximum)
    If min<1 : min=1 : EndIf : If max<1 : max=1 : EndIf
    DisableGadget(progressbar_ID, 1)
    HideGadget(progressbar_ID, 1)
    If Not image_ID : image_ID=CreateImage(#PB_Any, width, height, 24, background_color) : EndIf
    StartDrawing(ImageOutput(image_ID))
    Box(0, 0, width, height, background_color)
    If flags=#PB_ProgressBar_Vertical
      Box(1, height-(state-min)*(height/(max-min)), width-1, height, foreground_color)
    Else
      Box(0, 1, (state-min)*(width/(max-min)), height-1, foreground_color)
    EndIf
    DrawingMode(#PB_2DDrawing_Outlined)
    Box(0, 0, width, height, $BBBBBB)
    StopDrawing()
    If Not image_gadget_ID
      image_gadget_ID=ImageGadget(#PB_Any, GadgetX(progressbar_ID), GadgetY(progressbar_ID), width, height, ImageID(image_ID))
    EndIf
    SetGadgetState(image_gadget_ID, ImageID(image_ID))
    ProcedureReturn image_gadget_ID
  EndProcedure
EndModule
UseModule Progressbar_Simple_BF

Define window_ID=OpenWindow(#PB_Any, 0, 0, 310, 40, "Progressbar_Simple_BF", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
Define progressbar_ID=ProgressBarGadget(#PB_Any, 5, 5,
                                        WindowWidth(window_ID)-10,
                                        WindowHeight(window_ID)-10, 0, 100, #PB_ProgressBar_Smooth)

Define file_size=10e3
Define writen=file_size/1.3

SetGadgetState(progressbar_ID, 100*writen/file_size) ; OS progress bar
Progressbar_Simple_BF(progressbar_ID, flags, $32CD32, $FFFF) ; Progressbar_Simple_BF

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 67
; FirstLine = 34
; Folding = -
; EnableXP