﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Rotating, resizing and output for Images with transparence, also for PB GIF frames :-)
; Can output directly on images, PB sprites and canvas

EnableExplicit

Define window_ID, win_event, image_ID, texture_ID, background_ID, result
Define image_x, image_y, image_width, image_height
Define path$

#Image_0="./Image_Set/Foxy.png"
#Image_1="./Image_Set/Penguin.png"
#SoilWall="./Image_Set/soil_wall.jpg"
#Chicken_1_5="./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha5.png"

; Presets
image_width=800 : image_height=500

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; - Call function #1 -
texture_ID=LoadImage(#PB_Any, #SoilWall)
ErrorCheck_BF(BucketFill_BF(-2, background_ID, texture_ID,
                    0,  ; x Startpoint for BucketFill 
                    0)) ; y

; - Call function #2 -
Define image_0_ID=LoadImage(#PB_Any, #Image_0)
Define image_1_ID=LoadImage(#PB_Any, #Image_1)
Define chicken_1_5_ID=LoadImage(#PB_Any, #chicken_1_5)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
DrawingMode(#PB_2DDrawing_Transparent)

DrawText(10, 10, "Rotating, resizing")
DrawText(10, 30, "Images with transparence and auto tiling on screen - Also for PB GIF")
StopDrawing() 

NoCaching_BF(1) ; Deactivate BF texture caching - You can, but you must not

; =====================================================================

ErrorCheck_BF(RotateAlphaChannelSprite_BF(canvas_ID, image_0_ID,                                                                         
                                          500, ; Output pos x
                                          10,  ; Output pos y
                                          -10, ; Rotating degree
                                          1,   ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                          0,   ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific) 
                                          0,   ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                                          0,   ; Endposition texture output y - Preset 0 = Clipping is automatic to input height
                                          170, ; You can here resize the output x
                                          170, ; You can here resize the output y
                                          0,   ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                          0,   ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                          0,   ; Endposition inside the texture x - Preset 0 = full texture width (Texture clipping)
                                          0,   ; Endposition inside the texture y - Preset 0 = full texture height (Texture clipping)
                                          0,   ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                          0))  ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

ErrorCheck_BF(RotateAlphaChannelSprite_BF(canvas_ID, image_1_ID,                                                                         
                                          20,  ; Output pos x
                                          60,  ; Output pos y
                                          10,  ; Rotating degree
                                          1,   ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                          0,   ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)
                                          800, ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                                          600, ; Endposition texture output y - Preset 0 = Clipping is automatic to input height
                                          60,  ; You can here resize the output x
                                          60,  ; You can here resize the output y
                                          0,   ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                          0,   ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                          0,   ; Endposition inside the texture - x Preset 0 = full texture width (Texture clipping)
                                          0,   ; Endposition inside the texture - y Preset 0 = full texture height (Texture clipping)
                                          0,   ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                          0))  ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

ErrorCheck_BF(RotateAlphaChannelSprite_BF(canvas_ID, image_0_ID,                                                                         
                                          20,  ; Output pos x
                                          -10, ; Output pos y
                                          20,  ; Rotating degree
                                          2 ,  ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                          40,  ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)      
                                          0,   ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                                          0,   ; Endposition texture output y - Preset 0 = Clipping is automatic to input height     
                                          300, ; You can here resize the output x
                                          450, ; You can here resize the output y
                                          0,   ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                          0,   ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                          0,   ; Endposition inside the texture x - Preset 0 = full texture width (Texture clipping)
                                          0,   ; Endposition inside the texture y - Preset 0 = full texture height (Texture clipping)
                                          0,   ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                          0))  ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

; Look, this is a other function with less parameters
; it's not BF core based and can so not tiling, but it's fast
ErrorCheck_BF(RotateAlphaChannelSprite_fast_BF(canvas_ID, chicken_1_5_ID,                                                                         
                                               -30, ; Output pos x
                                               20,  ; Output pos y
                                               10,  ; Rotating degree
                                               0,   ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                               0,   ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)     
                                               200, ; You can here resize the output x
                                               250, ; You can here resize the output y
                                               0,   ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                               0,   ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                               0,   ; Endposition inside the texture x - Preset 0 = full texture width (Texture clipping)
                                               0,   ; Endposition inside the texture y - Preset 0 = full texture height (Texture clipping)
                                               0,   ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                               0))  ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

HideWindow(window_ID, 0)

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed BF textures - You can, but you must not here
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 124
; FirstLine = 99
; EnableXP
; DisableDebugger