﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Rotating, resizing and output for Images with transparence, also for PB GIF frames :-)
; Can output directly on images, PB sprites and canvas

EnableExplicit

Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option

Define window_ID, win_event, image_ID, texture_ID, background_ID, result
Define image_x, image_y, image_width, image_height
Define path$

#Image_0="./Image_Set/Foxy.png"
#Image_1="./Image_Set/Penguin.png"
#SoilWall="./Image_Set/soil_wall.jpg"
#Chicken_1_5="./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha5.png"

; Presets
image_width=800 : image_height=500

background_ID=CreateImage(#PB_Any, image_width*DPI_ResizeFactor_BF(), image_height*DPI_ResizeFactor_BF())

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; - Call function #1 -
texture_ID=LoadImage(#PB_Any, #SoilWall)
ErrorCheck_BF(BucketFill_BF(-2, background_ID, texture_ID,
                            0,  ; x Startpoint for BucketFill 
                            0)) ; y

; - Call function #2 -
Define image_0_ID=LoadImage(#PB_Any, #Image_0)
Define image_1_ID=LoadImage(#PB_Any, #Image_1)
Define chicken_1_5_ID=LoadImage(#PB_Any, #chicken_1_5)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0, image_width*DPI_ResizeFactor_BF(), image_height*DPI_ResizeFactor_BF())
StopDrawing()

Define font_ID=LoadFont(#PB_Any, "Times New Roman", 25*DPI_ResizeFactor_BF(), #PB_Font_Bold)

Define button_width=440
Define button_height=46
Define text_color=#Black
Define background_color=$DEDEDE
Define stretch_x=10 ; Text stretching
Define stretch_y=10
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define canvas_flag=#PB_Canvas_Border

Define gadget_1_ID=TextGadget_BF("Rotating, resizing"+#LF$+"Images with transparence and auto tiling on screen - Also for PB GIF",
                                 5,
                                 5,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag) 

NoCaching_BF(1) ; Deactivate BF texture caching - You can, but you must not

; =====================================================================

ErrorCheck_BF(RotateAlphaChannelSprite_BF(canvas_ID, image_0_ID,                                                                         
                                          500*DPI_ResizeFactor_BF(), ; Output pos x
                                          10*DPI_ResizeFactor_BF(),  ; Output pos y
                                          -10,                       ; Rotating degree
                                          1,                         ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                          0,                         ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific) 
                                          0,                         ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                                          0,                         ; Endposition texture output y - Preset 0 = Clipping is automatic to input height
                                          170*DPI_ResizeFactor_BF(), ; You can here resize the output x
                                          170*DPI_ResizeFactor_BF(), ; You can here resize the output y
                                          0,                         ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                          0,                         ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                          0,                         ; Endposition inside the texture x - Preset 0 = full texture width (Texture clipping)
                                          0,                         ; Endposition inside the texture y - Preset 0 = full texture height (Texture clipping)
                                          0,                         ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                          0))                        ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

ErrorCheck_BF(RotateAlphaChannelSprite_BF(canvas_ID, image_1_ID,                                                                         
                                          20*DPI_ResizeFactor_BF(),  ; Output pos x
                                          60*DPI_ResizeFactor_BF(),  ; Output pos y
                                          10,                        ; Rotating degree
                                          1,                         ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                          0,                         ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)
                                          800*DPI_ResizeFactor_BF(), ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                                          600*DPI_ResizeFactor_BF(), ; Endposition texture output y - Preset 0 = Clipping is automatic to input height
                                          60*DPI_ResizeFactor_BF(),  ; You can here resize the output x
                                          60*DPI_ResizeFactor_BF(),  ; You can here resize the output y
                                          0,                         ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                          0,                         ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                          0,                         ; Endposition inside the texture - x Preset 0 = full texture width (Texture clipping)
                                          0,                         ; Endposition inside the texture - y Preset 0 = full texture height (Texture clipping)
                                          0,                         ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                          0))                        ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

ErrorCheck_BF(RotateAlphaChannelSprite_BF(canvas_ID, image_0_ID,                                                                         
                                          20*DPI_ResizeFactor_BF(),  ; Output pos x
                                          -10*DPI_ResizeFactor_BF(), ; Output pos y
                                          20,                        ; Rotating degree
                                          2 ,                        ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                          40,                        ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)      
                                          0,                         ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                                          0,                         ; Endposition texture output y - Preset 0 = Clipping is automatic to input height     
                                          300*DPI_ResizeFactor_BF(), ; You can here resize the output x
                                          450*DPI_ResizeFactor_BF(), ; You can here resize the output y
                                          0,                         ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                          0,                         ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                          0,                         ; Endposition inside the texture x - Preset 0 = full texture width (Texture clipping)
                                          0,                         ; Endposition inside the texture y - Preset 0 = full texture height (Texture clipping)
                                          0,                         ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                          0))                        ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

; Look, this is a other function with less parameters
; it's not BF core based and can so not tiling, but it's fast
ErrorCheck_BF(RotateAlphaChannelSprite_fast_BF(canvas_ID, chicken_1_5_ID,                                                                         
                                               -30*DPI_ResizeFactor_BF(), ; Output pos x
                                               20*DPI_ResizeFactor_BF(),  ; Output pos y
                                               10,                        ; Rotating degree
                                               0,                         ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation
                                               0,                         ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)     
                                               200*DPI_ResizeFactor_BF(), ; You can here resize the output x
                                               250*DPI_ResizeFactor_BF(), ; You can here resize the output y
                                               0,                         ; Startposition inside the texture x - Preset 0 (Texture clipping)
                                               0,                         ; Startposition inside the texture y - Preset 0 (Texture clipping)
                                               0,                         ; Endposition inside the texture x - Preset 0 = full texture width (Texture clipping)
                                               0,                         ; Endposition inside the texture y - Preset 0 = full texture height (Texture clipping)
                                               0,                         ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                                               0))                        ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  

; =====================================================================

HideWindow(window_ID, 0)

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed BF textures - You can, but you must not here
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 159
; FirstLine = 131
; EnableXP
; DPIAware
; DisableDebugger