﻿; Compactness demo - Rotate large sprite on a windowed screen - Rotate a BF sprite as content from a PB sprite

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Macro output_sprites
  degree=(degree+1)%359+1
  degree_1=(degree_1+2)%359+1
  offset_x-4 : If offset_x<=-ImageWidth(background_1_ID) : offset_x=0 : EndIf
  offset_y-3 : If offset_y<=-ImageHeight(background_1_ID) : offset_y=0 : EndIf
  alpha-1 : If alpha<1 : alpha=256 : EndIf
  
  Free_PB_Sprite_BF(sprite_PB_ID)
  
  sprite_ID=CopySprite(sprite_1_ID, #PB_Any)
  
  ErrorCheck_BF(BF(-2, sprite_ID, background_1_ID, 0, 0, offset_x, offset_y)) ; Create a tilled background
  
  ErrorCheck_BF(RotateSprite_simple_BF(2, sprite_ID, texture_ID,                              
                                       image_get_color_x, ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                     
                                       image_get_color_y, ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                       -20,               ; Output pos x
                                       -40,               ; Output pos y
                                       degree_1,          ; Rotating degree
                                       alpha,             ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                       154,               ; You can here resize the output x
                                       154,               ; You can here resize the output y
                                       0,                 ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
                                       0))                ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50
                                                          ; Set alpha -1 to -256 for a output without invisible color
                                                          ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets - Do not make offsets too big - Bigger = slower
                                                          ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                                          ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                                          ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                                          ; So you can also simple create masked rotated sprites from all images without mask
                                                          ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                                          ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                                          ; Reduce for Images SetColorDistanceSpriteMask_BF or you can become "holes", but also nice effects
  
  ErrorCheck_BF(RotateSprite_simple_BF(2, sprite_ID, texture_ID,                              
                                       image_get_color_x, ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                     
                                       image_get_color_y, ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                       480,               ; Output pos x
                                       -40,               ; Output pos y
                                       degree_1,          ; Rotating degree
                                       0,                 ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                       154,               ; You can here resize the output x
                                       154,               ; You can here resize the output y
                                       0,                 ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
                                       0))                ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50
  
  sprite_PB_ID=CreateSprite_simple_BF(1, sprite_ID, -2, $998877, degree, 1, 700, 150, 0, 0, 0, 1) ; Create a resized and rotated PB sprite from a other
  
  ErrorCheck_BF(RotateSprite_simple_BF(1, sprite_PB_ID, texture_ID,                              
                                       0,         ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                     
                                       0,         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                       -235,      ; Output pos x
                                       -235,      ; Output pos y
                                       -degree_1, ; Rotating degree
                                       0,         ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                       200,       ; You can here resize the output x
                                       200,       ; You can here resize the output y
                                       100,       ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
                                       100))      ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50
  
  TransparentSpriteColor(sprite_PB_ID, $998877)
  DisplaySprite(background_sprite_ID, 0, 0)
  ZoomSprite(sprite_PB_ID, 400, 400)
  DisplayTransparentSprite(sprite_PB_ID, 340, 160)
  ZoomSprite(sprite_PB_ID, 300, 300)
  DisplayTransparentSprite(sprite_PB_ID, 10, 00, 150)
  DisplayTransparentSprite(sprite_PB_ID, 10, 300)
  ZoomSprite(sprite_PB_ID, 150, 150)
  Rotate_PB_Sprite_with_Offset_BF(sprite_PB_ID, 609, 7, degree, 1, 130)
EndMacro

window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate a BF sprite as content from a PB sprite", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(window_ID), 0, 0, 768, 600)

sprite_ID=CreateSprite(#PB_Any, 700, 150)
StartDrawing(SpriteOutput(sprite_ID))
Box(0, 0, 700, 150, $0000FF)
StopDrawing()
sprite_1_ID=CopySprite(sprite_ID, #PB_Any)

background_sprite_ID=CreateSprite(#PB_Any, 768, 600)

background_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")

background_1_ID=CopyImage(background_ID, #PB_Any)
ResizeImage(background_1_ID, 300, 300)

ErrorCheck_BF(BF(-2, background_sprite_ID, background_ID)) ; Create a tilled background

sprite_1_ID=CopySprite(sprite_ID, #PB_Any)

texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")

SetColorDistanceSpriteMask_BF(35) ; Remove artifacts from the sprite mask

texture_1_ID=CopyImage(texture_ID, #PB_Any)

alpha=256

SpriteQuality(#PB_Sprite_BilinearFiltering)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching
  
ActivateMaskCreating_BF($FF) ; Activate color mask creating

Repeat
  
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  
  ClearScreen(0)
  output_sprites
  FlipBuffers()
  
ForEver
; IDE Options = PureBasic 5.70 LTS (MacOS X - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; DisableDebugger