﻿
; Rotate a large BF sprite with alpha blending and color distance on canvas - This is a ability and handling demo

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define win_event, degree, xx, sprite_ID, xxx.f, alpha.f=1, x=50, y=-50

Macro output_sprites
  degree=(degree+1)%359+1
  xx+2 : If xx>450 : xx=450 : xxx+0.12 : alpha+0.6 : EndIf
  If xxx>50 : xxx=0 : xx=0 : alpha=1
  Else  
    sprite_ID=CreateSprite_simple_BF(0, texture_ID, ; type=0 = BF sprite - type=1 = PB sprite
                                     -1,            ; Grab transparence color from source pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                                     mask_color,    ; Grab transparence color from source pos y - For preset set ..y= the color you want - as sample $FF00FF
                                     degree,        ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                     1,             ; mode=0 deactivate rotating - mode=1 create a quadratic sprite for on demand rotation - mode=2 create a exactely resized sprite with minimized mask
                                     xx,            ; You can here resize the output x - On demand
                                     xx,            ; You can here resize the output y - On demand
                                     0,             ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
                                     0,             ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                     40+xxx,        ; Color distance sprite mask - Mask cleaning - Important                                  
                                     0,             ; Delete the input
                                     0,             ; Mirroring - 0=without - 1=horizontal - 2=vertical - 3=horizontal and vertical
                                     0)             ; Flags for CreateSprite - same PB function call
                                                    ; The function accepts as input a image, a PB sprite or a canvas (ID) 
    
    SetColorDistanceSpriteMask_BF(30) ; percent - The used demo image has not a clean mask - Without this function you get not a invisible color
    
    SpriteSimple_fast_BF(alpha, background_sprite_ID, sprite_ID,                                     
                         0, ; Grab transparence color from the frame pos x - Set to -1 for output without invisible color 
                         0, ; Grab transparence color from the frame pos y - You can set x or y, or both parameters to -1 
                         x, ; Output position x
                         y) ; Output position y
    
    FreeImage(sprite_ID)
    
    CopyContent_Image_Canvas_BF(background_sprite_ID, canvas_ID)
    CopyContent_Image_Image_BF(background_sprite_1_ID, background_sprite_ID)
    
  EndIf
EndMacro

Define window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate large sprite on canvas - Ability and handling demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 768, 600)

Define background_sprite_ID=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")
Define background_sprite_1_ID=CopyImage(background_sprite_ID, #PB_Any)
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")
Define mask_color=GetImageColor_BF(texture_ID, 0, 0)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching
HideWindow(window_ID, 0)

Repeat
  win_event=WindowEvent()
  If win_event=#PB_Event_CloseWindow
    End
  EndIf
  If Delay_BF(0, 30)
    output_sprites
  EndIf
ForEver
; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; CursorPosition = 56
; FirstLine = 39
; Folding = -
; EnableXP
; DisableDebugger