﻿
; Rotate a large BF sprite with alpha blending and color distance on canvas demo

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define win_event, degree, xx, xxx.f, alpha.f=1, x=50, y=-50

Macro output_sprites
  degree=(degree+1)%359+1
  xx+2 : If xx>450 : xx=450 : xxx+0.12 : alpha+0.6 : EndIf
  If xxx>50 : xxx=0 : xx=0 : alpha=1
  Else  
    SetColorDistanceSpriteMask_BF(40+xxx) ; percent - The used demo image has not a clean mask - Without this function you get not a invisible color
    
    ActivateMaskCreating_BF($FF, alpha-50) ; Activate color mask creating
    
    FlipBuffers_BF(0)
    RotateSprite_simple_BF(2, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID,                              
                           -1,         ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                           mask_color, ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                           x,          ; Output pos x
                           y,          ; Output pos y
                           degree,     ; Rotating degree - On demand
                           alpha+50,   ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                           xx,         ; You can here resize the output x - On demand
                           xx,         ; You can here resize the output y - On demand
                           0,          ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                           0)          ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                       ; Set alpha -1 to -256 for a output without invisible color
                                       ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                       ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                       ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                       ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                       ; So you can also simple create masked rotated sprites from all images without a included mask
                                       ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                       ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                       ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects   
    
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID)
  EndIf
EndMacro

Define window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Output large sprite on canvas - Using enhanced color distance", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 768, 600)

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

Define background_sprite_ID=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")
CopyContent_Image_Image_BF(background_sprite_ID, Get_animation_buffer_background_image_ID_BF(0))
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")
Define mask_color=GetImageColor_BF(texture_ID, 0, 0)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching

HideWindow(window_ID, 0)

Repeat
  win_event=WindowEvent()
  If win_event=#PB_Event_CloseWindow
    End
  EndIf
  If Delay_BF(0, 30)
    output_sprites
  EndIf
ForEver
; IDE Options = PureBasic 5.70 LTS (MacOS X - x64)
; CursorPosition = 8
; Folding = -
; EnableXP
; DisableDebugger