﻿
; Rotate a large BF sprite with alpha blending and color distance on a windowed screen

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define xxx.f

Macro output_sprites
  degree=(degree+1)%359+1
  xx+2 : If xx>450 : xx=450 : xxx+0.12 : EndIf
  If xxx>50 : xxx=0 : xx=0 
  Else  
    ClearScreen(0)
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    SetColorDistanceSpriteMask_BF(40+xxx)
    RotateSprite_simple_BF(2, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID,                              
                           0,          ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                           0,          ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                           379-xx/1.4, ; Output pos x
                           600-xx*1.5, ; 270-xx/1.4, ; Output pos y
                           degree,     ; Rotating degree - On demand
                           128,        ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                           xx,         ; You can here resize the output x - On demand
                           xx,         ; You can here resize the output y - On demand
                           0,          ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                           0)          ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                       ; Set alpha -1 to -256 for a output without invisible color
                                       ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                       ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                       ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                       ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                       ; So you can also simple create masked rotated sprites from all images without a included mask
                                       ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                       ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                       ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects
    
    CopyContent_Image_Screen_BF(Get_animation_buffer_hidden_image_ID_BF(0), 0, 0)
  EndIf
EndMacro

window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate large sprite on windowed screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window3D_Invisible)
OpenWindowedScreen(WindowID(window_ID), 0, 0, 768, 600)

texture_ID=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")

background_sprite_ID=CreateImage(#PB_Any, 768, 600)
ErrorCheck_BF(BF(-2, background_sprite_ID, texture_ID)) ; Create a tilled background - For this large background not needed, but it works with any textures and sizes
FreeImage(texture_ID)

texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")

Create_animation_buffers_BF(background_sprite_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching

HideWindow(window_ID, 0)

Repeat
  If Delay_BF(0, 30)
    Delay(30)
  EndIf
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
    output_sprites
  FlipBuffers()
ForEver
; IDE Options = PureBasic 5.71 LTS (Linux - x64)
; CursorPosition = 69
; FirstLine = 46
; Folding = -
; EnableXP
; DisableDebugger