﻿
; Rotate a large BF sprite with alpha blending and color distance on a windowed screen

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define win_event, degree, xx, sprite_ID, xxx.f, alpha.f=255

Macro output_sprites
  degree=(degree+1)%359+1
  xx+2 : If xx>450 : xx=450 : xxx+0.12 : alpha-0.7 : If alpha<0 : alpha=0 : EndIf : EndIf
  If xxx>50 : xxx=0 : xx=0 : alpha=255
  Else  
    ClearScreen(0)
    sprite_ID=CreateSprite_simple_BF(1, texture_ID,            ; type=0 = BF sprite - type=1 = PB sprite
                                     -1,                       ; Grab transparence color from source pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                                     mask_color,               ; Grab transparence color from source pos y - For preset set ..y= the color you want - as sample $FF00FF
                                     degree,                   ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                     1,                        ; mode=0 deactivate rotating - mode=1 create a quadratic sprite for on demand rotation - mode=2 create a exactely resized sprite with minimized mask
                                     xx,                       ; You can here resize the output x - On demand
                                     xx,                       ; You can here resize the output y - On demand
                                     0,                        ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
                                     0,                        ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                     40+xxx,                   ; Color distance sprite mask - Mask cleaning - Important                                  
                                     0,                        ; Delete the input
                                     0,                        ; Mirroring - 0=without - 1=horizontal - 2=vertical - 3=horizontal and vertical
                                     #PB_Sprite_AlphaBlending) ; Flags for CreateSprite - same PB function call
                                                               ; The function accepts as input a image, a PB sprite or a canvas (ID) 
    TransparentSpriteColor(sprite_ID, mask_color)
    DisplaySprite(background_sprite_ID, 0, 0)
    DisplayTransparentSprite(sprite_ID, 50, -50, alpha) 
    FreeSprite(sprite_ID)
  EndIf
EndMacro

Define window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate large sprite on windowed screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window3D_Invisible)
OpenWindowedScreen(WindowID(window_ID), 0, 0, 768, 600)
 
Define background_sprite_ID=LoadSprite(#PB_Any, "./Image_Set/Hubble.jpg")
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")
Define mask_color=GetImageColor_BF(texture_ID, 0, 0)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching
HideWindow(window_ID, 0)

Repeat
  If Delay_BF(0, 30)
    Delay(30)
  EndIf
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  output_sprites
  FlipBuffers()
ForEver
; IDE Options = PureBasic 5.71 LTS (Linux - x64)
; CursorPosition = 50
; FirstLine = 35
; Folding = -
; EnableXP
; DisableDebugger