﻿
; Rotate a large BF sprite with color distance and gradient colors on a windowed screen

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define xx.f, xxx.f

Macro output_sprites
  degree=(degree+1)%359+1
  DisplaySprite(background_sprite, 0, 0)
  xx+2 : If xx>380 : xx=380 : xxx+0.12 : EndIf
  If xxx>50 : xxx=0 : xx=0
  Else   
    ; This functions works equal the PB function
    ; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
    ; You must deactivate again
    FrontColor_BF(1, $FF)
    ; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
    GradientColor_Array_BF(1, 1, 0.2, $FF0000)
    GradientColor_Array_BF(1, 2, 0.3, $FF00)
    GradientColor_Array_BF(1, 3, 0.5, $FFFF)
    GradientColor_Array_BF(1, 4, 0.7, $FF)
    GradientColor_Array_BF(1, 5, 0.9, $FF0000)
    
    CircularGradient_BF(1,  ImageWidth(texture_ID)/2,  ImageHeight(texture_ID)/2, xx/1.5)
    
    GradientColor_Alpha_BF(120) ; Gradient color intensity 0 > 255
    GradientColor_Contrast_BF(50) ; Enhance the contrast - This influence the output speed
    
    texture_1_ID=CreateSpriteGradientColor_BF(texture_ID, 0, 0)
    
    SetColorDistanceSpriteMask_BF(40+xxx)
    RotateSprite_simple_BF(2, 0, texture_1_ID,                              
                           0,          ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                           0,          ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                           379-xx/1.4, ; Output pos x
                           600-xx*1.5, ; 270-xx/1.4, ; Output pos y
                           degree,     ; Rotating degree - On demand
                           0,          ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                           xx,         ; You can here resize the output x - On demand
                           xx,         ; You can here resize the output y - On demand
                           0,          ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                           0)          ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                       ; Set alpha -1 to -256 for a output without invisible color
                                       ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                       ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                       ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                       ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                       ; So you can also simple create masked rotated sprites from all images without a included mask
                                       ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                       ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                       ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects
    FreeImage(texture_1_ID) 
  EndIf
EndMacro

window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate large sprite on windowed screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window3D_Invisible)
OpenWindowedScreen(WindowID(window_ID), 0, 0, 768, 600)

texture_ID=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")

background_sprite=CreateSprite(#PB_Any, 768, 600)
ErrorCheck_BF(BF(-2, background_sprite, texture_ID)) ; Create a tilled background - For this large background not needed, but it works with any textures and sizes
FreeImage(texture_ID)

texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")

ActivateScreenOutput_BF(1)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching

HideWindow(window_ID, 0)

Repeat
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      DeactivateGradientColors_BF() ; Before End you must not use - It's here only for demonstrating added
      End
    EndIf
  Until Not win_event
  If Delay_BF(0, 30)
    ClearScreen(0)
    output_sprites
  EndIf
  FlipBuffers()
ForEver
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 79
; FirstLine = 56
; Folding = -
; EnableXP
; DisableDebugger