﻿
; Rotate and mirror a large BF sprite on a windowed screen

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Macro output_sprites
  degree=(degree+1)%359+1
  
  ; Mirroring BF
  ; This works at the same on images and canvas
  ; You can activate and deactivate for many functions how use stepless rotating
  If degree>120 : Activate_Mirroring_Horizontal_Rotate_BF(1) : EndIf
  If degree>250 : Activate_Mirroring_Horizontal_Rotate_BF(0) : EndIf
  If degree>80  : Activate_Mirroring_Vertical_Rotate_BF(1)   : EndIf
  If degree>200 : Activate_Mirroring_Vertical_Rotate_BF(0)   : EndIf
  
  DisplaySprite(background_sprite, 0, 0)

  xx+1 : If xx>500 : xx=500 : EndIf
  
  RotateSprite_simple_BF(2, output_ID, texture_ID,                              
                         -1,      ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                         $00D7FF, ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                         123,     ; Output pos x
                         20,      ; Output pos y
                         degree,  ; Rotating degree - On demand
                         0,       ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                         xx,      ; You can here resize the output x - On demand
                         100,     ; You can here resize the output y - On demand
                         0,       ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                         0)       ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                  ; Set alpha -1 to -256 for a output without invisible color
                                  ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                  ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                  ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                  ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                  ; So you can also simple create masked rotated sprites from all images without a included mask
                                  ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                  ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                  ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects   
EndMacro

window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate and mirror a large BF sprite on windowed screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window3D_Invisible)
OpenWindowedScreen(WindowID(window_ID), 0, 0, 768, 600)

texture_ID=CreateImage(#PB_Any, 256, 256)
StartDrawing(ImageOutput(texture_ID))
Box(0,0,128,128,$FF0000) : Box(128,0,128,128,$00FF00) : Box(0,128,128,128,$0000FF) : Box(128,128,128,128,$00FFFF)
StopDrawing()

background_sprite=CreateSprite(#PB_Any, 768, 600)
ErrorCheck_BF(BF(-2, background_sprite, texture_ID)) ; Create a tilled background

ActivateScreenOutput_BF(1)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching

; SetColorDistanceSpriteMask_BF(0) ; For BF sprite output without invisible color mostly not needed

HideWindow(window_ID, 0)

Repeat
  If Delay_BF(0, 10)
    Delay(10)
  EndIf
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
    ClearScreen(0)
    output_sprites
  FlipBuffers()
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 11
; Folding = -
; EnableXP
; DisableDebugger