﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Image output as BF sprites - rotated - without aliasing

EnableExplicit

Activate_DPI_aware_BF(1)

Define window_ID, texture_0_ID, texture_1_ID, texture_2_ID, texture_3_ID, texture_4_ID, texture_5_ID, image_ID, background_ID, destination_ID
Define i, degree, win_event, image_width, image_height, change_red.f, change_green.f, change_blue.f, change_contrast.f, change_brightness.f

; Presets
image_width=1060 : image_height=700
window_ID=OpenWindow(#PB_Any, 0, 0, image_width, image_height, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, image_width, image_height, #PB_Canvas_Container) ; Create a canvas for output the result all over

; - Call function #1 -
texture_0_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")
texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Lion.jpg")
texture_2_ID=LoadPhoto_BF("./Image_Set/Cat_01.jpg") ; LoadPhoto_BF can handle EXIF data and automatically image rotation
texture_3_ID=LoadPhoto_BF("./Image_Set/Hubble.jpg")
texture_4_ID=LoadImage(#PB_Any, "./Image_Set/Rose.jpg")
texture_5_ID=LoadImage(#PB_Any, "./Image_Set/PureBasicLogo.bmp")

ResizeImage(texture_0_ID, ImageWidth(texture_0_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_0_ID)*DPI_ResizeFactor_BF())
ResizeImage(texture_1_ID, 400*DPI_ResizeFactor_BF(), 300*DPI_ResizeFactor_BF())
ResizeImage(texture_2_ID, 400*DPI_ResizeFactor_BF(), 300*DPI_ResizeFactor_BF())
ResizeImage(texture_3_ID, 400*DPI_ResizeFactor_BF(), 300*DPI_ResizeFactor_BF())
ResizeImage(texture_4_ID, 400*DPI_ResizeFactor_BF(), 300*DPI_ResizeFactor_BF())
ResizeImage(texture_5_ID, ImageWidth(texture_5_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_5_ID)*DPI_ResizeFactor_BF())

For i= 0 To 4*DPI_ResizeFactor_BF() ; Add a border - This change the textures
  StartDrawing(ImageOutput(texture_1_ID))
  DrawingMode(#PB_2DDrawing_Outlined)
  Box(i, i, ImageWidth(texture_1_ID)-i*2, ImageHeight(texture_1_ID)-i*2)
  StopDrawing()
  StartDrawing(ImageOutput(texture_2_ID))
  DrawingMode(#PB_2DDrawing_Outlined)
  Box(i, i, ImageWidth(texture_2_ID)-i*2, ImageHeight(texture_2_ID)-i*2)
  StopDrawing()
  StartDrawing(ImageOutput(texture_3_ID))
  DrawingMode(#PB_2DDrawing_Outlined)
  Box(i, i, ImageWidth(texture_3_ID)-i*2, ImageHeight(texture_3_ID)-i*2)
  StopDrawing()
  StartDrawing(ImageOutput(texture_4_ID))
  DrawingMode(#PB_2DDrawing_Outlined)
  Box(i, i, ImageWidth(texture_4_ID)-i*2, ImageHeight(texture_4_ID)-i*2)
  StopDrawing()
Next i

NoCaching_BF(1) ; BF Texture caching not needed, i deactivate it

Define background_0_ID=CreateImage(#PB_Any, image_width*DPI_ResizeFactor_BF(), image_height*DPI_ResizeFactor_BF()) ; Create a large image for the background
ErrorCheck_BF(BF(-2, background_0_ID, texture_0_ID))                                                               ; Create a tiled background

Define temporary_background_1_ID=Create_empty_rotated_image_BF(image_width*DPI_ResizeFactor_BF(), image_height*DPI_ResizeFactor_BF(), 1) ; Preset for rotation degree 1

Define rotated_width=ImageWidth(temporary_background_1_ID)

Define rotated_height=ImageHeight(temporary_background_1_ID)

; --------------------------------------- Image 1 and 4 ------------------------------------------------
degree=1
ErrorCheck_BF(RotateSprite_simple_BF(3, temporary_background_1_ID, background_0_ID, 
                                     -2,     ; Grab transparence color from serite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                       
                                     0,      ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                     0,      ; Output pos x
                                     0,      ; Output pos y
                                     degree, ; Rotating degree - On demand
                                     0,      ;  Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                                     0,      ; You can here resize the output x
                                     0))     ; You can here resize the output y  

; Draw now the textures in the large image
ErrorCheck_BF(SpriteSimple_fast_BF(0, temporary_background_1_ID, texture_1_ID,  
                                   -2,                       ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,                        ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   60*DPI_ResizeFactor_BF(), ; Output pos x
                                   45*DPI_ResizeFactor_BF(), ; Output pos y
                                   0,                        ; You can here resize the output x
                                   0))                       ; You can here resize the output y


ErrorCheck_BF(SpriteSimple_fast_BF(0, temporary_background_1_ID, texture_4_ID,  
                                   -2,                        ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,                         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   550*DPI_ResizeFactor_BF(), ; Output pos x
                                   380*DPI_ResizeFactor_BF(), ; Output pos y
                                   0,                         ; You can here resize the output x
                                   0))                        ; You can here resize the output y

; --------------------------------------- Image 2 and 3 ------------------------------------------------
degree=-2
ErrorCheck_BF(RotateSprite_simple_BF(3, temporary_background_1_ID, temporary_background_1_ID, 
                                     -2,     ; Grab transparence color from serite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                       
                                     0,      ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                     0,      ; Output pos x
                                     0,      ; Output pos y
                                     degree, ; Rotating degree - On demand
                                     0,      ;  Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                                     0,      ; You can here resize the output x
                                     0))     ; You can here resize the output y  

ErrorCheck_BF(SpriteSimple_fast_BF(0, temporary_background_1_ID, texture_2_ID,  
                                   -2,                        ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,                         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   550*DPI_ResizeFactor_BF(), ; Output pos x
                                   45*DPI_ResizeFactor_BF(),  ; Output pos y
                                   0,                         ; You can here resize the output x
                                   0))                        ; You can here resize the output y

ErrorCheck_BF(SpriteSimple_fast_BF(0, temporary_background_1_ID, texture_3_ID,  
                                   -2,                        ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,                         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                   60*DPI_ResizeFactor_BF(),  ; Output pos x
                                   380*DPI_ResizeFactor_BF(), ; Output pos y
                                   0,                         ; You can here resize the output x
                                   0))                        ; You can here resize the output y

degree=1
ErrorCheck_BF(RotateSprite_simple_BF(3, temporary_background_1_ID, temporary_background_1_ID, 
                                     -2,                       ; Grab transparence color from serite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                       
                                     0,                        ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                     -3*DPI_ResizeFactor_BF(), ; Output pos x
                                     -3*DPI_ResizeFactor_BF(), ; Output pos y
                                     degree,                   ; Rotating degree - On demand
                                     0,                        ;  Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                                     0,                        ; You can here resize the output x
                                     0))                       ; You can here resize the output y  

; --------------------------------------- Addon ------------------------------------------------
; Add a Logo
ErrorCheck_BF(SpriteSimple_fast_BF(-100, temporary_background_1_ID, texture_5_ID,
                                   0,                         ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                   0,                         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                   300*DPI_ResizeFactor_BF(), ; Output position x
                                   280*DPI_ResizeFactor_BF(), ; Output position y
                                   0,                         ; Resizing - Define the output width - Preset zero = without resizing 
                                   0))                        ; Resizing - Define the output height

; Add at least a text and a border to the large image
StartDrawing(ImageOutput(temporary_background_1_ID))

image_width*DPI_ResizeFactor_BF()
image_height*DPI_ResizeFactor_BF()

DrawingMode(#PB_2DDrawing_Outlined)
For i= 0 To 10
  Box(i, i, image_width-i*2, image_height-i*2)
Next i

StopDrawing()

CopyContent_Image_Canvas_BF(temporary_background_1_ID, canvas_ID) ; Copy the finaly created large image to the canvas for output

; ----------- GradientColor_horizontal_Bar_1 ---- You can pre define bars as macro or procedures ------
If Not Defined(PB_ProgressBar_Horizontal , #PB_Constant) : #PB_ProgressBar_Horizontal=0 : EndIf
Enumeration : #Bar_1 : EndEnumeration

CompilerIf #PB_Compiler_OS<>#PB_OS_MacOS : Define font_1_ID=LoadFont(#PB_Any, "Arial", 9) ; Select a font for the progressbar percent display
CompilerElse : Define font_1_ID=LoadFont(#PB_Any, "Arial", 12)
CompilerEndIf

Macro GradientColor_horizontal_Bar_1 ; Define the progressbar
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
    SetFrontText_0_Progressbar_BF(RSet(Str(i), 3, "  ")+"%", 2, -3, 0, 0, 110, font_1_ID) ; Add text
  CompilerElse
    SetFrontText_0_Progressbar_BF(RSet(Str(i), 3, "  ")+"%", 2, 0, 0, 0, 110, font_1_ID) ; Add text
  CompilerEndIf
  
  Define resulted_ID=SetGadgetState_Progressbar_BF(#Bar_1, i, #PB_ProgressBar_Horizontal, 3, $00FFFF, $AAAAAA, $00FF00, 1, $606060)
EndMacro

i=70 ; Percent
ProgressBarGadget(#Bar_1, 70, 380, 920, 15, 0, 100, #PB_ProgressBar_Horizontal)

CloseGadgetList()

GradientColor_horizontal_Bar_1 ; Use Progressbar BF

; --------------------------------------------------------------------------------------------------

Repeat ; Waiting for Godot :-)
  win_event=WindowEvent()
  If win_event=#PB_Event_CloseWindow
    End
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 168
; FirstLine = 160
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger