﻿
DeclareModule ScrollingTextSimple_BF
  EnableExplicit
  Declare CreateTextImageSimple_ST(text$, font_ID, text_color=#Black, background_color=#White)
  Declare ScrollTextImageSimple_ST(image_ID, step_width=1)
  Declare BackColor_ST(BackColor_ST_) ; Back Color for GradientColor
  Declare GradientColor_Pos_ST(GradientColor_Pos_ST_.f, Gradient_Pos_Color_ST_) ; Output pos (0.0 to 1.0) for GradientColor and defined color
  Declare FrontColor_ST(FrontColor_ST_)                                         ; Front Color for GradientColor
  Declare LinearGradient_ST(ActivateLinearGradient_ST_=0,                       ; Activate LinearGradient = 1
                            LinearGradient_X_ST_=0,                             ; LinearGradient_X
                            LinearGradient_Y_ST_=0,                             ; LinearGradient_Y
                            LinearGradient_XX_ST_=0,                            ; LinearGradient_XX
                            LinearGradient_YY_ST_=0)                            ; LinearGradient_YY
EndDeclareModule

Module ScrollingTextSimple_BF
  ; Text scrolling - By Saki - DPI aware - This is a part from GFX_Wizzard_BF
  
  Global GradientColor_Pos_ST.f, Gradient_Pos_Color_ST, BackColor_ST, FrontColor_ST, CreateMaskedAlphaImage_ST, MaskColor_ST
  Global ActivateLinearGradient_ST, LinearGradient_X_ST, LinearGradient_Y_ST, LinearGradient_XX_ST, LinearGradient_YY_ST
  
  Procedure BackColor_ST(BackColor_ST_)
    BackColor_ST=BackColor_ST_
    ProcedureReturn 1
  EndProcedure
  
  Procedure GradientColor_Pos_ST(GradientColor_Pos_ST_.f, Gradient_Pos_Color_ST_)
    GradientColor_Pos_ST.f=GradientColor_Pos_ST_.f
    Gradient_Pos_Color_ST=Gradient_Pos_Color_ST_
    ProcedureReturn 1
  EndProcedure
  
  Procedure FrontColor_ST(FrontColor_ST_)
    FrontColor_ST=FrontColor_ST_
    ProcedureReturn 1
  EndProcedure
  
  Procedure LinearGradient_ST(ActivateLinearGradient_ST_=0,
                              LinearGradient_X_ST_=0,
                              LinearGradient_Y_ST_=0,
                              LinearGradient_XX_ST_=0,
                              LinearGradient_YY_ST_=0)
    ActivateLinearGradient_ST=ActivateLinearGradient_ST_
    LinearGradient_X_ST=LinearGradient_X_ST_
    LinearGradient_Y_ST=LinearGradient_Y_ST_
    LinearGradient_XX_ST=LinearGradient_XX_ST_
    LinearGradient_YY_ST=LinearGradient_YY_ST_
    ProcedureReturn 1
  EndProcedure
  
  Procedure CreateTextImageSimple_ST(text$, font_ID, text_color=#Black, background_color=#White)
    Protected image_ID=CreateImage(#PB_Any, 16, 16, 24, background_color)
    If Not image_ID : ProcedureReturn 0 : EndIf
    If Not StartDrawing(ImageOutput(image_ID)) : FreeImage(image_ID) : ProcedureReturn 0 : EndIf
    DrawingFont(FontID(font_ID))
    Protected text_width=TextWidth(text$)
    Protected text_height=TextHeight(text$)
    
    Box(0, 0, text_width, text_height, background_color)
    
    StopDrawing()
    ResizeImage(image_ID, text_width, text_height*1.2)
    StartDrawing(ImageOutput(image_ID))
    
    If ActivateLinearGradient_ST
      DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_Gradient)
      FrontColor(FrontColor_ST)
      BackColor(BackColor_ST)
      GradientColor(GradientColor_Pos_ST.f, Gradient_Pos_Color_ST)
      LinearGradient(LinearGradient_X_ST, LinearGradient_Y_ST, LinearGradient_XX_ST, LinearGradient_YY_ST)
    Else
      DrawingMode(#PB_2DDrawing_Transparent)
    EndIf 
    
    DrawingFont(FontID(font_ID))
    DrawText(0, 0, text$, text_color)
    StopDrawing()
    ProcedureReturn image_ID
  EndProcedure
  
  Procedure ScrollTextImageSimple_ST(image_ID, step_width=1)
    step_width*DesktopResolutionX()
    If step_width<1 : step_width=1 : EndIf
    Protected text_width=ImageWidth(image_ID)
    Protected text_height=ImageHeight(image_ID)
    If Not StartDrawing(ImageOutput(image_ID)) : ProcedureReturn 0 : EndIf
    Protected temp_image_1_ID=GrabDrawingImage(#PB_Any, 0, 0, step_width, text_height)
    If Not temp_image_1_ID : ProcedureReturn 0 : EndIf
    Protected temp_image_2_ID=GrabDrawingImage(#PB_Any, step_width, 0, text_width-step_width, text_height)
    If Not temp_image_2_ID : FreeImage(temp_image_1_ID) : ProcedureReturn 0 : EndIf
    DrawImage(ImageID(temp_image_1_ID), text_width-step_width, 0)
    DrawImage(ImageID(temp_image_2_ID), 0, 0)
    StopDrawing() 
    FreeImage(temp_image_1_ID) : FreeImage(temp_image_2_ID)
    ProcedureReturn image_ID
  EndProcedure
EndModule
UseModule ScrollingTextSimple_BF

; ###### Get the result ######

CompilerIf #PB_Compiler_IsMainFile
  EnableExplicit
  
  UsePNGImageDecoder()
  
  Define window_ID=OpenWindow(#PB_Any, 5 ,5 ,800 ,300 ,"Scrolling text" ,#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
  SetWindowColor(window_ID, $909090)
  
  Define font_ID=LoadFont(#PB_Any,"Tahoma", 24)
  
  Define text_color=#Yellow
  Define background_color=#Blue
  Define text$="     Hello World, this is scrolling text BF"
  
  Global image_ID=CreateTextImageSimple_ST(text$, font_ID, text_color, background_color) ; Init Gradient color diameters
  BackColor_ST(#Blue)                                                                    ; Back Color for GradientColor
  GradientColor_Pos_ST(0.3, text_color)                                                  ; Output pos (0.0 to 1.0) for GradientColor and defined color 
  FrontColor_ST(#Red)                                                                    ; FrontColor for GradientColor
  LinearGradient_ST(1,                                                                   ; Activate LinearGradient = 1
                    0,                                                                   ; LinearGradient_X
                    ImageHeight(image_ID)+ImageHeight(image_ID)/6,                       ; LinearGradient_Y
                    0,                                                                   ; LinearGradient_XX
                    -ImageHeight(image_ID)/6)                                            ; LinearGradient_YY
  FreeImage(image_ID)
  
  Global image_ID=CreateTextImageSimple_ST(text$, font_ID, text_color, background_color) ; Init
  Define image_1_ID=LoadImage(#PB_Any, "../GFX_Wizzard_BF/Image_Set/Foxy.png")
  ResizeImage(image_1_ID, ImageHeight(image_ID)/1.4, ImageHeight(image_ID))
  StartDrawing(ImageOutput(image_ID))
  DrawAlphaImage(ImageID(image_1_ID), 5, 0)
  StopDrawing()
  
  #CanvasOutput=#True ; Choose CanvasGadget for output or ButtonImageGadget
  
  If #CanvasOutput
    ; Output on a CanvasGadget
    Global gadget_ID=CanvasGadget(#PB_Any,
                                  WindowWidth(window_ID)/2-ImageWidth(image_ID)/2/DesktopResolutionX()/1.5,
                                  WindowHeight(window_ID)/3,
                                  ImageWidth(image_ID)/DesktopResolutionX()/1.5,
                                  ImageHeight(image_ID)/DesktopResolutionY(), #PB_Canvas_Border)
  Else 
    ; Output on a ButtonImageGadget
    gadget_ID=ButtonImageGadget(#PB_Any,
                                WindowWidth(window_ID)/2-ImageWidth(image_ID)/2/DesktopResolutionX()/1.5,
                                WindowHeight(window_ID)/3,
                                ImageWidth(image_ID)/DesktopResolutionX()/1.5,
                                ImageHeight(image_ID)/DesktopResolutionY(), 0) 
  EndIf
  
  Procedure DrawScrollingTextSimple()
    SetGadgetAttribute(gadget_ID, #PB_Button_Image, ImageID(image_ID))
    ScrollTextImageSimple_ST(image_ID, 1) ; 1 = Step width
    ProcedureReturn 1
  EndProcedure
  
  #BindEventMethod=#False ; Try what you want - Win10 Mac and Linux works good with both on my machine
  
  If #BindEventMethod
    ; BindEvent method
    AddWindowTimer(window_ID, 1, 10/DesktopResolutionX()) ; Speed
    BindEvent(#PB_Event_Timer, @DrawScrollingTextSimple())
    Repeat
      Define win_event=WaitWindowEvent()   
    Until win_event=#PB_Event_CloseWindow
  Else
    ; Timer method
    Define time
    Repeat
      Delay(1)
      If ElapsedMilliseconds()>time
        time=ElapsedMilliseconds()+10 ; Speed
        DrawScrollingTextSimple()
      EndIf
      Repeat
        Define win_event=WindowEvent()
        If win_event=#PB_Event_CloseWindow 
          End
        EndIf
      Until Not win_event 
    ForEver 
  EndIf
  
CompilerEndIf
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 184
; FirstLine = 151
; Folding = --
; EnableXP
; DPIAware