﻿XIncludeFile("./ScrollingText_BF.pb")

UseModule ScrollingText_BF

; ###### Get the result ######

CompilerIf #PB_Compiler_IsMainFile
  EnableExplicit
  
  UsePNGImageDecoder()
  
  Define window_ID=OpenWindow(#PB_Any, 5 ,5 ,800 ,520 ,"Scrolling text BF" ,#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
  SetWindowColor(window_ID, $909090)
  
  Define font_ID=LoadFont(#PB_Any,"Tahoma", 24) ; TODO Used font size
  
  Define text_color=#Yellow
  Define background_color=#Blue
  
  Global button_up_ID=ButtonGadget(#PB_Any, 290, WindowHeight(window_ID)-150, 90, 30, "UP")
  Global button_down_ID=ButtonGadget(#PB_Any, 400, WindowHeight(window_ID)-150, 90, 30, "DOWN")
  
  ; ##### Init text image for vertical scrolling #####
  Define text_v$=#LF$+#LF$+"Hello World, this is scrolling text BF"+#LF$+"AAAAAAAAAAAAAAAAAA"+#LF$+"BBBBBBBBB"+#LF$+
                 "CCCCCCCCCCCC"+#LF$+"DDDDDDDD"+#LF$+"EEEEEEEEEEEEEEE"+#LF$+"FFFFFFFFFFFFFFFFF"+#LF$+"GGGGGGGGGGGGGG"+
                 #LF$+"HHHHHHHHHHHHHHHHHHHHHHHH"+#LF$+"IIIIIIIIIIIIIIIIIIIIIIIIIII"+#LF$+"JJJJJJJJJJJ  JJJJJJJJJJJJ"+#LF$+
                 "KKKKKK  KKKKKKKKKK  KKKKKK"+#LF$+"Have Fun"
  Global image_v_ID=CreateTextImage_ST(text_v$, font_ID, text_color, background_color)
  ; ##################################################
  
  ; #### Create text image for vertical scrolling ####
  GradientColor_Pos_ST(0.5, text_color) ; Output pos (0.0 to 1.0) for GradientColor and defined color 
  
  LinearGradient_ST(1,                            ; Activate LinearGradient = 1
                    0,                            ; LinearGradient_X
                    -ImageHeight(image_v_ID)*1.5, ; LinearGradient_Y
                    0,                            ; LinearGradient_XX
                    ImageHeight(image_v_ID)*2.3)  ; LinearGradient_YY
  FreeImage(image_v_ID)
  
  Define text_alignement=2 ; Text alignement 0=left - 1=right - 2=center - TODO Text alignment
  Global image_v_ID=CreateTextImage_ST(text_v$, font_ID, text_color, background_color, text_alignement)
  
  ; ##################################################
  
  Define image_1_ID=LoadImage(#PB_Any, "../GFX_Wizzard_BF/Image_Set/Foxy.png")
  Define image_2_ID=LoadImage(#PB_Any, "../GFX_Wizzard_BF/Image_Set/Chicken_1_Alpha/Chicken_1_Alpha1.png")
  Define image_3_ID=LoadImage(#PB_Any, "../GFX_Wizzard_BF/Image_Set/PureBasicLogo.bmp")
  
  If image_1_ID And image_2_ID And image_3_ID
    ResizeImage(image_1_ID, ImageWidth(image_v_ID)/5.5, ImageHeight(image_v_ID)/4)
    ResizeImage(image_2_ID, ImageWidth(image_v_ID)/3, ImageHeight(image_v_ID)/3.2)
    ResizeImage(image_3_ID, ImageWidth(image_v_ID)/4, ImageHeight(image_v_ID)/20)
    
    ; ### Image v output ###
    StartDrawing(ImageOutput(image_v_ID))
    DrawAlphaImage(ImageID(image_1_ID), ImageWidth(image_v_ID)/25, ImageHeight(image_v_ID)/3)
    DrawAlphaImage(ImageID(image_2_ID), ImageWidth(image_v_ID)/3, -30*ImageHeight(image_v_ID)/215)
    DrawAlphaImage(ImageID(image_3_ID), ImageWidth(image_v_ID)/1.37, ImageHeight(image_v_ID)/2.5)
    StopDrawing()
  EndIf
  
  Define amount_textlines_on_gadget=8
  
  Define speed_ms=3 ; Speed ms delay
  
  ; Output on CanvasGadget
  Global text_lines_v_amount=GetTextLinesAmount_ST()
  Global text_line_height=GetTextLineHeight_ST()
  
  Global gadget_1_ID=CanvasGadget(#PB_Any,
                                  WindowWidth(window_ID)/2-ImageWidth(image_v_ID)/2/DesktopResolutionX(),
                                  WindowHeight(window_ID)/15,
                                  ImageWidth(image_v_ID)/DesktopResolutionX(),
                                  text_line_height*amount_textlines_on_gadget/DesktopResolutionX()) 
  
  ; Scroll vertical up
  Procedure DrawScrollingImage_V_Up(step_width=1)
    ScrollTextImage_V_Up_ST(image_v_ID, step_width)
    SetGadgetAttribute(gadget_1_ID, #PB_Button_Image, ImageID(image_v_ID))
    ProcedureReturn step_width
  EndProcedure
  
  ; Scroll vertical down
  Procedure DrawScrollingImage_V_Down(step_width=1)
    ScrollTextImage_V_Down_ST(image_v_ID, step_width)
    SetGadgetAttribute(gadget_1_ID, #PB_Button_Image, ImageID(image_v_ID))
    ProcedureReturn step_width
  EndProcedure
  
  Global line_up, line_down, lines_scrolled_up, scrolled_lines, i, click
  
  SetGadgetAttribute(gadget_1_ID, #PB_Button_Image, ImageID(image_v_ID)) ; Firstly draw the image
  
  Procedure gadget_events()
    If EventGadget()=button_up_ID
      If scrolled_lines<text_line_height*(text_lines_v_amount)/text_Line_height-GadgetHeight(gadget_1_ID)/text_line_height*DesktopResolutionX()
        click=1
        scrolled_lines+1
        CompilerIf #PB_Compiler_OS=#PB_OS_Windows ; VectorLib Bug Workaround PB573
          line_up+(ImageHeight(image_v_ID)/text_lines_v_amount+1)
          If Not scrolled_lines%3 ; Correction factor
            ScrollTextImage_V_Down_ST(image_v_ID, 1)
          EndIf
        CompilerElse
          line_up+GetTextLineHeight_ST()
        CompilerEndIf
      EndIf
    EndIf
    
    If EventGadget()=button_down_ID
      If scrolled_lines>0
        click=1
        scrolled_lines-1
        CompilerIf #PB_Compiler_OS=#PB_OS_Windows ; VectorLib Bug Workaround PB573
          line_down=-(ImageHeight(image_v_ID)/text_lines_v_amount+1)
          If Not scrolled_lines%3 ; Correction factor
            ScrollTextImage_V_Up_ST(image_v_ID, 1)
          EndIf
        CompilerElse
          line_down=-GetTextLineHeight_ST() 
        CompilerEndIf
      EndIf
    EndIf
  EndProcedure
  
  BindEvent(#PB_Event_Gadget, @gadget_events())
  
  Repeat
    Delay(1)

    Repeat
      Define win_event=WindowEvent() 
      If win_event=#PB_Event_CloseWindow 
        End
      EndIf
    Until Not win_event 
    
    If GetScrollPosImage_V_ST()<-ImageHeight(image_v_ID)
      lines_scrolled_up-DrawScrollingImage_V_Down(1)*DesktopResolutionY()
    EndIf
    If click
      click=0
      For i=1 To text_Line_height
        Delay(speed_ms)
        If line_up>0
          lines_scrolled_up+DrawScrollingImage_V_Up(1)*DesktopResolutionY()
          line_up-1*DesktopResolutionY()
        EndIf
        
        If line_down<0 Or (scrolled_lines=0 And GetScrollPosImage_V_ST()<0)
          lines_scrolled_up-DrawScrollingImage_V_Down(1)*DesktopResolutionY()
          line_down+1*DesktopResolutionY()
        EndIf 
      Next
    EndIf
    
  ForEver 
  
CompilerEndIf
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 99
; FirstLine = 92
; Folding = --
; EnableXP
; DPIAware