﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create and scroll a isometric patterned background on a windowed screen - Method 1 - simple

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define i, ii, texture_ID, sprite_ID, sprite_1_ID, output_x, output_y
Define output_width=DesktopWidth_UserScaled_BF()*0.90, output_height=DesktopHeight_UserScaled_BF()*0.90
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Clouds.jpg")
Define texture_2_ID=CreateImage(#PB_Any, output_width, output_height)
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, output_width, output_height, "Scrolling Demo on windowed Screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, output_width, output_height) : End : EndIf ;  Create a windowed screen for output

Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  If IsSprite(sprite_ID) : FreeSprite(sprite_ID) : EndIf
  texture_ID=CreateImage(#PB_Any, Random(300, 20), Random(300, 20))
  sprite_ID=CreateSprite(#PB_Any, ImageWidth(texture_ID), ImageHeight(texture_ID))
  StartDrawing(ImageOutput(texture_ID))
  LineXY(0, 0, ImageWidth(texture_ID), ImageHeight(texture_ID), 1) ; Use not black, this is the pre defined transparent color
  LineXY(0, ImageHeight(texture_ID), ImageWidth(texture_ID), 0, 1)
  StopDrawing()
EndMacro
create_sprite

Macro draw_PB_sprites
  CopyContent_Image_PB_Sprite_BF(texture_ID, sprite_ID) ; Move the created and internal animated sprite to a hardware sprite for output
  For i=0 To output_width : For ii=0 To output_height
      DisplayTransparentSprite(sprite_ID, i, ii, 255) : ii+ImageHeight(texture_ID)-1
    Next
    i+ImageWidth(texture_ID)-1
  Next
EndMacro

ErrorCheck_BF(BF(1, texture_2_ID, texture_1_ID, -1, -1, output_x, output_y)) ; Create a background
sprite_1_ID=CreateSprite(#PB_Any, output_width, output_height)
CopyContent_BF(texture_2_ID, sprite_1_ID) ; Move the created and internal animated sprite to a hardware sprite for output

Repeat

  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(1, 3000) : create_sprite : EndIf
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    ErrorCheck_BF(BF(1, texture_ID, texture_ID, -1, -1, output_x, output_y)) ; Scroll the sprite
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(sprite_1_ID, 0, 0)
    draw_PB_sprites
    ; You can change simple the direction and moving speed, how ever you want
    ; output_x-2 : If output_x=<-ImageWidth(texture_ID) : output_x=0 : EndIf ; Moving direction left
    ; output_y-2 : If output_y=<-ImageHeight(texture_ID) : output_y=0 : EndIf ; Moving direction up
    output_x+2 : If output_x=>0: output_x=-ImageWidth(texture_ID) : EndIf ; Moving direction right
    output_y+2 : If output_y=>0: output_y=-ImageHeight(texture_ID) : EndIf; Moving direction down
  EndIf
  
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 40
; FirstLine = 24
; Folding = -
; EnableXP
; DisableDebugger