﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create, move and scroll over a moved textured background with Triple buffering

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define texture_0_ID, result, output_x, output_y, output_x_1, output_y_1, output_x_2, win_event
Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/Caisse.png")
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Clouds.jpg")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/Rose.jpg") : ResizeImage(texture_2_ID, 150, 120)

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 700, 500, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_ID=CanvasGadget(#PB_Any, 50, 50, 600, 400) ; Create a canvas for output
Define image_ID=CreateImage(#PB_Any, 600, 400)
Define alpha.f=256

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

output_x_2=GadgetWidth(canvas_ID)

SetColorDistanceSpriteMask_BF(15) ; Set color distance for all functions with sprite output - This function influence ALL used textures
                                  ; Only with this BF function it is available for usig jpg images as masked sprites :-)

Repeat
  Delay(1)
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function
    
    ; Scroll and duplicate the sprite up to output max
    result=BF(1, Get_animation_buffer_background_image_ID_BF(0), texture_1_ID, -1, -1, output_x_1, output_y_1)
    ErrorCheck_BF(result)
    
    ; Output a masked sprite
    result=BF(alpha, Get_animation_buffer_background_image_ID_BF(0), texture_2_ID, 0, 0, 230 , 230, ImageWidth(texture_2_ID), ImageHeight(texture_2_ID))
    ErrorCheck_BF(result)
    
    output_x+1 : If output_x>0 : output_x=-ImageWidth(texture_0_ID) : EndIf
    output_y-1 : If output_y<-ImageHeight(texture_0_ID) : output_y=0 : EndIf
    output_x_1-1 : If output_x_1<-ImageWidth(texture_1_ID) : output_x_1=0 : EndIf
    output_y_1-1 : If output_y_1<-ImageHeight(texture_1_ID) : output_y_1=0 : EndIf
    output_x_2-1 : If output_x_2<-ImageWidth(texture_0_ID) : output_x_2=GadgetWidth(canvas_ID) : EndIf
    alpha-0.3 : If alpha<1 : alpha=1 : EndIf
    
    ; Scroll and duplicate the sprite up to output max
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_0_ID, -1, -1, output_x, 150, 0, ImageHeight(texture_0_ID))
    ErrorCheck_BF(result)
    
    ; Move a sprite
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_0_ID, -1, -1, output_x_2, 50, ImageWidth(texture_0_ID), ImageHeight(texture_0_ID))
    ErrorCheck_BF(result)
    
    StartDrawing(ImageOutput(Get_animation_buffer_background_image_ID_BF(0))) ; Draw in the background animation buffer
    Box(490, 130, 100 , 100, $FF)
    StopDrawing()
    
    StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(0))) ; Draw in the hidden animation buffer
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    Box(490, 130, 100, 100, RGBA(255, 0, 0, alpha))
    StopDrawing()
    
    ; Get the result
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas 
  EndIf
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabbed textures
      End
    EndIf
  Until Not win_event
  
ForEver
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 77
; FirstLine = 43
; Folding = -
; EnableXP
; DisableDebugger