﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create, move and scroll over a moved textured background with Triple buffering - Two canvas outputs

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define texture_0_ID, result, output_x, output_y, output_x_1, output_y_1, output_x_2, win_event
Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/Caisse.png")
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Clouds.jpg")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/Rose.jpg") : ResizeImage(texture_2_ID, 150, 120)

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 950, 500, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_0_ID=CanvasGadget(#PB_Any, 50, 50, 400, 400) ; Create a canvas for output
Define canvas_1_ID=CanvasGadget(#PB_Any, 500, 50, 400, 400); Create a canvas for output

Define image_ID=CreateImage(#PB_Any, 400, 400)
Define alpha.f=256

#Canvas_0=0 ; Canvas left
#Canvas_1=1 ; Canvas right

Create_animation_buffers_BF(canvas_0_ID, #Canvas_0) ; Init animation buffers - triple buffering - Flicker free animation
Create_animation_buffers_BF(canvas_1_ID, #Canvas_1) ; Init animation buffers - triple buffering - Flicker free animation

output_x_2=GadgetWidth(canvas_0_ID)

SetColorDistanceSpriteMask_BF(15) ; Set color distance for all functions with sprite output - This function influence ALL used textures
                                  ; Only with this BF function it is available for usig jpg images as masked sprites :-)

Repeat
  Delay(1)
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    
    FlipBuffers_BF(#Canvas_0) ; This works similar the PB FlipBuffers function - Initializing triple buffering for canvas #0
    FlipBuffers_BF(#Canvas_1) ; This works similar the PB FlipBuffers function - Initializing triple buffering for canvas #1
    
    ; Scroll and duplicate the sprite up to output max
    result=BF(1, Get_animation_buffer_background_image_ID_BF(#Canvas_0), texture_1_ID, -1, -1, output_x_1, output_y_1)
    ErrorCheck_BF(result)
    result=BF(1, Get_animation_buffer_background_image_ID_BF(#Canvas_1), texture_1_ID, -1, -1, output_x_1, output_y_1)
    ErrorCheck_BF(result)
    
    ; Output a masked sprite
    result=BF(alpha, Get_animation_buffer_background_image_ID_BF(#Canvas_0), texture_2_ID, 0, 0, 130 , 230, ImageWidth(texture_2_ID), ImageHeight(texture_2_ID))
    ErrorCheck_BF(result)
    result=BF(alpha, Get_animation_buffer_background_image_ID_BF(#Canvas_1), texture_2_ID, 0, 0, 180 , 180, ImageWidth(texture_2_ID), ImageHeight(texture_2_ID))
    ErrorCheck_BF(result)
    
    output_x+1 : If output_x>0 : output_x=-ImageWidth(texture_0_ID) : EndIf
    output_y-1 : If output_y<-ImageHeight(texture_0_ID) : output_y=0 : EndIf
    output_x_1-1 : If output_x_1<-ImageWidth(texture_1_ID) : output_x_1=0 : EndIf
    output_y_1-1 : If output_y_1<-ImageHeight(texture_1_ID) : output_y_1=0 : EndIf
    output_x_2-1 : If output_x_2<-ImageWidth(texture_0_ID) : output_x_2=GadgetWidth(canvas_0_ID) : EndIf
    alpha-0.3 : If alpha<1 : alpha=1 : EndIf
    
    ; Scroll and duplicate the sprite up to output max
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(#Canvas_0), texture_0_ID, -1, -1, output_x, 150, 0, ImageHeight(texture_0_ID))
    ErrorCheck_BF(result)
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(#Canvas_1), texture_0_ID, -1, -1, output_x, 50, 0, ImageHeight(texture_0_ID))
    ErrorCheck_BF(result)
    
    ; Move a sprite
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(#Canvas_0), texture_0_ID, -1, -1, output_x_2, 50, ImageWidth(texture_0_ID), ImageHeight(texture_0_ID))
    ErrorCheck_BF(result)
    result=BF(1, Get_animation_buffer_hidden_image_ID_BF(#Canvas_1), texture_0_ID, -1, -1, output_x_2, 150, ImageWidth(texture_0_ID), ImageHeight(texture_0_ID))
    ErrorCheck_BF(result)
    
    StartDrawing(ImageOutput(Get_animation_buffer_background_image_ID_BF(#Canvas_0))) ; Draw in the background animation buffer
    Box(290, 130, 100 , 100, $FF)
    StopDrawing()
    
    StartDrawing(ImageOutput(Get_animation_buffer_background_image_ID_BF(#Canvas_1))) ; Draw in the background animation buffer
    Box(10, 130, 100 , 100, $FFFF)
    StopDrawing()
    
    StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(#Canvas_0))) ; Draw in the hidden animation buffer
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    Box(290, 130, 100, 100, RGBA(255, 0, 0, alpha))
    StopDrawing()
    
    ; Get the result
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(#Canvas_0), canvas_0_ID) ; Put the hidden animation buffer in the canvas
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(#Canvas_1), canvas_1_ID) ; Put the hidden animation buffer in the canvas
    
  EndIf
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(#Canvas_0) ; Free animation buffers
      Free_animation_buffers_BF(#Canvas_1) ; Free animation buffers
      FreeTextures_BF()                    ; Free grabbed textures
      End
    EndIf
  Until Not win_event
  
ForEver
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 99
; FirstLine = 65
; Folding = -
; EnableXP
; DisableDebugger