﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

;- Rotating and scrolling demo - Rotate and scroll sprites and images - Triple buffering demo

EnableExplicit
CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_0, canvas_ID, window_ID, texture_ID, result, output_x, output_y, win_event
Define resize_0, resize_1, resize_2, resize_3
Define canvas_x, canvas_y, canvas_width, canvas_height

; Presets
canvas_x=50
canvas_y=50
canvas_width=600
canvas_height=400

window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, canvas_width+100, canvas_height+100, "GFX_WIzzard_BF - Rotating and scrolling",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
canvas_ID=CanvasGadget(#PB_Any, canvas_x, canvas_y, canvas_width, canvas_height) ; Create a canvas for output

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/ogrelogo-small.jpg") : ResizeImage(texture_1_ID, 200, 120) ; Load a sprite

texture_ID=CreateImage(#PB_Any, 1, 1) ; Create a buffer image

Define image_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg") ; Load a texture for background creating

CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  Define font_1_ID=LoadFont(1, "Arial", 11)
CompilerEndIf

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

StartDrawing(ImageOutput(Get_animation_buffer_background_image_ID_BF(0)))
DrawingMode(#PB_2DDrawing_Transparent)
CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  DrawingFont(font_1_ID)
CompilerEndIf
DrawText(20, 5, "A VERY COOL FUNCTION", -1)
DrawText(20, 25, "GFX WIZZARD BF", -1)
DrawText(20, 45, "WITH FLOOD FILL FUNCTION", -1)
DrawText(20, 65, "www.quick-aes-256.de", -1)
DrawText(20, 85, "www.nachtoptik.de", -1)
StopDrawing()

Define mode=1                    ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets - Do not make offsets too big - Bigger = slower
                                 ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                 ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
Define image_get_color_x=-1      ; Grab transparence color from sprite pos x - For preset set ..x=-1 - For ignore set ..x=-2
Define image_get_color_y=$FFFFFF ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
Define output_pos_x=-50          ; Output pos x
Define output_pos_y=-80          ; Output pos y
Define arc                       ; Rotating degree
Define alpha=256                 ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
Define output_width=200          ; You can here resize the output x
Define output_height=140         ; You can here resize the output y
Define rotating_offset_x=60      ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
Define rotating_offset_y=0       ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50

SetColorDistanceSpriteMask_BF(30)

NoCaching_BF(1) ; Rotating sprite change immediately the used texture, for significant speed up you can here deactivate the BF texture cache

ActivateSpriteArray_BF(2) ; Activate getting sprite coordinates for drawing a white frame

; - Call function #1 -
result=BF(-2, Get_animation_buffer_background_image_ID_BF(0), image_ID) ; Create a textured background
ErrorCheck_BF(result) 

Repeat
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabed textures
      End
    EndIf
  Until Not win_event

If Delay_BF(0, 25) ; Timer 0 - 100 timer available 0 - 99 - you can change
  
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    ResizeImage(texture_ID, ImageWidth(texture_1_ID)+resize_2, ImageHeight(texture_1_ID)+resize_2) ; Resize the output
    
    ; - Call function #2 -
    result=BF(1, texture_ID, texture_1_ID, -1, -1, output_x, output_y) ; Scroll and duplicate the sprite up to output max
    ErrorCheck_BF(result)
    
    result=RotateSprite_simple_BF(mode, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID,
                                  image_get_color_x,      ; Grab transparence color from sprite pos x - For preset set ..x=-1 - For ignore set ..x=-2
                                  image_get_color_y,      ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                                  output_pos_x,           ; Output pos x
                                  output_pos_y,           ; Output pos y
                                  arc,                    ; Rotating degree
                                  alpha,                  ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  output_width+resize_0,  ; You can here resize the output x
                                  output_height+resize_0, ; You can here resize the output y
                                  rotating_offset_x,      ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
                                  rotating_offset_y)      ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50   
                                                          ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets - Do not make offsets too big - Bigger = slower
                                                          ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                                          ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                                          ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                                          ; So you can also simple create masked rotated sprites from all images without mask
                                                          ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                                          ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                                          ; Reduce for Images SetColorDistanceSpriteMask_BF or you can become "holes", but also nice effects
    ErrorCheck_BF(result)
    
    ; Get the sprite position and make a white frame
    If resize_2>200 And resize_2<500 ; Get the sprite position and make a white frame
      If StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(0))) ; Write directly in the hidden animation buffer, very cool :)
        DrawingMode(#PB_2DDrawing_Outlined)
        Box(GetSprite_X_BF(), GetSprite_Y_BF(), GetSprite_XX_BF()-GetSprite_X_BF()+1, GetSprite_YY_BF()-GetSprite_Y_BF()+1)
        DrawingMode (#PB_2DDrawing_Transparent)
        DrawText(GetSprite_X_BF(), GetSprite_y_BF()-20, "Localize the Sprite")
      EndIf
    EndIf
    StopDrawing()
    
    If resize_2>200 And resize_2<500 : SetColorDistanceSpriteMask_BF(30) : Else : SetColorDistanceSpriteMask_BF(2) : EndIf
    output_x-5 : If output_x<-ImageWidth(texture_1_ID) : output_x=0 : EndIf
    output_y-1 : If output_y<-ImageHeight(texture_1_ID) : output_y=0 : EndIf
    arc+1 : If arc>359 : arc=0 : EndIf ; Rotate
    resize_0+resize_1 : If resize_0>80 : resize_1=-1 : EndIf : If resize_0=0 :resize_1=1 : EndIf ; Resizing the output
    resize_2+resize_3 : If resize_2>700 : resize_3=-1 : EndIf : If resize_2=0 :resize_3=2 : EndIf
    alpha-1 : If alpha<0 : alpha=0 : EndIf
    
  EndIf
  
  ; Get the result
  CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 3
; Folding = -
; EnableXP
; DisableDebugger