﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling and text demo - Create and scroll texture inside text - simple

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define texture_ID, output_x, output_y,  output_x_1, output_y_1, image_ID, arc, alpha, win_event
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 900, 700, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_ID=CanvasGadget(#PB_Any, 10, 10, 880, 680) ; Create a canvas for output
Define mode, stretch_x, stretch_y, result, font_ID, txt$
Define f_col=#Black, b_col=$13458B
Define flag=1
Define txt_x=150, txt_y=100 

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")
Define texture_3_ID=LoadImage(#PB_Any, "./Image_Set/Background.bmp")

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : result=190 : CompilerElse : result=150 : CompilerEndIf
font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)

txt$="Hello"+#LF$+"World"

Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  texture_ID=DrawTextCreateImage_BF(txt$, f_col, b_col, 1, 0, font_ID, stretch_x, stretch_y)
  ErrorCheck_BF(BF(-2, texture_ID, texture_1_ID, -1, -1, output_x, output_y )) ; Create texture
  ErrorCheck_BF(BF(-2, texture_ID, texture_2_ID, -1, -1, output_x_1, output_y_1 )) ; Create texture
EndMacro

SetColorDistanceFill_BF(20)

SetColorDistanceSpriteMask_BF(5)

SetColor_BF(#Black)

NoCaching_BF(1)

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

alpha=256

Repeat
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    
    ErrorCheck_BF(BF(1, Get_animation_buffer_background_image_ID_BF(0), texture_3_ID, -1, -1, output_x_1, output_y_1)) ; Make background
    create_sprite
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    result=RotateSprite_simple_BF(2, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID,                              
                                  0,     ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color                     
                                  0,     ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF     
                                  130,   ; Output pos x
                                  0,     ; Output pos y
                                  arc,   ; Rotating degree
                                  alpha, ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  500,   ; You can here resize the output x
                                  1+arc, ; You can here resize the output y
                                  0,     ; ImageWidth(texture_ID)>>1, ; Rotating offset x - For mode 1 - Handle with care - Do not make offsets too big - I will give you not a limit
                                  0)     ; ImageHeight(texture_ID)>>1) ; Rotating offset y - You can also set negative values - As sample x=50 - y=-50   
                                         ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets - Do not make offsets too big - Bigger = slower
                                         ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                         ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                         ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                         ; So you can also simple create masked rotated sprites from all images without mask
                                         ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                         ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                         ; Reduce for Images SetColorDistanceSpriteMask_BF or you can become "holes", but also nice effects    
    
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
    
    ; You can change simple the direction and moving speed, how ever you want
    output_x-1 : If output_x<-ImageWidth(texture_1_ID) : output_x=0 : EndIf  ; Moving direction left
    output_y-1 : If output_y<-ImageHeight(texture_1_ID) : output_y=0 : EndIf ; Moving direction up
    
    output_x_1+1 : If output_x_1>0: output_x_1=-ImageWidth(texture_2_ID) : EndIf ; Moving direction right
    output_y_1+1 : If output_y_1>0: output_y_1=-ImageHeight(texture_2_ID) : EndIf; Moving direction down
    
    arc=(arc+1)%360
    alpha-1 : If alpha <1 : alpha=1 : EndIf
    If arc>358 : alpha=256 : EndIf
    
  EndIf
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : FreeTextures_BF() : End : EndIf
  Until Not win_event
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 18
; Folding = -
; EnableXP
; DisableDebugger