﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling and text demo - Create and scroll texture inside text - BF function output directly on a windowed screen - simple
; Use a Image with alpha channel or a GIF frame with invisible color as BF sprite - Make tilling and scroll it - Direct access

EnableExplicit
CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define texture_ID, output_x, output_y
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 900, 700, "Scrolling Demo - BF direct access on a windowed screen",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

Define result, font_ID, txt$

OpenWindowedScreen(WindowID(window_ID), 10, 10, 880, 680)

Define sprite_1_ID=CreateSprite(#PB_Any, 880, 680)

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")
Define texture_3_ID=LoadImage(#PB_Any, "./Image_Set/Lion.jpg")
ResizeImage(texture_3_ID, 250, 180)

ErrorCheck_BF(BF(-2, sprite_1_ID, texture_2_ID)) ; Make a tilled background PB sprite

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : result=190 : CompilerElse : result=150 : CompilerEndIf
font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)

txt$="BF"+#LF$+"Screen"+#LF$+"Sprite"

Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  
  texture_ID=DrawTextCreateImage_BF(txt$, #Black, #White, 1, 0, font_ID, 0, -40, 10) ; Create a text image
  
  ErrorCheck_BF(BF(-2, texture_ID, texture_1_ID, -1, -1, output_x, output_y)) ; Create a textured PB sprite text
  
  SetColorDistanceSpriteMask_BF(72) ; Eliminate the artifacts in the text sprite mask
  
 ErrorCheck_BF(ScreenSprite_BF(texture_ID, ; Specialfunction for BF sprite output directly on windowed screen - SpritecolorDistance_BF is available
                               0,          ; Grab transparence color from sprite pos x (-1 = ignore the mask)
                               0,          ; Grab transparence color from sprite pos y (-1 = ignore the mask)
                               100,        ; Startposition texture output x - Preset 0
                               30,         ; Startposition texture output y - Preset 0
                               ImageWidth(texture_ID),  ; Endposition texture output - Preset 0 = Clipping is automatic To canvas width 
                               ImageHeight(texture_ID))); Endposition texture output - Preset 0 = Clipping is automatic To canvas height
 
  SetInvisibleColor_BF(-1)
  
  
EndMacro

NoCaching_BF(1) ; This is needed, or you can get not a animation inside the text

Repeat
  
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    
    ; Get the result
    DisplaySprite(sprite_1_ID, 0, 0)
    
    Define x : x-1 : If x<-ImageWidth(texture_3_ID) : x=0 : EndIf
    Define y : y-1 : If y<-ImageHeight(texture_3_ID) : y=0 : EndIf
    
    SetColorDistanceSpriteMask_BF(36) ; Eliminate the artifacts in the text sprite mask - For GIF not needed
    
    ErrorCheck_BF(ScreenSprite_BF(texture_3_ID, ; Specialfunction for BF sprite output directly on windowed screen - SpritecolorDistance_BF is available
                                  0,            ; Grab transparence color from sprite pos x (-1 = ignore the mask)
                                  0,            ; Grab transparence color from sprite pos y (-1 = ignore the mask)                  
                                  x,            ; Startposition texture output x - Preset 0
                                  y,            ; Startposition texture output y - Preset 0
                                  0,            ; Endposition texture output - Preset 0 = Clipping is automatic To canvas width 
                                  0,            ; Endposition texture output - Preset 0 = Clipping is automatic To canvas height 
                                  0,            ; Startposition inside the texture x - Preset 0
                                  0,            ; Startposition inside the texture y - Preset 0
                                  0,            ; Endposition inside the texture - Preset 0 = full texture width
                                  0))           ; Endposition inside the texture - Preset 0 = full texture height
                                                ; This function can handle sprite mask cleaning with the function SetColorDistanceSpriteMask_BF 
    
    create_sprite
    
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    
    ; You can change simple the direction and moving speed, how ever you want
    ; output_x-1 : If output_x<-ImageWidth(texture_1_ID) : output_x=0 : EndIf  ; Moving direction left
    ; output_y-1 : If output_y<-ImageHeight(texture_1_ID) : output_y=0 : EndIf ; Moving direction up
    
    output_x+1 : If output_x>0: output_x=-ImageWidth(texture_1_ID) : EndIf ; Moving direction right
    output_y+1 : If output_y>0: output_y=-ImageHeight(texture_1_ID) : EndIf; Moving direction down
  EndIf

ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 3
; Folding = -
; EnableXP
; DisableDebugger