﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling and text demo - Create and scroll texture inside text - BF function output directly on a windowed screen - High quality
; Use a Image with alpha channel or a GIF frame with invisible color as BF sprite - Make tilling and scroll it 
; This code create a BF sprite from a image with alpha channel or a GIF with invisible color

EnableExplicit
CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define texture_ID, output_x, output_y, x, y
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 900, 700, "Scrolling Demo - BF direct access on a windowed screen",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

Define result, font_ID, txt$

OpenWindowedScreen(WindowID(window_ID), 10, 10, 880, 680)

Define sprite_1_ID=CreateSprite(#PB_Any, 880, 680)

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")
Define texture_3_ID=LoadImage(#PB_Any, "./Image_Set/Penguin.png")
Define texture_4_ID=LoadImage(#PB_Any, "./Image_Set/Penguin.jpg")
Define texture_5_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")
ResizeImage(texture_3_ID, 170, 170)

ErrorCheck_BF(BF(-2, sprite_1_ID, texture_2_ID)) ; Make a tilled background PB sprite

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : result=190 : CompilerElse : result=150 : CompilerEndIf
font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)

txt$="BF"

Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  
  texture_ID=DrawTextCreateImage_BF(txt$, #Black, #White, 1, 0, font_ID, 0, -60, 10) ; Create a text image
  
  ErrorCheck_BF(BF(-2, texture_ID, texture_1_ID, -1, -1, output_x, output_y)) ; Create a textured PB sprite text
  
  SetColorDistanceSpriteMask_BF(72) ; Eliminate the artifacts in the text sprite mask
  
  ErrorCheck_BF(ScreenSprite_BF(texture_ID, ; Specialfunction for BF sprite output directly on windowed screen - SpritecolorDistance_BF is available
                                0,          ; Grab transparence color from sprite pos x (-1 = ignore the mask)
                                0,          ; Grab transparence color from sprite pos y (-1 = ignore the mask)
                                280,        ; Startposition texture output x - Preset 0
                                30,         ; Startposition texture output y - Preset 0
                                ImageWidth(texture_ID),  ; Endposition texture output - Preset 0 = Clipping is automatic To canvas width 
                                ImageHeight(texture_ID))); Endposition texture output - Preset 0 = Clipping is automatic To canvas height 
  
  SetColorDistanceSpriteMask_BF(0) ; Disable color distance
  
EndMacro

NoCaching_BF(1) ; This is needed, or you can get not a animation inside the text

; Manual mask color generating - Color distance influence the mask
Define mask_color=$FF00 ; Set a color for the sprite mask - different from the picture content

; Automatik mask color generating - Color distance influence the mask - Recommended for GIF
; mask_color=SearchUnusedColor_BF(image_ID, 0, 0, ImageWidth(image_ID)-1, ImageHeight(image_ID)-1)
; If mask_color<1 : mask_color=Random($FFFFFE, 1) : EndIf ; Fuse - Error handling for automatic mask color generating

Define percent_color_distance=0 ; You can set a color distance for the background color in percent
Define temporary_image_ID, temporary_image_1_ID, sprite_ID, degree, delete_old_image=1

texture_3_ID=CreateSprite_from_AlphaImage_BF(texture_3_ID, mask_color, percent_color_distance, delete_old_image) ; Create BF sprite and delete the old image
ErrorCheck_BF(texture_3_ID)

Define sprite_width=30
Define sprite_height=30

Define invisible_color=GetImageColor_BF(texture_5_ID, 0, 0) ; Get mask (invisible) color for PB sprite output
                                                            ; SetColorDistanceFill_BF(10)                                 ; Clear sprite mask
                                                            ; ErrorCheck_BF(BF(-1, texture_5_ID, invisible_color))        ; Clear sprite mask

Repeat
  
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 30) ; Timer 0 - 100 timer available 0 - 99 - you can change
    
    ; Get the result
    DisplaySprite(sprite_1_ID, 0, 0)
    
    If sprite_width<100 : sprite_width+1 : EndIf
    sprite_height=sprite_width
    Define x : x-1 : If x<-sprite_width : x=0 : EndIf
    Define y : y-1 : If y<-sprite_height : y=0 : EndIf
    
    degree=(degree+1)%359+1
    
    temporary_image_ID=RotateSprite_BF(texture_3_ID,
                                       0,                       
                                       0,                 
                                       degree,
                                       0,
                                       0,
                                       0,
                                       1) 
    
    ActivateScreenOutput_BF(1) ; Activate the BF core screen output
    
    SetColorDistanceSpriteMask_BF(30) ; Eliminate the artifacts in the text sprite mask
    
    SpriteSimple_BF(1, 0, temporary_image_ID,
                    0,                            ; Grab transparence color from sprite pos x -   to -1 ignore the mask
                    0,                            ; Grab transparence color from sprite pos y
                    x,                            ; Output pos x
                    y,                            ; Output pos y
                    sprite_width,                 ; You can here resize the output x
                    sprite_height,                ; You can here resize the output y
                    1,                            ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                    ScreenWidth()+sprite_width,   ; Endposition texture output - Preset 0 = Clipping is automatic to input width
                    ScreenHeight()+sprite_height, ; Endposition texture output - Preset 0 = Clipping is automatic to input height
                    0,                            ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                    0,                            ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                    0,                            ; Endposition inside the texture   - Preset 0 = full texture width
                    0)                            ; Endposition inside the texture   - Preset 0 = full texture height
                                                  ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                  ; For using pictures with alpha channel use mode=2
                                                  ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                  ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                  ; Resizing can change the colors a little,
                                                  ; so it is available a presetted invisible color works after resizing not longer correct    
    
    SetColorDistanceSpriteMask_BF(30) ; Eliminate the artifacts in the text sprite mask
    
    RotateSprite_simple_BF(3, 0, texture_3_ID,                              
                           0,      ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                           0,      ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                           10,     ; Output pos x
                           20,     ; Output pos y
                           degree, ; Rotating degree - On demand
                           1,      ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                           170,    ; You can here resize the output x - On demand
                           170,    ; You can here resize the output y - On demand
                           0,      ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                           0)      ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                   ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                   ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                   ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                   ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                   ; So you can also simple create masked rotated sprites from all images without a included mask
                                   ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                   ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                   ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects   
    
    SetColorDistanceSpriteMask_BF(0) ; Disable again
    
    SetInvisibleColor_BF(-2) ; Ignore invisible color     
    RotateSprite_simple_BF(2, 0, texture_4_ID,                              
                           0,      ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                           0,      ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                           640,    ; Output pos x
                           -20,    ; Output pos y
                           degree, ; Rotating degree - On demand
                           1,      ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                           170,    ; You can here resize the output x - On demand
                           170,    ; You can here resize the output y - On demand
                           0,      ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                           0)      ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                   ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                   ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                   ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                   ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                   ; So you can also simple create masked rotated sprites from all images without a included mask
                                   ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                   ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                   ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects   
    SetInvisibleColor_BF(-1)       ; Deactivate the function
    
    ActivateScreenOutput_BF(0) ; Deactivate the BF core screen output
    
    If IsSprite(sprite_ID) : FreeSprite(sprite_ID) : EndIf
    
    sprite_ID=CreateSprite_simple_BF(1, texture_5_ID,
                                         0,      ; Grab transparence color from input pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                                         0,      ; Grab transparence color from input pos y - For preset set ..y= the color you want - as sample $FF00FF
                                         degree, ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                         1,      ; mode=0 deactivate rotating - mode=1 create a exactely resized sprite with minimized mask - mode=2 create a quadratic sprite for on demand rotation
                                         400,    ; You can here resize the output x - On demand
                                         400,    ; You can here resize the output y - On demand
                                         0,      ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
                                         0,      ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                         30,     ; Color distance sprite mask - Mask cleaning - Important                                  
                                         0,      ; Delete the input 
                                         0,      ; Mirroring - 0=without - 1=horizontal - 2=vertical - 3=horizontal and vertical
                                         0)      ; Flags for CreateSprite - same PB function call
                                                 ; The function accepts as input a image, a PB sprite or a canvas (ID)
    
    create_sprite
    
    TransparentSpriteColor(sprite_ID, invisible_color) ; Set the invisible color for the PB sprite output
    DisplayTransparentSprite(sprite_ID, 140, 150, 180)
    FreeImage(temporary_image_ID)
    
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    
    ; You can change simple the direction and moving speed, how ever you want
    ; output_x-1 : If output_x<-ImageWidth(texture_2_ID) : output_x=0 : EndIf  ; Moving direction left
    ; output_y-1 : If output_y<-ImageHeight(texture_2_ID) : output_y=0 : EndIf ; Moving direction up
    
    output_x+1 : If output_x>0: output_x=-ImageWidth(texture_2_ID) : EndIf ; Moving direction right
    output_y+1 : If output_y>0: output_y=-ImageHeight(texture_2_ID) : EndIf; Moving direction down
  EndIf

ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 213
; FirstLine = 184
; Folding = -
; EnableXP
; DisableDebugger