﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Use a CSS Alpha Channel sprite sheet

; This function is created for simple using sheets with a symmetric frame arrangement
; As sample, for sheets created with the BF sheet creating tool for GIF pictures 
; For all other sheets use the method demonstrated in the demo code for RAW handling sprite sheets

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_ID, image_ID, texture_ID, background_ID, output_ID
Define image_width, image_height, frame, delay
Define path$, path_1$

#Background="./Image_Set/Background.bmp"
#Sheet="./Image_Set/Chicken_1_Alpha.png"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #Background)

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  Define font_1=LoadFont(1, "Arial", 11)
CompilerEndIf

; - Call function #1 -
path$=#Background
texture_ID=LoadImage(#PB_Any, path$)

ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background

Define alpha=255 ; Here you can set alpha blending - BF set 255 for full visible, 0 for full transparence

path_1$=#Sheet
texture_ID=LoadImage(#PB_Any, path_1$)

GetFrameData_fromSheet_BF(path_1$) ; Get all frame date from the sheet and use the BF frame variables

Define frame_width=GetGIFandCSS_Frame_width_BF() ; Frame width
Define frame_height=GetGIFandCSS_Frame_height_BF() ; Frame height

Define frames=GetGIFandCSS_Frames_BF() ; Count frames in the sheet

Define output_pos_x=10 ; Animation start point
Define output_pos_y=250

Define output_width=0  ; Output width  - For original frame width set width = 0
Define output_height=0 ; Output height - For original frame height set height = 0

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0

Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture width

CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  Define font_1=LoadFont(1, "Arial", 11)
CompilerEndIf

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID)) ; Create a canvas for output the result

HideWindow(window_ID, 0)

Repeat
  Delay(1)
  
  If WindowEvent()=#PB_Event_CloseWindow
    Break
  EndIf
  
  output_ID=Sprite_CSS_sheet_grab_frame_BF(texture_ID,
                                           frames,
                                           frame,
                                           frame_width,
                                           frame_height,
                                           0,
                                           output_width,
                                           output_height,
                                           texture_clip_x,
                                           texture_clip_y,
                                           texture_clip_width,
                                           texture_clip_height)
  
  If delay : delay=0 : frame+1 : EndIf : If frame=>frames : frame=0 : Else : delay+Delay_BF(1, GetGIFandCSS_delay_array_BF(frame)) : EndIf
  
  ; Get the result
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(background_ID), 0, 0)
  DrawAlphaImage(ImageID(output_ID), 100, 0, alpha)
  StopDrawing()
  
  FreeImage(output_ID)
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; DisableDebugger