﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester("Hint" , "PureBasic Version =>560 needed for this Code")
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  DeclareModule SpriteTool_BF
    Declare SpriteTool_BF(path$="")
  EndDeclareModule
  
  Module SpriteTool_BF
    
    UseModule GFX_Wizzard_BF
    
    ; GIF - Image - Sprite & coloring Wizzard
    
    ; With this tool you can solve many problems with GIF and sprites
    
    ; Many abilities
    
    ; Fitted for Image_coloring_BF and Image_coloring_partition_BF
    
    ; The tool can coloring GiF frames - CSS sprite sheets and images
    ; Can create CSS sprite sheets with included frame Data and delays
    ; Can load sheet info files for changing the sheet delays
    ; Can clean sprite masks
    ; Can handling color distance
    ; Can change the GIF invisible color
    ; Can grab the invisible color directly from the visible animation
    ; Can generate CSS sprite sheets from GIF
    ; On demand GIF and CSS sprite sheet animation
    ; And more ...
    ; Author W. Albus (C)
    ; GFX_Wizzard_BF is needed
    
    EnableExplicit
    
    If  Not ExamineDesktops()
      MessageRequester("Error", "Cannot initialize the tool")
      End
    EndIf
    
    CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
    
    Global partition_x.f
    Global partition_y.f
    Global partition_width.f
    Global partition_height.f
    Global swap_partition=0
    Global change_red.f
    Global change_green.f
    Global change_blue.f
    Global change_contrast.f
    Global change_brightness.f
    Global change_intensity.f
    Global mode_grey
    Global image
    Global window_2_ID, temporary_frame_ID, color_distance_sprite_mask, sprite_mode, old_frames
    
    Macro common_write_frame_data
      WriteStringN(file, "          Frames #"+RSet(Str(GetGIFandCSS_frames_BF()), 8, "0 "), #PB_Ascii)
      WriteStringN(file, "     Frame width #"+RSet(Str(GetGIFandCSS_Frame_width_BF()), 8, "0 "), #PB_Ascii)
      WriteStringN(file, "    Frame height #"+RSet(Str(GetGIFandCSS_Frame_height_BF()), 8, "0 "), #PB_Ascii)
      WriteStringN(file, "     Sheet width #"+RSet(Str(GetCSS_width_BF()), 8, "0 "), #PB_Ascii)
      WriteStringN(file, "    Sheet height #"+RSet(Str(GetCSS_height_BF()), 8, "0 "), #PB_Ascii)
      WriteStringN(file, " Frames in a row #"+RSet(Str(GetFrames_in_a_row_BF()), 8, "0 "), #PB_Ascii)
      If GetGIFandCSS_invisible_color_BF()<0
        WriteStringN(file, " Invisible color #"+RSet(Str(GetGIFandCSS_invisible_color_BF()), 8, "  ")+"   $"+RSet(Hex(GetGIFandCSS_invisible_color_BF()), 6, "  "), #PB_Ascii) ; Negative value available "  "
      Else
        WriteStringN(file, " Invisible color #"+RSet(Str(GetGIFandCSS_invisible_color_BF()), 8, "0 ")+"   $"+RSet(Hex(GetGIFandCSS_invisible_color_BF()), 6, "0 "), #PB_Ascii)
      EndIf
      WriteStringN(file, "  Color distance #"+RSet(Str(GetGIFandCSS_color_distance_BF()), 8, "0 ")+"   $"+RSet(Hex(GetGIFandCSS_color_distance_BF()), 6, "0 "), #PB_Ascii)
      ii=1
      For i=0 To old_frames-1
        If GetGIFandCSS_delay_array_BF(i)
          result=WriteStringN(file, "   Frame / delay :"+RSet(Str(ii), 8, "0 ")+" *"+RSet(Str(GetGIFandCSS_delay_array_BF(i)), 8, "0"), #PB_Ascii)
          ii+1
        EndIf
      Next i
    EndMacro
    
    Procedure CreateDataFile(mode, path$, image_type$)
      Macro write_delays
        For i=0 To old_frames-1
          If GetGIFandCSS_delay_array_BF(i)
            result=WriteStringN(file, "   Frame / delay :"+RSet(Str(i), 8, "0 ")+" *"+RSet(Str(GetGIFandCSS_delay_array_BF(i)), 8, "0"), #PB_Ascii)
          EndIf
        Next i
      EndMacro
      Protected i, ii, file,  result, temporary_image_ID, frames=GetGIFandCSS_frames_BF()
      
      Protected path_1$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+"_sheet_info_BF.txt"
      file=CreateFile(#PB_Any, path_1$)
      
      If file<1
        MessageRequester("Error", "Cannot create sheet info file ")
      EndIf
      If Not file : ProcedureReturn -22 : EndIf
      
      common_write_frame_data
      
      CloseFile(file)
      
      If Not result : ProcedureReturn -22 : EndIf
      
      If sprite_mode And image
        result=WriteColorDistanceValue_BF(path_1$, color_distance_sprite_mask)
        If result<>1 : ProcedureReturn result : EndIf
      EndIf
      
      Select image_type$ 
        Case "jpg" 
          path_1$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+".jpg"
          file=OpenFile(#PB_Any, path_1$)
        Case "png"
          path_1$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+".png"
          file=OpenFile(#PB_Any, path_1$)
        Case "bmp"
          path_1$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+".bmp"
          file=OpenFile(#PB_Any, path_1$)
      EndSelect 
      If Not file : ProcedureReturn -22 : EndIf
      
      Protected file_length_0=Lof(file)
      
      FileSeek(file, file_length_0)
      
      common_write_frame_data
      
      If Not result : CloseFile(file) : ProcedureReturn -22 : EndIf
      
      Protected file_length_1=Lof(file)
      
      result=WriteQuad(file, file_length_1-file_length_0)  
      
      CloseFile(file)
      
      If Not result : ProcedureReturn -22 : EndIf
      
      If sprite_mode And image
        ProcedureReturn WriteColorDistanceValue_BF(path_1$, color_distance_sprite_mask)
      Else
        ProcedureReturn 1
      EndIf
      
    EndProcedure
    
    Procedure SpriteTool_BF(path$="")
      
      Protected window_1_ID, canvas_ID, canvas_1_ID, win_event, texture_ID, image_ID, grabbed_texture_ID
      Protected animation_buffer_ID, background_ID, screen_ID, loaded_frame_ID, font_ID, undo_0_ID, undo_1_ID
      Protected temporary_frame_1_ID, temporary_frame_2_ID, temporary_frame_3_ID, temporary_frame_4_ID, temporary_frame_5_ID, source_ID, text_image_0_ID, text_image_1_ID
      Protected frames, sheet, window_width, window_height, sheet_width, sheet_height, stop_animation, animation_was_stopped, result, save_mode, mode, grab_color, replace_color, use_fill_frame_selective
      Protected preset_save_mode, move, max_x_output, max_y_output, point_x_pos=-20, point_y_pos=-20, active_frames, line, column, frame_offset_x, frame_offset_y, temporary_frame_6_ID, color_distance_image_mode, use_texture, loaded_alpha=1 
      Protected clipping=1, old_css_width, old_css_height, old_frame_width, old_frame_height, old_frames_in_a_row, old_color_distance, window_leave, create_frames_separately, font_requester_font_size=14, loaded_frame_state_alpha, loaded_frame_state_alpha_1
      Protected frame, delay, i, ii, iii, invisible_gif_color, old_invisible_gif_color, old_invisible_gif_color_1, coloring_changed, text_alignment, mirror, hide_selection_rectangle, transparent_fill, alpha_bucket_Fill, x, y, temporary_loaded_alpha
      Protected min_output_x, min_output_y, image, new_start=1, oversize_x, oversize_y, fit_width, fit_height, rectangle_width, rectangle_height, rectangle_active
      Protected save_result, show_loaded_frame, foreground_color, old_foreground_color, text_width, text_height, temp_frame_ID
      Protected frame_info$, old_frame_info$, delay_info$, old_delay_info$, resize_info$, old_resize_info$, delay$, font_requester_font_name$="Arial", text$, image_mode$
      Protected clip_max_x_output.f, clip_max_y_output.f, resized_x.f, resized_y.f, move_1.f, x_pos.f, y_pos.f, original_width.f, original_height.f, output_width.f, output_height.f
      
      #available_undo=20 ; Available undo steps - You can change
      Structure undo
        undo_1.i
        undo_2.i
      EndStructure
      NewList undo.undo()
      
      #min_window_width=940  ; Smallest window size x - available min =940
      #min_window_height=2   ; Smallest window size y - Without min limit
      
      #smaller_desktop_width=340  ; Max window size x 
      #smaller_desktop_height=340 ; Max window_size y
      
      #Can_not_create_image="Cannot create image"
      #SpriteToolBackground="SpriteTool_BF_Background.png"
      #EnvironmentVariable="CSS_sprite_tool_BF"
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Windows
        Protected font_1=LoadFont(#PB_Any, "Arial", 10)
      CompilerElseIf#PB_Compiler_OS=#PB_OS_Linux
        Protected font_1=LoadFont(#PB_Any, "Arial", 11)
      CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
        Protected font_1=LoadFont(#PB_Any, "Arial", 12)
      CompilerEndIf
      
      text_image_0_ID=DrawTextCreateImage_BF("Loaded frame floating", #White, #Black, 1, 0, font_1, 0, 0, 5)
      If Not text_image_0_ID : ProcedureReturn -6 : EndIf
      If path$=""
        path$=OpenFileRequester("Load a GIF - PB Sprite - Image - BF sprite sheet", "", "", 0)
      EndIf
      
      Protected readed_color_distance_value=ReadColorDistanceValue_BF(path$)
      
      If readed_color_distance_value>-1
        sprite_mode=1 ; Activate sprite_mode
        color_distance_sprite_mask=readed_color_distance_value ; Set color distance for sprite_mode - Image mode set it automatically = 0
      EndIf
      
      If UCase(GetExtensionPart(path$))<>"GIF"
        result=ReadSheetInfoFile_BF(path$)
        If result>0
          path$=RemoveString(GetPathPart(path$)+RemoveString(GetFilePart(path$), "_sheet_info_BF", #PB_String_NoCase), GetExtensionPart(path$), #PB_String_NoCase)
          If FileSize(path$+"jpg")>0 : path$+"jpg"
          ElseIf FileSize(path$+"JPG")>0 : path$+"JPG"
          ElseIf FileSize(path$+"png")>0 : path$+"png"
          ElseIf FileSize(path$+"PNG")>0 : path$+"PNG"
          ElseIf FileSize(path$+"bmp")>0 : path$+"bmp"
          ElseIf FileSize(path$+"JPG")>0 : path$+"JPG"
          EndIf
        Else
          result=GetFrameData_fromSheet_BF(path$)
        EndIf
        
        If GetGIFandCSS_color_distance_BF()
          sprite_mode=1
          color_distance_sprite_mask=GetGIFandCSS_color_distance_BF()
        EndIf
        
        image_ID=LoadPhoto_BF(path$)
        If Not image_ID : ProcedureReturn -2 : EndIf
        
      Else ; GIF - Create Sheet
        Protected image_1_ID=LoadImage(#PB_Any, path$)
        If image_1_ID
          ActivateAlphaChannel_BF(1)
          image_ID=CreateCSSSheet_simple_BF(image_1_ID)
          ActivateAlphaChannel_BF(0)
          If Not image_ID : ProcedureReturn -6 : EndIf
          result=2
        Else
          ProcedureReturn -2   
        EndIf
      EndIf
      
      If path$=""
        window_1_ID=OpenWindow(#PB_Any, 0, 0, 400, 210, "", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
        
        StickyWindow(window_1_ID, 1)
        
        TextGadget(#PB_Any, 75, 25, 75, 20, "Frame width")
        Protected set_frame_width_=StringGadget(#PB_Any, 75, 45, 50, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(set_frame_width_, #PB_String_MaximumLength, 5)
        SetGadgetText(set_frame_width_, Str(DesktopWidth_UserScaled_BF()-#smaller_desktop_width))
        
        TextGadget(#PB_Any, 170, 25, 75, 20, "Frame height")
        Protected set_frame_height_=StringGadget(#PB_Any, 170, 45, 50, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(set_frame_height_, #PB_String_MaximumLength, 5)
        SetGadgetText(set_frame_height_, Str(DesktopHeight_UserScaled_BF()-#smaller_desktop_height))
        
        TextGadget(#PB_Any, 270, 25, 85, 20, "Frames amount")
        Protected set_number_of_frames_=StringGadget(#PB_Any, 270, 45, 50, 20, "0", #PB_String_Numeric)
        
        Protected image_without_alpha_channel=ButtonGadget(#PB_Any, 20, 90, 360, 40, "Create sprite sheet or image without alpha channel")
        Protected image_with_alpha_channel=ButtonGadget(#PB_Any, 20, 150, 360, 40, "Create sprite sheet or image with alpha channel")
        
        Repeat
          win_event=WaitWindowEvent()
          Protected get_frame_width_=Val(GetGadgetText(set_frame_width_))
          Protected get_frame_height_=Val(GetGadgetText(set_frame_height_))
          Protected get_number_of_frames_=Val(GetGadgetText(set_number_of_frames_))
          If win_event=#PB_Event_Gadget
            Select EventGadget()
              Case image_with_alpha_channel
                If get_frame_width_ And get_frame_height_
                  CalculateCSSSheet_BF(get_frame_width_, get_frame_height_, get_number_of_frames_)
                  image_ID=CreateImage(#PB_Any, GetCSS_width_BF(), GetCSS_height_BF(), 32, #PB_Image_Transparent)
                  result=3
                  GetGIFandCSS_delay_array_BF(get_number_of_frames_) ; This works also same Dim for the delay array
                  For i=0 To get_number_of_frames_-1
                    SetGIFandCSS_delay_array_BF(i, 100)
                  Next
                  Break
                EndIf
              Case image_without_alpha_channel
                If get_frame_width_ And get_frame_height_
                  CalculateCSSSheet_BF(get_frame_width_, get_frame_height_, get_number_of_frames_)
                  image_ID=CreateImage(#PB_Any, GetCSS_width_BF(), GetCSS_height_BF(), 24, invisible_gif_color)
                  result=3
                  GetGIFandCSS_delay_array_BF(get_number_of_frames_) ; This works also same Dim for the delay array
                  For i=0 To get_number_of_frames_-1
                    SetGIFandCSS_delay_array_BF(i, 100)
                  Next
                  Break
                EndIf
            EndSelect
          EndIf
          If win_event=#PB_Event_CloseWindow : ProcedureReturn 1 : EndIf
        ForEver
        
        CloseWindow(window_1_ID)
        
        If Not image_ID
          ProcedureReturn -6
        EndIf
      EndIf
      
      temporary_frame_3_ID=CopyImage(image_ID, #PB_Any)
      If Not  temporary_frame_3_ID : ProcedureReturn -6 : EndIf
      
      Macro add_undo
        If ListSize(undo())=#available_undo
          FirstElement(undo())
          FreeImage(undo()\undo_1)
          FreeImage(undo()\undo_2)
          DeleteElement(undo(), 1)
          LastElement(undo())
        EndIf
        undo_0_ID=CreateImage(#PB_Any, ImageWidth(image_ID), ImageHeight(image_ID), 32, #PB_Image_Transparent) ; Undo image_ID
        If undo_0_ID
          AddElement(undo())
          CopyContent_Image_Image_BF(image_ID, undo_0_ID)
          undo()\undo_1=undo_0_ID
          undo_1_ID=CreateImage(#PB_Any, ImageWidth(image_ID), ImageHeight(image_ID), 32, #PB_Image_Transparent) ; Undo temporary_frame_3_ID
          If undo_1_ID
            CopyContent_Image_Image_BF(temporary_frame_3_ID, undo_1_ID)
            undo()\undo_2=undo_1_ID
            SetGadgetText(button_gadget_undo, "Undo "+Str(ListSize(undo())))
          Else
            FreeImage(undo_0_ID)
          EndIf
        EndIf
      EndMacro
      
      Macro set_sheet_data
        sheet=1
        sheet_width=GetCSS_width_BF()
        sheet_height=GetCSS_height_BF()
        frames=GetGIFandCSS_frames_BF()
        output_width=GetGIFandCSS_frame_width_BF()
        output_height=GetGIFandCSS_frame_height_BF()
        invisible_gif_color=GetGIFandCSS_invisible_color_BF()
        color_distance_sprite_mask=GetGIFandCSS_color_distance_BF()
        old_invisible_gif_color_1=invisible_gif_color
      EndMacro
      
      If GetGIFandCSS_frames_BF()>1
        If result=3
          set_sheet_data
        Else
          If (result=2 Or MessageRequester("Sprite Sheet " , "BF compatible sprite sheet found"+#CRLF$+#CRLF$+
                                                             "Do you want to import the frame data ?"+#CRLF$+#CRLF$+
                                                             "Hint :"+#CRLF$+
                                                             "To start a animation after import,"+#CRLF$+
                                                             "move the mouse pointer out of the window", #PB_MessageRequester_YesNo)=#PB_MessageRequester_Yes)
            set_sheet_data
          EndIf
        EndIf
      EndIf
      
      If Not sheet
        output_width=ImageWidth(image_ID)
        output_height=ImageHeight(image_ID)
        image=1
        invisible_gif_color=GetImageColor_BF(image_ID, 0, 0)
        old_invisible_gif_color_1=invisible_gif_color
      EndIf 
      
      SetInvisibleColor_BF(invisible_gif_color)
      
      Protected backup_image_ID=CopyImage(image_ID, #PB_Any)
      If Not backup_image_ID : FreeImage(image_ID) : ProcedureReturn -6 : EndIf
      
      window_width=output_width
      window_height=output_height
      
      original_width=output_width
      original_height=output_height
      
      Macro create_background
        texture_ID=CreateImage(#PB_Any, 100, 100) ; Create texture for the background
        If Not texture_ID : ProcedureReturn -6 : EndIf
        StartDrawing(ImageOutput(texture_ID))
        For i=1 To ImageWidth(texture_ID)-1 Step 7
          LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
        Next i
        For i=1 To ImageHeight(texture_ID)-1 Step 7
          LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
        Next i
        StopDrawing()
      EndMacro
      
      ; Macro create_background ; Mask color as background
      ;   texture_ID=CreateImage(#PB_Any, 100, 100) ; Create texture for the background
      ;   If Not texture_ID : ProcedureReturn -6 : EndIf
      ;   StartDrawing(ImageOutput(texture_ID))
      ;   Box(0, 0, ImageWidth(texture_ID), ImageHeight(texture_ID), invisible_gif_color)
      ;   StopDrawing()
      ; EndMacro
      
      Macro use_created_background
        StartDrawing(ImageOutput(background_ID))
        Box(0, 0, window_width, window_height, 0)
        StopDrawing()
        old_color_distance=GetColorDistanceSpriteMask_BF()
        SetColorDistanceSpriteMask_BF(0)
        ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create tiled textured background
        SetColorDistanceSpriteMask_BF(old_color_distance)
        FreeImage(texture_ID)
      EndMacro
      
      Macro coloring_image(source_ID)
        Image_coloring_partition_BF(source_ID, source_ID,
                                    partition_x,
                                    partition_y,
                                    partition_width,
                                    partition_height,
                                    swap_partition,
                                    change_red,
                                    change_green,
                                    change_blue,
                                    change_contrast,
                                    change_brightness,
                                    change_intensity,
                                    mode_grey)
      EndMacro
      
      Macro box_go_line_go
        
        If Not hide_selection_rectangle And WindowMouseX(window_2_ID)>-1 And WindowMouseY(window_2_ID)>-1
          
          If window_leave
            window_leave=0
            If sheet : DisableGadget(trackbar_frame, 0) : EndIf
            DisableGadget(trackbar_red, 0)
            DisableGadget(trackbar_green, 0)
            DisableGadget(trackbar_blue, 0)
            DisableGadget(trackbar_contrast, 0)
            DisableGadget(trackbar_brightness, 0)
            DisableGadget(trackbar_intensity, 0)
            DisableGadget(trackbar_partition_x, 0)
            DisableGadget(trackbar_partition_y, 0)
            DisableGadget(trackbar_partition_width, 0)
            DisableGadget(trackbar_partition_height, 0)
            While WindowEvent() : Wend
          EndIf
          
          BoxGo_16_BF(partition_x+(window_width/2-output_width/2),
                      partition_y+(window_height/2-output_height/2),
                      clip_max_x_output,
                      clip_max_y_output,
                      $FFFFFF,
                      move,
                      %11111111)
        Else
          If Not window_leave
            window_leave=1
            If sheet : DisableGadget(trackbar_frame, 1) : EndIf
            DisableGadget(trackbar_red, 1)
            DisableGadget(trackbar_green, 1)
            DisableGadget(trackbar_blue, 1)
            DisableGadget(trackbar_contrast, 1)
            DisableGadget(trackbar_brightness, 1)
            DisableGadget(trackbar_intensity, 1)
            DisableGadget(trackbar_partition_x, 1)
            DisableGadget(trackbar_partition_y, 1)  
            DisableGadget(trackbar_partition_width, 1)
            DisableGadget(trackbar_partition_height, 1)
            While WindowEvent() : Wend
          EndIf
        EndIf
        
        If sheet
          image_mode$=" Multi-frame - "
        ElseIf image
          image_mode$=" Image - "
        EndIf
        
        If sprite_mode
          image_mode$+" Sprite mode"
        Else
          image_mode$+" Image mode"
        EndIf
        
        If WindowMouseX(window_2_ID)>0
          If invisible_gif_color>-1
            text$=image_mode$+" - Mask color : "+LSet(Hex(invisible_gif_color), 6, "0")
          Else
            text$=image_mode$+" - Mask color not pre defined "
          EndIf
          text_width=DrawText_BF(0, 0, text$, 0, 0, 0, 3) ; Calculate the needet width and height for this text
          text_height=DrawText_BF(0, 0, text$, 0, 0, 0, 4)
          If WindowMouseY(window_2_ID)>text_height+5 Or WindowMouseX(window_2_ID)>text_width+5
            DrawText_BF(0, 0, text$+" ")
          Else
            DrawText_BF(window_width-text_width, 0, text$+" ", $FFFFFF, 0, 2)
          EndIf
        EndIf
        
        If Not hide_selection_rectangle And Not window_leave
          If point_x_pos=>min_output_x And point_y_Pos=>min_output_y And point_x_pos<max_x_output And point_y_pos<max_y_output
            LineGo_16_BF(point_x_pos-17, point_y_pos, point_x_pos-1, point_y_pos, $FFFFFF, move, %1111111, 0)
            LineGo_8_BF(point_x_pos, point_y_pos-9, point_x_pos, point_y_pos-1, $FFFFFF, move_1, %1111, 0)
            LineGo_16_BF(point_x_pos+1, point_y_pos, point_x_pos+17, point_y_pos, $FFFFFF, move, %1111111, 1)
            LineGo_8_BF(point_x_pos, point_y_pos+9, point_x_pos, point_y_pos+1, $FFFFFF, move_1, %1111, 1)
          EndIf
        EndIf
        
        If loaded_frame_ID And WindowMouseX(window_2_ID)>-1 And WindowMouseY(window_2_ID)>-1 ; And WindowMouseY(window_2_ID)>canvas_height
          show_loaded_frame=1
          If WindowMouseX(window_2_ID)>0 And WindowMouseX(window_2_ID)<ImageWidth(text_image_0_ID) And
             WindowMouseY(window_2_ID)>canvas_height-ImageHeight(text_image_0_ID) And
             WindowMouseY(window_2_ID)<canvas_height
          Else
            DrawImage(ImageID(text_image_0_ID), 0, window_height-ImageHeight(text_image_0_ID))
            ; DrawAlphaImage(ImageID(text_image_0_ID), 0, window_height-ImageHeight(text_image_0_ID), 120)
          EndIf
        Else
          show_loaded_frame=0
        EndIf
        
      EndMacro
      
      If window_width>DesktopWidth_UserScaled_BF()-#smaller_desktop_width
        window_width=DesktopWidth_UserScaled_BF()-#smaller_desktop_width
      EndIf
      
      If window_height>DesktopHeight_UserScaled_BF()-#smaller_desktop_height
        window_height=DesktopHeight_UserScaled_BF()-#smaller_desktop_height
      EndIf
      
      If output_height>output_width : window_width=window_height : EndIf
      
      ; --- Calculate the needed output window and temporary image ---
      If output_width>window_width Or output_height>window_height ; Calculate proportional resized output - Tipp : Look for ORBO GIF
        GetFitSize_BF(output_width, output_height, window_width, window_height)
        output_width=GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
        output_height=GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
      EndIf
      
      GetFitSize_BF(output_width, output_height, window_width, window_height)
      
      output_width=GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
      output_height=GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
      
      window_width=output_width
      window_height=output_height
      
      If output_width<#min_window_width : window_width=#min_window_width : EndIf
      If output_height<#min_window_height : window_height=#min_window_height : EndIf
      
      min_output_x=window_width>>1-output_width/2
      min_output_y=window_height>>1-output_height/2
      
      ; --------------------------------------------
      
      window_1_ID=OpenWindow(#PB_Any, 0, 0, 845, 435, "", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
      StickyWindow(window_1_ID, 1)
      
      Protected load_new_image=ButtonGadget(#PB_Any, 30, 30, 250, 40, "Load new image, BF sprite sheet, or GIF")
      Protected load_background=ButtonGadget(#PB_Any, 30, 80, 250, 40, "Load background texture")
      Protected delete_background=ButtonGadget(#PB_Any, 30, 130, 250, 40, "Delete loaded background")
      Protected load_frame=ButtonGadget(#PB_Any, 30, 180, 250, 40, "Load frame (Image) as sprite")
      Protected write_loaded_frame=ButtonGadget(#PB_Any, 30, 230, 250, 40, "Write loaded frame")
      Protected delete_loaded_frame=ButtonGadget(#PB_Any, 30, 280, 250, 40, "Delete loaded frame")
      Protected write_and_delete_loaded_frame=ButtonGadget(#PB_Any, 30, 330, 250, 40, "Write and delete loaded frame")
      Protected save_all_frames_as_sprite_sheet=OptionGadget(#PB_Any, 300, 277, 115, 20, "Save as sheet")
      SetGadgetState(save_all_frames_as_sprite_sheet, 1)
      Protected save_all_frames_separately=OptionGadget(#PB_Any, 300, 302, 115, 20, "Save as frames")
      Protected create_empty_sheet_or_image=ButtonGadget(#PB_Any, 300, 30, 250, 40, "Create empty sprite sheet or image")
      Protected load_frame_without_alpha_channel=OptionGadget(#PB_Any, 45, 380, 220, 20, "Load frame without alpha channel")
      SetGadgetState(load_frame_without_alpha_channel, 1)
      Protected load_frame_with_alpha_channel=OptionGadget(#PB_Any, 45, 405, 220, 20, "Load frame with alpha channel")
      FrameGadget(#PB_Any, 290, 10, 270, 130, "Create empty BF sprite sheet or image")
      TextGadget(#PB_Any, 305, 85, 75, 20, "Frame width")
      Protected set_frame_width=StringGadget(#PB_Any, 305, 105, 50, 20, Str(original_width), #PB_String_Numeric)
      SetGadgetAttribute(set_frame_width, #PB_String_MaximumLength, 5)
      TextGadget(#PB_Any, 385, 85, 75, 20, "Frame height")
      Protected set_frame_height=StringGadget(#PB_Any, 385, 105, 50, 20, Str(original_height), #PB_String_Numeric)
      SetGadgetAttribute(set_frame_height, #PB_String_MaximumLength, 5)
      TextGadget(#PB_Any, 470, 85, 85, 20, "frames amount")  
      Protected set_number_of_frames=StringGadget(#PB_Any, 470, 105, 50, 20, Str(GetGIFandCSS_frames_BF()), #PB_String_Numeric)
      SetGadgetAttribute(set_number_of_frames, #PB_String_MaximumLength, 5)
      Protected catch_loaded_frame_as_texture=ButtonGadget(#PB_Any, 300, 150, 250, 40, "Catch loaded frame as texture for fill")
      Protected use_grabbed_texture=OptionGadget(#PB_Any, 300, 200, 115, 20, "Use texture")
      Protected use_not_grabbed_texture=OptionGadget(#PB_Any, 300, 225, 115, 20, "Use not texture")
      SetGadgetState(use_not_grabbed_texture, 1)
      Protected save_tool_result=ButtonGadget(#PB_Any, 300, 330, 250, 40, "Save"+#LF$+"(Sprite mode has color distance info)", #PB_Button_MultiLine)
      Protected text_left=OptionGadget(#PB_Any, 575, 280, 70, 20, "Text left")
      Protected text_center=OptionGadget(#PB_Any, 655, 280, 30, 20, "C")
      Protected text_right=OptionGadget(#PB_Any, 700, 280, 30, 20, "R")
      Protected text_vertical=OptionGadget(#PB_Any, 750, 280, 70, 20, "Vertical") 
      
      SetGadgetState(text_left, 1)
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        TextGadget(#PB_Any, 575, 320, 120, 20, "Rotate loaded frame")
        Protected rotate_loaded_frame=StringGadget(#PB_Any, 615, 340, 40, 20, "0", #PB_String_Numeric)
        SetGadgetAttribute(rotate_loaded_frame, #PB_String_MaximumLength, 3)
      CompilerElse
        TextGadget(#PB_Any, 585, 320, 120, 20, "Rotate loaded frame")
        Protected rotate_loaded_frame=StringGadget(#PB_Any, 610, 340, 40, 20, "0", #PB_String_Numeric)
        SetGadgetAttribute(rotate_loaded_frame, #PB_String_MaximumLength, 3)
      CompilerEndIf
      
      Protected mirror_h=OptionGadget(#PB_Any, 300, 380, 135, 20, "Mirror loaded frame H")
      Protected mirror_v=OptionGadget(#PB_Any, 460, 380, 30, 20, "V")
      Protected mirror_off=OptionGadget(#PB_Any, 505, 380, 60, 20, "Off")
      SetGadgetState(mirror_off, 1)
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        TextGadget(#PB_Any, 715, 320, 100, 20, "Alpha blending")
        Protected alpha_loaded_frame=StringGadget(#PB_Any, 740, 340, 40, 20, "0", #PB_String_Numeric)
        SetGadgetAttribute(alpha_loaded_frame, #PB_String_MaximumLength, 3)
      CompilerElse
        TextGadget(#PB_Any, 725, 320, 100, 20, "Alpha blending")
        Protected alpha_loaded_frame=StringGadget(#PB_Any, 740, 340, 40, 20, "0", #PB_String_Numeric)
        SetGadgetAttribute(alpha_loaded_frame, #PB_String_MaximumLength, 3)
      CompilerEndIf
      
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Windows
        Protected transparent_fill_on=OptionGadget(#PB_Any, 300, 405, 200, 20, "Transparent fill for alpha images On")
        Protected transparent_fill_off=OptionGadget(#PB_Any, 505, 405, 40, 20, "Off")
      CompilerElse
        Protected transparent_fill_on=OptionGadget(#PB_Any, 285, 405, 230, 20, "Transparent fill for alpha images On")
        Protected transparent_fill_off=OptionGadget(#PB_Any, 520, 405, 40, 20, "Off")
      CompilerEndIf
      SetGadgetState(transparent_fill_off, 1)
      
      Protected use_color_requester_foreground=ButtonGadget(#PB_Any, 570, 30, 200, 40, "Change foreground color")
      Protected use_color_requester_invisible_color=ButtonGadget(#PB_Any, 570, 80, 200, 40, "Change invisible color")
      Protected create_rectangle=ButtonGadget(#PB_Any, 570, 130, 250, 40, "Create rectangle in loaded frame")
      Protected create_circle=ButtonGadget(#PB_Any, 570, 180, 250, 40, "Create ellipse in loaded frame")
      Protected import_text=ButtonGadget(#PB_Any, 570, 230, 250, 40, "Get clipboard text to the loaded frame")
      
      Protected use_fill_not_frame_selective=OptionGadget(#PB_Any, 610, 380, 150, 20, "Change all frames")
      Protected use_fill_all_frame_selective=OptionGadget(#PB_Any, 610, 405, 150, 20, "Change frame selective")
      SetGadgetState(use_fill_not_frame_selective, 1)
      If image
        DisableGadget(use_fill_all_frame_selective, 1)
        DisableGadget(use_fill_not_frame_selective, 1)
      EndIf
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        Protected help=ButtonGadget(#PB_Any, 780, 400, 60, 25, "Help")
      CompilerElse
        Protected help=ButtonGadget(#PB_Any, 780, 405, 60, 25, "Help")
      CompilerEndIf
      Protected canvas_foreground_color_ID=CanvasGadget(#PB_Any, 780, 30, 40, 40, #PB_Canvas_Border)
      Protected canvas_background_color_ID=CanvasGadget(#PB_Any, 780, 80, 40, 40, #PB_Canvas_Border)
      
      ; For initializing you can call ImageGadget_BF without parameters
      ; The gadget can also initialize itself at the first call, so you must not initialize firstly here, look at the demo codes
      Protected grabbed_texture_image_gadget_ID=ImageGadget_BF()
      
      If Not canvas_foreground_color_ID Or Not canvas_background_color_ID
        MessageRequester("Error", "Cannot initialize the tool")
        End
      EndIf
      
      window_2_ID=OpenWindow(#PB_Any, 0, 0,
                             window_width, window_height+200,
                             "SpriteTool_BF - Sprite - Image - GIF - CSS sprite sheet - coloring - PureBasic - Fitted for GFX_Wizzard_BF © W. Albus",
                             #PB_Window_SystemMenu | #PB_Window_ScreenCentered) 
      
      AddWindowTimer(window_2_ID, 1, 30)
      
      canvas_ID=CanvasGadget(#PB_Any, 0, 0, window_width, window_height)
      
      Protected canvas_width=GadgetWidth(canvas_ID), canvas_height=GadgetHeight(canvas_ID)
      
      Protected gadget_offset_x=window_width/2-460, gadget_offset_y=window_height+8 
      
      Protected container_gadget_1=ContainerGadget(#PB_Any, gadget_offset_x , gadget_offset_y, window_width, 200)
      HideGadget(container_gadget_1, 1)
      
      gadget_offset_x=0 : gadget_offset_y=0
      
      canvas_1_ID=CanvasGadget(#PB_Any, 771+gadget_offset_x, 35+gadget_offset_y, 45, 30)
      
      If Not window_2_ID Or Not window_1_ID Or Not canvas_ID Or Not canvas_1_ID
        MessageRequester("Error", "Cannot initialize the tool")
        End
      EndIf
      
      Protected trackbar_frame=TrackBarGadget(#PB_Any, 10+gadget_offset_x, gadget_offset_y, 900, 20, 0, frames-1, #PB_TrackBar_Ticks)
      If image : DisableGadget(trackbar_frame, 1) : EndIf
      
      Protected text_red=TextGadget(#PB_Any, 10+gadget_offset_x, 25+gadget_offset_y, 180, 20,"Red  0", #PB_Text_Center)
      Protected trackbar_red=TrackBarGadget(#PB_Any, 10+gadget_offset_x, 43+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_red, 100)
      
      Protected text_green=TextGadget(#PB_Any, 10+gadget_offset_x, 63+gadget_offset_y, 180, 20,"Green  0", #PB_Text_Center)
      Protected trackbar_green=TrackBarGadget(#PB_Any, 10+gadget_offset_x, 81+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_green, 100)
      
      Protected text_blue=TextGadget(#PB_Any, 10+gadget_offset_x, 103+gadget_offset_y, 180, 20,"Blue  0", #PB_Text_Center)
      Protected trackbar_blue=TrackBarGadget(#PB_Any, 10+gadget_offset_x, 121+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_blue, 100)
      
      Protected text_contrast=TextGadget(#PB_Any, 10+gadget_offset_x, 143+gadget_offset_y, 180, 20,"Contrast  0", #PB_Text_Center)
      Protected trackbar_contrast=TrackBarGadget(#PB_Any, 10+gadget_offset_x, 161+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_contrast, 100)
      
      Protected text_brightness=TextGadget(#PB_Any, 200+gadget_offset_x, 25+gadget_offset_y, 180, 20,"Brightness  0", #PB_Text_Center)
      Protected trackbar_brightness=TrackBarGadget(#PB_Any, 200+gadget_offset_x, 43+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_brightness, 100)
      
      Protected text_intensity=TextGadget(#PB_Any, 200+gadget_offset_x, 63+gadget_offset_y, 180, 20,"Intensity  0", #PB_Text_Center)
      Protected trackbar_intensity=TrackBarGadget(#PB_Any, 200+gadget_offset_x, 81+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_intensity, 100)
      
      Protected text_partition_x=TextGadget(#PB_Any, 200+gadget_offset_x, 103+gadget_offset_y, 180, 20,"Partition X  0", #PB_Text_Center)
      Protected trackbar_partition_x=TrackBarGadget(#PB_Any, 200+gadget_offset_x, 121+gadget_offset_y, 180, 20, 0, 200)
      
      Protected text_partition_y=TextGadget(#PB_Any, 200+gadget_offset_x, 143+gadget_offset_y, 180, 20,"Partition Y  0", #PB_Text_Center)
      Protected trackbar_partition_y=TrackBarGadget(#PB_Any, 200+gadget_offset_x, 161+gadget_offset_y, 180, 20, 0, 200)
      
      Protected text_partition_width=TextGadget(#PB_Any, 395+gadget_offset_x, 25+gadget_offset_y, 180, 20,"Partition width  "+original_width, #PB_Text_Center)
      Protected trackbar_partition_width=TrackBarGadget(#PB_Any, 395+gadget_offset_x, 43+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_partition_width, 200)
      
      Protected text_partition_height=TextGadget(#PB_Any, 395+gadget_offset_x, 63+gadget_offset_y, 180, 20,"Partition height  "+original_height, #PB_Text_Center)
      Protected trackbar_partition_height=TrackBarGadget(#PB_Any, 395+gadget_offset_x, 81+gadget_offset_y, 180, 20, 0, 200)
      SetGadgetState(trackbar_partition_height, 200)
      
      Protected text_color_distance=TextGadget(#PB_Any, 590+gadget_offset_x, 25+gadget_offset_y, 180, 20,"Color distance  "+color_distance_sprite_mask, #PB_Text_Center)
      Protected trackbar_color_distance=TrackBarGadget(#PB_Any, 590+gadget_offset_x, 43+gadget_offset_y, 170, 20, 0, 100)
      
      Protected delay_info_1=TextGadget(#PB_Any, 600+gadget_offset_x, 83+gadget_offset_y, 95, 20, "")
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        Protected text_resize_x=TextGadget(#PB_Any, 852+gadget_offset_x, 28+gadget_offset_y, 60, 20,"Resize X")
        Protected text_resize_y=TextGadget(#PB_Any, 852+gadget_offset_x, 74+gadget_offset_y, 60, 20,"Resize Y")
      CompilerElse
        Protected text_resize_x=TextGadget(#PB_Any, 830+gadget_offset_x, 28+gadget_offset_y, 90, 20,"Resize X", #PB_Text_Center)
        Protected text_resize_y=TextGadget(#PB_Any, 830+gadget_offset_x, 70+gadget_offset_y, 90, 20,"Resize Y", #PB_Text_Center)
      CompilerEndIf
      
      Protected text_resize_info=TextGadget(#PB_Any, 825+gadget_offset_x, 120+gadget_offset_y, 100, 20, "", #PB_Text_Center)
      
      Protected option_gadget_color=OptionGadget(#PB_Any, 395+gadget_offset_x, 102+gadget_offset_y, 60, 20, "Color")
      SetGadgetState(option_gadget_color, 1)
      Protected option_gadget_grey_1=OptionGadget(#PB_Any, 395+gadget_offset_x, 121+gadget_offset_y, 50, 20, "Grey 1")
      Protected option_gadget_grey_2=OptionGadget(#PB_Any, 395+gadget_offset_x, 139+gadget_offset_y, 50, 20, "Grey 2")
      Protected option_gadget_grey_3=OptionGadget(#PB_Any, 395+gadget_offset_x, 157+gadget_offset_y, 50, 20, "Grey 3") 
      
      TextGadget(#PB_Any, 0, 0, 0, 0, "") 
      
      Protected option_gadget_inside=OptionGadget(#PB_Any, 525+gadget_offset_x, 102+gadget_offset_y, 75, 20, "Inside") 
      SetGadgetState(option_gadget_inside, 1)
      Protected option_gadget_outside=OptionGadget(#PB_Any, 525+gadget_offset_x, 121+gadget_offset_y, 75, 20, "Outside")
      
      TextGadget(#PB_Any, 0, 0, 0, 0, "")
      
      Protected option_gadget_png=OptionGadget(#PB_Any, 465+gadget_offset_x, 102+gadget_offset_y, 50, 20, "PNG")
      Protected option_gadget_alpha_png=OptionGadget(#PB_Any, 465+gadget_offset_x, 121+gadget_offset_y, 55, 20, "PNGα") 
      Protected option_gadget_jpg=OptionGadget(#PB_Any, 465+gadget_offset_x, 140+gadget_offset_y, 50, 20, "JPG")
      Protected option_gadget_bmp=OptionGadget(#PB_Any, 465+gadget_offset_x, 159+gadget_offset_y, 50, 20, "BMP")
      
      Select save_mode
        Case 0 : SetGadgetState(option_gadget_png, 1) ; png
        Case 1 : SetGadgetState(option_gadget_jpg, 1) ; jpg
        Case 2 : SetGadgetState(option_gadget_bmp, 1) ; bmp
      EndSelect
      
      TextGadget(#PB_Any, 0, 0, 0, 0, "")
      
      Protected option_gadget_image_mode=OptionGadget(#PB_Any, 600+gadget_offset_x, 102+gadget_offset_y, 95, 20, "Image mode")
      Protected option_gadget_sprite_mode=OptionGadget(#PB_Any, 600+gadget_offset_x, 121+gadget_offset_y, 95, 20, "Sprite mode")
      Protected button_gadget_delay=ButtonGadget(#PB_Any, 728+gadget_offset_x, 73+gadget_offset_y, 90, 30, "Delay")
      If Not sheet
        DisableGadget(button_gadget_delay, 1)
      EndIf
      
      Protected button_gadget_reset=ButtonGadget(#PB_Any, 728+gadget_offset_x, 108+gadget_offset_y, 90, 30, "Reset")
      Protected button_gadget_more=ButtonGadget(#PB_Any, 728+gadget_offset_x, 143+gadget_offset_y, 90, 30, "More")
      Protected button_gadget_BucketFill=ButtonGadget(#PB_Any, 633+gadget_offset_x, 143+gadget_offset_y, 90, 30, "BucketFill")
      Protected button_gadget_FloodFill=ButtonGadget(#PB_Any, 538+gadget_offset_x, 143+gadget_offset_y, 90, 30, "FloodFill")
      
      Protected button_gadget_undo=ButtonGadget(#PB_Any, 840+gadget_offset_x, 143+gadget_offset_y, 70, 30, "Undo 0")
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        Protected string_gadget_resized_x=StringGadget(#PB_Any, 850+gadget_offset_x, 44+gadget_offset_y, 50, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(string_gadget_resized_x, #PB_String_MaximumLength, 5)
        Protected string_gadget_resized_y=StringGadget(#PB_Any, 850+gadget_offset_x, 90+gadget_offset_y, 50, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(string_gadget_resized_y, #PB_String_MaximumLength, 5)
      CompilerElse
        Protected string_gadget_resized_x=StringGadget(#PB_Any, 850+gadget_offset_x, 46+gadget_offset_y, 50, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(string_gadget_resized_x, #PB_String_MaximumLength, 5)
        Protected string_gadget_resized_y=StringGadget(#PB_Any, 850+gadget_offset_x, 88+gadget_offset_y, 50, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(string_gadget_resized_y, #PB_String_MaximumLength, 5)
      CompilerEndIf
      
      CompilerIf #PB_Compiler_OS=#PB_OS_Linux
        Protected string_gadget_delay=StringGadget(#PB_Any, 738+gadget_offset_x, 77+gadget_offset_y, 70, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(string_gadget_delay, #PB_String_MaximumLength, 8)
        HideGadget(string_gadget_delay, 1)
      CompilerElse
        Protected string_gadget_delay=StringGadget(#PB_Any, 738+gadget_offset_x, 83+gadget_offset_y, 70, 20, "", #PB_String_Numeric)
        SetGadgetAttribute(string_gadget_delay, #PB_String_MaximumLength, 8)
        HideGadget(string_gadget_delay, 1)
      CompilerEndIf
      
      If sheet
        Protected frame_info_1=TextGadget(#PB_Any, 600+gadget_offset_x, 68+gadget_offset_y, 120, 14, "")
      Else
        frame_info_1=TextGadget(#PB_Any, 600+gadget_offset_x, 78+gadget_offset_y, 120, 14, "")
      EndIf
      
      CloseGadgetList()
      
      EnableGadgetDrop(canvas_ID, #PB_Drop_Files, #PB_Drag_Link)
      EnableGadgetDrop(canvas_1_ID, #PB_Drop_Files, #PB_Drag_Link)
      EnableGadgetDrop(container_gadget_1, #PB_Drop_Files, #PB_Drag_Link)
      
      background_ID=CreateImage(#PB_Any, window_width, window_height)
      If Not background_ID : ProcedureReturn -6 : EndIf
      
      If FileSize(GetHomeDirectory()+#SpriteToolBackground)>0
        texture_ID=LoadPhoto_BF(GetHomeDirectory()+#SpriteToolBackground)
        If texture_ID 
          FitImage_BF(3,
                      texture_ID,
                      100,                ; Fit image to this width
                      100)                ; Fit image to this height
          ResizeImage(texture_ID, GetFitSize_Width_BF(), GetFitSize_Height_BF())
        Else
        create_background : EndIf
        If Not texture_ID : ProcedureReturn -6 : EndIf
      Else
        create_background
        If Not texture_ID : ProcedureReturn -6 : EndIf
      EndIf
      
      ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create tiled textured background
      
      FreeImage(texture_ID)
      
      animation_buffer_ID=CreateImage(#PB_Any, window_width, window_height)
      If Not animation_buffer_ID : FreeImage(background_ID) : ProcedureReturn -6 : EndIf
      
      NoCaching_BF(1) ; Deactivate BF texture caching
      
      Dim frame_sprite_ID(frames, 1)
      
      partition_width=output_width
      partition_height=output_height
      
      If sheet
        For i=0 To GetGIFandCSS_frames_BF()-1
          If i>ArraySize(frame_sprite_ID()) : Break : EndIf
          If GetGIFandCSS_delay_array_BF(i)=-1
            SetGIFandCSS_delay_array_BF(i, 0)
          Else
            frame_sprite_ID(i, 1)=GetGIFandCSS_delay_array_BF(i)
          EndIf
        Next
      EndIf
      
      HideGadget(container_gadget_1, 0)
      
      StartDrawing(CanvasOutput(canvas_ID))
      DrawImage(ImageID(background_ID), 0, 0)
      If IsImage(image_1_ID)
        DrawImage(ImageID(image_1_ID), canvas_width/2-output_width/2, canvas_height/2-output_height/2, output_width, output_height)
        FreeImage(image_1_ID)
      Else
        DrawImage(ImageID(image_ID), canvas_width/2-output_width/2, canvas_height/2-output_height/2, output_width, output_height)
      EndIf
      StopDrawing()
      While WindowEvent() : Wend
      
      If sprite_mode
        SetGadgetState(option_gadget_sprite_mode, 1)
        SetColorDistanceSpriteMask_BF(color_distance_sprite_mask)
        SetGadgetState(trackbar_color_distance, color_distance_sprite_mask)
        ResizeInterpolation_BF(0)
      Else
        SetGadgetState(option_gadget_image_mode, 1)
        DisableGadget(trackbar_color_distance, 1)
        color_distance_sprite_mask=0
      EndIf
      
      restart:
      
      SetInvisibleColor_BF(invisible_gif_color)
      
      If IsImage(temporary_frame_ID) : FreeImage(temporary_frame_ID) : EndIf
      
      If sheet
        
        If coloring_changed=2
          temporary_frame_ID=CopyImage(temporary_frame_3_ID, #PB_Any)
        Else
          temporary_frame_ID=CopyImage(image_ID, #PB_Any)
        EndIf
        Macro grab_changes
          If IsImage(frame_sprite_ID(i, 0)) : FreeImage(frame_sprite_ID(i, 0)) : EndIf
          frame_sprite_ID(i, 0)=CreateImage(#PB_Any, output_width, output_height)
          frame_sprite_ID(i, 1)=GetGIFandCSS_delay_array_BF(i)
          
          frame_sprite_ID(i, 0)=Sprite_CSS_sheet_grab_frame_and_free_BF(temporary_frame_ID, frame_sprite_ID(i, 0),
                                                                        frames,                         ; Number of frames
                                                                        i,                              ; Selected frame - For GIF compatibility the first frame is 0
                                                                        GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                                                        GetGIFandCSS_Frame_height_BF(), ; Frame height
                                                                        0,                              ; Frames in a row - Preset 0, then BF calculate self
                                                                        output_width,                   ; Output width - For original frame width set width = 0
                                                                        output_height)                  ; Output height - For original frame height set height = 0     
          
          Image_coloring_partition_BF(frame_sprite_ID(i, 0), frame_sprite_ID(i, 0),
                                      partition_x,
                                      partition_y,
                                      partition_width,
                                      partition_height,
                                      swap_partition,
                                      change_red,
                                      change_green,
                                      change_blue,
                                      change_contrast,
                                      change_brightness,
                                      change_intensity,
                                      mode_grey) 
        EndMacro
        
        If stop_animation
          i=frame 
          grab_changes
        Else
          SetGadgetColor(frame_info_1, #PB_Gadget_FrontColor, $FF)
          For i=0 To frames-1
            grab_changes
            SetGadgetText(frame_info_1, "Frames "+Str(frames)+" / "+Str(i+1))
            While WindowEvent() : Wend
          Next
          SetGadgetColor(frame_info_1, #PB_Gadget_FrontColor, 0)
          SetGadgetText(frame_info_1, "Frames "+Str(frames)+" / "+Str(frame+1))
        EndIf
        
      Else
        
        temporary_frame_ID=CreateImage(#PB_Any, window_width, window_height) ; Create temporary frame
        
        If IsImage(temporary_frame_1_ID) : FreeImage(temporary_frame_1_ID) : EndIf
        
        If coloring_changed=2
          temporary_frame_1_ID=CopyImage(temporary_frame_3_ID, #PB_Any)
        Else
          temporary_frame_1_ID=CopyImage(image_ID, #PB_Any)
        EndIf
        
        If sprite_mode=1
          ResizeImage(temporary_frame_1_ID, output_width, output_height, #PB_Image_Raw)
        Else
          ResizeImage(temporary_frame_1_ID, output_width, output_height)
        EndIf
        
        coloring_image(temporary_frame_1_ID)
      EndIf
      
      coloring_changed=0
      
      ActivateLineGoBackColor_BF(1, 0)
      
      Delay_BF(1, frame_sprite_ID(0, 1)) ; Init timer with the first frame delay
      
      If new_start
        new_start=0
        While WindowEvent() : Wend
      EndIf
      
      Repeat
        
        win_event=WindowEvent()
        
        If win_event=#PB_Event_CloseWindow
          FreeArray(frame_sprite_ID())
          ProcedureReturn 1
        EndIf
        
        max_x_output=window_width/2-output_width/2+output_width
        max_y_output=window_height/2-output_height/2+output_height
        clip_max_x_output=output_width-partition_x
        clip_max_y_output=output_height-partition_y
        If partition_width<clip_max_x_output : clip_max_x_output=partition_width : EndIf 
        If partition_height<clip_max_y_output : clip_max_y_output=partition_height : EndIf 
        
        ; Start window timer -----------
        If win_event=#PB_Event_Timer
          
          If WindowMouseX(window_2_ID)>GadgetX(canvas_1_ID)+GadgetX(container_gadget_1) And
             WindowMouseX(window_2_ID)<GadgetX(canvas_1_ID)+GadgetWidth(canvas_1_ID)+GadgetX(container_gadget_1) And
             WindowMouseY(window_2_ID)>GadgetY(canvas_1_ID)+GadgetY(container_gadget_1) And
             WindowMouseY(window_2_ID)<GadgetY(canvas_1_ID)+GadgetHeight(canvas_1_ID)+GadgetY(container_gadget_1)
            hide_selection_rectangle=1
            temporary_loaded_alpha=128
          Else
            hide_selection_rectangle=0
            temporary_loaded_alpha=loaded_alpha
          EndIf
          
          If (sprite_mode Or loaded_frame_ID) And Not window_leave
            DisableGadget(trackbar_color_distance, 0)
          Else
            DisableGadget(trackbar_color_distance, 1)
          EndIf
          
          If ListSize(undo())
            DisableGadget(button_gadget_undo, 0)
          Else
            DisableGadget(button_gadget_undo, 1)
          EndIf
          
          If stop_animation
            delay$=Str(frame_sprite_ID(frame, 1))
          EndIf
          
          If stop_animation=2 : animation_was_stopped=1 : EndIf
          
          If Not image And WindowMouseY(window_2_ID)<>-1
            stop_animation=1
          Else
            If animation_was_stopped
              animation_was_stopped=0
              coloring_changed=1
              If GetGadgetText(string_gadget_delay)<>""
                frame_sprite_ID(frame, 1)=Val(GetGadgetText(string_gadget_delay))
                SetGIFandCSS_delay_array_BF(frame, frame_sprite_ID(frame, 1))
                SetGadgetText(string_gadget_delay, "")
              EndIf
              HideGadget(button_gadget_delay, 0)
              HideGadget(string_gadget_delay, 1)
            EndIf
            stop_animation=0
          EndIf
          
          If frame_sprite_ID(frame, 1)
            SetGadgetState(trackbar_frame, frame)
          EndIf
          
          rectangle_width=((partition_x+(window_width/2-output_width/2))+clip_max_x_output)-((partition_x+(window_width/2-output_width/2)))
          Rectangle_height=((partition_y+(window_height/2-output_height/2))+clip_max_y_output)-((partition_y+(window_height/2-output_height/2)))
          
          If rectangle_width<2 Or rectangle_height<2
            DisableGadget(button_gadget_more, 1)
            DisableGadget(string_gadget_resized_x, 1)
            DisableGadget(string_gadget_resized_y, 1)
          Else
            DisableGadget(button_gadget_more, 0)
            DisableGadget(string_gadget_resized_x, 0)
            DisableGadget(string_gadget_resized_y, 0)
          EndIf
          
          resize_info$=Str(resized_x)+" & "+Str(resized_y)
          If resize_info$<>old_resize_info$
            old_resize_info$=resize_info$
            SetGadgetText(text_resize_info, resize_info$)
          EndIf
          
          If sheet
            frame_info$="Frames "+Str(frames)+" / "+Str(frame+1)
            If frame_info$<>old_frame_info$
              old_frame_info$=frame_info$
              SetGadgetText(frame_info_1, frame_info$)
            EndIf
            delay_info$="Delay "+Str(frame_sprite_ID(frame, 1))
            If delay_info$<>old_delay_info$
              old_delay_info$=delay_info$
              SetGadgetText(delay_info_1, delay_info$)
            EndIf
          Else
            If invisible_gif_color>-1
              frame_info$="Mask "+RSet(Hex(invisible_gif_color), 6, "0")
            EndIf
            If frame_info$<>old_frame_info$
              old_frame_info$=frame_info$
              SetGadgetText(frame_info_1, frame_info$)
            EndIf
          EndIf
          
          StartDrawing(CanvasOutput(canvas_1_ID))
          Box(4, 4, 37, 22, invisible_gif_color)
          DrawingMode(#PB_2DDrawing_Outlined)
          If sprite_mode And color_distance_sprite_mask
            Box(0, 0, 45, 30, $FF)
            Box(1, 1, 43, 28, $FF)
          Else
            Box(0, 0, 45, 30, $909090)
            Box(1, 1, 43, 28, $909090)
          EndIf
          StopDrawing()
          
          resized_x=Val(GetGadgetText(string_gadget_resized_x))
          resized_y=Val(GetGadgetText(string_gadget_resized_y))
          
          If Not resized_x And GetGadgetText(string_gadget_resized_x)="0" : SetGadgetText(string_gadget_resized_x, "") : EndIf
          If Not resized_y And GetGadgetText(string_gadget_resized_y)="0": SetGadgetText(string_gadget_resized_y, "") : EndIf         
          If resized_x And Not resized_y
            resized_y=Int(resized_x/100*(100/clip_max_x_output)*clip_max_y_output)
          ElseIf resized_y And Not resized_x
            resized_x=Int(resized_y/100*(100/clip_max_y_output)*clip_max_x_output)
          EndIf
          
          If save_result
            
            Macro calculate_clip_max_output
              If GetGadgetState(trackbar_partition_width)=200
                clip_max_x_output=Int((original_width/200*GetGadgetState(trackbar_partition_width))-(original_width/200*GetGadgetState(trackbar_partition_x)))
              Else
                clip_max_x_output=Int(original_width/200*GetGadgetState(trackbar_partition_width))
              EndIf
              
              If GetGadgetState(trackbar_partition_height)=200
                clip_max_y_output=Int((original_height/200*GetGadgetState(trackbar_partition_height))-(original_height/200*GetGadgetState(trackbar_partition_y)))
              Else
                clip_max_y_output=Int(original_height/200*GetGadgetState(trackbar_partition_height))
              EndIf
            EndMacro
            
            Macro calculate_output_rectangle
              ; Large and samll
              If (output_width<=canvas_width And output_height<canvas_height) Or (output_width>canvas_width And output_height=>canvas_height-1)
                If output_width=original_width ; Little
                  If partition_x+(window_width/2-output_width/2)+clip_max_x_output=>output_width-1 Or (original_width/200*GetGadgetState(trackbar_partition_width))=>clip_max_x_output-1
                    SetGadgetState(trackbar_partition_width, 200)
                  EndIf
                Else ; Large            
                  If partition_x+(window_width/2-output_width/2)+clip_max_x_output=>output_width-1
                    SetGadgetState(trackbar_partition_width, 200)
                  EndIf
                EndIf
                
                If output_height=original_height ; Little
                  If partition_y+(window_height/2-output_height/2)+clip_max_y_output=output_height Or Int(original_height/200*GetGadgetState(trackbar_partition_height))=>clip_max_y_output-1
                    SetGadgetState(trackbar_partition_height, 200)
                  EndIf
                Else ; large
                  If partition_y+(window_height/2-output_height/2)+clip_max_y_output=>output_height-1
                    SetGadgetState(trackbar_partition_height, 200)
                  EndIf
                EndIf 
                
              Else ; One site large
                If output_width<canvas_width
                  If partition_x+(window_width/2-output_width/2)+clip_max_x_output=output_width Or (original_width/200*GetGadgetState(trackbar_partition_width))=>clip_max_x_output-1
                    If (partition_x+(window_width/2-output_width/2)+clip_max_x_output)=>max_x_output-1
                      SetGadgetState(trackbar_partition_width, 200)
                    EndIf
                  EndIf
                Else ; Large            
                  If partition_x+(window_width/2-output_width/2)+clip_max_x_output=>output_width-1
                    SetGadgetState(trackbar_partition_width, 200)
                  EndIf
                EndIf
                
                If output_height<canvas_height ; Little
                  If partition_y+(window_height/2-output_height/2)+clip_max_y_output=output_height Or (original_height/200*GetGadgetState(trackbar_partition_height))=>clip_max_y_output-1
                    If (partition_y+(window_height/2-output_height/2)+clip_max_y_output)=>max_y_output-1
                      SetGadgetState(trackbar_partition_height, 200)
                    EndIf
                  EndIf
                Else ; large
                  If partition_y+(window_height/2-output_height/2)+clip_max_y_output=output_height
                    SetGadgetState(trackbar_partition_height, 200)
                  EndIf
                EndIf
                
              EndIf
            EndMacro
            
            Macro calculate_frame_offsets
              If sheet
                i=(frame+1)%Getframes_in_a_row_BF()
                If (frame+1)<=Getframes_in_a_row_BF()
                  line=1
                  column=(frame+1)
                Else
                  If i
                    line=(frame+1)/Getframes_in_a_row_BF()+1
                    column=i
                  Else
                    line=(frame+1)/Getframes_in_a_row_BF()
                    column=Getframes_in_a_row_BF()
                  EndIf
                EndIf
                column-1 : line-1
                frame_offset_x=column*GetGIFandCSS_Frame_width_BF()
                frame_offset_y=line*GetGIFandCSS_Frame_height_BF()
              EndIf
            EndMacro
            
            If path$<>"" Or save_result
              
              DisableGadget(container_gadget_1, 1)
              
              SetGadgetData(trackbar_partition_x, GetGadgetState(trackbar_partition_x))
              SetGadgetData(trackbar_partition_y, GetGadgetState(trackbar_partition_y))
              SetGadgetData(trackbar_partition_width, GetGadgetState(trackbar_partition_width))
              SetGadgetData(trackbar_partition_height, GetGadgetState(trackbar_partition_height))
              
              If Not resized_x Or Not resized_y
                resized_x=clip_max_x_output
                resized_y=clip_max_y_output
              EndIf
              
              If sheet
                
                If create_frames_separately
                  CreateDirectory(GetPathPart(path$)+GetFilePart(path$))
                EndIf
                
                old_css_width=GetCSS_width_BF()
                old_css_height=GetCSS_height_BF()
                old_frame_width=GetGIFandCSS_frame_width_BF()
                old_frame_height=GetGIFandCSS_frame_height_BF()
                old_frames=GetGIFandCSS_frames_BF()
                old_frames_in_a_row=GetFrames_in_a_row_BF()
                
                frames=GetGIFandCSS_Frames_BF()
                
                active_frames=0
                For i=0 To frames-1 ; Count active frames
                  If frame_sprite_ID(i, 1)
                    active_frames+1
                  EndIf
                  SetGIFandCSS_delay_array_BF(i, frame_sprite_ID(i, 1))
                Next i
                
                If active_frames
                  If Not resized_x Or Not resized_y
                    clip_max_x_output=old_frame_width
                    clip_max_y_output=old_frame_height
                  Else
                    If partition_x+(window_width/2-output_width/2)+clip_max_x_output=output_width
                      SetGadgetState(trackbar_partition_width, 200)
                    EndIf
                    If partition_y+(window_height/2-output_height/2)+clip_max_y_output=output_height
                      SetGadgetState(trackbar_partition_height, 200)
                    EndIf 
                    calculate_output_rectangle   
                    calculate_clip_max_output
                  EndIf
                  
                  temporary_frame_4_ID=CreateImage(#PB_Any, GetGIFandCSS_frame_width_BF(), GetGIFandCSS_frame_height_BF())
                  
                  If Not temporary_frame_4_ID
                    MessageRequester("Error", #Can_not_create_image)
                    save_mode=-1
                  EndIf
                Else
                  MessageRequester("Error", "No frame found to save")
                  save_mode=-1
                EndIf
                
                If save_mode<>-1
                  If save_result=2 : result=frame : Else : result=0 : EndIf
                  ii=0 : iii=0
                  SetGadgetColor(frame_info_1, #PB_Gadget_FrontColor, $FF)
                  For i=result To frames-1
                    
                    SetGadgetText(frame_info_1, "Frames "+Str(frames)+" / "+Str(i+1))
                    While WindowEvent() : Wend
                    
                    result=Sprite_CSS_sheet_simple_BF(0, temporary_frame_4_ID, temporary_frame_3_ID,
                                                      0,                   
                                                      0,
                                                      0,
                                                      0,
                                                      frames,
                                                      i,
                                                      old_frame_width,
                                                      old_frame_height)
                    
                    If result<0
                      MessageRequester("Error", "Cannot grab frame from sprite sheet")
                      save_mode=-1
                      Break
                    EndIf 
                    
                    temporary_frame_5_ID=GrabImage(temporary_frame_4_ID, #PB_Any,
                                                   Int(original_width/200*GetGadgetState(trackbar_partition_x)),
                                                   Int(original_height/200*GetGadgetState(trackbar_partition_y)),
                                                   clip_max_x_output,
                                                   clip_max_y_output)
                    
                    If Not temporary_frame_5_ID
                      MessageRequester("Error", "Cannot grab partition from image")
                      save_mode=-1
                      Break
                    EndIf
                    
                    If save_result=2 ; Rectangle snipping - Frame
                      If loaded_frame_ID : FreeImage(loaded_frame_ID) : loaded_frame_ID=0 : EndIf
                      loaded_frame_ID=CreateImage(#PB_Any, ImageWidth(temporary_frame_5_ID), ImageHeight(temporary_frame_5_ID))
                      If loaded_frame_ID
                        CopyContent_Image_Image_BF(temporary_frame_5_ID, loaded_frame_ID)
                        If mirror=1 ; Horizontal
                                    ; Mirror_and_Copy_BF(1, loaded_frame_ID)
                          Mirroring_Horizontal_BF(loaded_frame_ID)
                        ElseIf mirror=2 ; Vertical
                                        ; Mirror_and_Copy_BF(2, loaded_frame_ID)
                          Mirroring_Horizontal_BF(loaded_frame_ID)
                        EndIf
                        If Val(GetGadgetText(rotate_loaded_frame))
                          If loaded_frame_state_alpha
                            ActivateAlphaChannel_BF(1)
                          EndIf
                          RotateSprite_BF(loaded_frame_ID,
                                          0,
                                          0,
                                          Val(GetGadgetText(rotate_loaded_frame)))
                          ActivateAlphaChannel_BF(0)
                        EndIf
                      EndIf
                      save_mode=-1
                      Break
                    EndIf
                    
                    If (GetGadgetText(string_gadget_resized_x)<>"" Or GetGadgetText(string_gadget_resized_y)<>"")
                      If sprite_mode=1
                        result=ResizeImage(temporary_frame_5_ID, resized_x, resized_y, #PB_Image_Raw)
                      Else
                        result=ResizeImage(temporary_frame_5_ID, resized_x, resized_y)
                      EndIf
                      If Not result
                        MessageRequester("Error", "Cannot resize image")
                        save_mode=-1
                        Break
                      EndIf 
                    EndIf
                    
                    If i=0
                      If (GetGadgetText(string_gadget_resized_x)<>"" Or GetGadgetText(string_gadget_resized_y)<>"")
                        CalculateCSSSheet_BF(resized_x, resized_y, active_frames)
                      Else
                        CalculateCSSSheet_BF(clip_max_x_output, clip_max_y_output, active_frames)
                      EndIf
                      temporary_frame_2_ID=CreateImage(#PB_Any, GetCSS_width_BF(), GetCSS_height_BF(), 24, invisible_gif_color)
                    EndIf 
                    
                    If Not temporary_frame_2_ID
                      MessageRequester("Error", #Can_not_create_image)
                      save_mode=-1
                      Break
                    EndIf 
                    
                    If Not frame_sprite_ID(i, 1)
                      ii-GetGIFandCSS_frame_width_BF()
                    EndIf
                    
                    If frame_sprite_ID(i, 1)
                      If save_mode<>-1
                        If Not swap_partition Or Not clip_max_x_output Or Not clip_max_y_output
                          result=Image_coloring_BF(temporary_frame_5_ID, temporary_frame_5_ID,
                                                   change_red,
                                                   change_green,
                                                   change_blue,
                                                   change_contrast,
                                                   change_brightness,
                                                   change_intensity,
                                                   mode_grey)
                          If result<0
                            MessageRequester("Error", "Cannot colorize image")
                            save_mode=-1
                            Break
                          EndIf
                        EndIf
                      EndIf
                      
                      If create_frames_separately
                        
                        If GetGadgetState(option_gadget_alpha_png) ; Low priority without other checks
                          temporary_frame_6_ID=CreateAlphaImage_from_Sprite_BF(temporary_frame_5_ID,
                                                                               color_distance_sprite_mask,
                                                                               invisible_gif_color,
                                                                               loaded_alpha,
                                                                               1)
                          
                          If IsImage(temporary_frame_6_ID) : temporary_frame_5_ID=temporary_frame_6_ID : EndIf
                        EndIf
                        
                        Select save_mode
                          Case 0
                            Protected path_1$=GetPathPart(path$)+GetFilePart(path$)+"/"+GetFilePart(path$)+Str(i+1)+".png"
                            SaveImage(temporary_frame_5_ID, path_1$, #PB_ImagePlugin_PNG)
                          Case 1
                            path_1$=GetPathPart(path$)+GetFilePart(path$)+"/"+GetFilePart(path$)+Str(i+1)+".jpg"
                            SaveImage(temporary_frame_5_ID, path_1$, #PB_ImagePlugin_JPEG)
                          Case 2
                            path_1$=GetPathPart(path$)+GetFilePart(path$)+"/"+GetFilePart(path$)+Str(i+1)+".bmp"
                            SaveImage(temporary_frame_5_ID, path_1$, #PB_ImagePlugin_BMP)                         
                        EndSelect
                        
                        If sprite_mode And image
                          WriteColorDistanceValue_BF(path_1$, color_distance_sprite_mask)
                        EndIf
                        
                      EndIf
                      
                      result=SpriteSimple_fast_BF(0, temporary_frame_2_ID, temporary_frame_5_ID,                                     
                                                  0,                    
                                                  0, 
                                                  ii,
                                                  iii)
                      If result<0
                        MessageRequester("Error", "Cannot output sprite to the sheet")
                        save_mode=-1
                        Break
                      EndIf 
                    EndIf
                    
                    ii+GetGIFandCSS_frame_width_BF()
                    If ii=>GetCSS_width_BF() : ii=0 : iii+GetGIFandCSS_frame_height_BF() : EndIf
                    
                  Next
                  SetGadgetColor(frame_info_1, #PB_Gadget_FrontColor, 0)
                  
                EndIf
                
                If IsImage(temporary_frame_4_ID) : FreeImage(temporary_frame_4_ID) : EndIf
                
              Else ; Image
                
                calculate_output_rectangle
                
                calculate_clip_max_output
                
                temporary_frame_2_ID=GrabImage(temporary_frame_3_ID, #PB_Any,
                                               Int(original_width/200*GetGadgetState(trackbar_partition_x)),
                                               Int(original_height/200*GetGadgetState(trackbar_partition_y)),
                                               clip_max_x_output,
                                               clip_max_y_output) 
                
                If Not temporary_frame_2_ID
                  MessageRequester("Error", "Cannot grab partition from image")
                  save_mode=-1
                EndIf 
                
                If save_result<>2 
                  If save_mode<>-1
                    If Not swap_partition Or Not clip_max_x_output Or Not clip_max_y_output
                      result=Image_coloring_BF(temporary_frame_2_ID, temporary_frame_2_ID,
                                               change_red,
                                               change_green,
                                               change_blue,
                                               change_contrast,
                                               change_brightness,
                                               change_intensity,
                                               mode_grey)
                      If result<0
                        MessageRequester("Error", "Cannot colorize image")
                        save_mode=-1
                      EndIf 
                    EndIf
                  EndIf
                  
                  
                  If save_mode<>-1
                    If (GetGadgetText(string_gadget_resized_x)<>"" Or GetGadgetText(string_gadget_resized_y)<>"")
                      If sprite_mode=1
                        result=ResizeImage(temporary_frame_2_ID, resized_x, resized_y, #PB_Image_Raw)
                      Else
                        result=ResizeImage(temporary_frame_2_ID, resized_x, resized_y)
                      EndIf
                      If Not result
                        MessageRequester("Error", "Cannot resize image")
                        save_mode=-1
                      EndIf
                    EndIf
                  EndIf
                EndIf
                
                SetGadgetState(trackbar_partition_x, GetGadgetData(trackbar_partition_x))
                SetGadgetState(trackbar_partition_y, GetGadgetData(trackbar_partition_y))
                SetGadgetState(trackbar_partition_width, GetGadgetData(trackbar_partition_width))
                SetGadgetState(trackbar_partition_height, GetGadgetData(trackbar_partition_height))
                
                If save_result=2 ; Rectangle snipping - Image
                  If loaded_frame_ID : FreeImage(loaded_frame_ID) : loaded_frame_ID=0 : EndIf
                  If loaded_frame_state_alpha
                    loaded_frame_ID=CreateImage(#PB_Any, ImageWidth(temporary_frame_2_ID), ImageHeight(temporary_frame_2_ID), 32, #PB_Image_Transparent)
                  Else
                    loaded_frame_ID=CreateImage(#PB_Any, ImageWidth(temporary_frame_2_ID), ImageHeight(temporary_frame_2_ID))
                  EndIf
                  If loaded_frame_ID
                    CopyContent_Image_Image_BF(temporary_frame_2_ID, loaded_frame_ID)
                  EndIf
                  If mirror=1
                    Mirror_and_Copy_BF(1, loaded_frame_ID)
                  ElseIf mirror=2
                    Mirror_and_Copy_BF(2, loaded_frame_ID)
                  EndIf
                  If Val(GetGadgetText(rotate_loaded_frame))
                    If loaded_frame_state_alpha
                      ActivateAlphaChannel_BF(1)
                    EndIf
                    RotateSprite_BF(loaded_frame_ID,
                                    0,
                                    0,
                                    Val(GetGadgetText(rotate_loaded_frame)))
                    ActivateAlphaChannel_BF(0)
                  EndIf
                EndIf
                
              EndIf
              
              If save_result<>2 And Not create_frames_separately
                
                #can_not_save_image="Cannot save image" : #can_not_create_info_file="Cannot create info file"
                
                If GetGadgetState(option_gadget_alpha_png) ; Low priority without other checks
                  temporary_frame_4_ID=CreateAlphaImage_from_Sprite_BF(temporary_frame_2_ID,
                                                                       color_distance_sprite_mask,
                                                                       invisible_gif_color,
                                                                       loaded_alpha,
                                                                       1)
                  
                  If IsImage(temporary_frame_4_ID) : temporary_frame_2_ID=temporary_frame_4_ID : EndIf
                EndIf
                
                Select save_mode
                  Case 0
                    path$+".png"
                    If sheet
                      If Not SaveImage(temporary_frame_2_ID, path$, #PB_ImagePlugin_PNG) : MessageRequester("Error", #can_not_save_image)
                      Else
                        If Not CreateDataFile(0, path$, "png") : MessageRequester("Error", #can_not_create_info_file) : EndIf
                      EndIf
                    Else
                      If Not SaveImage(temporary_frame_2_ID, path$, #PB_ImagePlugin_PNG) : MessageRequester("Error", #can_not_save_image) : EndIf
                    EndIf
                  Case 1
                    path$+".jpg"
                    If sheet
                      If Not SaveImage(temporary_frame_2_ID, path$, #PB_ImagePlugin_JPEG) : MessageRequester("Error", #can_not_save_image)
                      Else
                        If Not CreateDataFile(0, path$, "jpg") : MessageRequester("Error", #can_not_create_info_file) : EndIf
                      EndIf
                    Else
                      If Not SaveImage(temporary_frame_2_ID, path$, #PB_ImagePlugin_JPEG) : MessageRequester("Error", #can_not_save_image) : EndIf
                    EndIf
                  Case 2
                    path$+".bmp"
                    If sheet
                      If Not SaveImage(temporary_frame_2_ID, path$, #PB_ImagePlugin_BMP) : MessageRequester("Error", #can_not_save_image)
                      Else
                        If Not CreateDataFile(0, path$, "bmp") : MessageRequester("Error", #can_not_create_info_file) : EndIf
                      EndIf
                    Else
                      If Not SaveImage(temporary_frame_2_ID, path$, #PB_ImagePlugin_BMP) : MessageRequester("Error", #can_not_save_image) : EndIf
                    EndIf
                EndSelect
                
                If sprite_mode And image
                  WriteColorDistanceValue_BF(path$, color_distance_sprite_mask)
                EndIf
                
              EndIf
              
              If IsImage(temporary_frame_2_ID) : FreeImage(temporary_frame_2_ID) : EndIf
              If IsImage(temporary_frame_4_ID) : FreeImage(temporary_frame_4_ID) : EndIf
              If IsImage(temporary_frame_5_ID) : FreeImage(temporary_frame_5_ID) : EndIf
              
              SetCSS_width_BF(old_css_width)
              SetCSS_height_BF(old_css_height)
              SetGIFandCSS_frame_width_BF(old_frame_width)
              SetGIFandCSS_frame_height_BF(old_frame_height)
              SetGIFandCSS_frames_BF(old_frames)
              SetFrames_in_a_row_BF(old_frames_in_a_row)
              
              DisableGadget(container_gadget_1, 0)
              
            EndIf
            If save_result=2 : coloring_changed=2 : EndIf
            save_result=0
            save_mode=0
          EndIf
        EndIf
        ; End window timer ----------
        
        If win_event=#PB_Event_GadgetDrop
          SetEnvironmentVariable(#EnvironmentVariable, EventDropFiles())
          RunProgram(ProgramFilename())
        EndIf
        
        If win_event=#PB_Event_Gadget
          Select EventGadget()
            Case trackbar_frame 
              frame=GetGadgetState(trackbar_frame)
              stop_animation=2
              HideGadget(button_gadget_delay, 1)
              HideGadget(string_gadget_delay, 0)
              delay_info$="Delay "+Str(frame_sprite_ID(frame, 1))
              SetGadgetText(delay_info_1, delay_info$)
              SetGadgetText(string_gadget_delay, Str(frame_sprite_ID(frame, 1)))
              CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
                coloring_changed=2
              CompilerEndIf
            Case trackbar_red 
              change_red=GetGadgetState(trackbar_red)-100
              SetGadgetText(text_red, "Red  "+change_red)
              stop_animation=2
              coloring_changed=1
            Case trackbar_green 
              change_green=GetGadgetState(trackbar_green)-100
              SetGadgetText(text_green, "Green  "+change_green)
              stop_animation=2
              coloring_changed=1
            Case trackbar_blue 
              change_blue=GetGadgetState(trackbar_blue)-100
              SetGadgetText(text_blue, "Blue  "+change_blue)
              stop_animation=2
              coloring_changed=1
            Case trackbar_contrast 
              change_contrast=GetGadgetState(trackbar_contrast)-100
              SetGadgetText(text_contrast, "Contrast  "+change_contrast)
              stop_animation=2
              coloring_changed=1
            Case trackbar_brightness 
              change_brightness.f=GetGadgetState(trackbar_brightness)-100
              SetGadgetText(text_brightness, "Brightness  "+change_brightness)
              stop_animation=2
              coloring_changed=1
            Case trackbar_intensity 
              change_intensity=GetGadgetState(trackbar_intensity)-100
              SetGadgetText(text_intensity, "Intensity  "+change_intensity)
              stop_animation=2
              coloring_changed=1
            Case trackbar_partition_x 
              partition_x=GetGadgetState(trackbar_partition_x)
              partition_x=Int(partition_x/200*output_width)
              SetGadgetText(text_partition_x, "Partition X  "+Str(Int(original_width/200*GetGadgetState(trackbar_partition_x))))
              stop_animation=2
              coloring_changed=1
            Case trackbar_partition_y 
              partition_y=GetGadgetState(trackbar_partition_y)
              partition_y=Int(partition_y/200*output_height)
              SetGadgetText(text_partition_y, "Partition Y  "+Str(Int(original_height/200*GetGadgetState(trackbar_partition_y))))
              stop_animation=2
              coloring_changed=1
            Case trackbar_partition_width 
              partition_width=GetGadgetState(trackbar_partition_width)
              partition_width=Int(partition_width/200*output_width)
              If partition_width<1 : partition_width=1 : EndIf
              SetGadgetText(text_partition_width, "Partition width  "+Str(Int(original_width/200*GetGadgetState(trackbar_partition_width))))
              stop_animation=2
              coloring_changed=1
            Case trackbar_partition_height 
              partition_height=GetGadgetState(trackbar_partition_height)
              partition_height=Int(partition_height/200*output_height)
              If partition_height<1 : partition_height=1 : EndIf
              SetGadgetText(text_partition_height, "Partition height  "+Str(Int(original_height/200*GetGadgetState(trackbar_partition_height))))
              stop_animation=2
              coloring_changed=1
            Case trackbar_color_distance
              If sprite_mode
                color_distance_sprite_mask=GetGadgetState(trackbar_color_distance)
                SetGadgetText(text_color_distance, "Color distance "+color_distance_sprite_mask)
                SetColorDistanceSpriteMask_BF(color_distance_sprite_mask)
              Else
                color_distance_image_mode=GetGadgetState(trackbar_color_distance)
                SetGadgetText(text_color_distance, "Color distance "+color_distance_image_mode)
              EndIf
              If Not sheet
                stop_animation=2
                coloring_changed=1
              EndIf
            Case option_gadget_color 
              mode_grey=0
              stop_animation=2
              coloring_changed=1
            Case option_gadget_grey_1 
              mode_grey=1
              stop_animation=2
              coloring_changed=1
            Case option_gadget_grey_2
              mode_grey=2
              stop_animation=2
              coloring_changed=1
            Case option_gadget_grey_3 
              mode_grey=3
              stop_animation=2
              coloring_changed=1
            Case option_gadget_inside 
              swap_partition=0
              stop_animation=2
              coloring_changed=1
            Case option_gadget_outside
              swap_partition=1
              stop_animation=2
              coloring_changed=1
            Case option_gadget_png, option_gadget_alpha_png
              save_mode=0 ; png 
            Case option_gadget_jpg
              save_mode=1 ; jpg
            Case option_gadget_bmp 
              save_mode=2 ; bmp
            Case option_gadget_image_mode
              SetGadgetText(text_color_distance, "Color distance "+color_distance_image_mode)
              SetGadgetState(trackbar_color_distance, color_distance_image_mode)
              ResizeInterpolation_BF(1)
              sprite_mode=0
              stop_animation=2
              coloring_changed=1 
            Case option_gadget_sprite_mode
              SetGadgetText(text_color_distance, "Color distance "+color_distance_sprite_mask)
              SetColorDistanceSpriteMask_BF(color_distance_sprite_mask)
              SetGadgetState(trackbar_color_distance, color_distance_sprite_mask)
              ResizeInterpolation_BF(0)
              sprite_mode=1
              stop_animation=2
              coloring_changed=1
            Case button_gadget_reset
              partition_x.f=0
              partition_y.f=0
              partition_width.f=output_width
              partition_height.f=output_height
              swap_partition=0
              change_red.f=0
              change_green.f=0
              change_blue.f=0
              change_contrast.f=0
              change_brightness.f=0
              change_intensity.f=0
              mode_grey=0
              sprite_mode=0
              frame=0
              point_x_pos=-20
              point_y_pos=-20
              color_distance_sprite_mask=0
              color_distance_image_mode=0
              invisible_gif_color=old_invisible_gif_color_1
              SetGadgetText(text_red, "Red  0") : SetGadgetState(trackbar_red, 100)
              SetGadgetText(text_green, "Green  0") :SetGadgetState(trackbar_green, 100)
              SetGadgetText(text_blue, "Blue  0") : SetGadgetState(trackbar_blue, 100)
              SetGadgetText(text_contrast, "Contrast  0") : SetGadgetState(trackbar_contrast, 100)
              SetGadgetText(text_brightness, "Brightness  0") : SetGadgetState(trackbar_brightness, 100)
              SetGadgetText(text_intensity, "Intensity  0") : SetGadgetState(trackbar_intensity, 100)
              SetGadgetText(text_partition_x, "Partition X  0") : SetGadgetState(trackbar_partition_x, 0)
              SetGadgetText(text_partition_y, "Partition Y  0") : SetGadgetState(trackbar_partition_y, 0)
              SetGadgetText(text_partition_width, "Partition width  "+original_width) : SetGadgetState(trackbar_partition_width, 200)
              SetGadgetText(text_partition_height, "Partition height  "+original_height) : SetGadgetState(trackbar_partition_height, 200)
              SetGadgetText(text_color_distance, "Color distance  0") : SetGadgetState(trackbar_color_distance, 0)
              SetGadgetState(option_gadget_color, 1)
              SetGadgetState(option_gadget_outside, 1)
              SetGadgetState(option_gadget_image_mode, 1)
              SetColorDistanceSpriteMask_BF(0)
              DisableGadget(trackbar_color_distance, 1) 
              Delay_BF(1, -1)
              If loaded_frame_ID : FreeImage(loaded_frame_ID) : loaded_frame_ID=0 : EndIf
              Select preset_save_mode
                Case 0 : SetGadgetState(option_gadget_png, 1) ; png
                Case 1 : SetGadgetState(option_gadget_jpg, 1) ; jpg
                Case 2 : SetGadgetState(option_gadget_bmp, 1) ; bmp
              EndSelect
              CopyContent_Image_Image_BF(backup_image_ID, image_ID)
              CopyContent_Image_Image_BF(backup_image_ID, temporary_frame_3_ID)
              coloring_changed=1
              stop_animation=0 ; This refresh the temporary frames directly without leave the GUI
            Case button_gadget_more
              ; Selection window -----------------------------
              
              If loaded_frame_ID
                DisableGadget(write_loaded_frame, 0)
                DisableGadget(delete_loaded_frame, 0)
                DisableGadget(write_and_delete_loaded_frame, 0)
                DisableGadget(catch_loaded_frame_as_texture, 0)
              Else
                DisableGadget(write_loaded_frame, 1)
                DisableGadget(delete_loaded_frame, 1)
                DisableGadget(write_and_delete_loaded_frame, 1)
                DisableGadget(catch_loaded_frame_as_texture, 1)
              EndIf
              If FileSize(GetHomeDirectory()+#SpriteToolBackground)>0
                DisableGadget(delete_background, 0)
              Else
                DisableGadget(delete_background, 1)
              EndIf
              
              If image
                DisableGadget(save_all_frames_separately, 1)
                DisableGadget(save_all_frames_as_sprite_sheet, 1)  
              Else        
                DisableGadget(save_all_frames_separately, 0)
                DisableGadget(save_all_frames_as_sprite_sheet, 0)
              EndIf
              
              If GetGadgetState(load_frame_with_alpha_channel)
                DisableGadget(create_rectangle, 1)
                DisableGadget(create_circle, 1)
                DisableGadget(import_text,1)
              Else
                DisableGadget(create_rectangle, 0)
                DisableGadget(create_circle, 0)
                DisableGadget(import_text, 0)
              EndIf
              
              If grabbed_texture_ID
                If sheet And use_texture
                  DisableGadget(use_fill_not_frame_selective, 1)
                  SetGadgetState(use_fill_all_frame_selective, 1)
                  use_fill_frame_selective=1
                EndIf
                DisableGadget(use_grabbed_texture, 0)
                DisableGadget(use_not_grabbed_texture, 0)
                If use_texture
                  SetGadgetState(use_grabbed_texture, 1)
                Else
                  SetGadgetState(use_not_grabbed_texture, 1)  
                EndIf
              Else
                DisableGadget(use_grabbed_texture, 1)
                DisableGadget(use_not_grabbed_texture, 1) 
              EndIf
              
              If image
                If transparent_fill         
                  SetGadgetState(transparent_fill_on, 1)
                EndIf
              Else
                DisableGadget(transparent_fill_on, 1)
                DisableGadget(transparent_fill_off, 1)
              EndIf
              
              StartDrawing(CanvasOutput(canvas_foreground_color_ID))
              Box(0, 0, 50, 50, foreground_color)
              StopDrawing()
              
              StartDrawing(CanvasOutput(canvas_background_color_ID))
              Box(0, 0, 50, 50, invisible_gif_color)
              StopDrawing()
              
              HideWindow(window_1_ID, 0)
              DisableGadget(container_gadget_1, 1)
              UseGadgetList(WindowID(window_1_ID))
              
              CompilerIf #PB_Compiler_OS=#PB_OS_Windows            
                SetImageGadget_BF(grabbed_texture_image_gadget_ID, grabbed_texture_ID,
                                  417,
                                  198,
                                  130,
                                  120,
                                  $DCDCDC,
                                  6,
                                  $FFFFFF,
                                  5,
                                  21)
              CompilerElse
                SetImageGadget_BF(grabbed_texture_image_gadget_ID, grabbed_texture_ID,
                                  420,
                                  200,
                                  130,
                                  120,
                                  $DCDCDC,
                                  6,
                                  $FFFFFF,
                                  5,
                                  21)
              CompilerEndIf
              
              Repeat
                
                win_event=WaitWindowEvent()
                If win_event=#PB_Event_Gadget
                  Select EventGadget() ; Start select --------
                    Case load_new_image
                      path$=OpenFileRequester("Load new image, BF CSS sprite sheet, or GIF", "", "", 0)
                      If path$<>""
                        HideWindow(window_1_ID, 1)
                        SetEnvironmentVariable(#EnvironmentVariable, path$)
                        RunProgram(ProgramFilename())
                        Break
                      EndIf
                    Case load_background
                      path$=OpenFileRequester("Load background texture or image", "", "", 0)
                      texture_ID=0
                      If path$<>""
                        HideWindow(window_1_ID, 1)
                        texture_ID=LoadPhoto_BF(path$)
                        If texture_ID
                          SaveImage(texture_ID, GetHomeDirectory()+#SpriteToolBackground)
                          FitImage_BF(3,
                                      texture_ID,
                                      100,                ; Fit image to this width
                                      100)                ; Fit image to this height
                          ResizeImage(texture_ID, GetFitSize_Width_BF(), GetFitSize_Height_BF())
                        EndIf
                        If Not texture_ID
                          create_background
                        EndIf
                        use_created_background
                        Break
                      EndIf
                    Case delete_background
                      DeleteFile(GetHomeDirectory()+#SpriteToolBackground)
                      create_background
                      use_created_background
                      Break
                    Case load_frame
                      path$=OpenFileRequester("Load frame", "", "", 0)
                      If path$<>""
                        HideWindow(window_1_ID, 1)
                        loaded_frame_ID=LoadPhoto_BF(path$)
                        If loaded_frame_ID
                          If UCase(GetExtensionPart(path$))="GIF"
                            temp_frame_ID=CreateImage(#PB_Any, ImageWidth(loaded_frame_ID), ImageHeight(loaded_frame_ID), 32)
                            If Not temp_frame_ID
                              ProcedureReturn -6
                            EndIf
                            If StartDrawing(ImageOutput(temp_frame_ID))
                              DrawAlphaImage(ImageID(loaded_frame_ID), 0, 0)
                              StopDrawing()
                              Swap loaded_frame_ID, temp_frame_ID
                              FreeImage(temp_frame_ID)
                            Else
                              ProcedureReturn -3
                            EndIf
                          EndIf
                          If mirror=1
                            Mirror_and_Copy_BF(1, loaded_frame_ID)
                          ElseIf mirror=2
                            Mirror_and_Copy_BF(2, loaded_frame_ID)
                          EndIf
                          If Val(GetGadgetText(rotate_loaded_frame))
                            If loaded_frame_state_alpha
                              ActivateAlphaChannel_BF(1)
                            EndIf
                            RotateSprite_BF(loaded_frame_ID,
                                            0,
                                            0,
                                            Val(GetGadgetText(rotate_loaded_frame)))
                            ActivateAlphaChannel_BF(0)
                          EndIf
                          If Not swap_partition
                            Image_coloring_BF(loaded_frame_ID, loaded_frame_ID,
                                              change_red,
                                              change_green,
                                              change_blue,
                                              change_contrast,
                                              change_brightness,
                                              change_intensity,
                                              mode_grey)
                          EndIf
                          DisableGadget(catch_loaded_frame_as_texture, 0)
                          
                          SetGadgetState(trackbar_partition_width, 200/output_width*ImageWidth(loaded_frame_ID))
                          partition_width=GetGadgetState(trackbar_partition_width)
                          partition_width=Int(partition_width/200*output_width)
                          If partition_width<1 : partition_width=1 : EndIf
                          SetGadgetText(text_partition_width, "Partition width  "+Str(Int(original_width/200*GetGadgetState(trackbar_partition_width))))
                          
                          SetGadgetState(trackbar_partition_height, 200/output_height*ImageHeight(loaded_frame_ID))
                          partition_height=GetGadgetState(trackbar_partition_height)
                          partition_height=Int(partition_height/200*output_height)
                          If partition_height<1 : partition_height=1 : EndIf
                          SetGadgetText(text_partition_height, "Partition height  "+Str(Int(original_height/200*GetGadgetState(trackbar_partition_height))))
                          
                          coloring_changed=1
                          stop_animation=2 
                          
                        EndIf
                        Break
                      EndIf
                    Case write_loaded_frame, write_and_delete_loaded_frame
                      If loaded_frame_ID
                        add_undo
                        HideWindow(window_1_ID, 1)
                        If sprite_mode=1 
                          ResizeImage(loaded_frame_ID, Int(original_width/200*GetGadgetState(trackbar_partition_width)), Int(original_height/200*GetGadgetState(trackbar_partition_height)), #PB_Image_Raw)
                        Else
                          ResizeImage(loaded_frame_ID, Int(original_width/200*GetGadgetState(trackbar_partition_width)), Int(original_height/200*GetGadgetState(trackbar_partition_height)))
                        EndIf
                        
                        calculate_frame_offsets
                        
                        old_color_distance=color_distance_sprite_mask
                        SetColorDistanceSpriteMask_BF(color_distance_image_mode)
                        
                        If image
                          
                          If loaded_frame_state_alpha And Not sprite_mode
                            loaded_frame_state_alpha_1=2
                          Else
                            loaded_frame_state_alpha_1=1
                          EndIf
                          
                          ErrorCheck_BF(SpriteSimple_BF(loaded_frame_state_alpha_1, image_ID, loaded_frame_ID,
                                                        -1,                    
                                                        invisible_gif_color,
                                                        original_width/200*GetGadgetState(trackbar_partition_x)+frame_offset_x-1,  ; Output position x
                                                        original_height/200*GetGadgetState(trackbar_partition_y)+frame_offset_y-1, ; Output position y
                                                        0,
                                                        0,
                                                        loaded_alpha,
                                                        0,
                                                        0,
                                                        0,
                                                        0,
                                                        original_width-Int(original_width/200*GetGadgetState(trackbar_partition_x)), ; Clip output x
                                                        original_height-Int(original_height/200*GetGadgetState(trackbar_partition_y)))) ; Clip output y
                          
                        Else
                          
                          ErrorCheck_BF(SpriteSimple_fast_BF(loaded_alpha, image_ID, loaded_frame_ID,
                                                             -1,                    
                                                             invisible_gif_color,
                                                             original_width/200*GetGadgetState(trackbar_partition_x)+frame_offset_x-1,  ; Output position x
                                                             original_height/200*GetGadgetState(trackbar_partition_y)+frame_offset_y-1, ; Output position y
                                                             0, 
                                                             0,
                                                             0,
                                                             0,
                                                             original_width-Int(original_width/200*GetGadgetState(trackbar_partition_x)), ; Clip output x
                                                             original_height-Int(original_height/200*GetGadgetState(trackbar_partition_y)))) ; Clip output y
                          
                        EndIf     
                        
                        CopyContent_Image_Image_BF(image_ID, temporary_frame_3_ID)
                        
                        SetColorDistanceSpriteMask_BF(old_color_distance)                  
                        
                        stop_animation=2
                        coloring_changed=1
                        If EventGadget()=write_and_delete_loaded_frame
                          FreeImage(loaded_frame_ID) : loaded_frame_ID=0
                          DisableGadget(catch_loaded_frame_as_texture, 1)
                        EndIf
                      EndIf
                      Break 
                    Case delete_loaded_frame
                      FreeImage(loaded_frame_ID) : loaded_frame_ID=0
                      DisableGadget(catch_loaded_frame_as_texture, 1)
                      Break
                    Case create_empty_sheet_or_image
                      If Val(GetGadgetText(set_frame_width)) And  Val(GetGadgetText(set_frame_height))
                        path$=SaveFileRequester("Save as BF sprite sheet with additional data file or image",
                                                GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension), "", 0)
                        If path$<>""
                          HideWindow(window_1_ID, 1)
                          old_css_width=GetCSS_width_BF()
                          old_css_height=GetCSS_height_BF()
                          old_frame_width=GetGIFandCSS_frame_width_BF()
                          old_frame_height=GetGIFandCSS_frame_height_BF()
                          old_frames=GetGIFandCSS_frames_BF()
                          old_frames_in_a_row=GetFrames_in_a_row_BF()
                          result=MessageRequester("Select", "Do you want create a sprite sheet or image with alpha channel ?",
                                                  #PB_MessageRequester_YesNo)
                          If result=#PB_MessageRequester_Yes
                            ActivateAlphaChannel_BF(1) 
                          EndIf
                          
                          CreateEmptyCSSandDataSheet_BF(path$, invisible_gif_color, Val(GetGadgetText(set_number_of_frames)), Val(GetGadgetText(set_frame_width)), Val(GetGadgetText(set_frame_height)))
                          
                          ActivateAlphaChannel_BF(0)
                          
                          SetCSS_width_BF(old_css_width)
                          SetCSS_height_BF(old_css_height)
                          SetGIFandCSS_frame_width_BF(old_frame_width)
                          SetGIFandCSS_frame_height_BF(old_frame_height)
                          SetGIFandCSS_frames_BF(old_frames)
                          SetFrames_in_a_row_BF(old_frames_in_a_row)
                          Break
                        EndIf
                      EndIf
                    Case save_all_frames_separately
                      create_frames_separately=1
                    Case save_all_frames_as_sprite_sheet
                      create_frames_separately=0
                    Case save_tool_result               
                      If sheet
                        path$=SaveFileRequester("Save as BF CSS sprite sheet with additional data file",
                                                GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension), "", 0)
                      Else
                        path$=SaveFileRequester("Save picture",
                                                GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension), "", 0)
                      EndIf
                      If path$<>""
                        save_result=1
                        SetGIFandCSS_color_distance_BF(color_distance_sprite_mask)
                        Break
                      EndIf
                    Case import_text
                      If GetClipboardText()<>""
                        If FontRequester(font_requester_font_name$, font_requester_font_size, #PB_FontRequester_Effects, foreground_color)
                          font_ID=LoadFont(#PB_Any, SelectedFontName(), SelectedFontSize())
                          If font_ID
                            If GetGadgetState(text_left) : text_alignment=0 : EndIf
                            If GetGadgetState(text_center) : text_alignment=1 : EndIf
                            If GetGadgetState(text_right) : text_alignment=2 : EndIf
                            If GetGadgetState(text_vertical) : text_alignment=3 : EndIf
                            Loaded_frame_ID=DrawTextCreateImage_BF(GetClipboardText(), SelectedFontColor(), invisible_gif_color, text_alignment, 0, font_ID, 0, 0, -1)
                            If loaded_frame_ID
                              If mirror=1
                                Mirror_and_Copy_BF(1, loaded_frame_ID)
                              ElseIf mirror=2
                                Mirror_and_Copy_BF(2, loaded_frame_ID)
                              EndIf
                              If Val(GetGadgetText(rotate_loaded_frame))
                                RotateSprite_BF(loaded_frame_ID, 
                                                0,
                                                0,
                                                Val(GetGadgetText(rotate_loaded_frame)))
                              EndIf
                              DisableGadget(catch_loaded_frame_as_texture, 0)
                            EndIf
                            font_requester_font_name$=SelectedFontName()
                            font_requester_font_size=SelectedFontSize()
                            foreground_color=SelectedFontColor()
                            FreeFont(font_ID)
                            Break
                          Else
                            MessageRequester("Error" , "Cannot load the selected font")
                          EndIf
                        EndIf
                      Else
                        MessageRequester("Error" , "No text to import in clipboard")
                      EndIf
                    Case text_left
                      text_alignment=0
                    Case text_center
                      text_alignment=1
                    Case text_right
                      text_alignment=2
                    Case text_vertical
                      text_alignment=3
                    Case use_color_requester_foreground
                      old_foreground_color=foreground_color
                      result=MessageRequester("Change foreground color", "Do you want search a unused color ?"+#LF$+
                                                                         "A unused color ist needed for worry free replacing colors with textures",
                                              #PB_MessageRequester_YesNoCancel)
                      If result=#PB_MessageRequester_Yes
                        foreground_color=SearchUnusedImageColor_BF(temporary_frame_3_ID) 
                      ElseIf result=#PB_MessageRequester_YesNoCancel
                        Break
                      ElseIf result=#PB_MessageRequester_No
                        foreground_color=ColorRequester(old_foreground_color)
                      EndIf
                      If foreground_color=-1
                        foreground_color=old_foreground_color
                      Else
                        StartDrawing(CanvasOutput(canvas_foreground_color_ID))
                        Box(0, 0, 50, 50, foreground_color)
                        StopDrawing()
                      EndIf  
                    Case use_color_requester_invisible_color
                      old_invisible_gif_color=invisible_gif_color
                      result=MessageRequester("Change invisible color", "Do you want search a unused color ?"+#LF$+
                                                                        "A unused color ist needed for hole free sprites",
                                              #PB_MessageRequester_YesNoCancel)
                      If result=#PB_MessageRequester_Yes
                        invisible_gif_color=SearchUnusedImageColor_BF(temporary_frame_3_ID) 
                      ElseIf result=#PB_MessageRequester_YesNoCancel
                        Break
                      ElseIf result=#PB_MessageRequester_No
                        invisible_gif_color=ColorRequester(old_invisible_gif_color)
                      EndIf
                      If invisible_gif_color=-1
                        invisible_gif_color=old_invisible_gif_color
                      Else
                        StartDrawing(CanvasOutput(canvas_background_color_ID))
                        Box(0, 0, 50, 50, invisible_gif_color)
                        StopDrawing()
                      EndIf  
                      SetGIFandCSS_invisible_color_BF(invisible_gif_color)
                      SetInvisibleColor_BF(invisible_gif_color)
                    Case create_rectangle
                      loaded_frame_ID=CreateImage(#PB_Any, output_width, output_height, 24, foreground_color)
                      If loaded_frame_ID
                        If Val(GetGadgetText(rotate_loaded_frame))
                          RotateSprite_BF(loaded_frame_ID, 
                                          0,
                                          0,
                                          Val(GetGadgetText(rotate_loaded_frame)))
                        EndIf
                      EndIf
                      Break
                    Case create_circle
                      loaded_frame_ID=CreateImage(#PB_Any, output_width, output_height, 24, invisible_gif_color)
                      StartDrawing(ImageOutput(loaded_frame_ID))
                      Ellipse(ImageWidth(loaded_frame_ID)/2, ImageHeight(loaded_frame_ID)/2, ImageWidth(loaded_frame_ID)/2, ImageHeight(loaded_frame_ID)/2, foreground_color)
                      StopDrawing()
                      If loaded_frame_ID
                        If Val(GetGadgetText(rotate_loaded_frame))
                          RotateSprite_BF(loaded_frame_ID, 
                                          0,
                                          0,
                                          Val(GetGadgetText(rotate_loaded_frame)))
                        EndIf
                      EndIf
                      Break
                    Case help
                      #text=#LF$+"The BF sprite tool supports color distance to clean up sprite masks"+#LF$+
                            "Image size changes are applied when saving the image or sheet"+#LF$+                                                             
                            "Rotation and loaded fonts is done with interpolation"+#LF$+
                            "Interpolation artifacts remove simple with the color distance function"+#LF$+
                            "In sprite mode interpolation is disabled to prevent mask artifacts, in image mode activated"+#LF$+
                            "The mask of imported sprites is cleaned in image mode before they are inserted, so while they are still floating"+#LF$+
                            "Do not save sprites with mask for use with PB as a JPG image, because then artifacts will always appear in the mask"+#LF$+                                                                                                                      
                            "When used with BF it doesn't matter, BF can remove artifacts on demand with the integrated color distance function"+#LF$+                                                                                                                   
                            "Movie like sprite sheets can always be saved as JPG, they do not have a mask and therefore cannot be damaged"+#LF$+                                                      
                            "To apply changed delays or start the animation, use the mouse to leave the GUI"+#LF$+
                            "The color button is clickable on sprite mode to apply changed color distance"+#LF$+
                            "To disable frames, set the delays in the tool to zero - This also removes the frames when saving"+#LF$+
                            "To disable frames in the sprite sheet set the delays in the sheet to -1"+#LF$+
                            "To change the frame delays click on the frame trackbar"+#LF$+
                            "The tool can convert everything you can load to masked PNG with invisible color"+#LF$+
                            "Fill works on image and frame selective mode with clipping, the output is then always within the selection rectangle"+#LF$+
                            "In sprite mode everything is without interpolation, because of the color distance treatment"+#LF$+
                            "A right click on the canvas grab the selection rectangle content and put it to the loaded frame, with rotating and mirroring"+#LF$+
                            "To start the tool with an self defined empty sprite sheet or image simply close the file requester on start"+#LF$+
                            "The BucketFill function is alpha channel sensitive, this works also with textures and color distance, for nice softly overlays"+#LF$+
                            "For transparence BucketFill for alpha images set alpha bending in the sub menue - BF specific 256 = full transparence"
                      
                      text_image_1_ID=DrawTextCreateImage_BF(#text, #White, #Black, 1, 0, font_1, 0, 0, 40)
                      If text_image_1_ID
                        HideWindow(window_1_ID, 1)
                        TextureBrush_canvas_BF(2, canvas_ID, text_image_1_ID,
                                               window_width/2-ImageWidth(text_image_1_ID)/2,   ; Output pos x
                                               window_height/2-ImageHeight(text_image_1_ID)/2, ; Output pos y
                                               ImageWidth(text_image_1_ID),                    ; Texture or image width
                                               ImageHeight(text_image_1_ID),                   ; Texture or image height
                                               50,                                             ; Percent visibility
                                               50)                                             ; Delay for animation 
                        
                        Repeat
                          win_event=WaitWindowEvent()
                        Until EventType()=#PB_EventType_LeftButtonDown Or EventType()=#PB_EventType_RightButtonDown Or win_event=#PB_Event_CloseWindow
                        FreeImage(text_image_1_ID)
                      EndIf    
                      Break
                    Case use_fill_not_frame_selective
                      use_fill_frame_selective=0
                    Case use_fill_all_frame_selective
                      use_fill_frame_selective=1
                    Case load_frame_with_alpha_channel
                      loaded_frame_state_alpha=1
                      DisableGadget(create_rectangle, 1)
                      DisableGadget(create_circle, 1)
                      DisableGadget(import_text,1)       
                    Case load_frame_without_alpha_channel
                      loaded_frame_state_alpha=0 
                      DisableGadget(create_rectangle, 0)
                      DisableGadget(create_circle, 0)
                      DisableGadget(import_text, 0)
                    Case mirror_h
                      mirror=1
                    Case mirror_v
                      mirror=2
                    Case mirror_off
                      mirror=0
                    Case catch_loaded_frame_as_texture
                      grabbed_texture_ID=CreateImage(#PB_Any, ImageWidth(loaded_frame_ID), ImageHeight(loaded_frame_ID), 32, #PB_Image_Transparent)
                      If grabbed_texture_ID
                        CopyContent_Image_Image_BF(loaded_frame_ID, grabbed_texture_ID)
                        If sprite_mode=1 
                          ResizeImage(grabbed_texture_ID, Int(original_width/200*GetGadgetState(trackbar_partition_width)), Int(original_height/200*GetGadgetState(trackbar_partition_height)), #PB_Image_Raw)
                        Else
                          ResizeImage(grabbed_texture_ID, Int(original_width/200*GetGadgetState(trackbar_partition_width)), Int(original_height/200*GetGadgetState(trackbar_partition_height)))
                        EndIf
                        
                        CompilerIf #PB_Compiler_OS=#PB_OS_Windows
                          SetImageGadget_BF(grabbed_texture_image_gadget_ID, grabbed_texture_ID,
                                            417,
                                            198,
                                            130,
                                            120,
                                            $DCDCDC,
                                            6,
                                            $FFFFFF,
                                            5,
                                            21)
                        CompilerElse
                          SetImageGadget_BF(grabbed_texture_image_gadget_ID, grabbed_texture_ID,
                                            420,
                                            200,
                                            130,
                                            120,
                                            $DCDCDC,
                                            6,
                                            $FFFFFF,
                                            5,
                                            21)
                        CompilerEndIf
                        
                        DisableGadget(use_grabbed_texture, 0)
                        DisableGadget(use_not_grabbed_texture, 0)
                        SetGadgetState(use_grabbed_texture, 1)
                        
                        If sheet
                          DisableGadget(use_fill_not_frame_selective, 1)
                          SetGadgetState(use_fill_all_frame_selective, 1)
                          use_fill_frame_selective=1
                        EndIf
                        
                        ; This part is not needed, but better for understanding how fill works
                        FreeImage(loaded_frame_ID) : loaded_frame_ID=0
                        DisableGadget(catch_loaded_frame_as_texture, 1)
                        DisableGadget(write_loaded_frame, 1)
                        DisableGadget(delete_loaded_frame, 1)
                        DisableGadget(write_and_delete_loaded_frame, 1)
                        DisableGadget(catch_loaded_frame_as_texture, 1)
                        SetGadgetState(trackbar_partition_width, 200)
                        partition_width=GetGadgetState(trackbar_partition_width)
                        partition_width=Int(partition_width/200*output_width)
                        SetGadgetText(text_partition_width, "Partition width  "+Str(Int(original_width/200*GetGadgetState(trackbar_partition_width))))
                        SetGadgetState(trackbar_partition_height, 200)
                        partition_height=GetGadgetState(trackbar_partition_height)
                        partition_height=Int(partition_height/200*output_height)
                        SetGadgetText(text_partition_height, "Partition height  "+Str(Int(original_height/200*GetGadgetState(trackbar_partition_height))))
                        coloring_changed=1
                      EndIf
                    Case use_grabbed_texture         
                      If sheet
                        DisableGadget(use_fill_not_frame_selective, 1)
                        SetGadgetState(use_fill_all_frame_selective, 1)
                        use_fill_frame_selective=1
                      EndIf
                    Case use_not_grabbed_texture
                      If sheet And Not use_texture
                        DisableGadget(use_fill_not_frame_selective, 0)
                        use_fill_frame_selective=0
                      EndIf
                  EndSelect ; End select --------
                EndIf
                
                If GetGadgetState(use_grabbed_texture) And grabbed_texture_ID
                  use_texture=1
                Else
                  use_texture=0
                EndIf
                
              Until win_event=#PB_Event_CloseWindow
              
              If GetGadgetState(transparent_fill_on)
                transparent_fill=1
              Else
                transparent_fill=0
              EndIf
              TransparentFloodFill_BF(transparent_fill)
              
              loaded_alpha=Val(GetGadgetText(alpha_loaded_frame))+1
              
              If use_texture
                alpha_bucket_Fill=-loaded_alpha-1 
              EndIf
              
              HideWindow(window_1_ID, 1)
              DisableGadget(container_gadget_1, 0)
              UseGadgetList(WindowID(window_2_ID))
              ;-----------------------------------------------
            Case button_gadget_FloodFill 
              
              If use_texture
                replace_color=grabbed_texture_ID
                result=-2
              Else
                result=-1
                replace_color=ColorRequester(invisible_gif_color)
              EndIf
              
              If replace_color<>-1
                SetGadgetText(text_color_distance, "Color distance  0") : SetGadgetState(trackbar_color_distance, 0)
                SetColorDistanceFill_BF(color_distance_sprite_mask)
                add_undo
                calculate_frame_offsets
                If use_fill_frame_selective Or image
                  calculate_clip_max_output
                  x_pos=(point_x_pos-((window_width/2-output_width/2)))
                  y_pos=(point_y_pos-((window_height/2-output_height/2)))
                  ErrorCheck_BF(FloodFill_BF(result, image_ID, replace_color,
                                             (original_width/100)*(x_pos/(output_width/100))+frame_offset_x,
                                             (original_height/100)*(y_pos/(output_height/100))+frame_offset_y,
                                             original_width/200*GetGadgetState(trackbar_partition_x)+frame_offset_x,
                                             original_height/200*GetGadgetState(trackbar_partition_y)+frame_offset_y,
                                             clip_max_x_output,
                                             clip_max_y_output))
                  CopyContent_Image_Image_BF(image_ID, temporary_frame_3_ID)
                Else
                  x_pos=(point_x_pos-((window_width/2-output_width/2)))
                  y_pos=(point_y_pos-((window_height/2-output_height/2)))
                  ErrorCheck_BF(FloodFill_BF(result, image_ID, replace_color,
                                             (original_width/100)*(x_pos/(output_width/100))+frame_offset_x,
                                             (original_height/100)*(y_pos/(output_height/100))+frame_offset_y))
                  CopyContent_Image_Image_BF(image_ID, temporary_frame_3_ID)
                EndIf
                color_distance_sprite_mask=0
                SetColorDistanceFill_BF(-1)
                SetColorDistanceSpriteMask_BF(0)
                coloring_changed=2
                stop_animation=0 ; This refresh the temporary frames directly without leave the GUI
              EndIf
            Case button_gadget_BucketFill 
              
              If use_texture
                replace_color=grabbed_texture_ID
                result=alpha_bucket_fill
              Else
                result=-1
                replace_color=ColorRequester(invisible_gif_color)
              EndIf
              
              If replace_color<>-1
                SetGadgetText(text_color_distance, "Color distance  0") : SetGadgetState(trackbar_color_distance, 0)
                SetColor_BF(invisible_gif_color)
                SetColorDistanceFill_BF(color_distance_sprite_mask)
                add_undo
                If use_fill_frame_selective Or image
                  calculate_frame_offsets
                  calculate_clip_max_output
                  
                  If transparent_fill ; Needed for transparent BucketFill feature
                    ActivateBucketArray_BF(1)
                  EndIf
                  
                  ErrorCheck_BF(BF(result, image_ID, replace_color, -1, -1,
                                   original_width/200*GetGadgetState(trackbar_partition_x)+frame_offset_x,
                                   original_height/200*GetGadgetState(trackbar_partition_y)+frame_offset_y,
                                   clip_max_x_output,
                                   clip_max_y_output))
                  
                  If transparent_fill ; Transparent BucketFill feature
                    StartDrawing(ImageOutput(image_ID))
                    DrawingMode(#PB_2DDrawing_AlphaChannel)
                    For y=GetBucket_Y_BF() To GetBucket_YY_BF()
                      For x=GetBucket_X_BF() To GetBucket_XX_BF()
                        If GetBucketArray_Point_BF(x, y) ; Read the BF BucketFill array
                          Plot(x, y, RGBA(0, 0, 0, loaded_alpha)) 
                        EndIf
                      Next x
                    Next y
                    StopDrawing()
                    ActivateBucketArray_BF(0)
                  EndIf
                  
                  CopyContent_Image_Image_BF(image_ID, temporary_frame_3_ID)
                Else
                  ErrorCheck_BF(BF(result, image_ID, replace_color, -1))
                  CopyContent_Image_Image_BF(image_ID, temporary_frame_3_ID)
                EndIf
                SetColor_BF(-1)
                color_distance_sprite_mask=0
                SetColorDistanceFill_BF(-1)
                SetColorDistanceSpriteMask_BF(0)
                coloring_changed=2
                stop_animation=0 ; This refresh the temporary frames directly without leave the GUI
              EndIf  
            Case button_gadget_delay
              path$=OpenFileRequester("Select the corresponding 'sheet_info_BF' file for changing frame delays",
                                      GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension), "", 0)
              If path$<>""
                If ReadSheetInfoFile_BF(path$)=1 
                  For i=0 To GetGIFandCSS_frames_BF()-1
                    If i>ArraySize(frame_sprite_ID()) : Break : EndIf
                    If GetGIFandCSS_delay_array_BF(i)=-1
                      frame_sprite_ID(i, 1)=0
                    Else
                      frame_sprite_ID(i, 1)=GetGIFandCSS_delay_array_BF(i)
                    EndIf
                  Next
                EndIf
              EndIf
            Case button_gadget_undo
              If ListSize(undo())
                LastElement(undo())
                CopyContent_Image_Image_BF(undo()\undo_1, image_ID)
                CopyContent_Image_Image_BF(undo()\undo_2, temporary_frame_3_ID)
                FreeImage(undo()\undo_1)
                FreeImage(undo()\undo_2)
                DeleteElement(undo())
              EndIf
              SetGadgetText(button_gadget_undo, "Undo "+Str(ListSize(undo())))
              coloring_changed=1
              stop_animation=0 ; This refresh the temporary frames directly without leave the GUI
            Case canvas_ID
              If EventType()=#PB_EventType_LeftButtonDown
                ; Or (EventType()=#PB_EventType_MouseMove And GetGadgetAttribute(canvas_ID, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
                
                point_x_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseX)
                point_y_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseY)
                
                If point_x_pos=>min_output_x And point_y_Pos=>min_output_y And point_x_pos<=max_x_output And point_y_pos<=max_y_output
                  grab_color=1
                EndIf
              EndIf
              If  EventType()=#PB_EventType_RightButtonDown
                If show_loaded_frame
                  FreeImage(loaded_frame_ID) : loaded_frame_ID=0
                Else
                  save_result=2
                EndIf
              EndIf
            Case canvas_1_ID
              If sprite_mode And color_distance_sprite_mask And EventType()=#PB_EventType_LeftButtonDown
                If MessageRequester("Color distance", "Do you want change the color distance ?", #PB_MessageRequester_YesNo)=#PB_MessageRequester_Yes
                  add_undo
                  SetGadgetText(text_color_distance, "Color distance  0") : SetGadgetState(trackbar_color_distance, 0)
                  SetColor_BF(invisible_gif_color)
                  SetColorDistanceFill_BF(color_distance_sprite_mask)
                  ErrorCheck_BF(BF(-1, image_ID, invisible_gif_color, -1))
                  ErrorCheck_BF(BF(-1, temporary_frame_3_ID, invisible_gif_color, -1))
                  SetColor_BF(-1)
                  color_distance_sprite_mask=0
                  SetColorDistanceFill_BF(-1)
                  SetColorDistanceSpriteMask_BF(0)
                  SetGIFandCSS_invisible_color_BF(invisible_gif_color)
                  SetInvisibleColor_BF(invisible_gif_color)
                  coloring_changed=2
                  stop_animation=2
                EndIf
              EndIf
          EndSelect
        EndIf
        
        If coloring_changed
          While WindowEvent() : Wend
          Goto restart:
        EndIf
        
        Macro common_output
          CopyContent_Image_Image_BF(background_ID, animation_buffer_ID)
          
          If sprite_mode
            ErrorCheck_BF(SpriteSimple_fast_BF(1, animation_buffer_ID, source_ID,                                     
                                               -1,                  ; Grab transparence color from sprite pos x - For preset set ..x=-1                      
                                               invisible_gif_color, ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                               min_output_x,        ; Output position x
                                               min_output_y))       ; Output position y
            
          Else
            StartDrawing(ImageOutput(animation_buffer_ID))
            DrawAlphaImage(ImageID(source_ID), min_output_x, min_output_y)
            StopDrawing()
          EndIf
          
          If loaded_frame_ID And clip_max_x_output And clip_max_y_output And show_loaded_frame
            
            If loaded_frame_state_alpha And Not sprite_mode
              loaded_frame_state_alpha_1=2
            Else
              loaded_frame_state_alpha_1=1
            EndIf
            
            old_color_distance=color_distance_sprite_mask
            SetColorDistanceSpriteMask_BF(color_distance_image_mode)
            ErrorCheck_BF(SpriteSimple_BF(loaded_frame_state_alpha_1, animation_buffer_ID, loaded_frame_ID, ; Works a litle other as SpriteSimple_fast_BF - BF core based, with automatic tiling
                                          -1,
                                          invisible_gif_color,
                                          Int(partition_x+(window_width/2-output_width/2))+1,
                                          Int(partition_y+(window_height/2-output_height/2)),
                                          partition_width,
                                          partition_height,
                                          temporary_loaded_alpha,
                                          clip_max_x_output,
                                          clip_max_y_output)) 
            SetColorDistanceSpriteMask_BF(old_color_distance)
          EndIf
          
          If Not grab_color
            StartDrawing(ImageOutput(animation_buffer_ID))
            box_go_line_go
            StopDrawing()
          EndIf
          
          CopyContent_Image_Canvas_fast_BF(animation_buffer_ID, canvas_ID) 
          
          If grab_color
            grab_color=0
            invisible_gif_color=GetCanvasColor_BF(canvas_ID, point_x_pos, point_y_pos)
            SetGIFandCSS_invisible_color_BF(invisible_gif_color)
            SetInvisibleColor_BF(invisible_gif_color)
          EndIf
          
        EndMacro
        
        If image
          
          If sprite_mode
            source_ID=temporary_frame_1_ID 
            
            common_output
            
          Else
            CopyContent_Image_Image_BF(background_ID, temporary_frame_ID)
            StartDrawing(ImageOutput(temporary_frame_ID))
            DrawAlphaImage(ImageID(temporary_frame_1_ID), min_output_x, min_output_y)
            StopDrawing()
            If loaded_frame_ID And clip_max_x_output And clip_max_y_output And show_loaded_frame
              
              If loaded_frame_state_alpha And Not sprite_mode
                loaded_frame_state_alpha_1=2
              Else
                loaded_frame_state_alpha_1=1
              EndIf
              
              old_color_distance=color_distance_sprite_mask
              SetColorDistanceSpriteMask_BF(color_distance_image_mode)
              ErrorCheck_BF(SpriteSimple_BF(loaded_frame_state_alpha_1, temporary_frame_ID, loaded_frame_ID,
                                            -1,
                                            invisible_gif_color,
                                            partition_x+(window_width/2-output_width/2),
                                            partition_y+(window_height/2-output_height/2),
                                            partition_width,
                                            partition_height,
                                            temporary_loaded_alpha,
                                            clip_max_x_output,
                                            clip_max_y_output)) 
              SetColorDistanceSpriteMask_BF(old_color_distance)
            EndIf
            
            If Not grab_color
              StartDrawing(ImageOutput(temporary_frame_ID))
              box_go_line_go
              StopDrawing()
            EndIf
            
            CopyContent_Image_Canvas_fast_BF(temporary_frame_ID, canvas_ID)
            
            If grab_color
              grab_color=0
              invisible_gif_color=GetCanvasColor_BF(canvas_ID, point_x_pos, point_y_pos)
              SetGIFandCSS_invisible_color_BF(invisible_gif_color)
              SetInvisibleColor_BF(invisible_gif_color)
            EndIf
            
          EndIf 
          
        Else
          
          If frame_sprite_ID(frame, 1)
            
            source_ID=frame_sprite_ID(frame, 0)
            
            common_output
            
          EndIf
          
        EndIf
        
        If Delay_BF(2, 25) ; BoxGo - LineGo delay
          move=(move+1)%16
          move_1=Mod(move_1+0.5, 8)
        EndIf
        
        ; Frame delay - Using BF timer 1
        If delay : delay=0 : If Not stop_animation : frame+1 : EndIf : If frame=>frames : frame=0 : EndIf : Else : delay+Delay_BF(1, frame_sprite_ID(frame, 1)) : EndIf
        
      ForEver
    EndProcedure
    
  EndModule
  UseModule SpriteTool_BF
  
  #EnvironmentVariable="CSS_sprite_tool_BF"
  Define path$=GetEnvironmentVariable(#EnvironmentVariable)
  SpriteTool_BF(path$)
  
CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 1298
; FirstLine = 1271
; Folding = ------
; EnableXP
; Executable = ..\SpriteTool_BF.exe
; DisableDebugger