﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Load a image with mask as sprite
;   This works not with sprites or pictures without mask
;   For some other pictures it is available you must change the color distance for the sprite mask
;   The resulted output is monochrome or with alpha belending colored !

EnableExplicit

Define window_ID, win_event, texture_ID, texture_1_ID, texture_2_ID, background_ID
Define image_x, image_y, image_width, image_height, point, i, ii, iii

#SoilWall="./Image_Set/soil_wall.jpg"
#Caisse="./Image_Set/Caisse.png"
#Lion="./Image_Set/Lion.jpg"

; Presets
image_width=900 : image_height=600

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

; - Call function #1 -
texture_ID=LoadImage(#PB_Any, #SoilWall)
texture_1_ID=LoadImage(#PB_Any, #Lion)
texture_2_ID=LoadImage(#PB_Any, #Caisse)

ErrorCheck_BF(BF(-2, background_ID, texture_ID))

Define alpha=80              ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
Define texture_width=0       ; Endposition texture output       - Preset 0 = Clipping is automatic To image width 
Define texture_height=0      ; Endposition texture output       - Preset 0 = Clipping is automatic To image height 
Define texture_clip_x=0      ; Startposition inside the texture - Preset 0
Define texture_clip_y=0      ; Startposition inside the texture - Preset 0
Define texture_clip_width=0  ; Endposition inside the texture   - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture   - Preset 0 = full texture height

; SetInvisibleColor_BF($FF00FF) ; Set the invisible color - Use this with care for sprites without a invisible color, or you can become "holes" in your output frames
; This use a QUAD, deactivate again with SetInvisibleColor_BF(-1) - For white set $FFFFFF - This is a globale function
; This deactivate "Grab transparence color from the frame pos" x, y
; -2 deactivate the invisible color

SetColorDistanceSpriteMask_BF(20) ; percent
ActivateMaskCreating_BF($FF, 0)   ; Activate color mask creating

; Function for simple using any images as sprites
ErrorCheck_BF(SpriteSimple_BF(1, background_ID, texture_1_ID, 
                              0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                              0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                              10,                   ; Output pos x
                              300,                  ; Output pos y
                              400,                  ; You can here resize the output x
                              300,                  ; You can here resize the output y
                              256,                  ; Set alpha blending from 1 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                              texture_width,        ; Endposition texture output       - Preset 0 = Clipping is automatic to image width 
                              texture_height,       ; Endposition texture output       - Preset 0 = Clipping is automatic to image height 
                              texture_clip_x,       ; Startposition inside the texture - Preset 0
                              texture_clip_y,       ; Startposition inside the texture - Preset 0
                              texture_clip_width,   ; Endposition inside the texture   - Preset 0 = full texture width
                              texture_clip_height)) ; Endposition inside the texture   - Preset 0 = full texture height
                                                    ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                    ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                    ; For using pictures with alpha channel use mode=2
                                                    ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                    ; Resizing can change the colors a little,
                                                    ; so it is available a presetted invisible color works after resizing not longer correct

SetColorDistanceFill_BF(10) ; percent  

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing() 

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation    

Delay_BF(1, -1) ; Init Delay BF

Repeat
  win_event=WindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    End
  EndIf
  
  If Delay_BF(1, 30)
    
    iii-1 : If iii<=-30 : iii=0 : EndIf
    
    i+2 : If i>256 : i=0 : ii=0 : EndIf
    ii+2
    
    FlipBuffers_BF(0)
    
    ; Flood Fill BF
    ErrorCheck_BF(FloodFill_BF(-2, Get_animation_buffer_hidden_image_ID_BF(0), texture_2_ID,
                               100, ; Output coordinate x
                               400, ; Output coordinate y
                               iii, ; Startposition texture output x - Preset 0
                               iii, ; Startposition texture output y - Preset 0
                               0,   ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                               0,   ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                               0,   ; Startposition inside the texture x - Preset 0
                               0,   ; Startposition inside the texture y - Preset 0
                               30,  ; Endposition inside the texture - Preset 0 = full texture width
                               30)) ; Endposition inside the texture - Preset 0 = full texture height
                                    ; mode = 0         - Set only a positioning marker
                                    ;       -1         - Ignore a texture and use a color - Set as texture_ID a color, as sample $FFFF00
                                    ;       -2         - Standard preset texture mode
                                    ;       -3 to -256 - Texture mode with alpha blending
                                    ; For compatibility with BucketFill this function use negative mode values, but it works at the same also with positive values
                                    ; This function can output on images, PB sprites and canvas
    
    ActivateMaskCreating_BF($FFFF, 0)
    ; Function for simple using any images as sprites
    ErrorCheck_BF(SpriteSimple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_1_ID,  
                                  0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                  0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                  10,                   ; Output pos x
                                  5,                    ; Output pos y
                                  400,                  ; You can here resize the output x
                                  300,                  ; You can here resize the output y
                                  i,                    ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  texture_width,        ; Endposition texture output       - Preset 0 = Clipping is automatic to image width 
                                  texture_height,       ; Endposition texture output       - Preset 0 = Clipping is automatic to image height 
                                  texture_clip_x,       ; Startposition inside the texture - Preset 0
                                  texture_clip_y,       ; Startposition inside the texture - Preset 0
                                  texture_clip_width,   ; Endposition inside the texture   - Preset 0 = full texture width
                                  texture_clip_height)) ; Endposition inside the texture   - Preset 0 = full texture height
                                                        ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                        ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                        ; For using pictures with alpha channel use mode=2
                                                        ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                        ; Resizing can change the colors a little,
                                                        ; so it is available a presetted invisible color works after resizing not longer correct
    
    ActivateMaskCreating_BF($FF, i)
    ErrorCheck_BF(SpriteSimple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_1_ID,  
                                  0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                  0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                                  490,                  ; Output pos x
                                  5,                    ; Output pos y
                                  400,                  ; You can here resize the output x
                                  300,                  ; You can here resize the output y
                                  ii,                   ; Set alpha blending from 1 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                                  texture_width,        ; Endposition texture output       - Preset 0 = Clipping is automatic to image width 
                                  texture_height,       ; Endposition texture output       - Preset 0 = Clipping is automatic to image height 
                                  texture_clip_x,       ; Startposition inside the texture - Preset 0
                                  texture_clip_y,       ; Startposition inside the texture - Preset 0
                                  texture_clip_width,   ; Endposition inside the texture   - Preset 0 = full texture width
                                  texture_clip_height)) ; Endposition inside the texture   - Preset 0 = full texture height
                                                        ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                        ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                        ; For using pictures with alpha channel use mode=2
                                                        ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                        ; Resizing can change the colors a little,
                                                        ; so it is available a presetted invisible color works after resizing not longer correct
    
    SetColorDistanceSpriteMask_BF(36) ; percent
    ActivateMaskCreating_BF($FF00, i)
    ErrorCheck_BF(SpriteSimple_fast_BF(256, Get_animation_buffer_hidden_image_ID_BF(0), texture_1_ID,
                                       0,                    ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                       0,                    ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                       490,                  ; Output position x
                                       300,                  ; Output position y
                                       400,                  ; Resizing - Define the output width - Preset zero = without resizing 
                                       300,                  ; Resizing - Define the output height
                                       texture_clip_x,       ; Startposition inside the texture - Preset 0
                                       texture_clip_y,       ; Startposition inside the texture - Preset 0
                                       texture_clip_width,   ; Endposition inside the texture - Preset 0 = full texture width
                                       texture_clip_height)) ; Endposition inside the texture - Preset 0 = full texture height
                                                             ; mode 0 = Without invisible color
                                                             ; mode 1 > 256 = With invisible color and with alpha blending
                                                             ; mode -1 > -256 = Without invisible color and with alpha blending
                                                             ; This is a special function for very fast sprite or GIF output- mode 0 is the fastest mode - Image output is a little faster as canvas output
                                                             ; The function is not based on the BF BucketFill core function, can so not output multiple pattern and works not with the BF sprite array
                                                             ; On PB sprites invisible color and alpha blending is ignored
    
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID)
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 5
; EnableXP
; DisableDebugger