﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Use a CSS sprite sheet with mask or without mask as sprite - BF Sprite CSS sheet Function used

; This function is created for simple using sheets with a symmetric frame arrangement
; As sample, for sheets created with the BF sheet creating tool for GIF pictures 
; For using a invisible color, use loss free compressed sheets with a clean mask
; Also you can pre clean masks on lossly compressed sheets with the BF mask cleaning function CleanMask_BF
; The SpriteTool_BF can create sprites, sheets and sheet info files with included color distance value

; - Look in the code for the needed settings

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_ID, win_event, texture_ID, sheet_ID, background_ID, result
Define image_width, image_height, frame, delay, i

Define path$

path$=OpenFileRequester("Select a BF CSS sheet - A BF sheet_info file must also exist", "", "", 0)
If path$=""
  End
EndIf

If UCase(GetExtensionPart(path$))="GIF"
  MessageRequester("Hint", "This is a GIF, not a sprite sheet"+#LF$+#LF$+"Select a sheet !")
  End
EndIf

Define path_sheet_info_file$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+"_sheet_info_BF.txt"
If FileSize(path_sheet_info_file$)<208 ; - New BF <246
  MessageRequester("Hint", "Sheet info file not found !")
  End
EndIf

ReadSheetInfoFile_BF(path_sheet_info_file$)                     ; Read the sheet info file

; GetCSS_width_BF()                                             ; Sheet width  - unused here - primary not needed
; GetCSS_height_BF()                                            ; Sheet height - unused here - primary not needed
Define frames=GetGIFandCSS_frames_BF()                          ; Count frames in the sheet
Define frame_width=GetGIFandCSS_frame_width_BF()                ; Frame width
Define frame_height=GetGIFandCSS_frame_height_BF()              ; Frame height
Define frames_in_a_row=GetFrames_in_a_row_BF()                  ; Frames in a row
Define invisible_color=GetGIFandCSS_invisible_color_BF()        ; Invisible color
SetColorDistanceSpriteMask_BF(GetGIFandCSS_color_distance_BF()) ; Color distance

sheet_ID=LoadImage(#PB_Any, path$)

If Not IsImage(sheet_ID) : End : EndIf

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7
  LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7
  LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
Next i
StopDrawing()

; Presets

; mode 0 = Without invisible color
; mode 1 > 256 = With invisible color and with alpha blending
; mode -1 > -256 = Without invisible color and with alpha blending
; Set 1 or -1 for full visible, 256 or -256 for full transparence (BF specific)
Define mode=1

Define x=40 ; Output point x
Define y=40 ; Output point y

Define output_width=0  ; Output width - For original frame width and height, set width or height = 0
Define output_height=0 ; Output height

Define sheet_width=ImageWidth(sheet_ID)
Define sheet_height=ImageHeight(sheet_ID)

Define image_get_color_x=0 ; Get the invisible color from pos x
Define image_get_color_y=0 ; Get the invisible color from pos y

Define texture_width=0  ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
Define texture_height=0 ; Endposition texture output - Preset 0 = Clipping is automatic to output height 

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0   

Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture width

image_width=frame_width+x*2 : image_height=frame_height+y*2

If output_width>0 : image_width=output_width+x*2 : EndIf
If output_height>0 : image_height=output_height+y*2 : EndIf

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; - Call function #1 -
result=BF(-2, background_ID, texture_ID) ; Create a background
ErrorCheck_BF(result)

Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

SetInvisibleColor_BF(invisible_color) ; Set the invisible color from the sheet
                                      ; This use a QUAD, deactivate again with SetInvisibleColor_BF(-1) - For white set $FFFFFF - This is a globale function
                                      ; This deactivate "Grab transparence color from the frame pos" x, y
                                      ; -2 deactivate the invisible color

; SetColorDistanceSpriteMask_BF(0) ; percent - With this function you can remove "Halos" on the edges from the GIF content
;                                  ; Is the mask color very different from the GIF content you get halos on the edges
;                                  ; This function can remove this complete - try about 20>30 percent
;                                  ; You can also use this function for nice graphic effect, on movie like GIF, as sample
;                                  ; Or for making invisible more different colors

NoCaching_BF(1) ; For immediately changed textures you can deactivate the BF texture caching

HideWindow(window_ID, 0)

Repeat
  Delay(1)
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change - Animation Refresh
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    ; - Call function #2 - Frame output
    result=Sprite_CSS_sheet_BF(mode, Get_animation_buffer_hidden_image_ID_BF(0), sheet_ID,
                               image_get_color_x,   ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                               image_get_color_y,   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                               x,                   ; Output position x
                               y,                   ; Output position y
                               frames,              ; Numbers of frames
                               frame,               ; Selected frame - For PB GIF compatibility the first frame is 0
                               frame_width,         ; Frame width
                               frame_height,        ; Frame height
                               frames_in_a_row,     ; Frames in a row - Preset 0, then BF calculate self
                               output_width,        ; Output width                     - Preset 0 = Is the full texture width
                               output_height,       ; Output height                    - Preset 0 = Is the full texture height
                               texture_width,       ; Endposition texture output       - Preset 0 = Clipping is automatic to output width 
                               texture_height,      ; Endposition texture output       - Preset 0 = Clipping is automatic to output height 
                               texture_clip_x,      ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                               texture_clip_y,      ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                               texture_clip_width,  ; Endposition inside the texture   - Preset 0 = full texture width
                               texture_clip_height) ; Endposition inside the texture   - Preset 0 = full texture height
                                                    ; mode 0 = Without invisible color
                                                    ; mode 1 > 256 = With invisible color and with alpha blending
                                                    ; mode -1 > -256 = Without invisible color and with alpha blending
                                                    ; You can also preset a invisible color with "SetInvisibleColor_BF(color)"
                                                    ; Attention, a setted "SetColorDistanceSpriteMask_BF(percent)" influence the output
    
    ErrorCheck_BF(result)
    
    If delay 
      delay=0
      frame+1 
      If frame=frames : frame=0 : EndIf 
    Else
      delay+Delay_BF(1, GetGIFandCSS_delay_array_BF(frame)) ; Timer 1 - delay 
    EndIf
    
    ; Get the result
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
    
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 11
; Folding = -
; EnableXP
; DisableDebugger