﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Use a CSS sprite sheet with mask or without mask as sprite - BF Sprite CSS sheet Function used - Direct access
; PB sprite output on a windowed screen

; This function is created for simple using sheets with a symmetric frame arrangement
; As sample, for sheets created with the BF sheet creating tool for GIF pictures 
; For using a invisible color, use loss free compressed sheets with a clean mask
; Also you can pre clean masks on lossly compressed sheets with the BF mask cleaning function CleanMask_BF
; The SpriteTool_BF can create sprites, sheets and sheet info files with included color distance value

; - Look in the code for the needed settings

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_ID, win_event, texture_ID, sheet_ID, sprite_ID, background_ID
Define image_width, image_height, frame, delay, i

Define path$

path$=OpenFileRequester("Select a BF CSS sheet - A BF sheet_info file must also exist", "", "", 0)
If path$=""
  End
EndIf

If UCase(GetExtensionPart(path$))="GIF"
  MessageRequester("Hint", "This is a GIF, not a sprite sheet"+#LF$+#LF$+"Select a sheet !")
  End
EndIf

Define path_sheet_info_file$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+"_sheet_info_BF.txt"
If FileSize(path_sheet_info_file$)<208 ; - New BF <246
  MessageRequester("Hint", "Sheet info file not found !")
  End
EndIf

ReadSheetInfoFile_BF(path_sheet_info_file$)              ; Read the sheet info file

; GetCSS_width_BF()                                      ; Sheet width  - unused here - primary not needed
; GetCSS_height_BF()                                     ; Sheet height - unused here - primary not needed
Define frames=GetGIFandCSS_frames_BF()                   ; Count frames in the sheet
Define frame_width=GetGIFandCSS_frame_width_BF()         ; Frame width
Define frame_height=GetGIFandCSS_frame_height_BF()       ; Frame height
Define frames_in_a_row=GetFrames_in_a_row_BF()           ; Frames in a row
Define invisible_color=GetGIFandCSS_invisible_color_BF() ; Invisible color

sheet_ID=LoadImage(#PB_Any, path$)

If Not IsImage(sheet_ID) : End : EndIf

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7
  LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7
  LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
Next i
StopDrawing()

; Presets

Define x=40 ; Output point x
Define y=40 ; Output point y

Define output_width=0  ; Output width - For original frame width and height, set width or height = 0
Define output_height=0 ; Output height

Define sheet_width=ImageWidth(sheet_ID)
Define sheet_height=ImageHeight(sheet_ID)

Define texture_width=0  ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
Define texture_height=0 ; Endposition texture output - Preset 0 = Clipping is automatic to output height 

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0   

Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture width

image_width=frame_width+x*2 : image_height=frame_height+y*2

If output_width>0 : image_width=output_width+x*2 : EndIf
If output_height>0 : image_height=output_height+y*2 : EndIf
If Not output_width : output_width=frame_width : EndIf
If Not output_height : output_height=frame_height : EndIf

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF - For Screen",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height)
If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height, 0, 0, 0, #PB_Screen_NoSynchronization) : End : EndIf ; No sync

sprite_ID=CreateSprite(#PB_Any, frame_width, frame_height)
background_ID=CreateSprite(#PB_Any, image_width, image_height)

; - Call function #1 -
ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background

NoCaching_BF(1) ; For immediately changed textures you can deactivate the BF texture caching

HideWindow(window_ID, 0)

SetInvisibleColor_BF(invisible_color)

ActivateScreenOutput_BF(1)

Repeat
  Delay(1)
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change - Animation Refresh
    
    ; - Call function #2 - Frame output
    ; Direct output on screen
    ErrorCheck_BF(Sprite_CSS_sheet_BF(1, 0, sheet_ID,                  
                                      -1,                               ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                      invisible_color,                  ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                                      image_width>>1-output_width>>1,   ; Output position x
                                      image_height>>1-output_height>>1, ; Output position y
                                      frames,                           ; Numbers of frames
                                      frame,                            ; Selected frame - For PB GIF compatibility the first frame is 0
                                      frame_width,                      ; Frame width
                                      frame_height,                     ; Frame height
                                      frames_in_a_row,                  ; Frames in a row - Preset 0, then BF calculate self
                                      output_width,                     ; Output width                     - Preset 0 = Is the full texture width
                                      output_height,                    ; Output height                    - Preset 0 = Is the full texture height
                                      texture_width,                    ; Endposition texture output       - Preset 0 = Clipping is automatic to output width 
                                      texture_height,                   ; Endposition texture output       - Preset 0 = Clipping is automatic to output height 
                                      texture_clip_x,                   ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                                      texture_clip_y,                   ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                                      texture_clip_width,               ; Endposition inside the texture   - Preset 0 = full texture width
                                      texture_clip_height))             ; Endposition inside the texture   - Preset 0 = full texture height
                                                                        ; Set alpha for alpha blending from 1 > 256 - 1=full visible - 256=invisible (BF specific)
                                                                        ; For screen output set alpha=0 - Alpha blending is not available for screen output
                                                                        ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                                        ; Resizing can change the colors a little,
                                                                        ; so it is available a presetted invisible color works after resizing not longer correct
                                                                        ; For screen output the output_ID is ignored
    
    FlipBuffers() ; Draw PB sprite
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(background_ID, 0, 0)
    If delay 
      delay=0
      frame+1 
      If frame=frames : frame=0 : EndIf 
    Else
      delay+Delay_BF(1, GetGIFandCSS_delay_array_BF(frame)) ; Timer 1 - delay 
    EndIf
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 12
; Folding = -
; EnableXP
; DisableDebugger