﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Use a CSS sprite sheet with mask or without mask as sprite - BF Sprite CSS sheet Function used - Direct access - Simple and fast
; PB sprite output on a windowed screen

; This function is created for simple using sheets with a symmetric frame arrangement
; As sample, for sheets created with the BF sheet creating tool for GIF pictures 
; For using a invisible color, use loss free compressed sheets with a clean mask
; Also you can pre clean masks on lossly compressed sheets with the BF mask cleaning function CleanMask_BF
; The SpriteTool_BF can create sprites, sheets and sheet info files with included color distance value

; - Look in the code for the needed settings

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_ID, win_event, texture_ID, sheet_ID, sprite_ID, background_ID, result
Define image_width, image_height, frame, delay, i

Define path$

path$=OpenFileRequester("Select a BF CSS sheet - A BF sheet_info file must also exist", "", "", 0)
If path$=""
  End
EndIf

If UCase(GetExtensionPart(path$))="GIF"
  MessageRequester("Hint", "This is a GIF, not a sprite sheet"+#LF$+#LF$+"Select a sheet !")
  End
EndIf

Define path_sheet_info_file$=GetPathPart(path$)+GetFilePart(path$, #PB_FileSystem_NoExtension)+"_sheet_info_BF.txt"
If FileSize(path_sheet_info_file$)<208 ; - New BF <246
  MessageRequester("Hint", "Sheet info file not found !")
  End
EndIf

ReadSheetInfoFile_BF(path_sheet_info_file$)              ; Read the sheet info file

; GetCSS_width_BF()                                      ; Sheet width  - unused here - primary not needed
; GetCSS_height_BF()                                     ; Sheet height - unused here - primary not needed
Define frames=GetGIFandCSS_frames_BF()                   ; Count frames in the sheet
Define frame_width=GetGIFandCSS_frame_width_BF()         ; Frame width
Define frame_height=GetGIFandCSS_frame_height_BF()       ; Frame height
Define frames_in_a_row=GetFrames_in_a_row_BF()           ; Frames in a row
Define invisible_color=GetGIFandCSS_invisible_color_BF() ; Invisible color

sheet_ID=LoadImage(#PB_Any, path$)

If Not IsImage(sheet_ID) : End : EndIf

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7
  LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC)
Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7
  LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC)
Next i
StopDrawing()

; Presets
Define alpha=255 ; Here you can set alpha blending - BF set 1 for full visible, 0 for full transparence

Define x=40 ; Output point x
Define y=40 ; Output point y

Define output_width=0  ; Output width - For original frame width and height, set width or height = 0
Define output_height=0 ; Output height

Define sheet_width=ImageWidth(sheet_ID)
Define sheet_height=ImageHeight(sheet_ID)

Define texture_width=0  ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
Define texture_height=0 ; Endposition texture output - Preset 0 = Clipping is automatic to output height 

Define texture_clip_x=0 ; Startposition inside the texture - Preset 0
Define texture_clip_y=0 ; Startposition inside the texture - Preset 0   

Define texture_clip_width=0  ; Endposition inside the texture - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture - Preset 0 = full texture width

image_width=frame_width+x*2 : image_height=frame_height+y*2

If output_width>0 : image_width=output_width+x*2 : EndIf
If output_height>0 : image_height=output_height+y*2 : EndIf

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height)

sprite_ID=CreateSprite(#PB_Any, frame_width, frame_height)
background_ID=CreateSprite(#PB_Any, image_width, image_height)

; - Call function #1 -
result=BF(-2, background_ID, texture_ID) ; Create a background
ErrorCheck_BF(result)

NoCaching_BF(1) ; For immediately changed textures you can deactivate the BF texture caching

HideWindow(window_ID, 0)

TransparentSpriteColor(sprite_ID, invisible_color)

Repeat
  Delay(1)
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change - Animation Refresh
    
    ; - Call function #2 -
    result=Sprite_CSS_sheet_simple_BF(0, sprite_ID, sheet_ID,
                                      0,                   ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                      0,                   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                      0,                   ; Output position x
                                      0,                   ; Output position y
                                      frames,              ; Numbers of frames
                                      frame,               ; Selected frame - For GIF compatibility the first frame is 0
                                      frame_width,         ; Frame width
                                      frame_height,        ; Frame height
                                      frames_in_a_row,     ; Frames in a row - Preset 0, then BF calculate self
                                      output_width,        ; Resizing - Define the output width - Preset zero = without resizing 
                                      output_height,       ; Resizing - Define the output height
                                      texture_clip_x,      ; Startposition inside the texture - Preset 0
                                      texture_clip_y,      ; Startposition inside the texture - Preset 0
                                      texture_clip_width,  ; Endposition inside the texture - Preset 0 = full texture width
                                      texture_clip_height) ; Endposition inside the texture - Preset 0 = full texture height
                                                           ; mode 0 = Without invisible color
                                                           ; mode 1 > 256 = With invisible color and with alpha blending
                                                           ; mode -1 > -256 = Without invisible color and with alpha blending
                                                           ; This is a special function for very fast CSS sheet output- mode 0 is the fastest mode - Image output is a little faster as canvas output
                                                           ; The function is not based on the GFX_Wizzard_BF core function, can so not output multiple pattern and works not with the BF sprite arrayial function for very fast CSS sheet output- mode 0 is the fastest mode - Image output is a little faster as canvas output
                                                           ; The function is not based on the GFX_Wizzard_BF core function, can so not output multiple pattern and works not with the BF sprite array
    
    ErrorCheck_BF(result)
    
    FlipBuffers() ; Draw PB sprite
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(background_ID, 0, 0)
    DisplayTransparentSprite(sprite_ID, image_width>>1-frame_width>>1, image_height>>1-frame_height>>1, alpha) 
    
    If delay 
      delay=0
      frame+1 
      If frame=frames : frame=0 : EndIf 
    Else
      delay+Delay_BF(1, GetGIFandCSS_delay_array_BF(frame)) ; Timer 1 - delay 
    EndIf
    
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 12
; Folding = -
; EnableXP
; DisableDebugger