﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Use a CSS sprite sheet with mask or without mask as sprite - BF Sprite CSS sheet Function used

; This function is created for simple using sheets with a symmetric frame arrangement
; As sample, for sheets created with the BF sheet creating tool for GIF pictures 
; For using a invisible color, use loss free compressed sheets with a clean mask
; Also you can pre clean masks on lossly compressed sheets with the BF mask cleaning function CleanMask_BF
; The SpriteTool_BF can create sprites, sheets and sheet info files with included color distance value

; - Look in the code for the needed settings

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_ID, win_event, image_ID, texture_ID, background_ID, result
Define image_width, image_height, frame, delay

Define path$, path_1$

#Background="./Image_Set/Background.bmp"
#Sheet="./Image_Set/Kid_1.png"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #Background)

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF - CSS Sprite sheet demo",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

; - Call function #1 -
path$=#Background
texture_ID=LoadImage(#PB_Any, path$)

result=BF(-2, background_ID, texture_ID)
ErrorCheck_BF(result)

path_1$=#Sheet
texture_ID=LoadImage(#PB_Any, path_1$)

; Presets

; mode 0 = Without invisible color
; mode 1 > 256 = With invisible color and with alpha blending
; mode -1 > -256 = Without invisible color and with alpha blending
; Set 1 or -1 for full visible, 256 or -256 for full transparence (BF specific)
Define mode=1

Define frame_width=106  ; Frame width
Define frame_height=126 ; Frame height

Define frames=8         ; Count frames in the sheet

Define output_pos_x=180 ; Animation start point x
Define output_pos_y=80  ; Animation start point y

Define output_width=300  ; Output width  - For original frame width set width = 0
Define output_height=300 ; Output height - For original frame height set height = 0

Define image_get_color_x=0
Define image_get_color_y=0

Define frames_in_a_row=0

Define texture_width=0  ; Endposition texture output - Preset 0 = Clipping is automatic to output width 
Define texture_height=0 ; Endposition texture output - Preset 0 = Clipping is automatic to output height 

Define texture_clip_x=0
Define texture_clip_y=0

Define texture_clip_width=0
Define texture_clip_height=0

Define sheet_width=ImageWidth(texture_ID)
Define sheet_height=ImageHeight(texture_ID)

Create_animation_buffers_BF(background_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID)) ; Create a canvas for output the result

; Needed for removing mask artifacts, this is important, use this your sprites have a colored halo - Try about 20>30 percent
; You can also use this for creating graphic effects, make simple a try
SetColorDistanceSpriteMask_BF(12) ; percent   

NoCaching_BF(1) ; For immediately changed textures you can deactivate the BF texture caching

HideWindow(window_ID, 0)

Repeat
  Delay(1)
  
  win_event=WindowEvent()
  If win_event=#PB_Event_CloseWindow
    Free_animation_buffers_BF(0) ; Free animation buffers
    FreeTextures_BF()            ; Free grabed textures
    Break
  EndIf
  
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change - Animation Refresh
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    ; - Call function #2 -
    result=Sprite_CSS_sheet_BF(mode, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID,
                               image_get_color_x,   ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                               image_get_color_y,   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                               output_pos_x,        ; Output position x
                               output_pos_y,        ; Output position y
                               frames,              ; Numbers of frames
                               frame,               ; Selected frame - For GIF compatibility the first frame is 0
                               frame_width,         ; Frame width
                               frame_height,        ; Frame height
                               frames_in_a_row,     ; Frames in a row - Preset 0, then BF calculate self
                               output_width,        ; Output width                     - Preset 0 = Is the full texture width
                               output_height,       ; Output height                    - Preset 0 = Is the full texture height
                               texture_width,       ; Endposition texture output       - Preset 0 = Clipping is automatic to output width 
                               texture_height,      ; Endposition texture output       - Preset 0 = Clipping is automatic to output height 
                               texture_clip_x,      ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                               texture_clip_y,      ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                               texture_clip_width,  ; Endposition inside the texture   - Preset 0 = full texture width
                               texture_clip_height) ; Endposition inside the texture   - Preset 0 = full texture height
                                                    ; mode 0 = Without invisible color
                                                    ; mode 1 > 256 = With invisible color and with alpha blending
                                                    ; mode -1 > -256 = Without invisible color and with alpha blending
                                                    ; You can also preset a invisible color with "SetInvisibleColor_BF(color)"
                                                    ; Attention, a setted "SetColorDistanceSpriteMask_BF(percent)" influence the output
    
    ErrorCheck_BF(result)
    
    ; This is a demo for presetted delays
    ; You can also read the delay table from the CSS sheet for automatic using delays on the same way, as sample with a array
    
    Select frame ; Frame delay - A BF timer starts ever with the first call, its all ok, then he returns 1 directly
      Case 0
        delay+Delay_BF(1, 1000) ; Timer 1 - delay 2000 ms
      Case 1, 3, 4, 6, 7
        delay+Delay_BF(1, 100)
      Case 5
        delay+Delay_BF(1, 800)
      Case 2
        delay+Delay_BF(1, 200)
    EndSelect
    
    If delay : delay=0 : frame+1 : EndIf
    
    If frame=>frames : frame=0 : EndIf
    
    ; Get the result
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
    
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 11
; Folding = -
; EnableXP
; DisableDebugger