﻿
; StretchTextGadget_BF

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

; === Using ==================================================

Define button_width=400
Define button_height=100

CompilerIf#PB_Compiler_OS=#PB_OS_Linux
  Define padding_x=20
  Define padding_y=20
CompilerElse
  Define padding_x=10*DPI_ResizeFactor_BF()
  Define padding_y=10*DPI_ResizeFactor_BF()
CompilerEndIf

; Workaround PB 572 - Linux Subsystem qt - WindowWidth and WindowHeight fail on invisible window
CompilerIf #PB_Compiler_OS=#PB_OS_Linux And Subsystem("qt")
  Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 400,
                              "StretchTextGadget_BF",
                              #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
CompilerElse
  Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 400,
                              "StretchTextGadget_BF",
                              #PB_Window_SystemMenu|#PB_Window_ScreenCentered | #PB_Window_Invisible)
CompilerEndIf

SetWindowColor(window_ID, $A0A0A0)

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/2.4-button_height/2

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha5.png")

; === Output the buttons ===

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($FF, $00, $00, $FF))
; GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

Define text_gadget_0$="Exactly OS style"+#LF$+"But with fine adjusted"+#LF$+"full automatic text"
Define gadget_0_ID=StretchTextGadget_BF(text_gadget_0$,
                                        330,
                                        20,
                                        140,
                                        50,
                                        17*DPI_ResizeFactor_BF(), ; padding_x
                                        17*DPI_ResizeFactor_BF(), ; padding_y
                                        #Black,                   ; text_color - Alpha channel supported
                                        $EEEEEE)                  ; back_color

CanvasStretchTextGadget_BF() ; Create and use a StretchTextGadget_BF canvas based
SetFlagsStretchTextGadget_BF(#PB_Canvas_Border)
Define text_gadget_1$="Hello World"+#LF$+"This is a CanvasGadget based"+#LF$+"StretchTextGadget_BF"
Define gadget_1_ID=StretchTextGadget_BF(text_gadget_1$,
                                        x_pos,
                                        y_pos+10,
                                        button_width,
                                        button_height,
                                        20*DPI_ResizeFactor_BF(), ; padding_x
                                        20*DPI_ResizeFactor_BF(), ; padding_y
                                        #Black,                   ; text_color - Alpha channel supported
                                        #Yellow,                  ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)

; Activate linear gradient
LinearGradient_BF(1, 0, 0, 100*DPI_ResizeFactor_BF() , 240*DPI_ResizeFactor_BF())
; Activate circular gradient
;CircularGradient_BF(1, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF())

FitImage_Offset_BF(14, 0) ; Set a x, y offset for FitImage..BF - You must deactivate again - Percent based
Define text_gadget_2$="Hello World"+#LF$+"This is a ImageGadget based"+#LF$+"StretchTextGadget_BF"
Define gadget_2_ID=StretchTextGadget_BF(text_gadget_2$,
                                        x_pos-40,
                                        y_pos+160,
                                        button_width+80,
                                        button_height,
                                        130*DPI_ResizeFactor_BF(), ; padding_x
                                        0,                         ; padding_y
                                        #Blue,                     ; text_color - Alpha channel supported
                                        #Green,                    ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)

HideWindow(window_ID, 0)

Define i
Macro animate_gadget_2
  
  ; This function deactivate the automatically text stretching for vector text based Gadgets_BF,
  ; - as sample ToggleGadget_BF, StretchTextGadget_BF, MagicTextGadget_BF, MessageRequester_Magic_BF
  ; This is a mighty feature - you must activate again text stretching
  ; With an unsymmetrical padding the stretching becomes active on MagicText, positive values reduce the output, negative values increase it
  Deactivate_TextStretching_BF(1) ; Deactivate text stretching 
  
  For i=110 To 20 Step -1
    
    FitImage_Offset_BF(i-6, i-20)
    
    SetStretchTextGadget_BF(gadget_2_ID,             ; Gadget_ID
                            "",                      ; Text
                            -1,                      ; Gadget output x pos
                            -1,                      ; Gadget output x pos
                            -1,                      ; Gadget width
                            -1,                      ; Gadget height
                            -1,                      ; padding_x
                            i*DPI_ResizeFactor_BF(), ; padding_y
                            -1,                      ; text_color - Alpha channel supported
                            -1)                      ; back_color
    Delay(3)
    While WindowEvent() : Wend
    
  Next 
  
  Define old_i=i
  For i = 250 To 1 Step -10
    CompilerIf #PB_Compiler_OS<>#PB_OS_Windows
      SetStretchTextGadget_BF(gadget_2_ID)
    CompilerEndIf
    
    ErrorCheck_BF(RotateAlphaChannelSprite_BF(GetGadgetImage_BF(gadget_2_ID), texture_1_ID, ; Sprite BF output
                                              -10*DPI_ResizeFactor_BF(),                    ; Output x pos
                                              -6*DPI_ResizeFactor_BF(),                     ; Output y pos
                                              0,                                            ; Rotating degree
                                              0,                                            ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation - Mode 1 has no effekt on linux
                                              i,                                            ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific) 
                                              0,                                            ; Endposition texture output  x - Preset 0 = Clipping is automatic to input width
                                              0,                                            ; Endposition texture output  y - Preset 0 = Clipping is automatic to input height
                                              130*DPI_ResizeFactor_BF(),                    ; You can here resize the output x
                                              115*DPI_ResizeFactor_BF()))                   ; You can here resize the output y
    
    
    SetGadgetAttribute(gadget_2_ID, #PB_Button_Image, ImageID(GetGadgetImage_BF(gadget_2_ID)))
    Delay (5)
    While WindowEvent() : Wend
  Next
  
  Deactivate_TextStretching_BF(0) ; Activate text stretching
  LinearGradient_BF(0)            ; Deactivate linear gradient
  FitImage_Offset_BF(0, 0)
  
EndMacro

animate_gadget_2

Deactivate_TextStretching_BF(0) ; Deactivate text stretching

SetTextFlagsStretchTextGadget_BF(#PB_VectorParagraph_Left)
Define text_gadget_3$="This is a ImageGadget based"+#LF$+"StretchTextGadget_BF"+#LF$+#LF$+"Automatic TextStretching OFF"
Define gadget_3_ID=StretchTextGadget_BF(text_gadget_3$,
                                        x_pos-195+Get_gtk3_button_x_offset_BF(),
                                        y_pos-112,
                                        button_width-105-Get_gtk3_button_x_offset_BF(),
                                        button_height-25,
                                        15*DPI_ResizeFactor_BF(), ; padding_x
                                        15*DPI_ResizeFactor_BF(), ; padding_y
                                        #Blue,                    ; text_color - Alpha channel supported
                                        #Green,                   ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)

Deactivate_TextStretching_BF(1) ; Activate text stretching

SetTextFlagsStretchTextGadget_BF(#PB_VectorParagraph_Right)
CanvasStretchTextGadget_BF() ; Create and use a StretchTextGadget_BF canvas based
SetFlagsStretchTextGadget_BF(#PB_Canvas_Border)
Define text_gadget_4$="This is a CanvasGadget based"+#LF$+"StretchTextGadget_BF"+#LF$+#LF$+"Automatic TextStretching ON"
Define gadget_4_ID=StretchTextGadget_BF(text_gadget_4$,
                                        x_pos+300,
                                        y_pos-112,
                                        button_width-105-Get_gtk3_button_x_offset_BF(),
                                        button_height-25,
                                        -515*DPI_ResizeFactor_BF(), ; padding_x
                                        15*DPI_ResizeFactor_BF(),   ; padding_y
                                        #Blue,                      ; text_color - Alpha channel supported
                                        #Green,                     ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)

; === Use the buttons ===

Repeat
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget 
    If (EventGadget() And GetGadgetTyp_BF(EventGadget())=#StretchTextImageGadget_BF) Or
       (EventGadget() And GetGadgetTyp_BF(EventGadget())=#StretchTextCanvasGadget_BF And
        EventType()=#PB_EventType_LeftButtonDown)
      
      Select EventGadget()
          
        Case gadget_0_ID ; #0
          If GetGadgetData(SetGadgetData(gadget_0_ID, GetGadgetData(gadget_0_ID)*-1+1))
            Define text$="GFX_Wizzard_BF"+#LF$+"It's cool man"
            Define text_color=#Blue
            Define background_color=#Green
          Else
            Define text$="Exactly OS style"+#LF$+"But with fine adjusted"+#LF$+"full automatic text"
            Define text_color=#Black
            Define background_color=$EEEEEE
          EndIf
          
          SetStretchTextGadget_BF(gadget_0_ID,      ; Gadget_ID
                                  text$,            ; Text
                                  -1,               ; Gadget output x pos
                                  -1,               ; Gadget output x pos
                                  -1,               ; Gadget width
                                  -1,               ; Gadget height
                                  -1,               ; padding_x
                                  -1,               ; padding_y
                                  text_color,       ; text_color - Alpha channel supported
                                  background_color) ; back_color
          
        Case gadget_1_ID ; #1
          If GetGadgetData(SetGadgetData(gadget_1_ID, GetGadgetData(gadget_1_ID)*-1+1))
            Define text$="Exactly fitted text"+#LF$+"It's cool man"
            Define text_color=#Blue ; Alpha channel supported
            Define background_color=#Red
            Define x=GetGadgetX_BF(gadget_1_ID)-60
            Define y=GetGadgetY_BF(gadget_1_ID)-30
            Define width=GetGadgetWidth_BF(gadget_1_ID)+120
            Define height=GetGadgetHeight_BF(gadget_1_ID)+60
          Else
            Define text$="Hello World"+#LF$+"This is a CanvasGadget based"+#LF$+"StretchTextGadget_BF"
            Define text_color=#Black ; Alpha channel supported
            Define background_color=#Yellow
            Define x=GetGadgetX_BF(gadget_1_ID)+60
            Define y=GetGadgetY_BF(gadget_1_ID)+30
            Define width=GetGadgetWidth_BF(gadget_1_ID)-120
            Define height=GetGadgetHeight_BF(gadget_1_ID)-60
          EndIf
          
          SetStretchTextGadget_BF(gadget_1_ID,              ; Gadget_ID
                                  text$,                    ; Text
                                  x,                        ; Gadget output x pos
                                  y,                        ; Gadget output x pos
                                  width,                    ; Gadget width
                                  height,                   ; Gadget height
                                  20*DPI_ResizeFactor_BF(), ; padding_x
                                  20*DPI_ResizeFactor_BF(), ; padding_y
                                  text_color,               ; text_color - Alpha channel supported
                                  background_color)         ; back_color
          
        Case gadget_2_ID ; #2
          LinearGradient_BF(1, 0, 0, 100*DPI_ResizeFactor_BF() , 240*DPI_ResizeFactor_BF())
          
          If GetGadgetData(SetGadgetData(gadget_2_ID, GetGadgetData(gadget_2_ID)*-1+1))
            Define text$="GFX_Wizzard_BF"+#LF$+"Simple a little more"
            Define text_color=#Red ; Alpha channel supported
            Define background_color=$BFBF3F
            Define x=GetGadgetX_BF(gadget_2_ID)-5
            Define y=GetGadgetY_BF(gadget_2_ID)-10
            Define width=GetGadgetWidth_BF(gadget_2_ID)+10
            Define height=GetGadgetHeight_BF(gadget_2_ID)+20 
          Else
            Define text$="Hello World"+#LF$+"This is a ImageGadget based"+#LF$+"StretchTextGadget_BF"
            Define text_color=#Blue ; Alpha channel supported
            Define background_color=#Green
            Define x=GetGadgetX_BF(gadget_2_ID)+5
            Define y=GetGadgetY_BF(gadget_2_ID)+10
            Define width=GetGadgetWidth_BF(gadget_2_ID)-10
            Define height=GetGadgetHeight_BF(gadget_2_ID)-20
          EndIf
          
          animate_gadget_2
          
      EndSelect
      
    EndIf
  EndIf
  
Until win_event=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.71 LTS (Linux - x64)
; CursorPosition = 161
; FirstLine = 149
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger