﻿; Demo - Draw text with DrawText_BF directly in a PB sprite - Stretched, with transparent color and alpha blending

XIncludeFile("./GFX_Wizzard_BF.pbi")

InitSprite()

EnableExplicit

Define max_needed_font_size=60

Dim font(max_needed_font_size) ; 40 > 60 is mostly enough
Define needed_font_size
For needed_font_size=1 To max_needed_font_size ; Get the fonts
  font(needed_font_size)=LoadFont(#PB_Any, "Arial", needed_font_size, #PB_Font_Bold)
Next needed_font_size

Define text$="Hello"+#LF$+
             "This Text is created with DrawText_BF"+#LF$+
             "For directly output as PB sprite on a Screen"+#LF$+
             "Stretched, rotated, with transparent Color,"+#LF$+
             "Alpha blending, Color distance, gradient Color, DPI aware"+#LF$+
             "GFX_Wizzard_BF (BF)"+#LF$+"Simple a little more"

Define text_output_width=1000

Define padding=80

Define alpha=255 ; Here you can set alpha blending

Define degree=15 ; Text rotating

text_output_width*DPI_ResizeFactor_BF()

; Calculate fitted font width
needed_font_size=Calculate_fitted_Font_Width_BF(text$,
                                                text_output_width, ; width,
                                                font(),            ; Needed Font array
                                                0,                 ; vertical=0,
                                                padding,           ; padding_x=0,
                                                7)                 ; stretch_x=0,
                                                                   ; resize_factor.f=1

; DrawText_BF -  Get text width - Multiline supported
Define text_output_width=GetTextWidth_BF(text$,
                                         font(needed_font_size),
                                         0,         ; vertical=0,
                                         7,         ; stretch_x=0,
                                         padding*2) ; padding_x=0)

; DrawText_BF -  Get text height - Multiline supported
Define text_output_height=GetTextHeight_BF(text$,
                                           font(needed_font_size),
                                           0,         ; vertical=0,
                                           7,         ; stretch_y=0,
                                           padding*2) ; padding_y=0)

; Flags : Text center=1 - Text right=2 - Text vertical=3
; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
; Mono line output give back the xx output coordinate - Multi line output give back the yy output coordinate
; For stretched text on a textured background often DrawingMode (#PB_2DDrawing_Transparent) is needed
; DrawTextCreateImage_BF(txt$, f_col=#White, b_col=#Black, flag=0, mode=0, font_ID=0, stretch_x=0, stretch_y=0, padding=0)

; With elliptic gradient
; This functions works equal the PB function
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
; You must deactivate again
BackColor_BF(1, $FFFF)

; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)

EllipticalGradient_BF(1, text_output_width/2, text_output_height/2, text_output_width/1.5, text_output_height/1.5)

Define text_image_ID=DrawTextCreateImage_BF(text$, #White, $A9A9A9, 1, 0, font(needed_font_size), 7, 7, padding) ; Create a text image with a mask

Define width=ImageWidth(text_image_ID)
Define height=ImageHeight(text_image_ID)

Calculate_empty_rotated_rectangle_BF(width, height, degree) ; Calculate a rotated rectangle

width=Get_resulted_rotated_width() ; Get the resulted width for Calculate_empty_rotated_rectangle_BF and Create_empty_rotated_image_BF

height=Get_resulted_rotated_height() ; Get the resulted height for Calculate_empty_rotated_rectangle_BF and Create_empty_rotated_image_BF


Define window_ID=OpenWindow(#PB_Any, 0, 0, width/DPI_ResizeFactor_BF(), height/DPI_ResizeFactor_BF(), "Draw Text directly in a PB sprite", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

OpenWindowedScreen(WindowID(window_ID), 0, 0, width, height)

Define sprite_1_ID, win_event

Define sprite_2_ID=CreateSprite(#PB_Any, width, height) ; Create a PB sprite for a background

StartDrawing(SpriteOutput(sprite_2_ID))
Box(0, 0, width/4, height, $FF0000)
Box(width-width/4, 0, width/4, height, $FF)
StopDrawing()

sprite_1_ID=CreateSprite_simple_BF(1, text_image_ID,
                                   0,      ; Grab transparence color from input pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                                   0,      ; Grab transparence color from input pos y - For preset set ..y= the color you want - as sample $FF00FF
                                   degree, ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                   2,      ; mode=0 deactivate rotating - - mode=1 create a quadratic sprite for on demand rotation - mode=2 create a exactely resized sprite with minimized mask
                                   0,      ; You can here resize the output x - On demand
                                   0,      ; You can here resize the output y - On demand
                                   0,      ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger = slower, but I will give you not a limit
                                   0,      ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                   5,      ; Color distance sprite mask - Mask cleaning - Important                                  
                                   0,      ; Delete the input 
                                   0,      ; Mirroring - 0=without - 1=horizontal - 2=vertical - 3=horizontal and vertical
                                   0)      ; Flags for CreateSprite - same PB function call
                                           ; The function accepts as input a image, a PB sprite or a canvas (ID)

TransparentSpriteColor(sprite_1_ID, GetUsedInvisibleColor_BF())

Repeat
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event = #PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Output
    FlipBuffers()
    ClearScreen(RGB($FF0000, 0, 0))
    DisplaySprite(sprite_2_ID, 0, 0)
    DisplayTransparentSprite(sprite_1_ID, 0, 0, alpha)
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 131
; FirstLine = 103
; EnableXP
; DPIAware
; DisableDebugger