﻿; Demo - Draw text with DrawText_BF directly in a PB sprite - Stretched, with transparent color and alpha blending

XIncludeFile("./GFX_Wizzard_BF.pbi")

InitSprite()

EnableExplicit

LoadFont(1, "Arial", 26, #PB_Font_Bold)

#text$=#LF$+"Hello World"+#LF$+
       " This Text is created with DrawText_BF "+#LF$+
       "And directly included in a PB Sprite"+#LF$+
       "Stretched"+#LF$+"With transparent Color,"+#LF$+"Color distance and gradient color"+#LF$

; Flags : Text center=1 - Text right=2 - Text vertical=3
; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
; Mono line output give back the xx output coordinate - Multi line output give back the yy output coordinate
; For stretched text on a textured background often DrawingMode (#PB_2DDrawing_Transparent) is needed
; DrawTextCreateImage_BF(txt$, f_col=#White, b_col=#Black, flag=0, mode=0, font_ID=0, stretch_x=0, stretch_y=0, padding=0)

Define width=DrawTextCreateImage_BF(#text$, #White, $A9A9A9, 0, 3, 1, 7, 7, 0) ; Calculate needed width
Define height=DrawTextCreateImage_BF(#text$, #White, $A9A9A9, 0, 4, 1, 7, 7, 0); Calculate needed height

; This are special functions for text output, directly, as image, or as sprite - The functions works equal the PB function ---
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance

; ; With linear gradient
; FrontColor_BF(1, $FFFFFF)
 LinearGradient_BF(1, 0, 0, width+100 , 0)
 
; With elliptic gradient
; This functions works equal the PB function
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
; You must deactivate again
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)
;CircularGradient_BF(1, width/2, height/2, height)

BackColor_BF(1, $FFFF)
; -------------------------------------------------------

Define text_image_ID=DrawTextCreateImage_BF(#text$, #White, $A9A9A9, 1, 0, 1, 7, 7, 0) ; Create a text image with a grey mask

Define alpha=0 ; Here you can activate alpha blending

width=ImageWidth(text_image_ID)
height=ImageHeight(text_image_ID)

Define window_ID=OpenWindow(#PB_Any, 0, 0, width, height,
                            "Draw Text directly in a PB sprite", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

OpenWindowedScreen(WindowID(window_ID), 0, 0, width, height)

Define sprite_1_ID=CreateSprite(#PB_Any, width, height) ; Create a PB sprite for the text output

StartDrawing(SpriteOutput(sprite_1_ID))
Box(0, 0, width/4, height, $FF0000)
Box(width-width/4, 0, width/4, height, $FF)
StopDrawing()

SetColorDistanceSpriteMask_BF(7)

; Function for simple using any images as sprites
; This function can output on images, PB sprites, canvas
; SpriteSimple_BF(mode, output_ID, texture_ID,
SpriteSimple_BF(1, sprite_1_ID, text_image_ID,
                0,     ; Grab transparence color from sprite pos x - Set to -1 ignore the mask
                0,     ; Grab transparence color from sprite pos y
                0,     ; Output pos x
                0,     ; Output pos y
                0,     ; You can here resize the output x
                0,     ; You can here resize the output y
                alpha, ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                0,     ; Endposition texture output       - Preset 0 = Clipping is automatic to input width
                0,     ; Endposition texture output       - Preset 0 = Clipping is automatic to input height
                0,     ; Startposition inside the texture - Preset 0 = The output starts with the texture x coordinate 0
                0,     ; Startposition inside the texture - Preset 0 = The output starts with the texture y coordinate 0
                0,     ; Endposition inside the texture   - Preset 0 = full texture width
                0)     ; Endposition inside the texture   - Preset 0 = full texture height
                       ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                       ; For using pictures with alpha channel use mode=2
                       ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                       ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                       ; Resizing can change the colors a little,
                       ; so it is available a presetted invisible color works after resizing not longer correct()

Define x, y, xx, yy, move

ActivateLineGoBackcolor_BF(1, $FF00) ; Activate a background color for LineGo and BoxGo (BoxGo is based on LineGo) - You can deactivate or remove - Try simple

HideWindow(window_ID, 0)

Repeat
  
  If Delay_BF(0, 25) ; Output
    Repeat           ; Get all window events before FlipBuffers
      Define win_event=WindowEvent()
      If win_event = #PB_Event_CloseWindow
        FreeTextures_BF() ; Free grabed textures
        End
      EndIf
    Until Not win_event
    
    StartDrawing(ScreenOutput()) ; BoxGo_16 - additional
    Define move=(move+1)%16
    
    BoxGo_16_BF(5, 30, width-10, height-60, $FFFFFF, move, %0011110000111100, 0) ; Alterable - Try simple
    BoxGo_16_BF(6, 31, width-12, height-62, $FFFFFF, move, %0011110000111100, 0)
    BoxGo_16_BF(7, 32, width-14, height-64, $FFFFFF, move, %0011110000111100, 0) 
    BoxGo_16_BF(8, 33, width-16, height-66, $FFFFFF, move, %0011110000111100, 0)
    
    ; BoxGo_16_BF(5, 30, width-10, height-60, $FFFFFF, move, %0011110000111100, 0) ; Alterable - Try simple
    ; BoxGo_16_BF(6, 31, width-12, height-62, $FFFFFF, move, %0011110000111100, 1) ; Changed direction
    ; BoxGo_16_BF(7, 32, width-14, height-64, $FFFFFF, move, %0011110000111100, 1) ; Changed direction
    ; BoxGo_16_BF(8, 33, width-16, height-66, $FFFFFF, move, %0011110000111100, 0)
    
    ; BoxGo_32_BF(5, 30, width-10, height-60, $FFFFFF, move, %0011110000111100, 0) ; Alterable - Try simple
    ; BoxGo_32_BF(6, 31, width-12, height-62, $FFFFFF, move, %0011110000111100, 1) ; Changed direction
    ; BoxGo_32_BF(7, 32, width-14, height-64, $FFFFFF, move, %0011110000111100, 1) ; Changed direction
    ; BoxGo_32_BF(8, 33, width-16, height-66, $FFFFFF, move, %0011110000111100, 0)  
    
    StopDrawing()
    
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(sprite_1_ID, 0, 0)
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 28
; FirstLine = 20
; EnableXP
; DisableDebugger