﻿
; Base Demo DrawText_Vector_BF - DPI aware

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
  Define font_0_ID=LoadFont(#PB_Any, "Arial", 15, #PB_Font_Bold)
  Define font_1_ID=LoadFont(#PB_Any, "Times New Roman", 15, #PB_Font_Bold)
CompilerElse
  Define font_0_ID=LoadFont(#PB_Any, "Arial", 11, #PB_Font_Bold)
  Define font_1_ID=LoadFont(#PB_Any, "Times New Roman", 11, #PB_Font_Bold)
CompilerEndIf
Define window_ID=OpenWindow(#PB_Any, 0, 0, 1200, 700, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, $FF00)
Define canvas_ID=CanvasGadget(#PB_Any, 5, 5 , WindowWidth(window_ID)-10, WindowHeight(window_ID)-10)

; - Create a background -
Define path$="./Image_Set/stone_1.jpg"
Define texture_ID=LoadImage(#PB_Any, path$)

; This function activate DPI aware enhancement for many BF functions, as sample Gadgets BF and FitImage BF and many more other
Activate_DPI_aware_BF(1)

ErrorCheck_BF(BucketFill_BF(-200, canvas_ID, texture_ID)) ; Full size output, not more settings needed

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available Array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

; DrawText_Vector_BF
; Flags : Text center=1 - Text right=2 - Text vertical=3
; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
; Mono line output give back the xx output coordinate - Multi line output give back the yy output coordinate
; For stretched text on a textured background often DrawingMode (#PB_2DDrawing_Transparent) is needed
; You can set the text color (f_col) As RGBA, but you must not - Alpha 0 is ignored and set a full visible color
; This function is GradientColor BF sensitive - (LinearGradient and CircularGradient)
; A Highlight is the text stretching (Headletter) scaling feature
; With scaling you can simple change the text size without changing a font, so you need only one font For any text sizes

StartVectorDrawing(CanvasVectorOutput(canvas_ID))
VectorFont(FontID(font_0_ID))

; A Highlight is the text stretching (Headletter) and scaling feature
; With scaling you can simple change the text size without changing a font, so you need only one font for any text sizes

; Alpha channel is suported - Set simple the color width - Sample $AAFF00FF - $AA is the Alpha channel - $FF is full visible

Define text$="A very nice Tool"+#LF$+"DrawText_Vector_BF"+#LF$+"Simple a little more"
Define result=DrawText_Vector_BF(100,       ; X pos
                                 10,        ; Y pos
                                 text$,     ; Text
                                 $FFFABF3F, ; Text Color
                                 1,         ; Flag
                                 0,         ; mode
                                 2,         ; Text stretching x - Headletter mode
                                 10,        ; Text stretching y - Headletter mode
                                 2.0,       ; Scale coordinates x
                                 2.0)       ; Scale coordinates y

Define text$="A very nice Tool"
Define result=DrawText_Vector_BF(10,    ; X pos
                                 10,    ; Y pos
                                 text$, ; Text
                                 #Red,  ; Text Color
                                 3,     ; Flag
                                 0,     ; mode
                                 1,     ; Text stretching x - Headletter mode
                                 1,     ; Text stretching y - Headletter mode
                                 4.0,   ; Scale coordinates x
                                 2.0)   ; Scale coordinates y

VectorFont(FontID(font_1_ID))
Define text$="Incredible"+#LF$+"Headletter mode"+#LF$+"With stepless free scaled"+#LF$+"and stretchable text"
Define text_stretching_x=2
Define text_stretching_y=5

CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  Define scale_coordinates_x.d=2.6
CompilerElse
  Define scale_coordinates_x.d=3.2
CompilerEndIf

Define scale_coordinates_y.d=4.0

Define result=DrawText_Vector_BF(500,                 ; X pos
                                 10,                  ; Y pos
                                 text$,               ; Text
                                 #Black,              ; Text Color
                                 1,                   ; Flag
                                 0,                   ; mode
                                 text_stretching_x,   ; Text stretching x - Headletter mode
                                 text_stretching_y,   ; Text stretching y - Headletter mode
                                 scale_coordinates_x, ; Scale coordinates x
                                 scale_coordinates_y) ; Scale coordinates y

; Get text width
Define box_width=GetTextWidth_Vector_BF(text$,
                                        0,                   ; Vertical text = 1
                                        text_stretching_x,   ; Text stretching x - Headletter mode
                                        scale_coordinates_x) ; Text scaling x

; Get text height
Define box_height=GetTextHeight_Vector_BF(text$,
                                          0,                   ; Vertical text = 1
                                          text_stretching_y,   ; Text stretching y - Headletter mode
                                          scale_coordinates_y) ; Text scaling y

; Activate linear gradient
; LinearGradient_BF(1, 0, 0, 500*DPI_ResizeFactor_BF() , 500*DPI_ResizeFactor_BF())
; Activate circular gradient
CircularGradient_BF(1, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 400*DPI_ResizeFactor_BF())

Define text$="All you can eat !"
Define result=DrawText_Vector_BF(270,                     ; X pos
                                 380,                     ; Y pos
                                 text$,                   ; Text
                                 $FF00FF,                 ; Text Color
                                 1,                       ; Flag
                                 0,                       ; mode
                                 4,                       ; Text stretching x - Headletter mode
                                 4,                       ; Text stretching y - Headletter mode
                                 4.0,                     ; Scale coordinates x
                                 4.5)                     ; Scale coordinates y

CircularGradient_BF(0) ; Deactivate Gradient Color

VectorFont(FontID(font_0_ID))
Define text$="The GFX_Wizzard_BF has a lot incredible text functions"+#LF$+
             "You found and can also create self"+#LF$+"many text output functions"+#LF$+#LF$+
             "All Wizzard functions are nearly endless combinable"
Define result=DrawText_Vector_BF(350,    ; X pos
                                 490,    ; Y pos
                                 text$,  ; Text
                                 #Black, ; Text Color
                                 1,      ; Flag
                                 0,      ; mode
                                 4,      ; Text stretching x - Headletter mode
                                 4,      ; Text stretching y - Headletter mode
                                 0.8,    ; Scale coordinates x
                                 0.8)    ; Scale coordinates y

Define x_pos=220
Define y_pos=140
RotateCoordinates_BF(x_pos, y_pos, 15) ; You must deactivate again - As sample so : RotateCoordinates_BF()
Define text$="Incredible"+#LF$+"Headletter mode"+#LF$+"With stepless free scaled"+#LF$+"and stretchable text"+#LF$+"Rotatable"
Define result=DrawText_Vector_BF(x_pos, ; X pos
                                 y_pos, ; Y pos
                                 text$, ; Text
                                 #Red,  ; Text Color
                                 1,     ; Flag
                                 0,     ; mode
                                 1,     ; Text stretching x - Headletter mode
                                 5,     ; Text stretching y - Headletter mode
                                 1.0,   ; Scale coordinates x
                                 2.0)   ; Scale coordinates y
RotateCoordinates_BF()                  ; You must deactivate again

; Activate circular gradient
CircularGradient_BF(1, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 180*DPI_ResizeFactor_BF())
Define text$="GFX_Wizzard_BF"
Define result=DrawText_Vector_BF(40,    ; X pos
                                 580,   ; Y pos
                                 text$, ; Text
                                 #Red,  ; Text Color
                                 1,     ; Flag
                                 0,     ; mode
                                 0.01,  ; Text stretching x - Headletter mode
                                 5,     ; Text stretching y - Headletter mode
                                 9.0,   ; Scale coordinates x
                                 6.0)   ; Scale coordinates y

; Activate circular gradient
CircularGradient_BF(1, 1000*DPI_ResizeFactor_BF(), 700*DPI_ResizeFactor_BF(), 900*DPI_ResizeFactor_BF())
Define text$="You must not load fonts with different sizes"+#LF$+
             "DrawText_Vector_BF is very mighty"+#LF$+
             "A single small font is enough"

Define result=DrawText_Vector_BF(900,   ; X pos
                                 500,   ; Y pos
                                 text$, ; Text
                                 #Blue, ; Text Color
                                 2,     ; Flag
                                 0,     ; mode
                                 0.01,  ; Text stretching x - Headletter mode
                                 0.01,  ; Text stretching y - Headletter mode
                                 0.8,   ; Scale coordinates x
                                 1.1)   ; Scale coordinates y

ResetCoordinates()

AddPathBox(491*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), box_width+10*DPI_ResizeFactor_BF(), box_height, 0)
StrokePath(3)

CircularGradient_BF(0) ; Deactivate Gradient color

StopVectorDrawing()

HideWindow(window_ID, 0)

While WaitWindowEvent()<>#PB_Event_CloseWindow
Wend
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 185
; FirstLine = 177
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger