﻿
; StretchText BD - DPI aware on windowed screen

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1)

Define font_1_ID=LoadFont(#PB_Any, "Georgia", 30, #PB_Font_Bold)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1100, 600, "StretchText BF - DPI aware on windowed screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(window_ID), 0, 0, WindowWidth(window_ID)*DPI_ResizeFactor_BF(), WindowHeight(window_ID)*DPI_ResizeFactor_BF())

Define sprite_ID=CreateSprite(#PB_Any, 256, 256)
StartDrawing(SpriteOutput(sprite_ID))
Box(0,0,128,128,$FF0000) : Box(128,0,128,128,$00FF00) : Box(0,128,128,128,$0000FF) : Box(128,128,128,128,$00FFFF)
StopDrawing()

Define background_sprite_ID=CreateSprite(#PB_Any, WindowWidth(window_ID)*DPI_ResizeFactor_BF(), WindowHeight(window_ID)*DPI_ResizeFactor_BF())
ErrorCheck_BF(BF(-2, background_sprite_ID, sprite_ID)) ; Create a tilled background

Define text$="Saki's"+#LF$+"Magic_StretchText_BF"+#LF$+
             "Headline mode"+#LF$+
             "Stepless free scalable"+#LF$+
             "Exactly fitted text"

; The text is output without disturbing borders and can even be output separately proportional or unproportional in the x and y axis
; Padding can be used and the text can be moved anywhere in the output rectangle

Define x_pos=20
Define y_pos=20
Define text_width.d=400  ; Text width  - So you get proportional x fitted text
Define text_height.d=300 ; Text height - So you get proportional y fitted text

; Define text_width.d=800*set_x  ; Text width  - So you get non propotrtional x fitted text
; Define text_height.d=400*set_y ; Text height - So you get non propotrtional y fitted text

Define fitted_text_width.d=400   ; Fitted text width  - Negative values available
Define fitted_text_height.d=300  ; Fitted text height - Negative values available
                                 ; Define fitted_width.d=GadgetWidth(CanvasGadget_1_ID)   ; Or so
                                 ; Define fitted_height.d=GadgetHeight(CanvasGadget_1_ID) ; Or so
Define text_color=#Blue          ; Accept alpha channel
Define text_stretching_x=0       ; Headline mode x stretching
Define text_stretching_y=0       ; Headline mode y stretching
Define padding_x.d=1             ; Padding x - Negative values available
Define padding_y.d=1             ; Padding y - Negative values available

Define flag=1 ; Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

; Rotate MagicStretchText - This force also a left adjusted output
Define activate_rotating_stretchtext=0
Define degree_stretchtext=15
RotateMagic_Stretchtext(activate_rotating_stretchtext, degree_stretchtext) ; Activate rotating stretchtext

; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
Define frame_size_stretchtext=5
Define frame_padding_stretchtext=2
Define frame_rounding_stretchtext=8
Define frame_color_stretchtext=$AAAAAAAA
Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                frame_padding_stretchtext,
                                frame_rounding_stretchtext,
                                frame_color_stretchtext)
ActivateScreenOutput_BF(1)

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($FF, $00, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

Macro output_sprites
  DisplayTransparentSprite(background_sprite_ID, 0, 0, 100)
  
  Define background_color=-1 ; Accept alpha channel - For invisible background set to -1
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=5
  Define frame_padding_stretchtext=2
  Define frame_rounding_stretchtext=12
  Define frame_color_stretchtext=$DDAAAAAA
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  text_color=#Blue
  background_color=#Yellow
  
  ; For output as image use a output function with alpha channel support or you see nothing
  ; With the function "ActivateScreenOutput_BF" you can activate the screen output
  ; Fitted_text_width and fitted_text_height different text_width and text_height is needed
  ; -for dynamic GUI, but also for moving or adjust the text inside the output rectangle
  Define result_ID=Magic_StretchText_Pro_BF(0,                  ; All channels supported
                                            text$,              ; Text
                                            x_pos,              ; Output x pos
                                            y_pos,              ; Output y pos
                                            text_width,         ; Text width
                                            text_height,        ; Text height
                                            fitted_text_width,  ; Fitted text width
                                            fitted_text_height, ; fitted text height
                                            text_color,         ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,   ; Alpha channel available - For invisible background set to -1
                                            text_stretching_x,  ; Text stretching x - Headline mode
                                            text_stretching_y,  ; Text stretching y - Headline mode
                                            padding_x.d,        ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,        ; Padding y - This is a virtual padding for resizing and boxed output
                                            flag,               ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,               ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Georgia",          ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)      ; Font style 
  
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=6
  Define frame_padding_stretchtext=4
  Define frame_rounding_stretchtext=10
  Define frame_color_stretchtext=#Yellow
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  
  text_color=#White
  background_color=-1
  
  Define text$="Advanced"+#LF$+"GFX_Wizzard_BF"+#LF$+
             "based text tools"
  
  ; Rotate MagicStretchText - This force also a left adjusted output
  Define activate_rotating_stretchtext=1
  Define degree_stretchtext=2
  RotateMagic_Stretchtext(activate_rotating_stretchtext, degree_stretchtext) ; Activate rotating stretchtext
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                         ; All channels supported
                                            text$,                     ; Text
                                            430*DPI_ResizeFactor_BF(), ; Output x pos
                                            30*DPI_ResizeFactor_BF(),  ; Output y pos
                                            400,                       ; Text width
                                            250,                       ; Text height
                                            400,                       ; Fitted text width
                                            250,                       ; fitted text height
                                            text_color,                ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,          ; Alpha channel available - For invisible background set to -1
                                            text_stretching_x,         ; Text stretching x - Headline mode
                                            text_stretching_y,         ; Text stretching y - Headline mode
                                            padding_x.d,               ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,               ; Padding y - This is a virtual padding for resizing and boxed output
                                            flag,                      ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                   ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)             ; Font style
  
  RotateMagic_Stretchtext(0)
  
  text_color=#White
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=6
  Define frame_padding_stretchtext=10
  Define frame_rounding_stretchtext=8
  Define frame_color_stretchtext=#Green
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  
  RotateMagic_Stretchtext(0)
  
  Define text_1$="Hello"+#LF$+
                 "World"
  
  ; Activate linear gradient
  ; LinearGradient_BF(1, 0, 0, 900*DPI_ResizeFactor_BF() , 400*DPI_ResizeFactor_BF())
  ; Activate circular gradient
  CircularGradient_BF(1, 500*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 800*DPI_ResizeFactor_BF())
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                         ; All channels supported
                                            text_1$,                   ; Text
                                            860*DPI_ResizeFactor_BF(), ; Output x pos
                                            10*DPI_ResizeFactor_BF(),  ; Output y pos
                                            220,                       ; Text width
                                            150,                       ; Text height
                                            220,                       ; Fitted text width
                                            150,                       ; fitted text height
                                            text_color,                ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,          ; Alpha channel available - For invisible background set to -1
                                            1,                         ; Text stretching x - Headline mode
                                            -4,                        ; Text stretching y - Headline mode
                                            padding_x.d,               ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,               ; Padding y - This is a virtual padding for resizing and boxed output
                                            flag,                      ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                   ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)             ; Font style
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=6
  Define frame_padding_stretchtext=10
  Define frame_rounding_stretchtext=8
  Define frame_color_stretchtext=#Yellow
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                         ; All channels supported
                                            text_1$,                   ; Text
                                            920*DPI_ResizeFactor_BF(), ; Output x pos
                                            180*DPI_ResizeFactor_BF(), ; Output y pos
                                            80,                        ; Text width
                                            520,                       ; Text height
                                            80,                        ; Fitted text width
                                            360,                       ; fitted text height
                                            text_color,                ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,          ; Alpha channel available - For invisible background set to -1
                                            1,                         ; Text stretching x - Headline mode
                                            -3,                        ; Text stretching y - Headline mode
                                            padding_x.d,               ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,               ; Padding y - This is a virtual padding for resizing and boxed output
                                            3,                         ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                   ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)             ; Font style
  
  Define text_2$="Hello"+#LF$+
                 "World"+#LF$+
                 "How are you"
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=0
  Define frame_padding_stretchtext=10
  Define frame_rounding_stretchtext=20
  Define frame_color_stretchtext=$8CB4D2
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                                ; All channels supported
                                            "Hello World"+#LF$+"How are you", ; Text
                                            350*DPI_ResizeFactor_BF(),        ; Output x pos
                                            300*DPI_ResizeFactor_BF(),        ; Output y pos
                                            600,                              ; Text width
                                            80,                               ; Text height
                                            600,                              ; Fitted text width
                                            80,                               ; fitted text height
                                            text_color,                       ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,                 ; Alpha channel available - For invisible background set to -1
                                            1,                                ; Text stretching x - Headline mode
                                            -3,                               ; Text stretching y - Headline mode
                                            padding_x.d,                      ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,                      ; Padding y - This is a virtual padding for resizing and boxed output
                                            1,                                ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                             ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                          ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)                    ; Font style
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=16
  Define frame_padding_stretchtext=10
  Define frame_rounding_stretchtext=20
  Define frame_color_stretchtext=$8CB4D2
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                         ; All channels supported
                                            text_2$,                   ; Text
                                            40*DPI_ResizeFactor_BF(),  ; Output x pos
                                            390*DPI_ResizeFactor_BF(), ; Output y pos
                                            880,                       ; Text width
                                            200,                       ; Text height
                                            800,                       ; Fitted text width
                                            200,                       ; fitted text height
                                            text_color,                ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,          ; Alpha channel available - For invisible background set to -1
                                            1,                         ; Text stretching x - Headline mode
                                            -3,                        ; Text stretching y - Headline mode
                                            padding_x.d,               ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,               ; Padding y - This is a virtual padding for resizing and boxed output
                                            1,                         ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                   ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)             ; Font style
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=1
  Define frame_padding_stretchtext=3
  Define frame_rounding_stretchtext=2
  Define frame_color_stretchtext=$AAAAAA
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  
  CircularGradient_BF(0)   
  
  text_color=#Black
  background_color=#Yellow
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                         ; All channels supported
                                            "Hi, this is cool",        ; Text
                                            910*DPI_ResizeFactor_BF(), ; Output x pos
                                            560*DPI_ResizeFactor_BF(), ; Output y pos
                                            220,                       ; Text width
                                            23,                        ; Text height
                                            100,                       ; Fitted text width
                                            18,                        ; fitted text height
                                            text_color,                ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,          ; Alpha channel available - For invisible background set to -1
                                            2,                         ; Text stretching x - Headline mode
                                            0,                         ; Text stretching y - Headline mode
                                            0,                         ; Padding x - This is a virtual padding for resizing and boxed output
                                            0,                         ; Padding y - This is a virtual padding for resizing and boxed output
                                            1,                         ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                      ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                   ; Font type - more is not needed - accept also ""
                                            0)                         ; Font style
  
  Define result_ID=Magic_StretchText_Pro_BF(0,                          ; All channels supported
                                            "Advanced text",            ; Text
                                            1030*DPI_ResizeFactor_BF(), ; Output x pos
                                            300*DPI_ResizeFactor_BF(),  ; Output y pos
                                            20,                         ; Text width
                                            300,                        ; Text height
                                            20,                         ; Fitted text width
                                            120,                        ; fitted text height
                                            text_color,                 ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,           ; Alpha channel available - For invisible background set to -1
                                            0,                          ; Text stretching x - Headline mode
                                            0,                          ; Text stretching y - Headline mode
                                            0,                          ; Padding x - This is a virtual padding for resizing and boxed output
                                            0,                          ; Padding y - This is a virtual padding for resizing and boxed output
                                            3,                          ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                       ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Arial",                    ; Font type - more is not needed - accept also ""
                                            0)                          ; Font style 
  
  text_color=#White
  background_color=-1
  
  ; Set a border for Magic_StretchText_Pro_BF() - Colors accept alpha channel
  Define frame_size_stretchtext=0
  Define frame_padding_stretchtext=3
  Define frame_rounding_stretchtext=4
  Define frame_color_stretchtext=$AAAAAA
  Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                  frame_padding_stretchtext,
                                  frame_rounding_stretchtext,
                                  frame_color_stretchtext)
  Define result_ID=Magic_StretchText_Pro_BF(0,                                                   ; All channels supported
                                            "On screen,"+#LF$+"canvas, images, sprites, window", ; Text
                                            10*DPI_ResizeFactor_BF(),                            ; Output x pos
                                            320*DPI_ResizeFactor_BF(),                           ; Output y pos
                                            450,                                                 ; Text width
                                            60,                                                  ; Text height
                                            400,                                                 ; Fitted text width
                                            60,                                                  ; fitted text height
                                            text_color,                                          ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel
                                            background_color,                                    ; Alpha channel available - For invisible background set to -1
                                            1,                                                   ; Text stretching x - Headline mode
                                            0,                                                   ; Text stretching y - Headline mode
                                            padding_x.d,                                         ; Padding x - This is a virtual padding for resizing and boxed output
                                            padding_y.d,                                         ; Padding y - This is a virtual padding for resizing and boxed output
                                            0,                                                   ; Text center=1 - Text right=2 - Text vertical=3
                                            mode,                                                ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                                            "Times New Roman",                                   ; Font type - more is not needed - accept also ""
                                            #PB_Font_Bold)                                       ; Font style
  
EndMacro

Repeat
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event = #PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Output
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    output_sprites
  EndIf
ForEver

; IDE Options = PureBasic 5.71 LTS (Linux - x64)
; CursorPosition = 388
; FirstLine = 362
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger