﻿
; VectorText - DrawVectorParagraph() enhanced - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1)

Define background_ID=LoadImage(#PB_Any, "./Image_Set/Sunrise_1.jpg")
ResizeImage(background_ID, ImageWidth(background_ID)/1.6*DesktopResolutionX(), ImageHeight(background_ID)/1.6*DesktopResolutionY())

Define window_ID=OpenWindow(#PB_Any, 0, 0,
                            ImageWidth(background_ID)/DesktopResolutionX(),
                            ImageHeight(background_ID)/DesktopResolutionX(),
                            "VectorText output as image - DrawVectorParagraph() enhanced - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 18, #PB_Font_Bold) ; -1 = Automatic - System font
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 40, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 9, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 25, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 40, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 11, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_Linux
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 14, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 26, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 8, #PB_Font_Bold)
  
CompilerEndIf

Define text$="BF enhanced DrawVectorParagraph function"+#LF$+#LF$+
             "DPI aware and alpha blending"+#LF$+#LF$+
             "This is a test output"+#LF$+
             "The quick brown fox jumps over the lazy dog"+#LF$+#LF$+
             "Left, right, center and Blocktext available"

Define output_width=360 ; 0 = Automatic width
Define output_height=0  ; Clip the height - You can set to zero for automatic
Define text_color=#White
Define background_color=#Green
Define text_alpha=255
Define background_alpha=90
Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center, #PB_VectorParagraph_Block 
Define frame_thickness=10
Define frame_color=-1 ; Automatic - Same text color
Define frame_alpha=255

Define image_ID=VectorText_CreateImage_BF(text$+#LF$+#LF$+#LF$+"Create simple your own mighty functions",
                                          font_0,
                                          output_width,
                                          output_height,
                                          text_color,
                                          background_color,
                                          text_alpha,
                                          background_alpha,
                                          flag,
                                          frame_thickness,
                                          frame_color,
                                          frame_alpha)

Define image_a_ID=VectorText_CreateImage_BF(text$+#LF$+#LF$+#LF$+"Create simple your own mighty functions",
                                            font_0,
                                            output_width,
                                            output_height,
                                            text_color,
                                            background_color,
                                            text_alpha,
                                            0,
                                            flag,
                                            frame_thickness,
                                            frame_color,
                                            frame_alpha)

Define image_1_ID=VectorText_CreateImage_BF(text$,
                                            font_0,
                                            -1, ; output_width - automatic
                                            output_height,
                                            #Yellow,
                                            background_color,
                                            text_alpha,
                                            0,
                                            flag,
                                            5)

; Padding X for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_X(-20)
; Padding Y for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_Y(-30)

Define image_2_ID=VectorText_CreateImage_RoundBox_BF("Or, what ever you want !"+#LF$+
                                                     "GFX_Wizzard_BF"+#LF$+"Simple a little more",
                                                     font_1,           ; -1 = System font
                                                     -1,               ; -1 = output_width - automatic
                                                     output_height,    ; 0 = automatic Output height 
                                                     #Blue,            ; Text color
                                                     background_color, ; Background color
                                                     text_alpha,       ; Text alpha
                                                     255 ,             ; Background alpha)
                                                     flag,             ; Flag
                                                     frame_thickness,  ; Frame thickness
                                                     frame_color,      ; Frame color
                                                     frame_alpha,      ; Frame alpha
                                                     18)               ; Rounding radius

Define image_3_ID=VectorText_CreateImage_BF("The special thing about the GFX_Wizzard_BF is"+
                                            ", that all functions can be combined almost endlessly",
                                            font_1,
                                            520,
                                            output_height,
                                            #Green,
                                            background_color,
                                            text_alpha,
                                            0,
                                            #PB_VectorParagraph_Center)

ResizeImage(image_1_ID,ImageWidth(image_1_ID)/1.3, ImageHeight(image_1_ID)/1.3)

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
ErrorCheck_BF(BucketFill_BF(-100, image_ID, texture_1_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $FFFFFF)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

ErrorCheck_BF(BucketFill_BF(-100, image_a_ID, texture_1_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $FFFFFF)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

StartDrawing(CanvasOutput(canvas_ID))
DrawImage(ImageID(background_ID), 0, 0)
DrawAlphaImage(ImageID(image_1_ID), 460*DPI_ResizeFactor_BF(), 30*DPI_ResizeFactor_BF())
DrawAlphaImage(ImageID(image_2_ID), 500*DPI_ResizeFactor_BF(), 310*DPI_ResizeFactor_BF(), 170)
StopDrawing()

RotateAlphaChannelSprite_BF(canvas_ID, image_3_ID,                                                                         
                            810*DPI_ResizeFactor_BF(), ; Output pos x
                            -70*DPI_ResizeFactor_BF(), ; Output pos y
                            20,                        ; Rotating degree
                            2,                         ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation - Mode 1 has no effekt on linux
                            0,                         ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)
                            0,                         ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                            0,                         ; Endposition texture output y - Preset 0 = Clipping is automatic to input height
                            370*DPI_ResizeFactor_BF(), ; You can here resize the output x
                            250*DPI_ResizeFactor_BF()) ; You can here resize the output y
                                                       ; And more parameters available - Look in the Wizzard declare part :-)

Define rectangle_ID=Grab_Rectangle_BF(canvas_ID, ; Grab rectangle
                                      20,
                                      50,
                                      ImageWidth(image_ID)/DPI_ResizeFactor_BF()+1,
                                      ImageHeight(image_ID)/DPI_ResizeFactor_BF()+1,
                                      1)

HideWindow(window_ID, 0)

; Demo for handling animations on BF
Define i, win_event, animation_delay=50
Delay_BF(1, -1) ; Init BF delay timer 1
                ; -1 set the first delay to zero for beginning a animation directly without a delay
                ; You must not do this here with a 30ms delay, it's for demonstrating how it work

Macro get_all_events ; Get all window events
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until win_event<>#PB_Event_CloseWindow
EndMacro

Repeat ; Animation part 1
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(image_ID), 20*DPI_ResizeFactor_BF(), 50*DPI_ResizeFactor_BF(), i)
    StopDrawing()
  EndIf
Until i>30

i=0
Repeat ; Animation part 2
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(image_a_ID), 20*DPI_ResizeFactor_BF(), 50*DPI_ResizeFactor_BF(), i)
    StopDrawing()
  EndIf
Until i>30

Get_Rectangle_BF(rectangle_ID) ; Get the rectangle coordinates

i=0
Repeat ; Animation part 3 - Write the rectangle
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(Get_Rectangle_ImageID_BF(rectangle_ID)), Get_Rectangle_x_BF(), Get_Rectangle_y_BF(), i)
    StopDrawing()
  EndIf
Until i>80

i=0
Repeat ; Animation part 4 - Write the rectangle
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(image_a_ID), 20*DPI_ResizeFactor_BF(), 50*DPI_ResizeFactor_BF(), i)
    StopDrawing()
  EndIf
Until i>80

i=0
Repeat ; Animation part 5 - Write the rectangle
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(Get_Rectangle_ImageID_BF(rectangle_ID)), Get_Rectangle_x_BF(), Get_Rectangle_y_BF(), i)
    StopDrawing()
  EndIf
Until i>80

i=0
Repeat ; Animation part 6 - Write the rectangle
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(image_ID), 20*DPI_ResizeFactor_BF(), 50*DPI_ResizeFactor_BF(), i)
    StopDrawing()
  EndIf
Until i>80

; BucketFill_BF
SetColorDistanceFill_BF(55)
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")

BucketFill_BF(-200, canvas_ID, texture_2_ID, ; Texture mode with alpha blending
              -1,                            ; Grab transparence color from sprite pos x - For preset set ..x=-1  
              #Green)                        ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

; Create and output BF sprite from the canvas
Define texture_3_ID=CreateImage_from_Canvas_BF(canvas_ID) ; Create a image from a canvas
Get_Rectangle_BF(rectangle_ID)                            ; Get the rectangle coordinates
Define x=463*DPI_ResizeFactor_BF()
Define y=33*DPI_ResizeFactor_BF()
Define width=ImageWidth(image_1_ID)-6*DPI_ResizeFactor_BF()
Define height=ImageHeight(image_1_ID)-6*DPI_ResizeFactor_BF()

ErrorCheck_BF(SpriteSimple_BF(0, canvas_ID, texture_3_ID, 
                              0,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                              0,       ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                              x,       ; Output pos x
                              y,       ; Output pos y
                              width,   ; You can here resize the output x
                              height)) ; You can here resize the output y

; BoxGo_32_BF
Procedure move(rectangle_ID, frame_thickness)
  Static move, swapp, swapp_1
  Protected i
  
  Get_Rectangle_BF(rectangle_ID) ; Get the rectangle coordinates
  Protected x=Get_Rectangle_x_BF()
  Protected y=Get_Rectangle_y_BF()
  Protected width=Get_Rectangle_Width_BF()
  Protected height=Get_Rectangle_Height_BF()
  
  frame_thickness*DPI_ResizeFactor_BF()/1.5+2
  
  For i=0 To frame_thickness
    If swapp<50
      If swapp_1<200
        ActivateLineGoBackcolor_BF(1, #Green) ; Activate a background color for LineGo and BoxGo (BoxGo is based on LineGo)
                                              ; - You can deactivate Or remove - Try simple
      Else
        ActivateLineGoBackcolor_BF(0) ; Deactivate a background color for LineGo and BoxGo
      EndIf
      BoxGo_32_BF(x+i, y+i, width-i*2, height-i*2, #Yellow, move, %00001111111100000000111111110000, 1)
    Else
      BoxGo_32_BF(x+i, y+i, width-i*2, height-i*2, #Blue, move, %00001111111100000000111111110000, 0)
    EndIf
  Next i
  
  move=(move+2)%32 : swapp=(swapp+2)%101 : swapp_1=(swapp_1+2)%401
EndProcedure

i=0
Repeat ; Animation part 7 - Write the rectangle
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    move(rectangle_ID, frame_thickness)
    StopDrawing()
  EndIf
ForEver

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeRectangles_BF()
FreeTextures_BF()
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 94
; FirstLine = 91
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger