﻿
; VectorText - DrawVectorParagraph() enhanced - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1)

Define background_ID=LoadImage(#PB_Any, "./Image_Set/Sunrise_1.jpg")
ResizeImage(background_ID, ImageWidth(background_ID)/1.6*DesktopResolutionX(), ImageHeight(background_ID)/1.4*DesktopResolutionY())

Define window_ID=OpenWindow(#PB_Any, 0, 0,
                            ImageWidth(background_ID)/DesktopResolutionX(),
                            ImageHeight(background_ID)/DesktopResolutionX(),
                            "VectorText output as image - DrawVectorParagraph() enhanced - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 18, #PB_Font_Bold) ; -1 = Automatic - System font
  Define font_1=LoadFont(#PB_Any, "Arial", 36, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 9, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 25, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 50, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 11, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_Linux
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 13, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 32, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 8, #PB_Font_Bold)
  
CompilerEndIf

; Available Parameters - Samples
; Define output_x_pos=10
; Define output_y_pos=10
; Define output_width=-1 ; -1 = Automatic width
; Define output_height=0 ; Clip the height - 0 = Automatic height
; Define text_color=#Blue
; Define background_color=$DEDEDE
; Define text_alpha=255
; Define background_alpha=255
; Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center, #PB_VectorParagraph_Block 
; Define frame_thickness=3
; Define frame_color=$FF
; Define frame_alpha=255
; Define rotating=0    ; Rotate the output
; Define scaling_x=1.0 ; Scaling the output x
; Define scaling_y=1.0 ; Scaling the output y

; Get_Rectangle_x_BF()
; Get_Rectangle_y_BF()
; Get_Rectangle_width_BF()
; Get_Rectangle_height_BF() 
; For get only the rectangle coordinates set simple the text and background alpha = 0 - Or set output_ID = -1
; - So you can as sample pre fill the rectangle with what ever you want
; - Also you can use a post fill with BucketFill_BF, this create border effects to the text depending on the background color used
; - The BF Fill functions are also SetColorDistanceFill_BF() sensitive to influence border effects and other how ever you want
; output_width, output_height is on DPIaware internal multiplied by the DPI_ResizeFactor_BF()
; - Max is so 3e4/DPI_ResizeFactor_BF()
; Check this or the text will be cut off

StartDrawing(CanvasOutput(canvas_ID))
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing()

; Hint :
; If you only need some functions, just make yourself own new sub functions !
; The functions of the Wizzard can easily be combined and changed almost endlessly
; As sample, for direct output on screen, you can use the sub function VectorText_CreateImage_BF()

; = Sample for creating a user defined new function ==========
; This Function is also included in the Wizzard 
Procedure VectorText_BF_here(text$,                         ; Text
                             output_ID,                     ; Output destination
                             output_x_pos,                  ; Output x pos
                             output_y_pos,                  ; Output y pos
                             font=-1,                       ; -1 = Automatic - System Font
                             text_color=#Black,             ; Text color
                             background_color=#White,       ; Background color
                             background_alpha=255,          ; Background alpha PB specific
                             flag=#PB_VectorParagraph_Left) ; Flag
  
  Protected result=VectorText_Simple_RoundBox_BF(text$,
                                                 output_ID,        ; Output destination
                                                 output_x_pos,     ; Output x pos
                                                 output_y_pos,     ; Output y pos
                                                 font,             ; -1 = Font preset system font
                                                 0,                ; Output_width - Line break is ever automatically, 0 is automatically width
                                                 0,                ; Output height 0 = automatically height - This is mostly recommended
                                                 text_color,       ; Text color
                                                 background_color, ; Background color
                                                 255,              ; Text alpha PB specific
                                                 background_alpha, ; Background alpha PB specific
                                                 flag,             ; Flag Text adjustment
                                                 0,                ; Frame thickness
                                                 -1,               ; Frame color=-1, ; -1 = Automatic - Same Text color
                                                 255,              ; Frame alpha PB specific
                                                 0,                ; Rotating angle
                                                 0)                ; Edge rounding 
  
  ProcedureReturn result
EndProcedure
; = End creating a user defined new function =================

; Ready to rumble ! ==========================================

Define text$="This are standard outputs"+#LF$+#LF$+
             "You must not set any parameters !"+#LF$+#LF$+
             "All work automatically"+#LF$+#LF$+
             "Preset is left adjusted text with black text,"+#LF$+
             "white background and a automatically space offset"+#LF$+
             "betwen frame and text"

; 1 = Use the user defined Function ============================
Vector_Roundbox_Simple_Padding_X(-5) ; Padding X for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_Y(-5) ; Padding Y for Vector_Roundbox_Simple functions
VectorText_BF_here(text$,
                   canvas_ID, ; Output destination
                   20,        ; Output x pos
                   20)        ; Output y pos

; 2 ==========================================================
Vector_Roundbox_Simple_Padding_X(-10) ; Padding X for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_Y(-20) ; Padding Y for Vector_Roundbox_Simple functions
VectorText_BF_here(text$,
                   canvas_ID,                                        ; Output destination
                   Get_Rectangle_x_BF()+Get_Rectangle_width_BF()+25, ; Output x pos - Adjusted
                   Get_Rectangle_y_BF(),                             ; Output y pos - Adjusted
                   font_0)                                           ; Font preset

; 3 ==========================================================
VectorText_Simple_BF("Line break is ever automatically"+#LF$+#LF$+text$,
                     canvas_ID, ; Output destination
                     995,       ; Output x pos
                     20,        ; Output y pos
                     font_2,    ; Font preset
                     150)       ; Output_width - Line break is ever automatically

; For exactelly positioned outputs or post processing you can get after each VectorText_Simple_BF call
; the coordinates, width nd height
; Debug Get_Rectangle_x_BF()
; Debug Get_Rectangle_y_BF()
; Debug Get_Rectangle_width_BF()
; Debug Get_Rectangle_height_BF()

; 4 ==========================================================
Vector_Roundbox_Simple_Padding_X(-5) ; Padding X for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_Y(-5) ; Padding Y for Vector_Roundbox_Simple functions

VectorText_Simple_RoundBox_BF("Line break is ever automatically"+#LF$+#LF$+text$,
                              canvas_ID,                  ; Output destination
                              40,                         ; Output x pos
                              220,                        ; Output y pos
                              -1,                         ; -1 = Font preset system font
                              250,                        ; Output_width - Line break is ever automatically - 0 = automatically width
                              0,                          ; Output height 0 = automatically height - This is mostly recommended
                              #Blue,                      ; Text color
                              #Yellow,                    ; Background color
                              255,                        ; Text alpha PB specific
                              120,                        ; Background alpha PB specific
                              #PB_VectorParagraph_Left,   ; Flag Text adjustment
                              6,                          ; Frame thickness
                              -1,                         ; Frame color=-1, ; -1 = Automatic - Same Text color
                              120,                        ; Frame alpha PB specific
                              15,                         ; rotating angle
                              18)                         ; Edge rounding

; 5 ==========================================================
VectorText_Simple_BF("Line break is ever automatically"+#LF$+
                     "Text you can change how ever you this want",
                     canvas_ID,                  ; Output destination
                     360,                        ; Output x pos
                     310,                        ; Output y pos
                     -1,                         ; -1 = Font preset system font
                     200,                        ; Output_width - Line break is ever automatically - 0 = automatically width
                     0,                          ; Output height 0 = automatically height - This is mostly recommended
                     #White,                     ; Text color
                     #Yellow,                    ; Background color
                     255,                        ; Text alpha PB specific
                     100,                        ; Background alpha PB specific
                     #PB_VectorParagraph_Center) ; Flag Text adjustment

; 6 ==========================================================
VectorText_Simple_BF("Line break is ever automatically"+#LF$+
                     "Text you can change how ever you this want",
                     canvas_ID,                  ; Output destination
                     610,                        ; Output x pos
                     310,                        ; Output y pos
                     -1,                         ; -1 = Font preset system font
                     200,                        ; Output_width - Line break is ever automatically - 0 = automatically width
                     0,                          ; Output height 0 = automatically height - This is mostly recommended
                     #White,                     ; Text color
                     #Yellow,                    ; Background color
                     255,                        ; Text alpha PB specific
                     0,                          ; Background alpha PB specific
                     #PB_VectorParagraph_Center, ; Flag Text adjustment
                     3,                          ; Frame thickness
                     -1,                         ; Frame color=-1, ; -1 = Automatic - Same Text color
                     180)                        ; Frame alpha PB specific

; 7 ==========================================================
VectorText_Simple_BF("Line break is ever automatically"+#LF$+#LF$+
                     "Also free rotating"+#LF$+
                     "And many more abilities",
                     canvas_ID,                  ; Output destination
                     880,                        ; Output x pos
                     300,                        ; Output y pos
                     -1,                         ; -1 = Font preset system font
                     250,                        ; Output_width - Line break is ever automatically - 0 = automatically width
                     0,                          ; Output height 0 = automatically height - This is mostly recommended
                     #Black,                     ; Text color
                     #Green,                     ; Background color
                     255,                        ; Text alpha PB specific
                     180,                        ; Background alpha PB specific
                     #PB_VectorParagraph_Center, ; Flag Text adjustment
                     4,                          ; Frame thickness
                     #Green,                     ; Frame color=-1, ; -1 = Automatic - Same Text color
                     255,                        ; Frame alpha PB specific
                     -12)                        ; Rotating angle

; 8 ==========================================================
; Padding X for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_X(-10)
; Padding Y for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_Y(-22)

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(2.0)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(2.0)

VectorText_Simple_RoundBox_small_BF("Line break is ever automatically"+#LF$+
                                    "Automatic DPI aware enhancement"+#LF$+
                                    "Free scaling without limits",
                                    canvas_ID,                  ; Output destination
                                    30,                         ; Output x pos
                                    512,                        ; Output y pos
                                    -1,                         ; -1 = Font preset system font
                                    #Red,                       ; Text color
                                    #Blue,                      ; Background color
                                    120,                        ; Background alpha PB specific
                                    4,                          ; Frame thickness
                                    #PB_VectorParagraph_Center, ; Flag Text adjustment
                                    8)                          ; Edge rounding

; 9 ==========================================================
; Padding X for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_X(-10)
; Padding Y for Vector_Roundbox_Simple functions
Vector_Roundbox_Simple_Padding_Y(-15)

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(1.0)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(0.8)

VectorText_Simple_RoundBox_BF("The position data and dimensions of VectorText_Simple_BF is inheritable",
                              canvas_ID,                  ; Output destination
                              380,                        ; Output x pos
                              455,                        ; Output y pos,
                              font_0,                     ; -1 = Font preset system font
                              0,                          ; Output_width - Line break is ever automatically - 0 = automatically width
                              0,                          ; Output height 0 = automatically height - This is mostly recommended
                              #Red,                       ; Text color
                              #Yellow,                    ; Background color
                              255,                        ; Text alpha PB specific
                              220,                        ; Background alpha PB specific
                              #PB_VectorParagraph_Center, ; Flag Text adjustment
                              5,                          ; Frame thickness
                              #Green,                     ; Frame color=-1, ; -1 = Automatic - Same Text color
                              80,                         ; Frame alpha PB specific
                              0)                          ; Rotating angle) 

; 10 =========================================================
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(1.4)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(0.8)

VectorText_Simple_BF("GFX_Wizzard_BF"+#LF$+
                     "Simple a little more",
                     canvas_ID,                  ; Output destination
                     500,                        ; Output x pos
                     480,                        ; Output y pos
                     Font_1,                     ; -1 = Font preset system font
                     0,                          ; Output_width - Line break is ever automatically, 0 is automatically width
                     0,                          ; Output height 0 = automatically height - This is mostly recommended
                     $F5F5F5,                    ; Text color
                     #Yellow,                    ; Background color
                     255,                        ; Text alpha PB specific
                     0,                          ; Background alpha PB specific
                     #PB_VectorParagraph_Center, ; Flag Text adjustment
                     0,                          ; Frame thickness
                     #Green,                     ; Frame color=-1, ; -1 = Automatic - Same Text color
                     255,                        ; Frame alpha PB specific
                     15)                         ; Rotating angle

; Post process - Make text rustic - Primary not needed
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
ErrorCheck_BF(BucketFill_BF(-80, canvas_ID, texture_1_ID, -1, $F5F5F5))

HideWindow(window_ID, 0)

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeTextures_BF()
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 139
; FirstLine = 135
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger