﻿
; VectorText - DrawVectorParagraph() enhanced - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; Activate here DPI aware for Windows OS - Activate also in the PB compiler options
; For pre output on images you can manually deactivate dpi_aware
Activate_DPI_aware_BF(1)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 500, "VectorText direct output - DrawVectorParagraph() enhanced - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

StartDrawing(CanvasOutput(canvas_ID))
Box(0, 0, WindowWidth(window_ID)*DesktopResolutionX(), WindowHeight(window_ID)*DesktopResolutionX(), $FF)
StopDrawing()

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 18, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_1=LoadFont(#PB_Any, "Arial", 12, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 9, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 25, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 16, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 11, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_Linux
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 16, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 11, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 8, #PB_Font_Bold)
  
CompilerEndIf

Define text$="BF enhanced DrawVectorParagraph function"+#LF$+#LF$+
             "The quick brown fox jumps over the lazy dog"+#LF$+#LF$+
             "DPI aware and alpha blending"+#LF$+#LF$+
             "This is a test output"+#LF$+#LF$+
             "Left, right, center and Blocktext available"

Define output_x_pos=30
Define output_y_pos=20
Define output_width=300 ; 0 = Automatic width
Define output_height=0  ; Clip the height - 0 = Automatic height
Define text_color=#Blue
Define background_color=#Green
Define text_alpha=255
Define background_alpha=255
Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center, #PB_VectorParagraph_Block 
Define frame_thickness=4
Define frame_color=#Blue ; -1 = Same text color
Define frame_alpha=255
Define degree=5

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height,
                     text_color,
                     background_color,
                     text_alpha,
                     background_alpha,
                     flag,
                     frame_thickness,
                     frame_color,
                     frame_alpha,
                     degree)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+390,
                     output_y_pos-10,
                     font_2,
                     output_width-100,
                     0, 
                     #Yellow,
                     #Blue,
                     text_alpha,
                     background_alpha,
                     flag,
                     2)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+410,
                     output_y_pos+210,
                     font_1,
                     output_width,
                     0,
                     #Black,
                     #Yellow,
                     text_alpha,
                     background_alpha,
                     flag,
                     3)

; Working demo - Post create a background :-)
Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
ErrorCheck_BF(FloodFill_BF(-180, canvas_ID, texture_0_ID, 0, 0))

HideWindow(window_ID, 0)

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeTextures_BF()
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 42
; FirstLine = 31
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger