﻿
; VectorText - DrawVectorParagraph() enhanced - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; Activate here DPI aware for Windows OS - Activate also in the PB compiler options
; For pre output on images you can manually deactivate dpi_aware
Activate_DPI_aware_BF(1)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1100, 500, "VectorText direct output - DrawVectorParagraph() enhanced - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 18, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_1=LoadFont(#PB_Any, "Arial", 12, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 9, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 25, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 16, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 11, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_Linux
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 16, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 11, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 8, #PB_Font_Bold)
  
CompilerEndIf

Define text$="BF enhanced DrawVectorParagraph function"+#LF$+#LF$+
             "The quick brown fox jumps over the lazy dog"+#LF$+#LF$+
             "DPI aware and alpha blending"+#LF$+#LF$+
             "This is a test output"+#LF$+#LF$+
             "Left, right, center and Blocktext available"

Define output_x_pos=20
Define output_y_pos=20
Define output_width=300 ; -1 = Automatic width
Define output_height=0  ; Clip the height - 0 = Automatic height
Define text_color=#Blue
Define background_color=$DEDEDE
Define text_alpha=255
Define background_alpha=255
Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center, #PB_VectorParagraph_Block 
Define degree=0
Define frame_thickness=6
Define frame_color=$606060 ; -1 = Same text color
Define frame_alpha=100

; For get only the rectangle coordinates set simple the text and background alpha = 0 - Or set output_ID = -1
; - So you can as sample pre fill the rectangle with what ever you want
; - Also you can use a post fill with BucketFill_BF, this create border effects to the text depending on the background color used
; - The BF Fill functions are also SetColorDistanceFill_BF() sensitive to influence border effects and other how ever you want

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height,
                     text_color,
                     background_color,
                     0,
                     background_alpha,
                     flag,
                     frame_thickness,
                     frame_color,
                     frame_alpha,
                     degree)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+410,
                     output_y_pos-10,
                     font_2,
                     output_width-100,
                     0,
                     #Yellow,
                     $FF00FF,
                     text_alpha,
                     background_alpha,
                     flag)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+370,
                     output_y_pos+200,
                     font_1,
                     output_width-30,
                     0,
                     #Black,
                     #Yellow,
                     text_alpha,
                     background_alpha,
                     flag)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+700,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height,
                     #Blue,
                     $DCDCDC,
                     text_alpha,
                     background_alpha,
                     flag,
                     2)

Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")

ErrorCheck_BF(BucketFill_BF(-180, canvas_ID, texture_0_ID,
                            -1,      ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            #White)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

ErrorCheck_BF(BucketFill_BF(-160, canvas_ID, texture_0_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $DCDCDC)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

ErrorCheck_BF(BucketFill_BF(-180, canvas_ID, texture_0_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            #Yellow)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")

ErrorCheck_BF(BucketFill_BF(-2, canvas_ID, texture_1_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $FF00FF)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")

ErrorCheck_BF(BucketFill_BF(-120, canvas_ID, texture_2_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $DEDEDE,
                            -450*DPI_ResizeFactor_BF(),
                            -100*DPI_ResizeFactor_BF()))

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height,
                     text_color,
                     background_color,
                     text_alpha,
                     0,
                     flag)

HideWindow(window_ID, 0)

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeTextures_BF()
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 144
; FirstLine = 136
; Folding = -
; EnableXP
; DisableDebugger