﻿
; VectorText - DrawVectorParagraph() enhanced - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; Activate here DPI aware for Windows OS - Activate also in the PB compiler options
; For pre output on images you can manually deactivate dpi_aware
Activate_DPI_aware_BF(1)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1100, 500, "VectorText direct output - DrawVectorParagraph() enhanced - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 18, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_1=LoadFont(#PB_Any, "Arial", 12, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 9, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 25, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 16, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 11, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_Linux
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 16, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Arial", 11, #PB_Font_Bold)
  Define font_2=LoadFont(#PB_Any, "", 8, #PB_Font_Bold)
  
CompilerEndIf

Define text$="BF enhanced DrawVectorParagraph function"+#LF$+#LF$+
             "The quick brown fox jumps over the lazy dog"+#LF$+#LF$+
             "DPI aware and alpha blending"+#LF$+#LF$+
             "This is a test output"+#LF$+#LF$+
             "Left, right, center and Blocktext available"

Define output_x_pos=20
Define output_y_pos=20
Define output_width=300 ; -1 = Automatic width
Define output_height=0  ; Clip the height - 0 = Automatic height
Define text_color=#Blue
Define background_color=$DEDEDE
Define text_alpha=255
Define background_alpha=255
Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center, #PB_VectorParagraph_Block 
Define frame_thickness=3
Define frame_color=$FF
Define frame_alpha=255
Define scaling_x=0.5
Define scaling_y=0.5

; For get only the rectangle coordinates set simple the text and background alpha = 0 - Or set output_ID = -1
; - So you can as sample pre fill the rectangle with what ever you want
; - Also you can use a post fill with BucketFill_BF, this create border effects to the text depending on the background color used
; - The BF Fill functions are also SetColorDistanceFill_BF() sensitive to influence border effects and other how ever you want

; Get only the rectangle coordinates
VectorText_Simple_BF(text$,
                     -1,
                     output_x_pos,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height)

; Set only the colored background
VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height,
                     $DEDEDE,
                     $DEDEDE)

; Fill the colored background with a texture
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")
ErrorCheck_BF(BucketFill_BF(-120, canvas_ID, texture_1_ID,
                            -1, ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $DEDEDE,
                            -450*DPI_ResizeFactor_BF(),
                            -100*DPI_ResizeFactor_BF()))

; Draw the text with invisible background on the rectangle
VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos,
                     output_y_pos,
                     font_0,
                     output_width,
                     output_height,
                     text_color,
                     background_color,
                     text_alpha,
                     0,
                     flag,
                     2)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+410,
                     output_y_pos-10,
                     font_2,
                     output_width-100,
                     0,
                     #Yellow,
                     $FF00FF,
                     text_alpha,
                     background_alpha,
                     flag)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+370,
                     output_y_pos+200,
                     font_1,
                     output_width-30,
                     0,
                     #Black,
                     #Yellow,
                     text_alpha,
                     background_alpha,
                     flag)

; Each VectorText_Simple_BF() give back also the rectangle coordinates and its width and height for post processing
StartDrawing(CanvasOutput(canvas_ID))
DrawingMode(#PB_2DDrawing_Outlined)
Box(Get_Rectangle_x_BF()*DPI_ResizeFactor_BF(),
    Get_Rectangle_y_BF()*DPI_ResizeFactor_BF(),
    Get_Rectangle_width_BF()*DPI_ResizeFactor_BF(),
    Get_Rectangle_height_BF()*DPI_ResizeFactor_BF(),
    #Black)
Box(Get_Rectangle_x_BF()*DPI_ResizeFactor_BF()+1,
    Get_Rectangle_y_BF()*DPI_ResizeFactor_BF()+1,
    Get_Rectangle_width_BF()*DPI_ResizeFactor_BF()-2,
    Get_Rectangle_height_BF()*DPI_ResizeFactor_BF()-2,
    #Black)
StopDrawing()

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(0.8)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(0.8)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+670,
                     output_y_pos-40,
                     font_0,
                     output_width-30,
                     output_height,
                     #Blue,   ; Text color
                     $DCDCDC, ; Background color
                     text_alpha,
                     background_alpha,
                     flag,
                     5,   ; Frame thickness
                     -1,  ; frame color -1 = automatic same text color
                     255, ; Frame alpha
                     40)  ; Rotating 

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(0.7)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(0.7)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+820,
                     output_y_pos+160,
                     font_0,
                     output_width-30,
                     output_height,
                     #Yellow, ; Text color
                     $FF00FF, ; Background color
                     text_alpha,
                     background_alpha,
                     flag,
                     8,   ; Frame thickness
                     -1,  ; Frame color -1 = automatic same text color
                     255, ; Frame alpha
                     -10) ; Rotating 

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(0.7)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(0.4)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+620,
                     output_y_pos+270,
                     font_0,
                     output_width-30,
                     output_height,
                     #Blue,   ; Text color
                     $FFFFFE, ; Background color
                     text_alpha,
                     background_alpha,
                     flag,
                     1,   ; Frame thickness
                     -1,  ; Frame color -1 = automatic same text color
                     255, ; Frame alpha
                     0)   ; Rotating

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF(0.8)
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF(0.8)

VectorText_Simple_BF(text$,
                     canvas_ID,
                     output_x_pos+150,
                     output_y_pos+160,
                     font_0,
                     output_width-30,
                     output_height,
                     #Blue,   ; Text color
                     $FFFFFA, ; Background color
                     text_alpha,
                     background_alpha,
                     flag,
                     6,      ; Frame thickness
                     #Green, ; Frame color -1 = automatic same text color
                     200,    ; Frame alpha
                     -15)    ; Rotating 

; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output width
ScaleVectorWidth_BF()
; This function scale the FittedText_RotateRoundBox_Vector_y_BF and all VectorText_Simple functions output height
ScaleVectorHeight_BF()

Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")

ErrorCheck_BF(BucketFill_BF(-180, canvas_ID, texture_0_ID,
                            -1,      ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            #White)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

; Fill the colored backgrounds with textures
ErrorCheck_BF(BucketFill_BF(-160, canvas_ID, texture_0_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $DCDCDC)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

ErrorCheck_BF(BucketFill_BF(-180, canvas_ID, texture_0_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            #Yellow)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")

ErrorCheck_BF(BucketFill_BF(-2, canvas_ID, texture_2_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $FF00FF)) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

ErrorCheck_BF(BucketFill_BF(-120, canvas_ID, texture_1_ID,
                            -1, ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $FFFFFA,
                            -450*DPI_ResizeFactor_BF(),
                            -100*DPI_ResizeFactor_BF())) ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 

HideWindow(window_ID, 0)

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeTextures_BF()
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 87
; FirstLine = 81
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger