﻿
; VectorText - DrawVectorParagraph() enhanced - On ScrollAreaGadget - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

; Activate here DPI aware for Windows OS - Activate also in the PB compiler options
; For pre output on images you can manually deactivate dpi_aware
Activate_DPI_aware_BF(1)

Define output_width=750
Define text_color=$00305D
Define background_color=$FFFFFF
Define text_alpha=255
Define background_alpha=180
Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Block 

Define max_output_height=3e4/DPI_ResizeFactor_BF() ; Max output_height - Max available PB image size (3e4) - Set ever so
                                                   ; Max output_width, max output_height is on DPIaware internal multiplied by the DPI_ResizeFactor_BF()
                                                   ; - Its the Max available PB image size = 3e4
                                                   ; - Max is so 3e4/DPI_ResizeFactor_BF()
                                                   ; Check this or the text will be cut off at the bottom

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width+200, 480,
                            "VectorText direct output - DrawVectorParagraph() enhanced - On ScrollAreaGadget - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

SetWindowColor(window_ID, $558EC3)

Define font_0=LoadFont(#PB_Any, "Times New Roman", 26, #PB_Font_Bold) ; -1 = Automatic - System Font

Define text$="ScrollAreaGadget Demo"+#LF$+#LF$+
             "BF enhanced DrawVectorParagraph function"+#LF$+#LF$+
             "The quick brown fox jumps over the lazy dog"+#LF$+#LF$+
             "DPI aware and alpha blending"+#LF$+
             #LF$+"This is a test output"+#LF$+#LF$+
             "Left, right, center and Blocktext available"+#LF$+#LF$+
             "###########"+#LF$+#LF$

; Expand the text for demo output
Define i : For i=1 To 4 : text$+text$ : Next : text$+"====== Finished ======"

; Firstly we calculate the needed output rectangle size - Width and
ErrorCheck_BF(VectorText_Simple_BF(text$,
                                   -1,                 ; Calculate output rectangle
                                   0,                  ; Output pos x
                                   0,                  ; output pos y
                                   font_0,             ; Used font
                                   output_width,       ; Output width
                                   max_output_height)) ; Output height - Max available image size - PB specific       

; Result = ScrollAreaGadget ( #Gadget , x , y , Breite , Höhe , ScrollBereichBreite , ScrollBereichHöhe [ , ScrollSchritt [ ,Flags ]])
ScrollAreaGadget(#PB_Any,
                 50,
                 25,
                 Get_Rectangle_width_BF()+23,
                 WindowHeight(window_ID)-50,
                 Get_Rectangle_Width_BF(),
                 Get_Rectangle_Height_BF(),
                 20,
                 #PB_ScrollArea_Center | #PB_ScrollArea_Raised) ; #PB_ScrollArea_Flat, #PB_ScrollArea_Single, #PB_ScrollArea_BorderLess

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, Get_Rectangle_width_BF(), Get_Rectangle_height_BF())

; Pre process - Make background - Primary not needed
Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
ErrorCheck_BF(BucketFill_BF(-2, canvas_ID, texture_0_ID, -1, $FFFFFF))

ErrorCheck_BF(VectorText_Simple_BF(text$,
                                   canvas_ID,
                                   0,                 ; Output pos x
                                   0,                 ; output pos y
                                   font_0,
                                   output_width,
                                   max_output_height, ; Output height - Max available image size - PB specific,
                                   text_color,
                                   background_color,
                                   text_alpha,
                                   background_alpha,
                                   flag))

; Post process - Make text rustic - Primary not needed
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Dirt.jpg")
ErrorCheck_BF(BucketFill_BF(-90, canvas_ID, texture_1_ID, -1, text_color))

If Get_Rectangle_height_BF()*DPI_ResizeFactor_BF()>28000
  MessageRequester("Hint", "Text to large - height :"+#LF$+#LF$+
                           Str(Get_Rectangle_height_BF()*DPI_ResizeFactor_BF()))
EndIf

HideWindow(window_ID, 0)

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeTextures_BF()
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 57
; FirstLine = 38
; EnableXP
; DPIAware
; DisableDebugger