﻿
; VectorText - DrawVectorParagraph() enhanced - DPI aware - Direct output on image, canvas, sprite, window
; Author (C) W. Albus

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1)

Define background_ID=LoadImage(#PB_Any, "./Image_Set/Sunrise_1.jpg")
ResizeImage(background_ID, ImageWidth(background_ID)/1.7*DesktopResolutionX(), ImageHeight(background_ID)/1.7*DesktopResolutionY())

Define window_ID=OpenWindow(#PB_Any, 0, 0,
                            ImageWidth(background_ID)/DesktopResolutionX(),
                            ImageHeight(background_ID)/DesktopResolutionX(),
                            "VectorText output as image - DrawVectorParagraph() enhanced - DPI aware",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))

CompilerIf #PB_Compiler_OS=#PB_OS_Windows
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 18, #PB_Font_Bold) ; -1 = Automatic - System font
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 40, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 9, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_MacOS
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 25, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 40, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 11, #PB_Font_Bold)
  
CompilerElseIf #PB_Compiler_OS=#PB_OS_Linux
  
  Define font_0=LoadFont(#PB_Any, "Times New Roman", 14, #PB_Font_Bold)
  Define font_1=LoadFont(#PB_Any, "Times New Roman", 26, #PB_Font_Bold) ; -1 = Automatic - System Font
  Define font_2=LoadFont(#PB_Any, "", 8, #PB_Font_Bold)
  
CompilerEndIf

Define text$="BF enhanced DrawVectorParagraph function"+#LF$+#LF$+
             "The quick brown fox jumps over the lazy dog"+#LF$+#LF$+
             "DPI aware and alpha blending"+#LF$+#LF$+
             "This is a test output"+#LF$+#LF$+
             "Left, right, center and Blocktext available"

Define output_width=360 ; -1 = Automatic width
Define output_height=0  ; Clip the height - You can set to zero for automatic
Define text_color=#White
Define background_color=#Green
Define text_alpha=255
Define background_alpha=90
Define flag=#PB_VectorParagraph_Center ; #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center, #PB_VectorParagraph_Block 
Define frame_thickness=10
Define frame_color=-1 ; Automatic - Same text color
Define frame_alpha=255

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

; Activate linear gradient
LinearGradient_BF(1, 0, 0, 500*DPI_ResizeFactor_BF() , 500*DPI_ResizeFactor_BF())
; Activate circular gradient
; CircularGradient_BF(1, 450*DPI_ResizeFactor_BF(), 450*DPI_ResizeFactor_BF(), 600*DPI_ResizeFactor_BF())
; ==============================

Define image_ID=VectorText_CreateImage_BF(text$+#LF$+"Create simple your own mighty functions",
                                          font_0,
                                          output_width,
                                          output_height,
                                          text_color,
                                          background_color,
                                          text_alpha,
                                          background_alpha,
                                          flag,
                                          frame_thickness,
                                          frame_color,
                                          frame_alpha)

Define image_a_ID=VectorText_CreateImage_BF(text$+#LF$+"Create simple your own mighty functions",
                                            font_0,
                                            output_width,
                                            output_height,
                                            text_color,
                                            background_color,
                                            text_alpha,
                                            0,
                                            flag,
                                            frame_thickness,
                                            frame_color,
                                            frame_alpha)

; Dectivate linear gradient
LinearGradient_BF(0, 0, 0, 500*DPI_ResizeFactor_BF() , 500*DPI_ResizeFactor_BF())

Define image_1_ID=VectorText_CreateImage_BF(text$,
                                            font_0,
                                            output_width,
                                            output_height,
                                            #Yellow,
                                            background_color,
                                            text_alpha,
                                            0,
                                            flag)

Define image_2_ID=VectorText_CreateImage_BF("What ever you want !"+#LF$+"GFX_Wizzard_BF"+#LF$+"Simple a little more",
                                            font_1,
                                            -1,
                                            output_height,
                                            #White,
                                            background_color,
                                            text_alpha,
                                            0,
                                            #PB_VectorParagraph_Left)

Define image_3_ID=VectorText_CreateImage_BF("The special thing about the GFX_Wizzard_BF is, that all functions can be combined almost endlessly",
                                            font_1,                                       
                                            520,
                                            output_height,
                                            #Green,
                                            Background_color,
                                            text_alpha,
                                            0,
                                            #PB_VectorParagraph_Center)

ResizeImage(image_1_ID,ImageWidth(image_1_ID)/1.3, ImageHeight(image_1_ID)/1.3)

StartDrawing(CanvasOutput(canvas_ID))
DrawImage(ImageID(background_ID), 0, 0)
DrawAlphaImage(ImageID(image_1_ID), 450*DPI_ResizeFactor_BF(), 20*DPI_ResizeFactor_BF())
DrawAlphaImage(ImageID(image_2_ID), 500*DPI_ResizeFactor_BF(), 260*DPI_ResizeFactor_BF(), 170)
StopDrawing()

RotateAlphaChannelSprite_BF(canvas_ID, image_3_ID,                                                                         
                            700*DPI_ResizeFactor_BF(), ; Output pos x
                            -50*DPI_ResizeFactor_BF(), ; Output pos y
                            20,                        ; Rotating degree
                            2,                         ; mode=1 rotating on - mode=2 rotating on and create a quadratic sprite for on demand rotation - Mode 1 has no effekt on linux
                            0,                         ; Set alpha blending from 1 to 255 - BF set 1=full visible - 256=invisible (BF specific)
                            0,                         ; Endposition texture output x - Preset 0 = Clipping is automatic to input width
                            0,                         ; Endposition texture output y - Preset 0 = Clipping is automatic to input height
                            370*DPI_ResizeFactor_BF(), ; You can here resize the output x
                            250*DPI_ResizeFactor_BF()) ; You can here resize the output y
                                                       ; And more parameters available - Look in the Wizzard declare part :-)

HideWindow(window_ID, 0)

; Demo for handling animations on BF
Define i, win_event, animation_delay=50
Delay_BF(1, -1) ; Init BF delay timer 1
                ; -1 set the first delay to zero for beginning a animation directly without a delay
                ; You must not do this here with a 30ms delay, it's for demonstrating how it work

Macro get_all_events ; Get all window events
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until win_event<>#PB_Event_CloseWindow
EndMacro

Repeat ; Animation part 1
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(image_ID), 20*DPI_ResizeFactor_BF(), 35*DPI_ResizeFactor_BF(), i)
    StopDrawing()
  EndIf
Until i>30

i=0
Repeat ; Animation part 2
  Delay(1)
  get_all_events
  If Delay_BF(1, animation_delay) : i+1
    StartDrawing(CanvasOutput(canvas_ID))
    DrawAlphaImage(ImageID(image_a_ID), 20*DPI_ResizeFactor_BF(), 35*DPI_ResizeFactor_BF(), i)
    StopDrawing()
  EndIf
Until i>30

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

FreeTextures_BF()
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 66
; FirstLine = 47
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger