﻿
; ToggleGadget_BF

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

; === Using ==================================================

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Chicken_1_Alpha/Chicken_1_Alpha5.png")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define texture_3_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")
ResizeImage(texture_3_ID, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF())

Define button_width=140
Define button_height=50
Define back_color=$DDDDDD
Define state
Define text$
Define text_color ; Alpha channel supported
Define slider_color
Define gadget_ID

CompilerIf#PB_Compiler_OS=#PB_OS_Linux
  Define padding_x=20
  Define padding_y=20
CompilerElse
  Define padding_x=10*DPI_ResizeFactor_BF()
  Define padding_y=10*DPI_ResizeFactor_BF()
CompilerEndIf

Define window_ID=OpenWindow(#PB_Any, 0, 0, 900, 420, "ToggleGadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, $A0A0A0)

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/5-button_height/2

; Sample procedure for ToggleGadget_BF control - sliding
Procedure SlideToggleGadget(gadget_ID, state_0_text$="OFF",
                            state_1_text$=" ON ",
                            state_0_text_color=#Blue,
                            state_1_text_color=#Red,
                            slider_color=#Yellow)
  
  Protected state_button=GetStateToggleGadget_BF(gadget_ID)*-1+1
  Protected text$, text_color, result, i
  
  If state_button
    text$=state_1_text$
    While i<GetSliderMovingSpaceToggleGadget_BF()
      i+1*DPI_ResizeFactor_BF()
      MoveSliderToggleGadget_BF(0, i) ; Move Slider 0
      Define result=SetToggleGadget_BF(gadget_ID,
                                       0,  ; state 0 or 1 , -1 deactivate the toggle feature
                                       text$,
                                       -1, ; x_pos
                                       -1, ; y_pos
                                       -1, ; button_width
                                       -1, ; button_height
                                       -1, ; padding_x
                                       -1, ; padding_y
                                       state_1_text_color,
                                       slider_color)
      If Not result : ProcedureReturn 0 : EndIf
      Delay(3)
      While WindowEvent() : Wend
    Wend
  Else
    text$=state_0_text$
    While i<GetSliderMovingSpaceToggleGadget_BF()
      i+1*DPI_ResizeFactor_BF()
      MoveSliderToggleGadget_BF(1, i) ; Move Slider 1
      result=SetToggleGadget_BF(gadget_ID,
                                1,  ; state 0 or 1 , -1 deactivate the toggle feature
                                state_0_text$,
                                -1, ; x_pos
                                -1, ; y_pos
                                -1, ; button_width
                                -1, ; button_height
                                -1, ; padding_x
                                -1, ; padding_y
                                state_0_text_color,
                                slider_color)
      If Not result : ProcedureReturn 0 : EndIf
      Delay(3)
      While WindowEvent() : Wend
    Wend
  EndIf
  If state_button
    text_color=state_1_text_color
  Else
    text_color=state_0_text_color
  EndIf
  If state_button ; Finished slider adjusting
    MoveSliderToggleGadget_BF(1, 0) ; Move Slider 1 to zero
  Else
    MoveSliderToggleGadget_BF(1, GetSliderMovingSpaceToggleGadget_BF()) ; Move Slider 1 to max
  EndIf
  result=SetToggleGadget_BF(gadget_ID,
                            state_button,  ; state 0 or 1 , -1 deactivate the toggle feature
                            text$,
                            -1, ; x_pos
                            -1, ; y_pos
                            -1, ; button_width
                            -1, ; button_height
                            -1, ; padding_x
                            -1, ; padding_y
                            text_color,
                            slider_color)
  If Not result : ProcedureReturn 0 : EndIf
  ProcedureReturn 1
EndProcedure

Procedure ToggleSimpleToggleGadget(gadget_ID, state_0_text$="OFF",
                                   state_1_text$=" ON ",
                                   state_0_text_color=#Blue,
                                   state_1_text_color=#Red,
                                   slider_0_color=#Yellow,
                                   slider_1_color=#Yellow)
  
  Protected state_button=GetStateToggleGadget_BF(gadget_ID)*-1+1
  Protected text$, text_color, slider_color, result, i
  
  If state_button
    text$=state_1_text$ 
    text_color=state_1_text_color
    slider_color=slider_1_color
  Else
    text$=state_0_text$
    text_color=state_0_text_color
    slider_color=slider_0_color
  EndIf
  result=SetToggleGadget_BF(gadget_ID,
                            state_button,  ; state 0 or 1 , -1 deactivate the toggle feature
                            text$,
                            -1, ; x_pos
                            -1, ; y_pos
                            -1, ; button_width
                            -1, ; button_height
                            -1, ; padding_x
                            -1, ; padding_y
                            text_color,
                            slider_color)
  If Not result : ProcedureReturn 0 : EndIf
  ProcedureReturn 1
EndProcedure

Procedure ToggleZoomButton(gadget_ID, state_1_txt$, state_0_txt$)
  If GetData_int_1_BF(gadget_ID)
    Define state_0_text$=state_1_txt$
    Define state_1_text$=state_0_txt$
    SetData_int_1_BF(gadget_ID, 0)
  Else
    Define state_0_text$=state_0_txt$
    Define state_1_text$=state_1_txt$
    SetData_int_1_BF(gadget_ID, 1)
  EndIf
  
  Define i, ii.d=GadgetHeight(gadget_ID)
  Define step_width.d=ii.d/100*Pow(DPI_ResizeFactor_BF(), 1.25)
  
  For i=1 To 2
    Define state_button_10=state_button_10*-1+1 
    If state_button_10
      Define padding_value=step_width
    Else
      Define padding_value=-step_width
    EndIf
    
    Repeat
      If i=1
        Define text$=state_0_text$
      Else
        text$=state_1_text$
      EndIf
      
      If state_button_10
        If GetPadding_Y_ToggleGadget_BF(gadget_ID)/2>GadgetHeight(gadget_ID)*1.1/2*DPI_ResizeFactor_BF()
          Break
        EndIf
      Else
        If GetPadding_Y_ToggleGadget_BF(gadget_ID)/2<11*DPI_ResizeFactor_BF()
          Break
        EndIf 
      EndIf
      ii-step_width
      SetCenteredTextToggleGadget_BF(1) ; For creating a full button width and height centered text ToggleGadget_BF - 0 or 1
      Define result=SetToggleGadget_BF(gadget_ID,
                                       1,  ; state 0 or 1 , -1 deactivate the toggle feature
                                       text$,
                                       -1, ; x_pos
                                       -1, ; y_pos
                                       -1, ; button_width
                                       -1, ; button_height
                                       -1, ; padding_x
                                       GetPadding_Y_ToggleGadget_BF(gadget_ID)+padding_value)
      Delay(8)
      While WindowEvent() : Wend
    ForEver
    
    If GetData_int_1_BF(gadget_ID)
      Define text_color=#Red
    Else
      text_color=#Black
    EndIf
    SetCenteredTextToggleGadget_BF(1) ; For creating a full button width and height centered text ToggleGadget_BF - 0 or 1
    Define result=SetToggleGadget_BF(gadget_ID,
                                     1,  ; state 0 or 1 , -1 deactivate the toggle feature
                                     text$,
                                     -1, ; x_pos
                                     -1, ; y_pos
                                     -1, ; button_width
                                     -1, ; button_height
                                     -1, ; padding_x
                                     -1, ; padding_y
                                     text_color)
  Next i
EndProcedure

Procedure BucketFill(gadget_ID, texture_ID, x, y) ; Manipulate the gadget image
  Protected gadget_image_ID=GetGadgetImage_BF(gadget_ID) ; For Gadgets_BF only - Fail results -1
  Protected result=BucketFill_BF(-2, gadget_image_ID, texture_ID, x, y)
  SetGadgetAttribute(gadget_ID, #PB_Button_Image, ImageID(gadget_image_ID))
  ProcedureReturn result
EndProcedure

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($FF, $00, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

; === Init and output the buttons ===
; This function deactivate the automatically text stretching for vector text based Gadgets_BF,
; - as sample ToggleGadget_BF, StretchTextGadget_BF, MagicTextGadget_BF, MessageRequester_Magic_BF
; This is a mighty feature - you must activate again text stretching
; With an unsymmetrical padding the stretching becomes active on MagicText, positive values reduce the output, negative values increase it
Define preset_stretchfactor_x.d=1.0 ; Accept here values =< 1
Define preset_stretchfactor_y.d=1.0
Deactivate_TextStretching_BF(1, preset_stretchfactor_x.d, preset_stretchfactor_y.d)

CanvasToggleGadget_BF() ; Create and use a ToggleGadget_BF canvas based
Define gadget_1_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   " ON ", ; text$
                                   x_pos,
                                   y_pos,
                                   button_width+20,
                                   button_height,
                                   padding_x,
                                   padding_y,
                                   #White, ; text_color
                                   #Red,   ; slider_color
                                   back_color, 
                                   "Arial",
                                   #PB_Font_Bold)
BucketFill(gadget_1_ID, texture_3_ID, -1, $FFFFFF)

Define gadget_2_ID=ToggleGadget_BF(0, ; state 0 or 1 , -1 deactivate the toggle feature
                                   "STOP"+#LF$+"please"+#LF$+"start again",
                                   x_pos-20,
                                   y_pos+95,
                                   button_width+120,
                                   button_height+25,
                                   padding_x,
                                   padding_y,
                                   #Black,
                                   #Yellow,
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Italic | #PB_Font_Bold)

Define gadget_3_ID=ToggleGadget_BF(0, ; state 0 or 1 , -1 deactivate the toggle feature
                                   "OFF",
                                   x_pos+130,
                                   y_pos+220,
                                   button_width-40,
                                   button_height-20,
                                   padding_x,
                                   padding_y,
                                   #Black,
                                   #Yellow,
                                   back_color,
                                   "Arial")

Define gadget_4_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   " ON ",
                                   x_pos+280,
                                   y_pos+270,
                                   button_width-30,
                                   button_height-15,
                                   padding_x,
                                   padding_y,
                                   #Red,
                                   #Yellow,
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Bold)

; Activate linear gradient
CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  LinearGradient_BF(1, 0, 0, 100, 130)
CompilerElse
  LinearGradient_BF(1, 0, 0, 80*DPI_ResizeFactor_BF(), 80*DPI_ResizeFactor_BF())
CompilerEndIf
SetCenteredTextToggleGadget_BF(1)
Define gadget_5_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   " ON ",
                                   x_pos+250,
                                   y_pos-20,
                                   button_width+30,
                                   button_height+15,
                                   padding_x,
                                   padding_y,
                                   #Red,
                                   #Yellow,
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Bold)
; Deactivate linear gradient
LinearGradient_BF(0)

CanvasToggleGadget_BF() ; Create and use a ToggleGadget_BF canvas based
SetCenteredTextToggleGadget_BF(1)
SetFlagsToggleGadget_BF(#PB_Canvas_Border) ; Flags - Same PB flags for CanvasGadget and ImageGadget
Define text_gadget_6$="This is a ToggleGadget_BF"+#LF$+
                      "Multiline centered text"+#LF$+
                      "With automatic text stretching and padding"+#LF$+
                      "Available as Canvas and Image Gadget"+#LF$+
                      "Also usable as Text and ButtonGadget"
Define gadget_6_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   text_gadget_6$,
                                   x_pos-300,
                                   y_pos+190,
                                   button_width+250,
                                   button_height+90,
                                   20*DPI_ResizeFactor_BF(), ; padding_x
                                   20*DPI_ResizeFactor_BF(), ; padding_y
                                   #Blue,
                                   #Green,
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Bold)

CanvasToggleGadget_BF() ; Create and use a ToggleGadget_BF canvas based
SetCenteredTextToggleGadget_BF(1)
Define gadget_7_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   "GFX_Wizzard_BF",
                                   x_pos-300,
                                   y_pos-30,
                                   button_width+120,
                                   button_height,
                                   20*DPI_ResizeFactor_BF(), ; padding_x
                                   20*DPI_ResizeFactor_BF(), ; padding_y
                                   #Yellow,                  ; text_color
                                   $A0A0A0,                  ; slider_color
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Bold)

; This Function set the ToggleGadget_BF text flags - #PB_VectorParagraph_Left, #PB_VectorParagraph_Right, #PB_VectorParagraph_Center
SetTextFlagsToggleGadget_BF(#PB_VectorParagraph_Left) ; Preset = Center
CanvasToggleGadget_BF()                               ; Create and use a ToggleGadget_BF canvas based
SetCenteredTextToggleGadget_BF(1)
Define gadget_8_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   "To see the features"+#LF$+"click the buttons"+#LF$+#LF$+"It's cool man",
                                   x_pos-300,
                                   y_pos+40,
                                   button_width+120,
                                   button_height+70,
                                   20*DPI_ResizeFactor_BF(), ; padding_x,
                                   20*DPI_ResizeFactor_BF(), ; padding_y,
                                   #Black,                   ; text_color
                                   $A0A0A0,                  ; slider_color
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Bold)
BucketFill(gadget_8_ID, texture_2_ID, -1, #Black)

Deactivate_TextStretching_BF(0, preset_stretchfactor_x.d, preset_stretchfactor_y.d)

CanvasToggleGadget_BF() ; Create and use a ToggleGadget_BF canvas based
Define gadget_9_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                   "GFX_Wizzard_BF"+#LF$+"It's cool man",
                                   x_pos+270,
                                   y_pos+180,
                                   button_width+40,
                                   button_height+5,
                                   12*DPI_ResizeFactor_BF(), ; padding_x,
                                   16*DPI_ResizeFactor_BF(), ; padding_y,
                                   #Black,                   ; text_color
                                   #Green,                   ; slider_color
                                   back_color,
                                   "Times New Roman",
                                   #PB_Font_Bold)

Deactivate_TextStretching_BF(1)

SetCenteredTextToggleGadget_BF(1)
Define text_gadget_10_1$="Hello"+#LF$+"World"
Define text_gadget_10_0$="ZooM"
Define gadget_10_ID=ToggleGadget_BF(1, ; state 0 or 1 , -1 deactivate the toggle feature
                                    text_gadget_10_1$,
                                    x_pos+270,
                                    y_pos+80,
                                    button_width+40,
                                    button_height+5,
                                    20*DPI_ResizeFactor_BF(), ; padding_x,
                                    20*DPI_ResizeFactor_BF(), ; padding_y,
                                    #Black,                   ; text_color
                                    #Green,                   ; slider_color
                                    back_color,
                                    "Times New Roman",
                                    #PB_Font_Bold)

; === Use the buttons ===

HideWindow(window_ID, 0)

; Available Constants for GetTypeToggleGadget_BF() : #ToggleImageGadget_BF, #ToggleCanvasGadget_BF
Repeat
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget 
    
    If (EventGadget() And GetGadgetTyp_BF(EventGadget())=#ToggleImageGadget_BF) Or
       (EventGadget() And GetGadgetTyp_BF(EventGadget())=#ToggleCanvasGadget_BF And
        EventType()=#PB_EventType_LeftButtonDown)
      
      Select EventGadget()
          
        Case gadget_1_ID ; #1
          Define state_0_text$="OFF"
          Define state_1_text$=" ON "
          Define state_0_text_color=#White
          Define state_1_text_color=#White
          Define slider_0_color=#Blue
          Define slider_1_color=#Red
          ToggleSimpleToggleGadget(gadget_1_ID, state_0_text$,
                                   state_1_text$,
                                   state_0_text_color,
                                   state_1_text_color,
                                   slider_0_color,
                                   slider_1_color)       
          
          
          ToggleZoomButton(gadget_6_ID, "GFX_Wizzard_BF"+#LF$+"Simple a little more", text_gadget_6$)
          BucketFill(gadget_1_ID, texture_3_ID, -1, #White)
          
        Case gadget_2_ID ; #2
          Define state_0_text$="OFF"
          Define state_1_text$=" ON "
          Define state_0_text_color=#Black
          Define state_1_text_color=#Black
          Define slider_0_color=#Yellow
          Define slider_1_color=#Green
          ToggleSimpleToggleGadget(gadget_2_ID, state_0_text$,
                                   state_1_text$,
                                   state_0_text_color,
                                   state_1_text_color,
                                   slider_0_color,
                                   slider_1_color)
          While WindowEvent() : Wend
          Delay(500)
          ToggleToggleGadget_BF(gadget_2_ID, 0) ; Toggle demo
          While WindowEvent() : Wend
          Delay(500)
          SetCenteredTextToggleGadget_BF(1)
          ToggleToggleGadget_BF(gadget_2_ID, 1, "Running", -1, $AAAAAA)
          BucketFill(gadget_2_ID, texture_3_ID, 0, 0)
          While WindowEvent() : Wend
          Delay(500)
          ToggleToggleGadget_BF(gadget_2_ID, 0)
          ErrorCheck_BF(AlphaChannelSprite_Pro_BF(GetGadgetImage_BF(gadget_2_ID), texture_1_ID, ; Sprite BF output
                                                  10*DPI_ResizeFactor_BF(),
                                                  -15*DPI_ResizeFactor_BF(),
                                                  0, ; Endposition texture output  x - Preset 0 = Clipping is automatic to input width
                                                  0, ; Endposition texture output  y - Preset 0 = Clipping is automatic to input height
                                                  130*DPI_ResizeFactor_BF(),  ; You can here resize the output x
                                                  115*DPI_ResizeFactor_BF())) ; You can here resize the output y
          SetGadgetAttribute(gadget_2_ID, #PB_Button_Image, ImageID(GetGadgetImage_BF(gadget_2_ID)))
          
        Case gadget_3_ID ; #3
          Define state_0_text$="OFF"
          Define state_1_text$=" ON "
          Define state_0_text_color=#Blue
          Define state_1_text_color=#Black
          Define slider_0_color=#Yellow
          Define slider_1_color=#Green
          ToggleSimpleToggleGadget(gadget_3_ID, state_0_text$,
                                   state_1_text$,
                                   state_0_text_color,
                                   state_1_text_color,
                                   slider_0_color,
                                   slider_1_color)
          Define state_button_3=GetStateToggleGadget_BF(gadget_3_ID)*-1+1 
          ; Resize and set new position
          If Not state_button_3
            Define x=GetGadgetX_BF(gadget_3_ID)-20
            Define y=GetGadgetY_BF(gadget_3_ID)-20
            Define width=GetGadgetWidth_BF(gadget_3_ID)+40
            Define height=GetGadgetHeight_BF(gadget_3_ID)+15
          Else
            Define x=GetGadgetX_BF(gadget_3_ID)+20
            Define y=GetGadgetY_BF(gadget_3_ID)+20
            Define width=GetGadgetWidth_BF(gadget_3_ID)-40
            Define height=GetGadgetHeight_BF(gadget_3_ID)-15
          EndIf
          SetToggleGadget_BF(gadget_3_ID, ; Gadget_ID
                             -1,          ; Toggle state 0 or 1
                             "",          ; Text
                             x,           ; Gadget output x pos
                             y,           ; Gadget output x pos
                             width,       ; Gadget width
                             height)      ; Gadget height
          
        Case gadget_4_ID ; #4
          Define state_0_text$="OFF"
          Define state_1_text$=" ON "
          Define state_0_text_color=#Blue
          Define state_1_text_color=#Red
          Define slider_color=#Yellow
          SlideToggleGadget(gadget_4_ID, state_0_text$,
                            state_1_text$,
                            state_0_text_color,
                            state_1_text_color,
                            slider_color)
          
        Case gadget_5_ID ; #5
          Define state_0_text$="OFF"
          Define state_1_text$=" ON "
          Define state_0_text_color=#Green
          Define state_1_text_color=#Red
          Define slider_0_color=#Yellow
          Define slider_1_color=#Yellow
          Define state_button_5=GetStateToggleGadget_BF(gadget_5_ID)*-1+1 
          ; Activate linear gradient
          If state_button_5=1
            GradientColor_Array_BF(1, 1, 0.2, RGBA(Red(state_1_text_color), Green(state_1_text_color), Blue(state_1_text_color), $FF))
          Else
            GradientColor_Array_BF(1, 1, 0.2, RGBA(Red(state_0_text_color), Green(state_0_text_color), Blue(state_0_text_color), $FF))
          EndIf
          CompilerIf #PB_Compiler_OS=#PB_OS_Linux
            LinearGradient_BF(1, 0, 0, 100 , 130)
          CompilerElse
            LinearGradient_BF(1, 0, 0, 80*DPI_ResizeFactor_BF(), 80*DPI_ResizeFactor_BF())
          CompilerEndIf
          SetCenteredTextToggleGadget_BF(1) ; For creating a full button width and height centered text ToggleGadget_BF - 0 or 1
          ToggleSimpleToggleGadget(gadget_5_ID, state_0_text$,
                                   state_1_text$,
                                   state_0_text_color,
                                   state_1_text_color,
                                   slider_0_color,
                                   slider_1_color)
          LinearGradient_BF(0) ; Deactivate linear gradient
          
        Case gadget_6_ID ; #6
          SetCenteredTextToggleGadget_BF(1) ; For creating a full button width and height centered text ToggleGadget_BF - 0 or 1
          Define state_0_text$="WOW"
          Define state_1_text$="GFX_Wizzard_BF"+#LF$+"Simple a little more"
          Define state_0_text_color=#Blue
          Define state_1_text_color=#Black
          Define slider_0_color=#Yellow
          Define slider_1_color=#Green
          ToggleSimpleToggleGadget(gadget_6_ID, state_0_text$,
                                   state_1_text$,
                                   state_0_text_color,
                                   state_1_text_color,
                                   slider_0_color,
                                   slider_1_color)
          
        Case gadget_9_ID ; #9
          Define state_0_text$="WOW"
          Define state_1_text$="GFX_Wizzard_BF"+#LF$+"It's cool man"
          Define state_0_text_color=#Blue
          Define state_1_text_color=#Black
          Define slider_0_color=#Yellow
          Define slider_1_color=#Green
          Deactivate_TextStretching_BF(0)
          ToggleSimpleToggleGadget(gadget_9_ID, state_0_text$,
                                   state_1_text$,
                                   state_0_text_color,
                                   state_1_text_color,
                                   slider_0_color,
                                   slider_1_color)
          
        Case gadget_10_ID ; #10
          ToggleZoomButton(gadget_10_ID, text_gadget_10_0$, text_gadget_10_1$)
          
      EndSelect
      
    EndIf
  EndIf
  
Until win_event=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.71 LTS (Linux - x64)
; CursorPosition = 33
; FirstLine = 15
; Folding = --
; EnableXP
; DPIAware
; DisableDebugger