﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Universal output - with alpha blending and textures - directly on images or canvas -
; - This code is for using simplest all PB graphic features which can make a monochrome output
; - And it fix the ugly edge problem with vector drawing output

; The following functions extend PB functions
; They are extensively documented
; You can easily add any new PB functions
; The necessary changes are minimal in each case
; See the demo codes for enhanced universal PB function output
; The functions can output on images, PB sprites and canvas
; The functions can output textured, with tiling, scrolling, clipping, texture adjusting, alpha blending, color distance

; mode= 0 - Texture mode simple 
;           You must set a unused image color self with SetMaskColorUniversalOutput_BF() for replacing this color with a texture

; mode= 1 - Standard preset texture mode
;           Search a unused image color automatically for replacing with a texture
;           You must deactivate SetMaskColorUniversalOutput_BF(-1) with -1

; mode= 2 > 256 - Equal mode 1 but with alpha blending - 2=full visible - 256=invisible (BF specific)
; mode=-1   Ignore a texture and use a color - Set as texture_ID a color, as sample $FFFF00 
; mode=-2 > -256 - Ignore a texture and use a color - With alpha blending 2=full visible - 256=invisible (BF specific)

; For best results with vector outputs set a unused image color nearly the background image color
; This fix the ugly edge problem with vector drawing outputs mixed with PB standard outputs

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define win_event, canvas_ID, output_ID, window_ID, texture_ID
Define canvas_width, canvas_height, point,texture_clip_x, texture_clip_y, texture_clip_xx, texture_clip_yy
Define canvas_x, canvas_y, mode, result
Define texture_x, texture_y, texture_width, texture_height
Define path$

#SoilWall="./Image_Set/soil_wall.jpg"
#RustySteel="./Image_Set/RustySteel.jpg"
#Caisse="./Image_Set/Caisse.png"
#Background="./Image_Set/Background.bmp"
#Clouds="./Image_Set/Clouds.jpg"
#Hubble="./Image_Set/Hubble.jpg"
#Cat="./Image_Set/Cat_02.jpg"

; Presets
canvas_x=50
canvas_y=50
canvas_width=1100
canvas_height=700

window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, canvas_width+100, canvas_height+100, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

output_ID=CreateImage(#PB_Any, canvas_width*DPI_ResizeFactor_BF(), canvas_height*DPI_ResizeFactor_BF()) ; Create a image for output

canvas_ID=CanvasGadget(#PB_Any, canvas_x, canvas_y, canvas_width, canvas_height) ; This canvas is for final displaying the results

; ===========================================================================================  
; Call function #1 - Make a Background with BF advanced
; ===========================================================================================  
path$=#Background
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
result=BF(-2, output_ID, texture_ID) ; Make a Background texture
ErrorCheck_BF(result)

; ===========================================================================================  
; Advertisement
; =========================================================================================== 

Define font_0_ID=LoadFont(0, "Arial", 11)
StartVectorDrawing(ImageVectorOutput(output_ID))
VectorFont(font_0_ID)

Define txt$="A VERY COOL FUNCTION"+#LF$+
            "GFX WIZZARD BF"+#LF$+
            "www.nachtoptik.de"+#LF$+#LF$+
            "DPI aware output demo"

DrawText_Vector_BF(20,                    ; Output x pos
                   5,                     ; Output y pos
                   txt$,                  ; Text
                   #White,                ; Text color
                   0,                     ; Text center=1 - Text right=2 - Text vertical=3
                   0,                     ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                   0,                     ; Text stretching x - Headline mode
                   0,                     ; Text stretching y - Headline mode
                   DPI_ResizeFactor_BF(), ; Text scaling x
                   DPI_ResizeFactor_BF()) ; Text scaling y
StopVectorDrawing()

; ===========================================================================================  
; AddPathLine - Call
; ===========================================================================================  
Define path$=#SoilWall
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=20

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathLine_BF(mode, output_ID, texture_ID,
                      600*DPI_ResizeFactor_BF(),               ; Output x
                      40*DPI_ResizeFactor_BF(),                ; Output y
                      1050*DPI_ResizeFactor_BF(),              ; Output xx
                      40*DPI_ResizeFactor_BF(),                ; Output yy
                      50*DPI_ResizeFactor_BF(),                ; Stroke path
                      #PB_Path_RoundEnd,                       ; Stroke path flag - As sample #PB_Path_Default
                      texture_x*DPI_ResizeFactor_BF(),         ; Startposition texture output x   - Preset 0
                      texture_y*DPI_ResizeFactor_BF(),         ; Startposition texture output y   - Preset 0
                      texture_width*DPI_ResizeFactor_BF(),     ; Endposition texture output xx    - Preset 0 = Full available width
                      texture_height*DPI_ResizeFactor_BF(),    ; Endposition texture output yy    - Preset 0 = Full available height
                      texture_clip_x*DPI_ResizeFactor_BF(),    ; Startposition inside the texture - Preset 0 (Texture clipping)
                      texture_clip_y*DPI_ResizeFactor_BF(),    ; Startposition inside the texture - Preset 0 (Texture clipping)
                      texture_clip_xx*DPI_ResizeFactor_BF(),   ; Endposition inside the texture   - Preset 0 (Texture clipping)
                      texture_clip_yy*DPI_ResizeFactor_BF())   ; Endposition inside the texture   - Preset 0 (Texture clipping)

ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; AddPathEllipse - Call
; ===========================================================================================  
Define path$=#Clouds
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=80

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathEllipse_BF(mode, output_ID, texture_ID,
                         820*DPI_ResizeFactor_BF(),             ; Output x
                         115*DPI_ResizeFactor_BF(),             ; Output y
                         350*DPI_ResizeFactor_BF(),             ; Radius x
                         75*DPI_ResizeFactor_BF(),              ; Radius y
                         0,                                     ; Starting angle
                         270,                                   ; End angle
                         0,                                     ; Rotate angle
                         texture_x*DPI_ResizeFactor_BF(),       ; Startposition texture output x   - Preset 0
                         texture_y*DPI_ResizeFactor_BF(),       ; Startposition texture output y   - Preset 0
                         texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
                         texture_height*DPI_ResizeFactor_BF(),  ; Endposition texture output yy    - Preset 0 = Full available height
                         texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                         texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                         texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
                         texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; AddPathCircle - Call
; ===========================================================================================  
Define path$=#Hubble
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=120

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathCircle_BF(mode, output_ID, texture_ID,
                        690*DPI_ResizeFactor_BF(),             ; Output x
                        350*DPI_ResizeFactor_BF(),             ; Output y
                        320*DPI_ResizeFactor_BF(),             ; Radius
                        0,                                     ; Starting angle
                        235,                                   ; End angle
                        texture_x*DPI_ResizeFactor_BF(),       ; Startposition texture output x   - Preset 0
                        texture_y*DPI_ResizeFactor_BF(),       ; Startposition texture output y   - Preset 0
                        texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
                        texture_height*DPI_ResizeFactor_BF(),  ; Endposition texture output yy    - Preset 0 = Full available height
                        texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
                        texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; AddPathCircle - Call
; ===========================================================================================  
Define texture_ID=$FF0000
Define mode=-150

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathCircle_BF(mode, output_ID, texture_ID,
                        980*DPI_ResizeFactor_BF(),             ; Output x
                        640*DPI_ResizeFactor_BF(),             ; Output y
                        150*DPI_ResizeFactor_BF(),             ; Radius
                        250,                                   ; Starting angle
                        25,                                    ; End angle
                        texture_x*DPI_ResizeFactor_BF(),       ; Startposition texture output x   - Preset 0
                        texture_y*DPI_ResizeFactor_BF(),       ; Startposition texture output y   - Preset 0
                        texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
                        texture_height*DPI_ResizeFactor_BF(),  ; Endposition texture output yy    - Preset 0 = Full available height
                        texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
                        texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; Ellipse - Call
; ===========================================================================================  
Define path$=#Hubble
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=1

result=Ellipse_BF(mode, output_ID, texture_ID,
                  270*DPI_ResizeFactor_BF(),             ; Output x
                  370*DPI_ResizeFactor_BF(),             ; Output y
                  240*DPI_ResizeFactor_BF(),             ; Radius x
                  305*DPI_ResizeFactor_BF(),             ; Radius y
                  texture_x*DPI_ResizeFactor_BF(),       ; Startposition texture output x   - Preset 0
                  texture_y*DPI_ResizeFactor_BF(),       ; Startposition texture output y   - Preset 0
                  texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
                  texture_height*DPI_ResizeFactor_BF(),  ; Endposition texture output yy    - Preset 0 = Full available height
                  texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                  texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                  texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
                  texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; RoundBox - Call
; ===========================================================================================  
Define path$=#Cat
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=1

result=RoundBox_BF(mode, output_ID, texture_ID,
                   760*DPI_ResizeFactor_BF(),             ; Output x
                   200*DPI_ResizeFactor_BF(),             ; Output y
                   309*DPI_ResizeFactor_BF(),             ; Width
                   230*DPI_ResizeFactor_BF(),             ; Height
                   15*DPI_ResizeFactor_BF(),              ; Curve x
                   15*DPI_ResizeFactor_BF(),              ; Curve y
                   587*DPI_ResizeFactor_BF(),             ; Startposition texture output x   - Preset 0
                   -10*DPI_ResizeFactor_BF(),             ; Startposition texture output y   - Preset 0
                   texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
                   texture_height*DPI_ResizeFactor_BF(),  ; Endposition texture output yy    - Preset 0 = Full available height
                   texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
                   texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; RoundBox - Call
; ===========================================================================================  
Define path$=#Hubble
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=80

result=RoundBox_BF(mode, output_ID, texture_ID,
                   -100*DPI_ResizeFactor_BF(),            ; Output x
                   450*DPI_ResizeFactor_BF(),             ; Output y
                   320*DPI_ResizeFactor_BF(),             ; Width
                   200*DPI_ResizeFactor_BF(),             ; Height
                   15*DPI_ResizeFactor_BF(),              ; Curve x
                   15*DPI_ResizeFactor_BF(),              ; Curve y
                   -360*DPI_ResizeFactor_BF(),            ; Startposition texture output x   - Preset 0
                   310*DPI_ResizeFactor_BF(),             ; Startposition texture output y   - Preset 0
                   texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
                   texture_height*DPI_ResizeFactor_BF(),  ; Endposition texture output yy    - Preset 0 = Full available height
                   texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
                   texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; Box - Call
; ===========================================================================================  
Define path$=#Cat
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=80
ResizeImage(texture_ID, ImageWidth(texture_ID)/5*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)/5*DPI_ResizeFactor_BF())

result=Box_BF(mode, output_ID, texture_ID,
              20*DPI_ResizeFactor_BF(),              ; Output x
              80*DPI_ResizeFactor_BF(),              ; Output y
              140*DPI_ResizeFactor_BF(),             ; Width
              230*DPI_ResizeFactor_BF(),             ; Height
              0,                                     ; Startposition texture output x   - Preset 0
              97*DPI_ResizeFactor_BF(),              ; Startposition texture output y   - Preset 0
              texture_width*DPI_ResizeFactor_BF(),   ; Endposition texture output xx    - Preset 0 = Full available width
              400*DPI_ResizeFactor_BF(),             ; Endposition texture output yy    - Preset 0 = Full available height
              texture_clip_x*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
              texture_clip_y*DPI_ResizeFactor_BF(),  ; Startposition inside the texture - Preset 0 (Texture clipping)
              texture_clip_xx*DPI_ResizeFactor_BF(), ; Endposition inside the texture   - Preset 0 (Texture clipping)
              texture_clip_yy*DPI_ResizeFactor_BF()) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; DrawRotatedText - Call
; ===========================================================================================  
Define path$=#Caisse
Define texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
Define mode=0
Define font_ID=LoadFont(#PB_Any, "Arial", 200)

result=DrawRotatedText_BF(mode, output_ID, texture_ID, font_ID,
                          465*DPI_ResizeFactor_BF(),            ; Output x
                          -25*DPI_ResizeFactor_BF(),            ; Output y
                          "Hello",                              ; Text
                          0,                                    ; Arc
                          texture_x*DPI_ResizeFactor_BF(),      ; Startposition texture output x   - Preset 0
                          texture_y*DPI_ResizeFactor_BF(),      ; Startposition texture output y   - Preset 0
                          texture_width*DPI_ResizeFactor_BF(),  ; Endposition texture output xx    - Preset 0 = Full available width
                          texture_height*DPI_ResizeFactor_BF(), ; Endposition texture output yy    - Preset 0 = Full available height
                          15*DPI_ResizeFactor_BF(),             ; Startposition inside the texture - Preset 0 (Texture clipping)
                          15*DPI_ResizeFactor_BF(),             ; Startposition inside the texture - Preset 0 (Texture clipping)
                          15*DPI_ResizeFactor_BF(),             ; Endposition inside the texture   - Preset 0 (Texture clipping)
                          15*DPI_ResizeFactor_BF())             ; Endposition inside the texture   - Preset 0 (Texture clipping)
                                                                ; Ignore font = -1 
ErrorCheck_BF(result)

; ===========================================================================================  
; Output the result
; ===========================================================================================  
HideWindow(window_ID, 0) ; Show the window, now

StartDrawing(CanvasOutput(canvas_ID)) ; Output
DrawImage(ImageID(output_ID), 0, 0)
StopDrawing()

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 64
; FirstLine = 54
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger