﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Universal output - with alpha blending, textures and vector graphic output - On screen -
; - This code is for using simplest all PB graphic features which can make a monochrome output
; - And it fix the ugly edge problem with vector drawing output

; The following functions extend PB functions
; They are extensively documented
; You can easily add any new PB functions
; The necessary changes are minimal in each case
; See the demo codes for enhanced universal PB function output
; The functions can output on images, PB sprites and canvas
; The functions can output textured, with tiling, scrolling, clipping, texture adjusting, alpha blending, color distance

; mode= 0 - Texture mode simple 
;           You must set a unused image color self with SetMaskColorUniversalOutput_BF() for replacing this color with a texture

; mode= 1 - Standard preset texture mode
;           Search a unused image color automatically for replacing with a texture
;           You must deactivate SetMaskColorUniversalOutput_BF(-1) with -1

; mode= 2 > 256 - Equal mode 1 but with alpha blending - 2=full visible - 256=invisible (BF specific)
; mode=-1   Ignore a texture and use a color - Set as texture_ID a color, as sample $FFFF00 
; mode=-2 > -256 - Ignore a texture and use a color - With alpha blending 2=full visible - 256=invisible (BF specific)

; For best results with vector outputs set a unused image color nearly the background image color
; This fix the ugly edge problem with vector drawing outputs mixed with PB standard outputs

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define win_event, canvas_ID, output_ID, image_1_ID, window_ID, texture_ID 
Define output_width, output_height, point,texture_clip_x, texture_clip_y, texture_clip_xx, texture_clip_yy
Define output_x, output_y, mode, result
Define texture_x, texture_y, texture_width, texture_height
Define path$

#SoilWall="./Image_Set/soil_wall.jpg"
#RustySteel="./Image_Set/RustySteel.jpg"
#Caisse="./Image_Set/Caisse.png"
#Background="./Image_Set/Background.bmp"
#Clouds="./Image_Set/Clouds.jpg"
#Hubble="./Image_Set/Hubble.jpg"
#Cat="./Image_Set/Cat_02.jpg"

; Presets
output_x=50
output_y=50
output_width=1150
output_height=700

window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, output_width+100, output_height+100, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

OpenWindowedScreen(WindowID(window_ID), output_x, output_y, output_width, output_height)

output_ID=CreateImage(#PB_Any, output_width, output_height) ; Create a image for output

; ===========================================================================================  
; Call function #1 - Make a Background with BF advanced
; ===========================================================================================  
path$=#Background
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, output_ID, texture_ID) ; Make a Background texture
ErrorCheck_BF(result)

; ===========================================================================================  
; Advertisement
; =========================================================================================== 
CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  Define font_0_ID=LoadFont(0, "Arial", 11)
CompilerEndIf
StartDrawing(ImageOutput(output_ID))
CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  DrawingFont(font_0_ID)
CompilerEndIf
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(20, 5, "A VERY COOL FUNCTION"+#LF$+
"GFX WIZZARD BF"+#LF$+
"www.nachtoptik.de")
StopDrawing()  

; ===========================================================================================  
; AddPathEllipse - Call
; ===========================================================================================  
Define path$=#Clouds
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=80

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathEllipse_BF(mode, output_ID, texture_ID,
                         820,             ; Output x
                         115,             ; Output y
                         350,             ; Radius x
                         75,              ; Radius y
                         0,               ; Starting angle
                         270,             ; End angle
                         0,               ; Rotate angle
                         texture_x,       ; Startposition texture output x   - Preset 0
                         texture_y,       ; Startposition texture output y   - Preset 0
                         texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
                         texture_height,  ; Endposition texture output yy    - Preset 0 = Full available height
                         texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                         texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                         texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
                         texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; AddPathCircle - Call
; ===========================================================================================  
Define path$=#Hubble
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=120

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathCircle_BF(mode, output_ID, texture_ID,
                        690,             ; Output x
                        350,             ; Output y
                        320,             ; Radius
                        0,               ; Starting angle
                        235,             ; End angle
                        texture_x,       ; Startposition texture output x   - Preset 0
                        texture_y,       ; Startposition texture output y   - Preset 0
                        texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
                        texture_height,  ; Endposition texture output yy    - Preset 0 = Full available height
                        texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
                        texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; AddPathCircle - Call
; ===========================================================================================  
Define texture_ID=$FF0000
Define mode=-150

SetMaskColorUniversalOutput_BF(10) ; Preset the mask color for vector output

result=AddPathCircle_BF(mode, output_ID, texture_ID,
                        980,             ; Output x
                        640,             ; Output y
                        150,             ; Radius
                        250,             ; Starting angle
                        25,              ; End angle
                        texture_x,       ; Startposition texture output x   - Preset 0
                        texture_y,       ; Startposition texture output y   - Preset 0
                        texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
                        texture_height,  ; Endposition texture output yy    - Preset 0 = Full available height
                        texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                        texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
                        texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetMaskColorUniversalOutput_BF(-1) ; Deactivate again

; ===========================================================================================  
; Ellipse - Call
; ===========================================================================================  
Define path$=#Hubble
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=1

result=Ellipse_BF(mode, output_ID, texture_ID,
                  270,             ; Output x
                  370,             ; Output y
                  240,             ; Radius x
                  305,             ; Radius y
                  texture_x,       ; Startposition texture output x   - Preset 0
                  texture_y,       ; Startposition texture output y   - Preset 0
                  texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
                  texture_height,  ; Endposition texture output yy    - Preset 0 = Full available height
                  texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                  texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                  texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
                  texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; RoundBox - Call
; ===========================================================================================  

image_1_ID=CreateImage(#PB_Any, 350, 230, 24, $FF00FF) ; Create a image for rotated output

Define path$=#Cat
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=1

result=RoundBox_BF(mode, image_1_ID, texture_ID,
                   0,               ; Output x
                   0,               ; Output y
                   350,             ; Width
                   230,             ; Height
                   15,              ; Curve x
                   15,              ; Curve y
                   -135,            ; Startposition texture output x   - Preset 0
                   -250,            ; Startposition texture output y   - Preset 0
                   texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
                   texture_height,  ; Endposition texture output yy    - Preset 0 = Full available height
                   texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
                   texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

SetColorDistanceSpriteMask_BF(30)

; ============== Rotate the secondary output ==================== 
result=RotateSprite_simple_BF(mode, output_ID, image_1_ID,                              
                              0,   ; Grab transparence color from sprite pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                              0,   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF
                              750, ; Output pos x
                              150, ; Output pos y
                              50,  ; Rotating degree - On demand
                              100, ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific) - On demand
                              300, ; You can here resize the output x - On demand
                              200, ; You can here resize the output y - On demand
                              0,   ; Rotating offset x - For mode 1 - Do not make offsets too large - Larger=slower, but I will give you not a limit
                              0)   ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple  
                                   ; Set alpha -1 to -256 for a output without invisible color
                                   ; mode=0 Deactivate rotating
                                   ; mode=1 create a exactely resized sprite with minimized mask - Centered with offsets
                                   ; mode=2 create a exactely resized sprite with minimized mask - Centered
                                   ; mode=3 create a exactely resized sprite with minimized mask - Left-aligned
                                   ; The function can create and handle sprite masks automatically or manual, from textures, images or photos
                                   ; So you can also simple create masked rotated sprites from all images without a included mask
                                   ; You see mask artifacts, set ColorDistanceSpriteMask - For jpg (lossly) compressed sprites this is ever needed - Try ~ 25 > 35 percent 
                                   ; For images set image_get_color_x=-1 and image_get_color_y to a unused image color, best similar the background color
                                   ; Reduce for Images SetColorDistanceSpriteMask_BF or you can get "holes", but also nice effects  
ErrorCheck_BF(result)

SetColorDistanceSpriteMask_BF(0)

; ===========================================================================================  
; RoundBox - Call
; ===========================================================================================  
Define path$=#Hubble
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=80

result=RoundBox_BF(mode, output_ID, texture_ID,
                   -100,            ; Output x
                   450,             ; Output y
                   320,             ; Width
                   200,             ; Height
                   15,              ; Curve x
                   15,              ; Curve y
                   -360,            ; Startposition texture output x   - Preset 0
                   310,             ; Startposition texture output y   - Preset 0
                   texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
                   texture_height,  ; Endposition texture output yy    - Preset 0 = Full available height
                   texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
                   texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
                   texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; Box - Call
; ===========================================================================================  
Define path$=#Cat
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=80
ResizeImage(texture_ID, ImageWidth(texture_ID)/5, ImageHeight(texture_ID)/5)

result=Box_BF(mode, output_ID, texture_ID,
              20,              ; Output x
              80,              ; Output y
              140,             ; Width
              230,             ; Height
              0,               ; Startposition texture output x   - Preset 0
              97,              ; Startposition texture output y   - Preset 0
              texture_width,   ; Endposition texture output xx    - Preset 0 = Full available width
              400,             ; Endposition texture output yy    - Preset 0 = Full available height
              texture_clip_x,  ; Startposition inside the texture - Preset 0 (Texture clipping)
              texture_clip_y,  ; Startposition inside the texture - Preset 0 (Texture clipping)
              texture_clip_xx, ; Endposition inside the texture   - Preset 0 (Texture clipping)
              texture_clip_yy) ; Endposition inside the texture   - Preset 0 (Texture clipping)
ErrorCheck_BF(result)

; ===========================================================================================  
; DrawRotatedText - Call
; ===========================================================================================  
Define path$=#Caisse
Define texture_ID=LoadImage(#PB_Any, path$)
Define mode=0
Define font_ID=LoadFont(#PB_Any, "Arial", 200/DPI_ResizeFactor_BF())

result=DrawRotatedText_BF(mode, output_ID, texture_ID, font_ID,
                          465,            ; Output x
                          -25,            ; Output y
                          "Hello",        ; Text
                          0,              ; Degree
                          texture_x,      ; Startposition texture output x   - Preset 0
                          texture_y,      ; Startposition texture output y   - Preset 0
                          texture_width,  ; Endposition texture output xx    - Preset 0 = Full available width
                          texture_height, ; Endposition texture output yy    - Preset 0 = Full available height
                          15,             ; Startposition inside the texture - Preset 0 (Texture clipping)
                          15,             ; Startposition inside the texture - Preset 0 (Texture clipping)
                          150,             ; Endposition inside the texture   - Preset 0 (Texture clipping)
                          150)             ; Endposition inside the texture   - Preset 0 (Texture clipping)
                                          ; Ignore font = -1 
ErrorCheck_BF(result)

; ===========================================================================================  
; Output the result
; ===========================================================================================  
HideWindow(window_ID, 0) ; Show the window, now

Define sprite_ID=Create_PB_Sprite_from_Source_BF(output_ID, 1) ; Create a PB sprite from image and delete the image

Repeat
  win_event=WaitWindowEvent()
  If win_event = #PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    End
  EndIf
  
  ClearScreen(RGB(0, 0, 0))
  
  DisplaySprite(sprite_ID, 0, 0)
  
  FlipBuffers()
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 295
; FirstLine = 281
; Folding = -
; EnableXP
; DisableDebugger